# Copyright (c) 2017 Yusuke Nomura, Terumasa Tadano 
# Usage of qe2respack (an interface from Quantum Espresso to RESPACK)

1. Edit the Makefile (edit "FC", "FFLAGS", "LINKER", "LDFLAGS", "LAPACK", and "QEROOT" according to your environment). 
   Please edit "QEROOT" to make it possible to use Quantum Espresso iotk toolkit. 
   One also needs to give a link to a LAPACK library (edit "LAPACK" and "LDFLAGS").
   If one compiles Quantum Espresso in MPI environment, one needs a MPI compiler as "LINKER" to build qe2respack.

2. Compile qe2respack.
   Type "make". 

3. Use qe2respack.sh to create input files of RESPACK.
   Edit qe2respack_root in qe2respack.sh. 
   Usage example: "bash qe2respack.sh ./outdir/prefix.save/"
   ./outdir/prefix.save/ is the Quantum Espresso output directory. 
   qe2respack.sh will create dir-wfn directory under a directory where qe2respack.sh is called. 

# Examples: Al, La2CuO4, Si, SrVO3, TiO2. 

**.cg                  : Input for cgmrpt (xTAPP scf calculation)   
**.vb                  : Input for vbpef (xTAPP band dispersion calculation) 
ps-** and ps-**.ichr   : Norm-conserving pseudopotential
input.in               : Input for RESPACK
wsh.mpirun.torque-impi : Job-script example for torque (intel MPI)
wsh.mpirun.torque-ompi : Job-script example for torque (open MPI)
**.vesta               : geometry file for vesta  

# Examples: Al, La2CuO4, Si, and SrVO3. 

**.scf.in   : Input for pw.x (scf calculation)   
**.band.in  : Input for pw.x (band calculation) 
**.bands.in : Input for bands.x
input.in    : Input for RESPACK

Acknowledgement: Pseudopotential files are taken from http://www.quantum-simulation.org/potentials/sg15_oncv/  

SUBROUTINE make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0,index_kpt)      
  implicit none 
  integer::NTK,nkb1,nkb2,nkb3
  real(8)::SK0(3,NTK)  
  integer::ik,ix,iy,iz
  real(8)::x,y,z
  integer::index_kpt(nkb1,nkb2,nkb3)    
  ! 
  !if(MOD(NTK,2)/=0)then 
  ! !write(6,*)'i am in make_index for odd'
  ! do ik=1,NTK 
  !  x=SK0(1,ik)*dble(nkb1) 
  !  y=SK0(2,ik)*dble(nkb2)
  !  z=SK0(3,ik)*dble(nkb3)  
  !  x=x+(dble(nkb1)-1.0d0)/2.0d0 
  !  y=y+(dble(nkb2)-1.0d0)/2.0d0
  !  z=z+(dble(nkb3)-1.0d0)/2.0d0 
  !  ix=idnint(x)+1
  !  iy=idnint(y)+1
  !  iz=idnint(z)+1
  !  index_kpt(ix,iy,iz)=ik
  ! enddo 
  !else!20170316 
  ! !write(6,*)'i am in make_index for even'
  ! do ik=1,NTK 
  !  x=SK0(1,ik)*dble(nkb1) 
  !  y=SK0(2,ik)*dble(nkb2)
  !  z=SK0(3,ik)*dble(nkb3)  
  !  x=x+dble(nkb1)/2.0d0 
  !  y=y+dble(nkb2)/2.0d0
  !  z=z+dble(nkb3)/2.0d0 
  !  ix=idnint(x)
  !  iy=idnint(y)
  !  iz=idnint(z)
  !  index_kpt(ix,iy,iz)=ik
  ! enddo 
  !endif 
  !--
  !
  !20190520 Kazuma Nakamura
  !
  do ik=1,NTK 
   x=SK0(1,ik)*dble(nkb1) 
   y=SK0(2,ik)*dble(nkb2)
   z=SK0(3,ik)*dble(nkb3)  
   x=x+(dble(nkb1)-dble(mod(nkb1,2)))/2.0d0 
   y=y+(dble(nkb2)-dble(mod(nkb2,2)))/2.0d0 
   z=z+(dble(nkb3)-dble(mod(nkb3,2)))/2.0d0 
   ix=idnint(x)+mod(nkb1,2)
   iy=idnint(y)+mod(nkb2,2)
   iz=idnint(z)+mod(nkb3,2)
   index_kpt(ix,iy,iz)=ik
  enddo 
  ! 
  RETURN  
END SUBROUTINE make_index_kpt  

subroutine det_shift(NTK,NWF,nsgm,FermiEnergy,sgmw,EKS,EMK,shift_value) 
  implicit none
  integer::NTK,NWF,nsgm
  real(8)::FermiEnergy 
  real(8)::sgmw(nsgm)  
  complex(8)::EMK(NWF,NTK,nsgm)           
  real(8)::EKS(NWF,NTK)           
  integer::min_ib,min_ik,min_ie 
  real(8)::min_diff,min_eak,diff_ie,diff_ef 
  integer::ik,ib,ie
  real(8)::shift_value 
  real(8),parameter::au=27.21151d0
  !
  min_diff=1.0d0
  do ik=1,NTK 
   do ib=1,NWF 
    diff_ef=dabs(EKS(ib,ik)-FermiEnergy)
    if(diff_ef<min_diff)then 
     min_diff=diff_ef  
     min_eak=EKS(ib,ik) 
     min_ib=ib
     min_ik=ik
    endif 
   enddo!ib
  enddo!ik 
  !
  min_diff=0.1d0
  do ie=1,nsgm 
   diff_ie=abs(sgmw(ie)-min_eak)
   if(diff_ie<min_diff)then 
    min_diff=diff_ie 
    min_ie=ie
   endif 
   !write(6,'(a10,f15.10,a10,f15.10)')'sgmw(ie)',sgmw(ie),'min_diff',min_diff 
  enddo!ie 
  shift_value=dble(EMK(min_ib,min_ik,min_ie))-EKS(min_ib,min_ik) 
  !
  write(6,*)'min_ib= ',min_ib
  write(6,*)'min_ik= ',min_ik
  write(6,*)'min_ie= ',min_ie 
  write(6,*)'closest EKS(eV)=',EKS(min_ib,min_ik)*au 
  write(6,*)'closest sgmw(eV)=',sgmw(min_ie)*au 
  write(6,*)'FermiEnergy(eV)=',FermiEnergy*au 
  write(6,*)'shift(eV)=',shift_value*au 
  ! 
return
end

subroutine make_LG0(NTG,b1,b2,b3,Gcut_for_eps,Gcut_for_psi,q1,q2,q3,LG0,NG_for_eps,NG_for_psi)
  implicit none 
  integer::NTG,igL,igL1,igL2,igL3
  integer::NG_for_eps,NG_for_psi            
  integer::LG0(3,NTG)    
  real(8)::b1(3),b2(3),b3(3) 
  real(8)::Gcut_for_eps,Gcut_for_psi  
  real(8)::q1,q2,q3,qgL2,qgL(3)
  integer,parameter::NGL1=150!100 
  integer,parameter::NGL2=150!100 
  integer,parameter::NGL3=150!100 
  !
  igL=0
  do igL1=-NGL1,NGL1 
   do igL2=-NGL2,NGL2 
    do igL3=-NGL3,NGL3 
     qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)    
     qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
     if(qgL2<=Gcut_for_eps)then 
      igL=igL+1 
      LG0(1,igL)=igL1
      LG0(2,igL)=igL2
      LG0(3,igL)=igL3 
      !write(6,*) igL
     endif  
    enddo 
   enddo 
  enddo 
  NG_for_eps=igL 
  !
  do igL1=-NGL1,NGL1 
   do igL2=-NGL2,NGL2 
    do igL3=-NGL3,NGL3 
     qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)    
     qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
     if(qgL2>Gcut_for_eps.and.qgL2<=Gcut_for_psi)then 
      igL=igL+1 
      LG0(1,igL)=igL1
      LG0(2,igL)=igL2
      LG0(3,igL)=igL3 
      !write(6,*) igL
     endif  
    enddo 
   enddo 
  enddo 
  NG_for_psi=igL 
  !
  !do igL=1,NG_for_eps 
  ! write(6,*) igL,LG0(:,igL)
  !enddo 
  !
  RETURN 
END subroutine  
!
subroutine make_eps(NTG,NTGQ,ne,itrs,NG,LGtmp,RWtmp,rginvtmp,pgtmp,nnp,L1,L2,L3,packtmp,epsirr,epsmk) 
  implicit none 
  integer::NTG,NTGQ,itrs,NG,ne,L1,L2,L3,nnp 
  integer::LGtmp(3,NTG) 
  integer::RWtmp(3) 
  real(8)::rginvtmp(3,3) 
  integer::pgtmp(3) 
  integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
  complex(4)::epsirr(NTGQ,NTGQ,ne) 
  integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3,iig,jjg 
  real(8)::phase 
  complex(8)::pf1,pf2 
  complex(4)::epsmk(NTGQ,NTGQ,ne) 
  !
  real(8),parameter::pi=dacos(-1.0d0)
  real(8),parameter::tpi=2.0d0*pi 
  complex(8),parameter::ci=(0.0D0,1.0D0) 
  !
  epsmk(:,:,:)=0.0d0 
  select case(itrs) 
  case(1)!=== not time-reversal ===    
  do ig=1,NG 
   i1=LGtmp(1,ig); j1=LGtmp(2,ig); k1=LGtmp(3,ig) 
   i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
   i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
   j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
   k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
   iig=packtmp(i3,j3,k3) 
   phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
   pf1=exp(-ci*phase/dble(nnp)) 
   do jg=1,NG 
    i1=LGtmp(1,jg); j1=LGtmp(2,jg); k1=LGtmp(3,jg) 
    i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
    i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
    j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
    k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
    jjg=packtmp(i3,j3,k3) 
    phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
    pf2=exp(ci*phase/dble(nnp)) 
    !write(6,'(a,x,2i5)') 'iig jjg',iig,jjg  
    epsmk(ig,jg,:)=epsirr(iig,jjg,:)*pf1*pf2 
   enddo!jg 
  enddo!ig 
  case(-1)!=== time-reversal ===*      
  do ig=1,NG 
   i1=-LGtmp(1,ig); j1=-LGtmp(2,ig); k1=-LGtmp(3,ig) 
   i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
   i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
   j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
   k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
   iig=packtmp(i3,j3,k3) 
   phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
   pf1=exp(-ci*phase/dble(nnp)) 
   do jg=1,NG 
    i1=-LGtmp(1,jg); j1=-LGtmp(2,jg); k1=-LGtmp(3,jg) 
    i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
    i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
    j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
    k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
    jjg=packtmp(i3,j3,k3) 
    phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
    pf2=exp(ci*phase/dble(nnp)) 
    epsmk(ig,jg,:)=epsirr(jjg,iig,:)*pf1*pf2 
   enddo!jg 
  enddo!ig 
  end select 
  !
  !write(6,*)'finish make_eps'
  !
  return 
end subroutine 

subroutine calc_dos_KS(NTB,NTK,nkb1,nkb2,nkb3,ndosgrd,dosgrd,E_EIG,SK0,delt,dmnr,dmna,b1,b2,b3,dos) 
  use m_tetrahedron
  implicit none
  integer::NTB,NTK,nkb1,nkb2,nkb3,ndosgrd
  real(8)::dosgrd(ndosgrd) 
  real(8)::E_EIG(NTB,NTK)           
  real(8)::SK0(3,NTK)           
  real(8)::delt,dmnr,dmna 
  real(8)::b1(3),b2(3),b3(3)
  real(8)::dos(ndosgrd) 
  integer::ie,jb,ik,ikb1,ikb2,ikb3
  integer::iomp,omp_get_thread_num  
  real(8)::SUM_REAL 
  !
  !ttrhdrn
  !
  integer,allocatable::imt1(:)!imt1(4*nkb1*nkb2*nkb3*6)  
  integer,allocatable::index_kpt(:,:,:)!index_kpt(nkb1,nkb2,nkb3)    
  complex(8),allocatable::fk_1D(:)!fk_1D(NTK)
  complex(8),allocatable::gk_1D(:)!gk_1D(NTK)
  complex(8),allocatable::fk_3D(:,:,:)!fk_3D(nkb1,nkb2,nkb3) 
  complex(8),allocatable::gk_3D(:,:,:)!gk_3D(nkb1,nkb2,nkb3)
  complex(8),allocatable::xo(:,:,:)!xo(nkb1,nkb2,nkb3) 
  complex(8),allocatable::xow(:,:,:,:)!xow(nsgm,nkb1,nkb2,nkb3)
  !
  real(8),parameter::pi=dacos(-1.0d0)
  real(8),parameter::au=27.21151d0 
  !
  allocate(imt1(4*nkb1*nkb2*nkb3*6)); imt1=0   
  allocate(index_kpt(nkb1,nkb2,nkb3)); index_kpt=0  
  call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
  call ttrhdrn_mkidx(nkb1,nkb2,nkb3,imt1(1),b1(1),b2(1),b3(1))
  !  
  allocate(xow(ndosgrd,nkb1,nkb2,nkb3)); xow=0.0d0 
!$OMP PARALLEL PRIVATE(ie,jb,fk_1D,gk_1D,ik,fk_3D,gk_3D,ikb3,ikb2,ikb1,xo,iomp) 
  allocate(fk_1D(NTK)); fk_1D=0.0d0 
  allocate(gk_1D(NTK)); gk_1D=0.0d0 
  allocate(fk_3D(nkb1,nkb2,nkb3)); fk_3D=0.0d0 
  allocate(gk_3D(nkb1,nkb2,nkb3)); gk_3D=0.0d0 
  allocate(xo(nkb1,nkb2,nkb3)); xo=0.0d0  
!$OMP DO 
  do ie=1,ndosgrd 
   do jb=1,NTB
    fk_1D=0.0d0
    gk_1D=0.0d0
    do ik=1,NTK 
     fk_1D(ik)=1.0d0 
     gk_1D(ik)=cmplx(dosgrd(ie)-E_EIG(jb,ik),-delt) 
    enddo 
    fk_3D=0.0d0 
    gk_3D=0.0d0 
    do ikb3=1,nkb3
     do ikb2=1,nkb2
      do ikb1=1,nkb1 
       ik=index_kpt(ikb1,ikb2,ikb3) 
       fk_3D(ikb1,ikb2,ikb3)=fk_1D(ik)
       gk_3D(ikb1,ikb2,ikb3)=gk_1D(ik)
      enddo 
     enddo 
    enddo 
    xo=0.0d0 
    call ttrhdrn_simple(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),fk_3D(1,1,1),gk_3D(1,1,1),xo(1,1,1))
    xow(ie,:,:,:)=xow(ie,:,:,:)+xo(:,:,:) 
   enddo!jb 
   iomp=omp_get_thread_num() 
   if(iomp.eq.0) then 
    write(6,*)'#',ie  
   endif 
  enddo!ie
!$OMP END DO 
  deallocate(fk_1D,gk_1D,fk_3D,gk_3D,xo) 
!$OMP END PARALLEL 
  !
  dos=0.0d0 
  do ie=1,ndosgrd 
   SUM_REAL=0.0d0 
   do ikb3=1,nkb3
    do ikb2=1,nkb2
     do ikb1=1,nkb1 
      SUM_REAL=SUM_REAL+dabs(dimag(xow(ie,ikb1,ikb2,ikb3)))/pi  
     enddo 
    enddo 
   enddo 
   dos(ie)=2.0d0*SUM_REAL/dble(NTK)!2 is spin 
  enddo 
  !
  deallocate(imt1,index_kpt,xow) 
return
end

!
! Copyright (c) 2013-2015,2018 Yoshihide Yoshimoto
!
program strconv
  use subr_fmtconv
  use subr_readstr
  implicit none
  real(kind=8):: ax
  integer:: nkd,nsi
  integer,parameter:: nfin = 10, nfout = 11
  !
  real(kind=8):: aa(3,3)
  integer,pointer:: kd(:)
  real(kind=8),pointer:: asi(:,:),cforce(:,:)

  real(kind=8),pointer:: zo(:),zn(:)
  real(kind=8):: etotal,efermi(2)

  character(len=256):: cbuf
  integer:: ftype

  integer:: tatm
  real(kind=8):: dspl(3)

  integer:: ios

  call getarg(1, cbuf)

  if (trim(cbuf).eq.'cif') then
     ftype = 1
  else if (trim(cbuf).eq.'xyz') then
     ftype = 2
  else if (trim(cbuf).eq.'xyzpr') then
     ftype = 3
  else if (trim(cbuf).eq.'xyzmol') then
     ftype = 4
  else if (trim(cbuf).eq.'poscar') then
     ftype = 5
  else if (trim(cbuf).eq.'cforce') then
     ftype = 6
  else if (trim(cbuf).eq.'respack') then
     ftype = 7
  else
     write(6,*) 'usage: strconv (cif|xyz|xyzpr|xyzmol|poscar|cforce|respack) fname'
     stop
  end if

  call getarg(2, cbuf)
  open(nfin, file=cbuf, status='old', action='read', iostat=ios)
  if (ios.ne.0) then
     write(6,*) 'error in opening '//trim(cbuf)
     stop
  end if

  call read_strfile(nfin,nkd,nsi,ax,aa,kd,asi,cforce,zo,zn,etotal,efermi)
  close(nfin)

  aa = ax*aa

  cbuf = 'xTAPP_str: ' // cbuf

  if (ftype.eq.1) then
     call printcif(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
  else if (ftype.eq.2) then
     call printxyz(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
  else if (ftype.eq.3) then
     call printxyzpr(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
  else if (ftype.eq.4) then
     call printxyzmol(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
  else if (ftype.eq.5) then
     call printposcar(6,ax,aa,nkd,zo,zn,nsi,kd,asi)
  else if (ftype.eq.6) then
     call printcforce(6,nsi,cforce)
  else if (ftype.eq.7) then
     call printrespack(nfout,cbuf,aa,nkd,zo,zn,nsi,kd,asi,etotal,efermi)
  end if

  stop

100 continue
  write(6,'(a)')'error in reading struct_data'
  stop
200 continue
  write(6,'(a)')'error in reading valence and nucleus charge'
  stop
300 continue
  write(6,'(a)')'error in reading atom kind and position'
  stop
400 continue
  write(6,'(a)')'error in reading force'
  stop
end program strconv

!
!(default parameters) 
!
!delt=0.01d0          !Greens function delt in eV
!dmna=0.001d0         !Ttrhdrn parameter dmna in eV
!dmnr=0.001d0         !Ttrhdrn parameter dmnr in eV
!delw=2.0d0*delt      !Grid width in eV [dos]
!delw=10.0d0*delt     !Grid width in eV [hist]
!ecut=0.0d0           !Energy cutoff for transfer integral in eV
!rcut=100.0d0         !Distance cutoff for transfer integral in AA
!diff=0.01d0          !Match threshold for two transfer integral in eV 
!elnm=0.0d0           !Total number of electrons in unitcell
!kgrd='nkb1 nkb2 nkb3'!k grid 
!
PROGRAM main 
  use m_rd_dat_zvo 
  use m_rd_transdef  
  use m_truncation 
  use m_dos, only: calculate_dos 
  use m_eigenstate, only: calculate_eigenstate
  use m_hist, only: calculate_hist 
  use m_band, only: calculate_banddisp 
  use m_frmsf, only: wrt_frmsf 
  include "config.h" 
  !
  !read zvo files in dir-model 
  !
  call rd_dat_mkkpts 
  call rd_dat_hr 
  call rd_dat_geom 
  call rd_dat_bandkpts 
  call rd_dat_ef 
  !
  !read input from command line 
  !
  ncount=iargc() 
  allocate(real_arg(ncount)); real_arg=0.0d0 
  do i=1,ncount-4 
   call getarg(i,arg) 
   read(arg,*) real_arg(i)  
  enddo 
  !dos
  call getarg(ncount-3,arg)
  read(arg,*) dos 
  !bnd
  call getarg(ncount-2,arg)
  read(arg,*) bnd
  !frm 
  call getarg(ncount-1,arg)
  read(arg,*) frm 
  !his 
  call getarg(ncount-0,arg)
  read(arg,*) his 
  !
  !write(6,*) ncount
  !write(6,*) real_arg(1)
  !write(6,*) real_arg(2)
  !write(6,*) real_arg(3)
  !write(6,*) real_arg(4)
  !write(6,*) real_arg(5)
  !write(6,*) real_arg(6)
  !write(6,*) real_arg(7)
  !write(6,*) real_arg(8)
  !
  delt=real_arg(1)
  elnm=real_arg(2)  
  ecut=real_arg(3)  
  rcut=real_arg(4)  
  diff=real_arg(5)  
  !
  kgd(1)=nint(real_arg(6)); kgd(2)=nint(real_arg(7)); kgd(3)=nint(real_arg(8)) 
  !
  delt=delt/au !au <- eV
  electron_number=elnm 
  threshold_e=ecut/au !au <- eV
  threshold_r=rcut !AA 
  diff_transfers=diff/au !au <- eV  
  !
  write(6,*) 
  write(6,'(a50)')'##### TRANSFER ANALYSIS #####'
  write(6,*) 
  write(6,'(a50,x,f10.5)')'Greens function delt (eV):',delt*au
  write(6,'(a50,x,f10.5)')'Grid spacing delw (eV) [dos]:',2.0d0*delt*au
  write(6,'(a50,x,f10.5)')'Grid spacing delw (eV) [hist]:',10.0d0*delt*au
  write(6,'(a50,x,f10.5)')'Electron numbers in unit cell:',electron_number  
  write(6,'(a50,x,f10.5)')'Energy cutoff for transfer (eV):',threshold_e*au
  write(6,'(a50,x,f10.5)')'Distance cutoff for transfer (AA):',threshold_r 
  write(6,'(a50,x,f10.5)')'Match threshold for transfers (eV):',diff_transfers*au
  write(6,'(a50,x,f10.5)')'FermiEnergy in band calculation (eV):',FermiEnergy_bandcalc*au  
  if(kgd(1)==0.and.kgd(2)==0.and.kgd(3)==0)then 
      write(6,'(a50,x,3i10 )')'k grid:',nkb1,nkb2,nkb3  
  else
      write(6,'(a50,x,3i10 )')'k grid:',kgd 
  endif  
  write(6,*) 
  !
  !truncate H(R) on threshold 
  !
  call truncation(NWF,Na1,Na2,Na3,threshold_e,threshold_r,diff_transfers,a1(1),a2(1),a3(1),wcenter_lat(1,1),HR(1,1,-Na1,-Na2,-Na3))
  !
  if(dos)then 
    !
    !set kvec
    !
    if(kgd(1)==0.and.kgd(2)==0.and.kgd(3)==0)then 
        kgd(1)=nkb1; kgd(2)=nkb2; kgd(3)=nkb3 
    endif 
    ncalck=PRODUCT(kgd(1:3))
    allocate(kvec(3,ncalck)); kvec=0.0d0 
    call set_kgrid(kgd(1),kvec(1,1)) 
    write(6,*) 
    write(6,'(a7)')'kvec:' 
    do i=1,ncalck
     write(6,'(3f15.10)') kvec(:,i) 
    enddo 
    !
    !make EKS
    !
    allocate(EKS(NWF,ncalck)); EKS=0.0d0; allocate(VKS(NWF,NWF,ncalck)); VKS=0.0d0 
    flg_weight=0 !Flg whether calculate weighted transfers (0:not calc, 1:calc)
    call calculate_eigenstate(NWF,ncalck,Na1,Na2,Na3,nkb1,nkb2,nkb3,flg_weight,a1(1),a2(1),a3(1),kvec(1,1),HR(1,1,-Na1,-Na2,-Na3),EKS(1,1),VKS(1,1,1)) 
    !
    !make DOS 
    !
    delw=2.0d0*delt !Grid spacing delw [dos] 
    call calculate_dos(NWF,ncalck,kgd(1),kgd(2),kgd(3),electron_number,threshold_e,delt,delw,b1(1),b2(1),b3(1),kvec(1,1),EKS(1,1),VKS(1,1,1))
    deallocate(EKS,VKS) 
    deallocate(kvec) 
    !
    write(6,'(a50)')'##### FINISH TRANSFER ANALYSIS (DOS) #####'
  endif!dos 
  !
  if(bnd)then 
    !
    !set F(R) 
    !
    if(kgd(1)==0.and.kgd(2)==0.and.kgd(3)==0)then 
        kgd(1)=nkb1; kgd(2)=nkb2; kgd(3)=nkb3 
    endif 
    La1=kgd(1)/2; La2=kgd(2)/2; La3=kgd(3)/2 
    allocate(FR(NWF,NWF,-La1:La1,-La2:La2,-La3:La3)); FR(:,:,:,:,:)=0.0d0  
    call set_FR(NWF,nkb1,nkb2,nkb3,kgd(1),kgd(2),kgd(3),Na1,Na2,Na3,La1,La2,La3,HR(1,1,-Na1,-Na2,-Na3),FR(1,1,-La1,-La2,-La3)) 
    !
    !make EKS
    !
    allocate(EKS(NWF,NSK_BAND_DISP)); EKS=0.0d0; allocate(VKS(NWF,NWF,NSK_BAND_DISP)); VKS=0.0d0 
    flg_weight=0 !Flg whether calculate weighted transfers (0:not calc, 1:calc)
    call calculate_eigenstate(NWF,NSK_BAND_DISP,La1,La2,La3,kgd(1),kgd(2),kgd(3),flg_weight,a1(1),a2(1),a3(1),SK_BAND_DISP(1,1),FR(1,1,-La1,-La2,-La3),EKS(1,1),VKS(1,1,1)) 
    !
    !calc band disp
    !
    call calculate_banddisp(NWF,NSK_BAND_DISP,Ndiv,N_sym_points,threshold_e,b1(1),b2(1),b3(1),SK_BAND_DISP(1,1),EKS(1,1)) 
    deallocate(EKS,VKS) 
    !
    write(6,'(a50)')'##### FINISH TRANSFER ANALYSIS (BND) #####'
  endif!bnd 
  !
  if(frm)then
    !
    !wrt fermi surface 
    !
    call wrt_frmsf(NWF,kgd(1),Na1,Na2,Na3,nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),b1(1),b2(1),b3(1),FermiEnergy_bandcalc,HR(1,1,-Na1,-Na2,-Na3)) 
    !
    write(6,'(a50)')'##### FINISH TRANSFER ANALYSIS (FRM) #####'
  endif!frm 
  !
  if(his)then
    write(6,*) 
    write(6,'(a50)')'##### TRANSFER ANALYSIS (trans.def) #####'
    write(6,*) 
    !
    !read trans.def 
    !
    call rd_transdef  
    !
    !calc histgram
    ! 
    delw=10.0d0*delt !Grid spacing delw [hist] 
    call calculate_hist(Ndim_TR,delw,TR(1,1)) 
    !
    write(6,'(a50)')'##### FINISH TRANSFER ANALYSIS (HIS) #####'
  endif!his
  !
  stop
end     

subroutine wrt_optical_property(ngrd,grd,func) 
  implicit none
  integer,intent(in)::ngrd
  complex(8),intent(in)::grd(ngrd)
  complex(8),intent(in)::func(ngrd,3)
  integer::ix,ie 
  real(8)::x,y,r  
  complex(8)::zsqrt 
  integer::file_num 
  character(99)::filename 
  real(8),parameter::au=27.21151D0!hartree 
  integer,parameter::file_num_eels=9000 
  integer,parameter::file_num_optical=9100 
  integer,parameter::file_num_reflectivity=9200 
  !
  !eels
  !
  do ix=1,3
   file_num=file_num_eels+ix
   !--
   !OPEN(900%,W,FILE='dat.eels-x,y,z')
   if(ix==1)write(filename,"('dat.eels-x')") 
   if(ix==2)write(filename,"('dat.eels-y')") 
   if(ix==3)write(filename,"('dat.eels-z')") 
   OPEN(file_num,FILE=filename) 
   REWIND(file_num)
   do ie=1,ngrd
    x=dble(func(ie,ix))
    y=imag(func(ie,ix)) 
    write(file_num,'(f15.8,2f25.12)') dble(grd(ie))*au,x,-y 
   enddo!ie
  enddo!ix 
  !
  !optical conductivity 
  !
  do ix=1,3
   file_num=file_num_optical+ix
   !--
   !OPEN(910%,W,FILE='dat.optical_conductivity-x,y,z')
   if(ix==1)write(filename,"('dat.optical_conductivity-x')") 
   if(ix==2)write(filename,"('dat.optical_conductivity-y')") 
   if(ix==3)write(filename,"('dat.optical_conductivity-z')") 
   OPEN(file_num,FILE=filename) 
   REWIND(file_num)
   do ie=1,ngrd
    x=dble(func(ie,ix))
    y=imag(func(ie,ix)) 
    write(file_num,'(f15.8,2f25.12)') dble(grd(ie))*au,x/(x**2+y**2),-y/(x**2+y**2) 
   enddo!ie
  enddo!ix 
  !
  !reflectivity 
  !
  do ix=1,3
   file_num=file_num_reflectivity+ix
   !--
   !OPEN(920%,W,FILE='dat.reflectivity-x,y,z')
   if(ix==1)write(filename,"('dat.reflectivity-x')") 
   if(ix==2)write(filename,"('dat.reflectivity-y')") 
   if(ix==3)write(filename,"('dat.reflectivity-z')") 
   OPEN(file_num,FILE=filename) 
   REWIND(file_num)
   do ie=1,ngrd
    zsqrt=func(ie,ix)**0.5d0
    r=(abs((1.0d0-zsqrt)/(1.0d0+zsqrt)))**2 
    write(file_num,'(2f15.8)') dble(grd(ie))*au,r 
   enddo!ie 
  enddo!ix  
  !
return
end

!
! Copyright (c) 2013-2018 Yoshihide Yoshimoto and Kazuma Nakamura 
!
module m_gencif_sub!subr_fmtconv: original name in xtapp
  character(len=2):: atom_name(0:102) = (/ 'Un', 'H ','He', &
       'Li','Be','B ','C ','N ','O ','F ','Ne', &
       'Na','Mg','Al','Si','P ','S ','Cl','Ar', &
       'K ','Ca', &
       'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn', &
       'Ga','Ge','As','Se','Br','Kr', &
       'Rb','Sr', &
       'Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd', &
       'In','Sn','Sb','Te','I ','Xe', &
       'Cs','Ba', &
       'La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb', &
       'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg', &
       'Tl','Pb','Bi','Po','At','Rn', &
       'Fr','Ra', &
       'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No' /)
  real(8),parameter::oneau=0.52917721067d0!by 2014 CODATA
  real(8),parameter::pi=3.14159265358979323846d0
contains
  subroutine printcif(cbuf,aa,nkd,zn,nsi,kd,asi,na,nb,nc) 
    implicit none
    character(len=*)::cbuf
    real(8),intent(in)::aa(3,3)
    integer,intent(in)::nkd,nsi,kd(nsi)
    real(8)::zn(nkd)
    real(8)::asi(3,nsi)
    integer::nsikd(nkd)
    character(len=10240)::chem_abs_conf
    character(len=6)::cnsikd
    integer::it,ikd,izn
    real(8)::cla,clb,clc,tmp
    !
    character(99)::filename 
    integer,parameter::file_num=304
    integer::na,nb,nc 
    !
    !OUTPUT by cif format 
    !OPEN(file_num,W,FILE='dat.supercell-xxx.cif') 
    write(filename,"('dat.supercell-',i3.3,'x',i3.3,'x',i3.3,'.cif')")na,nb,nc
    write(6,*)'filename',filename 
    OPEN(file_num,FILE=filename) 
    REWIND(file_num)
    ! 
    nsikd = 0
    do it=1,nsi
       nsikd(kd(it)) = nsikd(kd(it))+1
    end do
    chem_abs_conf = ''''
    do ikd=1,nkd
       izn = nint(zn(ikd))
       write(cnsikd,'(i0)') nsikd(ikd)
       chem_abs_conf = trim(chem_abs_conf) // ' ' &
            // trim(atom_name(izn)) // trim(cnsikd)
    end do
    chem_abs_conf = trim(chem_abs_conf)//''''
    !
    write(file_num,'(a)') 'data_global'
    write(file_num,'(a)') '_chemical_name ''' // trim(cbuf) // ''''
    write(file_num,'(a)') '_chemical_absolute_configuration ' // trim(chem_abs_conf)
    write(file_num,'(a)') '_symmetry_space_group_name ''P1'''
    ! 
    cla = aa(1,1)*aa(1,1)+aa(2,1)*aa(2,1)+aa(3,1)*aa(3,1)
    cla = sqrt(cla)
    write(file_num,'(a,f15.7)') '_cell_length_a ', oneau*cla
    !
    clb = aa(1,2)*aa(1,2)+aa(2,2)*aa(2,2)+aa(3,2)*aa(3,2)
    clb = sqrt(clb)
    write(file_num,'(a,f15.7)') '_cell_length_b ', oneau*clb
    !
    clc = aa(1,3)*aa(1,3)+aa(2,3)*aa(2,3)+aa(3,3)*aa(3,3)
    clc = sqrt(clc)
    write(file_num,'(a,f15.7)') '_cell_length_c ', oneau*clc
    !
    tmp = aa(1,2)*aa(1,3)+aa(2,2)*aa(2,3)+aa(3,2)*aa(3,3)
    tmp = tmp/(clb*clc)
    tmp = acos(tmp)/pi*180.0
    write(file_num,'(a,f11.7)') '_cell_angle_alpha ', tmp
    !
    tmp = aa(1,3)*aa(1,1)+aa(2,3)*aa(2,1)+aa(3,3)*aa(3,1)
    tmp = tmp/(clc*cla)
    tmp = acos(tmp)/pi*180.0
    write(file_num,'(a,f11.7)') '_cell_angle_beta ', tmp
    !
    tmp = aa(1,1)*aa(1,2)+aa(2,1)*aa(2,2)+aa(3,1)*aa(3,2)
    tmp = tmp/(cla*clb)
    tmp = acos(tmp)/pi*180.0
    write(file_num,'(a,f11.7)') '_cell_angle_gamma ', tmp
    !
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_11 ', oneau*aa(1,1)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_21 ', oneau*aa(2,1)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_31 ', oneau*aa(3,1)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_12 ', oneau*aa(1,2)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_22 ', oneau*aa(2,2)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_32 ', oneau*aa(3,2)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_13 ', oneau*aa(1,3)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_23 ', oneau*aa(2,3)
    write(file_num,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_33 ', oneau*aa(3,3)
    write(file_num,*)
    !
    write(file_num,'(a)') 'loop_'
    write(file_num,'(a)') '_symmetry_equiv_pos_as_xyz'
    write(file_num,'(a)') '''x, y, z'''
    write(file_num,*)
    !
    write(file_num,'(a)') 'loop_'
    write(file_num,'(a)') '_atom_site_type_symbol'
    write(file_num,'(a)') '_atom_site_label'
    write(file_num,'(a)') '_atom_site_fract_x'
    write(file_num,'(a)') '_atom_site_fract_y'
    write(file_num,'(a)') '_atom_site_fract_z'
    !
    nsikd = 0
    do it=1,nsi
       izn = nint(zn(kd(it)))
       nsikd(kd(it)) = nsikd(kd(it))+1
       write(cnsikd,'(i0)') nsikd(kd(it))
       write(file_num,'(a,1x,a,3(1x,f13.9))') trim(atom_name(izn)), &
            trim(atom_name(izn))//trim(cnsikd), &
            modulo(asi(1,it),1.0d0), &
            modulo(asi(2,it),1.0d0), &
            modulo(asi(3,it),1.0d0)
    end do
    !
    close(file_num)
    !
    return
  end subroutine printcif
end module m_gencif_sub

module m_rdinput 
implicit none
private
public::read_input 
!--
integer,public::calc_ifreq!    
integer,public::ix_intJ_min!
integer,public::ix_intJ_max!
integer,public::iy_intJ_min!
integer,public::iy_intJ_max!
integer,public::iz_intJ_min!
integer,public::iz_intJ_max!
!real(8),public::wcut_model!Cutoff of U' for model 
!real(8),public::jcut_model!Cutoff of J  for model 
namelist/param_calc_int/calc_ifreq,ix_intJ_min,ix_intJ_max,iy_intJ_min,iy_intJ_max,&
iz_intJ_min,iz_intJ_max!,wcut_model,jcut_model   
contains
subroutine read_input 
!--
!default
CALC_IFREQ=1!omega=0
IX_INTJ_MIN=0
IX_INTJ_MAX=0
IY_INTJ_MIN=0
IY_INTJ_MAX=0
IZ_INTJ_MIN=0
IZ_INTJ_MAX=0 
!WCUT_MVMC=2.0d0!eV
!JCUT_MVMC=0.3d0!eV   
!--
!open(999,file='input.in')
!read(999,nml=param_calc_int)
read(5,nml=param_calc_int)
write(6,param_calc_int) 
end subroutine
end module

module m_rdinput 
implicit none
private
public::read_input
!--
!&param-wannier 
integer,public::icell!0:gen,1:sc,2:fcc,3:bcc,4:hcp,5:ttr&ort,6:mon,7:tri,8:bct  
integer,public::n_occ!Total number of considerd band in wannier calc 
integer,public::N_wannier!Total number of considerd band in wannier calc 
integer,public::nigs!TOTAL NUMBER OF INITIAL GUESS GAUSSIAN       
integer,public::N_initial_guess!TOTAL NUMBER OF INITIAL GUESS GAUSSIAN       
real(8),public::EPS_SPILLAGE!Threshold for spilage minimization 
real(8),public::DAMP!damping in spilage minimization 
real(8),public::EPS_SPREAD!Threshold for spread minimization 
real(8),public::MAX_STEP_LENGTH!Step length in line search 
real(8),public::Lower_energy_window!E_LOWER!LOWER BOUND OF ENERGY WINDOW (eV)
real(8),public::E_LOWER!LOWER BOUND OF ENERGY WINDOW (eV)
real(8),public::Upper_energy_window!E_UPPER!UPPER BOUND OF ENERGY WINDOW (eV)
real(8),public::E_UPPER!UPPER BOUND OF ENERGY WINDOW (eV)
logical,public::set_inner_window!flag for inner window 
real(8),public::Upper_inner_window!Upper inner energy window for wannier calc (eV)
real(8),public::E_UPPER_inner!Upper inner energy window for wannier calc (eV)
real(8),public::Lower_inner_window!Lower inner energy window for wannier calc (eV)
real(8),public::E_LOWER_inner!Lower inner energy window for wannier calc (eV)
integer,public::flg_BMAT!0:BMAT=unit matrix, 1:BMAT from input 
integer,public::flg_initial_guess_direc!0:use global coordinate, 1:use local coordinate  
real(8),public::electron_number_wannier_space!electron number in wannier_space for density matrix 
real(8),public::elec_num!electron number in wannier_space for density matrix 
integer,public::flg_fermisurface!flag for fermisurface  
logical,public::CALC_FERMISURFACE!flag for fermisurface  
integer,public::flg_global_dos!flag for global dos 
logical,public::CALC_GLOBAL_DOS!flag for global dos 
!hidden parameters 
integer,public::flg_vis_bloch!flag for visualization  of Bloch function
logical,public::CALC_REAL_SPACE_BLOCH!flag for visualization of Bloch function 
logical,public::CALC_BLOCH_VIS_RANGE!flag to calculate visualization range of Bloch function 
real(8),public::calc_k(3)!k points to be calculated 
integer,public::reading_bmat_format!To specify bmat reading format  
!
!&param-interpolation   
integer,public::N_sym_points!The number of k-point points in symmetry line
integer,public::Ndiv!Separation between symmetry points  
integer,public::reading_sk_format!20170709 
!&param-visualization   
integer,public::flg_vis_wannier!flag for visualization 
logical,public::CALC_REAL_SPACE_WANNIER!flag for visualization 
integer,public::N_write_wannier!Total number of visalization wannier calculation (manual mode)
integer,public::ix_vis_min!x-range for visualization 
integer,public::ix_vis_max!x-range for visualization 
integer,public::iy_vis_min!y-range for visualization 
integer,public::iy_vis_max!y-range for visualization 
integer,public::iz_vis_min!z-range for visualization 
integer,public::iz_vis_max!z-range for visualization 
integer,public::xmin!x-range for visualization 
integer,public::xmax!x-range for visualization 
integer,public::ymin!y-range for visualization 
integer,public::ymax!y-range for visualization 
integer,public::zmin!z-range for visualization 
integer,public::zmax!z-range for visualization
integer,public::dense(3)! Dense k-grid for the Wnnier-interpolated FS
!initial_guess 
type initial_guess 
!integer::i,j!20170406
character(3)::orb!20170406
real(8)::a,x,y,z 
real(8)::lx(3)!20170914
real(8)::ly(3)!20170914
real(8)::lz(3)!20170914
end type initial_guess  
type(initial_guess),public,allocatable::vec_ini(:) 
!BMAT  
real(8),public,allocatable::B_MAT(:,:)!B_MAT(nigs,n_occ)
!symmetry line in BZ 
real(8),public,allocatable::SK_sym_pts(:,:) 
!wrt_list 
integer,public,allocatable::wrt_list(:)!wrt_list(N_write_wannier) 
!--
namelist/param_wannier/icell,N_wannier,N_initial_guess,EPS_SPILLAGE,DAMP,EPS_SPREAD,MAX_STEP_LENGTH,&
Lower_energy_window,Upper_energy_window,set_inner_window,Upper_inner_window,Lower_inner_window,flg_BMAT,&
reading_bmat_format,flg_initial_guess_direc,flg_vis_bloch,calc_k,electron_number_wannier_space,&
flg_fermisurface,flg_global_dos
namelist/param_interpolation/N_sym_points,Ndiv,reading_sk_format,dense!20170709  
namelist/param_visualization/flg_vis_wannier,N_write_wannier,& 
ix_vis_min,ix_vis_max,iy_vis_min,iy_vis_max,iz_vis_min,iz_vis_max
contains

subroutine read_input
integer::igs,ix,ik  
!--
!&param_wannier
!--
!default
ICELL=0
EPS_SPILLAGE=1.0d-4
DAMP=0.1d0 
EPS_SPREAD=1.0d-4
MAX_STEP_LENGTH=4.0d0 
SET_INNER_WINDOW=.FALSE.
UPPER_INNER_WINDOW=0.0d0 
LOWER_INNER_WINDOW=0.0d0 
FLG_BMAT=0
READING_BMAT_FORMAT=0
FLG_INITIAL_GUESS_DIREC=0
electron_number_wannier_space=0.0d0 
flg_fermisurface=0 
flg_global_dos=0 
flg_vis_bloch=0
CALC_BLOCH_VIS_RANGE=.FALSE.
calc_k(:)=0.0d0
!---
!open(999,file='input.in')
!read(999,nml=param_wannier)
read(5,nml=param_wannier)
!--
n_occ=N_wannier 
nigs=N_initial_guess 
E_LOWER=Lower_energy_window
E_UPPER=Upper_energy_window
E_LOWER_inner=Lower_inner_window
E_UPPER_inner=Upper_inner_window
elec_num=electron_number_wannier_space 
!--
!check ENERGY WINDOW
if(E_LOWER>=E_UPPER)then 
 write(6,'(a)')'wrong input: energy windows; stop'
 write(6,'(a)')'Lower_energy_window >= Upper_energy_window: WRONG'
 write(6,'(a,2f20.9)')'Lower_energy_window, Upper_energy_window',Lower_energy_window,Upper_energy_window
 stop
endif 
!--
!default set_inner_window==F
!if(set_inner_window.eqv..true..and.E_UPPER_inner==0.0d0.and.E_LOWER_inner==0.0d0)then!20171212 
!if(set_inner_window==.true..and.E_UPPER_inner==0.0d0.and.E_LOWER_inner==0.0d0)then!20180822 
if(set_inner_window.and.E_UPPER_inner==0.0d0.and.E_LOWER_inner==0.0d0)then!20181009
 write(6,'(a)')'wrong input: inner energy windows; stop'
 write(6,'(a)')'Lower_inner_window = Upper_inner_window = 0.0d0: WRONG'
 write(6,'(a,2f20.9)')'Upper_inner_window,Lower_inner_window',Upper_inner_window,Lower_inner_window
 stop
endif 
!if(set_inner_window.eqv..true.)then!20171212 
!if(set_inner_window==.true.)then!20180822 
if(set_inner_window)then!20181009 
 if(E_LOWER_inner>=E_UPPER_inner)then 
  write(6,'(a)')'wrong input: inner energy windows; stop'
  write(6,'(a)')'Lower_inner_window >= Upper_inner_window: WRONG'
  write(6,'(a,2f20.9)')'Lower_inner_window,Upper_inner_window',Lower_inner_window,Upper_inner_window
  stop
 endif 
 if(E_UPPER<=E_UPPER_inner)then 
  write(6,'(a)')'wrong input: inner energy windows; stop'
  write(6,'(a)')'Upper_energy_window <= Upper_inner_window: WRONG'
  write(6,'(a,2f20.9)')'Upper_energy_window,Upper_inner_window',Upper_energy_window,Upper_inner_window
  stop
 endif  
 if(E_LOWER>=E_LOWER_inner)then 
  write(6,'(a)')'wrong input: inner energy windows; stop'
  write(6,'(a)')'Lower_energy_window >= Lower_inner_window: WRONG'
  write(6,'(a,2f20.9)')'Lower_energy_window,Lower_inner_window',Lower_energy_window,Lower_inner_window
  stop
 endif 
endif 
!--
!INITIAL GUESS
allocate(vec_ini(nigs)) 
!--
if(flg_initial_guess_direc==0)then!default 20170914 
 write(6,*)'DIRECTION OF INITIAL GUESS IS REPRESENTED IN GLOBAL COORDINATE' 
 do igs=1,nigs
 !read(999,*)vec_ini(igs)
 !read(999,*)vec_ini(igs)%orb,vec_ini(igs)%a,vec_ini(igs)%x,vec_ini(igs)%y,vec_ini(igs)%z
  read(5,*)vec_ini(igs)%orb,vec_ini(igs)%a,vec_ini(igs)%x,vec_ini(igs)%y,vec_ini(igs)%z
 enddo 
 do igs=1,nigs 
  vec_ini(igs)%lx(:)=0.0d0  
  vec_ini(igs)%ly(:)=0.0d0  
  vec_ini(igs)%lz(:)=0.0d0  
  vec_ini(igs)%lx(1)=1.0d0  
  vec_ini(igs)%ly(2)=1.0d0  
  vec_ini(igs)%lz(3)=1.0d0  
 enddo 
endif 
!--
if(flg_initial_guess_direc==1)then!default 20170914 
 write(6,*)'DIRECTION OF INITIAL GUESS IS REPRESENTED IN LOCAL COORDINATE' 
 do igs=1,nigs
  !read(999,*)vec_ini(igs)
   read(5,*)vec_ini(igs)
 enddo 
endif 
!--
!B_MAT
allocate(B_MAT(nigs,n_occ));B_MAT(:,:)=0.0D0 
!default flg_BMAT==0
if(flg_BMAT==0)then  
 write(6,*)'BMAT is 0'
 if(nigs/=n_occ)then 
  write(6,*)'wrong input: nigs/=n_occ'
  stop
 endif 
 do igs=1,nigs!=n_occ 
  B_MAT(igs,igs)=1.0d0 
 enddo 
elseif(flg_BMAT==1)then 
 write(6,*)'BMAT from input.in'
 if(reading_bmat_format==0)then 
  write(6,*)'READING BMAT format=0: respack'
  do igs=1,nigs 
   !read(999,*)(B_MAT(igs,ix),ix=1,n_occ)
    read(5,*)(B_MAT(igs,ix),ix=1,n_occ)
  enddo
 endif 
 if(reading_bmat_format==1)then 
  write(6,*)'READING BMAT format=1: xtapp'
  do ix=1,n_occ 
   !read(999,*)(B_MAT(igs,ix),igs=1,nigs)
    read(5,*)(B_MAT(igs,ix),igs=1,nigs)
  enddo
 endif 
endif 
!--
if(flg_vis_bloch==0) CALC_REAL_SPACE_BLOCH=.false.!default 
if(flg_vis_bloch==1) CALC_REAL_SPACE_BLOCH=.true. 
!--
if(flg_fermisurface==0) CALC_FERMISURFACE=.false.!default 
if(flg_fermisurface==1) CALC_FERMISURFACE=.true. 
!--
if(flg_global_dos==0) CALC_GLOBAL_DOS=.false.!default 
if(flg_global_dos==1) CALC_GLOBAL_DOS=.true. 
!--
write(6,param_wannier) 
do igs=1,nigs 
 write(6,'(a3,x,4f8.4,9f8.4)') vec_ini(igs) 
enddo 
do igs=1,nigs 
 write(6,'(100f10.5)')(B_MAT(igs,ix),ix=1,n_occ)
enddo
write(6,*) 
!--
!&param_interpolation
!--
!default
Ndiv=40!Separation between symmetry points  
dense(1:3) = 0
!--
!read(999,nml=param_interpolation)
read(5,nml=param_interpolation)
!k for band dispersion
allocate(SK_sym_pts(3,N_sym_points))  
if(reading_sk_format==0)then 
 write(6,*)'READING SK_sym_pts format=0: respack'
 do ik=1,N_sym_points 
  !read(999,*)(SK_sym_pts(ix,ik),ix=1,3) 
  read(5,*)(SK_sym_pts(ix,ik),ix=1,3) 
 enddo 
endif 
if(reading_sk_format==1)then 
 write(6,*)'READING SK_sym_pts format=1: xtapp'
 do ix=1,3 
  !read(999,*)(SK_sym_pts(ix,ik),ik=1,N_sym_points) 
  read(5,*)(SK_sym_pts(ix,ik),ik=1,N_sym_points) 
 enddo 
endif 
!--
write(6,param_interpolation) 
do ik=1,N_sym_points 
 write(6,'(3f10.5)')(SK_sym_pts(ix,ik),ix=1,3) 
enddo 
write(6,*) 
!--
!&param_visualization)
!--
!default
ix_vis_min=-1
ix_vis_max=1
iy_vis_min=-1
iy_vis_max=1
iz_vis_min=-1
iz_vis_max=1
!--
!read(999,nml=param_visualization)
read(5,nml=param_visualization)
!default
if(flg_vis_wannier==0) CALC_REAL_SPACE_WANNIER=.false.!default 
if(flg_vis_wannier==1) CALC_REAL_SPACE_WANNIER=.true. 
!write vis wannier 
if(N_write_wannier==0)then
 N_write_wannier=N_wannier 
 allocate(wrt_list(N_write_wannier)) 
 do ix=1,N_write_wannier 
  wrt_list(ix)=ix
 enddo 
elseif(N_write_wannier/=0)then 
 allocate(wrt_list(N_write_wannier)) 
 !read(999,*)(wrt_list(ix),ix=1,N_write_wannier)
 read(5,*)(wrt_list(ix),ix=1,N_write_wannier)
endif  
xmin=ix_vis_min
xmax=ix_vis_max
ymin=iy_vis_min
ymax=iy_vis_max
zmin=iz_vis_min
zmax=iz_vis_max
!--
write(6,param_visualization) 
write(6,'(100i5)')(wrt_list(ix),ix=1,N_write_wannier) 
write(6,*) 
!--
end subroutine
end module

subroutine search_Rmin(i,j,k,nkb1,nkb2,nkb3,a1,a2,a3,imin,jmin,kmin)
implicit none
integer::i,j,k,nkb1,nkb2,nkb3
integer::imin,jmin,kmin
real(8)::a1(3),a2(3),a3(3) 
integer::nmin,mmin,lmin
integer::n,m,l 
real(8)::R_pos(3),R_abs,R_min,R_bfr
R_pos(:)=dble(i)*a1(:)+dble(j)*a2(:)+dble(k)*a3(:)
nmin=0;mmin=0;lmin=0
R_bfr=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
R_min=R_bfr 
do n=-3,3
 do m=-3,3
  do l=-3,3
   R_pos(:)=dble(i+n*nkb1)*a1(:)+dble(j+m*nkb2)*a2(:)+dble(k+l*nkb3)*a3(:)
   R_abs=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
   if(R_min>R_abs)then 
    R_min=R_abs
    nmin=n
    mmin=m
    lmin=l
   endif 
  enddo
 enddo
enddo
imin=i+nmin*nkb1
jmin=j+mmin*nkb2
kmin=k+lmin*nkb3
!if(nmin/=0.or.mmin/=0.or.lmin/=0)then 
! write(6,'(a15,f15.8)')'R_before      ',R_bfr 
! write(6,'(a15,f15.8)')'R_after       ',R_min 
! write(6,'(a15,3i5)')  'i   ,j   ,k   ',i,j,k
! write(6,'(a15,3i5)')  'nmin,mmin,lmin',nmin,mmin,lmin
! write(6,'(a15,3i5)')  'imin,jmin,kmin',imin,jmin,kmin
!endif 
return
end

subroutine calc_dos_GW(nkb1,nkb2,nkb3,NTK,NWF,nsgm,idlt,dmna,dmnr,shift_value,b1,b2,b3,sgmw,SK0,EMK,AW) 
 !
 use m_tetrahedron
 !
 implicit none 
 integer::nkb1,nkb2,nkb3,NTK,NWF,nsgm 
 real(8)::idlt,dmna,dmnr,shift_value 
 real(8)::b1(3),b2(3),b3(3),SK0(3,NTK),sgmw(nsgm)  
 complex(8)::EMK(NWF,NTK,nsgm)           
 integer::jb,ie,ikb1,ikb2,ikb3,ik   
 real(8)::delta,ReZ,ImZ,SUM_REAL 
 complex(8)::en  
 real(8)::AW(nsgm) 
 !
 !ttrhdrn
 !
 integer,allocatable::imt1(:)!imt1(4*nkb1*nkb2*nkb3*6)  
 integer,allocatable::index_kpt(:,:,:)!index_kpt(nkb1,nkb2,nkb3)    
 complex(8),allocatable::fk_1D(:)!fk_1D(NTK)
 complex(8),allocatable::gk_1D(:)!gk_1D(NTK)
 complex(8),allocatable::fk_3D(:,:,:)!fk_3D(nkb1,nkb2,nkb3) 
 complex(8),allocatable::gk_3D(:,:,:)!gk_3D(nkb1,nkb2,nkb3)
 complex(8),allocatable::xo(:,:,:)!xo(nkb1,nkb2,nkb3) 
 complex(8),allocatable::xow(:,:,:,:)!xow(nsgm,nkb1,nkb2,nkb3)
 !
 real(8),parameter::pi=dacos(-1.0d0)
 real(8),parameter::au=27.21151d0
 !
 allocate(imt1(4*nkb1*nkb2*nkb3*6)); imt1=0   
 allocate(index_kpt(nkb1,nkb2,nkb3)); index_kpt=0  
 call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
 call ttrhdrn_mkidx(nkb1,nkb2,nkb3,imt1(1),b1(1),b2(1),b3(1))
 !
 allocate(xow(nsgm,nkb1,nkb2,nkb3)); xow=0.0d0 
!$OMP PARALLEL PRIVATE(ie,jb,delta,fk_1D,gk_1D,ik,en,ReZ,ImZ,fk_3D,gk_3D,ikb3,ikb2,ikb1,xo) 
 allocate(fk_1D(NTK)); fk_1D=0.0d0 
 allocate(gk_1D(NTK)); gk_1D=0.0d0 
 allocate(fk_3D(nkb1,nkb2,nkb3)); fk_3D=0.0d0 
 allocate(gk_3D(nkb1,nkb2,nkb3)); gk_3D=0.0d0 
 allocate(xo(nkb1,nkb2,nkb3)); xo=0.0d0  
!$OMP DO 
 do ie=1,nsgm 
  do jb=1,NWF 
   !
   delta=sgmw(ie)+shift_value 
   !
   fk_1D=0.0d0
   gk_1D=0.0d0 
   do ik=1,NTK 
    en=EMK(jb,ik,ie)
    ReZ=delta-dble(en) 
    ImZ=-(idlt+dabs(dimag(en)))!retarded 
    gk_1D(ik)=cmplx(ReZ,ImZ)
    fk_1D(ik)=1.0d0 
   enddo!ik 
   !
   fk_3D=0.0d0
   gk_3D=0.0d0 
   do ikb3=1,nkb3
    do ikb2=1,nkb2
     do ikb1=1,nkb1
      ik=index_kpt(ikb1,ikb2,ikb3)
      fk_3D(ikb1,ikb2,ikb3)=fk_1D(ik)
      gk_3D(ikb1,ikb2,ikb3)=gk_1D(ik)
     enddo!ikb1 
    enddo!ikb2 
   enddo!ikb3 
   !
   xo=0.0d0 
   call ttrhdrn_simple(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),fk_3D(1,1,1),gk_3D(1,1,1),xo(1,1,1))
   xow(ie,:,:,:)=xow(ie,:,:,:)+xo(:,:,:) 
   !
  enddo!jb 
 enddo!ie
!$OMP END DO
 deallocate(fk_1D,gk_1D,fk_3D,gk_3D,xo) 
!$OMP END PARALLEL
 !
 AW=0.0d0 
 do ie=1,nsgm
  SUM_REAL=0.0d0 
  do ikb3=1,nkb3
   do ikb2=1,nkb2
    do ikb1=1,nkb1
     SUM_REAL=SUM_REAL+dabs(dimag(xow(ie,ikb1,ikb2,ikb3))) 
    enddo!ikb1 
   enddo!ikb2 
  enddo!ikb3 
 AW(ie)=2.0d0*SUM_REAL/dble(NTK)/pi 
 enddo!ie  
 !
 deallocate(imt1,index_kpt,xow) 
 !
RETURN  
END 

module m_rd_input 
implicit none
private
public::read_input 
!&param_calc_gw 
integer,public::Rc_range_spacing!Range of attenuation potential cutoff 
integer,public::Ncalc!The number of bands considered in the GW calculation  
logical,public::calc_SC!flag to calc SC or not 
real(8),public::gw_grid_separation!minimum separation of GW grid (eV) 
!real(8),public::Green_func_delt!ttrhdrn Green's function delt (eV)
!real(8),public::idlt!ttrhdrn Green's function delt (eV)
!&param_interpolation   
integer,public::N_sym_points!The number of k-point points in symmetry line
integer,public::Ndiv!Separation between symmetry points  
integer,public::reading_sk_format!20170709 
real(8),public,allocatable::SK_sym_pts(:,:) 
integer,public,allocatable::dense(:)!dense(3)!Dense k-grid for the Wnnier-interpolated FS
namelist/param_interpolation/N_sym_points,Ndiv,reading_sk_format,dense
namelist/param_calc_gw/Rc_range_spacing,Ncalc,calc_SC,gw_grid_separation   
contains
subroutine read_input 
integer::ix,ik  
!--
!&param_interpolation
!--
!default
Ndiv=40!Separation between symmetry points  
allocate(dense(3));dense(1:3)=0
!--
rewind(5) 
!read(999,nml=param_interpolation)
read(5,nml=param_interpolation)
write(6,param_interpolation) 
!k for band dispersion
allocate(SK_sym_pts(3,N_sym_points))  
if(reading_sk_format==0)then 
 write(6,*)'READING SK_sym_pts format=0: respack'
 do ik=1,N_sym_points 
  !read(999,*)(SK_sym_pts(ix,ik),ix=1,3) 
  read(5,*)(SK_sym_pts(ix,ik),ix=1,3) 
 enddo 
endif 
if(reading_sk_format==1)then 
 write(6,*)'READING SK_sym_pts format=1: xtapp'
 do ix=1,3 
  !read(999,*)(SK_sym_pts(ix,ik),ik=1,N_sym_points) 
  read(5,*)(SK_sym_pts(ix,ik),ik=1,N_sym_points) 
 enddo 
endif 
!--
write(6,param_interpolation) 
do ik=1,N_sym_points 
 write(6,'(3f10.5)')(SK_sym_pts(ix,ik),ix=1,3) 
enddo 
write(6,*) 
!--
!&param_calc_gw 
!--
!default
!
!GREEN_FUNC_DELT=0.1d0!eV
!
Rc_range_spacing=2!3  
Ncalc=0!Ncalc is set to NTB after
calc_SC=.true.!calc SC: .true., not calc SC: .false.
gw_grid_separation=0.05d0!(eV) 
!--
!open(999,file='input.in')
!read(999,nml=param_calc_gw)
read(5,nml=param_calc_gw)
write(6,param_calc_gw) 
!
!idlt=Green_func_delt 
!
!--
end subroutine
end module

      subroutine search_kq(NTK,SK0,q1,q2,q3,ik,ikq,shift_G)
      implicit none 
      integer::NTK
      real(8)::SK0(3,NTK)  
      real(8)::q1,q2,q3
      integer::ik,jk
      real(8)::SKQ(3)
      integer::ikq,shift_G(3) 
      real(8),parameter::dlt_BZ=1.0d-6!20170316 
!--
      SKQ(1)=SK0(1,ik)+q1
      SKQ(2)=SK0(2,ik)+q2 
      SKQ(3)=SK0(3,ik)+q3 
!--
      if(SKQ(1)>1.50d0+dlt_BZ)then 
       SKQ(1)=SKQ(1)-2.0D0 
       shift_G(1)=+2 
      endif 
      if(SKQ(1)>0.5D0+dlt_BZ)then 
       SKQ(1)=SKQ(1)-1.0D0 
       shift_G(1)=+1
      endif 
      if(SKQ(1)<=-1.5D0+dlt_BZ)then 
       SKQ(1)=SKQ(1)+2.0D0 
       shift_G(1)=-2 
      endif 
      if(SKQ(1)<=-0.5D0+dlt_BZ)then 
       SKQ(1)=SKQ(1)+1.0D0 
       shift_G(1)=-1
      endif 
!--
      if(SKQ(2)>1.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)-2.0D0 
       shift_G(2)=+2 
      endif 
      if(SKQ(2)>0.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)-1.0D0 
       shift_G(2)=+1
      endif 
      if(SKQ(2)<=-1.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)+2.0D0 
       shift_G(2)=-2 
      endif 
      if(SKQ(2)<=-0.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)+1.0D0 
       shift_G(2)=-1
      endif 
!--
      if(SKQ(3)>1.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)-2.0D0 
       shift_G(3)=+2 
      endif 
      if(SKQ(3)>0.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)-1.0D0 
       shift_G(3)=+1
      endif 
      if(SKQ(3)<=-1.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)+2.0D0 
       shift_G(3)=-2 
      endif 
      if(SKQ(3)<=-0.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)+1.0D0 
       shift_G(3)=-1
      endif 
!--
      do jk=1,NTK
       if(ABS(SK0(1,jk)-SKQ(1))<1.D-6.and.
     +    ABS(SK0(2,jk)-SKQ(2))<1.D-6.and. 
     +    ABS(SK0(3,jk)-SKQ(3))<1.D-6)then 
        ikq=jk 
       endif 
!      write(6,'(a6,3f15.7)')'SKQ',SKQ
      enddo 
      RETURN  
      END 
!--
      subroutine search_list(SQI,SQ)
      implicit none 
      real(8)::SQI(3),SQ(3)
      real(8),parameter::dlt_BZ=1.0d-6!20170316 
      SQ=SQI 
      if(SQ(1)>  1.50d0+dlt_BZ) SQ(1)=SQ(1)-2.0d0 
      if(SQ(1)>  0.50d0+dlt_BZ) SQ(1)=SQ(1)-1.0d0 
      if(SQ(1)<=-1.50d0+dlt_BZ) SQ(1)=SQ(1)+2.0d0 
      if(SQ(1)<=-0.50d0+dlt_BZ) SQ(1)=SQ(1)+1.0d0 
      if(SQ(2)>  1.50d0+dlt_BZ) SQ(2)=SQ(2)-2.0d0 
      if(SQ(2)>  0.50d0+dlt_BZ) SQ(2)=SQ(2)-1.0d0 
      if(SQ(2)<=-1.50d0+dlt_BZ) SQ(2)=SQ(2)+2.0d0 
      if(SQ(2)<=-0.50d0+dlt_BZ) SQ(2)=SQ(2)+1.0d0 
      if(SQ(3)>  1.50d0+dlt_BZ) SQ(3)=SQ(3)-2.0d0 
      if(SQ(3)>  0.50d0+dlt_BZ) SQ(3)=SQ(3)-1.0d0 
      if(SQ(3)<=-0.50d0+dlt_BZ) SQ(3)=SQ(3)+1.0d0 
      if(SQ(3)<=-1.50d0+dlt_BZ) SQ(3)=SQ(3)+2.0d0 
      RETURN  
      END 
!--
      subroutine calc_InterStateMatrix(NTK,NTG,NG0,KG0,C0_K,C0_KQ,
     +                                 ik,ikq,nwx2,nwy2,nwz2,
     +                                 nfft1,nfft2,Nl123,
     +                                 wfunc,fftwk,fs,LG0,NG_for_eps,
     +                                 shift_G,m_tmp)
!--
      use fft_3d 
      implicit none 
      type(fft3_struct)::fs 
      integer::NTK,NTG 
      integer::NG0(NTK),KG0(3,NTG,NTK) 
      complex(8)::C0_K(NTG),C0_KQ(NTG) 
      integer::ik,ikq 
      integer::nwx2,nwy2,nwz2,nfft1,nfft2,Nl123 
      real(8)::wfunc(Nl123*2),fftwk(Nl123*2) 
      integer::NG_for_eps 
      integer::LG0(3,NTG) 
      integer::shift_G(3)
      integer::ig,igb1,igb2,igb3,ind,igL,igL1,igL2,igL3  
      integer::ir,ir1,ir2,ir3 
      complex(8)::cell_periodic_k(Nl123)  
      complex(8)::cell_periodic_kq(Nl123)  
      complex(8)::f
      real(8)::dG1,dG2,dG3
      real(8)::phase 
      complex(8)::pf 
      complex(8)::m_tmp(NG_for_eps) 
      real(8),parameter::pi=dacos(-1.0d0)
      real(8),parameter::tpi=2.0d0*pi 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      wfunc(:)=0.0D0
      fftwk(:)=0.0D0
      do ig=1,NG0(ik) 
       igb1=KG0(1,ig,ik) 
       igb2=KG0(2,ig,ik) 
       igb3=KG0(3,ig,ik) 
       igb1=MOD(nwx2+igb1,nwx2)+1
       igb2=MOD(nwy2+igb2,nwy2)+1
       igb3=MOD(nwz2+igb3,nwz2)+1
       ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
       wfunc(ind)=dble(C0_K(ig))
       wfunc(ind+Nl123)=dimag(C0_K(ig))
      enddo 
      call fft3_bw(fs,wfunc(1),fftwk(1)) 
      do ir=1,Nl123 
       cell_periodic_k(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
      enddo 
!     write(6,*) 'cell_k',cell_periodic_k  
!--
      wfunc(:)=0.0D0
      fftwk(:)=0.0D0
      do ig=1,NG0(ikq)
       igb1=KG0(1,ig,ikq)
       igb2=KG0(2,ig,ikq) 
       igb3=KG0(3,ig,ikq) 
       igb1=MOD(nwx2+igb1,nwx2)+1
       igb2=MOD(nwy2+igb2,nwy2)+1      
       igb3=MOD(nwz2+igb3,nwz2)+1 
       ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
       wfunc(ind)=dble(C0_KQ(ig))
       wfunc(ind+Nl123)=dimag(C0_KQ(ig)) 
      enddo 
      call fft3_bw(fs,wfunc,fftwk)    
      do ir=1,Nl123
       cell_periodic_kq(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
      enddo 
!    write(6,*) 'cell_kq',cell_periodic_kq  
!--
      dG1=dble(shift_G(1))
      dG2=dble(shift_G(2))
      dG3=dble(shift_G(3))
!     write(6,*) 'dG=',dG1,dG2,dG3
!--
      do ir3=1,nwz2
       do ir2=1,nwy2
        do ir1=1,nwx2
         ir=ir1+(ir2-1)*nfft1+(ir3-1)*nfft1*nfft2 
         phase=tpi*(dble(ir1-1)*dG1/dble(nwx2)
     +             +dble(ir2-1)*dG2/dble(nwy2) 
     +             +dble(ir3-1)*dG3/dble(nwz2)) 
         pf=exp(-ci*phase) 
         cell_periodic_kq(ir)
     +  =cell_periodic_kq(ir)*pf 
        enddo 
       enddo 
      enddo 
!--
      wfunc(:)=0.0D0
      fftwk(:)=0.0D0
      do ir=1,Nl123 
       f=CONJG(cell_periodic_kq(ir))*cell_periodic_k(ir)
       wfunc(ir)=dble(f)
       wfunc(ir+Nl123)=dimag(f) 
      enddo 
      call fft3_fw(fs,wfunc,fftwk) 
      do igL=1,NG_for_eps
       igL1=-LG0(1,igL)
       igL2=-LG0(2,igL)
       igL3=-LG0(3,igL) 
       igL1=MOD(nwx2+igL1,nwx2)+1
       igL2=MOD(nwy2+igL2,nwy2)+1
       igL3=MOD(nwz2+igL3,nwz2)+1
       ind=igL1+(igL2-1)*nfft1+(igL3-1)*nfft1*nfft2
       m_tmp(igL)=cmplx(wfunc(ind),wfunc(ind+Nl123))
      enddo 
!--
      RETURN  
      END 
!--
      subroutine calc_VMab(NTK,NTG,NG0,KG0,C0_K,C0_KQ,ik,b1,b2,b3,vm)  
      implicit none 
      integer::NTK,NTG,ik 
      integer::NG0(NTK),KG0(3,NTG,NTK) 
      real(8)::b1(3),b2(3),b3(3) 
      complex(8)::C0_K(NTG),C0_KQ(NTG) 
      integer::ig,igb1,igb2,igb3 
      real(8)::G_VEC(3)
      complex(8)::SUM_VEC(3)
      complex(8)::vm(3) 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      SUM_VEC(:)=0.0D0 
      do ig=1,NG0(ik) 
       igb1=KG0(1,ig,ik) 
       igb2=KG0(2,ig,ik) 
       igb3=KG0(3,ig,ik) 
       G_VEC(:)=dble(igb1)*b1(:)+dble(igb2)*b2(:)+dble(igb3)*b3(:) 
       SUM_VEC(:)=SUM_VEC(:)+G_VEC(:)*CONJG(C0_KQ(ig))*C0_K(ig) 
      enddo 
!"vm" depends on the direction of q approaching the zero limit
!We employ q=[001],[010],[100] therefore
!Kazuma Nakamura bugfix 2010 10 12
      vm(:)=SUM_VEC(:)*ci!ci is multiplied  
      RETURN  
      END 
!--
      subroutine calc_VMaa(NTK,NTG,NG0,KG0,C0_K,C0_KQ,ik,b1,b2,b3,SKT, 
     +                     vm)  
      implicit none 
      integer::NTK,NTG,ik 
      integer::NG0(NTK),KG0(3,NTG,NTK) 
      real(8)::b1(3),b2(3),b3(3),SKT(3) 
      complex(8)::C0_K(NTG),C0_KQ(NTG) 
      integer::ig,igb1,igb2,igb3 
      real(8)::G_VEC(3)
      complex(8)::SUM_VEC(3)
      complex(8) :: vm(3) 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      SUM_VEC(:)=0.0D0 
      do ig=1,NG0(ik) 
       igb1=KG0(1,ig,ik) 
       igb2=KG0(2,ig,ik) 
       igb3=KG0(3,ig,ik) 
       G_VEC(:)=(SKT(1)+dble(igb1))*b1(:)
     +         +(SKT(2)+dble(igb2))*b2(:)
     +         +(SKT(3)+dble(igb3))*b3(:) 
       SUM_VEC(:)=SUM_VEC(:)+G_VEC(:)*CONJG(C0_KQ(ig))*C0_K(ig) 
      enddo 
!"vm" depends on the direction of q approaching the zero limit 
!We employ q=[001],[010],[100] therefore
!Kazuma Nakamura bugfix 2010 10 12
      vm(:)=SUM_VEC(:)*ci!ci is multiplied  
      RETURN  
      END 
!--
      subroutine make_C0(NTG,itrs,NG,KGtmp,RWtmp,rginvtmp,pgtmp,
     +           nnp,L1,L2,L3,packtmp,OCCtmp,C0_K) 
      implicit none 
      integer::NTG,L1,L2,L3,nnp  
      integer::itrs 
      integer::NG
      integer::KGtmp(3,NTG) 
      integer::RWtmp(3) 
      real(8)::rginvtmp(3,3) 
      integer::pgtmp(3) 
      integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
      complex(8)::OCCtmp(NTG) 
      integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3 
      real(8)::phase 
      complex(8)::pf 
      complex(8)::C0_K(NTG) 
      real(8),parameter::pi=dacos(-1.0d0)
      real(8),parameter::tpi=2.0d0*pi 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      C0_K(:)=0.0d0 
      if(itrs==1) then 
       do ig=1,NG 
        i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
        i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
        i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +    +int(rginvtmp(1,3))*k2 
        j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +    +int(rginvtmp(2,3))*k2 
        k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +    +int(rginvtmp(3,3))*k2 
        jg=packtmp(i3,j3,k3) 
        phase=tpi*(dble(i1)*dble(pgtmp(1))
     +            +dble(j1)*dble(pgtmp(2))
     +            +dble(k1)*dble(pgtmp(3))) 
        pf=exp(-ci*phase/dble(nnp)) 
        C0_K(ig)=OCCtmp(jg)*pf 
       enddo!ig 
      elseif(itrs==-1) then  
       do ig=1,NG 
        i1=-KGtmp(1,ig); j1=-KGtmp(2,ig); k1=-KGtmp(3,ig) 
        i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
        i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +    +int(rginvtmp(1,3))*k2 
        j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +    +int(rginvtmp(2,3))*k2 
        k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +    +int(rginvtmp(3,3))*k2 
        jg=packtmp(i3,j3,k3) 
        phase=tpi*(dble(i1)*dble(pgtmp(1))
     +            +dble(j1)*dble(pgtmp(2))
     +            +dble(k1)*dble(pgtmp(3))) 
        pf=exp(-ci*phase/dble(nnp)) 
        C0_K(ig)=OCCtmp(jg)*pf 
       enddo!ig 
       C0_K(:)=conjg(C0_K(:))  
      endif 
      return 
      end 
!---
      SUBROUTINE make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0,index_kpt)      
      implicit none 
      integer::NTK,nkb1,nkb2,nkb3
      real(8)::SK0(3,NTK)  
      integer::ik,ix,iy,iz
      real(8)::x,y,z
      integer::index_kpt(nkb1,nkb2,nkb3)    
      ! 
      !if(MOD(NTK,2)/=0) then 
      ! write(6,*)'i am in make_index for odd'
      ! do ik=1,NTK 
      !  x=SK0(1,ik)*dble(nkb1) 
      !  y=SK0(2,ik)*dble(nkb2)
      !  z=SK0(3,ik)*dble(nkb3)  
      !  x=x+(dble(nkb1)-1.0d0)/2.0d0 
      !  y=y+(dble(nkb2)-1.0d0)/2.0d0
      !  z=z+(dble(nkb3)-1.0d0)/2.0d0 
      !  ix=idnint(x)+1
      !  iy=idnint(y)+1
      !  iz=idnint(z)+1
      !  index_kpt(ix,iy,iz)=ik
      ! enddo 
      !else!20170316 
      ! write(6,*)'i am in make_index for even'
      ! do ik=1,NTK 
      !  x=SK0(1,ik)*dble(nkb1) 
      !  y=SK0(2,ik)*dble(nkb2)
      !  z=SK0(3,ik)*dble(nkb3)  
      !  x=x+dble(nkb1)/2.0d0 
      !  y=y+dble(nkb2)/2.0d0
      !  z=z+dble(nkb3)/2.0d0 
      !  ix=idnint(x)
      !  iy=idnint(y)
      !  iz=idnint(z)
      !  index_kpt(ix,iy,iz)=ik
      ! enddo 
      !endif 
      !--
      !
      !20190520 Kazuma Nakamura
      !
      do ik=1,NTK 
       x=SK0(1,ik)*dble(nkb1) 
       y=SK0(2,ik)*dble(nkb2)
       z=SK0(3,ik)*dble(nkb3)  
       x=x+(dble(nkb1)-dble(mod(nkb1,2)))/2.0d0 
       y=y+(dble(nkb2)-dble(mod(nkb2,2)))/2.0d0 
       z=z+(dble(nkb3)-dble(mod(nkb3,2)))/2.0d0 
       ix=idnint(x)+mod(nkb1,2)
       iy=idnint(y)+mod(nkb2,2)
       iz=idnint(z)+mod(nkb3,2)
       index_kpt(ix,iy,iz)=ik
      enddo 
      ! 
      !--
      !do iz=1,nkb3 
      ! do iy=1,nkb2
      !  do ix=1,nkb1
      !   ik=index_kpt(ix,iy,iz)
      !   write(6,'(i8,3f15.10)') ik,SK0(:,ik)
      !  enddo
      ! enddo
      !enddo
      !--
      !
      RETURN  
      END 
!---
      subroutine calc_eps_rpa(NTG,NG_for_eps,LG0,
     +                   q1,q2,q3,b1,b2,b3,
     +                   chi0,tpi,eps_rpa, 
     +                   file_num_chi,file_num_eps)  
      implicit none 
      integer::NTG,NG_for_eps  
      integer::LG0(3,NTG)    
      real(8)::q1,q2,q3,b1(3),b2(3),b3(3),tpi 
      integer::file_num_chi,file_num_eps 
      complex(8)::chi0(NG_for_eps,NG_for_eps)
      integer::ig,jg,igL1,igL2,igL3,jgL1,jgL2,jgL3 
      real(8)::qgL(3),qgL1,qgL2,qgLi,qgLj   
      complex(8)::f
      complex(8)::eps_rpa(NG_for_eps,NG_for_eps) 
!
      if(file_num_chi==0) write(6,*)'not write chi'
!Factor of 2 is needed for only LDA-polarization calculation, pointed by Yohiro Nohara, 2009 5 27 ---* 
      chi0(:,:)=2.0d0*chi0(:,:) 
!cal_eps_rpa 
      write(6,*)'calc eps_rpa'
      write(6,*)' ' 
      eps_rpa(:,:)=0.0D0 
      do ig=1,NG_for_eps 
       igL1=LG0(1,ig)
       igL2=LG0(2,ig)
       igL3=LG0(3,ig)
       qgL(:)=(q1+dble(igL1))*b1(:)
     +       +(q2+dble(igL2))*b2(:)
     +       +(q3+dble(igL3))*b3(:)
       qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
       qgLi=dsqrt(qgL2) 
      do jg=1,NG_for_eps   
       jgL1=LG0(1,jg)
       jgL2=LG0(2,jg)
       jgL3=LG0(3,jg)
       qgL(:)=(q1+dble(jgL1))*b1(:)
     +       +(q2+dble(jgL2))*b2(:)
     +       +(q3+dble(jgL3))*b3(:)
       qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
       qgLj=dsqrt(qgL2) 
!diag 
       if(ig==jg)then 
!       write(file_num_chi,'(3F20.10)') qgLi,chi0(ig,jg)
        eps_rpa(ig,jg)=1.0D0-chi0(ig,jg)*2.0D0*tpi/qgLi/qgLj 
       endif 
!off diag
       if(ig/=jg)then 
        eps_rpa(ig,jg)=-chi0(ig,jg)*2.0D0*tpi/qgLi/qgLj 
       endif 
      enddo 
      enddo 
!---
      call invZGE(NG_for_eps,eps_rpa(1,1)) 
!---
      write(6,*)'calc eps_rpa_inv'
      write(6,*)' ' 
      do ig=1,NG_for_eps 
       igL1=LG0(1,ig)
       igL2=LG0(2,ig)
       igL3=LG0(3,ig)
       qgL(:)=(q1+dble(igL1))*b1(:)
     +       +(q2+dble(igL2))*b2(:)
     +       +(q3+dble(igL3))*b3(:)
       qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
       qgL1=dsqrt(qgL2) 
       f=eps_rpa(ig,ig)
!      write(file_num_eps,'(3F20.10)') qgL1,dble(1.0D0/f),dimag(1.0d0/f)  
       write(file_num_eps,'(3F20.10)') qgL1,dble(f),dimag(f)  
      enddo 
!---
      return 
      end 
!---
      subroutine calc_eps_rpa_q_0(NTG,NG_for_eps,LG0,
     +                   q1,q2,q3,b1,b2,b3,
     +                   chi0,tpi,No_G_0,eps_rpa,
     +                   wd,delt,wcmplx,   
     +                   file_num_chi,file_num_eps)  
      implicit none 
      integer::NTG,NG_for_eps,No_G_0,file_num_chi,file_num_eps 
      integer::LG0(3,NTG)    
      real(8)::q1,q2,q3,b1(3),b2(3),b3(3),tpi,wd,delt,w  
      complex(8)::chi0(NG_for_eps,NG_for_eps)
      complex(8)::wcmplx,f
      integer::ig,jg,igL1,igL2,igL3,jgL1,jgL2,jgL3 
      real(8)::qgL(3),qgL1,qgL2,qgLi,qgLj   
      complex(8)::eps_rpa(NG_for_eps,NG_for_eps) 
!
      if(file_num_chi==0) write(6,*)'not write chi'
!Factor of 2 is needed for only LDA-polarization calculation, pointed by Yohiro Nohara, 2009 5 27 ---* 
      chi0(:,:)=2.0d0*chi0(:,:) 
      w=dble(wcmplx)  
      if(w==0.0d0)then 
       w=1.0d-5 
       write(6,*) wcmplx,w 
      endif 
!     wd=0.0d0 
!calc_eps_rpa_q=0 
      write(6,*)'calc eps_rpa_q=0'
      write(6,*)' ' 
      eps_rpa(:,:)=0.0D0 
      do ig=1,NG_for_eps 
       igL1=LG0(1,ig)
       igL2=LG0(2,ig)
       igL3=LG0(3,ig)
       qgL(:)=(q1+dble(igL1))*b1(:)
     +       +(q2+dble(igL2))*b2(:)
     +       +(q3+dble(igL3))*b3(:)
       qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
       qgLi=dsqrt(qgL2) 
      do jg=1,NG_for_eps   
       jgL1=LG0(1,jg)
       jgL2=LG0(2,jg)
       jgL3=LG0(3,jg)
       qgL(:)=(q1+dble(jgL1))*b1(:)
     +       +(q2+dble(jgL2))*b2(:)
     +       +(q3+dble(jgL3))*b3(:)
       qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
       qgLj=dsqrt(qgL2) 
!head 
       if(ig==jg.and.ig==No_G_0)then 
!       write(file_num_chi,'(3F20.10)') qgLi,chi0(ig,jg)
        eps_rpa(ig,jg)
     + =1.0D0-chi0(ig,jg)*2.0D0*tpi 
     + +cmplx(-wd**2/(w**2+delt**2),delt*wd**2/(w**3+w*delt**2))
       endif 
!body(diag)
       if(ig==jg.and.ig/=No_G_0)then 
!       write(file_num_chi,'(3F20.10)') qgLi,chi0(ig,jg)
        eps_rpa(ig,jg)=1.0D0-chi0(ig,jg)*2.0D0*tpi/qgLi/qgLj  
       endif 
!wing(column) 
       if(ig/=jg.and.ig==No_G_0)then 
        eps_rpa(ig,jg)=-chi0(ig,jg)*2.0D0*tpi/qgLj  
       endif 
!wing(raw) 
       if(ig/=jg.and.jg==No_G_0)then 
        eps_rpa(ig,jg)=-chi0(ig,jg)*2.0D0*tpi/qgLi
       endif      
!body(off diag)
       if(ig/=jg.and.ig/=No_G_0.and.jg/=No_G_0) then 
        eps_rpa(ig,jg)=-chi0(ig,jg)*2.0D0*tpi/qgLi/qgLj 
       endif 
      enddo 
      enddo 
!---
!      write(6,*)' '
!      write(6,*)'eps(i,G0)'
!      do ig=1,NG_for_eps
!       write(6,*) ig,eps_rpa(ig,No_G_0)
!      enddo 
!      write(6,*)' '
!      write(6,*)'eps(G0,j)'
!      do ig=1,NG_for_eps
!       write(6,*) ig,eps_rpa(No_G_0,ig)
!      enddo 
!      write(6,*)' '
!---
!      do ig=1,NG_for_eps
!       do jg=1,NG_for_eps
!        write(6,'(2i8,2f15.8)') ig,jg,eps_rpa(ig,jg)
!       enddo 
!      enddo 
!---
      call invZGE(NG_for_eps,eps_rpa(1,1)) 
!---
      write(6,*)'calc eps_rpa_inv_q=0'
      write(6,*)' ' 
      do ig=1,NG_for_eps 
       igL1=LG0(1,ig)
       igL2=LG0(2,ig)
       igL3=LG0(3,ig)
       qgL(:)=(q1+dble(igL1))*b1(:)
     +       +(q2+dble(igL2))*b2(:)
     +       +(q3+dble(igL3))*b3(:)
       qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
       qgL1=dsqrt(qgL2) 
       f=eps_rpa(ig,ig)
!     write(file_num_eps,'(3F20.10)') qgL1,dble(1.0D0/f),dimag(1.0d0/f) 
      write(file_num_eps,'(3F20.10)') qgL1,dble(f),dimag(f)  
      enddo 
      return 
      end 
!--
      subroutine judge_FermiInside(NTK,NTB,E_EIG,FermiEnergy,
     + WindowInside,Tindx,E_AVE,band_max,band_min) 
      implicit none 
      integer::NTK,NTB
      real(8)::E_EIG(NTB,NTK)  
      real(8)::FermiEnergy
      integer::ik,ib,fs 
      real(8)::e,top,btm 
      integer::WindowInside(NTB)    
      integer::Tindx(NTB)    
      real(8)::E_AVE(NTB)    
      real(8)::band_max(NTB)
      real(8)::band_min(NTB)
!--
      WindowInside(:)=0
      Tindx(:)=0
      do ib=1,NTB
       do ik=1,NTK 
        e=E_EIG(ib,ik) 
        if(ik==1)then 
         top=e
         btm=e
        endif 
        if(e<btm) btm=e
        if(e>top) top=e
       enddo!ik 
!uocc
       if(btm>FermiEnergy) fs=2
!pocc
       if(btm<=FermiEnergy.and.top>=FermiEnergy) then
        fs=1
        Tindx(ib)=ib 
       endif 
!docc
       if(top<FermiEnergy) fs=0
!
       WindowInside(ib)=fs 
       E_AVE(ib)=(top+btm)/2.0d0 
       band_max(ib)=top
       band_min(ib)=btm
      enddo!ib 
!--
      RETURN 
      END 
!--
      subroutine judge_WindowInside(NTK,NTB,E_EIG,EL,EU,WindowInside,
     + Tindx,E_AVE,band_max,band_min)
      implicit none 
      integer::NTK,NTB
      real(8)::E_EIG(NTB,NTK)  
      real(8)::EL,EU
      integer::ik,ib,fs 
      real(8)::e,top,btm 
      integer::WindowInside(NTB)    
      integer::Tindx(NTB)    
      real(8)::E_AVE(NTB)    
      real(8)::band_max(NTB)
      real(8)::band_min(NTB)
!--
      WindowInside(:)=0
      Tindx(:)=0
      do ib=1,NTB
       do ik=1,NTK 
        e=E_EIG(ib,ik) 
        if(ik==1)then 
         top=e
         btm=e
        endif 
        if(e<btm) btm=e
        if(e>top) top=e
       enddo!ik 
!case1:docc
       if(top<EL) fs=0
!case2:docc
       if(EL<=top.and.top<EU.and.btm<EL) fs=0 
!case3:pocc
       if(EL<=top.and.top<EU.and.EL<=btm.and.btm<EU)then 
        fs=1
        Tindx(ib)=ib
       endif   
!case4:pocc
       if(btm<EL.and.top>EU)then   
        fs=1 
        Tindx(ib)=ib
       endif   
!case5:uocc
       if(EL<btm.and.btm<EU.and.top>EU) fs=2 
!case6:uocc 
       if(btm>EU) fs=2 
!--
       WindowInside(ib)=fs 
       E_AVE(ib)=(top+btm)/2.0d0 
       band_max(ib)=top
       band_min(ib)=btm
      enddo!ib 
      RETURN 
      END 
!--
      subroutine kcheck(ktmp,RWtmp) 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      real(8),parameter::dlt_BZ=1.0d-6!20170316 
!--
!      write(6,'(a8,3f15.10)')'before',ktmp(1),ktmp(2),ktmp(3)
!--
      if(ktmp(1)>1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-2.0d0;RWtmp(1)=-2
      endif 
      if(ktmp(1)>0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<=-1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+2.0d0;RWtmp(1)=2 
      endif 
      if(ktmp(1)<=-0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
!--
      if(ktmp(2)>1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-2.0d0;RWtmp(2)=-2 
      endif 
      if(ktmp(2)>0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<=-1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+2.0d0;RWtmp(2)=2 
      endif 
      if(ktmp(2)<=-0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
!--
      if(ktmp(3)>1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-2.0d0;RWtmp(3)=-2 
      endif 
      if(ktmp(3)>0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<=-1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+2.0d0;RWtmp(3)=2 
      endif 
      if(ktmp(3)<=-0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
!--
!     write(6,'(a8,3f15.10)')'after',ktmp(1),ktmp(2),ktmp(3)
!--
      return
      end 
!--
!20170316 
      subroutine kcheck_trs(ktmp,RWtmp)!20170316 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      real(8),parameter::dlt_BZ=-1.0d-6 
!--
!      write(6,'(a8,3f15.10)') 'before',ktmp(1),ktmp(2),ktmp(3)
!--
      if(ktmp(1)>=1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-2.0d0;RWtmp(1)=-2
      endif 
      if(ktmp(1)>=0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<-1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+2.0d0;RWtmp(1)=2 
      endif 
      if(ktmp(1)<-0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
!--
      if(ktmp(2)>=1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-2.0d0;RWtmp(2)=-2 
      endif 
      if(ktmp(2)>=0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<-1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+2.0d0;RWtmp(2)=2 
      endif 
      if(ktmp(2)<-0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
!--
      if(ktmp(3)>=1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-2.0d0;RWtmp(3)=-2 
      endif 
      if(ktmp(3)>=0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<-1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+2.0d0;RWtmp(3)=2 
      endif 
      if(ktmp(3)<-0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
!--
!      write(6,'(a8,3f15.10)') 'after',ktmp(1),ktmp(2),ktmp(3)
!--
      return
      end 
!--
      subroutine make_KG0(NTG,b1,b2,b3,Gcut,q1,q2,q3,KG0,NG) 
      implicit none 
      integer,intent(in)::NTG
      real(8),intent(in)::b1(3),b2(3),b3(3) 
      real(8),intent(in)::q1,q2,q3,Gcut 
      integer::igL,igL1,igL2,igL3
      real(8)::qgL(3),qgL2  
      integer,intent(out)::KG0(3,NTG)    
      integer,intent(out)::NG 
      integer,parameter::NGL1=150!100!300
      integer,parameter::NGL2=150!100!300 
      integer,parameter::NGL3=150!100!300
      igL=0
      do igL1=-NGL1,NGL1 
       do igL2=-NGL2,NGL2 
        do igL3=-NGL3,NGL3 
         qgL(:)=(q1+dble(igL1))*b1(:)
     +         +(q2+dble(igL2))*b2(:)
     +         +(q3+dble(igL3))*b3(:)    
         qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
         if(qgL2<=Gcut)then 
          igL=igL+1 
          KG0(1,igL)=igL1
          KG0(2,igL)=igL2
          KG0(3,igL)=igL3 
         endif  
        enddo 
       enddo 
      enddo 
      NG=igL 
!---
!write(6,*)"maxabs KG0_1=",maxval(abs(KG0(1,:))) 
!write(6,*)"maxabs KG0_2=",maxval(abs(KG0(2,:))) 
!write(6,*)"maxabs KG0_3=",maxval(abs(KG0(3,:))) 
!---
!do igL=1,NG 
! write(6,*) igL,KG0(:,igL)
!enddo 
      RETURN 
      END 
!---
      SUBROUTINE OUTER_PRODUCT(vec_x,vec_y,vec_z)
      implicit none 
      real(8)::vec_x(3),vec_y(3),vec_z(3) 
      vec_z(1)=vec_x(2)*vec_y(3)-vec_x(3)*vec_y(2)
      vec_z(2)=vec_x(3)*vec_y(1)-vec_x(1)*vec_y(3) 
      vec_z(3)=vec_x(1)*vec_y(2)-vec_x(2)*vec_y(1)
      RETURN
      END

subroutine est_nkbi(N,SK,nkb1,nkb2,nkb3)  
implicit none 
integer::N,nkb1,nkb2,nkb3,NTK  
real(8)::SK(3,N) 
integer::i 
real(8)::x 
!---
x=1.0d0 
do i=1,N
 if(abs(SK(1,i))<1.0d-7) cycle 
 if(abs(SK(1,i))<x) then 
  x=abs(SK(1,i))  
 endif 
enddo    
nkb1=nint(1.0d0/x)  
!---
x=1.0d0 
do i=1,N
 if(abs(SK(2,i))<1.0d-7) cycle 
 if(abs(SK(2,i))<x) then 
  x=abs(SK(2,i))  
 endif 
enddo    
nkb2=nint(1.0d0/x)  
!---
x=1.0d0 
do i=1,N
 if(abs(SK(3,i))<1.0d-7) cycle 
 if(abs(SK(3,i))<x) then 
  x=abs(SK(3,i))  
 endif 
enddo    
nkb3=nint(1.0d0/x)  
!---
NTK=nkb1*nkb2*nkb3 
!write(6,'(a24,4i10)') 'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
!---
return 
end 
!--
!20180301 
subroutine est_NTK(Nk_irr,Nsymq,SKI,rg,NTK)
implicit none 
integer::Nk_irr,Nsymq,N  
real(8)::SKI(3,Nk_irr) 
integer::rg(3,3,Nsymq) 
real(8),allocatable::SK0(:,:)!SK0(3,N) 
real(8)::ktmp(3)
integer::RWtmp(3)
integer::jk,ik,iop,iik 
integer::NTK 
!---
N=Nk_irr*Nsymq*2
!write(6,*)'N=',N
!--
!SK0,numirr,numrot,trs,RW
allocate(SK0(3,N));SK0(:,:)=0.0d0
!allocate(numirr(NTK));numirr(:)=0
!allocate(numrot(NTK));numrot(:)=0
!allocate(trs(NTK));trs(:)=0
!allocate(RW(3,NTK));RW(:,:)=0
jk=0
do ik=1,Nk_irr
 do iop=1,Nsymq
  ktmp(:)=0.0d0; RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)
  call kcheck(ktmp(1),RWtmp(1))!rewind check 
  do iik=1,jk
   if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and.abs(SK0(2,iik)-ktmp(2))<1.0d-4.and.abs(SK0(3,iik)-ktmp(3))<1.0d-4) goto 1000
  enddo!iik
  jk=jk+1
  SK0(:,jk)=ktmp(:)
  !numirr(jk)=ik;numrot(jk)=iop;trs(jk)=1;RW(:,jk)=RWtmp(:)
1000 ktmp(:)=0.0d0; RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)
  call kcheck_trs(ktmp(1),RWtmp(1))!rewind check modified 20170316  
  do iik=1,jk
   if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and.abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and.abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4) goto 2000
  enddo!iik
  jk=jk+1
  SK0(:,jk)=-ktmp(:) 
  !numirr(jk)=ik;numrot(jk)=iop;trs(jk)=-1;RW(:,jk)=RWtmp(:) 
2000 enddo!iop 
enddo!ik 
!--
NTK=jk 
if(NTK>N)then 
 write(6,*)'Estimated NTK is too large; stop' 
 write(6,*)'NTK, N=',NTK, N 
 stop
endif 
!write(6,*)'Estimated NTK=',NTK 
return
end

! m_bvector.f90 -- a simple generator of b-vectors
!
! Copyright(C) 2017 Terumasa Tadano
!
! This file is distributed under the terms of the MIT license.
! Please see http://opensource.org/licenses/mit-license.php for information.
!
module m_bvector
  implicit none
contains
  !
  subroutine generate_bvectors(b1, b2, b3, nkb1, nkb2, nkb3, &
       nbmax, maxshell, verbosity, &
       nb, bvec_frac, bvec_cart, weight) 
    !
    ! Automatic generation of b-vectors
    !
    real(8), intent(in) :: b1(3), b2(3), b3(3)
    integer, intent(in) :: nkb1, nkb2, nkb3
    integer, intent(in) :: nbmax, maxshell
    integer, intent(in) :: verbosity ! expect 0 or 1
    integer, intent(out) :: nb
    real(8), intent(out) :: bvec_frac(3,nbmax), bvec_cart(3,nbmax)
    real(8), intent(out) :: weight(nbmax)
    ! local variables
    integer :: i, j, k, m, l
    integer :: nk, nbvec
    integer :: nmulti, nshell
    integer :: nbvec_now, nbvec_shell
    integer :: nrank, nmin, shift
    integer, allocatable :: multiplicity(:)
    integer, allocatable :: index_sort(:), index_k(:)
    integer, allocatable :: index_k_shell(:), index_k_tmp(:)
    logical :: is_new, is_fullrank, satisfy_orthogonal, success
    real(8), parameter :: tolerance = 1.0d-8
    real(8) :: kval(3), dist_tmp, sigma_tmp(6), bvec(3)
    real(8), parameter :: sigma_vec(6) = (/1.d0, 0.d0, 0.d0, 1.d0, 0.d0, 1.d0/)
    real(8), allocatable :: xk(:,:), xk_cart(:,:), dist_k(:)
    real(8), allocatable :: bvec_merged(:,:), bvec_shell(:,:)
    real(8), allocatable :: bvec_tmp(:,:), bvec_now(:,:)
    real(8), allocatable :: bbmat(:,:), weight_tmp(:)
    real(8), allocatable :: Umat(:,:), Sval(:), VTmat(:,:), Sinv(:,:)
    !
    if (verbosity > 0) then
       write(6,*) ' '
       write(6,*) '============================================='
       write(6,*) '     Auatomatic generation of b-vectors      '
       write(6,*) '============================================='
       write(6,*) ' '
    endif
    !
    bvec_frac = 0.0d0
    bvec_cart = 0.0d0
    weight = 0.0d0
    nb = 0
    !
    ! Generate gamma-centered mesh points in fractional coordinate 
    ! in the range of [-0.5:0.5)
    !
    nk = nkb1 * nkb2 * nkb3 + 26
    allocate(xk(3, nk))
    m = 0
    do i = 1, nkb1
       kval(1) = dble(i-1) / dble(nkb1)
       if (kval(1) >= 0.5d0) then
          kval(1) = kval(1) - 1.0d0
       endif
       do j = 1, nkb2
          kval(2) = dble(j-1) / dble(nkb2)
          if (kval(2) >= 0.5d0) then
             kval(2) = kval(2) - 1.0d0
          endif
          do k = 1, nkb3
             kval(3) = dble(k-1) / dble(nkb3)
             if (kval(3) >= 0.5d0) then
                kval(3) = kval(3) - 1.0d0
             endif
             m = m + 1
             xk(1:3, m) = kval(1:3)
          enddo
       enddo
    enddo
    !
    ! Also add nearest G-vectors in each direction
    !
    do i = -1, 1
       do j = -1, 1
          do k = -1, 1
             if (i == 0 .and. j == 0 .and. k == 0) then 
                cycle
             endif
             m = m + 1
             xk(1:3, m) = (/dble(i), dble(j), dble(k)/) 
          enddo
       enddo
    enddo
    !
    ! Convert mesh points in Cartesian coordinate and
    ! calculate distance from gamma point
    !
    allocate(xk_cart(3, nk), dist_k(nk))
    allocate(index_sort(nk))
    do i = 1, nk
       xk_cart(:,i) = xk(1,i)*b1(:) + xk(2,i)*b2(:) + xk(3,i)*b3(:)
       dist_k(i) = sqrt(dot_product(xk_cart(:,i), xk_cart(:,i)))
       index_sort(i) = i
    enddo
    !
    ! Sort distance in ascending order (dist_k(1) <= dist_k(2) <= ...)
    ! 
    call quicksort_double_arg(nk, dist_k, index_sort, 1, nk)
    !
    ! Construct information about nearest-neighbor shells.
    ! multiplicity(i) represents the number k points in the (i-1)th shelll.
    !
    allocate(multiplicity(maxshell+1))
    nmulti = 0
    dist_tmp = 0.0d0
    multiplicity = 0
    m = 1 
    do i = 1, nk
       if (abs(dist_k(i) - dist_tmp) < tolerance) then
          nmulti = nmulti + 1
       else
          dist_tmp = dist_k(i)
          multiplicity(m) = nmulti
          ! Reset value for the next shell
          nmulti = 1
          m = m + 1
          if (m > maxshell + 1) then
             exit
          endif
       endif
    enddo
    !
    nshell = 0
    do i = 1, maxshell + 1
       if (multiplicity(i) > 0) then
          nshell = nshell + 1
       endif
    enddo
    !
    if (verbosity > 0) then
       write(6,*) "  Shell        Distance        Multiplicity"
       write(6,*) " -------      ----------       ------------"
       m = 1
       do i = 1, nshell
          dist_tmp = dist_k(m)
          ! skip 0th shell (distance = 0.0)
          if (dist_tmp > tolerance) then
             write(6,'(i5,F20.8,i18)') i - 1, dist_tmp, multiplicity(i) 
          endif
          m = m + multiplicity(i)
       enddo
       write(6,*)
    endif
    deallocate(dist_k)
    !
    ! index_k: contains k point index of b-vectors 
    ! bvec_now: contains Cartesian coordinates of b-vectors
    !
    allocate(index_k(nk))
    allocate(bvec_now(3,nk))
    nbvec_now = 0
    index_k = 0
    bvec_now = 0.0d0
    !
    ! Main loop over the shell index
    !
    do i = 2, nshell 
       !
       nmulti = multiplicity(i)
       !
       allocate(bvec_shell(3, nmulti)) 
       allocate(bvec_tmp(3, nmulti))
       allocate(index_k_shell(nmulti))
       allocate(index_k_tmp(nmulti))
       bvec_shell = 0.0d0
       index_k_shell = 0
       !
       shift = sum(multiplicity(1:i-1))
       index_k_tmp(:) = index_sort(shift+1:shift+nmulti)
       bvec_tmp(:,1:nmulti) = xk_cart(:,index_k_tmp(1:nmulti))
       !
       ! Search unique set of b-vectors in this shell and
       ! save them in bvec_shell.
       !
       m = 0
       do j = 1, nmulti
          !
          is_new = .true.
          !
          bvec(:) = -bvec_tmp(:,j)
          do k = 1, m
             if (sqrt(dot_product(bvec_shell(:,k)-bvec(:), &
                  bvec_shell(:,k)-bvec(:))) < tolerance) then
                is_new = .false.
                exit
             endif
          enddo
          !
          if (is_new) then
             m = m + 1
             bvec_shell(:,m) = bvec_tmp(:,j)
             index_k_shell(m) = index_k_tmp(j)
          endif
       enddo
       nbvec_shell = m
       nbvec = nbvec_now + nbvec_shell
       deallocate(index_k_tmp, bvec_tmp)
       !
       ! Merge b-vectors for making the b*b matrix
       !
       allocate(bvec_merged(3, nbvec))
       bvec_merged = 0.0d0
       bvec_merged(:,1:nbvec_now) = bvec_now(:,1:nbvec_now)
       bvec_merged(:,nbvec_now+1:nbvec) = bvec_shell(:,1:nbvec_shell)
       !
       if (verbosity > 0) then
          write(6,*)
          write(6,*) " ------------------------------------------------ "
          write(6,'(2x,a,i4)') " New shell index : ", i - 1
          write(6,*)
          write(6,'(2x,a,i4)') " Number of candidate b-vectors : ", nbvec
          write(6,*) "  List of b-vectors (Cartesian) :"
          do j = 1, nbvec
             write(6,'(3F15.8)') bvec_merged(:,j) 
          enddo
       endif
       !
       ! Generate b*b matrix
       !
       allocate(bbmat(6, nbvec))
       allocate(weight_tmp(nbvec))
       !
       m = 0
       do j = 1, 3
          do k = j, 3
             m = m + 1
             do l = 1, nbvec
                bbmat(m, l) = bvec_merged(j,l) * bvec_merged(k,l)
             enddo
          enddo
       enddo
       !
       nmin = min(6, nbvec)
       allocate(Sval(nmin), Umat(6, 6), VTmat(nbvec, nbvec))
       !
       call SVD(6, nbvec, nmin, bbmat, nrank, Sval, Umat, VTmat)
       !
       is_fullrank = (nrank == nmin)
       !
       if (is_fullrank) then
          !
          ! Accept the current shell and update bvec_now and index_k.
          !
          bvec_now(:,nbvec_now+1:nbvec) = bvec_shell(:,1:nbvec_shell)
          index_k(nbvec_now+1:nbvec) = index_k_shell(1:nbvec_shell)
          nbvec_now = nbvec
          !
          allocate(Sinv(6, nbvec))
          Sinv = 0.0d0
          do j = 1, nmin
             Sinv(j,j) = 1.0d0 / Sval(j)
          enddo
          !
          weight_tmp = matmul(transpose(matmul(matmul(Umat, Sinv), VTmat)), sigma_vec)
          !
          deallocate(Sinv) 
          !
          if (verbosity > 0) then
             write(6,*)
             write(6,*) "  Matrix is full-rank. This shell is"
             write(6,*) "  linearly independent on the existing shells."
             write(*,*) "  Weights of each b-vectors below:"
             do j = 1, nbvec
                write(6,'(3x, F15.8)') weight_tmp(j)*0.5d0
             enddo
          endif
          ! 
          ! Check if the b-vectors satisfy the orthogonality relation
          !
          m = 0
          do j = 1, 3
             do k = j, 3
                m = m + 1
                sigma_tmp(m) = 0.0d0
                do l = 1, nbvec
                   sigma_tmp(m) = sigma_tmp(m) &
                        + weight_tmp(l)*bvec_merged(j,l)*bvec_merged(k,l)
                enddo
             enddo
          enddo
          !
          sigma_tmp = sigma_tmp - sigma_vec
          if (sqrt(dot_product(sigma_tmp,sigma_tmp)) < tolerance) then
             satisfy_orthogonal = .true.
          else
             satisfy_orthogonal = .false.
          endif
       else
          if (verbosity > 0) then
             write(6,*)
             write(6,*) "  Matrix is rank-deficient. This shell is"
             write(6,*) "  linearly dependent on the existing shells."
             write(6,*) "  Skipping this shell..."
          endif
       endif
       !
       deallocate(Sval, Umat, VTmat)
       deallocate(bbmat)
       deallocate(bvec_shell,bvec_merged)
       deallocate(index_k_shell)
       !  
       success = .false.
       if (is_fullrank) then
          if (satisfy_orthogonal) then
             !
             success = .true.
             !
             if (verbosity > 0) then
                write(6,*)
                write(6,*) "  Weighted orthogonality is satisfied."
             endif
             !
             ! Store data in the return arrays
             !
             nb = 2 * nbvec
             do j = 1, nbvec
                bvec_frac(:, 2*(j-1) + 1) =  xk(:, index_k(j))
                bvec_frac(:, 2*j        ) = -xk(:, index_k(j))
                bvec_cart(:, 2*(j-1) + 1) =  xk_cart(:, index_k(j))
                bvec_cart(:, 2*j        ) = -xk_cart(:, index_k(j))
                weight(2*(j-1) + 1) = weight_tmp(j)*0.5d0
                weight(2*j        ) = weight_tmp(j)*0.5d0
             enddo
          else
             if (verbosity > 0) then
                write(6,*)
                write(6,*) "  Weighted orthogonality is NOT satisfied."
             endif
          endif
       endif
       !
       deallocate(weight_tmp)
       !
       if (success) exit
    enddo
    !
    deallocate(xk, xk_cart, index_k, bvec_now)
    !
    if (success) then
       if (verbosity > 0) then
          write(6,*)
          write(6,*) " b-vectors are created successfully."
          write(6,*) ' '
          write(6,*) '============================================='
          write(6,*) '        Finish automatic generation          '
          write(6,*) '============================================='
          write(6,*) ' '
       endif
    else
       stop ' Could not find b-vectors'
    endif
    !
    return
  end subroutine generate_bvectors
  !
  !
  subroutine SVD(m, n, k, A, nrank, S, U, VT)
    !
    ! Singular value decomposition of matrix A.
    ! 
    implicit none
    integer, intent(in) :: m, n, k
    real(8), intent(in) :: A(m, n)
    integer, intent(out) :: nrank
    real(8), intent(out) :: S(k), U(m, m), VT(n, n)
    ! local variable
    integer :: i
    integer :: lwork, info
    real(8), allocatable :: work(:)
    real(8), allocatable :: Acopy(:,:)
    !
    lwork = max(3*k+max(m,n), 5*k) 
    lwork = 2 * lwork
    !
    allocate(Acopy(m, n), work(lwork))
    Acopy = A
    !
    call dgesvd('A', 'A', m, n, Acopy, m, S, U, m, &
         VT, n, work, lwork, info)
    !
    nrank = 0
    do i = 1, k
       if (S(1) > 1.0d-12) then
          if (S(i) > S(1)*1.0d-8) then
             nrank = nrank + 1
          endif
       endif
    enddo
    !
    deallocate(Acopy, work)
    !
    return
  end subroutine SVD
  ! 
  recursive subroutine quicksort_double_arg(n, array, ind, first, last)
    !
    ! Quick sort with index (similar to argsort in python)
    !
    implicit none
    integer, intent(in) :: n, first, last
    integer, intent(inout) :: ind(n)
    real(8), intent(inout) :: array(n)
    integer :: i, j, ind_tmp
    real(8) :: tmp, pivot
    pivot= array((first+last)/2)
    i= first
    j= last
    do
       do while (array(i) < pivot)
          i = i + 1
       end do
       do while (pivot < array(j))
          j = j - 1
       end do
       if (i >= j) exit
       ! 
       tmp = array(i)
       array(i) = array(j)
       array(j) = tmp
       ind_tmp = ind(i)
       ind(i) = ind(j)
       ind(j) = ind_tmp
       ! 
       i= i + 1
       j= j - 1
    end do
    if (first < i - 1) call quicksort_double_arg(n, array, ind, first, i - 1)
    if (j + 1 < last)  call quicksort_double_arg(n, array, ind, j + 1, last)
  end subroutine quicksort_double_arg
  !
end module m_bvector

subroutine calcdet(N,mat,det) 
implicit none
complex(8)::det
integer,intent(in)::N 
complex(8),intent(inout)::mat(N,N) 
integer::ipiv(N)
integer::i,info 
!---
ipiv=0
info=0 
call zgetrf(N,N,mat,N,ipiv,info)
if(info/=0) then 
 write(6,*) 'info=',info 
endif 
det=1.0d0 
do i=1,N!-1
 if(ipiv(i)==i) then
  det=det*mat(i,i)
 else 
  det=-det*mat(i,i)
 endif  
enddo
return 
end

subroutine makekpts(Ndiv,Nblk,NSK_BAND_DISP,SKI,SK)  
implicit none 
integer::Nblk,Ndiv,NSK_BAND_DISP 
real(8)::SKI(3,Nblk) 
real(8)::SK(3,NSK_BAND_DISP)
integer::i,k  
do k=1,Nblk-1 
do i=1,Ndiv 
 SK(:,i+Ndiv*(k-1))& 
=SKI(:,k)+(SKI(:,k+1)-SKI(:,k))/dble(Ndiv)*dble(i-1)  
enddo 
enddo  
SK(:,Ndiv*(Nblk-1)+1)=SKI(:,Nblk) 
!write(6,*) NSK_BAND_DISP
!do i=1,Ndiv*(Nblk-1)+1
!write(6,*) SK(:,i)
!enddo 
return 
end 

      SUBROUTINE CALC_GRADIENT(NTK,NTB,n_occ,NB,WF_CHARGE,WEIGHT_b,
     + OVERLAP,tci,GRADIENT,TR_GRAD)                  
      implicit none           
      integer::NTK,NTB,n_occ,NB         
      integer::ik,ibvec,i_band,j_band
      real(8)::WF_CHARGE(n_occ,NTK,NB),WEIGHT_b(NB)                 
      real(8)::TR_GRAD(NTK)              
      real(8)::SUM_REAL                 
      complex(8)::OVERLAP(NTB,NTB,NTK,NB)         
      complex(8)::GRADIENT(n_occ,n_occ,NTK)              
      complex(8)::WF_R(n_occ,n_occ,NB)         
      complex(8)::WF_T(n_occ,n_occ,NB)         
      complex(8)::SUM_CMPX,tci       
!--
      GRADIENT(:,:,:)=0.0D0        
      Do ik=1,NTK        
       Do i_band=1,n_occ       
        Do j_band=1,n_occ       
         Do ibvec=1,NB           
          WF_R(i_band,j_band,ibvec)          
     +   =OVERLAP(i_band,j_band,ik,ibvec)
     +   *CONJG(OVERLAP(j_band,j_band,ik,ibvec)) !modified 2007 6 26 
          WF_T(i_band,j_band,ibvec)          
     +   =OVERLAP(i_band,j_band,ik,ibvec)
     +   /OVERLAP(j_band,j_band,ik,ibvec) !modified 2007 6 26 
     +   *WF_CHARGE(j_band,ik,ibvec) !modified 2007 6 26 
         ENDDO !ibvec            
        ENDDO !j_band           
       ENDDO !i_band           
       Do i_band=1,n_occ       
        Do j_band=1,n_occ       
         SUM_CMPX=0.0D0 
         Do ibvec=1,NB           
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +4.0D0 
     +   *WEIGHT_b(ibvec) 
     +   *(((WF_R(i_band,j_band,ibvec)          
     +    -CONJG(WF_R(j_band,i_band,ibvec)))/2.0D0)            
     +    -((WF_T(i_band,j_band,ibvec)          
     +    +CONJG(WF_T(j_band,i_band,ibvec)))/tci))           
         ENDDO !ibvec            
         GRADIENT(i_band,j_band,ik)=SUM_CMPX/CMPLX(NTK) 
        ENDDO !j_band           
       ENDDO !i_band           
      ENDDO !ik       
!-- block diagonal constraint --
!      G(:,:,:)=GRADIENT(:,:,:) 
!      GRADIENT=0.0d0 
!      GRADIENT(1:2,1:2,:)=G(1:2,1:2,:) 
!      GRADIENT(3:4,3:4,:)=G(3:4,3:4,:) 
!      GRADIENT(5:6,5:6,:)=G(5:6,5:6,:) 
!-- Tr(G^2) --                 
      TR_GRAD(:)=0.0D0      
      SUM_REAL=0.0D0                          
      Do ik=1,NTK    
       SUM_CMPX=0.0D0        
       Do i_band=1,n_occ 
        Do j_band=1,n_occ 
         SUM_CMPX 
     +  =SUM_CMPX 
     +  +GRADIENT(i_band,j_band,ik)     
     +  *GRADIENT(j_band,i_band,ik)     
        ENDDO!j_band   
       ENDDO!i_band   
       TR_GRAD(ik)=DBLE(SUM_CMPX)          
       SUM_REAL=SUM_REAL+TR_GRAD(ik)          
      ENDDO !ik         
      write(6,*) 'Tr(G^2)=',SUM_REAL          
      RETURN
      END                
!--
      SUBROUTINE CALC_OMEGA(NTK,NTB,n_occ,NB,VEC_b,ILS,       
     + WEIGHT_b,OVERLAP,WF_CHARGE,OMEGA_I,OMEGA_OD,OMEGA_D)        
      implicit none 
      integer::NTK,NTB,n_occ,NB,ILS                 
      integer::ik,ibvec,i_band,j_band
      real(8)::VEC_b(3,NB),WEIGHT_b(NB)                 
      real(8)::WF_CHARGE(n_occ,NTK,NB)          
      real(8)::OMEGA_I,OMEGA_OD,OMEGA_D                      
      real(8)::WF_POSITION(3,n_occ)         
      real(8)::VEC_SUM_REAL(3),SUM_REAL,SUM_REAL1,SUM_REAL2 
      complex(8)::LOG_OVERLAP      
      complex(8)::OVERLAP(NTB,NTB,NTK,NB)         

!(1) WANNIER POSITION

      WF_POSITION(:,:) = 0.0D0            
      Do i_band = 1 , n_occ       
      VEC_SUM_REAL(:) = 0.0D0          
      Do ik     = 1 , NTK        
      Do ibvec  = 1 , NB           
       LOG_OVERLAP=LOG(OVERLAP(i_band,i_band,ik,ibvec)) 
         VEC_SUM_REAL(:) 
     + = VEC_SUM_REAL(:) 
     + + WEIGHT_b(ibvec) 
     + * VEC_b (:,ibvec) 
     + * AIMAG( LOG_OVERLAP ) 
      ENDDO!ibvec            
      ENDDO!ik       
      WF_POSITION(:,i_band)=-VEC_SUM_REAL(:)/DBLE(NTK)   
      ENDDO!i_band           

!(2) WANNIER CHARGE

      WF_CHARGE(:,:,:) = 0.0D0            
      Do ik     = 1 , NTK        
      Do ibvec  = 1 , NB           
      Do i_band = 1 , n_occ       
       SUM_REAL = VEC_b(1,ibvec)*WF_POSITION(1,i_band)         
     +          + VEC_b(2,ibvec)*WF_POSITION(2,i_band)         
     +          + VEC_b(3,ibvec)*WF_POSITION(3,i_band)         
       LOG_OVERLAP = LOG ( OVERLAP(i_band,i_band,ik,ibvec) ) 
         WF_CHARGE(i_band,ik,ibvec) 
     + = AIMAG( LOG_OVERLAP )
     + + SUM_REAL       
      ENDDO!i_band           
      ENDDO!ibvec            
      ENDDO!ik       

!(3-a) OMEGA_I 

      SUM_REAL1 = 0.0D0            
      Do ik     = 1 , NTK        
      Do ibvec  = 1 , NB           
      SUM_REAL2 = 0.0D0          
      Do i_band = 1 , n_occ       
      Do j_band = 1 , n_occ       
         SUM_REAL2 
     + = SUM_REAL2 
     + + ( ABS( OVERLAP(i_band,j_band,ik,ibvec) ) )**2     
      ENDDO!j_band           
      ENDDO!i_band           
         SUM_REAL1 
     + = SUM_REAL1 
     + + WEIGHT_b(ibvec) 
     + * ( DBLE(n_occ) - SUM_REAL2 )       
      ENDDO!ibvec            
      ENDDO!ik       
      OMEGA_I = SUM_REAL1 / DBLE(NTK)        

!(3-b) OMEGA_OD 

      SUM_REAL1 = 0.0D0            
      Do ik     = 1 , NTK        
      Do ibvec  = 1 , NB           
      SUM_REAL2 = 0.0D0          
      Do i_band = 1 , n_occ       
      Do j_band = 1 , n_occ       
      IF(i_band /= j_band) THEN          
         SUM_REAL2 
     + = SUM_REAL2 
     + + ( ABS( OVERLAP(i_band,j_band,ik,ibvec) ) )**2     
      ENDIF            
      ENDDO!j_band           
      ENDDO!i_band           
         SUM_REAL1 
     + = SUM_REAL1 
     + + WEIGHT_b(ibvec) 
     + * SUM_REAL2                  
      ENDDO!ibvec            
      ENDDO!ik       
      OMEGA_OD = SUM_REAL1 / DBLE(NTK)        

!(3-c) OMEGA_D 

      SUM_REAL1 = 0.0D0            
      Do ik     = 1 , NTK        
      Do ibvec  = 1 , NB           
      SUM_REAL2 = 0.0D0          
      Do i_band = 1 , n_occ       
         SUM_REAL2 
     + = SUM_REAL2 
     + + ( WF_CHARGE(i_band,ik,ibvec) )**2     
      ENDDO!i_band           
         SUM_REAL1 
     + = SUM_REAL1 
     + + WEIGHT_b(ibvec) 
     + * SUM_REAL2                  
      ENDDO!ibvec            
      ENDDO!ik       
      OMEGA_D = SUM_REAL1 / DBLE(NTK)        

!(4) OMEGA_I,OD AND OMEGA_D OF EACH BAND 

      IF(ILS == 1) THEN 
       Do i_band = 1 , n_occ       
        SUM_REAL1 = 0.0D0            
        SUM_REAL2 = 0.0D0            
        Do ik     = 1 , NTK        
         Do ibvec  = 1 , NB           
          SUM_REAL1 
     +   =SUM_REAL1 
     +   +WEIGHT_b(ibvec) 
     +   *(1.0D0-(ABS(OVERLAP(i_band,i_band,ik,ibvec)))**2)       
          SUM_REAL2 
     +   =SUM_REAL2 
     +   +WEIGHT_b(ibvec)                  
     +   *(WF_CHARGE(i_band,ik,ibvec))**2     
         ENDDO!ibvec            
        ENDDO!ik       
        SUM_REAL1=SUM_REAL1/DBLE(NTK) 
        SUM_REAL2=SUM_REAL2/DBLE(NTK) 
        write(6,*) i_band,SUM_REAL1,SUM_REAL2 
       ENDDO!i_band           
      ENDIF               
!--
      RETURN
      END
!--
      SUBROUTINE UNITARY_GEN(NTK,n_occ,ILS, 
     + DIRECTION,DIRECTION2,STEP_LENGTH,UNITARY,U_ORG,U_OLD)          
      implicit none           
      integer::NTK,n_occ,ILS          
      integer::ik,i_band,j_band,k_band   
      real(8)::STEP_LENGTH         
      real(8)::D_EIG(n_occ),D_INV(n_occ),D_COS(n_occ),D_SIN(n_occ) 
      complex(8),INTENT(IN)::DIRECTION (n_occ,n_occ,NTK)              
      complex(8),INTENT(IN)::DIRECTION2(n_occ,n_occ,NTK)              
      complex(8)::UNITARY(n_occ,n_occ,NTK)              
      complex(8)::U_ORG(n_occ,n_occ,NTK)              
      complex(8)::U_OLD(n_occ,n_occ,NTK)              
      complex(8)::D_MAT(n_occ,n_occ) 
      complex(8)::R_MAT(n_occ,n_occ) 
      complex(8)::RC_MAT(n_occ,n_occ) 
      complex(8)::RS_MAT(n_occ,n_occ) 
      complex(8)::G_MAT(n_occ,n_occ) 
      complex(8)::SUM_CMPX

      UNITARY(:,:,:)=0.0D0 
      IF(ILS==1) THEN 
       Do ik=1,NTK           
!STEP(1) diag D_MAT
        D_MAT(:,:)=DIRECTION2(:,:,ik)              
        D_EIG(:)=0.0D0                
        call diagV(n_occ,D_MAT(1,1),D_EIG(1)) 
        R_MAT(:,:)=D_MAT(:,:)

!STEP(2) CONSTRUCT DIAGONAL MATRICES
        D_INV(:)=0.0D0           
        D_COS(:)=0.0D0 
        D_SIN(:)=0.0D0   
        Do i_band=1,n_occ         
         IF(D_EIG(i_band)==0.0D0) THEN 
          D_EIG(i_band)=1.0D-20 
         ENDIF          
         D_EIG(i_band)=DSQRT(ABS(D_EIG(i_band)))          
         D_INV(i_band)=1.0D0/D_EIG(i_band)        
         D_COS(i_band)=DCOS(D_EIG(i_band)*STEP_LENGTH)       
         D_SIN(i_band)=DSIN(D_EIG(i_band)*STEP_LENGTH)       
        ENDDO 

!STEP(3) CONSTRUCT RC & RS MATRIX 
        RC_MAT(:,:)=0.0D0    
        RS_MAT(:,:)=0.0D0    
        Do i_band=1,n_occ   
         Do j_band=1,n_occ   
           RC_MAT(i_band,j_band) 
     +    =R_MAT(i_band,j_band) 
     +    *D_COS(j_band)       
           RS_MAT(i_band,j_band) 
     +    =R_MAT(i_band,j_band) 
     +    *D_SIN(j_band) 
     +    *D_INV(j_band)           
         ENDDO 
        ENDDO 

!STEP(4) CONSTRUCT RC MATRIX 
        G_MAT(:,:)=DIRECTION(:,:,ik)         
        Do i_band=1,n_occ   
         Do j_band=1,n_occ   
          SUM_CMPX=0.0D0            
          Do k_band=1,n_occ       
           SUM_CMPX 
     +    =SUM_CMPX 
     +    +G_MAT(i_band,k_band) 
     +    *RS_MAT(k_band,j_band)     
          ENDDO 
          RC_MAT(i_band,j_band) 
     +   =RC_MAT(i_band,j_band)+SUM_CMPX        
         ENDDO 
        ENDDO 

!STEP(5) CONSTRUCT U MATRIX 
        Do i_band=1,n_occ   
         Do j_band=1,n_occ   
          SUM_CMPX=0.0D0            
          Do k_band=1,n_occ       
           SUM_CMPX 
     +    =SUM_CMPX 
     +    +RC_MAT(i_band,k_band) 
     +    *CONJG(R_MAT(j_band,k_band))        
          ENDDO 
          UNITARY(i_band,j_band,ik)=SUM_CMPX        
         ENDDO 
        ENDDO 
       ENDDO!ik === UNITARY MATRIX GENERATION ROOP ===     
       U_ORG(:,:,:)=UNITARY(:,:,:)
       U_OLD(:,:,:)=UNITARY(:,:,:)
      ELSE 
       Do ik=1,NTK 
        DO i_band=1,n_occ 
         DO j_band=1,n_occ 
          SUM_CMPX=0.0D0            
          Do k_band=1,n_occ       
           SUM_CMPX 
     +    =SUM_CMPX 
     +    +U_OLD(i_band,k_band,ik) 
     +    *U_ORG(k_band,j_band,ik)  
          ENDDO 
          UNITARY(i_band,j_band,ik)=SUM_CMPX        
         ENDDO!j_band 
        ENDDO!i_band 
       ENDDO!ik 
       U_OLD(:,:,:)=UNITARY(:,:,:)
      ENDIF
      RETURN
      END        
!--
      SUBROUTINE UPDATE_OVERLAP(NTK,NTB,n_occ,NB,KPT,UNITARY,OVERLAP)  
      implicit none           
      integer::NTK,NTB,n_occ,NB
      integer::KPT(NTK,NB)         
      integer::ik,ik_ib,ibvec,i_band,j_band,k_band   
      complex(8)::UNITARY(n_occ,n_occ,NTK)              
      complex(8)::OVERLAP(NTB,NTB,NTK,NB)         
      complex(8)::U_MAT(n_occ,n_occ) 
      complex(8)::SUM_CMPX

      Do ik=1,NTK 
       Do ibvec=1,NB      
        ik_ib=KPT(ik,ibvec)        
        Do i_band=1,n_occ          
         Do j_band=1,n_occ          
          SUM_CMPX=0.0D0          
          Do k_band=1,n_occ 
           SUM_CMPX 
     +    =SUM_CMPX 
     +    +OVERLAP(i_band,k_band,ik,ibvec)
     +    *UNITARY(k_band,j_band,ik_ib)
          ENDDO 
          U_MAT(i_band,j_band)=SUM_CMPX         
         ENDDO 
        ENDDO 
        Do i_band=1,n_occ          
         Do j_band=1,n_occ          
          SUM_CMPX=0.0D0          
          Do k_band=1,n_occ 
           SUM_CMPX 
     +    =SUM_CMPX 
     +    +CONJG(UNITARY(k_band,i_band,ik))        
     +    *U_MAT(k_band,j_band)
          ENDDO 
          OVERLAP(i_band,j_band,ik,ibvec)=SUM_CMPX         
         ENDDO 
        ENDDO 
       ENDDO !ibvec                   
      ENDDO !ik          
      RETURN
      END
!---
      SUBROUTINE A_MAT_UPDATE(NTK,NTB,NGAUSS,n_occ,UNITARY,A_MAT)   
      implicit none           
      integer::NTK,NTB,NGAUSS,n_occ
      integer::ik,i_band,j_band,k_band   
      complex(8)::UNITARY(n_occ,n_occ,NTK)              
      complex(8)::A_MAT(NTB,NGAUSS,NTK)           
      complex(8)::A_TMP(NTB,NGAUSS)        
      complex(8)::SUM_CMPX

      Do ik=1,NTK        
       A_TMP(:,:)=0.0D0             
       A_TMP(:,:)=A_MAT(:,:,ik)            
       Do i_band=1,n_occ       
        Do j_band=1,n_occ       
         SUM_CMPX=0.0D0 
         Do k_band=1,n_occ           
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +A_TMP(i_band,k_band) 
     +   *UNITARY(k_band,j_band,ik)        
         ENDDO              
         A_MAT(i_band,j_band,ik)=SUM_CMPX     
        ENDDO !j_band
       ENDDO !i_band
      ENDDO !ik          
      RETURN
      END    
!---
      SUBROUTINE CALC_OVERLAP(NTK,NTB,NTG,nvx,nvy,nvz,ik,ik_ib,NG0,
     + KG0,N_BAND,SHIFT_b,C0_BRA,C0_KET,OVERLAP_TMP,N_BAND_BOTTOM)
      implicit none           
      integer::NTK,NTB,NTG,nvx,nvy,nvz       
      integer::NG0(NTK),KG0(3,NTG,NTK),N_BAND(NTK)         
      integer::SHIFT_b(3),N_BAND_BOTTOM(NTK)         
      integer::PULLBACK(NTG)           
      integer::MAP(-nvx:nvx,-nvy:nvy,-nvz:nvz)
      integer::ik,ik_ib,ig,ig1,ig2,i_band,j_band
      complex(8)::C0_BRA(0:NTG,NTB)    
      complex(8)::C0_KET(0:NTG,NTB)    
      complex(8)::OVERLAP_TMP(NTB,NTB)            
      complex(8)::ELEMENT_OVERLAP
!MAP FUNCTION
      MAP(:,:,:)=0
      do ig=1,NG0(ik) 
       MAP(KG0(1,ig,ik)+SHIFT_b(1),
     +     KG0(2,ig,ik)+SHIFT_b(2),
     +     KG0(3,ig,ik)+SHIFT_b(3))=ig                  
      enddo       
!PULLBACK 
      PULLBACK(:)=0
      do ig=1,NG0(ik_ib) 
         PULLBACK(ig) 
     + = MAP(KG0(1,ig,ik_ib) 
     +      ,KG0(2,ig,ik_ib) 
     +      ,KG0(3,ig,ik_ib))     
      enddo       
!INTERSTATE MATRIX 
      OVERLAP_TMP(:,:)=0.0D0         
      do i_band=1,N_BAND(ik)        
       do j_band=1,N_BAND(ik_ib)       
        ELEMENT_OVERLAP=0.0D0 
        do ig2=1,NG0(ik_ib)     
         ig1=PULLBACK(ig2)   
          ELEMENT_OVERLAP 
     +  = ELEMENT_OVERLAP 
     +  + CONJG(C0_BRA(ig1,i_band+N_BAND_BOTTOM(ik)))
     +  *       C0_KET(ig2,j_band+N_BAND_BOTTOM(ik_ib))
        enddo!IG2 
        OVERLAP_TMP(i_band,j_band)=ELEMENT_OVERLAP      
       enddo!j_band     
      enddo!i_band     
      RETURN 
      END              
!--
      subroutine kcheck(ktmp,RWtmp) 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      real(8),parameter::dlt_BZ=1.0d-6 
!--
!      write(6,'(a8,3f15.10)') 'before',ktmp(1),ktmp(2),ktmp(3)
!--
      if(ktmp(1)>1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-2.0d0;RWtmp(1)=-2
      endif 
      if(ktmp(1)>0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<=-1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+2.0d0;RWtmp(1)=2 
      endif 
      if(ktmp(1)<=-0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
!--
      if(ktmp(2)>1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-2.0d0;RWtmp(2)=-2 
      endif 
      if(ktmp(2)>0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<=-1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+2.0d0;RWtmp(2)=2 
      endif 
      if(ktmp(2)<=-0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
!--
      if(ktmp(3)>1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-2.0d0;RWtmp(3)=-2 
      endif 
      if(ktmp(3)>0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<=-1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+2.0d0;RWtmp(3)=2 
      endif 
      if(ktmp(3)<=-0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
!--
!      write(6,'(a8,3f15.10)') 'after',ktmp(1),ktmp(2),ktmp(3)
!--
      return
      end 
!--
!20170316 
      subroutine kcheck_trs(ktmp,RWtmp) 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      real(8),parameter::dlt_BZ=-1.0d-6 
!--
!      write(6,'(a8,3f15.10)') 'before',ktmp(1),ktmp(2),ktmp(3)
!--
      if(ktmp(1)>=1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-2.0d0;RWtmp(1)=-2
      endif 
      if(ktmp(1)>=0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<-1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+2.0d0;RWtmp(1)=2 
      endif 
      if(ktmp(1)<-0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
!--
      if(ktmp(2)>=1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-2.0d0;RWtmp(2)=-2 
      endif 
      if(ktmp(2)>=0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<-1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+2.0d0;RWtmp(2)=2 
      endif 
      if(ktmp(2)<-0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
!--
      if(ktmp(3)>=1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-2.0d0;RWtmp(3)=-2 
      endif 
      if(ktmp(3)>=0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<-1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+2.0d0;RWtmp(3)=2 
      endif 
      if(ktmp(3)<-0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
!--
!      write(6,'(a8,3f15.10)') 'after',ktmp(1),ktmp(2),ktmp(3)
!--
      return
      end 
!--
      subroutine kcheck_old(ktmp,RWtmp) 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      if(ktmp(1)>=0.5d0)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<-0.5d0)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
      if(ktmp(2)>=0.5d0)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<-0.5d0)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
      if(ktmp(3)>=0.5d0)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<-0.5d0)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
      return
      end 
!---
      subroutine make_KG0(NTG,b1,b2,b3,Gcut,q1,q2,q3,KG0,NG) 
      implicit none 
      integer,intent(in)::NTG
      real(8),intent(in)::b1(3),b2(3),b3(3) 
      real(8),intent(in)::Gcut,q1,q2,q3        
      integer,intent(out)::KG0(3,NTG),NG 
      integer::igL,igL1,igL2,igL3
      real(8)::qgL(3),qgL2  
      integer,parameter::NGL1=150!100!300
      integer,parameter::NGL2=150!100!300 
      integer,parameter::NGL3=150!100!300

      igL=0
      do igL1=-NGL1,NGL1 
      do igL2=-NGL2,NGL2 
      do igL3=-NGL3,NGL3 
      qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)
     +      +(q3+dble(igL3))*b3(:)    
      qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
      if(qgL2<=Gcut) then 
       igL=igL+1 
       KG0(1,igL)=igL1
       KG0(2,igL)=igL2
       KG0(3,igL)=igL3 
      endif  
      enddo 
      enddo 
      enddo 
      NG=igL 
!--
!write(6,*) "maxabs KG0_1=",maxval(abs(KG0(1,:))) 
!write(6,*) "maxabs KG0_2=",maxval(abs(KG0(2,:))) 
!write(6,*) "maxabs KG0_3=",maxval(abs(KG0(3,:))) 
!--
!      do ig=1,NG 
!       write(6,'(4i8)') ig,KG0(:,ig)
!      enddo 
!--
      RETURN 
      END 
!--
      subroutine make_C0(NTG,NTB,itrs,NG,KGtmp,RWtmp,rginvtmp,pgtmp,
     +           nnp,L1,L2,L3,packtmp,C0irr,C0_K) 
      implicit none 

      integer::NTG,NTB,itrs,NG,L1,L2,L3,nnp 
      integer::KGtmp(3,NTG),RWtmp(3),pgtmp(3) 
      integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
      integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3 
      real(8)::rginvtmp(3,3),phase 
      complex(8)::C0irr(NTG,NTB),C0_K(NTG,NTB) 
      complex(8)::pf
      real(8),parameter::pi=dacos(-1.0d0)
      real(8),parameter::tpi=2.0d0*pi 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      C0_K(:,:)=0.0d0 
      select case(itrs) 
      case(1)!=== not time-reversal ===*      
      do ig=1,NG 
       i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
       i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
       i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +   +int(rginvtmp(1,3))*k2 
       j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +   +int(rginvtmp(2,3))*k2 
       k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +   +int(rginvtmp(3,3))*k2 
       jg=packtmp(i3,j3,k3) 
       phase=tpi*(dble(i1)*dble(pgtmp(1))
     +           +dble(j1)*dble(pgtmp(2))
     +           +dble(k1)*dble(pgtmp(3))) 
       pf=exp(-ci*phase/dble(nnp)) 
       C0_K(ig,:)=C0irr(jg,:)*pf 
      enddo!ig 
      case(-1)!=== time-reversal ===*      
      do ig=1,NG 
       i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
       i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
       i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +   +int(rginvtmp(1,3))*k2 
       j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +   +int(rginvtmp(2,3))*k2 
       k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +   +int(rginvtmp(3,3))*k2 
       jg=packtmp(i3,j3,k3) 
       phase=tpi*(dble(i1)*dble(pgtmp(1))
     +           +dble(j1)*dble(pgtmp(2))
     +           +dble(k1)*dble(pgtmp(3))) 
       pf=exp(-ci*phase/dble(nnp)) 
       C0_K(ig,:)=C0irr(jg,:)*pf 
      enddo!ig 
      C0_K(:,:)=conjg(C0_K(:,:))  
      end select 
!--
!      SUM_CMPX=0.0d0 
!      do ig=1,NG 
!       SUM_CMPX=SUM_CMPX+CONJG(C0_K(ig))*C0_K(ig) 
!      enddo 
!      write(6,'(a,x,2f15.10)') 'sumC0_K',SUM_CMPX 
!--
      return 
      end 
!--
      SUBROUTINE OUTER_PRODUCT(vec_x,vec_y,vec_z)
      implicit none 
      real(8)::vec_x(3),vec_y(3),vec_z(3) 
      vec_z(1)=vec_x(2)*vec_y(3)-vec_x(3)*vec_y(2)
      vec_z(2)=vec_x(3)*vec_y(1)-vec_x(1)*vec_y(3) 
      vec_z(3)=vec_x(1)*vec_y(2)-vec_x(2)*vec_y(1)
      RETURN
      END
!--
      subroutine BZcheck(ktmp,kflg) 
      implicit none 
      real(8),intent(in)::ktmp(3)
      real(8)::kx,ky,kz 
      integer,intent(out)::kflg 
      kx=-ktmp(1) 
      ky=-ktmp(2) 
      kz=-ktmp(3) 
      kflg=0 
      if(kx<=-0.5d0) kflg=1
      if(kx>0.5d0) kflg=1
      if(ky<=-0.5d0) kflg=1
      if(ky>0.5d0) kflg=1
      if(kz<=-0.5d0) kflg=1
      if(kz>0.5d0) kflg=1
      return
      end
!--
!set NB_start,NB_end 
      subroutine calc_NB_start_end(NK,NB,EIG,EL,EU,NB_start,NB_end) 
      implicit none
      integer::NK,NB
      real(8)::EIG(NB,NK) 
      real(8)::EL,EU  
      integer::NB_start,NB_end
      integer::Ein(NB,NK) 
      integer::ik,ib
!
      Ein=0 
      do ik=1,NK 
       do ib=1,NB 
        if(EL<=EIG(ib,ik).and.EIG(ib,ik)<=EU)then 
         Ein(ib,ik)=ib
        endif 
       enddo
      enddo   
      NB_end=maxval(Ein)
      do ik=1,NK 
       do ib=1,NB 
        if(Ein(ib,ik)==0) Ein(ib,ik)=10000
       enddo
      enddo 
      NB_start=minval(Ein) 
      return
      end 
!--
!SHIFT VECTOR
      subroutine make_shift_vector(NTK,NB,ik,ibvec,SK0,b_LAT,
     +SHIFT_b,ik_ib)
      implicit none
      integer::NTK,NB,ik,ibvec 
      real(8)::SK0(3,NTK) 
      real(8)::b_LAT(3,NB)  
      integer::SHIFT_b(3)
      integer::ik_ib 
      real(8)::SL(3) 
      integer::jk 
      real(8),parameter::dlt_BZ=1.0d-6 
!--
      SL(:)=SK0(:,ik)+b_LAT(:,ibvec)         
!     write(6,'(a8,3f15.10)')'SLbfr=',SL(1),SL(2),SL(3) 
!     dlt_BZ=1.d-6
      SHIFT_b(:)=0           
      IF(SL(1)<=-0.5D0+dlt_BZ)THEN!20170210 
       SL(1)=SL(1)+1.0D0 
       SHIFT_b(1)=-1                
      ENDIF           
      IF(SL(2)<=-0.5D0+dlt_BZ)THEN!20170210
       SL(2)=SL(2)+1.0D0 
       SHIFT_b(2)=-1                
      ENDIF           
      IF(SL(3)<=-0.5D0+dlt_BZ)THEN!20170210 
       SL(3)=SL(3)+1.0D0 
       SHIFT_b(3)=-1                
      ENDIF           
      IF(SL(1)>0.5D0+dlt_BZ)THEN
       SL(1)=SL(1)-1.0D0 
       SHIFT_b(1)=1                
      ENDIF           
      IF(SL(2)>0.5D0+dlt_BZ)THEN
       SL(2)=SL(2)-1.0D0 
       SHIFT_b(2)=1                
      ENDIF           
      IF(SL(3)>0.5D0+dlt_BZ)THEN
       SL(3)=SL(3)-1.0D0 
       SHIFT_b(3)=1                
      ENDIF           
!     write(6,'(a8,3f15.10)')'SLaft=',SL(1),SL(2),SL(3) 
!IK_IB
      do jk=1,NTK          
       IF(ABS(SK0(1,jk)-SL(1))<=1.d-4.AND.
     +    ABS(SK0(2,jk)-SL(2))<=1.d-4.AND.
     +    ABS(SK0(3,jk)-SL(3))<=1.d-4)THEN           
        ik_ib=jk           
       ENDIF        
      enddo!jk               
      return
      end 
!--
!       call make_amat(nigs,NTB,NTG,NG0(ik),SK0(1,ik),KG0(1,1,ik),
!     + b1(1),b2(1),b3(1),TAU_GAUSS(1,1),ALPHA_GAUSS(1),
!     + loc_x(1,1),loc_y(1,1),loc_z(1,1),LGAUSS(1),MGAUSS(1),
!     + N_BAND(ik),C0(1,1,ik),N_BAND_BTM(ik),NORM_GAUSS(1),VOLUME,
!     + A_TMP(1,1)) 
!--
      subroutine make_amat(nigs,NTB,NTG,NG0,SK0,KG0,b1,b2,b3,    
     + TAU_GAUSS,ALPHA_GAUSS,loc_x,loc_y,loc_z,LGAUSS,MGAUSS,
     + N_BAND,C0,N_BAND_BTM,NORM_GAUSS,VOLUME,A_TMP) 
      implicit none
      integer::nigs,NTB,NTG
      integer::NG0
      real(8)::SK0(3)
      integer::KG0(3,NTG)
      real(8)::b1(3),b2(3),b3(3) 
      real(8)::VOLUME 
      real(8)::TAU_GAUSS(3,nigs)
      real(8)::ALPHA_GAUSS(nigs)
      real(8)::NORM_GAUSS(nigs)
      real(8)::loc_x(3,nigs),loc_y(3,nigs),loc_z(3,nigs) 
      integer::LGAUSS(nigs),MGAUSS(nigs)
      integer::N_BAND,N_BAND_BTM 
      complex(8)::C0(NTG,NTB)
      complex(8)::A_TMP(NTB,nigs)  
      !--
      real(8),parameter::pi=dacos(-1.0d0)
      complex(8),parameter::ci=(0.0D0,1.0D0) 
      integer::j_gauss,ig,i_band,jL,jM 
      real(8)::PHASE,ZETA1,ZETA2,YLM
      real(8)::VEC_KG(3,NTG)  
      real(8)::KG2(NTG) 
      complex(8)::PF1(NTG)
      real(8)::PF2(NTG) 
      real(8)::ktmp(3),tmp(3)
      complex(8)::SUM_CMPX        
      !
      !write(6,*) C0 
      !write(6,*) VOLUME  
      !write(6,*) ALPHA_GAUSS 
      !write(6,*) TAU_GAUSS 
      !write(6,*) NORM_GAUSS 
      !write(6,*) loc_x 
      !write(6,*) loc_y 
      !write(6,*) loc_z 
      !
      A_TMP=0.0d0 
      do j_gauss=1,nigs
       !--
       VEC_KG(:,:)=0.0D0             
       PF1(:)=0.0D0 
       PF2(:)=0.0D0 
       KG2(:)=0.0D0
       do ig=1,NG0 
        VEC_KG(:,ig)=(SK0(1)+DBLE(KG0(1,ig)))*b1(:)   
     +              +(SK0(2)+DBLE(KG0(2,ig)))*b2(:)   
     +              +(SK0(3)+DBLE(KG0(3,ig)))*b3(:)   
        KG2(ig)=VEC_KG(1,ig)**2+VEC_KG(2,ig)**2+VEC_KG(3,ig)**2
        PHASE=VEC_KG(1,ig)*TAU_GAUSS(1,j_gauss) 
     +       +VEC_KG(2,ig)*TAU_GAUSS(2,j_gauss) 
     +       +VEC_KG(3,ig)*TAU_GAUSS(3,j_gauss)                 
        PF1(ig)=EXP(-ci*PHASE )         
        PF2(ig)=EXP(-KG2(ig)/4.0D0/ALPHA_GAUSS(j_gauss))
       enddo!ig  
       !
       !write(6,*)'PF1'
       !write(6,*)PF1
       !write(6,*)'PF2'
       !write(6,*)PF2
       !
       do ig=1,NG0
        ktmp(:)=VEC_KG(:,ig) 
        tmp(1)=ktmp(1)*loc_x(1,j_gauss)
     +        +ktmp(2)*loc_x(2,j_gauss)
     +        +ktmp(3)*loc_x(3,j_gauss)   
        tmp(2)=ktmp(1)*loc_y(1,j_gauss)
     +        +ktmp(2)*loc_y(2,j_gauss)
     +        +ktmp(3)*loc_y(3,j_gauss) 
        tmp(3)=ktmp(1)*loc_z(1,j_gauss)
     +        +ktmp(2)*loc_z(2,j_gauss)
     +        +ktmp(3)*loc_z(3,j_gauss) 
        VEC_KG(:,ig)=tmp(:) 
       enddo!ig 
       !
       !write(6,*)'VEC_KG'
       !write(6,*)VEC_KG 
       !
       jL=LGAUSS(j_gauss) 
       jM=MGAUSS(j_gauss)     
       !--
       do i_band=1,N_BAND 
        SUM_CMPX=0.0D0                   
!<Psi|s>
        IF(jL==1)THEN                          
         do ig=1,NG0 
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          YLM=DSQRT(1.0D0/4.0D0/pi)        
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig) 
     +   *YLM                                      
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*PF2(ig)       
         enddo!ig          
        ENDIF 
!<Psi|py>
        IF(jL==2.AND.jM==2)THEN
         do ig=1,NG0 
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=1.0D0/2.0D0/ALPHA_GAUSS(j_gauss) 
          YLM=DSQRT(3.0D0/4.0D0/pi)*VEC_KG(2,ig)
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)  
     +   *(-ci)*YLM                                      
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig)       
         enddo!ig          
        ENDIF 
!<Psi|pz>
        IF(jL==2.AND.jM==3)THEN
         do ig=1,NG0 
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=1.0D0/2.0D0/ALPHA_GAUSS(j_gauss) 
          YLM=DSQRT(3.0D0/4.0D0/pi)*VEC_KG(3,ig) 
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)            
     +   *(-ci)*YLM                                      
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig)  
         enddo!ig          
        ENDIF 
!<Psi|px>
        IF(jL==2.AND.jM==1)THEN
         do ig=1,NG0
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=1.0D0/2.0D0/ALPHA_GAUSS(j_gauss) 
          YLM=DSQRT(3.d0/4.d0/pi)*VEC_KG(1,ig)
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)  
     +   *(-ci)*YLM                                      
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig)     
         enddo!ig          
        ENDIF 
!<Psi|dxy>
        IF(jL==3.AND.jM==1)THEN                          
         do ig=1,NG0          
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=(1.0D0/2.0D0/ALPHA_GAUSS(j_gauss))**2.0D0   
          YLM=0.5d0*DSQRT(15.d0/pi)*VEC_KG(1,ig)*VEC_KG(2,ig)       
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)     
     +   *(-YLM)                                             
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig) 
         enddo!ig          
        ENDIF 
!<Psi|dyz>
        IF(jL==3.AND.jM==2)THEN                          
         do ig=1,NG0
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=(1.0D0/2.0D0/ALPHA_GAUSS(j_gauss))**2.0D0   
          YLM=(0.5d0)*DSQRT(15.d0/pi)*VEC_KG(2,ig)*VEC_KG(3,ig)
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)  
     +   *(-YLM)                                             
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig) 
         enddo!ig          
        ENDIF 
!<Psi|dz2>
        IF(jL==3.AND.jM==3)THEN                          
         do ig=1,NG0
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=(1.0D0/2.0D0/ ALPHA_GAUSS(j_gauss))**2.0D0     
          YLM=(0.25d0)*DSQRT(5.d0/pi)*(3.d0*VEC_KG(3,ig)**2-KG2(ig))
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)  
     +   *(-YLM)                                             
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig) 
         enddo!ig          
        ENDIF 
!<Psi|dzx>
        IF(jL==3.AND.jM==4)THEN                          
         do ig=1,NG0 
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=(1.0D0/2.0D0/ALPHA_GAUSS(j_gauss))**2.0D0    
          YLM=(0.5d0)*DSQRT(15.d0/pi)*VEC_KG(3,ig)*VEC_KG(1,ig)
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)           
     +   *(-YLM)                                             
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig) 
         enddo!ig          
        ENDIF 
!<Psi|dx2>
        IF(jL==3.AND.jM==5)THEN                          
         do ig=1,NG0 
          ZETA1=(pi/ALPHA_GAUSS(j_gauss))**1.5D0          
          ZETA2=(1.0D0/2.0D0/ALPHA_GAUSS(j_gauss))**2.0D0    
          YLM=(0.25d0)*DSQRT(15.d0/pi)
     +       *(VEC_KG(1,ig)**2-VEC_KG(2,ig)**2) 
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C0(ig,i_band+N_BAND_BTM)) 
     +   *PF1(ig)              
     +   *(-YLM)                                             
     +   *NORM_GAUSS(j_gauss) 
     +   *ZETA1*ZETA2*PF2(ig)     
         enddo!ig          
        ENDIF 
        !--
        A_TMP(i_band,j_gauss)=SUM_CMPX/DSQRT(VOLUME)             
       enddo!i_band         
      enddo!j_gauss 
      ! 
      !do i_band=1,N_BAND
      ! write(6,'(100f12.5)')(A_TMP(i_band,j_gauss),j_gauss=1,nigs)
      !enddo 
      !write(6,*) 
      ! 
      return
      end 
      !--
      subroutine make_pw(C0_I,wfunc,fftwk,NG0,KG0,NTG,nwx2,nwy2,nwz2,
     + nfft1,nfft2,Nl123,fs,xmin,xmax,ymin,ymax,zmin,zmax,SK0,pw) 
      use fft_3d 
      implicit none
      type(fft3_struct)::fs 
      integer::NTG,nwx2,nwy2,nwz2,nfft1,nfft2,Nl123
      integer::xmin,xmax,ymin,ymax,zmin,zmax
      integer::KG0(3,NTG)
      integer::NG0 
      real(8)::fftwk(Nl123*2)
      real(8)::wfunc(Nl123*2) 
      real(8)::SK0(3) 
      complex(8)::C0_I(NTG) 
      complex(8)::pw((xmin)*nwx2:(xmax)*nwx2-1,
     +               (ymin)*nwy2:(ymax)*nwy2-1, 
     +               (zmin)*nwz2:(zmax)*nwz2-1)
      integer::ig,igb1,igb2,igb3,ind,ir,ir1,ir2,ir3 
      integer::ir1_SHIFT,ir2_SHIFT,ir3_SHIFT,jr1,jr2,jr3  
      real(8)::PHASE
      complex(8)::pf 
      real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
      complex(8),parameter::ci=(0.0D0,1.0D0) 
      complex(8)::u_1D(Nl123) 
      complex(8)::u_3D(0:nwx2-1,0:nwy2-1,0:nwz2-1) 
      !--
      u_3D=0.0D0 
      u_1D=0.0D0 
      wfunc=0.0d0 
      fftwk=0.0d0 
      do ig=1,NG0 
       igb1=KG0(1,ig) 
       igb2=KG0(2,ig) 
       igb3=KG0(3,ig) 
       igb1=MOD(nwx2+igb1,nwx2)+1
       igb2=MOD(nwy2+igb2,nwy2)+1
       igb3=MOD(nwz2+igb3,nwz2)+1
       ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
       wfunc(ind)=dble(C0_I(ig)) 
       wfunc(ind+Nl123)=dimag(C0_I(ig)) 
      enddo!ig 
      call fft3_bw(fs,wfunc(1),fftwk(1)) 
      do ir=1,Nl123
       u_1D(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
      enddo!ir 
      !--
      do ir3=1,nwz2
       do ir2=1,nwy2
        do ir1=1,nwx2 
         ir=ir1+(ir2-1)*nfft1+(ir3-1)*nfft1*nfft2  
         u_3D(ir1-1,ir2-1,ir3-1)=u_1D(ir) 
        enddo 
       enddo 
      enddo 
      !--
      do ir1=(xmin)*nwx2,(xmax)*nwx2-1         
       do ir2=(ymin)*nwy2,(ymax)*nwy2-1        
        do ir3=(zmin)*nwz2,(zmax)*nwz2-1         
         PHASE=tpi*(DBLE(ir1)*SK0(1)/DBLE(nwx2) 
     +             +DBLE(ir2)*SK0(2)/DBLE(nwy2) 
     +             +DBLE(ir3)*SK0(3)/DBLE(nwz2)) 
         pf=EXP(ci*PHASE)          
         !(ir1,ir2,ir3)->(jr1,jr2,jr3)
         ir1_SHIFT=ir1       
         ir2_SHIFT=ir2       
         ir3_SHIFT=ir3       
         DO WHILE(ir1_SHIFT<0) 
          ir1_SHIFT=ir1_SHIFT+nwx2               
         ENDDO        
         DO WHILE(ir2_SHIFT<0) 
          ir2_SHIFT=ir2_SHIFT+nwy2                              
         ENDDO        
         DO WHILE(ir3_SHIFT<0) 
          ir3_SHIFT=ir3_SHIFT+nwz2            
         ENDDO        
         jr1=MOD(ir1_SHIFT,nwx2)       
         jr2=MOD(ir2_SHIFT,nwy2)       
         jr3=MOD(ir3_SHIFT,nwz2)       
         !CALC wannier(ir1,ir2,ir3)
         pw(ir1,ir2,ir3)=pw(ir1,ir2,ir3)+u_3D(jr1,jr2,jr3)*pf 
        enddo!ir3         
       enddo!ir2 
      enddo!ir1 
      !-- 
      return
      end
      !--
      subroutine make_bf(C0_I,wfunc,fftwk,NG0,KG0,NTG,nwx2,nwy2,nwz2,
     + nfft1,nfft2,Nl123,fs,pw) 
      use fft_3d 
      implicit none
      type(fft3_struct)::fs 
      integer::NTG,nwx2,nwy2,nwz2,nfft1,nfft2,Nl123
      integer::KG0(3,NTG)
      integer::NG0 
      real(8)::fftwk(Nl123*2)
      real(8)::wfunc(Nl123*2) 
      complex(8)::C0_I(NTG) 
      integer::ig,igb1,igb2,igb3,ind,ir,ir1,ir2,ir3 
      complex(8)::u_1D(Nl123) 
      real(8)::pw(0:nwx2-1,0:nwy2-1,0:nwz2-1)
      !--
      u_1D=0.0d0 
      wfunc=0.0d0 
      fftwk=0.0d0 
      do ig=1,NG0 
       igb1=KG0(1,ig) 
       igb2=KG0(2,ig) 
       igb3=KG0(3,ig) 
       igb1=MOD(nwx2+igb1,nwx2)+1
       igb2=MOD(nwy2+igb2,nwy2)+1
       igb3=MOD(nwz2+igb3,nwz2)+1
       ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
       wfunc(ind)=dble(C0_I(ig)) 
       wfunc(ind+Nl123)=dimag(C0_I(ig)) 
      enddo!ig 
      call fft3_bw(fs,wfunc(1),fftwk(1)) 
      do ir=1,Nl123
       u_1D(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
      enddo!ir 
      !--
      do ir3=1,nwz2
       do ir2=1,nwy2
        do ir1=1,nwx2 
         ir=ir1+(ir2-1)*nfft1+(ir3-1)*nfft1*nfft2  
         pw(ir1-1,ir2-1,ir3-1)=abs(u_1D(ir))**2 
        enddo 
       enddo 
      enddo 
      !--
      return
      end
      !--
      subroutine search_ik(NTK,SK0,ktmp,ik) 
      implicit none 
      integer::NTK
      real(8)::SK0(3,NTK) 
      real(8)::ktmp(3)
      integer::iik,ik
      real(8),parameter::dlt_BZ=1.0d-5 
      !--
      ik=0 
      do iik=1,NTK 
       !write(6,*)SK0(:,iik) 
       if( abs(SK0(1,iik)-ktmp(1))<dlt_BZ.and. 
     +     abs(SK0(2,iik)-ktmp(2))<dlt_BZ.and. 
     +     abs(SK0(3,iik)-ktmp(3))<dlt_BZ )then 
        ik=iik 
       endif 
      enddo!iik
      if(ik==0)then 
       write(6,*)'Failed search ik:'
       write(6,*)'There exits no k pts to be calculated:'
       write(6,*)'Then, stop'
       stop 
      endif 
      !--
      return
      end 
      !
      !20180817
      !
      subroutine search_vis_range(ktmp,amin,amax,bmin,bmax,cmin,cmax) 
      implicit none 
      real(8),intent(in)::ktmp(3)
      integer,intent(out)::amin,amax,bmin,bmax,cmin,cmax 
      real(8)::denom
      real(8),parameter::dlt_BZ=1.0d-5 
      amin=0; amax=0; bmin=0; bmax=0; cmin=0; cmax=0
      !
      if(dabs(ktmp(1))<dlt_BZ)then 
       denom=1.0d0 
      else
       denom=ktmp(1) 
      endif 
      amax=nint(1.0d0/denom)
      !
      if(dabs(ktmp(2))<dlt_BZ)then 
       denom=1.0d0 
      else
       denom=ktmp(2) 
      endif 
      bmax=nint(1.0d0/denom)
      !
      if(dabs(ktmp(3))<dlt_BZ)then 
       denom=1.0d0 
      else
       denom=ktmp(3) 
      endif 
      cmax=nint(1.0d0/denom)
      !
      return 
      end
      !
      !20180820
      !
      subroutine phase_fix_bf(nwx2,nwy2,nwz2,xmin,xmax,ymin,ymax,
     + zmin,zmax,pw) 
      implicit none
      integer,intent(in)::nwx2,nwy2,nwz2,xmin,xmax,ymin,ymax,zmin,zmax
      complex(8),intent(inout)::pw((xmin)*nwx2:(xmax)*nwx2-1,
     +                             (ymin)*nwy2:(ymax)*nwy2-1, 
     +                             (zmin)*nwz2:(zmax)*nwz2-1)
      integer::ir1,ir2,ir3 
      real(8)::x,y,r,rmax 
      complex(8)::glb_phase 
      complex(8),parameter::ci=(0.0d0,1.0d0) 
      ! 
      rmax=1.0d-6 
      do ir1=(xmin)*nwx2,(xmax)*nwx2-1         
       do ir2=(ymin)*nwy2,(ymax)*nwy2-1        
        do ir3=(zmin)*nwz2,(zmax)*nwz2-1         
         x=dble(pw(ir1,ir2,ir3))  
         y=dimag(pw(ir1,ir2,ir3))  
         r=dsqrt(x**2+y**2)
         if(r>rmax)then
          glb_phase=(x-ci*y)/r 
          rmax=r 
         endif 
        enddo!ir3         
       enddo!ir2 
      enddo!ir1 
      !write(6,*)'rmax=',rmax 
      pw=pw*glb_phase 
      !
      return
      end

subroutine diagV(nm,mat,eig)
implicit none 
integer,intent(in)::nm
complex(8),intent(inout)::mat(nm,nm)
real(8),intent(out)::eig(nm)
integer::LWORK,LRWORK,LIWORK  
integer,allocatable::iwork_zheevd(:)
real(8),allocatable::rwork_zheevd(:)
complex(8),allocatable::work_zheevd(:)
integer::ind
real(8)::eps 
!---
LWORK= 2*nm+nm**2
LRWORK=1+12*nm+3*nm**2
LIWORK=3+10*nm 
allocate(work_zheevd(LWORK));work_zheevd(:)=0.0d0
allocate(rwork_zheevd(LRWORK));rwork_zheevd(:)=0.0d0
allocate(iwork_zheevd(LIWORK));iwork_zheevd(:)=0
eps=1.0d-18
ind=0                 
!---
call zheevd("V","U",nm,mat,nm,eig,work_zheevd,LWORK, &
        rwork_zheevd,LRWORK,iwork_zheevd,LIWORK,ind)
!---
if(ind/=0) then 
write(6,*) 'ind=',ind 
stop
endif 
!---
deallocate(work_zheevd,rwork_zheevd,iwork_zheevd) 
return 
end subroutine

subroutine inv_ge_lapack(L,NBh,mat) 
implicit none 
integer,intent(in)::L 
integer,intent(in)::NBh 
real(8),intent(inout)::mat(L,L)!notice 
integer,allocatable::ipiv(:)!ipiv(NBh)
real(8),allocatable::work(:)
integer::Lwork,info,m,n,lda  
m=NBh  
n=L 
lda=L   
Lwork=10*m
allocate(ipiv(NBh));ipiv=0 
allocate(work(Lwork));work=0.0d0 
info=0
call dgetrf(n,m,mat,lda,ipiv,info)
if(info/=0)then
 write(6,*)'info(subrouitine dgetrf):',info
!stop
endif 
call dgetri(m,mat,lda,ipiv,work,Lwork,info)
if(info/=0)then
 write(6,*)'info(subrouitine dgetri):',info
!stop
endif 
deallocate(work)
!write(6,*) mat 
return 
end subroutine

!Copyright (c) 2017 Yusuke Nomura, Ryosuke Akashi, Terumasa Tadano 
program convert101
  use iotk_module
  implicit none
  character(150) :: data_dir 
  character(150) :: data_xml 
  real(8), parameter :: pi = dacos(-1.0d0)

  character(iotk_attlenx) :: attr
  real(8), allocatable :: k_vec(:,:), k_tmp(:,:)
  integer, allocatable :: num_Gk(:)
  integer, allocatable :: Gk_grid(:,:)
  complex(8), allocatable :: evc(:,:)
  real(8), allocatable :: eig(:)
  character(100), allocatable :: data_wfc(:), data_Gk(:)
  character(100), allocatable :: data_eig(:)

  real(8) :: a1(3), a2(3), a3(3)
  real(8) :: eFermi, celldm
  real(8) :: Ecut_for_psi, Etot
  integer :: i, j, num_k, num_b
  integer :: ncomp = 1 
  character(5) :: cwrk

  i = command_argument_count()
  if( i /= 1 ) then 
    stop "please specify single directory"
  else 
    call get_command_argument(1,data_dir)
  end if 

  data_xml = trim(data_dir)//"/data-file.xml"
  write(*,'(a)') "Read data from "
  write(*,*) data_xml

  call iotk_open_read(11,data_xml)
  call iotk_scan_begin(11,"BAND_STRUCTURE_INFO",attr=attr)
    call iotk_scan_dat(11,"NUMBER_OF_K-POINTS",num_k)
    call iotk_scan_dat(11,"NUMBER_OF_BANDS",num_b)
    call iotk_scan_dat(11,"FERMI_ENERGY",eFermi)
  call iotk_scan_end(11,"BAND_STRUCTURE_INFO")
      
  allocate(k_vec(3,num_k),k_tmp(3,num_k))
  allocate(data_wfc(num_k),data_Gk(num_k),data_eig(num_k))
  call iotk_scan_begin(11,"EIGENVALUES",attr=attr)
  do i = 1, num_k
    !
    ! generate filenames 
    !
    cwrk = "     "
    write(cwrk,'(i5)') i
    do j = 1, 5
      if(cwrk(j:j).eq." ") cwrk(j:j) = "0"
    end do ! j 
    !
    ! generate wfc filename
    !
    data_wfc(i) = "/K" // cwrk
    data_wfc(i) = trim(data_wfc(i)) // "/evc.dat"
    data_wfc(i) = trim(data_dir) // trim(data_wfc(i))
    write(*,*) data_wfc(i)
    !
    ! generate Gk filename
    !
    data_Gk(i) = "/K" // cwrk
    data_Gk(i) = trim(data_Gk(i)) // "/gkvectors.dat"
    data_Gk(i) = trim(data_dir) // trim(data_Gk(i))
    write(*,*) data_Gk(i)
    ! 
    ! generate eigen filename
    !
    data_eig(i) = "/K" // cwrk
    data_eig(i) = trim(data_eig(i)) // "/eigenval.xml"
    data_eig(i) = trim(data_dir) // trim(data_eig(i))
    write(*,*) data_eig(i)

    call iotk_scan_begin(11,"K-POINT"//iotk_index(i),attr=attr)
      call iotk_scan_dat(11,"K-POINT_COORDS",k_vec(:,i))
    call iotk_scan_end(11,"K-POINT"//iotk_index(i))
  end do ! i  
  call iotk_scan_end(11,"EIGENVALUES")

  allocate(num_Gk(num_k))
  call iotk_scan_begin(11,"EIGENVECTORS",attr=attr)
  do i= 1, num_k
    call iotk_scan_begin(11,"K-POINT"//iotk_index(i),attr=attr)
      call iotk_scan_dat(11,"NUMBER_OF_GK-VECTORS",num_Gk(i))
    call iotk_scan_end(11,"K-POINT"//iotk_index(i))
  end do ! i 
  call iotk_scan_end(11,"EIGENVECTORS")
  ! 
  ! Lattice vectors 
  ! 
  call iotk_scan_begin(11,"CELL",attr=attr)

    call iotk_scan_dat(11,"LATTICE_PARAMETER",celldm)

    call iotk_scan_begin(11,"DIRECT_LATTICE_VECTORS",attr=attr)
      call iotk_scan_dat(11,"a1",a1)
      call iotk_scan_dat(11,"a2",a2)
      call iotk_scan_dat(11,"a3",a3)
    call iotk_scan_end(11,"DIRECT_LATTICE_VECTORS")

  call iotk_scan_end(11,"CELL")

  call iotk_scan_begin(11,"PLANE_WAVES",attr=attr)
    call iotk_scan_dat(11,"WFC_CUTOFF",Ecut_for_psi)
  call iotk_scan_end(11,"PLANE_WAVES")

  call iotk_close_read(11)
 
  k_tmp(1,:) = a1(1)*k_vec(1,:) + a1(2)*k_vec(2,:) + a1(3)*k_vec(3,:) 
  k_tmp(2,:) = a2(1)*k_vec(1,:) + a2(2)*k_vec(2,:) + a2(3)*k_vec(3,:) 
  k_tmp(3,:) = a3(1)*k_vec(1,:) + a3(2)*k_vec(2,:) + a3(3)*k_vec(3,:) 
  k_tmp(:,:) = k_tmp(:,:)/celldm
  k_vec(:,:) = k_tmp(:,:)

  open(101,file='./dir-wfn/dat.sample-k') 
    rewind(101) 
    write(101,*) num_k
    do i = 1, num_k
      write(101,*) k_vec(:,i)
    end do 
  close(101)
  deallocate(k_vec,k_tmp)

  open(105,file='./dir-wfn/dat.lattice') 
    rewind(105)
    write(105,*) a1(:)
    write(105,*) a2(:)
    write(105,*) a3(:)
  close(105)

  open(117,file='./dir-wfn/dat.bandcalc') 
    rewind(117) 
    Etot = 0d0
    write(117,*) Ecut_for_psi*2d0 ! Hartree => Rydberg  
    write(117,*) eFermi       
    write(117,*) Etot         
  close(117)
 
  open(132,file='./dir-wfn/dat.nkm') 
    rewind(132)
    do i = 1, num_k
      write(132,*) num_Gk(i)
    end do ! i  
  close(132)

  open(104,file='./dir-wfn/dat.kg') 
  rewind(104) 
  do i = 1, num_k
    allocate(GK_grid(3,num_Gk(i)))
    call iotk_open_read(12,data_Gk(i))
      call iotk_scan_dat(12,"GRID",GK_grid)
      write(104,*) num_Gk(i)
      do j = 1, num_Gk(i)
        write(104,*) GK_grid(:,j)
      end do ! j 
    call iotk_close_read(12)
    deallocate(Gk_grid)
  end do ! i 

  open(102,file='./dir-wfn/dat.wfn',FORM='unformatted') 
    rewind(102)
    write(102) ncomp
    do i = 1, num_k
      allocate(evc(num_Gk(i),num_b))
      call iotk_open_read(13, data_wfc(i))
        do j = 1, num_b
          call iotk_scan_dat(13,"evc"//iotk_index(j),evc(:,j))
        end do ! j  
        do j = 1, num_b
          write(102) evc(:,j)
        end do ! j 
      call iotk_close_read(13)
      deallocate(evc)
    end do ! i 
  close(102)
  deallocate(num_Gk)

  open(111,file='./dir-wfn/dat.eigenvalue') 
    rewind(111)
    write(111,*) num_b 
    do i = 1, num_k
      allocate(eig(num_b))
      call iotk_open_read(14,data_eig(i))
        call iotk_scan_dat(14,"EIGENVALUES",eig)
        do j = 1, num_b
          write(111,*) eig(j)
        end do ! j 
      call iotk_close_read(14)
      deallocate(eig)
    end do ! i  
  close(111)

  call convert_sym(data_xml)

  deallocate(data_wfc,data_Gk,data_eig)

end program



subroutine convert_sym(data_xml)
  use iotk_module
  implicit none

  character(150), intent(in) :: data_xml         
  real(8), parameter :: pi = dacos(-1.0d0)
  character(iotk_attlenx) :: attr
  real(8) , allocatable :: ftau(:,:)
  integer , allocatable :: tau(:,:)
  real(8) :: tmp, mat(3,3) 
  integer i, j, k, l, n_sym
  integer :: torf
  integer , allocatable :: mat_sym(:,:)


  open(100,file='./dir-wfn/dat.symmetry') 
  rewind(100) 
   
  call iotk_open_read(11,data_xml)
  call iotk_scan_begin(11,"SYMMETRIES",attr=attr)
    call iotk_scan_dat(11,"NUMBER_OF_SYMMETRIES",n_sym)
    allocate(ftau(3,n_sym))
    allocate(tau(3,n_sym))
    allocate(mat_sym(9,n_sym))
    do i = 1, n_sym
      call iotk_scan_begin(11,"SYMM"//iotk_index(i),attr=attr)
        call iotk_scan_dat(11,"ROTATION",mat_sym(:,i))
        call iotk_scan_dat(11,"FRACTIONAL_TRANSLATION",ftau(:,i))
      call iotk_scan_end(11,"SYMM"//iotk_index(i))
    end do ! i 

    do i = 1, 1000
      torf = 1
      do j = 1, n_sym
        do k = 1, 3 
          tmp = ftau(k,j)*dble(i) - idnint(ftau(k,j)*dble(i))
          if(abs(tmp)>1.0d-7) torf = 0
        end do ! k 
      end do ! j  
      if( torf == 1 ) then 
        write(100,'(I5)') n_sym
        write(100,'(I5)') i
        do j = 1, n_sym
          do k = 1, 3 
            tau(k,j) = -idnint(ftau(k,j)*dble(i))
          end do ! k  
        end do ! j  
        exit 
      end if 
    end do ! i

    do i = 1, n_sym 
      mat = 0.0d0
      l = 0
      do j = 1, 3 
      do k = 1, 3 
        l = l+1
        mat(k,j) = dble(mat_sym(l,i))
      end do 
      end do 
      call inv(3,mat) 
      do j = 1, 3 
      do k = 1, 3 
        tmp = mat(k,j) - dble(idnint(mat(k,j)))
        if(tmp>1.0d-10) stop 'Error: something wrong in symmetry matrix'
      end do ! k 
      end do ! j 
      write(100,'(9I3)') ((idnint(mat(k,j)),k=1,3),j=1,3)
      write(100,'(3I3)') tau(:,i)
    end do ! i 
    call iotk_scan_end(11,"SYMMETRIES")
  call iotk_close_read(11)
  close(100)

  deallocate(ftau,tau,mat_sym)

  return

end subroutine


subroutine inv(nm,mat)
  implicit none 
  integer , intent(in) :: nm
  real(8) , intent(inout) :: mat(nm,nm)
  integer :: ipiv(nm)
  integer :: Lwork 
  real(8) , allocatable :: work(:)
  integer :: info 

  Lwork = 10*nm
  allocate (work(Lwork))
  info = 0
  call dgetrf(nm,nm,mat,nm,ipiv,info)
  call dgetri(nm,mat,nm,ipiv,work,Lwork,info)

  if(info /= 0) then
    write(6,*) 'Error: inverse matrix calculation fails, & 
                info (subrouitine inv):' , info
    stop
  end if 
  deallocate(work)

  return 
end subroutine

!
! Copyright (c) 2000-2013,2016,2017 Yoshihide Yoshimoto
! 

program wfn2respack
  implicit none
  integer, parameter:: nfin = 10, nfout = 11
  integer, parameter:: nfoutkg = 12, nfouteig = 13

  character(len=8):: sign
  integer:: ver
  integer:: nks, nw, ng, nnp
  integer:: nkmmax
  integer,allocatable:: nkmary(:), kg(:,:), rg(:,:,:), pg(:,:), srg(:)
  real(kind=8),allocatable:: sk(:,:)
  real(kind=8),allocatable:: pr(:)
  complex(kind=8),allocatable:: p(:,:)
  integer:: nspin, ncomp
  real(kind=8):: bb(3,3), aa(3,3)
  integer:: i, j, ios, ik, ig, ib
  character(len=256):: ifname, argv(4)
  logical:: ifinvsymi
  real(kind=8):: w(2) = (/0.0d0, 0.0d0/), ee(2) = (/0.0d0, 0.0d0/)
  real(kind=8):: ecut, x(3), xsq
  logical:: iffedsym, ifgreysym
  integer:: igh

  call getarg(1, argv(1))
  if (len_trim(argv(1)) .eq. 0) then
     write(6,*) 'invalid fname'
     stop
  end if
  ifname = argv(1)

  open(nfin, file=ifname, status='old', action='read', form='unformatted')
  ifinvsymi = .false.
  read(nfin, iostat=ios) sign, ver
  if (ios.ne.0) then
     write(6,*) 'unknown format'
     stop
  end if
  if (ver.ne.3) then
     write(6,*) 'only version 3 format is supported by this program'
  end if
  if (sign .ne. 'TAPP:wfn') then
     if (sign .ne. 'TAPP:wfi') then
        write(6,*) 'Bad magic'
        stop
     else
        ifinvsymi = .true.
     end if
  end if
  read(nfin) aa, bb
  read(nfin) nspin, nks, nw, ng, nnp, ncomp
  allocate(nkmary(nks), sk(3,nks), rg(3,3,ng), pg(3,ng), srg(ng))
  read(nfin) rg, pg, srg

  !
  ! check if symmetry is a Federov group, namely a pure space group.
  !
  iffedsym = .true.
  do ig=1,ng
     if (srg(ig).ne.1) then
        iffedsym = .false.
     end if
  end do
  
  !
  ! check if symmetry is a grey group automatically generated by
  ! symmetry_format = reciprocal in the xTAPP input.
  !
  ifgreysym = .true.
  if (mod(ng,2).ne.0) then
     ifgreysym = .false.
  else
     do igh=1,ng/2
        if (maxval(abs(rg(:,:,2*igh-1)-rg(:,:,2*igh))).ne.0) then
           ifgreysym = .false.
        end if
        if (maxval(abs(pg(:,2*igh-1)-pg(:,2*igh))).ne.0) then
           ifgreysym = .false.
        end if
        if (srg(2*igh-1).ne.1 .or. srg(2*igh).ne.-1) then
           ifgreysym = .false.
        end if
     end do
  end if
  if (.not. (iffedsym .or. ifgreysym) ) then
     write(6,*) 'The symmetry in the wavefunction file is a magnetic type.'
     write(6,*) 'RESPACK does not support this type.'
     stop 1
  end if
  if (iffedsym .and. ifgreysym) then
     write(6,*) 'Internal error in wfn2respack'
     stop 1
  endif

  read(nfin) (sk(:,ik),ik=1,nks)
  read(nfin) nkmary
  nkmmax = maxval(nkmary)
  allocate(kg(3,nkmmax), pr(nkmmax), p(ncomp,nkmmax))

  open(nfout,file='dat.sample-k')
  write(nfout,*) nks
  do ik=1,nks
     write(nfout,*) (sk(i,ik),i=1,3)
  end do

  close(nfout)
  open(nfout,file='dat.nkm')
  do ik=1,nks
     write(nfout,*) nkmary(ik)
  end do
  close(nfout)

  open(nfout,file='dat.lattice')
  write(nfout,*) aa(1,1),aa(2,1),aa(3,1)
  write(nfout,*) aa(1,2),aa(2,2),aa(3,2)
  write(nfout,*) aa(1,3),aa(2,3),aa(3,3)
  close(nfout)

  open(nfout,file='dat.symmetry')
  if (iffedsym) then
     write(nfout,*) ng
     write(nfout,*) nnp
     do ig=1,ng
        write(nfout,'(9(1x,i4))') ((rg(i,j,ig),i=1,3),j=1,3)
        write(nfout,'(3(1x,i4))') (pg(i,ig),i=1,3)
     end do
  else ! grey group case
     write(nfout,*) ng/2
     write(nfout,*) nnp
     do igh=1,ng/2
        write(nfout,'(9(1x,i4))') ((rg(i,j,2*igh-1),i=1,3),j=1,3)
        write(nfout,'(3(1x,i4))') (pg(i,2*igh-1),i=1,3)
     end do
     
  end if
  close(nfout)

  open(nfoutkg,file='dat.kg')
  open(nfouteig,file='dat.eigenvalue')
  open(nfout,file='dat.wfn',form='unformatted')
  write(nfout) ncomp
  write(nfouteig,*) nw

  ecut = 0.0d0

  do ik=1,nks
     read(nfin) ((kg(i,ig),i=1,3),ig=1,nkmary(ik))
     write(nfoutkg,*) nkmary(ik)
     do ig=1,nkmary(ik)
        write(nfoutkg,*) (kg(i,ig),i=1,3)
     end do
     do ig=1,nkmary(ik)
        x(1) = bb(1,1)*( sk(1,ik) + kg(1,ig) ) &
             + bb(1,2)*( sk(2,ik) + kg(2,ig) ) &
             + bb(1,3)*( sk(3,ik) + kg(3,ig) )
        x(2) = bb(2,1)*( sk(1,ik) + kg(1,ig) ) &
             + bb(2,2)*( sk(2,ik) + kg(2,ig) ) &
             + bb(2,3)*( sk(3,ik) + kg(3,ig) )
        x(3) = bb(3,1)*( sk(1,ik) + kg(1,ig) ) &
             + bb(3,2)*( sk(2,ik) + kg(2,ig) ) &
             + bb(3,3)*( sk(3,ik) + kg(3,ig) )
        xsq = x(1)*x(1)+x(2)*x(2)+x(3)*x(3)
        if (xsq.gt.ecut) ecut = xsq
     end do
     
     do ib=1,nw

        if (ifinvsymi) then
           read(nfin) (pr(i),i=1,nkmary(ik)), w(1), ee(1)
           write(nfout) (dcmplx(pr(i),0.0d0),i=1,nkmary(ik))
        else
           read(nfin) ((p(i,j),i=1,ncomp),j=1,nkmary(ik)), w(1), ee(1)
           !
           ! xTAPP uses (sigma, G) order
           ! RESPACK uses (G, sigma) order
           !
           write(nfout) ((p(i,j),j=1,nkmary(ik)),i=1,ncomp)
        end if
        write(nfouteig,*) ee(1)

     end do
     !
     ! advance to the next k-point
     !
     if (nspin .eq. 2) then
        do ib=1,nw
           if (ifinvsymi) then
              read(nfin)
           else
              read(nfin)
           end if
        end do
     end if
  end do
  close(nfoutkg)
  close(nfouteig)
  close(nfout)
  open(nfout,file='dat.bandcalc')
  write(nfout,*) ecut + 16*spacing(ecut)
  close(nfout)

end program wfn2respack

module m_rdinput 
implicit none
private
public::read_input 
!--
integer,public::N_CALC_BAND!TOTAL NUMBER OF CALCULATION BANDS 
real(8),public::Ecut_for_eps!cutoff energy for dielectric matrix (Ry)
real(8),public::shift_ef!artificial shift of Ef (eV) 
real(8),public::Max_excitation_energy!delta_ex!excitation constraint (eV)
real(8),public::delta_ex!excitation constraint (eV)
real(8),public::Green_func_delt!delt!ttrhdrn Green's function delt (eV)
real(8),public::delt!ttrhdrn Green's function delt (eV)
real(8),public::ttrhdrn_dmna!dmna!ttrhdrn
real(8),public::dmna!ttrhdrn
real(8),public::ttrhdrn_dmnr!dmnr!ttrhdrn
real(8),public::dmnr!ttrhdrn
integer,public::MPI_io_rank!io_rank !mpi 
integer,public::io_rank !mpi 
integer,public::MPI_num_proc_per_qcomm!num_of_mpi_per_comm !mpi 
integer,public::num_of_mpi_per_comm !mpi 
integer,public::MPI_num_qcomm!num_of_comm !mpi 
integer,public::num_of_comm !mpi 
integer,public::Num_freq_grid!nen !frequency grid 
integer,public::nen !frequency grid 
real(8),public::Lower_bound_energy_window!LOWER BOUND OF ENERGY WINDOW (eV)
real(8),public::E_LOWER!LOWER BOUND OF ENERGY WINDOW (eV)
real(8),public::Upper_bound_energy_window!UPPER BOUND OF ENERGY WINDOW (eV)
real(8),public::E_UPPER!UPPER BOUND OF ENERGY WINDOW (eV)
integer,public::flg_cRPA 
integer,public::flg_cRPA_band 
integer,public::flg_cRPA_ewin
integer,public::flg_calc_type 
integer,public::file_num_log_start 
integer,public::file_num_chi_start 
integer,public::file_num_eps_start 
integer,public::file_num_chi_base_start 
integer,public::file_num_eps_base_start
!calc_num_k 
integer,public::n_calc_q!total number of calculated q pts
integer,public,allocatable::calc_num_k(:)!calc_num_k(n_calc_q) 
namelist/param_chiqw/N_CALC_BAND,Ecut_for_eps,shift_ef,Max_excitation_energy,& 
Green_func_delt,ttrhdrn_dmna,ttrhdrn_dmnr,MPI_io_rank,MPI_num_proc_per_qcomm,&
MPI_num_qcomm,Num_freq_grid,Lower_bound_energy_window,Upper_bound_energy_window,&
flg_cRPA,flg_calc_type,file_num_log_start,file_num_chi_start,file_num_eps_start,&
file_num_chi_base_start,file_num_eps_base_start,n_calc_q 
contains
subroutine read_input(nproc)  
integer::nproc 
integer::ix 
!--
!default
Ecut_for_eps=0.0d0!1/10 of Ecut_for_psi 
Num_freq_grid=70!log grid 
N_CALC_BAND=0!NTB
SHIFT_EF=0.0d0!eV
MAX_EXCITATION_ENERGY=200.0d0!eV 
GREEN_FUNC_DELT=0.1d0!eV
TTRHDRN_DMNA=0.001d0!eV
TTRHDRN_DMNR=0.001d0!eV
MPI_IO_RANK=0!master
MPI_NUM_QCOMM=0!see below
MPI_NUM_PROC_PER_QCOMM=0!see below
LOWER_BOUND_ENERGY_WINDOW=0.0d0!not active
UPPER_BOUND_ENERGY_WINDOW=0.0d0!not active
FLG_CRPA=0!fRPA
FLG_CALC_TYPE=0!all-q-calc
FILE_NUM_LOG_START=400
FILE_NUM_CHI_START=500
FILE_NUM_EPS_START=600
FILE_NUM_CHI_BASE_START=500000
FILE_NUM_EPS_BASE_START=600000
N_CALC_Q=0
!--
!open(999,file='input.in')
!read(999,nml=param_chiqw)
read(5,nml=param_chiqw)
!--
!default mpi setting
if(MPI_num_qcomm==0)then
 MPI_num_qcomm=1
 MPI_num_proc_per_qcomm=nproc 
endif 
if(MPI_num_qcomm/=0)then
 if(mod(nproc,MPI_num_qcomm)/=0)then 
  write(6,*)'ERROR: mpi setting wrong'
  stop
 endif 
 MPI_num_proc_per_qcomm=nproc/MPI_num_qcomm 
endif 
!--
if(flg_cRPA==0)then
 write(6,*) 
 write(6,*)'========================'
 write(6,*)'THIS CALCULATION IS fRPA'
 write(6,*)'========================'
 write(6,*) 
elseif(flg_cRPA==1)then  
 write(6,*) 
 write(6,*)'========================'
 write(6,*)'THIS CALCULATION IS cRPA'
 write(6,*)'========================'
 write(6,*) 
endif 
!--
if(flg_calc_type==2.and.n_calc_q==0)then!manual mode 
 write(6,*)'ERROR: n_calc_q should not be zero'
 stop
endif 
!--
if(n_calc_q/=0)then!manual mode 
 allocate(calc_num_k(n_calc_q));calc_num_k=0
 !read(999,*)(calc_num_k(ix),ix=1,n_calc_q)
 read(5,*)(calc_num_k(ix),ix=1,n_calc_q)
else
 allocate(calc_num_k(n_calc_q));calc_num_k=0!not use
endif 
!
write(6,nml=param_chiqw) 
delta_ex=Max_excitation_energy 
delt=Green_func_delt 
dmna=ttrhdrn_dmna 
dmnr=ttrhdrn_dmnr  
io_rank=MPI_io_rank 
num_of_mpi_per_comm=MPI_num_proc_per_qcomm 
num_of_comm=MPI_num_qcomm
nen=Num_freq_grid
E_LOWER=Lower_bound_energy_window
E_UPPER=Upper_bound_energy_window
end subroutine
end module

subroutine gen_grid(Nt,E,em)  
implicit none 
real(8),parameter::au=27.21151d0
real(8),parameter::dlt=0.05d0/au!default  
real(8),parameter::ratio=0.1d0!default  
real(8),parameter::eps=1.0d-6!default 
real(8)::alp,x,x1,dl,a,b,c,d,E,f,g  
integer::Nt,N,M,i,k 
complex(8)::em(Nt) 
if(Nt==1)then 
 em(1)=0.0d0 
else
 M=int(ratio*dble(Nt)) 
 N=Nt-M
 alp=E/dlt
 x=1.5d0 
 dl=1.0d0 
 k=0
 do while(dl>eps) 
 f=x**(N-1)-alp*x+alp-1.0d0
 g=dble(N-1)*x**(N-2)-alp 
 x1=x-f/g
 dl=dabs(x1-x)
 k=k+1
 x=x1 
 enddo 
 a=dlt/(x-1.0d0)
 b=log(x)
 do i=1,N
 em(i)=dcmplx(a*exp(b*dble(i-1))-a,0.0d0) 
 enddo 
 !--
 !20180906 
 !c=E*exp(-log(2.0d0)*dble(N)/dble(M)) 
 !d=log(2.0d0)/dble(M) 
 c=E*exp(-log(3.0d0)*dble(N)/dble(M)) 
 d=log(3.0d0)/dble(M) 
 !--
 do i=N+1,N+M 
 em(i)=dcmplx(c*exp(d*dble(i)),0.0d0)  
 enddo 
endif 
return 
end

      PROGRAM MAIN
!--
      use m_rdinput       
      use fft_3d 
      include "config_w3d.h" 
      call read_input 
!--
!OPEN(117,R,FILE='dat.bandcalc') 
      OPEN(117,FILE='./dir-wfn/dat.bandcalc') 
      rewind(117) 
      read(117,*) Ecut_for_psi 
      read(117,*) FermiEnergy  
      read(117,*) Etot
      write(6,*)'Ecut_for_psi=',Ecut_for_psi 
      write(6,*)'FermiEnergy=',FermiEnergy  
      write(6,*)'Etot=',Etot
!--
!OPEN(105,R,FILE='dat.lattice')
      OPEN(105,FILE='./dir-wfn/dat.lattice') 
      REWIND(105)
      READ(105,*) a1(1),a1(2),a1(3)!a1 vector
      READ(105,*) a2(1),a2(2),a2(3)!a2 vector
      READ(105,*) a3(1),a3(2),a3(3)!a3 vector
      write(6,*)'FINISH REDING a1,a2,a3'
      CLOSE(105)
      call OUTER_PRODUCT(a2(1),a3(1),b1(1))
      VOLUME=a1(1)*b1(1)+a1(2)*b1(2)+a1(3)*b1(3)
      b1(:)=b1(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a3(1),a1(1),b2(1))
      b2(:)=b2(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a1(1),a2(1),b3(1))
      b3(:)=b3(:)*tpi/VOLUME 
      write(6,*) 
      write(6,*)'======================'
      write(6,*)'CHECK OF (A_VEC*B_VEC)'
      write(6,*)'======================'
      write(6,*) 
      write(6,*)'a1*b1=',b1(1)*a1(1)+b1(2)*a1(2)+b1(3)*a1(3)
      write(6,*)'a2*b2=',b2(1)*a2(1)+b2(2)*a2(2)+b2(3)*a2(3)
      write(6,*)'a3*b3=',b3(1)*a3(1)+b3(2)*a3(2)+b3(3)*a3(3)
      write(6,*)'VOLUME OF UNIT CELL=',VOLUME  
!--
!OPEN(100,R,FILE='dat.symmetry') 
      OPEN(100,FILE='./dir-wfn/dat.symmetry') 
      rewind(100) 
      read(100,*) nsymq 
      read(100,*) nnp
      allocate(rg(3,3,nsymq));rg=0
      allocate(pg(3,nsymq));pg=0
      allocate(rginv(3,3,nsymq));rginv(:,:,:)=0.0d0 
      do iop=1,nsymq
       read(100,*)((rg(i,j,iop),i=1,3),j=1,3) 
       read(100,*)(pg(i,iop),i=1,3)   
      enddo 
      CLOSE(100) 
      rginv=rg 
      do iop=1,nsymq
      call invmat(3,rginv(1,1,iop)) 
      enddo 
      write(6,*)'finish rg'
!check 
      do iop=1,nsymq
       write(6,*) iop
       do i=1,3
        write(6,'(3I5,1x,3F15.10)')
     +  (rg(i,j,iop),j=1,3),(rginv(i,j,iop),j=1,3)
       enddo 
      enddo 
!do iop=1,nsymq
!do i=1,3
!do j=1,3
!s=0.0d0 
!do k=1,3
!s=s+rg(i,k,iop)*rginv(k,j,iop)
!enddo 
!write(6,*) i,j,s
!enddo 
!enddo 
!enddo 
!--
!OPEN(101,R,FILE='dat.sample-k') 
      OPEN(101,FILE='./dir-wfn/dat.sample-k') 
      rewind(101) 
      read(101,*) Nk_irr 
      allocate(SKI(3,Nk_irr));SKI(:,:)=0.0D0 
      do ik=1,Nk_irr 
       read(101,*)(SKI(i,IK),i=1,3) 
      enddo 
      close(101) 
      write(6,*)'finish ski'
!20170327 
      !call est_NTK(NK_irr,SKI(1,1),NTK,nkb1,nkb2,nkb3)  
      !write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      !Na1=nkb1/2;Na2=nkb2/2;Na3=nkb3/2
      !write(6,'(a24,3i10)')'Na1,Na2,Na3=',Na1,Na2,Na3 
!--
!OPEN(132,R,FILE='dat.nkm')20170419  
      OPEN(132,FILE='./dir-wfn/dat.nkm') 
      allocate(NGI(Nk_irr));NGI(:)=0
!     allocate(NBI(Nk_irr));NBI(:)=0!20170419
      rewind(132)
      do ik=1,Nk_irr 
       read(132,*) NGI(ik)!,NBI(ik)!20170419
      enddo 
      close(132) 
      NTG=maxval(abs(NGI(:))) 
!     NTB=maxval(abs(NBI(:)))!20170419  
      write(6,'(a10,i10)')'NTG=',NTG  
!     write(6,'(a10,i10)')'NTB=',NTB!20170419
!--
!OPEN(104,R,FILE='dat.kg') 
      OPEN(104,FILE='./dir-wfn/dat.kg') 
      rewind(104) 
      allocate(KGI(3,NTG,Nk_irr));KGI(:,:,:)=0 
      do ik=1,Nk_irr 
       read(104,*) NG_for_psi 
       NGI(IK)=NG_for_psi 
       do ig=1,NG_for_psi 
        read(104,*)(KGI(i,ig,ik),i=1,3) 
       enddo 
      enddo  
      close(104)
      write(6,*)'finish kgi'
!--
      allocate(LKGI(NTG,Nk_irr));LKGI=0.0d0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
       ktmp(1)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(1)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(1) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(1) 

       ktmp(2)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(2)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(2) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(2) 

       ktmp(3)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(3)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(3) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(3) 
       LKGI(ig,ik)=ktmp(1)**2+ktmp(2)**2+ktmp(3)**2
       enddo!ig 
       write(6,*) maxval(LKGI(:,ik))
      enddo!ik 
      write(6,*) 
      write(6,*) maxval(LKGI(:,:))
      Ecut_for_psi=maxval(LKGI(:,:))+1.0d-8
      write(6,*)'Ecut_for_psi=',Ecut_for_psi 
!--
      L1=maxval(abs(KGI(1,:,:)))+1;write(6,*)'L1=',L1 
      L2=maxval(abs(KGI(2,:,:)))+1;write(6,*)'L2=',L2 
      L3=maxval(abs(KGI(3,:,:)))+1;write(6,*)'L3=',L3 
      allocate(packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr))   
      packing(:,:,:,:)=0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
        i1=KGI(1,ig,ik);j1=KGI(2,ig,ik);k1=KGI(3,ig,ik) 
        packing(i1,j1,k1,ik)=ig 
       enddo 
      enddo 
!--
!fft grid
      !20180309 
      !m1=maxval(abs(KGI(1,:,:))) 
      !m2=maxval(abs(KGI(2,:,:))) 
      !m3=maxval(abs(KGI(3,:,:))) 
      !nwx2=algn235(2*m1) 
      !nwy2=algn235(2*m2) 
      !nwz2=algn235(2*m3) 
      !
      htmp=dsqrt(dot_product(a1,a1))
      h1(:)=a1(:)/htmp 
      htmp=dsqrt(dot_product(a2,a2))
      h2(:)=a2(:)/htmp 
      htmp=dsqrt(dot_product(a3,a3)) 
      h3(:)=a3(:)/htmp 
      d1=abs(dot_product(b1,h1)) 
      d2=abs(dot_product(b2,h2)) 
      d3=abs(dot_product(b3,h3)) 
      qwf=2.0d0*dsqrt(Ecut_for_psi) 
      !
      !nwx2=algn235(int(qwf/d1)+1,1) 
      !nwy2=algn235(int(qwf/d2)+1,1) 
      !nwz2=algn235(int(qwf/d3)+1,1) 
      !
      nwx2=algn235(int(qwf/d1)+1)!20180412 by Y.Nomura 
      nwy2=algn235(int(qwf/d2)+1)!20180412 by Y.Nomura 
      nwz2=algn235(int(qwf/d3)+1)!20180412 by Y.Nomura 
      !
      nfft1=nwx2+1
      nfft2=nwy2+1
      nfft3=nwz2+1
      Nl123=nfft1*nfft2*nfft3 
      write(6,*)'nwx2=',nwx2 
      write(6,*)'nwy2=',nwy2 
      write(6,*)'nwz2=',nwz2 
      write(6,*)'nfft1=',nfft1 
      write(6,*)'nfft2=',nfft2 
      write(6,*)'nfft3=',nfft3 
      write(6,*)'NL123=',Nl123  
      call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
!--
!20180302  
      call est_NTK(Nk_irr,Nsymq,SKI(1,1),rg(1,1,1),NTK)
      write(6,*)'Estimated NTK=',NTK 
!--
!gen(SK0,numirr,numrot,trs,RW) 
      allocate(SK0(3,NTK));SK0(:,:)=0.0d0
      allocate(numirr(NTK));numirr(:)=0
      allocate(numrot(NTK));numrot(:)=0
      allocate(trs(NTK));trs(:)=0
      allocate(RW(3,NTK));RW(:,:)=0
!20161207 
!      do ik=1,Nk_irr 
!       SK0(:,ik)=SKI(:,ik) 
!       numirr(ik)=ik;numrot(ik)=1;trs(ik)=1;RW(1:3,ik)=0
!      enddo 
!      jk=Nk_irr 
!--
      jk=0
      do ik=1,Nk_irr
      do iop=1,Nsymq
!sym
       ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)
     +        +rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)
     +        +rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik)
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)
     +        +rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik)
       call kcheck(ktmp(1),RWtmp(1))!rewind check 
       do iik=1,jk
        if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and. 
     +     abs(SK0(2,iik)-ktmp(2))<1.0d-4.and. 
     +     abs(SK0(3,iik)-ktmp(3))<1.0d-4)goto 1000
       enddo!iik
       jk=jk+1
       SK0(:,jk)=ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=1;RW(:,jk)=RWtmp(:)
!time-reversal
1000   ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)
     +        +rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)
     +        +rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik) 
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)
     +        +rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik) 
       call kcheck_trs(ktmp(1),RWtmp(1))!rewind check 20170321 
       do iik=1,jk
        if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and. 
     +     abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and. 
     +     abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4)goto 2000
       enddo!iik
       jk=jk+1
       SK0(:,jk)=-ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=-1;RW(:,jk)=RWtmp(:)
2000  enddo 
      enddo 
!--
      if(NTK/=jk)then 
       write(6,*)'ERROR;STOP;NTK should be jk'   
       write(6,*)'NTK=',NTK,'jk=',jk;STOP
      endif 
!--   
       write(6,*) 
       write(6,*)'====='
       write(6,*)' SK0 '
       write(6,*)'====='
       write(6,*) 
       do ik=1,NTK
        write(6,'(I5,3F12.5)') ik,SK0(:,ik) 
       enddo 
!--
      call est_nkbi(NTK,SK0(1,1),nkb1,nkb2,nkb3)  
      write(6,*) 
      write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      Na1=nkb1/2;Na2=nkb2/2;Na3=nkb3/2
      write(6,'(a24,3i10)')'Na1,Na2,Na3=',Na1,Na2,Na3 
!--
!gen(NG0,KG0) 
      allocate(KGtmp(3,NTG));KGtmp(:,:)=0 
      allocate(KG0(3,NTG,NTK));KG0(:,:,:)=0 
      allocate(NG0(NTK));NG0(:)=0
!20161207 
!      do jk=1,Nk_irr 
!       NG0(jk)=NGI(jk);KG0(:,:,jk)=KGI(:,:,jk)
!      enddo 
!      do jk=Nk_irr+1,NTK 
!--
      do jk=1,NTK 
       if(trs(jk)==1)then 
        ik=numirr(jk);iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)
     +         +rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)
     +         +rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)
     +         +rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KG0(1,1,jk),NG_for_psi)
        if(NG_for_psi/=NGI(ik))then 
         write(6,*)'ERROR;STOP;NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
       elseif(trs(jk)==-1)then  
        ik=numirr(jk); iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)
     +         +rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)
     +         +rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)
     +         +rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        KGtmp(:,:)=0 
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KGtmp(1,1),NG_for_psi)
        if(NG_for_psi/=NGI(ik))then 
         write(6,*)'ERROR;STOP;NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
        KG0(:,:,jk)=-KGtmp(:,:) 
       endif 
      enddo 
!--
      write(6,*) 
      write(6,*)'====='
      write(6,*)' NG0 '
      write(6,*)'====='
      write(6,*) 
      do ik=1,NTK 
       write(6,'(1I10)') NG0(ik) 
      enddo 
!--
!OPEN(113,R,FILE='dat.wan',FORM='unformatted') 
      OPEN(113,FILE='./dir-wan/dat.wan',FORM='unformatted') 
      REWIND(113)       
      read(113) NWF 
      allocate(C0(NTG,NWF,NTK));C0(:,:,:)=0.0D0 
      do ik=1,NTK
       read(113)((C0(ig,iw,ik),ig=1,NG0(ik)),iw=1,NWF)           
       !
       !20180519 
       !do iw=1,NWF
       ! read(113)(C0(ig,iw,ik),ig=1,NG0(ik))
       !enddo!iw
       !
      enddo!ik
      write(6,*)'FINISH REDING C0'
      CLOSE(113)  
!--
!      do ik=1,Nk_irr 
!       do iw=1,NWF
!        do jw=1,NWF 
!         SUM_CMPX=0.0d0 
!         do ig=1,NG0(ik) 
!          SUM_CMPX=SUM_CMPX+CONJG(C0(ig,iw,ik))*C0(ig,jw,ik) 
!         enddo 
!         write(6,'(3i5,x,2f15.10)') ik,iw,jw,SUM_CMPX 
!        enddo 
!       enddo 
!      enddo 
!--
!OPEN(134,R,FILE='dat.wan-center') 
      OPEN(134,FILE='./dir-wan/dat.wan-center') 
      allocate(coord(3,NWF));coord(:,:)=0.0d0    
      rewind(134)
      read(134,'(a)') dum_char
      read(134,'(a)') dum_char
      do iw=1,NWF
       read(134,*)(coord(i,iw),i=1,3) 
      enddo 
!--
!OPEN(127,R,FILE='dat.sample-q')
!      OPEN(127,FILE='./dir-wfn/dat.sample-q')
!      Nq_irr=Nk_irr 
!      allocate(SQR(3,Nq_irr));SQR(:,:)=0.0D0 
!      rewind(127) 
!      read(127,*) idum 
!      do iq=1,Nq_irr 
!       read(127,*)(SQR(i,iq),i=1,3) 
!      enddo 
!      write(6,*)'FINISH REDING SQR'
!      CLOSE(127) 
!20161207 
!shift[-1/2:1/2]  
!      allocate(SQI(3,Nq_irr));SQI(:,:)=0.0D0 
!      do iq=1,Nq_irr
!       call search_q(SQR(1,iq),SQI(1,iq)) 
!      enddo  
!      write(6,*) 
!      write(6,*)'====================='
!      write(6,*)'shifted SQ (SQR->SQI)'
!      write(6,*)'====================='
!      write(6,*) 
!      do iq=1,Nq_irr 
!       write(6,'(a10,3f10.5,2x,3f10.5)')'SQR->SQI',SQR(:,iq),SQI(:,iq) 
!      enddo 
!--
!OPEN(300,R,FILE='dat.chi_cutoff')!20170402  
       OPEN(300,FILE='./dir-eps/dat.chi_cutoff')!20170402 
       read(300,*) Ecut_for_eps!20170402  
!--
!OPEN(135,R,FILE='W-grid') 
      OPEN(135,FILE='./dir-eps/dat.wgrid') 
      rewind(135) 
      read(135,*) Num_freq_grid!20170402
      ne=Num_freq_grid!20170402
      allocate(em(ne));em(:)=0.0d0 
      do ie=1,ne 
       !read(135,*) em(ie) 
        read(135,'(2f15.10)') em(ie)!20171212
      enddo 
!--
!OPEN(400,R,FILE='dat.log.400')!20170420  
!OPEN(301,R,FILE='dat.sq')!20170420   
      Nq_irr=Nk_irr 
      allocate(SQI(3,Nq_irr));SQI(:,:)=0.0D0 
      ierr=CHDIR("./dir-eps") 
      do iq=1,Nq_irr 
       write(dirname,"('q',i3.3)")iq 
       ierr=CHDIR(dirname) 
       inquire(file='dat.log.400',exist=file_e) 
       if(file_e)then 
        write(6,*)'dat.log.400 exists in ',trim(dirname) 
       else
        write(6,*)'error: no dat.log.400 in ',trim(dirname) 
       endif 
       OPEN(301,FILE='dat.sq') 
       rewind(301)
       inquire(file='dat.sq',exist=file_e) 
       if(file_e)then 
        read(301,*)(SQI(i,iq),i=1,3) 
       else
        write(6,*)'error: no dat.sq in',trim(dirname) 
       endif 
       close(301) 
       ierr=CHDIR("..") 
      enddo!iq 
      ierr=CHDIR("..") 
      call system('pwd') 
!--
!gen(SQ,numirrq,numrotq,trsq,RWq) 
      NTQ=NTK!TOTAL NUMBER OF Q POINTS 
      allocate(SQ(3,NTQ));SQ(:,:)=0.0d0 
      allocate(numirrq(NTQ));numirrq(:)=0 
      allocate(numrotq(NTQ));numrotq(:)=0 
      allocate(trsq(NTQ));trsq(:)=0
      allocate(RWq(3,NTQ));RWq(:,:)=0      
!--
      do iq=1,Nq_irr 
       SQ(:,iq)=SQI(:,iq) 
       numirrq(iq)=iq;numrotq(iq)=1;trsq(iq)=1;RWq(1:3,iq)=0
      enddo 
      jk=Nq_irr 
      do iq=1,Nq_irr
      do iop=1,Nsymq
!sym
       ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SQI(1,iq)
     +        +rg(1,2,iop)*SQI(2,iq)
     +        +rg(1,3,iop)*SQI(3,iq)
       ktmp(2)=rg(2,1,iop)*SQI(1,iq)
     +        +rg(2,2,iop)*SQI(2,iq)
     +        +rg(2,3,iop)*SQI(3,iq)
       ktmp(3)=rg(3,1,iop)*SQI(1,iq)
     +        +rg(3,2,iop)*SQI(2,iq)
     +        +rg(3,3,iop)*SQI(3,iq)
       call kcheck(ktmp(1),RWtmp(1))!rewind check 
       do iik=1,jk 
        if(abs(SQ(1,iik)-ktmp(1))<1.0d-4.and. 
     +     abs(SQ(2,iik)-ktmp(2))<1.0d-4.and. 
     +     abs(SQ(3,iik)-ktmp(3))<1.0d-4)goto 1100
       enddo!iik
       jk=jk+1
       SQ(:,jk)=ktmp(:)
       numirrq(jk)=iq;numrotq(jk)=iop;trsq(jk)=1;RWq(:,jk)=RWtmp(:)
!time-reversal
1100   ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SQI(1,iq)
     +        +rg(1,2,iop)*SQI(2,iq)
     +        +rg(1,3,iop)*SQI(3,iq)
       ktmp(2)=rg(2,1,iop)*SQI(1,iq)
     +        +rg(2,2,iop)*SQI(2,iq)
     +        +rg(2,3,iop)*SQI(3,iq) 
       ktmp(3)=rg(3,1,iop)*SQI(1,iq)
     +        +rg(3,2,iop)*SQI(2,iq)
     +        +rg(3,3,iop)*SQI(3,iq) 
       call kcheck_trs(ktmp(1),RWtmp(1))!rewind check 20170321 
       do iik=1,jk
        if(abs(SQ(1,iik)-(-ktmp(1)))<1.0d-4.and. 
     +     abs(SQ(2,iik)-(-ktmp(2)))<1.0d-4.and. 
     +     abs(SQ(3,iik)-(-ktmp(3)))<1.0d-4)goto 2100
       enddo!iik
       jk=jk+1
       SQ(:,jk)=-ktmp(:)
       numirrq(jk)=iq;numrotq(jk)=iop;trsq(jk)=-1;RWq(:,jk)=RWtmp(:)
2100  enddo 
      enddo 
!--
      if(NTQ/=jk)then 
       write(6,*)'ERROR;STOP;NTQ should be jk'   
       write(6,*)'NTQ=',NTQ,'jk=',jk;STOP
      endif 
!--
      write(6,*) 
      write(6,*)'============'
      write(6,*)' SQ and SK0 '
      write(6,*)'============'
      write(6,*) 
      do iq=1,NTQ 
       ik=iq
       write(6,'(I5,3F10.5,2x,3F10.5)') iq,SQ(:,iq),SK0(:,ik) 
      enddo 
      write(6,*) 
!--
!      do iq=1,NTQ 
!       write(6,'(i7,x,i7,x,i7,x,i7,x,3i5)')
!     + iq,numirrq(iq),numrotq(iq),trsq(iq),RWq(:,iq) 
!      enddo 
!      write(6,*) 
!--
!gen(NGQ_eps,NGQ_psi,LG0)
      allocate(LG0(3,NTG,NTQ));LG0(:,:,:)=0
      allocate(NGQ_eps(NTQ));NGQ_eps(:)=0
      allocate(NGQ_psi(NTQ));NGQ_psi(:)=0
!--
      do iq=1,Nq_irr 
       q1=SQI(1,iq);q2=SQI(2,iq);q3=SQI(3,iq)
       call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +      Ecut_for_psi,q1,q2,q3,LG0(1,1,iq),NG_for_eps,NG_for_psi) 
       NGQ_eps(iq)=NG_for_eps;NGQ_psi(iq)=NG_for_psi  
       write(6,'(i8,3f10.5,a8,i8,a8,i10)') 
     + iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
      enddo 
      do iq=Nq_irr+1,NTQ 
       if(trsq(iq)==1)then 
        iqir=numirrq(iq);iop=numrotq(iq) 
        q1=rg(1,1,iop)*SQI(1,iqir)
     +    +rg(1,2,iop)*SQI(2,iqir)
     +    +rg(1,3,iop)*SQI(3,iqir)+dble(RWq(1,iq)) 
        q2=rg(2,1,iop)*SQI(1,iqir)
     +    +rg(2,2,iop)*SQI(2,iqir)
     +    +rg(2,3,iop)*SQI(3,iqir)+dble(RWq(2,iq))  
        q3=rg(3,1,iop)*SQI(1,iqir)
     +    +rg(3,2,iop)*SQI(2,iqir)
     +    +rg(3,3,iop)*SQI(3,iqir)+dble(RWq(3,iq))  
        call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +       Ecut_for_psi,q1,q2,q3,LG0(1,1,iq),NG_for_eps,NG_for_psi) 
        NGQ_eps(iq)=NG_for_eps;NGQ_psi(iq)=NG_for_psi  
        write(6,'(i8,3f10.5,a8,i8,a8,i10)') 
     +  iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
       elseif(trsq(iq)==-1)then  
        iqir=numirrq(iq);iop=numrotq(iq) 
        q1=rg(1,1,iop)*SQI(1,iqir)
     +    +rg(1,2,iop)*SQI(2,iqir)
     +    +rg(1,3,iop)*SQI(3,iqir)+dble(RWq(1,iq)) 
        q2=rg(2,1,iop)*SQI(1,iqir)
     +    +rg(2,2,iop)*SQI(2,iqir)
     +    +rg(2,3,iop)*SQI(3,iqir)+dble(RWq(2,iq))  
        q3=rg(3,1,iop)*SQI(1,iqir)
     +    +rg(3,2,iop)*SQI(2,iqir)
     +    +rg(3,3,iop)*SQI(3,iqir)+dble(RWq(3,iq))  
        KGtmp(:,:)=0 
        call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +       Ecut_for_psi,q1,q2,q3,KGtmp(1,1),NG_for_eps,NG_for_psi) 
        NGQ_eps(iq)=NG_for_eps;NGQ_psi(iq)=NG_for_psi  
        write(6,'(i8,3f10.5,a8,i8,a8,i10)') 
     +  iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
        LG0(:,:,iq)=-KGtmp(:,:) 
       endif 
      enddo 
!--
      Lq1=maxval(abs(LG0(1,:,:)))+1;write(6,*)'Lq1=',Lq1 
      Lq2=maxval(abs(LG0(2,:,:)))+1;write(6,*)'Lq2=',Lq2 
      Lq3=maxval(abs(LG0(3,:,:)))+1;write(6,*)'Lq3=',Lq3 
      allocate(packingq(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3,Nq_irr))   
      packingq(:,:,:,:)=0 
      do iq=1,Nq_irr 
       do ig=1,NGQ_eps(iq) 
        i1=LG0(1,ig,iq);j1=LG0(2,ig,iq);k1=LG0(3,ig,iq) 
        packingq(i1,j1,k1,iq)=ig 
        write(6,'(a,5i10)')'iq,ig,i1,j1,k1',iq,ig,i1,j1,k1
       enddo 
      enddo 
!
      write(6,*) 
      do iq=1,NTQ 
       write(6,'(i5,3f15.10,6i5)')iq,(SQ(i1,iq),i1=1,3),
     + numirrq(iq),numrotq(iq),trsq(iq),(RWq(j1,iq),j1=1,3)
      enddo  
!-- 
      NTGQ=maxval(NGQ_eps(:))!TOTAL NUMBER OF G VECTORS FOR EPSILON
      write(6,*)'NTGQ=',NTGQ  
!--
!OPEN(600-,R,FILE='DATA_EPSILON_fRPA',FORM='unformatted') 
      allocate(epstmp(NTGQ,NTGQ,ne));epstmp(:,:,:)=0.0D0!real8
      allocate(epstmpgm(NTGQ,NTGQ,ne,3));epstmpgm(:,:,:,:)=0.0D0!real8
      allocate(epsirr(NTGQ,NTGQ,ne,Nq_irr));epsirr(:,:,:,:)=0.0D0!real4 
!--
      ierr=CHDIR("./dir-eps") 
      call system('pwd') 
      do iq=1,Nq_irr 
       if(abs(SKI(1,iq))<1.0d-5.and.abs(SKI(2,iq))<1.0d-5.and.
     +    abs(SKI(3,iq))<1.0d-5)then 
        write(dirname,"('q',i3.3)")iq
        iqgm=iq 
        ierr=CHDIR(dirname) 
        do ix=1,3 
         file_num=600+(ix-1)  
         write(filename,'("dat.epsqw.",i3.3)')file_num 
         open(file_num,file=filename,form='unformatted') 
         write(6,'(a10,a15,a5,a10)') 
     +   'read: ',trim(filename),'in ',trim(dirname)  
         rewind(file_num) 
         NG_for_eps=NGQ_eps(iq)
         read(file_num)(((epstmpgm(ig,jg,ie,ix),ig=1,NG_for_eps)
     +                          ,jg=1,NG_for_eps),ie=1,ne)
        enddo!ix 
        epsirr(:,:,:,iq)!epsirr:real4,epstmp:real8 
     + =(epstmpgm(:,:,:,1)+epstmpgm(:,:,:,2)+epstmpgm(:,:,:,3))/3.0d0
       else
        write(dirname,"('q',i3.3)")iq
        ierr=CHDIR(dirname) 
        file_num=600 
        write(filename,'("dat.epsqw.",i3.3)')file_num 
        open(file_num,file=filename,form='unformatted') 
        write(6,'(a10,a15,a5,a10)') 
     +  'read: ',trim(filename),'in ',trim(dirname)  
        rewind(file_num) 
        NG_for_eps=NGQ_eps(iq)
        read(file_num)(((epstmp(ig,jg,ie),ig=1,NG_for_eps)
     +                         ,jg=1,NG_for_eps),ie=1,ne)
        epsirr(:,:,:,iq)=epstmp(:,:,:)!epsirr:real4,epstmp:real8 
       endif!q=0 or not 
       ierr=CHDIR("..") 
      enddo!iq   
      ierr=CHDIR("..") 
      call system('pwd') 
!--
!      do iq=1,Nq_irr 
!       NG_for_eps=NGQ_eps(iq)
!       write(6,*) NG_for_eps 
!       do ig=1,NG_for_eps 
!        write(6,*) epsirr(ig,ig,100,iq) 
!       enddo  
!      enddo  
!--
      WRITE(6,*) 
      WRITE(6,*)'====================================='
      WRITE(6,*)'=== INTERACTION CALCULATION START ==='
      WRITE(6,*)'====================================='
      WRITE(6,*) 
!--
!make rho(G,iw,q/=0)  
      allocate(rho(NTG,NWF,NTQ));rho(:,:,:)=0.0D0 
      do iq=1,NTQ 
       q1=SQ(1,iq);q2=SQ(2,iq);q3=SQ(3,iq)
       if(q1.ne.0.0d0.or.q2.ne.0.0d0.or.q3.ne.0.0d0) then 
        NG_for_eps=NGQ_eps(iq)
        NG_for_psi=NGQ_psi(iq)
        allocate(length_qg(NG_for_psi));length_qg(:)=0.0D0 
        do igL=1,NG_for_psi   
         igL1=LG0(1,igL,iq)
         igL2=LG0(2,igL,iq)
         igL3=LG0(3,igL,iq)
         qgL(:)=(q1+dble(igL1))*b1(:)
     +         +(q2+dble(igL2))*b2(:)
     +         +(q3+dble(igL3))*b3(:)
         qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
         qgL1=dsqrt(qgL2) 
         length_qg(igL)=qgL1
        enddo 
!$OMP PARALLEL PRIVATE(ik,iw,igL,shift_G,ikq,C0_K,C0_KQ,
!$OMP&  fftwk,wfunc,rho_tmp,prho)
        allocate(prho(NTG,NWF));prho(:,:)=0.0D0 
        allocate(fftwk(Nl123*2));fftwk(:)=0.0d0  
        allocate(wfunc(Nl123*2));wfunc(:)=0.0d0 
        allocate(rho_tmp(NG_for_psi));rho_tmp(:)=0.0D0 
        allocate(C0_K(NTG));C0_K(:)=0.0d0     
        allocate(C0_KQ(NTG));C0_KQ(:)=0.0d0  
!$OMP DO 
        do ik=1,NTK 
         do iw=1,NWF 
          shift_G(:)=0
          call search_kq(NTK,SK0(1,1),q1,q2,q3,ik,ikq,shift_G(1))
          C0_K(:)=C0(:,iw,ik) 
          C0_KQ(:)=C0(:,iw,ikq) 
          rho_tmp(:)=0.0D0 
          call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),
     +     C0_K(1),C0_KQ(1),ik,ikq,nwx2,nwy2,nwz2,
     +     nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,
     +     LG0(1,1,iq),NG_for_psi,shift_G(1),rho_tmp(1))
          do igL=1,NG_for_psi  
           prho(igL,iw)=prho(igL,iw)+rho_tmp(igL)
          enddo!igL
         enddo!iw  
        enddo!ik 
!$OMP END DO 
!$OMP CRITICAL 
        rho(:,:,iq)=rho(:,:,iq)+prho(:,:) 
!$OMP END CRITICAL 
        deallocate(prho,fftwk,wfunc,rho_tmp,C0_K,C0_KQ) 
!$OMP END PARALLEL 
        do iw=1,NWF
         do igL=1,NG_for_psi 
          rho(igL,iw,iq)=rho(igL,iw,iq)/length_qg(igL)
         enddo!igL
        enddo!iw 
        deallocate(length_qg)
        write(6,'(a10,x,2i5)')'FINISH iq',iq
!--
!gen rho(G,iw,q=0); iq=NTQ 
       elseif(q1==0.0d0.and.q2==0.0d0.and.q3==0.0d0)then 
        write(6,'(a,x,3f10.5)')'q1,q2,q3',q1,q2,q3 
        NG_for_eps=NGQ_eps(iq);NG_for_psi=NGQ_psi(iq)
        allocate(length_qg(NG_for_psi));length_qg(:)=0.0d0 
        do igL=1,NG_for_psi  
         igL1=LG0(1,igL,iq)
         igL2=LG0(2,igL,iq)
         igL3=LG0(3,igL,iq)
         if(igL1==0.and.igL2==0.and.igL3==0)then 
          NoG0=igL  
         else
          qgL(:)=(q1+dble(igL1))*b1(:)
     +          +(q2+dble(igL2))*b2(:)
     +          +(q3+dble(igL3))*b3(:)
          qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
          qgL1=dsqrt(qgL2) 
          length_qg(igL)=qgL1
         endif  
        enddo 
!$OMP PARALLEL PRIVATE(ik,iw,igL,shift_G,ikq,C0_K,C0_KQ,
!$OMP&  fftwk,wfunc,rho_tmp,prho)
        allocate(prho(NTG,NWF));prho(:,:)=0.0D0 
        allocate(fftwk(Nl123*2));fftwk(:)=0.0d0  
        allocate(wfunc(Nl123*2));wfunc(:)=0.0d0 
        allocate(rho_tmp(NG_for_psi));rho_tmp(:)=0.0D0 
        allocate(C0_K(NTG));C0_K(:)=0.0d0     
        allocate(C0_KQ(NTG));C0_KQ(:)=0.0d0  
!$OMP DO 
        do ik=1,NTK 
         do iw=1,NWF 
          ikq=ik 
          shift_G(:)=0 
          C0_K(:)=C0(:,iw,ik) 
          C0_KQ(:)=C0(:,iw,ikq) 
          rho_tmp(:)=0.0D0 
          call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),
     +     C0_K(1),C0_KQ(1),ik,ikq,nwx2,nwy2,nwz2,
     +     nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,
     +     LG0(1,1,iq),NG_for_psi,shift_G(1),rho_tmp(1))
          rho_tmp(NoG0)=0.0d0!rho=0.0 is correct 
          do igL=1,NG_for_psi  
           prho(igL,iw)=prho(igL,iw)+rho_tmp(igL)
          enddo!igL
         enddo!iw 
        enddo!ik  
!$OMP END DO 
!$OMP CRITICAL 
        rho(:,:,iq)=rho(:,:,iq)+prho(:,:) 
!$OMP END CRITICAL 
        deallocate(prho,fftwk,wfunc,rho_tmp,C0_K,C0_KQ) 
!$OMP END PARALLEL 
        do iw=1,NWF 
         do igL=1,NG_for_psi  
          if(igL/=NoG0)then 
           rho(igL,iw,iq)=rho(igL,iw,iq)/length_qg(igL)
          endif 
         enddo!igL 
        enddo!iw
        deallocate(length_qg)
        write(6,'(a10,x,2i5)')'FINISH iq',iq
       endif 
      enddo!iq 
      rho(:,:,:)=rho(:,:,:)/dble(NTK)
!--
!     do iq=1,NTQ
!      do iw=1,NWF 
!       do ig=1,NGQ_psi(iq) 
!        write(6,'(i5,2f15.10)') ig,rho(ig,iw,iq) 
!       enddo 
!      enddo 
!     enddo 
!     stop 
!--
!CORRECTION TERM TO DIVERGENCE 
!      ie=calc_ifreq          
!      write(6,*)'ie=',ie 
!--
       write(6,*)'HybertsenLouie'!Louie 
       write(6,*)'NoG0=',NoG0
       write(6,*)'iqgm=',iqgm 
       qsz=(6.0D0*(pi**2)/dble(NTQ)/dble(VOLUME))**(1.0D0/3.0D0)  
       write(6,*)'qsz=',qsz
       write(6,*)'2*qsz/pi=',(2.0d0/pi)*qsz
       chead=(2.0D0/pi)*qsz 
       write(6,*)'chead(HL) in eV=',chead*au    
       allocate(cheadw(ne));cheadw(:)=0.0d0 
       do iw=1,ne 
        cheadw(iw)=(2.0D0/pi)*epsirr(NoG0,NoG0,iw,iqgm)*qsz 
        write(6,*)'cheadw(HL) in eV=',cheadw(iw)*au   
        write(6,*)'1/eps=',epsirr(NoG0,NoG0,iw,Nq_irr)
       enddo 
!      endif 
!--
!wing 
!      allocate(cwing(NWF,NWF));cwing(:,:)=0.0D0 
!      allocate(wL(NWF));wL(:)=0.0D0 
!      allocate(wR(NWF));wR(:)=0.0D0 
!      do iw=1,NWF 
!       SUM_CMPX_1=0.0D0 
!       SUM_CMPX_2=0.0D0 
!       do igL=1,NGQ_eps(Nq_irr) 
!        if(igL/=NoG0) then 
!         SUM_CMPX_1
!     +  =SUM_CMPX_1
!     +  +rho(igL,iw,Nq_irr) 
!     +  *epsirr(igL,NoG0,ie,Nq_irr) 
!         SUM_CMPX_2
!     +  =SUM_CMPX_2
!     +  +CONJG(rho(igL,iw,Nq_irr))
!     +  *epsirr(NoG0,igL,ie,Nq_irr) 
!        Endif 
!       enddo 
!       wL(iw)=SUM_CMPX_1
!       wR(iw)=SUM_CMPX_2 
!      enddo 
!      do iw=1,NWF
!       write(6,'(4f15.10)') wL(iw),wR(iw)
!      enddo 
!      do iw=1,NWF
!       do jw=1,NWF 
!        cwing(iw,jw)=(qsz**2)*(wL(iw)+wR(jw))/pi 
!        write(6,'(a20,2f15.10)') 'cwing(eV)=',cwing(iw,jw)*au     
!       enddo 
!      enddo 
!      deallocate(cwing,wL,wR) 
!-- 
!make func(\mu,\nu,q)  
!--
       allocate(func(NWF,NWF,NTQ));func(:,:,:)=0.0D0
       do iq=1,NTQ
        do iw=1,NWF
         do jw=1,NWF
          SUM_CMPX=0.0D0
          do igL=1,NGQ_psi(iq)
           SUM_CMPX
     +    =SUM_CMPX
     +    +rho(igL,iw,iq)
     +    *CONJG(rho(igL,jw,iq))
          enddo 
          func(iw,jw,iq)=SUM_CMPX 
         enddo 
        enddo 
        write(6,'(a,x,i5)')'FINISH iq',iq
       enddo!iq 
       allocate(funcw(NWF,NWF,ne,NTQ));funcw(:,:,:,:)=0.0D0
       do iq=1,NTQ
        allocate(epsmk(NTGQ,NTGQ,ne))
        allocate(packtmp(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3)) 
        epsmk(:,:,:)=0.0d0 
        iqir=numirrq(iq)
        iop=numrotq(iq)
        packtmp(:,:,:)=packingq(:,:,:,iqir) 
        call make_eps(NTG,NTGQ,ne,trsq(iq),NGQ_eps(iq),LG0(1,1,iq), 
     +  RWq(1,iq),rginv(1,1,iop),pg(1,iop),nnp,Lq1,Lq2,Lq3,
     +  packtmp(-Lq1,-Lq2,-Lq3),epsirr(1,1,1,iqir),epsmk(1,1,1)) 
!--
!        if(iq.eq.xxx)then 
!         write(6,'(a5,3f15.10)')'SQ',SQ(1,iq),SQ(2,iq),SQ(3,iq)
!         write(6,'(a5,i10)')'iqir',iqir 
!         write(6,'(a5,i10)')'trsq',trsq(iq) 
!         write(6,'(a5,3i10)')'RWq',RWq(1,iq),RWq(2,iq),RWq(3,iq)
!         write(6,'(a5)')'epsirr' 
!         do ie=1,ne 
!          do igL=1,NGQ_eps(iqir)
!           do jgL=1,NGQ_eps(iqir) 
!            write(6,'(i5,i5,2f15.8)')igL,jgL,epsirr(igL,jgL,ie,iqir)
!           enddo
!          enddo 
!         enddo 
!         write(6,'(a5)')'epsmk' 
!         do ie=1,ne 
!          do igL=1,NGQ_eps(iq)
!           do jgL=1,NGQ_eps(iq) 
!            write(6,'(i5,i5,2f15.8)')igL,jgL,epsmk(igL,jgL,ie)
!           enddo
!          enddo 
!         enddo 
!        endif 
!$OMP PARALLEL PRIVATE(ie,iw,jw,SUM_CMPX,igL,jgL)
!$OMP DO 
        do ie=1,ne 
         do iw=1,NWF
          do jw=1,NWF
           SUM_CMPX=0.0D0
           do igL=1,NGQ_eps(iq)
            do jgL=1,NGQ_eps(iq) 
              SUM_CMPX
     +       =SUM_CMPX
     +       +rho(igL,iw,iq)
     +       *epsmk(igL,jgL,ie)
     +       *CONJG(rho(jgL,jw,iq))
            enddo 
           enddo 
           do igL=NGQ_eps(iq)+1,NGQ_psi(iq)
             SUM_CMPX
     +      =SUM_CMPX
     +      +rho(igL,iw,iq)
     +      *CONJG(rho(igL,jw,iq))
           enddo 
           funcw(iw,jw,ie,iq)=SUM_CMPX 
          enddo!jw 
         enddo!iw
        enddo!ie 
!$OMP END DO 
!$OMP END PARALLEL 
        deallocate(epsmk,packtmp)  
        write(6,'(a,x,i5)')'FINISH iq',iq
       enddo!iq 
!--
!write func  
!      write(6,*) 
!      write(6,*)'----'
!      write(6,*)'func'
!      write(6,*)'----'
!      write(6,*) 
!      Do iq=1,NTQ
!       write(6,*) SQ(1,iq),SQ(2,iq),SQ(3,iq) 
!       Do iw=1,NWF
!        write(6,'(100F12.5)')(func(iw,jw,iq),jw=1,NWF)
!       ENDDO      
!       write(6,*) 
!      ENDDO      
!write funcw  
!      write(6,*) 
!      write(6,*)'-----'
!      write(6,*)'funcw'
!      write(6,*)'-----'
!      write(6,*) 
!      do iq=1,NTQ
!       write(6,*) SQ(1,iq),SQ(2,iq),SQ(3,iq) 
!       do iw=1,NWF
!        write(6,'(100F12.5)')(funcw(iw,jw,1,iq),jw=1,NWF)
!       enddo       
!       write(6,*) 
!      enddo 
!-- 
!make MATRIX_W  
       allocate(V_MAT(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3))  
       V_MAT(:,:,:,:,:)=0.0D0 
       do ia1=-Na1,Na1
        do ia2=-Na2,Na2
         do ia3=-Na3,Na3
          do iw=1,NWF
           do jw=1,NWF 
            SUM_CMPX=0.0D0 
            do iq=1,NTQ 
             q1=SQ(1,iq);q2=SQ(2,iq);q3=SQ(3,iq)
             phase=tpi*(q1*dble(ia1)+q2*dble(ia2)+q3*dble(ia3)) 
             pf=exp(-ci*phase) 
             SUM_CMPX=SUM_CMPX+func(iw,jw,iq)*pf
            enddo 
            V_MAT(iw,jw,ia1,ia2,ia3)
     +     =2.0D0*tpi*SUM_CMPX/VOLUME/DBLE(NTQ)+chead 
           enddo 
          enddo 
         enddo 
        enddo 
       enddo 
       allocate(W_MAT(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,ne))  
       W_MAT(:,:,:,:,:,:)=0.0D0 
       do ie=1,ne
        do ia1=-Na1,Na1
         do ia2=-Na2,Na2
          do ia3=-Na3,Na3
           do iw=1,NWF
            do jw=1,NWF 
             SUM_CMPX=0.0D0 
             do iq=1,NTQ 
              q1=SQ(1,iq);q2=SQ(2,iq);q3=SQ(3,iq)
              phase=tpi*(q1*dble(ia1)+q2*dble(ia2)+q3*dble(ia3)) 
              pf=exp(-ci*phase) 
              SUM_CMPX=SUM_CMPX+funcw(iw,jw,ie,iq)*pf
             enddo 
             W_MAT(iw,jw,ia1,ia2,ia3,ie)
     +      =2.0D0*tpi*SUM_CMPX/VOLUME/DBLE(NTQ)+cheadw(ie) 
            enddo 
           enddo 
          enddo 
         enddo 
        enddo 
       enddo 
!--
!WRITE V_MAT  
       write(6,*)'# '
       write(6,*)'#-----'
       write(6,*)'#V_MAT'
       write(6,*)'#-----'
       write(6,*)'# '
       do ia1=-Na1,Na1 
        do ia2=-Na2,Na2 
         do ia3=-Na3,Na3 
          write(6,*) ia1,ia2,ia3           
          do iw=1,NWF
           write(6,'(100F12.5)')(DBLE(V_MAT(iw,jw,ia1,ia2,ia3)*au), 
     +                                         jw=1,NWF)
          enddo       
          write(6,*) 
         enddo 
        enddo 
       enddo 
!--
!OPEN(200,W,FILE='dat.Vmat')
       call system('rm -rf dir-intW') 
       call system('mkdir dir-intW') 
       ierr=CHDIR("./dir-intW") 
       call system("pwd") 
       OPEN(200,FILE='dat.Vmat') 
       rewind(200)
       write(200,'(a)')'#Bare Coulomb: V' 
       write(200,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
       write(200,'(a)')'#1:i, 2:j, 3:Re(V_ij) [eV], 4:Im(V_ij) [eV]' 
       do ia1=-Na1,Na1
        do ia2=-Na2,Na2
         do ia3=-Na3,Na3
          write(200,*) ia1,ia2,ia3           
          do iw=1,NWF 
           do jw=1,NWF 
            write(200,'(i5,i5,2f20.10)')
     +      iw,jw,V_MAT(iw,jw,ia1,ia2,ia3)*au
           enddo!jw 
          enddo!iw 
          write(200,*)
         enddo 
        enddo 
       enddo 
       close(200) 
!--
!WRITE W_MAT  
!--
       ie=calc_ifreq          
       write(6,*)'# '
       write(6,*)'#-------------------------'
       write(6,*)'# W_MAT(omega=calc_ifreq) '
       write(6,*)'#-------------------------'
       write(6,*)'# '
       do ia1=-Na1,Na1 
        do ia2=-Na2,Na2 
         do ia3=-Na3,Na3 
          write(6,*) ia1,ia2,ia3           
          do iw=1,NWF
           write(6,'(100F12.5)')(DBLE(W_MAT(iw,jw,ia1,ia2,ia3,ie)*au), 
     +                                         jw=1,NWF)
          enddo       
          write(6,*) 
         enddo 
        enddo 
       enddo 
!--
!OPEN(201,W,FILE='./dir-intW/dat.Wmat')
       ie=calc_ifreq          
       OPEN(201,FILE='dat.Wmat') 
       rewind(201)
       write(201,'(a)')'#Screened Coulomb: W at omega=calc_ifreq' 
       write(201,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
       write(201,'(a)')'#1:i, 2:j, 3:Re(W_ij) [eV], 4:Im(W_ij) [eV]' 
       do ia1=-Na1,Na1
        do ia2=-Na2,Na2
         do ia3=-Na3,Na3
          write(201,*) ia1,ia2,ia3           
          do iw=1,NWF 
           do jw=1,NWF
            write(201,'(i5,i5,2f20.10)')
     +      iw,jw,W_MAT(iw,jw,ia1,ia2,ia3,ie)*au 
           enddo!jw 
          enddo!iw 
          write(201,*)
         enddo 
        enddo 
       enddo 
       close(201)  
!--
!OPEN(1000,W,FILE='./dir-intW/dat.VvsR.xxx')
       do iw=1,NWF 
        write(filename,'("dat.VvsR.",i3.3)') iw 
        file_num=1000+(iw-1) 
        OPEN(file_num,FILE=filename) 
        rewind(file_num) 
        write(file_num,'(a)')'#R dependence of bare Coulomb' 
        write(file_num,'(a)')
     +  '#1:R [AA], 2:Re[V(R)] [eV], 3:Im[V(R)] [eV]'
        do ia1=-Na1,Na1
         do ia2=-Na2,Na2
          do ia3=-Na3,Na3
           do jw=1,NWF 
            rij(:)=dble(ia1)*a1(:)+dble(ia2)*a2(:)+dble(ia3)*a3(:)
     +            +(coord(:,jw)-coord(:,iw)) 
            rij2=rij(1)**2+rij(2)**2+rij(3)**2
            rij1=dsqrt(rij2)
            write(file_num,'(3F12.5)')
     +      rij1*bohr,V_MAT(iw,jw,ia1,ia2,ia3)*au  
           enddo!jw 
          enddo!ia3 
         enddo!ia2 
        enddo!ia1 
        close(file_num) 
       enddo!iw 
!--
!OPEN(2000,W,FILE='./dir-intW/dat.WvsR')
       ie=calc_ifreq          
       do iw=1,NWF 
        write(filename,'("dat.WvsR.",i3.3)') iw 
        file_num=2000+(iw-1) 
        OPEN(file_num,FILE=filename) 
        rewind(file_num) 
        write(file_num,'(a)')
     +  '#R dependence of screened Coulomb at omega=calc_ifreq' 
        write(file_num,'(a)') 
     +  '#1:R [AA], 2:Re[W(R)] [eV], 3:Im[W(R)] [eV]'  
        do ia1=-Na1,Na1
         do ia2=-Na2,Na2
          do ia3=-Na3,Na3
            do jw=1,NWF 
             rij(:)=dble(ia1)*a1(:)+dble(ia2)*a2(:)+dble(ia3)*a3(:)
     +             +(coord(:,jw)-coord(:,iw)) 
             rij2=rij(1)**2+rij(2)**2+rij(3)**2
             rij1=dsqrt(rij2)
             write(file_num,'(3F12.5)')
     +       rij1*bohr,W_MAT(iw,jw,ia1,ia2,ia3,ie)*au    
            enddo!jw 
          enddo!ia3 
         enddo!ia2 
        enddo!ia1  
        close(file_num) 
       enddo!iw  
!--
!OPEN(3000,W,FILE='./dir-intW/dat.UvsE')
      do iw=1,NWF
       do jw=iw,NWF 
        write(filename,'("dat.UvsE.",i3.3,"-",i3.3)') iw,jw  
        file_num=3000+(iw-1)*NWF+(jw-1)  
        OPEN(file_num,FILE=filename) 
        rewind(file_num) 
        write(file_num,'(a)')
     +  '#Omega dependence of onsite Coulomb' 
        write(file_num,'(a)') 
     +  '#1:Re(w) [eV], 2:Im(w) [eV], 3:Re[U(w)] [eV], 4:Im[U(w)] [eV]'
        do ie=1,ne
         write(file_num,'(4F12.5)') em(ie)*au,W_MAT(iw,jw,0,0,0,ie)*au 
        enddo 
        close(file_num) 
       enddo
      enddo
      ierr=CHDIR("..") 
      call system("pwd") 
!--
!write model parameters 
      ierr=CHDIR("./dir-model") 
      call system("pwd") 
      ie=calc_ifreq          
      !wcut_model=wcut_model/au 
      !
      !old: 20180604
      !
      ! call wrt_model(nkb1,nkb2,nkb3,NTK,Na1,Na2,Na3,NWF,wcut_model,
      !+     W_MAT(1,1,-Na1,-Na2,-Na3,ie)) 
      !
      !new: 20181127 
      !
      !WEIGHT_R 20170317 by Y.Nomura 
      !
      allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
      SUM_REAL=0.0d0 
      do ia1=-Na1,Na1
       do ia2=-Na2,Na2
        do ia3=-Na3,Na3
         if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
        enddo!ia3
       enddo!ia2
      enddo!ia1 
      write(6,'(a20,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
      if(abs(SUM_REAL-dble(NTK))>1.0d-6)then 
       stop 'SUM_WEIGHT/=NTK'
      endif 
      !
      call wrt_model(Na1,Na2,Na3,NWF,W_MAT(1,1,-Na1,-Na2,-Na3,ie),
     +     WEIGHT_R(-Na1,-Na2,-Na3)) 
      !
      ierr=CHDIR("..") 
      call system("pwd") 
      !
      deallocate(C0,epsirr) 
      !
      STOP
      END           

!
! Copyright (c) 2013-2018 Yoshihide Yoshimoto and Kazuma Nakamura 
!
subroutine gencif(a1,a2,a3,amin,amax,bmin,bmax,cmin,cmax,nsi,cs,asi)    
use m_gencif_sub!subr_fmtconv: original name in xtapp 
implicit none 
real(8),intent(in)::a1(3),a2(3),a3(3)
integer,intent(in)::amin,amax,bmin,bmax,cmin,cmax 
!
integer::nsi 
character(len=2)::cs(nsi) 
real(8)::asi(3,nsi) 
!
integer::nkd 
character(len=2)::csr 
character(len=2),allocatable::csref(:)!csref(nkd) 
integer,allocatable::kd(:)!kd(nsi) 
real(8),allocatable::zn(:)!zn(nkd)
!
integer,allocatable::kd_sc(:) 
real(8),allocatable::asi_sc(:,:) 
real(8)::aa(3,3),aa_sc(3,3)  
integer::i,is,js,ks,ip,j,ia  
integer::na,nb,nc,nsi_sc 
character(len=256)::cbuf
! 
allocate(kd(nsi));kd=0 
csr=cs(1)
is=1
kd(1)=is 
do ia=2,nsi
 if(csr/=cs(ia))then
  csr=cs(ia)
  is=is+1
  kd(ia)=is 
 else
  kd(ia)=is 
 endif 
enddo 
nkd=is 
!
allocate(csref(nkd))
csr=cs(1)
is=1
csref(is)=csr 
do ia=2,nsi
 if(csr/=cs(ia))then
  csr=cs(ia)
  is=is+1
  csref(is)=csr  
 endif 
enddo 
!
allocate(zn(nkd));zn=0.0d0  
do i=1,nkd 
 do is=0,102
  if(csref(i).eq.atom_name(is))then
   js=is 
  endif 
 enddo 
 zn(i)=dble(js) 
enddo 
!
aa(:,1)=a1(:)
aa(:,2)=a2(:)
aa(:,3)=a3(:)
!
na=amax-amin
nb=bmax-bmin
nc=cmax-cmin
nsi_sc=nsi*na*nb*nc 
!
allocate(kd_sc(nsi_sc));kd_sc=0 
allocate(asi_sc(3,nsi_sc));asi_sc=0.0d0
! 
asi(1,:)=asi(1,:)/dble(na) 
asi(2,:)=asi(2,:)/dble(nb) 
asi(3,:)=asi(3,:)/dble(nc) 
! 
do is=1,na
 do js=1,nb
  do ks=1,nc 
   do i=1,nsi 
    ip=i+nsi*(ks-1)+nsi*nc*(js-1)+nsi*nc*nb*(is-1)
    asi_sc(1,ip)=asi(1,i)+dble((is-1))/dble(na) 
    asi_sc(2,ip)=asi(2,i)+dble((js-1))/dble(nb) 
    asi_sc(3,ip)=asi(3,i)+dble((ks-1))/dble(nc) 
    kd_sc(ip)=kd(i)
   enddo!i
  enddo!ks
 enddo!js
enddo!is 
!
aa_sc(:,1)=aa(:,1)*dble(na)
aa_sc(:,2)=aa(:,2)*dble(nb)
aa_sc(:,3)=aa(:,3)*dble(nc)
!
!do j=1,3
! write(6,'(3f15.10)')(aa_sc(i,j),i=1,3) 
!enddo 
!
!do i=1,nsi_sc
! write(6,'(i5,3f15.10)')kd_sc(i),(asi_sc(j,i),j=1,3) 
!enddo 
!
cbuf='cif'
call printcif(cbuf,aa_sc(1,1),nkd,zn(1),nsi_sc,kd_sc(1),asi_sc(1,1),na,nb,nc)
!
return 
end 

      PROGRAM WANNIER          
      use m_rdinput       
      use fft_3d
      use m_bvector, only: generate_bvectors
      use m_frmsf_wan, only: wrt_frmsf_wan
      use m_dos, only: calculate_dos 
      use m_eigenstate, only: calculate_eigenstate
      use m_wrt_frmsf, only: wrt_frmsf 
      use m_wrt_model  
      use m_dmx, only: calculate_dmx 
      include "config.h"
      !--
      call read_input
      NGAUSS=n_occ!TOTAL NUMBER OF WANNIER ORBITAL  
      E_LOWER=E_LOWER/au 
      E_UPPER=E_UPPER/au 
      E_LOWER_inner=E_LOWER_inner/au 
      E_UPPER_inner=E_UPPER_inner/au 
      write(6,*)'E_LOWER in au',E_LOWER 
      write(6,*)'E_UPPER in au',E_UPPER 
      write(6,*)'E_LOWER_inner in au',E_LOWER_inner 
      write(6,*)'E_UPPER_inner in au',E_UPPER_inner 
!--
!      do ig=1,nigs 
!       write(6,*) vec_ini(ig) 
!      enddo 
!--
!      do ix=1,3 
!       write(6,'(100f10.5)')(SK_sym_pts(ix,ik),ik=1,N_sym_points)
!      enddo 
!--
      WRITE(6,*) 
      WRITE(6,*)'=========================================='
      WRITE(6,*)'=== WANNIER FUNCTION CALCULATION START ==='
      WRITE(6,*)'=========================================='
      WRITE(6,*) 
!--
!OPEN(117,R,FILE='dat.bandcalc') 
      OPEN(117,FILE='./dir-wfn/dat.bandcalc') 
      rewind(117) 
      read(117,*) Ecut_for_psi 
      read(117,*) FermiEnergy  
      read(117,*) Etot
      write(6,*)'Ecut_for_psi=',Ecut_for_psi 
      write(6,*)'FermiEnergy=',FermiEnergy  
      write(6,*)'Etot=',Etot
!--
!OPEN(105,R,FILE='dat.lattice')
      OPEN(105,FILE='./dir-wfn/dat.lattice') 
      REWIND(105)
      READ(105,*) a1(1),a1(2),a1(3)!a1 vector
      READ(105,*) a2(1),a2(2),a2(3)!a2 vector
      READ(105,*) a3(1),a3(2),a3(3)!a3 vector
      CLOSE(105)
      !--
      call OUTER_PRODUCT(a2(1),a3(1),b1(1))
      VOLUME=a1(1)*b1(1)+a1(2)*b1(2)+a1(3)*b1(3)
      b1(:)=b1(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a3(1),a1(1),b2(1))
      b2(:)=b2(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a1(1),a2(1),b3(1))
      b3(:)=b3(:)*tpi/VOLUME 
      !--
      write(6,*) 
      write(6,*)'=============='
      write(6,*)'LATTICE VECTOR'
      write(6,*)'=============='
      write(6,*) 
      write(6,*) a1(1), a1(2), a1(3)
      write(6,*) a2(1), a2(2), a2(3)
      write(6,*) a3(1), a3(2), a3(3)
      write(6,*) 
      write(6,*)'VOLUME OF UNIT CELL=',VOLUME  
      write(6,*) 
      write(6,*)'========================='
      write(6,*)'RECIPROCAL LATTICE VECTOR'
      write(6,*)'========================='
      write(6,*) 
      write(6,*) b1(1), b1(2), b1(3)
      write(6,*) b2(1), b2(2), b2(3)
      write(6,*) b3(1), b3(2), b3(3)
      write(6,*) 
      write(6,*)'======================'
      write(6,*)'CHECK OF (A_VEC*B_VEC)'
      write(6,*)'======================'
      write(6,*) 
      write(6,*)'a1*b1=',b1(1)*a1(1)+b1(2)*a1(2)+b1(3)*a1(3)
      write(6,*)'a2*b2=',b2(1)*a2(1)+b2(2)*a2(2)+b2(3)*a2(3)
      write(6,*)'a3*b3=',b3(1)*a3(1)+b3(2)*a3(2)+b3(3)*a3(3)
      call est_latparam(a1(1),a2(1),a3(1),a,b,c,alp,bet,gmm) 
      write(6,'(6f15.10)') a,b,c,alp,bet,gmm 
!--
!OPEN(107,R,FILE='dat.atom_kind')
!      OPEN(107,FILE='./dir-wfn/dat.atom_kind') 
!      rewind(107)
!      read(107,*) nkd 
!      allocate(zo(nkd));zo=0.0d0
!      allocate(zn(nkd));zn=0.0d0
!      do i=1,nkd 
!       read(107,*) zo(i),zn(i)
!      enddo
!      close(107)
!--
!OPEN(108,R,FILE='dat.atom_position')
!      OPEN(108,FILE='./dir-wfn/dat.atom_position') 
!      rewind(108)
!      read(108,*) nsi 
!      allocate(kd(nsi));kd=0 
!      allocate(asi(3,nsi));asi=0.0d0
!      do i=1,nsi  
!       read(108,*) kd(i),(asi(j,i),j=1,3) 
!      enddo 
!      close(108)
!--
!OPEN(108,R,FILE='dat.atom_position')
      OPEN(108,FILE='./dir-wfn/dat.atom_position') 
      rewind(108)
      read(108,*) nsi 
      allocate(chemical_species(nsi))
      allocate(asi(3,nsi));asi=0.0d0
      do i=1,nsi  
       read(108,*) chemical_species(i),(asi(j,i),j=1,3) 
      enddo 
      close(108)
!--
!OPEN(100,R,FILE='dat.symmetry') 
      OPEN(100,FILE='./dir-wfn/dat.symmetry') 
      rewind(100) 
      read(100,*) nsymq 
      read(100,*) nnp 
      write(6,*)'nsymq=',nsymq 
      write(6,*)'nnp=',nnp 
      allocate(rg(3,3,nsymq));rg=0
      allocate(pg(3,nsymq));pg=0
      allocate(rginv(3,3,nsymq));rginv=0.0d0 
      do iop=1,nsymq
       read(100,*)((rg(i,j,iop),i=1,3),j=1,3) 
       read(100,*)(pg(i,iop),i=1,3)   
      enddo 
      close(100) 
      !--
      write(6,*) 
      write(6,*)'========'
      write(6,*)'SYMMETRY'
      write(6,*)'========'
      write(6,*) 
      do iop=1,nsymq  
       write(6,'(a5,i4)')'sym=',iop
       write(6,'(a10)')'rg and pg' 
       do i=1,3
        write(6,'(3i5,5x,i5)')(rg(i,j,iop),j=1,3),pg(i,iop) 
       enddo
       write(6,*) 
      enddo
      !--
      rginv=rg 
      do iop=1,nsymq
       call invmat(3,rginv(1,1,iop)) 
      enddo 
      !--
      do iop=1,nsymq  
       write(6,'(a5,i4)')'sym=',iop
       write(6,'(a10)')'rginv' 
       do i=1,3
        write(6,'(3f10.5)')(rginv(i,j,iop),j=1,3) 
       enddo
       write(6,*) 
      enddo
      write(6,*)'finish read dat.symmetry'
!--
!OPEN(101,R,FILE='dat.sample-k') 
      OPEN(101,FILE='./dir-wfn/dat.sample-k') 
      rewind(101) 
      read(101,*) Nk_irr 
      allocate(SKI(3,Nk_irr));SKI(:,:)=0.0D0 
      do ik=1,Nk_irr 
       read(101,*)(SKI(i,IK),i=1,3) 
      enddo 
      close(101) 
      !call est_NTK(NK_irr,SKI(1,1),NTK,nkb1,nkb2,nkb3)  
      !write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      !Na1=nkb1/2;Na2=nkb2/2;Na3=nkb3/2
      !write(6,'(a24,3i10)')'Na1,Na2,Na3=',Na1,Na2,Na3 
!--
!OPEN(132,R,FILE='dat.nkm') 
      OPEN(132,FILE='./dir-wfn/dat.nkm') 
      allocate(NGI(Nk_irr));NGI(:)=0
      rewind(132)
      do ik=1,Nk_irr 
       read(132,*) NGI(ik) 
      enddo 
      close(132) 
      NTG=maxval(abs(NGI(:))) 
      write(6,'(a10,i10)')'NTG=',NTG  
!--
!OPEN(104,R,FILE='dat.kg') 
      OPEN(104,FILE='./dir-wfn/dat.kg') 
      rewind(104) 
      allocate(KGI(3,NTG,Nk_irr));KGI=0 
      do ik=1,Nk_irr 
       read(104,*) NKG_tmp
       if(NKG_tmp/=NGI(ik)) then 
        write(6,*)'ERROR; STOP; NKG_tmp should be NGI(ik)'   
        write(6,*)'NKG_tmp=',NKG_tmp,'NGI(ik)=',NGI(ik)
        stop 
       endif 
       do ig=1,NKG_tmp
        read(104,*)(KGI(i,ig,ik),i=1,3) 
       enddo!ig 
      enddo!ik  
      close(104)
      !--
      L1=maxval(abs(KGI(1,:,:)))+1; write(6,*)'L1=',L1 
      L2=maxval(abs(KGI(2,:,:)))+1; write(6,*)'L2=',L2 
      L3=maxval(abs(KGI(3,:,:)))+1; write(6,*)'L3=',L3 
      allocate(packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr))   
      packing(:,:,:,:)=0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
        i1=KGI(1,ig,ik); j1=KGI(2,ig,ik); k1=KGI(3,ig,ik) 
        packing(i1,j1,k1,ik)=ig 
       enddo 
      enddo 
      !--
      allocate(LKGI(NTG,Nk_irr));LKGI=0.0d0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
       ktmp(1)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(1)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(1) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(1) 

       ktmp(2)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(2)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(2) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(2) 

       ktmp(3)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(3)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(3) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(3) 
       LKGI(ig,ik)=ktmp(1)**2+ktmp(2)**2+ktmp(3)**2
       enddo!ig 
       write(6,*) maxval(LKGI(:,ik))
      enddo!ik 
      write(6,*) 
      write(6,*) maxval(LKGI(:,:))
      Ecut_for_psi=maxval(LKGI(:,:))+1.0d-8
      write(6,*)'Ecut_for_psi=',Ecut_for_psi 
!--
!fft grid
      !--
      !m1=maxval(abs(KGI(1,:,:))) 
      !m2=maxval(abs(KGI(2,:,:))) 
      !m3=maxval(abs(KGI(3,:,:))) 
      !nwx2=algn235(2*m1) 
      !nwy2=algn235(2*m2) 
      !nwz2=algn235(2*m3) 
      !--
      htmp=dsqrt(dot_product(a1,a1))
      h1(:)=a1(:)/htmp 
      htmp=dsqrt(dot_product(a2,a2))
      h2(:)=a2(:)/htmp 
      htmp=dsqrt(dot_product(a3,a3)) 
      h3(:)=a3(:)/htmp 
      d1=abs(dot_product(b1,h1)) 
      d2=abs(dot_product(b2,h2)) 
      d3=abs(dot_product(b3,h3)) 
      qwf=2.0d0*dsqrt(Ecut_for_psi) 
      !--
      !nwx2=algn235(int(qwf/d1)+1,1)!wrong 
      !nwy2=algn235(int(qwf/d2)+1,1)!wrong 
      !nwz2=algn235(int(qwf/d3)+1,1)!wrong 
      !--
      nwx2=algn235(int(qwf/d1)+1)!20180412 by Y.Nomura 
      nwy2=algn235(int(qwf/d2)+1)!20180412 by Y.Nomura 
      nwz2=algn235(int(qwf/d3)+1)!20180412 by Y.Nomura 
      !--
      nfft1=nwx2+1;nfft2=nwy2+1;nfft3=nwz2+1
      Nl123=nfft1*nfft2*nfft3 
      write(6,'(a20,i10)')'nwx2:',nwx2 
      write(6,'(a20,i10)')'nwy2:',nwy2 
      write(6,'(a20,i10)')'nwz2:',nwz2 
      write(6,'(a20,i10)')'nfft1:',nfft1 
      write(6,'(a20,i10)')'nfft2:',nfft2 
      write(6,'(a20,i10)')'nfft3:',nfft3 
      write(6,'(a20,i10)')'NL123:',Nl123  
!--
!call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
!--
!OPEN(111,R,FILE='dat.eigenvalue') 
      OPEN(111,FILE='./dir-wfn/dat.eigenvalue') 
      rewind(111)
      read(111,*) NBAND 
      allocate(E_EIGI(NBAND,Nk_irr));E_EIGI=0.0d0
      do ik=1,Nk_irr 
       do ib=1,NBAND 
        read(111,*) E_EIGI(ib,ik)
       enddo!ib
      enddo!ik          
      !--
      call calc_NB_start_end(NK_irr,NBAND,E_EIGI(1,1),E_LOWER,E_UPPER,
     +     NB_start,NB_end) 
      !--
      NTB_glb=NBAND 
      NTB=NB_end-NB_start+1!TOTAL NUMBER OF CONSIDERED BAND in wannier  
      write(6,'(a20,i10)')'NTB_glb:',NTB_glb  
      write(6,'(a20,i10)')'NB_start:',NB_start 
      write(6,'(a20,i10)')'NB_end:',NB_end 
      write(6,'(a20,i10)')'NTB:',NTB 
      deallocate(E_EIGI) 
!--
!OPEN(111,R,FILE='dat.eigenvalue') 
      OPEN(111,FILE='./dir-wfn/dat.eigenvalue') 
      rewind(111)
      read(111,*) NBAND 
      allocate(E_EIGI(NTB,Nk_irr));E_EIGI=0.0d0
      do ik=1,Nk_irr 
       do ib=1,NBAND!NBI(ik) 
        if((ib.ge.NB_start).and.(ib.le.NB_end)) then  
         read(111,*) E_EIGI(ib-NB_start+1,ik)
        else 
         read(111,*) 
        endif 
       enddo!ib
      enddo!ik          
!--
      call est_NTK(Nk_irr,Nsymq,SKI(1,1),rg(1,1,1),NTK)
      write(6,'(a20,i10)')'Estimated NTK:',NTK 
!--
!SK0,numirr,numrot,trs,RW
      allocate(SK0(3,NTK));SK0(:,:)=0.0d0
      allocate(numirr(NTK));numirr(:)=0
      allocate(numrot(NTK));numrot(:)=0
      allocate(trs(NTK));trs(:)=0
      allocate(RW(3,NTK));RW(:,:)=0
!--
!      do ik=1,Nk_irr 
!       SK0(:,ik)=SKI(:,ik) 
!       numirr(ik)=ik;numrot(ik)=1;trs(ik)=1;RW(1:3,ik)=0
!      enddo 
!      jk=Nk_irr 
!--
      jk=0
      do ik=1,Nk_irr
       !write(6,*)'--' 
       !write(6,'(a8,i8,3f15.10)')'ik=',ik,SKI(:,ik)  
       !write(6,*)'--' 
      do iop=1,Nsymq
!sym
       ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik)
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik)
       call kcheck(ktmp(1),RWtmp(1))!rewind check 
       do iik=1,jk
        if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and. 
     +     abs(SK0(2,iik)-ktmp(2))<1.0d-4.and. 
     +     abs(SK0(3,iik)-ktmp(3))<1.0d-4)goto 1000
       enddo!iik
       jk=jk+1
       !write(6,'(a8,i8,3f15.10)')'jk=',jk,ktmp(:)  
       SK0(:,jk)=ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=1;RW(:,jk)=RWtmp(:)
       !if(.true.)goto 2000
!time-reversal
1000   ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik)
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik)
       call kcheck_trs(ktmp(1),RWtmp(1))!rewind check modified 20170316  
       do iik=1,jk
        if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and. 
     +     abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and. 
     +     abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4)goto 2000
       enddo!iik
       jk=jk+1
       !write(6,'(a8,i8,3f15.10)')'jk=',jk,ktmp(:)  
       SK0(:,jk)=-ktmp(:) 
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=-1;RW(:,jk)=RWtmp(:) 
2000  enddo 
      enddo 
      !--
      if(NTK/=jk) then 
       write(6,*)'ERROR;STOP;NTK should be jk'   
       write(6,*)'NTK=',NTK,'jk=',jk;STOP
      endif 
      !--
      write(6,*) 
      write(6,*)'====================='
      write(6,*)'WRITE SAMPLE K-POINTS'
      write(6,*)'====================='
      do ik=1,NTK
       WRITE(6,'(I5,3F15.10)') ik,SK0(:,ik) 
      enddo  
!--
!      do ik=1,NTK 
!       write(6,*) ik,numrot(ik) 
!      enddo 
!--
      call est_nkbi(NTK,SK0(1,1),nkb1,nkb2,nkb3)  
      write(6,*) 
      write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      Na1=nkb1/2;Na2=nkb2/2;Na3=nkb3/2
      write(6,'(a24,3i10)')'Na1,Na2,Na3=',Na1,Na2,Na3 
!--
      call system('rm -rf dir-wan') 
      call system('mkdir dir-wan') 
!--
!write Fermi surface 
      if(CALC_FERMISURFACE)then 
        write(6,*) 
        write(6,'(a30)')'write Fermi surface'
        write(6,*) 
        allocate(E_EIG(NTB,NTK));E_EIG(:,:)=0.0d0
        do jk=1,NTK 
         if(trs(jk)==1) then 
          ik=numirr(jk) 
          E_EIG(:,jk)=E_EIGI(:,ik) 
         elseif(trs(jk)==-1)then  
          ik=numirr(jk) 
          E_EIG(:,jk)=E_EIGI(:,ik) 
         endif 
        enddo!jk  
        filename='./dir-wan/dat.frmsf'
        call wrt_frmsf(NTB,NTK,nkb1,nkb2,nkb3,E_EIG(1,1),SK0(1,1),
     +       FermiEnergy,filename,b1(1),b2(1),b3(1)) 
        deallocate(E_EIG)
      endif 
!-- 
!write global DOS
      if(CALC_GLOBAL_DOS)then 
        write(6,*) 
        write(6,'(a30)')'write global DOS'
        write(6,*) 
        allocate(E_EIG(NTB,NTK));E_EIG(:,:)=0.0d0
        allocate(V_EIG(NTB,NTB,NTK));V_EIG(:,:,:)=0.0d0
        do jk=1,NTK 
         if(trs(jk)==1) then 
          ik=numirr(jk) 
          E_EIG(:,jk)=E_EIGI(:,ik) 
         elseif(trs(jk)==-1)then  
          ik=numirr(jk) 
          E_EIG(:,jk)=E_EIGI(:,ik) 
         endif 
        enddo!jk  
        filename='./dir-wan/dat.dos.global'
        call calculate_dos(NTB,NTK,nkb1,nkb2,nkb3,0.0d0,FermiEnergy,
     +   filename,b1(1),b2(1),b3(1),SK0(1,1),E_EIG(1,1),V_EIG(1,1,1))
        deallocate(E_EIG,V_EIG)
      endif 
!--
!OPEN(102,R,FILE='dat.wfn',FORM='unformatted') 
      OPEN(102,FILE='./dir-wfn/dat.wfn',FORM='unformatted') 
!old--
!      allocate(CIR(NTG,NTB,Nk_irr));CIR=0.0d0  
!      rewind(102)
!      do ik=1,Nk_irr 
!       do ib=1,NBAND!NBI(ik) 
!        if((ib.ge.NB_start).and.(ib.le.NB_end)) then  
!         read(102)(CIR(IG,ib-NB_start+1,ik),IG=1,NGI(ik))
!        else 
!         read(102) 
!        endif 
!       enddo!ib 
!      enddo!ik          
!      close(102) 
!new--
      rewind(102)
      read(102) ncomp 
      if(ncomp/=1)then 
       write(6,*)'This program not suport ncomp/=1; then stop'
       stop
      endif 
      allocate(CIR(NTG,NTB,Nk_irr));CIR=0.0d0  
      do ik=1,Nk_irr 
       do ib=1,NBAND 
        if((ib.ge.NB_start).and.(ib.le.NB_end)) then  
         read(102)(CIR(IG,ib-NB_start+1,ik),IG=1,NGI(ik))
        else 
         read(102) 
        endif 
       enddo!ib 
      enddo!ik          
      close(102) 
!--
!gen(C0,E_EIG,NG0,NB0,KG0) 
      allocate(C0(NTG,NTB,NTK));C0(:,:,:)=0.0d0
      allocate(E_EIG(NTB,NTK));E_EIG(:,:)=0.0d0
      allocate(NB0(NTK));NB0(:)=0
      allocate(NG0(NTK));NG0(:)=0
      allocate(KG0(3,NTG,NTK));KG0(:,:,:)=0 
      allocate(KGtmp(3,NTG));KGtmp(:,:)=0 
!20161207
!      do jk=1,Nk_irr 
!       C0(:,:,jk)=CIR(:,:,jk) 
!       E_EIG(:,jk)=E_EIGI(:,jk) 
!       NB0(jk)=NBI(jk)
!       NG0(jk)=NGI(jk)
!       KG0(:,:,jk)=KGI(:,:,jk)
!      enddo 
!      do jk=Nk_irr+1,NTK 
!--
       do jk=1,NTK 
       if(trs(jk)==1) then 
        ik=numirr(jk);iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        E_EIG(:,jk)=E_EIGI(:,ik) 
        NB0(jk)=NBAND!NBI(ik)
!--
!20170316 KG0s are generated by original KGI
!        NG0(jk)=NGI(ik) 
!        do ig=1,NG0(jk)  
!         i1=rg(1,1,iop)*KGI(1,ig,ik)
!     +     +rg(1,2,iop)*KGI(2,ig,ik)
!     +     +rg(1,3,iop)*KGI(3,ig,ik)-RW(1,jk) 
!         i2=rg(2,1,iop)*KGI(1,ig,ik)
!     +     +rg(2,2,iop)*KGI(2,ig,ik)
!     +     +rg(2,3,iop)*KGI(3,ig,ik)-RW(2,jk) 
!         i3=rg(3,1,iop)*KGI(1,ig,ik)
!     +     +rg(3,2,iop)*KGI(2,ig,ik)
!     +     +rg(3,3,iop)*KGI(3,ig,ik)-RW(3,jk) 
!         KG0(1,ig,jk)=i1 
!         KG0(2,ig,jk)=i2 
!         KG0(3,ig,jk)=i3 
!         phase=tpi*(dble(i1)*dble(pg(1,iop))
!     +             +dble(i2)*dble(pg(2,iop))
!     +             +dble(i3)*dble(pg(3,iop))) 
!         pf=exp(-ci*phase/dble(nnp)) 
!         C0(ig,:,jk)=CIR(ig,:,ik)*pf 
!        enddo!ig  
!       write(6,'(i5,3f15.10,i5)') jk,ktmp(:),trs(jk)  
!--
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KG0(1,1,jk),NG_for_psi)
        if(NG_for_psi/=NGI(ik)) then 
         write(6,*)'ERROR; STOP; NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NG0(ik)=',NGI(ik)
         write(6,*)'ik,jk',ik,jk;STOP
        endif 
        NG0(jk)=NG_for_psi  
        call make_C0(NTG,NTB,trs(jk),NG0(jk),KG0(1,1,jk),RW(1,jk),
     +  rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,packing(-L1,-L2,-L3,ik),
     +  CIR(1,1,ik),C0(1,1,jk)) 
       !--
       elseif(trs(jk)==-1)then  
        ik=numirr(jk);iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        !write(6,'(i5,3f15.10,i5)') jk,ktmp(:),trs(jk)  
        E_EIG(:,jk)=E_EIGI(:,ik) 
        NB0(jk)=NBAND!NBI(ik)
        KGtmp(:,:)=0 
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KGtmp(1,1),NG_for_psi)
        if(NG_for_psi/=NGI(ik))then 
         write(6,*)'ERROR; STOP; NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
        KG0(:,:,jk)=-KGtmp(:,:)!notice on '-' sign 
        call make_C0(NTG,NTB,trs(jk),NG0(jk),KGtmp(1,1),RW(1,jk), 
     +  rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,packing(-L1,-L2,-L3,ik),
     +  CIR(1,1,ik),C0(1,1,jk))!modified 20170316 KG0->KGtmp 
       endif 
      enddo 
      !--
      WRITE(6,*) 
      write(6,*)'==================='
      write(6,*)'CALCULATED K-POINTS'
      write(6,*)'==================='
      WRITE(6,*) 
      do ik=1,NTK
       write(6,'(i5,3f15.10,i5)') ik,SK0(:,ik),trs(ik)  
      enddo 
!--
!     WRITE(6,*) 
!     write(6,*)'====================='
!     write(6,*)'WRITE ALL EIGENVALUES'
!     write(6,*)'====================='
!     WRITE(6,*) 
!     do ik=1,NTK
!      write(6,'(5F15.10)')(E_EIG(ib,ik),ib=1,NTB) 
!     enddo 
!--
!
!=========================================================
!=== CALCULATE THE NUMBER OF BANDS INSIDE OUTER WINDOW ===
!=========================================================

      allocate(N_BAND(NTK));N_BAND(:)=0
      allocate(N_BAND_BTM(NTK));N_BAND_BTM(:)=0
      do ik=1,NTK       
       SUM_INT=0        
       do ib=1,NTB        
        IF(E_LOWER<=E_EIG(ib,ik).AND.E_EIG(ib,ik)<=E_UPPER)THEN    
         SUM_INT=SUM_INT+1         
         IF(SUM_INT==1) N_BAND_BTM(ik)=ib-1  
        ENDIF        
       enddo!ib 
       N_BAND(ik)=SUM_INT 
      enddo!ik       
      !
      write(6,*) 
      write(6,*)'===================================='
      write(6,*)'BAND INFO INSIDE OUTER ENERGY WINDOW'
      write(6,*)'===================================='
      write(6,*) 
      !
      if(maxval(N_BAND)/=NTB)then
       write(6,'(a)')'maxval(N_BAND) SHOULD BE THE SAME AS NTB; STOP'
      endif 
      !
      do ik=1,NTK
!check N_BAND(ik) >= N_wannier 
       if(N_BAND(ik)<N_wannier)then 
        write(6,'(a)')'energy window setting: WRONG'
        write(6,'(a)')'N_BAND(ik) SHOULD BE LARGER THAN N_wannier: STOP'
        write(6,'(a,3i8)')'ik, N_BAND(ik), N_wannier',
     +                     ik, N_BAND(ik), N_wannier 
        stop 
       endif  
       write(6,*) ik,N_BAND_BTM(ik),N_BAND(ik) 
      enddo!ik 
      write(6,*) 
!--
!OPEN(149,W,FILE='dat.ns-nb')
      OPEN(149,FILE='./dir-wan/dat.ns-nb') 
      rewind(149)
      do ik=1,NTK
       write(149,*) N_BAND_BTM(ik)+NB_start-1,N_BAND(ik) 
      enddo!ik 
!--
!20180906 
      if(CALC_REAL_SPACE_BLOCH)then 
       write(6,*) 
       write(6,*)'================================'
       write(6,*)'=== VISUALIZE BLOCH FUNCTION ==='
       write(6,*)'================================'
       write(6,*) 
       !--
       nfft1=nwx2+1;nfft2=nwy2+1;nfft3=nwz2+1
       Nl123=nfft1*nfft2*nfft3 
       write(6,'(a20,3i10)')'nwx2,nwy2,nwz2:',nwx2,nwy2,nwz2 
       write(6,'(a20,3i10)')'nfft1,nfft2,nfft2:',nfft1,nfft2,nfft3 
       write(6,'(a20,i10)')'Nl123:',Nl123 
       call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
       allocate(fftwk(Nl123*2),stat=err) 
       allocate(wfunc(Nl123*2),stat=err) 
       !--
       write(6,'(a20,3f15.10)')'calc_k:',calc_k
       call search_ik(NTK,SK0(1,1),calc_k(1),ik) 
       write(6,'(a20,i10)')'ik:',ik 
       !
       amax=1; bmax=1; cmax=1 
       if(CALC_BLOCH_VIS_RANGE)then 
        write(6,*) 
        write(6,'(a40)')'CALCULATE BLOCH VISUALIZATION RANGE'
        write(6,*) 
        call search_vis_range(calc_k(1),amin,amax,bmin,bmax,cmin,cmax) 
       endif  
       !
       write(6,'(a20,3i10)')'supercell:',amax,bmax,cmax 
       allocate(BF_REALSPACE((amin)*nwx2:(amax)*nwx2-1,
     +                       (bmin)*nwy2:(bmax)*nwy2-1, 
     +                       (cmin)*nwz2:(cmax)*nwz2-1))!<--complex(8)
       !-- 
       do ib=1,N_BAND(ik)
        BF_REALSPACE=0.0d0           
        call make_pw(C0(1,N_BAND_BTM(ik)+ib,ik),wfunc(1),fftwk(1),
     +   NG0(ik),KG0(1,1,ik),NTG,nwx2,nwy2,nwz2,nfft1,nfft2,Nl123,fs,
     +   amin,amax,bmin,bmax,cmin,cmax,SK0(1,ik),
     +   BF_REALSPACE(amin*nwx2,bmin*nwy2,cmin*nwz2)) 
        call phase_fix_bf(nwx2,nwy2,nwz2,amin,amax,bmin,bmax,
     +   cmin,cmax,BF_REALSPACE(amin*nwx2,bmin*nwy2,cmin*nwz2)) 
        !--
        !normalize 
        !BF_REALSPACE=BF_REALSPACE/DBLE(NTK)/DSQRT(VOLUME)
        !--
        !OUTPUT by VESTA format 
        !OPEN(116,W,FILE='dat.bf-realspace-xxx.grd')
        write(filename,"('dat.bf-realspace-',i3.3,'.grd')")ib 
        OPEN(116,FILE=filename) 
        REWIND(116)
        na_grid=nwx2 
        nb_grid=nwy2
        nc_grid=nwz2 
        aa1=a1*dble(amax-amin)
        aa2=a2*dble(bmax-bmin)
        aa3=a3*dble(cmax-cmin)
        call est_latparam(aa1(1),aa2(1),aa3(1),a,b,c,alp,bet,gmm) 
        write(116,'(a40,f10.5)')'Electron density and energy (eV)',
     +  E_EIG(N_BAND_BTM(ik)+ib,ik)*au 
        write(116,'(6f15.10)') a*bohr,b*bohr,c*bohr,alp,bet,gmm  
        write(116,'(3I5)')
     +  (amax-amin)*na_grid,(bmax-bmin)*nb_grid,(cmax-cmin)*nc_grid 
        write(116,'(6g25.16)')(((dble(BF_REALSPACE(i1,i2,i3)),
     +  i3=(cmin)*nc_grid,(cmax)*nc_grid-1),
     +  i2=(bmin)*nb_grid,(bmax)*nb_grid-1),
     +  i1=(amin)*na_grid,(amax)*na_grid-1)
        CLOSE(116)
       enddo!ib 
       deallocate(BF_REALSPACE,fftwk,wfunc)
       !--
       !gencif 20180906  
       call gencif(a1(1),a2(1),a3(1),amin,amax,bmin,bmax,cmin,cmax,
     +      nsi,chemical_species(1),asi(1,1))
       !--
       write(6,*) 
       write(6,*)'==================================='
       write(6,*)'FINIDH VISUALIZE BLOCH FUNCTION ==='
       write(6,*)'!!!!!! We stop calculation !!!!!!!!'
       write(6,*)'==================================='
       write(6,*) 
       stop
      endif!CALC_REAL_SPACE_BLOCH 
      !--
      WRITE(6,*) 
      WRITE(6,*)'========================================='
      WRITE(6,*)'=== WE NOW CALCULATE WANNIER FUNCTION ==='
      WRITE(6,*)'========================================='
      WRITE(6,*) 

!================================
!=== SET B-VECTORS AND WEIGHT ===
!================================

      select case(icell) 
      case(0)!=== CASE(0) ===      
!
!== Automatic generation of b-vectors by TERUMASA TADANO ==
!
       allocate(b_LAT(3,NBMAX));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NBMAX));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NBMAX));WEIGHT_b(:)=0.0D0             
       call generate_bvectors(b1(1),b2(1),b3(1),nkb1,nkb2,nkb3, 
     + NBMAX,maxshell,verbosity,NB,b_LAT(1,1),VEC_b(1,1),WEIGHT_b(1))
      !--
      case(1)!=== CASE(1) SIMPLE CUBIC CELL ===      
       NB=6
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       b_LAT(:,:) = 0.0D0 
       b_LAT(1,1) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,2) =  (1.0D0/DBLE(nkb1))
       b_LAT(3,3) =  (1.0D0/DBLE(nkb1))
       b_LAT(1,4) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,5) = -(1.0D0/DBLE(nkb1))
       b_LAT(3,6) = -(1.0D0/DBLE(nkb1))
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:,1) =  (1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:,2) =  (1.0D0/DBLE(nkb1)) * b2(:) 
       VEC_b(:,3) =  (1.0D0/DBLE(nkb1)) * b3(:) 
       VEC_b(:,4) = -(1.0D0/DBLE(nkb1)) * b1(:)
       VEC_b(:,5) = -(1.0D0/DBLE(nkb1)) * b2(:) 
       VEC_b(:,6) = -(1.0D0/DBLE(nkb1)) * b3(:) 
       VEC_b2=VEC_b(1,1)**2+VEC_b(2,1)**2+VEC_b(3,1)**2 
       WEIGHT_b(:) = 3.0d0/dble(NB)/VEC_b2              
       !WEIGHT_b(:) = (3.0D0/6.0D0)*(alat*nkb1/tpi)**2 
      !--
      case(2)!=== CASE(2) FCC PRIMITIVE CELL ===      
       NB=8
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       b_LAT(:,:) = 0.0D0 
       b_LAT(1,1) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,2) =  (1.0D0/DBLE(nkb1))
       b_LAT(3,3) =  (1.0D0/DBLE(nkb1))
       b_LAT(1,4) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,4) =  (1.0D0/DBLE(nkb1))
       b_LAT(3,4) =  (1.0D0/DBLE(nkb1))
       b_LAT(1,5) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,6) = -(1.0D0/DBLE(nkb1))
       b_LAT(3,7) = -(1.0D0/DBLE(nkb1))
       b_LAT(1,8) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,8) = -(1.0D0/DBLE(nkb1))
       b_LAT(3,8) = -(1.0D0/DBLE(nkb1))
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:,1) =  (1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:,2) =  (1.0D0/DBLE(nkb1)) * b2(:) 
       VEC_b(:,3) =  (1.0D0/DBLE(nkb1)) * b3(:) 
       VEC_b(:,4) =  (1.0D0/DBLE(nkb1)) *(b1(:)+b2(:)+b3(:))  
       VEC_b(:,5) = -(1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:,6) = -(1.0D0/DBLE(nkb1)) * b2(:) 
       VEC_b(:,7) = -(1.0D0/DBLE(nkb1)) * b3(:) 
       VEC_b(:,8) = -(1.0D0/DBLE(nkb1)) *(b1(:)+b2(:)+b3(:))  
       VEC_b2=VEC_b(1,1)**2+VEC_b(2,1)**2+VEC_b(3,1)**2 
       WEIGHT_b(:) = 3.0d0/dble(NB)/VEC_b2              
       !WEIGHT_b(:) = (1.0D0/8.0D0)*(alat*nkb1/tpi)**2 
      !--
      case(3)!=== CASE(3) BCC PRIMITIVE CELL ===      
       NB=12 
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       b_LAT(:,:) = 0.0D0 
       b_LAT(1, 1) =  (1.0D0/DBLE(nkb1))
       b_LAT(2, 2) =  (1.0D0/DBLE(nkb1))
       b_LAT(3, 3) =  (1.0D0/DBLE(nkb1))
       b_LAT(1, 4) =  (1.0D0/DBLE(nkb1))
       b_LAT(2, 4) = -(1.0D0/DBLE(nkb1))
       b_LAT(2, 5) =  (1.0D0/DBLE(nkb1))
       b_LAT(3, 5) = -(1.0D0/DBLE(nkb1))
       b_LAT(3, 6) =  (1.0D0/DBLE(nkb1))
       b_LAT(1, 6) = -(1.0D0/DBLE(nkb1))
       b_LAT(1, 7) = -(1.0D0/DBLE(nkb1))
       b_LAT(2, 8) = -(1.0D0/DBLE(nkb1))
       b_LAT(3, 9) = -(1.0D0/DBLE(nkb1))
       b_LAT(1,10) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,10) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,11) = -(1.0D0/DBLE(nkb1))
       b_LAT(3,11) =  (1.0D0/DBLE(nkb1))
       b_LAT(3,12) = -(1.0D0/DBLE(nkb1))
       b_LAT(1,12) =  (1.0D0/DBLE(nkb1))
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:, 1) =  (1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:, 2) =  (1.0D0/DBLE(nkb1)) * b2(:) 
       VEC_b(:, 3) =  (1.0D0/DBLE(nkb1)) * b3(:) 
       VEC_b(:, 4) =  (1.0D0/DBLE(nkb1)) *(b1(:)-b2(:))      
       VEC_b(:, 5) =  (1.0D0/DBLE(nkb1)) *(b2(:)-b3(:))      
       VEC_b(:, 6) =  (1.0D0/DBLE(nkb1)) *(b3(:)-b1(:))      
       VEC_b(:, 7) = -(1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:, 8) = -(1.0D0/DBLE(nkb1)) * b2(:) 
       VEC_b(:, 9) = -(1.0D0/DBLE(nkb1)) * b3(:) 
       VEC_b(:,10) = -(1.0D0/DBLE(nkb1)) *(b1(:)-b2(:))   
       VEC_b(:,11) = -(1.0D0/DBLE(nkb1)) *(b2(:)-b3(:))   
       VEC_b(:,12) = -(1.0D0/DBLE(nkb1)) *(b3(:)-b1(:))   
       VEC_b2=VEC_b(1,1)**2+VEC_b(2,1)**2+VEC_b(3,1)**2 
       WEIGHT_b(:) = 3.0d0/dble(NB)/VEC_b2              
       !WEIGHT_b(:) = (1.0D0/8.0D0)*(alat*nkb1/tpi)**2 
      !--
      case(4)!=== CASE(4) HCP PRIMITIVE CELL ===      
       NB=8 
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       b_LAT(:,:) = 0.0D0 
       b_LAT(1,1) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,2) =  (1.0D0/DBLE(nkb2))
       b_LAT(1,3) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,3) = -(1.0D0/DBLE(nkb2))!SiO2(hcp)
       !b_LAT(2,3) =  (1.0D0/DBLE(nkb2))!Re(hcp)
       b_LAT(1,4) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,5) = -(1.0D0/DBLE(nkb2))
       b_LAT(1,6) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,6) =  (1.0D0/DBLE(nkb2))!SiO2(hcp) 
       !b_LAT(2,6) = -(1.0D0/DBLE(nkb2))!Re(hcp)
       b_LAT(3,7) =  (1.0D0/DBLE(nkb3))
       b_LAT(3,8) = -(1.0D0/DBLE(nkb3))
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:,1) =  (1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:,2) =  (1.0D0/DBLE(nkb2)) * b2(:) 
       VEC_b(:,3) =  (1.0D0/DBLE(nkb1)) * b1(:) 
     +            -  (1.0D0/DBLE(nkb2)) * b2(:)!SiO2(hcp) 
!+            +  (1.0D0/DBLE(nkb2)) * b2(:)!Re(hcp) 
       VEC_b(:,4) = -(1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:,5) = -(1.0D0/DBLE(nkb2)) * b2(:) 
       VEC_b(:,6) = -(1.0D0/DBLE(nkb1)) * b1(:) 
     +            +  (1.0D0/DBLE(nkb2)) * b2(:)!SiO2(hcp)  
!+            -  (1.0D0/DBLE(nkb2)) * b2(:)!Re(hcp)
       VEC_b(:,7) =  (1.0D0/DBLE(nkb3)) * b3(:) 
       VEC_b(:,8) = -(1.0D0/DBLE(nkb3)) * b3(:)            
       La = DSQRT( a1(1)**2 + a1(2)**2 + a1(3)**2 )     
       Lc = DSQRT( a3(1)**2 + a3(2)**2 + a3(3)**2 )     
       WEIGHT_b(:) = 0.0D0             
       WEIGHT_b(1) = (1.0D0/4.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(2) = (1.0D0/4.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(3) = (1.0D0/4.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(4) = (1.0D0/4.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(5) = (1.0D0/4.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(6) = (1.0D0/4.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(7) = (1.0D0/2.0D0)*(Lc*nkb3/tpi)**2 
       WEIGHT_b(8) = (1.0D0/2.0D0)*(Lc*nkb3/tpi)**2 
      !--
      case(5)!=== CASE(5) ORTHORHOMBIC OR TETRAGONAL CELL ===
       NB=6 
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       b_LAT(:,:) = 0.0D0 
       b_LAT(1,1) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,2) =  (1.0D0/DBLE(nkb2))
       b_LAT(3,3) =  (1.0D0/DBLE(nkb3))
       b_LAT(1,4) = -(1.0D0/DBLE(nkb1))
       b_LAT(2,5) = -(1.0D0/DBLE(nkb2))
       b_LAT(3,6) = -(1.0D0/DBLE(nkb3))
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:,1) =  (1.0D0/DBLE(nkb1)) * b1(:) 
       VEC_b(:,2) =  (1.0D0/DBLE(nkb2)) * b2(:) 
       VEC_b(:,3) =  (1.0D0/DBLE(nkb3)) * b3(:) 
       VEC_b(:,4) = -(1.0D0/DBLE(nkb1)) * b1(:)
       VEC_b(:,5) = -(1.0D0/DBLE(nkb2)) * b2(:) 
       VEC_b(:,6) = -(1.0D0/DBLE(nkb3)) * b3(:) 
       La = DSQRT( a1(1)**2 + a1(2)**2 + a1(3)**2 )     
       Lb = DSQRT( a2(1)**2 + a2(2)**2 + a2(3)**2 )     
       Lc = DSQRT( a3(1)**2 + a3(2)**2 + a3(3)**2 )     
       WEIGHT_b(:) = 0.0D0             
       WEIGHT_b(1) = (1.0D0/2.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(2) = (1.0D0/2.0D0)*(Lb*nkb2/tpi)**2 
       WEIGHT_b(3) = (1.0D0/2.0D0)*(Lc*nkb3/tpi)**2 
       WEIGHT_b(4) = (1.0D0/2.0D0)*(La*nkb1/tpi)**2 
       WEIGHT_b(5) = (1.0D0/2.0D0)*(Lb*nkb2/tpi)**2 
       WEIGHT_b(6) = (1.0D0/2.0D0)*(Lc*nkb3/tpi)**2 
      !--
      case(6)!=== CASE(6) MONOCLINIC CELL === 
       NB=8
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       b_LAT(:,:) = 0.0D0 
       b_LAT(1,1) =  (1.0D0/DBLE(nkb1))
       b_LAT(3,2) =  (1.0D0/DBLE(nkb3))
       b_LAT(1,3) =  (1.0D0/DBLE(nkb1))
       b_LAT(3,3) = -(1.0D0/DBLE(nkb3))
       b_LAT(1,4) = -(1.0D0/DBLE(nkb1))
       b_LAT(3,5) = -(1.0D0/DBLE(nkb3))
       b_LAT(1,6) = -(1.0D0/DBLE(nkb1))
       b_LAT(3,6) =  (1.0D0/DBLE(nkb3))
       b_LAT(2,7) =  (1.0D0/DBLE(nkb2))
       b_LAT(2,8) = -(1.0D0/DBLE(nkb2))
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:,1) = (1.0D0/DBLE(nkb1))*b1(:) 
       VEC_b(:,2) = (1.0D0/DBLE(nkb3))*b3(:) 
       VEC_b(:,3) = VEC_b(:,1)-VEC_b(:,2)
       VEC_b(:,4) =-VEC_b(:,1)
       VEC_b(:,5) =-VEC_b(:,2)
       VEC_b(:,6) =-VEC_b(:,3)
       VEC_b(:,7) = (1.0D0/DBLE(nkb2))*b2(:) 
       VEC_b(:,8) =-VEC_b(:,7)
       s = VEC_b(1,1)
       t = VEC_b(3,1)
       u = VEC_b(3,2)
       v = VEC_b(2,7) 
       WEIGHT_b(:) = 0.0D0             
       WEIGHT_b(1) = (u-t)/(2.0d0*(s**2)*u) 
       WEIGHT_b(2) = (s**2-t*(u-t))/(2.0d0*(s**2)*(u**2))
       WEIGHT_b(3) = t/(2.0d0*(s**2)*u) 
       WEIGHT_b(4) = WEIGHT_b(1)
       WEIGHT_b(5) = WEIGHT_b(2)
       WEIGHT_b(6) = WEIGHT_b(3)
       WEIGHT_b(7) = 1.0d0/(2.0d0*(v**2)) 
       WEIGHT_b(8) = WEIGHT_b(7) 
      !--
      case(8)!=== CASE(8) BCT CELL === 2011/1/4 by Y.Nomura ===
       write(6,*) 
       write(6,*)'==============================='
       write(6,*)' body centered tetragonal cell '
       write(6,*)'==============================='
       write(6,*) 
       NB=10
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       if(nkb1/=nkb2)stop'nkb1/=nkb2'
       if(nkb1/=nkb3)stop'nkb1/=nkb3'
       if(nkb2/=nkb3)stop'nkb2/=nkb3'
       b_LAT(:,:)=0.0D0 
       b_LAT(1,1)=(1.0D0/DBLE(nkb1))
       b_LAT(2,1)=(1.0D0/DBLE(nkb2))
       b_LAT(3,1)=-(1.0D0/DBLE(nkb3))
       b_LAT(1,2)=(1.0D0/DBLE(nkb1))
       b_LAT(2,3)=(1.0D0/DBLE(nkb2))
       b_LAT(1,4)=(1.0D0/DBLE(nkb1))
       b_LAT(3,4)=-(1.0D0/DBLE(nkb3))
       b_LAT(2,5)=(1.0D0/DBLE(nkb2))
       b_LAT(3,5)=-(1.0D0/DBLE(nkb3))
       b_LAT(:,6)=-b_LAT(:,1)
       b_LAT(:,7)=-b_LAT(:,2)
       b_LAT(:,8)=-b_LAT(:,3)
       b_LAT(:,9)=-b_LAT(:,4)
       b_LAT(:,10)=-b_LAT(:,5)
       VEC_b(:,:)=0.0D0                            
       VEC_b(:,1)=(1.0D0/DBLE(nkb1))*(b1(:)+b2(:)-b3(:))
       VEC_b(:,2)=(1.0D0/DBLE(nkb1))*b1(:) 
       VEC_b(:,3)=(1.0D0/DBLE(nkb2))*b2(:) 
       VEC_b(:,4)=(1.0D0/DBLE(nkb1))*b1(:)-(1.0D0/DBLE(nkb3))*b3(:)
       VEC_b(:,5)=(1.0D0/DBLE(nkb2))*b2(:)-(1.0D0/DBLE(nkb3))*b3(:)
       VEC_b(:,6)=-VEC_b(:,1)
       VEC_b(:,7)=-VEC_b(:,2)
       VEC_b(:,8)=-VEC_b(:,3)
       VEC_b(:,9)=-VEC_b(:,4)
       VEC_b(:,10)=-VEC_b(:,5)
!--
!NUMPACK
!       NBh=NB/2 
!       allocate(VEC_d(6));VEC_d(:)=0.0d0                  
!       allocate(bb(NBh,6));bb(:,:)=0.0d0 
!       allocate(aa(NBh,6));aa(:,:)=0.0d0 
!       do ib=1,Nbh 
!        ab=0
!        do ix=1,3
!         do jx=ix,3
!          ab=ab+1
!          bb(ib,ab)=VEC_b(ix,ib)*VEC_b(jx,ib)
!         enddo 
!        enddo 
!       enddo 
!       aa=bb 
!!do i=1,NBh 
!! write(6,'(10f20.5)')(bb(i,j),j=1,6)!org 
!!enddo 
!       call inv_ge(NBh,6,aa(1,1)) 
!!do i=1,NBh 
!! write(6,'(10f20.5)')(aa(i,j),j=1,6)!inv
!!enddo 
!!write(6,*) 
!!write(6,*)'CHECK BB*AA=1'       
!!write(6,*) 
!!do i=1,NBh
!! do j=1,NBh 
!!  SUM_REAL=0.0d0
!!  do k=1,6 
!!   SUM_REAL=SUM_REAL+bb(i,k)*aa(j,k)
!!  enddo 
!!  write(6,'(i5,i5,f15.10)') i,j,SUM_REAL 
!! enddo
!!enddo 
!--
!LAPACK
       NBh=NB/2 
       allocate(VEC_d(6));VEC_d(:)=0.0d0!tmp                   
       allocate(aa(6,6));aa(:,:)=0.0d0!matrix A tmp
       allocate(bb(6,6));bb(:,:)=0.0d0!matrix A^-1 tmp
       do ib=1,Nbh 
        ab=0
        do ix=1,3
         do jx=ix,3
          ab=ab+1
          aa(ib,ab)=VEC_b(ix,ib)*VEC_b(jx,ib)
         enddo 
        enddo 
       enddo 
       !--
       !bb<-aa 
       do i=1,6
        do j=1,6
         bb(j,i)=aa(i,j) 
        enddo
       enddo 
!--
!do i=1,n 
! write(6,'(10f15.10)')(bb(i,j),j=1,n)!org 
!enddo 
!--
       call inv_ge_lapack(6,NBh,bb(1,1)) 
!--
!write(6,*) 
!do i=1,n 
! write(6,'(10f15.10)')(bb(i,j),j=1,n)!inv
!enddo 
!--
!      write(6,*) 
!      write(6,*)'CHECK BB*AA=1'       
!      write(6,*) 
!      do i=1,NBh
!       do j=1,NBh 
!        s=0.0d0
!        do k=1,n 
!         s=s+aa(i,k)*bb(j,k)
!        enddo 
!        write(6,'(i5,i5,f15.10)') i,j,s
!       enddo
!      enddo 
!--
       VEC_d(1)=0.5d0!xx
       VEC_d(2)=0.0d0!xy
       VEC_d(3)=0.0d0!xz
       VEC_d(4)=0.5d0!yy 
       VEC_d(5)=0.0d0!yz 
       VEC_d(6)=0.5d0!zz
       !--
       WEIGHT_b(:)=0.0D0             
       do ib=1,Nbh
        ab=0
        SUM_REAL=0.0d0 
        do ix=1,3
         do jx=ix,3
          ab=ab+1
          !SUM_REAL=SUM_REAL+VEC_d(ab)*aa(ib,ab)!NUMPACK
          SUM_REAL=SUM_REAL+VEC_d(ab)*bb(ib,ab)!LAPACK 
         enddo 
        enddo 
        WEIGHT_b(ib)=SUM_REAL 
       enddo 
       WEIGHT_b(6)=WEIGHT_b(1)
       WEIGHT_b(7)=WEIGHT_b(2)
       WEIGHT_b(8)=WEIGHT_b(3) 
       WEIGHT_b(9)=WEIGHT_b(4) 
       WEIGHT_b(10)=WEIGHT_b(5) 
      !--
      case(7)!=== CASE(7) TRICLINIC CELL ===* 
       NB=12 
       allocate(b_LAT(3,NB));b_LAT(:,:)=0.0D0 
       allocate(VEC_b(3,NB));VEC_b(:,:)=0.0d0                 
       allocate(WEIGHT_b(NB));WEIGHT_b(:)=0.0D0             
       NBh=NB/2 
       b_LAT(:,:) = 0.0D0 
       b_LAT(1,1) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,2) =  (1.0D0/DBLE(nkb2))
       b_LAT(3,3) =  (1.0D0/DBLE(nkb3))
       b_LAT(1,4) =  (1.0D0/DBLE(nkb1))
       b_LAT(2,4) = -(1.0D0/DBLE(nkb2))
       b_LAT(2,5) =  (1.0D0/DBLE(nkb2))
       b_LAT(3,5) = -(1.0D0/DBLE(nkb3))
       b_LAT(3,6) =  (1.0D0/DBLE(nkb3))
       b_LAT(1,6) = -(1.0D0/DBLE(nkb1))
       b_LAT(:,7) = -b_LAT(:,1) 
       b_LAT(:,8) = -b_LAT(:,2) 
       b_LAT(:,9) = -b_LAT(:,3) 
       b_LAT(:,10)= -b_LAT(:,4) 
       b_LAT(:,11)= -b_LAT(:,5) 
       b_LAT(:,12)= -b_LAT(:,6) 
       VEC_b(:,:) = 0.0D0                            
       VEC_b(:,1) = (1.0D0/DBLE(nkb1))*b1(:) 
       VEC_b(:,2) = (1.0D0/DBLE(nkb2))*b2(:) 
       VEC_b(:,3) = (1.0D0/DBLE(nkb3))*b3(:) 
       VEC_b(:,4) = VEC_b(:,1)-VEC_b(:,2)
       VEC_b(:,5) = VEC_b(:,2)-VEC_b(:,3)
       VEC_b(:,6) = VEC_b(:,3)-VEC_b(:,1)
       VEC_b(:,7) =-VEC_b(:,1)
       VEC_b(:,8) =-VEC_b(:,2)
       VEC_b(:,9) =-VEC_b(:,3)
       VEC_b(:,10)=-VEC_b(:,4)
       VEC_b(:,11)=-VEC_b(:,5)
       VEC_b(:,12)=-VEC_b(:,6)
       allocate(VEC_d(NBh));VEC_d(:)=0.0d0                  
       allocate(bb(NBh,NBh));bb(:,:)=0.0d0 
       do ib=1,Nbh 
        ab=0
        do ix=1,3
         do jx=ix,3
          ab=ab+1
          bb(ib,ab)=VEC_b(ix,ib)*VEC_b(jx,ib)
         enddo 
        enddo 
       enddo 
       call invmat(Nbh,bb(1,1)) 
       VEC_d(1)=0.5d0 !xx
       VEC_d(2)=0.0d0 !xy
       VEC_d(3)=0.0d0 !xz
       VEC_d(4)=0.5d0 !yy 
       VEC_d(5)=0.0d0 !yz 
       VEC_d(6)=0.5d0 !zz
       WEIGHT_b(:)=0.0D0             
       do ib=1,Nbh
        ab=0
        SUM_REAL=0.0d0 
        do ix=1,3
         do jx=ix,3
          ab=ab+1
          SUM_REAL=SUM_REAL+VEC_d(ab)*bb(ab,ib)
         enddo 
        enddo 
        WEIGHT_b(ib)=SUM_REAL
       enddo 
       WEIGHT_b(7) = WEIGHT_b(1)
       WEIGHT_b(8) = WEIGHT_b(2) 
       WEIGHT_b(9) = WEIGHT_b(3) 
       WEIGHT_b(10)= WEIGHT_b(4) 
       WEIGHT_b(11)= WEIGHT_b(5) 
       WEIGHT_b(12)= WEIGHT_b(6) 
      end select 
      !--
      do ibvec=1,NB 
       write(6,*) b_LAT(:,ibvec)       
      enddo 
      write(6,*) 
      SUM_REAL=0.0D0          
      Do ibvec=1,NB 
       SUM_REAL=SUM_REAL+WEIGHT_b(ibvec) 
      ENDDO           
      WEIGHT=SUM_REAL          
      !--
      write(6,*)'WEIGHT_b=',WEIGHT_b(:) 
      write(6,*)'WEIGHT  =',WEIGHT              
 
!======================
!=== CHECK SUM RULE ===
!======================

      write(6,*) 
      write(6,*)'SUM RULE CHECK OF B-VEC'       
      write(6,*) 
      Do IC=1,3   
       Do JC=1,3   
        SUM_REAL=0.0D0 
        Do ibvec=1,NB      
         SUM_REAL
     +  =SUM_REAL+WEIGHT_b(ibvec)*VEC_b(IC,ibvec)*VEC_b(JC,ibvec)
        ENDDO!ibvec            
        write(6,*) IC,JC,SUM_REAL          
       ENDDO!JC    
      ENDDO!IC    

!=========================
!=== INTERSTATE MATRIX ===
!=========================

      WRITE(6,*) 
      WRITE(6,*)'==================='
      WRITE(6,*)' INTERSTATE MATRIX '
      WRITE(6,*)'==================='
      WRITE(6,*) 
      allocate(OVERLAP(NTB,NTB,NTK,NB));OVERLAP=0.0D0   
      allocate(KPT(NTK,NB));KPT=0  
      nvx=nwx2+1;nvy=nwy2+1;nvz=nwz2+1 
!--
!$OMP PARALLEL PRIVATE(ik,C0_BRA,ig,ibvec,SHIFT_b,ik_ib,C0_KET,
!$OMP&  OVERLAP_TMP)
      allocate(C0_BRA(0:NTG,NTB));C0_BRA(0,:)=0.0D0       
      allocate(C0_KET(0:NTG,NTB));C0_KET(0,:)=0.0D0       
      allocate(SHIFT_b(3));SHIFT_b=0 
      allocate(OVERLAP_TMP(NTB,NTB));OVERLAP_TMP=0.0d0 
!$OMP DO 
      do ik=1,NTK       
!C0_BRA
       C0_BRA(0,:)=0.0D0       
       do ig=1,NG0(ik) 
        C0_BRA(ig,:)=C0(ig,:,ik)  
       enddo 
!SHIFT VECTOR
       do ibvec=1,NB               
        call make_shift_vector(NTK,NB,ik,ibvec,SK0(1,1),b_LAT(1,1),
     +  SHIFT_b(1),ik_ib)
        KPT(ik,ibvec)=ik_ib                
!C0_KET
        C0_KET(0,:)=0.0D0       
        do ig=1,NG0(ik_ib) 
         C0_KET(ig,:)=C0(ig,:,ik_ib)  
        enddo 
!CALC OVERLAP 
        CALL CALC_OVERLAP(NTK,NTB,NTG,nvx,nvy,nvz,ik,ik_ib,NG0(1),
     +  KG0(1,1,1),N_BAND(1),SHIFT_b(1),C0_BRA(0,1),C0_KET(0,1),
     +  OVERLAP_TMP(1,1),N_BAND_BTM(1))  
        OVERLAP(:,:,ik,ibvec)=OVERLAP_TMP(:,:)          
       !--
       enddo!ibvec                
      enddo!ik                           
!$OMP END DO 
      deallocate(C0_BRA,C0_KET,SHIFT_b,OVERLAP_TMP) 
!$OMP END PARALLEL 
      write(6,*)'finish calc ISM' 
      !--
      WRITE(6,*) 
      write(6,*)'================================================='
      write(6,*)' LOG{det[M(k,k+b)]} only when M is square matrix '
      write(6,*)'=================================================' 
      WRITE(6,*) 
      do ik=1,NTK       
       do ibvec=1,NB               
        ik_ib=KPT(ik,ibvec) 
        if(N_BAND(ik)==N_BAND(ik_ib))then 
         nm=N_BAND(ik) 
         allocate(mat_tmp(nm,nm));mat_tmp=0.0d0 
         mat_tmp(1:nm,1:nm)=OVERLAP(1:nm,1:nm,ik,ibvec) 
         call calcdet(nm,mat_tmp(1,1),DET) 
         write(6,'(a8,i6,a8,i6,a8,2f15.10)')
     +   'ik=',ik,'ik_ib=',ik_ib,'log=',log(DET) 
         deallocate(mat_tmp) 
        endif 
       enddo!ibvec                
      enddo!ik                           

!==============================================
!=== INITIAL GUESS FOR OMEGA_I MINIMIZATION ===
!==============================================

      allocate(orbtype(nigs)) 
      allocate(ALPHA_GAUSS(nigs));ALPHA_GAUSS(:)=0.0d0
      allocate(TAU_GAUSS(3,nigs));TAU_GAUSS(:,:)=0.0d0
      allocate(NORM_GAUSS(nigs));NORM_GAUSS(:)=0.0d0
      allocate(loc_x(3,nigs));loc_x=0.0d0
      allocate(loc_y(3,nigs));loc_y=0.0d0
      allocate(loc_z(3,nigs));loc_z=0.0d0
      !--
      do ig=1,nigs 
       orbtype(ig)=vec_ini(ig)%orb
       ALPHA_GAUSS(ig)=vec_ini(ig)%a 
       TAU_GAUSS(1,ig)=vec_ini(ig)%x
       TAU_GAUSS(2,ig)=vec_ini(ig)%y 
       TAU_GAUSS(3,ig)=vec_ini(ig)%z 
       loc_x(:,ig)=vec_ini(ig)%lx(:)
       loc_y(:,ig)=vec_ini(ig)%ly(:)
       loc_z(:,ig)=vec_ini(ig)%lz(:)
      enddo 
!--
!20170406 
      allocate(LGAUSS(nigs));LGAUSS(:)=0 
      allocate(MGAUSS(nigs));MGAUSS(:)=0 
      do ig=1,nigs 
       if(orbtype(ig)=='s')then 
        LGAUSS(ig)=1;MGAUSS(ig)=1   
       endif 
       if(orbtype(ig)=='px')then 
        LGAUSS(ig)=2;MGAUSS(ig)=1   
       endif 
       if(orbtype(ig)=='py')then 
        LGAUSS(ig)=2;MGAUSS(ig)=2   
       endif 
       if(orbtype(ig)=='pz')then 
        LGAUSS(ig)=2;MGAUSS(ig)=3   
       endif 
       if(orbtype(ig)=='dxy')then 
        LGAUSS(ig)=3;MGAUSS(ig)=1   
       endif 
       if(orbtype(ig)=='dyz')then 
        LGAUSS(ig)=3;MGAUSS(ig)=2   
       endif 
       if(orbtype(ig)=='dz2')then 
        LGAUSS(ig)=3;MGAUSS(ig)=3   
       endif 
       if(orbtype(ig)=='dzx')then 
        LGAUSS(ig)=3;MGAUSS(ig)=4   
       endif 
       if(orbtype(ig)=='dx2')then 
        LGAUSS(ig)=3;MGAUSS(ig)=5   
       endif 
      enddo!ig 
!--
!NORMALIZE
      Do ig=1,nigs
       iL=LGAUSS(ig) 
       IF(iL==1)THEN 
        NORM_GAUSS(ig)
     +  =(8.0D0*ALPHA_GAUSS(ig)/pi)**0.25D0
     +  *(4.0D0*ALPHA_GAUSS(ig)/1.0D0)**0.50D0    
       ENDIF 
       IF(iL==2)THEN 
        NORM_GAUSS(ig)
     +  =(8.0D0*ALPHA_GAUSS(ig)/pi)**0.25D0    
     +  *(4.0D0*ALPHA_GAUSS(ig)/1.0D0)**0.50D0    
     +  *(4.0D0*ALPHA_GAUSS(ig)/3.0D0)**0.50D0    
       ENDIF 
       IF(iL==3)THEN 
        NORM_GAUSS(ig)
     +  =(8.0D0*ALPHA_GAUSS(ig)/pi)**0.25D0    
     +  *(4.0D0*ALPHA_GAUSS(ig)/1.0D0)**0.50D0    
     +  *(4.0D0*ALPHA_GAUSS(ig)/3.0D0)**0.50D0    
     +  *(4.0D0*ALPHA_GAUSS(ig)/5.0D0)**0.50D0    
       ENDIF 
      ENDDO!ig 
      !--
      write(6,*) 
      write(6,*)'=================='
      write(6,*)'INITIAL GUESS DATA'
      write(6,*)'=================='
      write(6,*) 
      do ig=1,nigs 
       write(6,'(2i5,4f15.10)')
     + LGAUSS(ig),MGAUSS(ig),ALPHA_GAUSS(ig),TAU_GAUSS(:,ig)
      enddo 
      write(6,*) 
      write(6,*)'=================='
      write(6,*)'COORD IN CARTESIAN'
      write(6,*)'=================='
      write(6,*) 
      do ig=1,nigs
       tmp(:)=TAU_GAUSS(:,ig)  
       TAU_GAUSS(:,ig)=tmp(1)*a1(:)+tmp(2)*a2(:)+tmp(3)*a3(:) 
       write(6,'(3f20.12)') TAU_GAUSS(:,ig) 
      enddo 
      write(6,*) 
!--
!A_MAT
      write(6,*) 
      write(6,*)'=========='
      write(6,*)'CALC A_MAT' 
      write(6,*)'=========='
      write(6,*) 
      allocate(A_MAT(NTB,nigs,NTK));A_MAT=0.0d0          
!--
!$OMP PARALLEL PRIVATE(ik,A_TMP)
      allocate(A_TMP(NTB,nigs));A_TMP=0.0d0 
!$OMP DO 
      do ik=1,NTK         
       call make_amat(nigs,NTB,NTG,NG0(ik),SK0(1,ik),KG0(1,1,ik),
     + b1(1),b2(1),b3(1),TAU_GAUSS(1,1),ALPHA_GAUSS(1),
     + loc_x(1,1),loc_y(1,1),loc_z(1,1),LGAUSS(1),MGAUSS(1),
     + N_BAND(ik),C0(1,1,ik),N_BAND_BTM(ik),NORM_GAUSS(1),VOLUME,
     + A_TMP(1,1)) 
       A_MAT(:,:,ik)=A_TMP(:,:) 
      enddo!ik           
!$OMP END DO 
      deallocate(A_TMP) 
!$OMP END PARALLEL 
!--
!     do ik=1,NTK 
!      WRITE(6,*)'ik=',ik 
!      do i_band=1,N_BAND(ik)       
!       do j_gauss=1,nigs 
!        write(6,'(2i5,2f15.10)')i_band,j_gauss,A_MAT(i_band,j_gauss,ik)
!       enddo!j_gauss
!      enddo!i_band 
!      WRITE(6,*) 
!     enddo!ik  
!     WRITE(6,*) 
!--
!BMAT 
!SP2 WF 
!      B_MAT(:,:) = 0.0D0 
!      B_MAT(1,1) = DSQRT(1.0D0/3.0D0)  
!      B_MAT(1,2) = DSQRT(1.0D0/3.0D0)  
!      B_MAT(1,3) = DSQRT(1.0D0/3.0D0)  
!      B_MAT(2,1) =-DSQRT(2.0D0/3.0D0)  
!      B_MAT(2,2) = DSQRT(1.0D0/6.0D0)  
!      B_MAT(2,3) = DSQRT(1.0D0/6.0D0)  
!      B_MAT(3,4) = 1.0D0 
!      B_MAT(4,2) = DSQRT(1.0D0/2.0D0)  
!      B_MAT(4,3) =-DSQRT(1.0D0/2.0D0)  
!      B_MAT(5,5) = DSQRT(1.0D0/3.0D0)  
!      B_MAT(5,6) = DSQRT(1.0D0/3.0D0)  
!      B_MAT(5,7) = DSQRT(1.0D0/3.0D0)  
!      B_MAT(6,5) = DSQRT(2.0D0/3.0D0)  
!      B_MAT(6,6) =-DSQRT(1.0D0/6.0D0)  
!      B_MAT(6,7) =-DSQRT(1.0D0/6.0D0)  
!      B_MAT(7,8) = 1.0D0 
!      B_MAT(8,6) =-DSQRT(1.0D0/2.0D0)  
!      B_MAT(8,7) = DSQRT(1.0D0/2.0D0)  
!SP3 WF 
!      B_MAT(:,:) = 0.0D0 
!      B_MAT(1,1) =  0.5D0  
!      B_MAT(1,2) =  0.5D0  
!      B_MAT(1,3) =  0.5D0  
!      B_MAT(1,4) =  0.5D0  
!      B_MAT(2,1) = -0.5D0  
!      B_MAT(2,2) =  0.5D0  
!      B_MAT(2,3) = -0.5D0  
!      B_MAT(2,4) =  0.5D0  
!      B_MAT(3,1) =  0.5D0  
!      B_MAT(3,2) = -0.5D0  
!      B_MAT(3,3) = -0.5D0  
!      B_MAT(3,4) =  0.5D0  
!      B_MAT(4,1) = -0.5D0  
!      B_MAT(4,2) = -0.5D0  
!      B_MAT(4,3) =  0.5D0  
!      B_MAT(4,4) =  0.5D0  
!      B_MAT(5,5) =  0.5D0  
!      B_MAT(5,6) =  0.5D0  
!      B_MAT(5,7) =  0.5D0  
!      B_MAT(5,8) =  0.5D0  
!      B_MAT(6,5) =  0.5D0  
!      B_MAT(6,6) = -0.5D0  
!      B_MAT(6,7) =  0.5D0  
!      B_MAT(6,8) = -0.5D0  
!      B_MAT(7,5) = -0.5D0  
!      B_MAT(7,6) =  0.5D0  
!      B_MAT(7,7) =  0.5D0  
!      B_MAT(7,8) = -0.5D0  
!      B_MAT(8,5) =  0.5D0  
!      B_MAT(8,6) =  0.5D0  
!      B_MAT(8,7) = -0.5D0  
!      B_MAT(8,8) = -0.5D0  
!--
!A_MAT=A_MAT*B_MAT
      allocate(A_TMP(NTB,nigs));A_TMP=0.0d0 
      do ik=1,NTK 
       A_TMP(:,:)=A_MAT(:,:,ik) 
       do ib=1,N_BAND(ik)
        do ig=1,NGAUSS
         SUM_CMPX=0.0D0 
         do jg=1,nigs
          SUM_CMPX=SUM_CMPX+A_TMP(ib,jg)*B_MAT(jg,ig) 
         ENDDO 
         A_MAT(ib,ig,ik)=SUM_CMPX 
        ENDDO!ig 
       ENDDO!ib
      ENDDO!ik 
      write(6,*)'finish calc A_MAT' 
      !--
      allocate(S_MAT(NGAUSS,NGAUSS));S_MAT(:,:)=0.0D0
      allocate(S_TMP(NGAUSS,NGAUSS));S_TMP(:,:)=0.0d0
      allocate(S_EIG(NGAUSS));S_EIG(:)=0.0D0
      allocate(X_MAT(NGAUSS,NGAUSS));X_MAT(:,:)=0.0D0
      allocate(S_HALF_MAT(NGAUSS,NGAUSS));S_HALF_MAT(:,:)=0.0D0
      allocate(C_MAT(NTB,NGAUSS,NTK));C_MAT(:,:,:)=0.0D0          
      !--
      do ik=1,NTK        
!S_MAT
       S_MAT(:,:)=0.0d0 
       do ig=1,NGAUSS
        do jg=1,NGAUSS
         SUM_CMPX=0.0D0         
         do ib=1,N_BAND(ik)        
          SUM_CMPX=SUM_CMPX+CONJG(A_MAT(ib,ig,ik))*A_MAT(ib,jg,ik)   
         enddo!ib
         S_MAT(ig,jg)=SUM_CMPX 
        enddo!jg
       enddo!ig       
!--
!      write(6,*)'IK=',ik     
!       do ig=1,NGAUSS
!        do jg=1,NGAUSS
!         write(6,'(2i5,2f15.10)') ig,jg,S_MAT(ig,jg) 
!        enddo!ig       
!       enddo!jg       
!       write(6,*) 
!diag S_MAT
       S_EIG(:)=0.0D0                
       S_TMP(:,:)=S_MAT(:,:) 
       call diagV(NGAUSS,S_TMP(1,1),S_EIG(1)) 
       X_MAT(:,:)=S_TMP(:,:)
       do ig=1,NGAUSS 
        if(S_EIG(ig)<=0.0D0)then 
         write(6,*)'WARNING diag S_MAT' 
         write(6,*) ig,S_EIG(ig) 
         S_EIG(ig)=1.0D-10 
        endif 
       enddo 
!S_HALF_MAT
       S_HALF_MAT(:,:)=0.0D0 
       S_EIG(:)=1.0D0/DSQRT(S_EIG(:)) 
       do ig=1,NGAUSS
        do jg=1,NGAUSS
         SUM_CMPX=0.0D0         
         do kg=1,NGAUSS      
          SUM_CMPX=SUM_CMPX+X_MAT(ig,kg)*S_EIG(kg)*CONJG(X_MAT(jg,kg)) 
         enddo!kg 
         S_HALF_MAT(ig,jg)=SUM_CMPX  
        enddo!jg 
       enddo!ig 
!C_MAT
       do ib=1,N_BAND(ik)         
        do jg=1,NGAUSS
         SUM_CMPX=0.0D0             
         do kg=1,NGAUSS             
          SUM_CMPX=SUM_CMPX+A_MAT(ib,kg,ik)*S_HALF_MAT(kg,jg)        
         enddo 
         C_MAT(ib,jg,ik)=SUM_CMPX         
        enddo!jg       
       enddo!ib    
      enddo!ik ===CONSTRUCT C_MAT ROOP===      
      deallocate(S_MAT,S_TMP,S_EIG,X_MAT,S_HALF_MAT)
      ! 
      !write(6,*)'C_MAT'
      !write(6,*) C_MAT 
      ! 
!--
!      WRITE(6,*) 
!      WRITE(6,*)'==========================='
!      WRITE(6,*)'CHECK OF UNITALITY OF C_MAT'
!      WRITE(6,*)'==========================='
!      WRITE(6,*) 
!      do ik=1,NTK      
!       do i_gauss=1,NGAUSS       
!        do j_gauss=1,NGAUSS
!         SUM_CMPX=0.0D0             
!         do i_band=1,N_BAND(ik)        
!          SUM_CMPX 
!     +   =SUM_CMPX 
!     +   +CONJG(C_MAT(i_band,i_gauss,ik))  
!     +   *      C_MAT(i_band,j_gauss,ik)        
!         enddo 
!         write(6,'(2I5,2F20.15)') i_gauss,j_gauss,SUM_CMPX
!        enddo!j_gauss     
!       enddo!i_gauss     
!       write(6,*) 
!      enddo!ik            
!
!=========================================================
!=== CALCULATE THE NUMBER OF BANDS INSIDE INNER WINDOW ===
!=========================================================

      if(set_inner_window)then 
       allocate(N_BAND_inner(NTK));N_BAND_inner=0
       allocate(N_BAND_BTM_inner(NTK));N_BAND_BTM_inner=0
       allocate(inner(NTB,NTK));inner=0
       write(6,*) 
       write(6,*)'===================================='
       write(6,*)'BAND INFO INSIDE INNER ENERGY WINDOW'
       write(6,*)'===================================='
       write(6,*) 
       do ik=1,NTK 
        SUM_INT=0 
        do ib=1,N_BAND(ik) 
         if(E_LOWER_inner<=E_EIG(N_BAND_BTM(ik)+ib,ik).and.
     +      E_EIG(N_BAND_BTM(ik)+ib,ik)<=E_UPPER_inner)then 
          inner(ib,ik)=1
          SUM_INT=SUM_INT+1 
          if(SUM_INT==1) N_BAND_BTM_inner(ik)=ib-1  
         endif 
        enddo 
        N_BAND_inner(ik)=SUM_INT
!--
!check N_BAND_inner(ik) <= N_wannier 
        if(N_BAND_inner(ik)>N_wannier)then 
         write(6,'(a)')'inner energy window setting: WRONG'
         write(6,'(a)')'NBAND_inner SHOULD BE SMALLER THAN N_wannier'
         write(6,'(a,3i8)')'ik, N_BAND_inner(ik), N_wannier',
     +                      ik, N_BAND_inner(ik), N_wannier 
         stop 
        endif  
        write(6,*) ik,N_BAND_BTM_inner(ik),N_BAND_inner(ik) 
       enddo!ik  
       write(6,*) 
!--
!initial CMAT
       do ik=1,NTK 
!X=QPQ 
        allocate(P_MAT(NTB,NTB));P_MAT=0.0d0
        do ib=1,N_BAND(ik)
         do jb=1,N_BAND(ik)
          SUM_CMPX=0.0d0 
          do jg=1,NGAUSS 
           SUM_CMPX=SUM_CMPX+C_MAT(ib,jg,ik)*CONJG(C_MAT(jb,jg,ik)) 
          enddo 
          P_MAT(ib,jb)=SUM_CMPX 
         enddo!jb  
        enddo!ib
        allocate(Qin(NTB,NTB));Qin=0.0d0
        do ib=1,N_BAND(ik)
         if(inner(ib,ik)==1)cycle 
         Qin(ib,ib)=1.0d0 
        enddo 
!--
!        do ib=1,N_BAND_inner(ik)
!         do jb=1,N_BAND_inner(ik) 
!          Qin(ib+N_BAND_BTM_inner(ik),jb+N_BAND_BTM_inner(ik)) 
!     +   =Qin(ib+N_BAND_BTM_inner(ik),jb+N_BAND_BTM_inner(ik)) 
!     +   -P_MAT(ib+N_BAND_BTM_inner(ik),jb+N_BAND_BTM_inner(ik)) 
!         enddo 
!        enddo 
!--
        allocate(X_MAT(NTB,NTB));X_MAT=0.0d0  
        do ib=1,N_BAND(ik)
         do jb=1,N_BAND(ik) 
          SUM_CMPX=0.0d0 
          do k=1,N_BAND(ik) 
           do l=1,N_BAND(ik) 
            SUM_CMPX=SUM_CMPX+CONJG(Qin(k,ib))*P_MAT(k,l)*Qin(l,jb) 
           enddo!l 
          enddo!k 
          X_MAT(ib,jb)=SUM_CMPX 
         enddo!jb
        enddo!ib  
!XC=Cx
        nm=N_BAND(ik) 
        allocate(mat_tmp(nm,nm));mat_tmp(:,:)=0.0d0 
        allocate(eig_tmp(nm));eig_tmp(:)=0.0d0        
        mat_tmp(1:nm,1:nm)=X_MAT(1:nm,1:nm) 
        call diagV(nm,mat_tmp(1,1),eig_tmp(1)) 
!descending order
        X_MAT=0.0d0 
        do ib=1,nm 
         X_MAT(1:nm,ib)=mat_tmp(1:nm,nm-ib+1) 
        enddo 
        deallocate(mat_tmp,eig_tmp) 
!CMAT 
        do jg=1,NGAUSS-N_BAND_inner(ik) 
         C_MAT(:,jg,ik)=X_MAT(:,jg) 
        enddo               
        do jg=1,N_BAND_inner(ik) 
         C_MAT(:,NGAUSS-N_BAND_inner(ik)+jg,ik)=0.0d0 
        enddo 
        do ib=1,N_BAND_inner(ik)
         i=N_BAND_BTM_inner(ik)+ib 
         j=NGAUSS-N_BAND_inner(ik)+ib 
         C_MAT(i,j,ik)=1.0d0 
        enddo 
        deallocate(P_MAT,Qin,X_MAT) 
       enddo!ik   
      else
       allocate(N_BAND_inner(NTK));N_BAND_inner=0
       allocate(N_BAND_BTM_inner(NTK));N_BAND_BTM_inner=0
       allocate(inner(NTB,NTK));inner=0
      endif!set_inner_window 
!--
!      write(6,*)'INNER'
!      do ik=1,NTK 
!       write(6,*) ik,N_BAND_BTM_inner(ik),N_BAND_inner(ik) 
!      enddo 
!--
      WRITE(6,*) 
      WRITE(6,*)'==========================================='        
      WRITE(6,*)'=== MINIMIZATION OF SPILLAGE FUNCTIONAL ==='
      WRITE(6,*)'==========================================='        
      WRITE(6,*) 
      !--
      allocate(Z_EIG(NTB));Z_EIG(:)=0.0D0            
      allocate(Z_MAT(NTB,NTB,NTK));Z_MAT(:,:,:)=0.0D0        
      allocate(Z_TMP(NTB,NTB));Z_TMP(:,:)=0.0D0               
      allocate(C_TMP(NTB,NTB));C_TMP(:,:)=0.0D0      
      allocate(M_MAT(NTB,NTB,NTK,NB));M_MAT(:,:,:,:)=0.0D0            
!--
!N    : NGAUSS  
!N_k  : N_BAND(ik) 
!N_k+b: N_BAND(ik_ib) 
!M_k  : N_BAND_inner(ik) 
!--
      I_SCF=0           
      DEL_OMEGA_I=1.0D0 
      OMEGA_I_OLD=0.0D0        
      do while(DEL_OMEGA_I>EPS_SPILLAGE) 
!make M_MAT: size = N_k * N_k+b 
       M_MAT(:,:,:,:)=0.0D0            
       do ik=1,NTK         
        do ibvec=1,NB 
         ik_ib=KPT(ik,ibvec)       
         do ib=1,N_BAND(ik)       
          do jg=1,NGAUSS 
           SUM_CMPX=0.0D0             
           do kb=1,N_BAND(ik_ib)         
            SUM_CMPX=SUM_CMPX+OVERLAP(ib,kb,ik,ibvec)*C_MAT(kb,jg,ik_ib)
           enddo 
           M_MAT(ib,jg,ik,ibvec)=SUM_CMPX       
          enddo!jg
         enddo!ib     
        enddo!ibvec  
       enddo!ik         
       !--
       SUM_REAL=0.0D0           
       OMEGA_I_NEW=0.0D0           
       C_MAT(:,:,:)=0.0D0 
       do ik=1,NTK           
!make Z_TMP: size = N_k * N_k 
        Z_TMP(:,:)=0.0D0               
        do ib=1,N_BAND(ik)    
         do jb=1,N_BAND(ik)    
          SUM_CMPX=0.0D0                
          do ibvec=1,NB          
           do jg=1,NGAUSS 
            SUM_CMPX
     +     =SUM_CMPX
     +     +WEIGHT_b(ibvec)
     +     *M_MAT(ib,jg,ik,ibvec)*CONJG(M_MAT(jb,jg,ik,ibvec))  
           enddo 
          enddo 
          Z_TMP(ib,jb)=SUM_CMPX                  
         enddo!jb         
        enddo!ib         
!make Z_MAT: damped Z_TMP
        IF(I_SCF==0) THEN  
         Z_MAT(:,:,ik)=Z_TMP(:,:)          
        ELSE 
         Z_MAT(:,:,ik)=DAMP*Z_TMP(:,:)+(1.0D0-DAMP)*Z_MAT(:,:,ik)   
        ENDIF        
!make X: size = (N_k-M_k)*(N_k-M_k) 
        nm=N_BAND(ik)-N_BAND_inner(ik)!inner window    
        allocate(mat_tmp(nm,nm));mat_tmp(:,:)=0.0d0 
        allocate(eig_tmp(nm));eig_tmp(:)=0.0d0        
        i=0 
        do ib=1,N_BAND(ik) 
         if(inner(ib,ik)==1)cycle 
         i=i+1 
         j=0 
         do jb=1,N_BAND(ik) 
          if(inner(jb,ik)==1)cycle
          j=j+1 
          mat_tmp(i,j)=Z_MAT(ib,jb,ik)
         enddo 
        enddo   
!diag X: XC'=C'x 
        eig_tmp(:)=0.0d0 
        !--
        !20180412 by Y.Nomura 
        !--
        if(nm>0)then
         call diagV(nm,mat_tmp(1,1),eig_tmp(1)) 
        endif 
        !--
!descending order
        Z_EIG(:)=0.0D0            
        C_TMP(:,:)=0.0d0 
        do ib=1,nm
         Z_EIG(ib)=eig_tmp(nm-ib+1)
         C_TMP(1:nm,ib)=mat_tmp(1:nm,nm-ib+1) 
        enddo 
        deallocate(mat_tmp,eig_tmp) 
!make C_MAT: size = N_k * N 
        i=0 
        do ib=1,N_BAND(ik) 
         if(inner(ib,ik)==0)then 
          i=i+1
          !C_MAT(ib,:,ik)=C_TMP(i,:) ###bag### 20171208
          C_MAT(ib,1:NGAUSS-N_BAND_inner(ik),ik)
     +   =C_TMP(i ,1:NGAUSS-N_BAND_inner(ik)) 
         else!(inner(ib,ik)==1) 
          C_MAT(ib,:,ik)=0.0d0 
         endif 
        enddo!ib  
        do jg=1,N_BAND_inner(ik) 
         C_MAT(:,NGAUSS-N_BAND_inner(ik)+jg,ik)=0.0d0 
        enddo 
        do ib=1,N_BAND_inner(ik)
         i=N_BAND_BTM_inner(ik)+ib 
         j=NGAUSS-N_BAND_inner(ik)+ib 
         C_MAT(i,j,ik)=1.0d0 
        enddo 
!--
!SPILLAGE 
        do ig=1,NGAUSS
         do jb=1,N_BAND(ik)
          do ib=1,N_BAND(ik)
           SUM_REAL
     +    =SUM_REAL 
     +    +dble(conjg(C_MAT(ib,ig,ik))*Z_MAT(ib,jb,ik)*C_MAT(jb,ig,ik)) 
          enddo 
         enddo 
        enddo 
        OMEGA_I_NEW=OMEGA_I_NEW+dble(NGAUSS)*WEIGHT 
!--
!        nm=NGAUSS-N_BAND_inner(ik)!inner window
!        do jg=1,nm
!         SUM_REAL=SUM_REAL+Z_EIG(jg) 
!        enddo 
!        OMEGA_I_NEW=OMEGA_I_NEW+dble(nm)*WEIGHT 
!--
       enddo!ik 
       OMEGA_I_NEW=(OMEGA_I_NEW-SUM_REAL)/DBLE(NTK)      
       DEL_OMEGA_I=DABS(OMEGA_I_NEW-OMEGA_I_OLD)            
       OMEGA_I_OLD=OMEGA_I_NEW          
       I_SCF=I_SCF+1                                       
       write(6,'(A8,I5,A15,F20.10,A10,F20.10)')'I_SCF=',I_SCF, 
     +         'DEL_OMEGA_I=',DEL_OMEGA_I,'OMEGA_I',OMEGA_I_NEW        
      enddo!do-while##### OMEGA_I MINIMIZATION ##### 
!--
!      do ik=1,NTK 
!       if(N_BAND_inner(ik)/=0)then 
!        write(6,*)'CMAT(fns) ik=',ik  
!        do ib=1,N_BAND(ik) 
!         write(6,'(100f10.5)')(C_MAT(ib,jg,ik),jg=1,NGAUSS)  
!        enddo 
!        write(6,*) 
!       endif 
!      enddo!ik
!===============================================
!=== PSEUDO EIGENSTATE AND PSEUDO EIGENVALUE === 
!===============================================

      allocate(PSEUDO_EIG(NGAUSS,NTK));PSEUDO_EIG(:,:)=0.0D0    
      allocate(PSEUDO_MAT(NGAUSS,NGAUSS,NTK));PSEUDO_MAT(:,:,:)=0.0D0 
      allocate(P_EIG(NGAUSS));P_EIG(:)=0.0d0 
      allocate(P_MAT_IN(NGAUSS,NGAUSS));P_MAT_IN(:,:)=0.0D0 
      allocate(P_MAT_OUT(NGAUSS,NGAUSS));P_MAT_OUT(:,:)=0.0D0 
      !--
      do ik=1,NTK               
!PSEUDO-KS 
       P_MAT_IN(:,:)=0.0D0          
       do ig=1,NGAUSS            
        do jg=1,NGAUSS           
         SUM_CMPX=0.0D0           
         do kb=1,N_BAND(ik)                 
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(C_MAT(kb,ig,ik))          
     +   *E_EIG(kb+N_BAND_BTM(ik),ik)      
     +   *C_MAT(kb,jg,ik)                     
         enddo 
         P_MAT_IN(ig,jg)=SUM_CMPX              
        enddo!jg        
       enddo!ig        
!diag PSEUDO-KS 
       P_EIG(:)=0.0D0            
       call diagV(NGAUSS,P_MAT_IN(1,1),P_EIG(1)) 
       P_MAT_OUT(:,:)=P_MAT_IN(:,:) 
       PSEUDO_MAT(:,:,ik)=P_MAT_OUT(:,:)          
       PSEUDO_EIG(:,ik)=P_EIG(:)          
      enddo!ik                    
      !deallocate(E_EIG) 
!--
!     do ik=1,NTK                  
!      write(6,'(30F15.10)')PSEUDO_EIG(:,ik)*au 
!     enddo 
!
!====================================================
!=== PREPARE INITIAL GUESS FOR OMEGA MINIMIZATION ===
!====================================================

      allocate(S_MAT(NGAUSS,NGAUSS));S_MAT(:,:)=0.0D0
      allocate(S_TMP(NGAUSS,NGAUSS));S_TMP(:,:)=0.0d0
      allocate(S_EIG(NGAUSS));S_EIG(:)=0.0D0
      allocate(X_MAT(NGAUSS,NGAUSS));X_MAT(:,:)=0.0D0
      allocate(S_HALF_MAT(NGAUSS,NGAUSS));S_HALF_MAT(:,:)=0.0D0
      Z_MAT(:,:,:)=0.0D0!INITIAL GUESS <---> CELL-PERIODIC 
      do ik=1,NTK               
!A_TMP
       A_TMP(:,:)=0.0D0             
       do ib=1,n_occ        
        do jg=1,NGAUSS          
         SUM_CMPX=0.0D0           
         do kb=1,N_BAND(ik)          
          do lg=1,NGAUSS    
           SUM_CMPX
     +    =SUM_CMPX
     +    +CONJG(PSEUDO_MAT(lg,ib,ik))          
     +    *CONJG(C_MAT(kb,lg,ik))          
     +    *A_MAT(kb,jg,ik)               
          ENDDO 
         ENDDO 
         A_TMP(ib,jg)=SUM_CMPX               
        ENDDO!jg      
       ENDDO!ib            
!S_MAT
       S_MAT(:,:)=0.0D0                   
       Do ig=1,NGAUSS
        Do jg=1,NGAUSS
         SUM_CMPX=0.0D0         
         Do kb=1,n_occ                      
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(A_TMP(kb,ig))
     +   *A_TMP(kb,jg) 
         ENDDO!kb
          S_MAT(ig,jg)=SUM_CMPX 
        ENDDO!jg
       ENDDO!ig       
!diag S_MAT
       S_EIG(:)=0.0D0            
       call diagV(NGAUSS,S_MAT(1,1),S_EIG(1)) 
       X_MAT(:,:)=S_MAT(:,:) 
       Do ig=1,NGAUSS 
        IF(S_EIG(ig)<=0.0D0) THEN 
         write(6,*) ig,S_EIG(ig) 
         S_EIG(ig)=1.0D-10 
        ENDIF       
       ENDDO 
!S_HALF_MAT
       S_EIG(:)=1.0D0/DSQRT(S_EIG(:)) 
       S_HALF_MAT(:,:)=0.0D0         
       Do ig=1,NGAUSS
        Do jg=1,NGAUSS
         SUM_CMPX=0.0D0         
         Do kg=1,NGAUSS      
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +X_MAT(ig,kg) 
     +   *S_EIG(kg) 
     +   *CONJG(X_MAT(jg,kg))          
         ENDDO 
         S_HALF_MAT(ig,jg)=SUM_CMPX  
        ENDDO!jg 
       ENDDO!ig 
!A_MAT
       A_MAT(:,:,ik)=0.0D0         
       Do ib=1,n_occ              
        Do jg=1,NGAUSS
         SUM_CMPX=0.0D0             
         Do kg=1,NGAUSS             
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +A_TMP(ib,kg) 
     +   *S_HALF_MAT(kg,jg)        
         ENDDO              
         A_MAT(ib,jg,ik)=SUM_CMPX         
        ENDDO!jg       
       ENDDO!ib    
!Z_MAT 
       Do ib=1,N_BAND(ik)          
        Do jg=1,NGAUSS 
         SUM_CMPX=0.0D0                   
         Do kg=1,NGAUSS 
          Do llb=1,n_occ                
           SUM_CMPX 
     +    =SUM_CMPX 
     +    +C_MAT(ib,kg,ik) 
     +    *PSEUDO_MAT(kg,llb,ik) 
     +    *A_MAT(llb,jg,ik)
          ENDDO 
         ENDDO 
         Z_MAT(ib,jg,ik)=SUM_CMPX          
        ENDDO!jg         
       ENDDO!ib          
      ENDDO!ik ##### INITIAL GUESS FOR OMEGA MINIMIZATION #####
      deallocate(S_MAT,S_TMP,S_EIG,X_MAT,S_HALF_MAT)
!--
!      WRITE(6,*) 
!      WRITE(6,*)'==========================='
!      WRITE(6,*)'CHECK OF UNITALITY OF Z_MAT'
!      WRITE(6,*)'==========================='
!      WRITE(6,*) 
!      do ik=1,NTK      
!       do i_gauss=1,NGAUSS       
!        do j_gauss=1,NGAUSS
!         SUM_CMPX=0.0D0             
!         do i_band=1,N_BAND(ik)        
!          SUM_CMPX 
!     +   =SUM_CMPX 
!     +   +CONJG(Z_MAT(i_band,i_gauss,ik))  
!     +   *Z_MAT(i_band,j_gauss,ik)        
!         enddo               
!         write(6,'(2i5,2f20.15)') i_gauss,j_gauss,SUM_CMPX
!        enddo!j_gauss     
!       enddo!i_gauss     
!       write(6,*)  
!      enddo!ik            
!
!=========================================
!=== MINIMIZATION OF SPREAD FUNCTIONAL ===
!=========================================

      WRITE(6,*) 
      WRITE(6,*)'====================================='
      WRITE(6,*)'INTERSTATE MATRIX; LOG{det[M(k,k+b)]}'
      WRITE(6,*)'====================================='
      WRITE(6,*) 

      M_MAT(:,:,:,:)=OVERLAP(:,:,:,:)                      
      OVERLAP(:,:,:,:)=0.0D0                                          
      Do ik=1,NTK 
       Do ibvec=1,NB      
        ik_ib=KPT(ik,ibvec)        
        Do i_band=1,n_occ!NOTICE n_occ=NGAUSS  
         Do j_band=1,n_occ!NOTICE n_occ=NGAUSS  
          SUM_CMPX=0.0D0           
          Do k_band=1,N_BAND(ik)      
           Do l_band=1,N_BAND(ik_ib)      
            SUM_CMPX 
     +     =SUM_CMPX 
     +     +CONJG(Z_MAT(k_band,i_band,ik)) 
     +     *      M_MAT(k_band,l_band,ik,ibvec)            
     +     *      Z_MAT(l_band,j_band,ik_ib) 
           ENDDO 
          ENDDO 
          OVERLAP(i_band,j_band,ik,ibvec)=SUM_CMPX          
         ENDDO!j_band        
        ENDDO!i_band        
        !--
        !DET
         nm=n_occ 
         allocate(mat_tmp(nm,nm));mat_tmp(:,:)=0.0d0 
         mat_tmp(1:nm,1:nm)=OVERLAP(1:nm,1:nm,ik,ibvec) 
         call calcdet(nm,mat_tmp(1,1),DET) 
         deallocate(mat_tmp) 
        !--
        write(6,'(a8,i5,a8,i5,a8,2f15.10)')
     +  'IK=',ik,'IK_IB=',ik_ib,'LOG=',LOG(DET) 
       ENDDO!ibvec                
       WRITE(6,*) 
      ENDDO!ik                           

!=================================
!=== INITIAL SPREAD FUNCTIONAL ===
!=================================

      allocate(WF_CHARGE(n_occ,NTK,NB));WF_CHARGE(:,:,:)=0.0d0       
      allocate(TR_GRAD(NTK));TR_GRAD(:)=0.0d0 
      allocate(TR_GRAD_OLD(NTK));TR_GRAD_OLD(:)=0.0d0   
      allocate(GRADIENT(n_occ,n_occ,NTK));GRADIENT(:,:,:)=0.0d0     
      allocate(DIRECTION(n_occ,n_occ,NTK));DIRECTION(:,:,:)=0.0d0      
      allocate(DIRECTION2(n_occ,n_occ,NTK));DIRECTION2(:,:,:)=0.0d0 
      allocate(UNITARY(n_occ,n_occ,NTK));UNITARY(:,:,:)=0.0d0        
      allocate(U_ORG(n_occ,n_occ,NTK));U_ORG(:,:,:)=0.0d0               
      allocate(U_OLD(n_occ,n_occ,NTK));U_OLD(:,:,:)=0.0d0               
      !--
      ILS=1           
      CALL CALC_OMEGA(NTK,NTB,n_occ,NB,VEC_b,ILS,WEIGHT_b,OVERLAP,
     +     WF_CHARGE,OMEGA_I,OMEGA_OD,OMEGA_D)                   
      !--
      write(6,*)'OMEGA_I =',OMEGA_I 
      write(6,*)'OMEGA_OD=',OMEGA_OD      
      write(6,*)'OMEGA_D =',OMEGA_D 
      write(6,*)'OMEGA_total=',OMEGA_I+OMEGA_D+OMEGA_OD
      WRITE(6,*) 
      WRITE(6,*)'========================================='        
      WRITE(6,*)'=== MINIMIZATION OF SPREAD FUNCTIONAL ==='
      WRITE(6,*)'========================================='        
      WRITE(6,*) 
      !--
      M_MAT(:,:,:,:)=OVERLAP(:,:,:,:)                      
      DEL_SPREAD=1.0d0!EPS_SPREAD=1.0D-6 default
      SPREAD_OLD=0.0D0 
      I_STEP=1        
      SPREAD=OMEGA_I+OMEGA_OD+OMEGA_D               
      do while(DEL_SPREAD>EPS_SPREAD) 
!--
!initial step 
      ILS=0 
      DELTA(1)=0.0D0  
      OMEGA(1)=SPREAD       
      write(6,*)'ILS=',ILS,DELTA(1),OMEGA(1)
!--
!CALC GRADIENT
      CALL CALC_GRADIENT(NTK,NTB,n_occ,NB,WF_CHARGE,WEIGHT_b,OVERLAP,
     +                   tci,GRADIENT,TR_GRAD) 
      DIRECTION(:,:,:)=GRADIENT(:,:,:) 
!--
!CONJUGATE GRADIENT
!      IF(I_STEP==1) THEN 
!       DIRECTION(:,:,:)=GRADIENT(:,:,:) 
!      ELSE                 
!       Do ik=1,NTK 
!         DIRECTION(:,:,ik) 
!     + = GRADIENT(:,:,ik) 
!     + + (TR_GRAD(ik)/TR_GRAD_OLD(ik)) 
!     + * DIRECTION(:,:,ik) 
!       ENDDO          
!      ENDIF              
!      TR_GRAD_OLD(:)=TR_GRAD(:) 
!--
!DIRECTION^2
      DIRECTION2(:,:,:)=0.0D0        
      Do ik=1,NTK        
       Do i_band=1,n_occ       
        Do j_band=1,n_occ       
         SUM_CMPX=0.0D0 
         Do k_band=1,n_occ    
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +DIRECTION(i_band,k_band,ik)     
     +   *DIRECTION(k_band,j_band,ik) 
         ENDDO!k_band     
         DIRECTION2(i_band,j_band,ik)=SUM_CMPX                
        ENDDO!j_band           
       ENDDO!i_band           
      ENDDO!ik       
!===
!=== ONE-DIMENSIONAL SEARCH 
!===
      ILS=1           
      STEP_LENGTH=MAX_STEP_LENGTH/4.0D0/WEIGHT 
      DELTA(2)=STEP_LENGTH 
      CALL UNITARY_GEN(NTK,n_occ,ILS,DIRECTION(1,1,1),DIRECTION2(1,1,1),
     +     STEP_LENGTH,UNITARY(1,1,1),U_ORG(1,1,1),U_OLD(1,1,1))   
      OVERLAP(:,:,:,:)=M_MAT(:,:,:,:) 
      CALL UPDATE_OVERLAP(NTK,NTB,n_occ,NB,KPT,UNITARY,OVERLAP)
      CALL CALC_OMEGA(NTK,NTB,n_occ,NB,VEC_b,ILS,      
     +     WEIGHT_b,OVERLAP,WF_CHARGE,OMEGA_I,OMEGA_OD,OMEGA_D) 
      OMEGA(2)=OMEGA_I+OMEGA_D+OMEGA_OD
      write(6,*)'ILS=',ILS,DELTA(2),OMEGA(2)
!20170917
      if(abs(OMEGA(1)-OMEGA(2))<1.0d-10)then
!update M_MAT
       M_MAT(:,:,:,:)=OVERLAP(:,:,:,:)                      
!update A_MAT
       CALL A_MAT_UPDATE(NTK,NTB,NGAUSS,n_occ,UNITARY,A_MAT)      
!CONVERGENCE CHECK
       SPREAD_OLD=OMEGA(1) 
       SPREAD=OMEGA(2) 
       DEL_SPREAD=ABS(SPREAD-SPREAD_OLD) 
       SPREAD_OLD=OMEGA(2)               
       write(6,*) 
       write(6,'(a47)')'==============================================' 
       write(6,'(a47)')' SPREAD HAS ALREADY CONVERGED IN INITIAL STEP ' 
       write(6,'(a47)')'=============================================='
       write(6,*) 
       write(6,'(a26,i8,2f20.10)')'I_STEP SPREAD DEL_SPREAD:', 
     +                             I_STEP,SPREAD,DEL_SPREAD 
       write(6,*)  
       I_STEP=I_STEP+1          
      else
       do while(OMEGA(1)>OMEGA(2)) 
        ILS=ILS+1           
        DELTA(3) = DELTA(2)+STEP_LENGTH 
        CALL UNITARY_GEN(NTK,n_occ,ILS,DIRECTION(1,1,1),
     +  DIRECTION2(1,1,1),STEP_LENGTH,UNITARY(1,1,1),
     +  U_ORG(1,1,1),U_OLD(1,1,1))          
        OVERLAP(:,:,:,:)=M_MAT(:,:,:,:) 
        CALL UPDATE_OVERLAP(NTK,NTB,n_occ,NB,
     +                      KPT,UNITARY,OVERLAP)                       
        CALL CALC_OMEGA(NTK,NTB,n_occ,NB,VEC_b,ILS,          
     +                  WEIGHT_b,OVERLAP,WF_CHARGE,
     +                  OMEGA_I,OMEGA_OD,OMEGA_D)                   
        OMEGA(3)=OMEGA_I+OMEGA_D+OMEGA_OD
        write(6,*) 'ILS=',ILS,DELTA(3),OMEGA(3) 
        IF(OMEGA(2)<OMEGA(3)) EXIT 
        DELTA(1)=DELTA(2) 
        OMEGA(1)=OMEGA(2) 
        DELTA(2)=DELTA(3) 
        OMEGA(2)=OMEGA(3) 
       enddo!do while 
       !--
       DELTA(4)=0.5D0*(OMEGA(1)*(DELTA(2)**2-DELTA(3)**2) 
     +                +OMEGA(2)*(DELTA(3)**2-DELTA(1)**2)
     +                +OMEGA(3)*(DELTA(1)**2-DELTA(2)**2))
     +               /(OMEGA(1)*(DELTA(2)-DELTA(3))        
     +                +OMEGA(2)*(DELTA(3)-DELTA(1))        
     +                +OMEGA(3)*(DELTA(1)-DELTA(2)))       
       ILS=1           
       STEP_LENGTH=DELTA(4) 
       CALL UNITARY_GEN(NTK,n_occ,ILS,DIRECTION(1,1,1),
     +      DIRECTION2(1,1,1),STEP_LENGTH,UNITARY(1,1,1),
     +      U_ORG(1,1,1),U_OLD(1,1,1))      
       OVERLAP(:,:,:,:) = M_MAT(:,:,:,:) 
       CALL UPDATE_OVERLAP(NTK,NTB,n_occ,NB,KPT,UNITARY,OVERLAP) 
       CALL CALC_OMEGA(NTK,NTB,n_occ,NB,VEC_b,ILS,         
     +      WEIGHT_b,OVERLAP,WF_CHARGE,OMEGA_I,OMEGA_OD,OMEGA_D)
       OMEGA(4) = OMEGA_I+OMEGA_D+OMEGA_OD
       write(6,*)'DELTA_OPT=',DELTA(4),'OMEGA_OPT=',OMEGA(4) 
       write(6,*)'OMEGA_I =',OMEGA_I 
       write(6,*)'OMEGA_OD=',OMEGA_OD
       write(6,*)'OMEGA_D =',OMEGA_D
!update M_MAT
       M_MAT(:,:,:,:)=OVERLAP(:,:,:,:)                      
!update A_MAT
       CALL A_MAT_UPDATE(NTK,NTB,NGAUSS,n_occ,UNITARY,A_MAT)      
!CONVERGENCE CHECK
       SPREAD=OMEGA(4) 
       DEL_SPREAD=ABS(SPREAD-SPREAD_OLD) 
       SPREAD_OLD=OMEGA(4)               
       write(6,'(a26,i8,2f20.10)')'I_STEP SPREAD DEL_SPREAD:', 
     +                             I_STEP,SPREAD,DEL_SPREAD 
       write(6,*)  
       I_STEP=I_STEP+1
      endif
      !--           
      ENDDO!##### SPREAD-MINIMIZATION ROOP #####         
!--
!      WRITE(6,*) 
!      WRITE(6,*)'========================'
!      WRITE(6,*)'UNITALITY CHECK OF A_MAT'
!      WRITE(6,*)'========================'
!      WRITE(6,*)  
!      do ik=1,NTK 
!       do ib=1,n_occ   
!        do jb=1,n_occ   
!         SUM_CMPX=0.0D0            
!         do kb=1,n_occ       
!          SUM_CMPX=SUM_CMPX+CONJG(A_MAT(kb,ib,ik))*A_MAT(kb,jb,ik) 
!         enddo 
!         write(6,*) ib,jb,SUM_CMPX        
!        enddo  
!       enddo  
!       write(6,*)       
!      enddo!ik        
!--
!wannier center 
      allocate(wannier_center(3,n_occ));wannier_center(:,:)=0.0d0  
      wannier_center(:,:)=0.0D0            
      Do i_band=1,n_occ       
       tmp(:)=0.0D0          
       Do ik=1,NTK        
        Do ibvec=1,NB           
         tmp(:) 
     +  =tmp(:) 
     +  +WEIGHT_b(ibvec) 
     +  *VEC_b(:,ibvec) 
     +  *AIMAG(LOG(OVERLAP(i_band,i_band,ik,ibvec)))
        ENDDO!ibvec            
       ENDDO!ik       
       wannier_center(:,i_band)=-tmp(:)/DBLE(NTK)   
      ENDDO!i_band           
!--
!OPEN(134,W,FILE='dat.wan-center') 
      OPEN(134,FILE='./dir-wan/dat.wan-center') 
      rewind(134)
      write(134,'(a)')'#Wannier center'
      write(134,'(a)')'#1:x, 2:y, 3:z (in xyz coord)'
      do i_band=1,n_occ 
       write(134,"(3F20.10)")(wannier_center(i,i_band),i=1,3)  
      enddo 
!-- 
!OPEN(113,W,FILE='dat.wan',FORM='unformatted') 
      OPEN(113,FILE='./dir-wan/dat.wan',FORM='unformatted') 
      allocate(C0_TMP_1(NTG,NTB))    
      allocate(C0_TMP_2(NTG,NTB))    
      REWIND(113)       
      write(113) n_occ!20170331(n_occ=NWF) 
      do ik=1,NTK 
       A_TMP(:,:)=0.0D0 
       do ib=1,N_BAND(ik)        
        do jb=1,n_occ        
         SUM_CMPX=0.0D0             
         do k=1,n_occ       
          do l=1,n_occ         
           SUM_CMPX
     +    =SUM_CMPX
     +    +C_MAT(ib,k,ik)*PSEUDO_MAT(k,l,ik)*A_MAT(l,jb,ik)
          enddo!l 
         enddo!k 
         A_TMP(ib,jb)=SUM_CMPX 
        enddo!jb
       enddo!ib
       C0_TMP_1(:,:)=C0(:,:,ik)        
       C0_TMP_2(:,:)=0.0D0     
!--
!write BF 
!       A_TMP(:,:)=0.d0 
!       do k_band=1,N_BAND(ik)
!        A_TMP(k_band,k_band)=1.0d0
!       enddo 
!--
       do ig=1,NG0(ik)  
        do jb=1,n_occ        
         SUM_CMPX=0.0D0             
         do kb=1,N_BAND(ik)       
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +C0_TMP_1(ig,kb+N_BAND_BTM(ik))*A_TMP(kb,jb) 
         enddo!kb 
         C0_TMP_2(ig,jb)=SUM_CMPX  
        enddo!jb 
       enddo!ig             
       write(113)((C0_TMP_2(ig,ib),ig=1,NG0(ik)),ib=1,n_occ) 
       !--
       !20180519
       !do ib=1,n_occ
       ! write(113) (C0_TMP_2(ig,ib),ig=1,NG0(ik))
       !enddo!ib 
       !--
      enddo!ik              
!-- 
!OPEN(113,R,FILE='dat.wan',FORM='unformatted') 
      ierr=CHDIR("./dir-wan") 
      call system('pwd') 
      REWIND(113)       
      read(113) NWF 
      allocate(C0WN(NTG,NWF,NTK));C0WN(:,:,:)=0.0D0 
      do ik=1,NTK 
       read(113)((C0WN(ig,jb,ik),ig=1,NG0(ik)),jb=1,NWF) 
       !--
       !20180519
       !do jb=1,NWF 
       ! read(113)(C0WN(ig,jb,ik),ig=1,NG0(ik))
       !enddo!jb 
       !--
      enddo!ik
      write(6,*)'FINISH REDING C0_WN'
      ierr=CHDIR("..") 
      call system('pwd') 
!--
!OPEN(150,W,FILE='dat.umat')
      OPEN(150,FILE='./dir-wan/dat.umat') 
      rewind(150) 
      Mb=maxval(N_BAND) 
      write(6,*)"Mb=",Mb 
      write(150,*) n_occ!20170331(n_occ=NWF) 
      allocate(UNT(Mb,n_occ,NTK));UNT(:,:,:)=0.0d0 
      do ik=1,NTK 
       do ib=1,N_BAND(ik)
        do jb=1,n_occ 
         SUM_CMPX=0.0d0 
         do ig=1,NG0(ik)  
          SUM_CMPX 
     +   =SUM_CMPX
     +   +conjg(C0(ig,ib+N_BAND_BTM(ik),ik))*C0WN(ig,jb,ik)
         enddo 
         UNT(ib,jb,ik)=SUM_CMPX 
        enddo 
       enddo 
      enddo 
      deallocate(C0WN) 
      do ik=1,NTK 
       do ib=1,N_BAND(ik)
        write(150,*)(UNT(ib,jb,ik),jb=1,n_occ)
       enddo 
      enddo 
!--
!      WRITE(6,*) 
!      WRITE(6,*)'============================='
!      WRITE(6,*)'UNITALITY CHECK OF UMAT:<n|m>'
!      WRITE(6,*)'============================='
!      WRITE(6,*)  
!      do ik=1,NTK 
!       nm=n_occ 
!       allocate(mat_tmp(nm,nm));mat_tmp=0.0d0 
!       do iw=1,nm 
!        do jw=1,nm 
!         SUM_CMPX=0.0D0            
!         do ib=1,N_BAND(ik) 
!          SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*UNT(ib,jw,ik) 
!         enddo!ib  
!         mat_tmp(iw,jw)=SUM_CMPX 
!        enddo!jw  
!       enddo!iw   
!       do iw=1,nm 
!        write(6,'(300f10.5)')(mat_tmp(iw,jw),jw=1,nm)  
!       enddo 
!       write(6,*)       
!       deallocate(mat_tmp) 
!      enddo!ik        
!--
      WRITE(6,*) 
      WRITE(6,*)'============================='
      WRITE(6,*)'UNITALITY CHECK OF UMAT:<a|b>'
      WRITE(6,*)'============================='
      WRITE(6,*)
      do ik=1,NTK 
       nm=N_BAND(ik) 
       allocate(mat_tmp(nm,nm));mat_tmp=0.0d0 
       do ib=1,nm 
        do jb=1,nm 
         SUM_CMPX=0.0D0            
         do iw=1,n_occ       
          SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*UNT(jb,iw,ik) 
         enddo!iw  
         mat_tmp(ib,jb)=SUM_CMPX 
        enddo!jb  
       enddo!ib   
       !--
       SUM_CMPX=0.0d0 
       do ib=1,nm 
        SUM_CMPX=SUM_CMPX+mat_tmp(ib,ib) 
       enddo!ib 
       write(6,'(a8,x,i8,2f15.10)')'ik=',ik,SUM_CMPX 
       write(6,'(300f10.5)')(mat_tmp(ib,ib),ib=1,nm)  
       write(6,*)       
       !--
       if(N_BAND_inner(ik)/=0)then  
        do ib=1,nm 
         write(6,'(300f10.5)')(mat_tmp(ib,jb),jb=1,nm)  
        enddo 
        write(6,*)       
       endif 
       !--
       deallocate(mat_tmp) 
      enddo!ik        

!====================================
!=== INTERPOLATED BAND DISPERSION ===
!====================================

      allocate(H_MAT_K(n_occ,n_occ,NTK));H_MAT_K(:,:,:)=0.0D0      
      allocate(E_TMP(n_occ));E_TMP(:)=0.0d0            
      allocate(H_TMP_IN(n_occ,n_occ));H_TMP_IN(:,:)=0.0d0           
      allocate(H_TMP_OUT(n_occ,n_occ));H_TMP_OUT(:,:)=0.0d0  
      allocate(H_MAT_R(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3)) 
      allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)) 
!--
!(1) SAMPLE k-POINTS FOR INTERPOLATED BAND DISPERSION 
      NSK_BAND_DISP=Ndiv*(N_sym_points-1)+1
      allocate(SK_BAND_DISP(3,NSK_BAND_DISP));SK_BAND_DISP(:,:)=0.0d0 
      allocate(E_BAND_DISP(n_occ,NSK_BAND_DISP));E_BAND_DISP(:,:)=0.0d0 
      call makekpts(Ndiv,N_sym_points,NSK_BAND_DISP,SK_sym_pts(1,1),
     +              SK_BAND_DISP(1,1))
      write(6,*) 
      write(6,*)'====================================='
      write(6,*)' CALCULATED kpts FOR BAND DISPERSION '
      write(6,*)'====================================='
      write(6,*) 
      write(6,'(a20,i15)')'NSK_BAND_DISP=',NSK_BAND_DISP
      write(6,*) 
      do ik=1,NSK_BAND_DISP 
       write(6,*) SK_BAND_DISP(:,ik)
      enddo 
!--
!(2) H_MAT(k) IN WANNIER BASIS 
      H_MAT_K(:,:,:)=0.0D0            
      Do ik=1,NTK 
       Do i_band=1,n_occ   
        Do j_band=1,n_occ   
         SUM_CMPX=0.0D0            
         Do k_band=1,n_occ       
          SUM_CMPX 
     +   =SUM_CMPX 
     +   +CONJG(A_MAT(k_band,i_band,ik))        
     +   *PSEUDO_EIG(k_band,ik)             
     +   *A_MAT(k_band,j_band,ik) 
         ENDDO 
         H_MAT_K(i_band,j_band,ik)=SUM_CMPX        
        ENDDO!j_band    
       ENDDO!i_band    
      ENDDO!ik        
!--
!(3) H_MAT(R) IN WANNIER BASIS 
      H_MAT_R(:,:,:,:,:)=0.0D0            
      Do ia1=-Na1,Na1!-1
       Do ia2=-Na2,Na2!-1
        Do ia3=-Na3,Na3!-1
         Do i_band=1,n_occ          
          Do j_band=1,n_occ          
           SUM_CMPX=0.0D0                             
           Do ik=1,NTK           
            PHASE=tpi*(SK0(1,ik)*DBLE(ia1) 
     +                +SK0(2,ik)*DBLE(ia2) 
     +                +SK0(3,ik)*DBLE(ia3))                
            PHASE_FACTOR=EXP(-ci*PHASE)         
            SUM_CMPX 
     +     =SUM_CMPX 
     +     +H_MAT_K(i_band,j_band,ik) 
     +     *PHASE_FACTOR                
           ENDDO               
           H_MAT_R(i_band,j_band,ia1,ia2,ia3)=SUM_CMPX/DBLE(NTK)     
          ENDDO!j_band
         ENDDO!i_band
        ENDDO!ia3      
       ENDDO!ia2       
      ENDDO!ia1         
!-- 
!(4) PRINT H_MAT(R) IN WANNIER BASIS 
      !
      !OPEN(122,W,FILE='dat.h_mat_r') 
      !
      OPEN(122,FILE='./dir-wan/dat.h_mat_r') 
      REWIND(122)
      write(122,'(a)')'#transfer'
      write(122,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
      write(122,'(a)')'#1:i, 2:j, 3:Re(t_ij) [eV], 4:Im(t_ij) [eV]' 
      do ia1=-Na1,Na1!-1
       do ia2=-Na2,Na2!-1
        do ia3=-Na3,Na3!-1
         write(122,*) ia1,ia2,ia3           
         do ib=1,n_occ          
          do jb=1,n_occ  
           write(122,'(i5,i5,2f20.10)') 
     +     ib,jb,H_MAT_R(ib,jb,ia1,ia2,ia3)*au 
          enddo!jb 
         enddo!ib 
         write(122,*) 
        enddo 
       enddo 
      enddo 
      CLOSE(122) 
      !--
      write(6,*) 
      write(6,*)'============='
      write(6,*)'H_MAT_R in eV'
      write(6,*)'============='
      write(6,*) 
      do ia1=-Na1,Na1!-1
       do ia2=-Na2,Na2!-1
        do ia3=-Na3,Na3!-1
         write(6,*) ia1,ia2,ia3           
         do ib=1,n_occ          
          write(6,'(300f15.8)')
     +    (DBLE(H_MAT_R(ib,jb,ia1,ia2,ia3)*au),jb=1,n_occ)
         enddo 
         write(6,*) 
        enddo      
       enddo      
      enddo      
!--
!(5) WEIGHT_R 20170317 by Y.Nomura 
      write(6,'(a40)')'WEIGHT CALCULATED' 
      WEIGHT_R=1.0d0; SUM_REAL=0.0d0 
      do ia1=-Na1,Na1!-1         
       do ia2=-Na2,Na2!-1         
        do ia3=-Na3,Na3!-1         
         if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
        enddo
       enddo
      enddo 
      write(6,'(a40,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
      if(abs(SUM_REAL-dble(NTK))>1.0d-6)then 
       write(6,'(a40)')'SUM_WEIGHT/=NTK'
       stop 
      endif 
!--
!(6) OUTPUT Hphi/mVMC DATA 
      write(6,*) 
      write(6,'(a40)')'+++ write transfers in dir-model +++'
      write(6,*) 
      call system('rm -rf dir-model') 
      call system('mkdir dir-model') 
      !
      call wrt_model_hr(Na1,Na2,Na3,n_occ,H_MAT_R(1,1,-Na1,-Na2,-Na3),
     +     WEIGHT_R(-Na1,-Na2,-Na3)) 
      call wrt_model_wcenter(n_occ,a1(1),a2(1),a3(1),
     +     wannier_center(1,1))
      call wrt_model_SK_BAND_DISP(Ndiv,N_sym_points,NSK_BAND_DISP,
     +     SK_BAND_DISP(1,1)) 
      call wrt_model_SK0(NTK,SK0(1,1)) 
      call wrt_model_ef(FermiEnergy) 
      !
      !ELECTRON NUMBER == 0.0 -> DMX IS EVALUATED WITH BAND-CALC EF
      !
      if(elec_num==0.0d0)then 
       call calculate_dmx(NTB,NTK,NWF,nkb1,nkb2,nkb3,Na1,Na2,Na3,!NWF=n_occ 
     +      FermiEnergy,a1(1),a2(1),a3(1),b1(1),b2(1),b3(1),SK0(1,1),
     +      E_EIG(1,1),UNT(1,1,1)) 
      endif 
      deallocate(E_EIG) 
!--
!(7) H_MAT(k') IN WANNIER BASIS. AND DIAGONALIZE 
      do ik=1,NSK_BAND_DISP          
       H_TMP_IN(:,:)=0.0D0               
       do ib=1,n_occ      
        do jb=1,n_occ      
         SUM_CMPX=0.0D0                    
         do ia1=-Na1,Na1!-1         
          do ia2=-Na2,Na2!-1         
           do ia3=-Na3,Na3!-1         
            !--
            !-- NEAREST R SEARCH BY YOSHIHIDE YOSHIMOTO 
            !--
            call search_Rmin(ia1,ia2,ia3,nkb1,nkb2,nkb3,
     +      a1(1),a2(1),a3(1),ia1min,ia2min,ia3min)
            PHASE=tpi*(SK_BAND_DISP(1,ik)*DBLE(ia1min) 
     +                +SK_BAND_DISP(2,ik)*DBLE(ia2min) 
     +                +SK_BAND_DISP(3,ik)*DBLE(ia3min))                
            !--
            PHASE_FACTOR=EXP(ci*PHASE)*WEIGHT_R(ia1,ia2,ia3)!20170317 
            SUM_CMPX=SUM_CMPX+H_MAT_R(ib,jb,ia1,ia2,ia3)*PHASE_FACTOR 
           enddo!ia3            
          enddo!ia2                       
         enddo!ia1
         H_TMP_IN(ib,jb)=SUM_CMPX           
        enddo!jb
       enddo!ib
       !--
       E_TMP(:)=0.0D0                
       call diagV(n_occ,H_TMP_IN(1,1),E_TMP(1)) 
       H_TMP_OUT(:,:)=H_TMP_IN(:,:)
       E_BAND_DISP(:,ik)=E_TMP(:)            
      ENDDO!ik           
!--
!      write(6,*) 
!      do ik=1,NSK_BAND_DISP          
!       do i_band=1,n_occ 
!        write(6,*) E_BAND_DISP(i_band,ik)*27.21151D0  
!       enddo 
!      enddo 
!--
!(8) WRITE BAND DISPERSION 
      allocate(DIST_K(NSK_BAND_DISP));DIST_K(:)=0.0d0 
      allocate(dist(0:N_sym_points-1));dist(:)=0.0d0 
      !--
      dist(0)=0.0d0 
      do ix=1,N_sym_points-1 
       ks=(ix-1)*Ndiv+1
       ke=(ix)*Ndiv+1
       do ik=ks,ke 
        DIST_B(:)
     + =(SK_BAND_DISP(1,ik)-SK_BAND_DISP(1,ks))*b1(:)
     + +(SK_BAND_DISP(2,ik)-SK_BAND_DISP(2,ks))*b2(:)
     + +(SK_BAND_DISP(3,ik)-SK_BAND_DISP(3,ks))*b3(:)
        DIST_KSPACE
     + =DSQRT(DIST_B(1)**2+DIST_B(2)**2+DIST_B(3)**2)
        DIST_K(ik)=DIST_KSPACE+dist(ix-1) 
       enddo!ik 
       dist(ix)=dist(ix-1)+DIST_KSPACE
      enddo!ix 
      !
      !OPEN(114,W,FILE='dat.iband') 
      !
      OPEN(114,FILE='./dir-wan/dat.iband') 
      write(114,'(a)')'#Wannier interpolaed band'
      write(114,'(a)')'#1:k, 2:Energy [eV]' 
      REVERSE=.TRUE.        
      do ib=1,n_occ             
       if(REVERSE) then 
        do ik=1,NSK_BAND_DISP                     
         write(114,*) DIST_K(ik)/DIST_K(NSK_BAND_DISP),
     +                E_BAND_DISP(ib,ik)*au
        enddo!ik        
        REVERSE=.FALSE.        
       else         
        do ik=NSK_BAND_DISP,1,-1          
         write(114,*) DIST_K(ik)/DIST_K(NSK_BAND_DISP),
     +                E_BAND_DISP(ib,ik)*au
        enddo!ik        
        REVERSE=.TRUE.        
       endif!REVERSE                   
      enddo!ib                      
!--
!(9) WRITE FERMISURFACE WITH WANNIER INTERPOLATION 
      IF(ALL(dense(1:3)/=0)) THEN
         CALL wrt_frmsf_wan(Na1,Na2,Na3,nkb1,nkb2,nkb3,
     +                      a1,a2,a3,b1,b2,b3,FermiEnergy,
     +                      WEIGHT_R,H_MAT_R)
      ENDIF

!============================================================
!=== DENSITY OF STATE and DENSITY MATRIX IN WANNIER SPACE ===
!============================================================
   
      write(6,*) 
      write(6,'(a40)')'==============================='
      write(6,'(a40)')' CALCULATE WANNIER DOS AND DMX '
      write(6,'(a40)')'==============================='
      write(6,*) 
      allocate(E_EIG(NWF,NTK)); E_EIG(:,:)=0.0d0
      allocate(V_EIG(NWF,NWF,NTK)); V_EIG(:,:,:)=0.0d0
      call calculate_eigenstate(NWF,Na1,Na2,Na3,
     +     H_MAT_R(1,1,-Na1,-Na2,-Na3),NTK,nkb1,nkb2,nkb3,
     +     a1(1),a2(1),a3(1),1,NTK,SK0(1,1),E_EIG(1,1),V_EIG(1,1,1))   
      filename='./dir-wan/dat.dos.wan'
      !
      !ELECTRON NUMBER == 0.0 -> DOS IS EVALUATED WITH BAND-CALC EF
      !
      if(elec_num==0.0d0)then 
       call calculate_dos(NWF,NTK,nkb1,nkb2,nkb3,elec_num,FermiEnergy,
     +      filename,b1(1),b2(1),b3(1),SK0(1,1),E_EIG(1,1),V_EIG(1,1,1))
      endif 
      !
      !ELECTRON NUMBER /= 0.0 -> DOS & DMX ARE EVALUATED WITH RECALC EF
      !
      if(elec_num/=0.0d0)then  
       call calculate_dos(NWF,NTK,nkb1,nkb2,nkb3,elec_num,FermiEnergy,
     +      filename,b1(1),b2(1),b3(1),SK0(1,1),E_EIG(1,1),V_EIG(1,1,1))
       call calculate_dmx(NWF,NTK,NWF,nkb1,nkb2,nkb3,Na1,Na2,Na3,!NWF=n_occ 
     +      FermiEnergy,a1(1),a2(1),a3(1),b1(1),b2(1),b3(1),SK0(1,1),
     +      E_EIG(1,1),V_EIG(1,1,1)) 
      endif 
      deallocate(E_EIG,V_EIG)

!==================================
!=== VISUALIZE WANNIER FUNCTION ===
!==================================

      if(CALC_REAL_SPACE_WANNIER)then 
       !--
       write(6,*) 
      write(6,'(a40)')'============================='
      write(6,'(a40)')' CALCULATE REALSPACE WANNIER '
      write(6,'(a40)')'============================='
       write(6,*) 
       nfft1=nwx2+1;nfft2=nwy2+1;nfft3=nwz2+1
       Nl123=nfft1*nfft2*nfft3 
       write(6,'(a40,i5,i5,i5)')'nwx2,nwy2,nwz2',nwx2,nwy2,nwz2 
       write(6,'(a40,i5,i5,i5)')'nfft1,nfft2,nfft2',nfft1,nfft2,nfft3 
       write(6,'(a40,i10)')'Nl123',Nl123 
       call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
       !--
       mem_size=dble((xmax-xmin)*nwx2+(ymax-ymin)*nwy2+(zmax-zmin)*nwz2)
       mem_size=mem_size*16.0d0/1024.0d0/1024.0d0/1024.0d0 
       write(6,'(a40,f20.15)')'mem size realspace wannier (GB)',mem_size
       if(mem_size>1.0d0)then 
        write(6,'(a40,f20.15)')'mem size > 1 GB; skipp' 
        go to 9999
       endif  
       !--
       allocate(WANNIER_REALSPACE((xmin)*nwx2:(xmax)*nwx2-1,
     +                            (ymin)*nwy2:(ymax)*nwy2-1, 
     +                            (zmin)*nwz2:(zmax)*nwz2-1))
       !--
       !OPEN(113,R,FILE='dat.wan',FORM='unformatted') 
       ierr=CHDIR("./dir-wan") 
       call system('pwd') 
       REWIND(113)       
       read(113) NWF!20170331(n_occ=NWF) 
       allocate(C0WN(NTG,NWF,NTK));C0WN(:,:,:)=0.0D0 
       do ik=1,NTK 
        read(113)((C0WN(ig,jb,ik),ig=1,NG0(ik)),jb=1,NWF) 
        !
        !20180519
        !do jb=1,NWF 
        ! read(113)(C0WN(ig,jb,ik),ig=1,NG0(ik))
        !enddo!jb 
        !
       enddo!ik 
       !write(6,*)'FINISH REDING C0_WN'
       !--
       do ix=1,N_write_wannier!NWF 
        iw=wrt_list(ix)!20170406  
        WANNIER_REALSPACE=0.0d0           
!$OMP PARALLEL PRIVATE(ik,C0_I,wfunc,fftwk,pw) 
        allocate(C0_I(NTG));C0_I=0.0D0 
        allocate(fftwk(Nl123*2),stat=err) 
        allocate(wfunc(Nl123*2),stat=err) 
        allocate(pw((xmin)*nwx2:(xmax)*nwx2-1,
     +              (ymin)*nwy2:(ymax)*nwy2-1, 
     +              (zmin)*nwz2:(zmax)*nwz2-1));pw=0.0d0           
!$OMP DO 
        do ik=1,NTK
         C0_I(:)=C0WN(:,iw,ik) 
         call make_pw(C0_I(1),wfunc(1),fftwk(1),NG0(ik),KG0(1,1,ik),NTG,
     +    nwx2,nwy2,nwz2,nfft1,nfft2,Nl123,fs,
     +    xmin,xmax,ymin,ymax,zmin,zmax,SK0(1,ik),
     +    pw(xmin*nwx2,ymin*nwy2,zmin*nwz2)) 
        enddo!ik         
!$OMP END DO
!$OMP CRITICAL
        WANNIER_REALSPACE=WANNIER_REALSPACE+pw 
!$OMP END CRITICAL
        deallocate(C0_I,fftwk,wfunc,pw)
!$OMP END PARALLEL
        !--
        !normalize 
        WANNIER_REALSPACE=WANNIER_REALSPACE/DBLE(NTK)/DSQRT(VOLUME)
        !--
        !OUTPUT by VESTA format 
        !OPEN(116,W,FILE='dat.wan-realspace-xxx.grd')
        write(filename,"('dat.wan-realspace-',i3.3,'.grd')") iw 
        OPEN(116,FILE=filename) 
        REWIND(116)
        na_grid=nwx2 
        nb_grid=nwy2
        nc_grid=nwz2 
        aa1=a1*dble(xmax-xmin)
        aa2=a2*dble(ymax-ymin)
        aa3=a3*dble(zmax-zmin)
        call est_latparam(aa1(1),aa2(1),aa3(1),a,b,c,alp,bet,gmm) 
        write(116,*)'Electron density'
        write(116,'(6f15.10)')
     +  a*bohr,b*bohr,c*bohr,alp,bet,gmm!bohr->angstrom
        write(116,'(3I5)') 
     +  (xmax-xmin)*na_grid,(ymax-ymin)*nb_grid,(zmax-zmin)*nc_grid 
        write(116,"(6g25.16)") (((dble(WANNIER_REALSPACE(i1,i2,i3)),
     +  i3=(zmin)*nc_grid,(zmax)*nc_grid-1),
     +  i2=(ymin)*nb_grid,(ymax)*nb_grid-1),
     +  i1=(xmin)*na_grid,(xmax)*na_grid-1)
        CLOSE(116)
        !
        !20190515 check whether wannier is real
        !
        !do i1=(xmin)*na_grid,(xmax)*na_grid-1
        ! do i2=(ymin)*nb_grid,(ymax)*nb_grid-1
        !  do i3=(zmin)*nc_grid,(zmax)*nc_grid-1
        !   write(6,"(2f15.10)") WANNIER_REALSPACE(i1,i2,i3)
        !  enddo!i3
        ! enddo!i2
        !enddo!i1
        !
       enddo!ix 
       !--
       !gencif 20180906  
       call gencif(a1(1),a2(1),a3(1),xmin,xmax,ymin,ymax,zmin,zmax,
     +  nsi,chemical_species(1),asi(1,1))
       !--
       ierr=CHDIR("..") 
       call system('pwd') 
9999  endif!CALC_REAL_SPACE_WANNIER 
      !--
      STOP 
      END        

module m_wrt_frmsf 
  implicit none
contains
  !
  subroutine wrt_frmsf(NTB,NTK,nkb1,nkb2,nkb3,E_EIG,SK0,FermiEnergy,filename,b1,b2,b3)                     
    implicit none 
    integer,intent(in)::NTB,NTK,nkb1,nkb2,nkb3 
    real(8),intent(in)::E_EIG(NTB,NTK)           
    real(8),intent(in)::SK0(3,NTK)           
    real(8),intent(in)::FermiEnergy,b1(3),b2(3),b3(3)
    character(99),intent(in)::filename 
    integer::index_kpt(nkb1,nkb2,nkb3) 
    integer::ib,ik,ikb1,ikb2,ikb3
    real(8)::E_3D(nkb3,nkb2,nkb1,NTB) 
    integer::ishift  
    !
    index_kpt=0     
    E_3D=0.0d0 
    call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
    do ib=1,NTB 
     do ikb1=1,nkb1
      do ikb2=1,nkb2
       do ikb3=1,nkb3 
        ik=index_kpt(ikb1,ikb2,ikb3)
        E_3D(ikb3,ikb2,ikb1,ib)=E_EIG(ib,ik)-FermiEnergy 
       enddo 
      enddo 
     enddo 
    enddo 
    ! 
    ishift=0 
    !
    !OPEN(301,W,file='./dir-wan/dat.frmsf')
    !
    OPEN(301,file=trim(filename)) 
    rewind(301) 
    write(301,*) nkb1,nkb2,nkb3
    write(301,*) ishift!not grid shift
    write(301,*) NTB 
    write(301,*) real(b1(1:3))
    write(301,*) real(b2(1:3))
    write(301,*) real(b3(1:3))
    do ib=1,NTB 
     do ikb1=1,nkb1
      do ikb2=1,nkb2
       do ikb3=1,nkb3
        write(301,*) real(E_3D(ikb3,ikb2,ikb1,ib))
       end do
      end do
     end do
    end do
    do ib=1,NTB
     do ikb1=1,nkb1
      do ikb2=1,nkb2
       do ikb3=1,nkb3
        write(301,*) real(ib)!real(phys(ikb3,ikb2,ikb1,ib))
       end do
      end do
     end do
    end do
    close(301)
    return
  end subroutine wrt_frmsf 
  !
  SUBROUTINE make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0,index_kpt)      
    implicit none 
    integer::NTK,nkb1,nkb2,nkb3
    real(8)::SK0(3,NTK)  
    integer::ik,ix,iy,iz
    real(8)::x,y,z
    integer::index_kpt(nkb1,nkb2,nkb3)    
    ! 
    !if(MOD(NTK,2)/=0) then 
    ! do ik=1,NTK 
    !  x=SK0(1,ik)*dble(nkb1) 
    !  y=SK0(2,ik)*dble(nkb2)
    !  z=SK0(3,ik)*dble(nkb3)  
    !  x=x+(dble(nkb1)-1.0d0)/2.0d0 
    !  y=y+(dble(nkb2)-1.0d0)/2.0d0
    !  z=z+(dble(nkb3)-1.0d0)/2.0d0 
    !  ix=idnint(x)+1
    !  iy=idnint(y)+1
    !  iz=idnint(z)+1
    !  index_kpt(ix,iy,iz)=ik
    ! enddo 
    !else!20170316 
    ! do ik=1,NTK 
    !  x=SK0(1,ik)*dble(nkb1) 
    !  y=SK0(2,ik)*dble(nkb2)
    !  z=SK0(3,ik)*dble(nkb3)  
    !  x=x+dble(nkb1)/2.0d0 
    !  y=y+dble(nkb2)/2.0d0
    !  z=z+dble(nkb3)/2.0d0 
    !  ix=idnint(x)
    !  iy=idnint(y)
    !  iz=idnint(z)
    !  index_kpt(ix,iy,iz)=ik
    ! enddo 
    !endif 
    !--
    !
    !20190520 Kazuma Nakamura
    !
    do ik=1,NTK 
     x=SK0(1,ik)*dble(nkb1) 
     y=SK0(2,ik)*dble(nkb2)
     z=SK0(3,ik)*dble(nkb3)  
     x=x+(dble(nkb1)-dble(mod(nkb1,2)))/2.0d0 
     y=y+(dble(nkb2)-dble(mod(nkb2,2)))/2.0d0 
     z=z+(dble(nkb3)-dble(mod(nkb3,2)))/2.0d0 
     ix=idnint(x)+mod(nkb1,2)
     iy=idnint(y)+mod(nkb2,2)
     iz=idnint(z)+mod(nkb3,2)
     index_kpt(ix,iy,iz)=ik
    enddo 
    ! 
    RETURN  
  end subroutine make_index_kpt 
  !
end module m_wrt_frmsf 

subroutine search_kq(NTK,SK0,q1,q2,q3,ik,ikq,shift_G)
  implicit none 
  integer::NTK
  real(8)::SK0(3,NTK)  
  real(8)::q1,q2,q3
  integer::ik
  integer::jk
  real(8)::SKQ(3)
  integer::ikq,shift_G(3)
  real(8),parameter::dlt_BZ=1.0d-6!20170322  
  !
  SKQ(1)=SK0(1,ik)+q1
  SKQ(2)=SK0(2,ik)+q2 
  SKQ(3)=SK0(3,ik)+q3 
  !
  if(SKQ(1)>1.50d0+dlt_BZ)then 
   SKQ(1)=SKQ(1)-2.0D0 
   shift_G(1)=+2 
  endif 
  if(SKQ(1)>0.5D0+dlt_BZ)then 
   SKQ(1)=SKQ(1)-1.0D0 
   shift_G(1)=+1
  endif 
  if(SKQ(1)<=-1.5D0+dlt_BZ)then 
   SKQ(1)=SKQ(1)+2.0D0 
   shift_G(1)=-2 
  endif 
  if(SKQ(1)<=-0.5D0+dlt_BZ)then 
   SKQ(1)=SKQ(1)+1.0D0 
   shift_G(1)=-1
  endif 
  !
  if(SKQ(2)>1.5D0+dlt_BZ)then 
   SKQ(2)=SKQ(2)-2.0D0 
   shift_G(2)=+2 
  endif 
  if(SKQ(2)>0.5D0+dlt_BZ)then 
   SKQ(2)=SKQ(2)-1.0D0 
   shift_G(2)=+1
  endif 
  if(SKQ(2)<=-1.5D0+dlt_BZ)then 
   SKQ(2)=SKQ(2)+2.0D0 
   shift_G(2)=-2 
  endif 
  if(SKQ(2)<=-0.5D0+dlt_BZ)then 
   SKQ(2)=SKQ(2)+1.0D0 
   shift_G(2)=-1
  endif 
  !
  if(SKQ(3)>1.5D0+dlt_BZ)then 
   SKQ(3)=SKQ(3)-2.0D0 
   shift_G(3)=+2 
  endif 
  if(SKQ(3)>0.5D0+dlt_BZ)then 
   SKQ(3)=SKQ(3)-1.0D0 
   shift_G(3)=+1
  endif 
  if(SKQ(3)<=-1.5D0+dlt_BZ)then 
   SKQ(3)=SKQ(3)+2.0D0 
   shift_G(3)=-2 
  endif 
  if(SKQ(3)<=-0.5D0+dlt_BZ)then 
   SKQ(3)=SKQ(3)+1.0D0 
   shift_G(3)=-1
  endif 
  !
  do jk=1,NTK
   if(ABS(SK0(1,jk)-SKQ(1))<1.D-6.and.ABS(SK0(2,jk)-SKQ(2))<1.D-6.and.ABS(SK0(3,jk)-SKQ(3))<1.D-6)then 
    ikq=jk 
   endif 
  enddo 
  RETURN  
END 
!
subroutine calc_InterStateMatrix(NTK,NTG,NG0,KG0,C0_K,C0_KQ,ik,ikq,nwx2,nwy2,nwz2,nfft1,nfft2,Nl123,&
  wfunc,fftwk,fs,LG0,NG_for_eps,shift_G,m_tmp)
  use fft_3d 
  implicit none 
  type(fft3_struct)::fs 
  integer::NTK,NTG 
  integer::NG0(NTK),KG0(3,NTG,NTK) 
  complex(8)::C0_K(NTG),C0_KQ(NTG) 
  integer::ik,ikq 
  integer::nwx2,nwy2,nwz2,nfft1,nfft2,Nl123 
  real(8)::wfunc(Nl123*2),fftwk(Nl123*2) 
  integer::NG_for_eps 
  integer::LG0(3,NTG) 
  integer::shift_G(3)
  integer::ig,igb1,igb2,igb3,ind,igL,igL1,igL2,igL3  
  integer::ir,ir1,ir2,ir3
  real(8)::dG1,dG2,dG3,phase 
  complex(8),allocatable::cell_periodic_k(:)
  complex(8),allocatable::cell_periodic_kq(:)
  complex(8)::f,pf
  complex(8)::phx(nwx2),phy(nwy2),phz(nwz2)
  complex(8)::m_tmp(NG_for_eps) 
  !
  real(8),parameter::pi=dacos(-1.0d0)
  real(8),parameter::tpi=2.0d0*pi 
  complex(8),parameter::ci=(0.0D0,1.0D0) 
  !
  allocate(cell_periodic_k(Nl123))
  allocate(cell_periodic_kq(Nl123))
  wfunc(:)=0.0D0
  fftwk(:)=0.0D0
  do ig=1,NG0(ik) 
   igb1=KG0(1,ig,ik) 
   igb2=KG0(2,ig,ik) 
   igb3=KG0(3,ig,ik) 
   igb1=MOD(nwx2+igb1,nwx2)+1
   igb2=MOD(nwy2+igb2,nwy2)+1
   igb3=MOD(nwz2+igb3,nwz2)+1
   ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
   wfunc(ind)=dble(C0_K(ig))
   wfunc(ind+Nl123)=dimag(C0_K(ig))
  enddo!ig 
  call fft3_bw(fs,wfunc,fftwk) 
  do ir=1,Nl123 
   cell_periodic_k(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
  enddo 
  !--
  wfunc(:)=0.0D0
  fftwk(:)=0.0D0
  do ig=1,NG0(ikq)
   igb1=KG0(1,ig,ikq)
   igb2=KG0(2,ig,ikq) 
   igb3=KG0(3,ig,ikq) 
   igb1=MOD(nwx2+igb1,nwx2)+1
   igb2=MOD(nwy2+igb2,nwy2)+1      
   igb3=MOD(nwz2+igb3,nwz2)+1 
   ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
   wfunc(ind)=dble(C0_KQ(ig))
   wfunc(ind+Nl123)=dimag(C0_KQ(ig)) 
  enddo!ig 
  call fft3_bw(fs,wfunc,fftwk)    
  do ir=1,Nl123
   cell_periodic_kq(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
  enddo 
  !--
  dG1=dble(shift_G(1))
  dG2=dble(shift_G(2))
  dG3=dble(shift_G(3))
  !YOSHIHIDE YOSHIMOTO 20080620 
  do ir1=1,nwx2
   phase = tpi*(dble(ir1-1)*dG1/dble(nwx2))
   phx(ir1) = exp(-ci*phase)
  end do
  do ir2=1,nwy2
   phase = tpi*(dble(ir2-1)*dG2/dble(nwy2))
   phy(ir2) = exp(-ci*phase)
  end do
  do ir3=1,nwz2
   phase = tpi*(dble(ir3-1)*dG3/dble(nwz2))
   phz(ir3) = exp(-ci*phase)
  end do
  !
  do ir3=1,nwz2
   do ir2=1,nwy2
    do ir1=1,nwx2
     ir=ir1+(ir2-1)*nfft1+(ir3-1)*nfft1*nfft2 
     !YOSHIHIDE YOSHIMOTO 20080620 
     pf=phx(ir1)*phy(ir2)*phz(ir3)
     cell_periodic_kq(ir)=cell_periodic_kq(ir)*pf 
    enddo 
   enddo 
  enddo 
  !
  wfunc(:)=0.0D0
  fftwk(:)=0.0D0
  do ir=1,Nl123 
   f=CONJG(cell_periodic_kq(ir))*cell_periodic_k(ir)
   wfunc(ir)=dble(f)
   wfunc(ir+Nl123)=dimag(f) 
  enddo 
  call fft3_fw(fs,wfunc,fftwk) 
  do igL=1,NG_for_eps
   igL1=-LG0(1,igL)
   igL2=-LG0(2,igL)
   igL3=-LG0(3,igL) 
   igL1=MOD(nwx2+igL1,nwx2)+1
   igL2=MOD(nwy2+igL2,nwy2)+1
   igL3=MOD(nwz2+igL3,nwz2)+1
   ind=igL1+(igL2-1)*nfft1+(igL3-1)*nfft1*nfft2
   m_tmp(igL)=cmplx(wfunc(ind),wfunc(ind+Nl123))
  enddo 
  !--
  deallocate(cell_periodic_k)
  deallocate(cell_periodic_kq)
  RETURN  
END 
!
subroutine calc_MAT_VXC(NTK,NWF,NTG,NG0,KG0,vhxc,C0_K,ik,nrx2,nry2,nrz2,nfft1,nfft2,Nl123,&
  wfunc,fftwk,fs,MAT_VHXC)
  use fft_3d 
  implicit none 
  type(fft3_struct)::fs 
  integer::ik,NTK,NWF,NTG 
  integer::NG0(NTK)
  integer::KG0(3,NTG,NTK) 
  !
  !20180922 
  !
  !complex(8)::C0_K(NTG,NWF)
  complex(4)::C0_K(NTG,NWF)
  !
  integer::nrx2,nry2,nrz2,nfft1,nfft2,Nl123
  real(8)::wfunc(Nl123*2)
  real(8)::fftwk(Nl123*2) 
  real(8)::vhxc(nrx2,nry2,nrz2) 
  integer::ig,igb1,igb2,igb3,ind
  integer::ir,ir1,ir2,ir3,iw,jw
  complex(8)::SUM_CMPX
  complex(8),allocatable::u_1D(:)!u_1D(Nl123)  
  complex(8),allocatable::u_3D(:,:,:,:)!u_3D(nrx2,nry2,nrz2,NWF)  
  complex(8),intent(out)::MAT_VHXC(NWF,NWF) 
  !
  allocate(u_1D(Nl123));u_1D=0.0d0 
  allocate(u_3D(nrx2,nry2,nrz2,NWF));u_3D=0.0d0 
  do iw=1,NWF 
   wfunc=0.0d0
   fftwk=0.0d0
   do ig=1,NG0(ik) 
    igb1=KG0(1,ig,ik) 
    igb2=KG0(2,ig,ik) 
    igb3=KG0(3,ig,ik) 
    igb1=MOD(nrx2+igb1,nrx2)+1
    igb2=MOD(nry2+igb2,nry2)+1
    igb3=MOD(nrz2+igb3,nrz2)+1
    ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
    wfunc(ind)=dble(C0_K(ig,iw))
    !
    !20180922
    !
    !wfunc(ind+Nl123)=dimag(C0_K(ig,iw))
    wfunc(ind+Nl123)=imag(C0_K(ig,iw))
    ! 
   enddo!ig 
   call fft3_bw(fs,wfunc(1),fftwk(1)) 
   u_1D(:)=0.0d0 
   do ir=1,Nl123 
    u_1D(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
   enddo!ir 
   do ir3=1,nrz2
    do ir2=1,nry2
     do ir1=1,nrx2
      ir=ir1+(ir2-1)*nfft1+(ir3-1)*nfft1*nfft2 
      u_3D(ir1,ir2,ir3,iw)=u_1D(ir) 
     enddo!ir1 
    enddo!ir2 
   enddo!ir3 
  enddo!iw  
  MAT_VHXC(:,:)=0.0d0 
  do iw=1,NWF
   do jw=1,NWF
    SUM_CMPX=0.0D0 
    do ir3=1,nrz2
     do ir2=1,nry2
      do ir1=1,nrx2
       SUM_CMPX=SUM_CMPX+CONJG(u_3D(ir1,ir2,ir3,iw))*vhxc(ir1,ir2,ir3)*u_3D(ir1,ir2,ir3,jw)
      enddo!ir1 
     enddo!ir2 
    enddo!ir3 
    MAT_VHXC(iw,jw)=SUM_CMPX/dble(nrx2)/dble(nry2)/dble(nrz2)
   enddo!jw 
  enddo!iw  
  !
  !write(6,*)'CHECK MAT_VHXC'
  !
  !do iw=1,NWF 
  ! write(6,*)(MAT_VHXC(iw,jw),jw=1,NWF)
  !enddo 
  !write(6,*)
  !
  deallocate(u_1D,u_3D)
  RETURN  
END 
!
!subroutine make_C0_for_given_band(NTG,itrs,NG,KGtmp,RWtmp,rginvtmp,pgtmp,L1,L2,L3,packtmp,OCCtmp,C0_K) 
!implicit none 
!integer::NTG,L1,L2,L3 
!integer::itrs 
!integer::NG
!integer::KGtmp(3,NTG) 
!integer::RWtmp(3) 
!real(8)::rginvtmp(3,3) 
!integer::pgtmp(3) 
!integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
!complex(8)::OCCtmp(NTG) 
!integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3 
!real(8),parameter::pi=dacos(-1.0d0)
!real(8),parameter::tpi=2.0d0*pi 
!complex(8),parameter::ci=(0.0D0,1.0D0) 
!real(8)::phase 
!complex(8)::pf 
!complex(8)::C0_K(NTG) 
!!
!C0_K(:)=0.0d0 
!select case(itrs) 
!case(1)!=== not time-reversal ===      
! do ig=1,NG 
!  i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
!  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
!  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
!  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
!  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
!  jg=packtmp(i3,j3,k3) 
!  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
!  pf=exp(-ci*phase) 
!  C0_K(ig)=OCCtmp(jg)*pf 
! enddo!ig 
!case(-1)!=== time-reversal ===      
! do ig=1,NG 
!  i1=-KGtmp(1,ig); j1=-KGtmp(2,ig); k1=-KGtmp(3,ig) 
!  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
!  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
!  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
!  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
!  jg=packtmp(i3,j3,k3) 
!  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
!  pf=exp(-ci*phase) 
!  C0_K(ig)=OCCtmp(jg)*pf 
! enddo !ig 
! C0_K(:)=conjg(C0_K(:))  
!end select 
!return 
!end 
!
!subroutine make_eps(NTG,NTGQ,ne,itrs,NG,LGtmp,RWtmp,rginvtmp,pgtmp,nnp,L1,L2,L3,packtmp,epsirr,epsmk) 
!implicit none 
!integer::NTG,NTGQ,itrs,NG,ne,L1,L2,L3,nnp 
!integer::LGtmp(3,NTG) 
!integer::RWtmp(3) 
!real(8)::rginvtmp(3,3) 
!integer::pgtmp(3) 
!integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
!complex(4)::epsirr(NTGQ,NTGQ,ne) 
!integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3,iig,jjg 
!real(8)::phase 
!complex(8)::pf1,pf2 
!complex(4)::epsmk(NTGQ,NTGQ,ne) 
!!
!real(8),parameter::pi=dacos(-1.0d0)
!real(8),parameter::tpi=2.0d0*pi 
!complex(8),parameter::ci=(0.0D0,1.0D0) 
!!
!epsmk(:,:,:)=0.0d0 
!select case(itrs) 
!case(1)!=== not time-reversal ===    
!do ig=1,NG 
! i1=LGtmp(1,ig); j1=LGtmp(2,ig); k1=LGtmp(3,ig) 
! i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
! i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
! j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
! k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
! iig=packtmp(i3,j3,k3) 
! phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
! pf1=exp(-ci*phase/dble(nnp)) 
! do jg=1,NG 
!  i1=LGtmp(1,jg); j1=LGtmp(2,jg); k1=LGtmp(3,jg) 
!  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
!  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
!  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
!  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
!  jjg=packtmp(i3,j3,k3) 
!  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
!  pf2=exp(ci*phase/dble(nnp)) 
!  !write(6,'(a,x,2i5)') 'iig jjg',iig,jjg  
!  epsmk(ig,jg,:)=epsirr(iig,jjg,:)*pf1*pf2 
! enddo!jg 
!enddo!ig 
!case(-1)!=== time-reversal ===      
!do ig=1,NG 
! i1=-LGtmp(1,ig); j1=-LGtmp(2,ig); k1=-LGtmp(3,ig) 
! i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
! i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
! j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
! k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
! iig=packtmp(i3,j3,k3) 
! phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
! pf1=exp(-ci*phase/dble(nnp)) 
! do jg=1,NG 
!  i1=-LGtmp(1,jg); j1=-LGtmp(2,jg); k1=-LGtmp(3,jg) 
!  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
!  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
!  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
!  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
!  jjg=packtmp(i3,j3,k3) 
!  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
!  pf2=exp(ci*phase/dble(nnp)) 
!  epsmk(ig,jg,:)=epsirr(jjg,iig,:)*pf1*pf2 
! enddo!jg 
!enddo!ig 
!end select 
!!
!!write(6,*)'finish make_eps'
!!
!return 
!end 

!
! Copyright (c) 2013-2015,2018 Yoshihide Yoshimoto
!
module subr_fmtconv
  character(len=2):: atom_name(0:102) = (/ 'Un', 'H ','He', &
       'Li','Be','B ','C ','N ','O ','F ','Ne', &
       'Na','Mg','Al','Si','P ','S ','Cl','Ar', &
       'K ','Ca', &
       'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn', &
       'Ga','Ge','As','Se','Br','Kr', &
       'Rb','Sr', &
       'Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd', &
       'In','Sn','Sb','Te','I ','Xe', &
       'Cs','Ba', &
       'La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb', &
       'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg', &
       'Tl','Pb','Bi','Po','At','Rn', &
       'Fr','Ra', &
       'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No' /)
  real(kind=8),parameter:: oneau = 0.52917721067d0 ! by 2014 CODATA
  real(kind=8),parameter:: pi = 3.14159265358979323846d0

contains
  subroutine printcif(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
    implicit none
    character(len=*):: cbuf
    real(kind=8),intent(in):: aa(3,3)
    integer,intent(in):: nkd,nsi,kd(nsi)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),pointer:: asi(:,:)

    integer:: nsikd(nkd)
    character(len=10240):: chem_abs_conf
    character(len=6):: cnsikd
    integer:: it,ikd,izn
    real(kind=8):: cla,clb,clc,tmp

    nsikd = 0
    do it=1,nsi
       nsikd(kd(it)) = nsikd(kd(it))+1
    end do
    chem_abs_conf = ''''
    do ikd=1,nkd
       izn = nint(zn(ikd))
       write(cnsikd,'(i0)') nsikd(ikd)
       chem_abs_conf = trim(chem_abs_conf) // ' ' &
            // trim(atom_name(izn)) // trim(cnsikd)
    end do
    chem_abs_conf = trim(chem_abs_conf)//''''

    write(6,'(a)') 'data_global'
    write(6,'(a)') '_chemical_name ''' // trim(cbuf) // ''''
    write(6,'(a)') '_chemical_absolute_configuration ' // trim(chem_abs_conf)
    write(6,'(a)') '_symmetry_space_group_name ''P1'''
    
    cla = aa(1,1)*aa(1,1)+aa(2,1)*aa(2,1)+aa(3,1)*aa(3,1)
    cla = sqrt(cla)
    write(6,'(a,f15.7)') '_cell_length_a ', oneau*cla

    clb = aa(1,2)*aa(1,2)+aa(2,2)*aa(2,2)+aa(3,2)*aa(3,2)
    clb = sqrt(clb)
    write(6,'(a,f15.7)') '_cell_length_b ', oneau*clb

    clc = aa(1,3)*aa(1,3)+aa(2,3)*aa(2,3)+aa(3,3)*aa(3,3)
    clc = sqrt(clc)
    write(6,'(a,f15.7)') '_cell_length_c ', oneau*clc

    tmp = aa(1,2)*aa(1,3)+aa(2,2)*aa(2,3)+aa(3,2)*aa(3,3)
    tmp = tmp/(clb*clc)
    tmp = acos(tmp)/pi*180.0
    write(6,'(a,f11.7)') '_cell_angle_alpha ', tmp

    tmp = aa(1,3)*aa(1,1)+aa(2,3)*aa(2,1)+aa(3,3)*aa(3,1)
    tmp = tmp/(clc*cla)
    tmp = acos(tmp)/pi*180.0
    write(6,'(a,f11.7)') '_cell_angle_beta ', tmp

    tmp = aa(1,1)*aa(1,2)+aa(2,1)*aa(2,2)+aa(3,1)*aa(3,2)
    tmp = tmp/(cla*clb)
    tmp = acos(tmp)/pi*180.0
    write(6,'(a,f11.7)') '_cell_angle_gamma ', tmp

    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_11 ', oneau*aa(1,1)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_21 ', oneau*aa(2,1)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_31 ', oneau*aa(3,1)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_12 ', oneau*aa(1,2)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_22 ', oneau*aa(2,2)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_32 ', oneau*aa(3,2)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_13 ', oneau*aa(1,3)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_23 ', oneau*aa(2,3)
    write(6,'(a,f15.7)') '_atom_sites_Cartn_tran_matrix_33 ', oneau*aa(3,3)
    write(6,*)

    write(6,'(a)') 'loop_'
    write(6,'(a)') '_symmetry_equiv_pos_as_xyz'
    write(6,'(a)') '''x, y, z'''
    write(6,*)

    write(6,'(a)') 'loop_'
    write(6,'(a)') '_atom_site_type_symbol'
    write(6,'(a)') '_atom_site_label'
    write(6,'(a)') '_atom_site_fract_x'
    write(6,'(a)') '_atom_site_fract_y'
    write(6,'(a)') '_atom_site_fract_z'

    nsikd = 0
    do it=1,nsi
       izn = nint(zn(kd(it)))
       nsikd(kd(it)) = nsikd(kd(it))+1
       write(cnsikd,'(i0)') nsikd(kd(it))
       write(6,'(a,1x,a,3(1x,f13.9))') trim(atom_name(izn)), &
            trim(atom_name(izn))//trim(cnsikd), &
            modulo(asi(1,it),1.0d0), &
            modulo(asi(2,it),1.0d0), &
            modulo(asi(3,it),1.0d0)
    end do
    return
  end subroutine printcif

  subroutine printxyz(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
    implicit none
    character(len=*):: cbuf
    real(kind=8),intent(in):: aa(3,3)
    integer,intent(in):: nkd,nsi,kd(nsi)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),pointer:: asi(:,:)

    integer:: it,izn
    real(kind=8):: x,y,z

    write(6,'(i0)') nsi
    write(6,'(a)') trim(cbuf)

    do it=1,nsi
       izn = nint(zn(kd(it)))
       x = aa(1,1)*asi(1,it)+aa(1,2)*asi(2,it)+aa(1,3)*asi(3,it)
       y = aa(2,1)*asi(1,it)+aa(2,2)*asi(2,it)+aa(2,3)*asi(3,it)
       z = aa(3,1)*asi(1,it)+aa(3,2)*asi(2,it)+aa(3,3)*asi(3,it)
       write(6,'(a,3(1x,e15.7))') trim(atom_name(izn)), &
            oneau*x, oneau*y, oneau*z
    end do
    return
  end subroutine printxyz

  subroutine printxyzpr(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
    implicit none
    character(len=*):: cbuf
    real(kind=8),intent(in):: aa(3,3)
    integer,intent(in):: nkd,nsi,kd(nsi)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),pointer:: asi(:,:)

    integer:: it,izn,i,i1,i2,i3,nsipr
    real(kind=8):: x,y,z,a,b,c,delta(3)
    real(kind=8),parameter:: eps = 0.1d0

    do i=1,3
       delta(i) = eps/sqrt( aa(1,i)*aa(1,i)+aa(2,i)*aa(2,i)+aa(3,i)*aa(3,i) )
    end do

    nsipr = 0
    do it=1,nsi
       izn = nint(zn(kd(it)))
       do i3=-1,1
          do i2=-1,1
             do i1=-1,1
                a = modulo(asi(1,it),1.0d0) + i1
                b = modulo(asi(2,it),1.0d0) + i2
                c = modulo(asi(3,it),1.0d0) + i3
                if ( -delta(1).lt.a .and. a.lt.1.0d0+delta(1) .and. &
                     -delta(2).lt.b .and. b.lt.1.0d0+delta(2) .and. &
                     -delta(3).lt.c .and. c.lt.1.0d0+delta(3) ) then
                   nsipr = nsipr + 1
                end if
             end do
          end do
       end do
    end do

    write(6,'(i0)') nsipr
    write(6,'(a)') trim(cbuf)

    i = 0
    do it=1,nsi
       izn = nint(zn(kd(it)))
       do i3=-1,1
          do i2=-1,1
             do i1=-1,1
                a = modulo(asi(1,it),1.0d0) + i1
                b = modulo(asi(2,it),1.0d0) + i2
                c = modulo(asi(3,it),1.0d0) + i3
                if ( -delta(1).lt.a .and. a.lt.1.0d0+delta(1) .and. &
                     -delta(2).lt.b .and. b.lt.1.0d0+delta(2) .and. &
                     -delta(3).lt.c .and. c.lt.1.0d0+delta(3) ) then
                   x = aa(1,1)*a + aa(1,2)*b + aa(1,3)*c
                   y = aa(2,1)*a + aa(2,2)*b + aa(2,3)*c
                   z = aa(3,1)*a + aa(3,2)*b + aa(3,3)*c
                   write(6,'(a,3(1x,e15.7))') trim(atom_name(izn)), &
                        oneau*x, oneau*y, oneau*z
                   i = i + 1 
                end if
             end do
          end do
       end do
    end do

    if (i.ne.nsipr) then
       write(6,*) 'error in printxyzpr()'
       stop
    end if
    return
  end subroutine printxyzpr

  subroutine printxyzmol(cbuf,aa,nkd,zo,zn,nsi,kd,asi)
    implicit none
    character(len=*):: cbuf
    real(kind=8),intent(in):: aa(3,3)
    integer,intent(in):: nkd,nsi,kd(nsi)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),pointer:: asi(:,:)

    integer:: it,izn,i1,i2,i3
    real(kind=8):: x,y,z,c(3),as(3),am(3),sc(3),d,td

    write(6,'(i0)') nsi
    write(6,'(a)') trim(cbuf)

    it = 1
    sc = asi(:,it)
    izn = nint(zn(kd(it)))
    x = aa(1,1)*asi(1,it)+aa(1,2)*asi(2,it)+aa(1,3)*asi(3,it)
    y = aa(2,1)*asi(1,it)+aa(2,2)*asi(2,it)+aa(2,3)*asi(3,it)
    z = aa(3,1)*asi(1,it)+aa(3,2)*asi(2,it)+aa(3,3)*asi(3,it)
    write(6,'(a,3(1x,e15.7))') trim(atom_name(izn)), &
         oneau*x, oneau*y, oneau*z

    do it=2,nsi
       izn = nint(zn(kd(it)))
       c = sc/(it-1)
       d = huge(1.0d0)
       am = huge(1.0d0)
       do i3=-1,1
          do i2=-1,1
             do i1=-1,1
                as(1) = modulo(asi(1,it),1.0d0) + i1
                as(2) = modulo(asi(2,it),1.0d0) + i2
                as(3) = modulo(asi(3,it),1.0d0) + i3
                td = abs(as(1)-c(1))+abs(as(2)-c(2))+abs(as(3)-c(3))
                if (td.lt.d) then
                   d = td
                   am = as
                end if
             end do
          end do
       end do
       sc = sc + am

       x = aa(1,1)*am(1)+aa(1,2)*am(2)+aa(1,3)*am(3)
       y = aa(2,1)*am(1)+aa(2,2)*am(2)+aa(2,3)*am(3)
       z = aa(3,1)*am(1)+aa(3,2)*am(2)+aa(3,3)*am(3)
       write(6,'(a,3(1x,e15.7))') trim(atom_name(izn)), &
            oneau*x, oneau*y, oneau*z
    end do
    return
  end subroutine printxyzmol

  subroutine printposcar(nf,ax,aa,nkd,zo,zn,nsi,kd,asi)
    implicit none
    integer,intent(in):: nf
    real(kind=8),intent(in):: ax,aa(3,3)
    integer,intent(in):: nkd,nsi,kd(nsi)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),pointer:: asi(:,:)

    integer:: it,ikd
    integer:: nsikd(nkd)

    do ikd=1,nkd
       write(nf,'(1x,a)',advance='no')  atom_name(nint(zn(ikd)))
    end do
    write(nf,*)
    write(nf,'(1x,e18.10)') ax*oneau
    write(nf,'(3(1x,e18.10))') aa(:,1)/ax
    write(nf,'(3(1x,e18.10))') aa(:,2)/ax
    write(nf,'(3(1x,e18.10))') aa(:,3)/ax

    nsikd = 0
    do it=1,nsi
       nsikd(kd(it)) = nsikd(kd(it)) + 1
    end do
    do ikd=1,nkd
       write(nf,'(1x,i6)',advance='no') nsikd(ikd)
    end do
    write(nf,*)

    write(nf,'(a)') 'Direct'
    do ikd=1,nkd
       do it=1,nsi
          if (kd(it).eq.ikd) then
             write(nf,'(1x,3f16.12)') &
                  asi(1,it),asi(2,it),asi(3,it)
          end if
       end do
    end do
    return
  end subroutine printposcar

  subroutine printrespack(nf,cbuf,aa,nkd,zo,zn,nsi,kd,asi,etotal,efermi)
    implicit none
    integer,intent(in):: nf
    character(len=*):: cbuf
    real(kind=8),intent(in):: aa(3,3)
    integer,intent(in):: nkd,nsi,kd(nsi)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),pointer:: asi(:,:)
    real(kind=8),intent(in):: etotal,efermi(2)

    integer:: it,izn,ios

    open(nf, file='dat.atom_position', status='replace', &
         action='write', iostat=ios)
    if (ios.ne.0) then
       write(6,*) 'error in opening '//trim(cbuf)
       stop
    end if
    
    write(nf,'(1x,i0)') nsi
    do it=1,nsi
       izn = nint(zn(kd(it)))
       write(nf,'(1x,a,1x,3(1x,f13.9))') trim(atom_name(izn)), &
            modulo(asi(1,it),1.0d0), &
            modulo(asi(2,it),1.0d0), &
            modulo(asi(3,it),1.0d0)
    end do
    close(nf)

    open(nf, file='dat.bandcalc', status='old', &
         action='write', position='append', iostat=ios)
    if (ios.ne.0) then
       write(6,*) 'error in opening '//trim(cbuf)
       stop
    end if
    write(nf,'(1x,e19.10,1x,e19.10)') efermi(1),efermi(2)
    write(nf,'(1x,e21.12)') etotal
    close(nf)
    
    return
  end subroutine printrespack

  subroutine printcforce(nf,nsi,cforce)
    implicit none
    integer,intent(in):: nf
    integer,intent(in):: nsi
    real(kind=8),pointer:: cforce(:,:)

    integer:: it

    do it=1,nsi
       write(nf,'(3(1x,e18.10))') cforce(1,it),cforce(2,it),cforce(3,it)
    end do
    return
  end subroutine printcforce
end module subr_fmtconv

! The MIT License (MIT)
! Copyright (c) 2016, Yoshiro Nohara, Takeo Fujiwara, and University of Tokyo.
!
! Permission is hereby granted, free of charge, to any person
! obtaining a copy of this software and associated documentation
! files (the "Software"), to deal in the Software without restriction,
! including without limitation the rights to use, copy, modify, merge,
! publish, distribute, sublicense, and/or sell copies of the Software,
! and to permit persons to whom the Software is furnished to do so,
! subject to the following conditions:
!
! The above copyright notice and this permission notice shall be
! included in all copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
! EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
! OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
! NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
! HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
! WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
! IN THE SOFTWARE.
!
!     This program uses the generalized tetrahedron method and implements
!     an efficient tool in the GW-LMTO package developed by Fujiwara group
!     in University of Tokyo. The algorithm of the generalized tetrahedron
!     method is written in the following published papers:
!
!     [Generalized tetrahedron method] Takeo Fujiwara, Susumu Yamamoto, and
!     Yasushi Ishii, J. Phys. Soc. Jpn. 72, No.4, 777-780 (2003).
!     (cond.mat/0211159)
!
!     [GW-LMTO package] Yoshiro Nohara, Susumu Yamamoto, and Takeo Fujiwara,
!     Phys. Rev. B 79, 195110 (2009)
!
!     One can use this part of the program package in one's developed code
!     on the condition of citing these two papers and mentioning the name of
!     `the generalized tetrahedron method'  in the published paper.
      module m_tetrainteg
      implicit none
      private

      public :: ttritg_mkidx
      public :: ttritg_sum
      public :: ttritg_simple
      public :: ttritg_search
      public :: ttritg_sub1normal
      public :: ttritg_sub1simple
      public :: ttritg_sub1g30g20
      public :: ttritg_sub1g30g21
      public :: ttritg_sub1g30
      public :: ttritg_sub2normal
      public :: ttritg_sub2simple
      public :: ttritg_sub2g30g20
      public :: ttritg_sub2g30g10
      public :: ttritg_sub2g30g21
      public :: ttritg_sub2g30
      public :: ttritg_sub2g10


      integer, parameter, public :: ttritg_vtx=4
      integer, parameter, public :: ttritg_div=6
      integer, parameter :: nvtx=ttritg_vtx
      integer, parameter :: ndiv=ttritg_div
      integer, parameter, public :: ttritg_tbl1(nvtx,ndiv)
     $                       =reshape((/1,2,3,6
     $                                 ,1,3,5,6
     $                                 ,3,5,6,7
     $                                 ,2,3,4,6
     $                                 ,3,4,6,8
     $                                 ,3,6,7,8/)
     $                               ,(/nvtx,ndiv/))

      contains

      subroutine ttritg_search(dmna,dmnr,n1,n2,n3,n4,imt1,fk,gk,xo
     $                        ,dtgt,drg1,drg2,dout)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: n1,n2,n3,n4
      integer, intent(in) :: imt1(nvtx,n1*n2*n3*ndiv)
      complex(8), intent(in) :: fk(n1*n2*n3,n4)
      complex(8), intent(in) :: gk(n1*n2*n3,n4)
      complex(8), intent(inout) :: xo(n1*n2*n3)
      real(8), intent(in) :: dtgt,drg1,drg2
      real(8), intent(out):: dout
      integer :: i1,i2,i3
      real(8) :: d1,d2,d3,d4,d5,d6
      logical :: b1,b2,b3
      complex(8) :: ca1(nvtx),ca2(1)
      complex(8), allocatable :: ca3(:)
      d3=drg1
      d4=drg2
      xo=0.d0
      ca2=d3
      do i1=1,n4
        call ttritg_sum(dmna,dmnr,n1,n2,n3,imt1
     $                 ,fk(:,i1),gk(:,i1),1,ca2,ca1,xo)
      end do
      d1=abs(dimag(sum(xo)))
      xo=0.d0
      ca2=d4
      do i1=1,n4
        call ttritg_sum(dmna,dmnr,n1,n2,n3,imt1
     $                 ,fk(:,i1),gk(:,i1),1,ca2,ca1,xo)
      end do
      d2=abs(dimag(sum(xo)))
#ifdef MPI
#else
      write(*,"(a,2g25.16)")"#ttritg_search: d1,d2=",d1,d2
#endif
      if((d1-dtgt)*(dtgt-d2).lt.0.d0) 
     $  call errexec("bad drg1,drg2,dtgt")
      b1=.false.
      do while(.not.b1)
        d6=(d3+d4)*.5d0
        b1=abs(d4-d6).lt.1.d-15.or.abs((d4-d6)/(d4+d6))*2.d0.lt.1.d-15
        xo=0.d0
        ca2=d6
!$OMP PARALLEL PRIVATE(ca1,ca3)
        allocate(ca3(n1*n2*n3)); ca3=(0.d0,0.d0)
!$OMP DO
        do i1=1,n4
          call ttritg_sum(dmna,dmnr,n1,n2,n3,imt1
     $                   ,fk(:,i1),gk(:,i1),1,ca2,ca1,ca3)
        end do
!$OMP END DO
!$OMP CRITICAL
        xo=xo+ca3
!$OMP END CRITICAL
        deallocate(ca3)
!$OMP END PARALLEL
        d5=abs(dimag(sum(xo)))
        if((d1-dtgt)*(dtgt-d5).ge.0.d0)then
          d4=d6
        else
          d3=d6
        end if
#ifdef MPI
#else
        write(*,"(a,2g25.16)")"#ttritg_search: d6,d5=",d6,d5
#endif
      end do
      dout=d6
      end subroutine

      subroutine ttritg_simple(dmna,dmnr,n1,n2,n3,imt1,fk,gk,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: n1
      integer, intent(in) :: n2
      integer, intent(in) :: n3
      integer, intent(in) :: imt1(nvtx,n1*n2*n3*ndiv)
      complex(8), intent(in) :: fk(n1*n2*n3)
      complex(8), intent(in) :: gk(n1*n2*n3)
      complex(8), intent(inout) :: xo(n1*n2*n3)
      complex(8) :: ca1(nvtx),ca2(1)
      ca2=(0.d0,0.d0)
      call ttritg_sum(dmna,dmnr,n1,n2,n3,imt1,fk,gk
     $                ,1,ca2,ca1,xo)
      end subroutine

      subroutine ttritg_sum(dmna,dmnr,n1,n2,n3,imt1,fk,gk,ne,em,ca1,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: n1
      integer, intent(in) :: n2
      integer, intent(in) :: n3
      integer, intent(in) :: imt1(nvtx,n1*n2*n3*ndiv)
      complex(8), intent(in) :: fk(n1*n2*n3)
      complex(8), intent(in) :: gk(n1*n2*n3)
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(  out) :: ca1(ne*nvtx)
      complex(8), intent(inout) :: xo(ne,n1*n2*n3)
      integer :: i1,i2,i3,i4,i5,i6,i7
      if(n1.eq.1.and.n2.eq.1.and.n3.eq.1)then
        xo(:,1)=xo(:,1)+fk(1)*log((gk(1)+em)/(-1.d0))
        return
      end if
      do i1=1,n1*n2*n3*ndiv
        call calc(dmna,dmnr,imt1(:,i1),n1*n2*n3
     $           ,fk
     $           ,gk,ne,em,ca1
     $           ,xo)
      end do
      end subroutine

      subroutine calc(dmna,dmnr,ia1,nnn,fk,gk,ne,em,ca1,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: ia1(nvtx)
      integer, intent(in) :: nnn
      complex(8), intent(in) :: fk(nnn)
      complex(8), intent(in) :: gk(nnn)
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(  out) :: ca1(ne,nvtx)
      complex(8), intent(inout) :: xo(ne,nnn)
      integer :: i1,i2,i3,i4,i5,i6
      integer :: ia2(4),ia3(4),ia4(4)
      complex(8) :: geq1,geq2
      call chk1(dmna,dmnr,nnn,gk,ia1,ia2,ia3,ia4,i3)
      select case(sum(ia2))
      case(0)
        call ttritg_sub2normal(
     $             gk(ia4(2)),gk(ia4(1)),gk(ia4(3)),gk(ia4(4))
     $            ,ne,em,ca1(:,1))
        call ttritg_sub2normal(
     $             gk(ia4(1)),gk(ia4(2)),gk(ia4(3)),gk(ia4(4))
     $            ,ne,em,ca1(:,2))
        call ttritg_sub2normal(
     $             gk(ia4(1)),gk(ia4(3)),gk(ia4(2)),gk(ia4(4))
     $            ,ne,em,ca1(:,3))
        call ttritg_sub2normal(
     $             gk(ia4(1)),gk(ia4(4)),gk(ia4(2)),gk(ia4(3))
     $            ,ne,em,ca1(:,4))
          xo(:,ia4(1))=xo(:,ia4(1))+fk(ia4(1))*ca1(:,1)
          xo(:,ia4(2))=xo(:,ia4(2))+fk(ia4(2))*ca1(:,2)
          xo(:,ia4(3))=xo(:,ia4(3))+fk(ia4(3))*ca1(:,3)
          xo(:,ia4(4))=xo(:,ia4(4))+fk(ia4(4))*ca1(:,4)
      case(2)
          geq1=sum(gk(ia3(1:2)))/2.d0
          call ttritg_sub2g10   (
     $             geq1      ,geq1      ,gk(ia4(1)),gk(ia4(2))
     $            ,ne,em,ca1(:,1))
          call ttritg_sub2g30   (
     $             geq1      ,gk(ia4(1)),gk(ia4(2)),geq1      
     $            ,ne,em,ca1(:,2))
          call ttritg_sub2g30   (
     $             geq1      ,gk(ia4(2)),gk(ia4(1)),geq1      
     $            ,ne,em,ca1(:,3))
          xo(:,ia3(1))=xo(:,ia3(1))+fk(ia3(1))*ca1(:,1)
          xo(:,ia3(2))=xo(:,ia3(2))+fk(ia3(2))*ca1(:,1)
          xo(:,ia4(1))=xo(:,ia4(1))+fk(ia4(1))*ca1(:,2)
          xo(:,ia4(2))=xo(:,ia4(2))+fk(ia4(2))*ca1(:,3)
      case(3)
          geq1=sum(gk(ia3(1:3)))/3.d0
          call ttritg_sub2g30g10(
     $             geq1      ,geq1      ,gk(ia4(1)),geq1      
     $            ,ne,em,ca1(:,1))
          call ttritg_sub2g30g20(
     $             geq1      ,gk(ia4(1)),geq1      ,geq1      
     $            ,ne,em,ca1(:,2))
          xo(:,ia3(1))=xo(:,ia3(1))+fk(ia3(1))*ca1(:,1)
          xo(:,ia3(2))=xo(:,ia3(2))+fk(ia3(2))*ca1(:,1)
          xo(:,ia3(3))=xo(:,ia3(3))+fk(ia3(3))*ca1(:,1)
          xo(:,ia4(1))=xo(:,ia4(1))+fk(ia4(1))*ca1(:,2)
      case(4)
        select case(i3)
        case(2)
          geq1=sum(gk(ia3(1:2)))/2.d0; geq2=sum(gk(ia3(3:4)))/2.d0
          call ttritg_sub2g30g21(
     $             geq2      ,geq1      ,geq1      ,geq2      
     $            ,ne,em,ca1(:,1))
          call ttritg_sub2g30g21(
     $             geq1      ,geq2      ,geq2      ,geq1      
     $            ,ne,em,ca1(:,2))
          xo(:,ia3(1))=xo(:,ia3(1))+fk(ia3(1))*ca1(:,1)
          xo(:,ia3(2))=xo(:,ia3(2))+fk(ia3(2))*ca1(:,1)
          xo(:,ia3(3))=xo(:,ia3(3))+fk(ia3(3))*ca1(:,2)
          xo(:,ia3(4))=xo(:,ia3(4))+fk(ia3(4))*ca1(:,2)
        case(3:6)
          geq1=sum(gk(ia3(1:4)))/4.d0
          call ttritg_sub2simple(
     $             geq1      ,geq1      ,geq1      ,geq1      
     $            ,ne,em,ca1(:,1))
          xo(:,ia3(1))=xo(:,ia3(1))+ca1(:,1)*fk(ia3(1))
          xo(:,ia3(2))=xo(:,ia3(2))+ca1(:,1)*fk(ia3(2))
          xo(:,ia3(3))=xo(:,ia3(3))+ca1(:,1)*fk(ia3(3))
          xo(:,ia3(4))=xo(:,ia3(4))+ca1(:,1)*fk(ia3(4))
        case default
          call errexec("bad i3")
        end select
      case default
        call errexec("bad sum ia2")
      end select
      end subroutine

      subroutine ttritg_sub1simple(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=log((h0+em)/(-1.d0))/6.d0
      end subroutine

      subroutine ttritg_sub1g30g21(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g1); gmx1=max(-g0,-g1)
      x0=
     $     +g0**2*(g0-3.d0*g1)*log((h0+em)/(h1+em))
     $     -min(max(dble(em),gmn1),gmx1)*(6.d0*g0*g1
     $     +min(max(dble(em),gmn1),gmx1)*(3.d0*(g0+g1)
     $     +min(max(dble(em),gmn1),gmx1)*2.d0))
     $        *log((-h0-em)/(-h1-em))
      x0=x0/(6.d0*g01**3)
      x0=x0-log((-1.d0)/(h1+em))/6.d0
      end subroutine

      subroutine ttritg_sub1g30g20(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g1); gmx1=max(-g0,-g1)
      x0=-(g1+min(max(dble(em),gmn1),gmx1))**3*log((-h1-em)/(-h0-em))
      x0=x0/(6.d0*g01**3)+log(-h0-em)/6.d0
      end subroutine

      subroutine ttritg_sub1g30   (h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g1); gmx1=max(-g0,-g1)
      gmn2=min(-g1,-g2); gmx2=max(-g1,-g2)
      x0=
     $ -g12*(g0+min(max(dble(em),gmn1),gmx1))**2
     $        *(g0**2-2.d0*g0*(g1+g2)
     $         +3.d0*g1*g2+(-2.d0*g0+g1+g2)
     $         *min(max(dble(em),gmn1),gmx1))*log((h0+em)/(h1+em))
     $ +g01**2*(
     $         +(g2+min(max(dble(em),gmn2),gmx2))**3
     $          *log((-h2-em)/(-h1-em))
     $         +(g0**2*g1-g0**2*g2-2.d0*g0*g1*g2+2.d0*g0*g2**2+g1*g2**2)
     $          *log((-1.d0)/(h1+em)))
     $ +g01**2*g2**3*log(-h1-em)
      x0=-x0/(6.d0*g01**2*g02**2*g12)
      end subroutine

      subroutine ttritg_sub1normal(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g1); gmx1=max(-g0,-g1)
      gmn2=min(-g1,-g3); gmx2=max(-g1,-g3)
      gmn3=min(-g1,-g2); gmx3=max(-g1,-g2)
      x0=
     $  +g12*g13*g23*(g0+min(max(dble(em),gmn1),gmx1))**3
     $   *log((h0+em)/(h1+em))
     $  -g01*g02*g12*(g3+min(max(dble(em),gmn2),gmx2))**3
     $   *log((-h3-em)/(-h1-em))
     $  +g01*g03*g13*(g2+min(max(dble(em),gmn3),gmx3))**3
     $   *log((-h2-em)/(-h1-em))
     $  +g01*g23*(g03*g1*g2**2+g12*g3*(g2*g03+g3*g0))*log(-h1-em)
     $  -g01*g23
     $   *(g0**2*(g1*(g1-g2-g3)+g2*g3)
     $    +g0*g1*(g2*g3-g1*(g2+g3))+g1**2*g2*g3)*log((-1.d0)/(h1+em))
      x0=x0/(6.d0*(g01*g12*g23*g13*g02*g03))
      end subroutine

      subroutine ttritg_sub2simple(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=log((h0+em)/(-1.d0))/24.d0
      end subroutine

      subroutine ttritg_sub2g30g20(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g1); gmx1=max(-g0,-g1)
      x0=
     $  -(g1+min(max(dble(em),gmn1),gmx1))**3
     $   *(4.d0*g0-g1+3.d0*min(max(dble(em),gmn1),gmx1))
     $   *log((-h1-em)/(-h0-em))
      x0=x0/(24.d0*g01**4)+log(-h0-em)/24.d0
      end subroutine

      subroutine ttritg_sub2g30g21(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      call ttritg_sub2g30g20(h1,h0,h1,h1,ne,em,x0)
      end subroutine

      subroutine ttritg_sub2g30g10(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g2); gmx1=max(-g0,-g2)
      x0=(g2+min(max(dble(em),gmn1),gmx1))**4*log((h2+em)/(h0+em))
     $  -g02**4*log((-1.d0)/(h0+em))
      x0=x0/(24.d0*g02**4)
      end subroutine

      subroutine ttritg_sub2g10   (h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g2); gmx1=max(-g0,-g2)
      gmn2=min(-g0,-g3); gmx2=max(-g0,-g3)
      x0=-g03**3*(g2+min(max(dble(em),gmn1),gmx1))**4
     $    *log((h2+em)/(h0+em))
     $   +g02**3*(g3+min(max(dble(em),gmn2),gmx2))**4
     $    *log((h3+em)/(h0+em))
      x0=x0/(24.d0*g02**3*g03**3*g23)-log((-1.d0)/(h0+em))/24.d0
      end subroutine

      subroutine ttritg_sub2g30   (h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      gmn1=min(-g0,-g1); gmx1=max(-g0,-g1)
      gmn2=min(-g0,-g2); gmx2=max(-g0,-g2)
      x0=
     $  +g02**2*(g1+min(max(dble(em),gmn1),gmx1))**3
     $   *(g12*(3.d0*g0-g1)-g2*g01
     $    +(2.d0*g02-3.d0*g01)*min(max(dble(em),gmn1),gmx1))
     $                     *log((-h1-em)/(-h0-em))
     $  +g01**3*(g2+min(max(dble(em),gmn2),gmx2))**4
     $   *log((-h2-em)/(-h0-em))
      x0=x0/(24.d0*g01**3*g02**2*g12**2)+log(-h0-em)/24.d0
      end subroutine

      subroutine ttritg_sub2normal(h0,h1,h2,h3,ne,em,x0)
      complex(8), intent(in) :: h0,h1,h2,h3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      real(8) :: g0,g1,g2,g3,g01,g02,g03,g12,g13,g23
      real(8) :: gmn1,gmx1,gmn2,gmx2,gmn3,gmx3
      g0=dble(h0); g1=dble(h1); g2=dble(h2); g3=dble(h3)
      gmn1=min(-g1,-g2); gmx1=max(-g1,-g2)
      gmn2=min(-g1,-g3); gmx2=max(-g1,-g3)
      gmn3=min(-g0,-g1); gmx3=max(-g0,-g1)
      g01=g0-g1; g02=g0-g2; g03=g0-g3; g12=g1-g2; g13=g1-g3; g23=g2-g3
      x0=-g01**2*g03*g13**2*(g2+min(max(dble(em),gmn1),gmx1))**4
     $    *log((h2+em)/(h1+em))
     $   +g01**2*g02*g12**2*(g3+min(max(dble(em),gmn2),gmx2))**4
     $    *log((h3+em)/(h1+em))
     $   -g12**2*g13**2*g23*min(max(dble(em),gmn3),gmx3)
     $    *(2.d0*g0+min(max(dble(em),gmn3),gmx3))
     $    *(2.d0*g0**2+min(max(dble(em),gmn3),gmx3)
     $    *(2.d0*g0+min(max(dble(em),gmn3),gmx3)))
     $    *log((-h1-em)/(-h0-em))
     $ +g12**2*g13**2*g23*(
     $   (g01*(2.d0*g0*g1*g03-g0*g2*g13+g1*g2*g3)
     $   +g02*g0**2*(g23+2.d0*g3)+g12*g0*g1*g03
     $   +g0**2*g2*g23+g0*g1*g2*g3
     $   )*log((-1.d0)/(h1+em))+g0**4*log(-h0-em)
     $                    )
      x0=x0/(24.d0*g01**2*g02*g12**2*g03*g13**2*g23)
      end subroutine





      subroutine chk1(dmna,dmnr,nnn,gk,ia1,ia2,ia3,ia4,i3)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: nnn
      complex(8), intent(in) :: gk(nnn)
      integer, intent(in) :: ia1(4)
      integer, intent(out):: ia2(4)
      integer, intent(out):: ia3(4)
      integer, intent(out):: ia4(4)
      integer, intent(out):: i3
      integer :: i1,i2,i4,i5
      real(8) :: d1,d2
      i3=0
      i4=0
      ia2=0
      ia3=0
      do i1=1,3
        do i2=i1+1,4
          d1=abs(dble(gk(ia1(mod(i1,4)+1))-gk(ia1(mod(i2,4)+1))))
          d2=abs(dble(gk(ia1(mod(i1,4)+1))+gk(ia1(mod(i2,4)+1))))*.5d0
          if(d1.lt.dmna.or.d1/d2.lt.dmnr)then
            i3=i3+1
            if(ia2(mod(i1,4)+1).eq.0)then
              i4=i4+1
              ia3(i4)=ia1(mod(i1,4)+1)
              ia2(mod(i1,4)+1)=1
            end if
            if(ia2(mod(i2,4)+1).eq.0)then
              i4=i4+1
              ia3(i4)=ia1(mod(i2,4)+1)
              ia2(mod(i2,4)+1)=1
            end if
          else
          end if
        end do
      end do
      i5=0
      ia4=0
      do i1=1,4
        if(ia2(mod(i1,4)+1).eq.0) then
          i5=i5+1
          ia4(i5)=ia1(mod(i1,4)+1)
        end if
      end do
      if(sum(ia2).ne.i4) call errexec("bad ia2 and i4")
      if(i4+i5.ne.4)     call errexec("bad i4 and i5")
      end subroutine

      !subroutine ttritg_mkidx(n1,n2,n3,idx1)
      subroutine ttritg_mkidx(n1,n2,n3,idx1,bvec1,bvec2,bvec3)
      integer, intent(in) :: n1
      integer, intent(in) :: n2
      integer, intent(in) :: n3
      integer, intent(out):: idx1(nvtx,n1*n2*n3*ndiv)
      real(8), intent(in), optional :: bvec1(3),bvec2(3),bvec3(3)
      real(8) :: bvec(3,3)
      integer :: i1,i2,i3,i4,i5,i6,i7
      integer :: imt1(8,8)
      integer :: ia1(8)
      if(n1.eq.1.and.n2.eq.1.and.n3.eq.1)return
!--
!      imt1(:,1)=(/0,1,n1,n1+1,n1*n2,n1*n2+1,n1*n2+n1,n1*n2+n1+1/)
!      imt1(:,2)=imt1(:,1)-(/0,n1,0,n1,0,n1,0,n1/)
!      imt1(:,3)=imt1(:,1)
!     $                -(/0,0,n1*n2,n1*n2,0,0,n1*n2,n1*n2/)
!      imt1(:,4)=imt1(:,3)-(/0,n1,0,n1,0,n1,0,n1/)
!      imt1(:,5)=imt1(:,1)
!     $                -(/0,0,0,0,n1*n2*n3,n1*n2*n3,n1*n2*n3,n1*n2*n3/)
!      imt1(:,6)=imt1(:,2)
!     $                -(/0,0,0,0,n1*n2*n3,n1*n2*n3,n1*n2*n3,n1*n2*n3/)
!      imt1(:,7)=imt1(:,3)
!     $                -(/0,0,0,0,n1*n2*n3,n1*n2*n3,n1*n2*n3,n1*n2*n3/)
!      imt1(:,8)=imt1(:,4)
!     $                -(/0,0,0,0,n1*n2*n3,n1*n2*n3,n1*n2*n3,n1*n2*n3/)
!      i6=0
!      i4=0
!      do i3=1,n3
!      do i2=1,n2
!      do i1=1,n1
!        i4=i4+1
!        i5=1
!        if (i1.eq.n1) i5=i5+1
!        if (i2.eq.n2) i5=i5+2
!        if (i3.eq.n3) i5=i5+4
!        ia1=i4+imt1(:,i5)
!        do i7=1,ndiv
!          i6=i6+1
!          idx1(:,i6)=ia1(ttritg_tbl1(:,i7))
!        end do
!      end do
!      end do
!      end do
!      if (i4.ne.n1*n2*n3     ) call errexec("bad i4")
!      if (i6.ne.n1*n2*n3*ndiv) call errexec("bad i6")
!--
      bvec=reshape((/1d0,0d0,0d0,0d0,1d0,0d0,0d0,0d0,1d0/),(/3,3/))
      if(present(bvec1))bvec(:,1)=bvec1
      if(present(bvec2))bvec(:,2)=bvec2
      if(present(bvec3))bvec(:,3)=bvec3
      call libtetrabzinitialize(bvec,(/n1,n2,n3/),idx1)
      end subroutine
        
      subroutine errexec(smsg)
      character(*), intent(in) :: smsg
      integer :: i(1:1)
      integer :: j
      j=0
      write(*,"(a)")"#ERROR in ttritg_: "//smsg
      i(j)=0
      write(*,"('#errexec cannot stop')")
      write(*,"('#please use debug option')")
      stop
      end subroutine

!!!FROM LIBTETRABZ, MIT License, Copyright (c) 2014 Mitsuaki Kawamura!!!
      subroutine libtetrabzinitialize(bvec,ng,indx1)
      real(8), intent(in   ) :: bvec(3,3)
      integer, intent(in   ) :: ng(3)
      integer, intent(  out) :: indx1(4,*)
      integer :: nk,nt, ivvec(3,4,6), ikv(3)
      integer :: itype, i1, i2, i3, it, ii, divvec(4,4), ivvec0(4)
      real(8) :: l(4), bvec2(3,3), bvec3(3,4)
      nk = product(ng(1:3))
      nt = nk * 6
      do i1 = 1, 3
        bvec2(1:3,i1) = bvec(1:3,i1) / dble(ng(i1))
      end do
      bvec3(1:3,1) = -bvec2(1:3,1) + bvec2(1:3,2) + bvec2(1:3,3)
      bvec3(1:3,2) =  bvec2(1:3,1) - bvec2(1:3,2) + bvec2(1:3,3)
      bvec3(1:3,3) =  bvec2(1:3,1) + bvec2(1:3,2) - bvec2(1:3,3)
      bvec3(1:3,4) =  bvec2(1:3,1) + bvec2(1:3,2) + bvec2(1:3,3)
      ! length of delta bvec
      do i1 = 1, 4
        l(i1) = dot_product(bvec3(1:3,i1),bvec3(1:3,i1))
      end do
      itype = minloc(l(1:4),1)
      ! start & last
      ivvec0(1:4) = (/ 0, 0, 0, 0 /)
      divvec(1:4,1) = (/ 1, 0, 0, 0 /)
      divvec(1:4,2) = (/ 0, 1, 0, 0 /)
      divvec(1:4,3) = (/ 0, 0, 1, 0 /)
      divvec(1:4,4) = (/ 0, 0, 0, 1 /)
      ivvec0(itype) = 1
      divvec(itype, itype) = - 1
      ! Corners of tetrahedra
      it = 0
      do i1 = 1, 3
        do i2 = 1, 3
          if(i2 == i1) cycle
          do i3 = 1, 3
            if(i3 == i1 .or. i3 == i2) cycle
            it = it + 1
            ivvec(1:3,1,it) = ivvec0(1:3)
            ivvec(1:3,2,it) = ivvec(1:3,1,it) + divvec(1:3,i1)
            ivvec(1:3,3,it) = ivvec(1:3,2,it) + divvec(1:3,i2)
            ivvec(1:3,4,it) = ivvec(1:3,3,it) + divvec(1:3,i3)
          end do
        end do
      end do
!     allocate(indx1(20, 6 * nk), indx2(20, 6 * nk), indx3(20 * 6 * nk))
      nt = 0
      do i3 = 1, ng(3)
        do i2  = 1, ng(2)
          do i1 = 1, ng(1)
            do it = 1, 6
              nt = nt + 1
              do ii = 1, 4
                ikv(1:3) = (/i1, i2, i3/) + ivvec(1:3,ii,it) - 1
                ikv(1:3) = modulo(ikv(1:3), ng(1:3))
                indx1(ii,nt) = 1 + ikv(1) + ng(1) * ikv(2) 
     $                                    + ng(1) * ng(2) * ikv(3)
              end do
            end do
          end do
        end do
      end do
      end subroutine
!!!FROM LIBTETRABZ, MIT License, Copyright (c) 2014 Mitsuaki Kawamura!!!
        
      end module

subroutine make_eks(NTK,NWF,Na1,Na2,Na3,HmatR,pf,EKS,VKS)  
  implicit none 
  integer::NTK,NWF,Na1,Na2,Na3 
  complex(8)::pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)   
  complex(8)::HmatR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
  complex(8),allocatable::Hin(:,:)!Hin(NWF,NWF)          
  real(8),allocatable::E_TMP_R(:)!E_TMP_R(NWF)           
  integer::ik,ib,jb,ia1,ia2,ia3
  complex(8)::SUM_CMPX 
  real(8)::EKS(NWF,NTK)           
  complex(8)::VKS(NWF,NWF,NTK)  
  !
  !HKS IN WANNIER BASIS. AND DIAGONALIZE
  !
  allocate(Hin(NWF,NWF)); Hin=0.0d0           
  allocate(E_TMP_R(NWF)); E_TMP_R=0.0d0            
  !
  EKS=0.0d0 
  VKS=0.0d0 
  do ik=1,NTK 
   Hin(:,:)=0.0D0               
   do ib=1,NWF      
    do jb=1,NWF      
     SUM_CMPX=0.0D0                    
     do ia1=-Na1,Na1 
      do ia2=-Na2,Na2 
       do ia3=-Na3,Na3 
        SUM_CMPX=SUM_CMPX+HmatR(ib,jb,ia1,ia2,ia3)*pf(ia1,ia2,ia3,ik)  
       enddo!ia3            
      enddo!ia2                       
     enddo!ia1
     Hin(ib,jb)=SUM_CMPX           
    enddo!jb 
   enddo!ib 
   E_TMP_R(:)=0.0D0 
   call diagV(NWF,Hin(1,1),E_TMP_R(1)) 
   EKS(:,ik)=E_TMP_R(:) 
   VKS(:,:,ik)=Hin(:,:) 
  enddo!ik 
  deallocate(Hin,E_TMP_R) 
  !
return
end

subroutine make_emk(NTK,NWF,nsgm,Na1,Na2,Na3,HmatT,pf,EMK)  
  implicit none 
  integer::NTK,NWF,nsgm,Na1,Na2,Na3 
  complex(8)::pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)   
  !complex(8)::HmatT(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm)   
  complex(4)::HmatT(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm)   
  complex(8)::larger_en
  complex(8),allocatable::Hin(:,:)!Hin(NWF,NWF)          
  complex(8),allocatable::E_TMP_C(:)!E_TMP_C(NWF)           
  integer::LDVL,LDVR,LWORK,ind 
  complex(8),ALLOCATABLE::VL(:,:)
  complex(8),ALLOCATABLE::VR(:,:)
  complex(8),ALLOCATABLE::work_zgeev(:)
  real(8),ALLOCATABLE::rwork_zgeev(:)
  integer::ie,ik,ib,jb,ia1,ia2,ia3,i,j
  complex(8)::SUM_CMPX 
  complex(8)::EMK(NWF,NTK,nsgm)           
  !
  do ie=1,nsgm
   LWORK=5*NWF;LDVL=NWF;LDVR=NWF;ind=0                 
!$OMP PARALLEL PRIVATE(ik,ib,jb,ia1,ia2,ia3,SUM_CMPX,Hin,E_TMP_C,VL,VR,work_zgeev,rwork_zgeev,i,j,larger_en)
   allocate(VL(LDVL,NWF))
   allocate(VR(LDVR,NWF))
   allocate(work_zgeev(LWORK))
   allocate(rwork_zgeev(2*NWF))
   allocate(Hin(NWF,NWF)); Hin=0.0d0           
   allocate(E_TMP_C(NWF)); E_TMP_C=0.0d0            
!$OMP DO
   do ik=1,NTK 
    Hin(:,:)=0.0D0               
    do ib=1,NWF      
     do jb=1,NWF      
      SUM_CMPX=0.0D0                    
      do ia1=-Na1,Na1 
       do ia2=-Na2,Na2 
        do ia3=-Na3,Na3 
         SUM_CMPX=SUM_CMPX+HmatT(ib,jb,ia1,ia2,ia3,ie)*pf(ia1,ia2,ia3,ik)  
        enddo!ia3            
       enddo!ia2                       
      enddo!ia1
      Hin(ib,jb)=SUM_CMPX           
     ENDDO!jb 
    ENDDO!ib 
    !write(6,*)Hin
    E_TMP_C(:)=0.0d0  
    call zgeev("N","N",NWF,Hin,NWF,E_TMP_C,VL,NWF,VR,NWF,work_zgeev,LWORK,rwork_zgeev,ind)
    if(ind/=0) write(6,*) ind,ik,ib 
    !
    do i=1,NWF-1
     do j=i+1,NWF 
      if(dble(E_TMP_C(i))>dble(E_TMP_C(j)))then 
       larger_en=E_TMP_C(i)
       E_TMP_C(i)=E_TMP_C(j) 
       E_TMP_C(j)=larger_en 
      endif 
     enddo!j 
    enddo!i 
    do ib=1,NWF  
     EMK(ib,ik,ie)=E_TMP_C(ib) 
    enddo!ib  
    !
   enddo!ik 
!$OMP END DO
    deallocate(VL,VR,work_zgeev,rwork_zgeev,Hin,E_TMP_C) 
!$OMP END PARALLEL
   write(6,*)'ie=',ie 
  enddo !ie 
  !
  !
return
end

subroutine calc_band_disp(Ndiv,N_sym_points,NTK,NSK_BAND_DISP,Na1,Na2,Na3,n_occ,SK_BAND_DISP,H_MAT_R,nkb1,nkb2,nkb3,a1,a2,a3,b1,b2,b3,&
  kdata,E_BAND_DISP)  
  implicit none 
  !
  integer::Ndiv,N_sym_points,NTK,NSK_BAND_DISP,Na1,Na2,Na3,n_occ
  integer::nkb1,nkb2,nkb3 
  real(8)::SK_BAND_DISP(3,NSK_BAND_DISP)
  real(8)::a1(3),a2(3),a3(3),b1(3),b2(3),b3(3) 
  complex(8)::H_MAT_R(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3)
  !
  real(8),allocatable::E_TMP(:)!E_TMP(n_occ)  
  real(8),allocatable::WEIGHT_R(:,:,:)!WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
  complex(8),allocatable::H_TMP_IN(:,:)!H_TMP_IN(n_occ,n_occ)
  complex(8),allocatable::H_TMP_OUT(:,:)!H_TMP_OUT(n_occ,n_occ)
  real(8),allocatable::DIST_K(:)!DIST_K(NTK)
  real(8),allocatable::dist(:)!dist(0:Nblk-1)
  !
  integer::ik,ib,jb,ix,ia1,ia2,ia3,ks,ke,ia1min,ia2min,ia3min 
  real(8)::DIST_B(3),DIST_KSPACE
  real(8)::PHASE 
  real(8)::SUM_REAL 
  complex(8)::PHASE_FACTOR     
  complex(8)::SUM_CMPX 
  !
  real(8),parameter::au=27.21151d0
  real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
  complex(8),parameter::ci=(0.0D0,1.0D0) 
  !
  real(8),intent(out)::kdata(NSK_BAND_DISP)
  real(8),intent(out)::E_BAND_DISP(n_occ,NSK_BAND_DISP)
  !
  !1. SAMPLE k-POINTS FOR INTERPOLATED BAND DISPERSION 
  !
  write(6,*) 
  write(6,*)'==================================='
  write(6,*)'CALCULATED kpts FOR BAND DISPERSION'
  write(6,*)'==================================='
  write(6,*) 
  write(6,'(a20,i8)')'NSK_BAND_DISP=',NSK_BAND_DISP
  do ik=1,NSK_BAND_DISP 
   write(6,*) SK_BAND_DISP(:,ik)
  enddo!ik  
  !
  !2. WEIGHT_R BY YUSUKE NOMURA 
  !
  allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)) 
  WEIGHT_R=1.0d0; SUM_REAL=0.0d0 
  do ia1=-Na1,Na1!-1         
   do ia2=-Na2,Na2!-1         
    do ia3=-Na3,Na3!-1         
     if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
    enddo
   enddo
  enddo 
  write(6,'(a20,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
  if(abs(SUM_REAL-dble(NTK))>1.0d-6)then 
   stop 'SUM_WEIGHT/=NTK'
  endif 
  !
  !3. H_MAT(k') IN WANNIER BASIS AND DIAGONALIZE 
  !
  allocate(E_TMP(n_occ));E_TMP(:)=0.0d0            
  allocate(H_TMP_IN(n_occ,n_occ));H_TMP_IN(:,:)=0.0d0           
  allocate(H_TMP_OUT(n_occ,n_occ));H_TMP_OUT(:,:)=0.0d0  
  !allocate(E_BAND_DISP(n_occ,NSK_BAND_DISP))
  E_BAND_DISP=0.0d0 
  !
  do ik=1,NSK_BAND_DISP          
   H_TMP_IN(:,:)=0.0D0               
   do ib=1,n_occ      
    do jb=1,n_occ      
     SUM_CMPX=0.0D0                    
     do ia1=-Na1,Na1!-1         
      do ia2=-Na2,Na2!-1         
       do ia3=-Na3,Na3!-1         
        !
        !NEAREST R SEARCH BY YOSHIHIDE YOSHIMOTO 
        !
        call search_Rmin(ia1,ia2,ia3,nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),ia1min,ia2min,ia3min)
        PHASE=tpi*(SK_BAND_DISP(1,ik)*DBLE(ia1min)+SK_BAND_DISP(2,ik)*DBLE(ia2min)+SK_BAND_DISP(3,ik)*DBLE(ia3min))                
        PHASE_FACTOR=EXP(ci*PHASE)*WEIGHT_R(ia1,ia2,ia3) 
        SUM_CMPX=SUM_CMPX+H_MAT_R(ib,jb,ia1,ia2,ia3)*PHASE_FACTOR 
       enddo!ia3            
      enddo!ia2                       
     enddo!ia1
     H_TMP_IN(ib,jb)=SUM_CMPX           
    enddo!jb
   enddo!ib
   !
   !4. diag H_TMP_IN
   !
   E_TMP(:)=0.0D0                
   call diagV(n_occ,H_TMP_IN(1,1),E_TMP(1)) 
   H_TMP_OUT(:,:)=H_TMP_IN(:,:)
   E_BAND_DISP(:,ik)=E_TMP(:)            
  enddo!ik           
  !
  !5. GENERATE KDATA (DISPERSION LINE) 
  !
  allocate(DIST_K(NSK_BAND_DISP));DIST_K(:)=0.0d0 
  allocate(dist(0:N_sym_points-1));dist(:)=0.0d0 
  !
  dist(0)=0.0d0 
  do ix=1,N_sym_points-1 
   ks=(ix-1)*Ndiv+1
   ke=(ix)*Ndiv+1
   do ik=ks,ke 
    DIST_B(:)=(SK_BAND_DISP(1,ik)-SK_BAND_DISP(1,ks))*b1(:)&
             +(SK_BAND_DISP(2,ik)-SK_BAND_DISP(2,ks))*b2(:)&
             +(SK_BAND_DISP(3,ik)-SK_BAND_DISP(3,ks))*b3(:)
    DIST_KSPACE=DSQRT(DIST_B(1)**2+DIST_B(2)**2+DIST_B(3)**2)
    DIST_K(ik)=DIST_KSPACE+dist(ix-1) 
   enddo!ik 
   dist(ix)=dist(ix-1)+DIST_KSPACE
  enddo!ix 
  !
  kdata=0.0d0 
  kdata(:)=DIST_K(:)/DIST_K(NSK_BAND_DISP)
  !
  deallocate(E_TMP,WEIGHT_R,H_TMP_IN,H_TMP_OUT,DIST_K,dist) 
  !
return
end

! $Id: fft3d.f90,v 1.11 2002/09/18 00:47:12 yosimoto Exp $
module fft_3d
  integer,parameter,private:: nradix=6
  integer,dimension(nradix),parameter,private:: radix=(/6, 8, 3, 4, 2, 5/)
  integer,parameter,private:: nfmax = 30
  logical,parameter,private:: prefer4 = .false.
  private:: fact235,genw,fftv,bftv,fft_tp1,fft_tp,fft_tps1,fft_tps
  private:: fftrd2,bftrd2,fftrd3,bftrd3,fftrd4,bftrd4,fftrd5,bftrd5
  private:: fftrd6,bftrd6,fftrd8,bftrd8
  !
  type fft3_struct
     integer:: nx,ny,nz,nxyz,lx,ly,lz,lxyz
     integer:: nfx,nfy,nfz
     integer,dimension(nfmax):: facx,facy,facz
     real(kind=8),pointer,dimension(:,:):: wx,wy,wz
  end type fft3_struct
contains

  subroutine fact235(n,nf,fac)
    implicit none
    integer,intent(in):: n
    integer,intent(out):: nf,fac(nfmax)
    !
    integer:: p,q,r,j
    integer:: n2,n3,n4,n5,n6,n8
    !
    p = n
    fac(:) = 0
    !
    n2 = 0
    q = p/2
    r = p-2*q
    do while ( (q .gt. 0) .and. (r .eq. 0) )
       n2 = n2 + 1
       p = q
       q = p/2
       r = p-2*q
    end do

    n3 = 0
    q = p/3
    r = p-3*q
    do while ( (q .gt. 0) .and. (r .eq. 0) )
       n3 = n3 + 1
       p = q
       q = p/3
       r = p-3*q
    end do

    n5 = 0
    q = p/5
    r = p-5*q
    do while ( (q .gt. 0) .and. (r .eq. 0) )
       n5 = n5 + 1
       p = q
       q = p/5
       r = p-5*q
    end do

    if (p .ne. 1) then
       write(6,*) n, ' can not be factorized with 2, 3, 5'
       stop
    end if

    n6 = min(n2,n3)
    n2 = n2 - n6
    n3 = n3 - n6
    if (prefer4) then ! prefer radix 4
       n4 = n2/2
       j = mod(n2,2)
       if ( (j .eq. 1) .and. (n4 .ge. 1) ) then
          n8 = 1
          n4 = n4 - 1
       else
          n8 = 0
       end if
    else ! prefer radix 8
       n8 = n2/3
       j = mod(n2,3)
       if (j .eq. 2) then
          n4 = 1
       else if ( (j .eq. 1) .and. (n8 .ge. 1) ) then
          n8 = n8 - 1
          n4 = 2
       else
          n4 = 0
       end if
    end if
       
    n2 = n2 - n4*2 - n8*3
    if (n2 .lt. 0) then
       write(6,*) n2, ' n2 become negative'
       stop
    end if
    if (n2+n3+n4+n5+n6+n8 .gt. nfmax) then
       write(6,*) 'too many factors'
       stop
    end if

    p = 1
    nf = 0
    do j=1,n2
       nf = nf + 1
       fac(nf) = 2
       p = p*2
    end do
    do j=1,n3
       nf = nf + 1
       fac(nf) = 3
       p = p*3
    end do
    do j=1,n4
       nf = nf + 1
       fac(nf) = 4
       p = p*4
    end do
    do j=1,n5
       nf = nf + 1
       fac(nf) = 5
       p = p*5
    end do
    do j=1,n6
       nf = nf + 1
       fac(nf) = 6
       p = p*6
    end do
    do j=1,n8
       nf = nf + 1
       fac(nf) = 8
       p = p*8
    end do

    if (p .ne. n) then
       write(6,*) p, ' is not equal to n = ', n
       stop
    end if

    return
  end subroutine fact235


  subroutine genw(n,nf,fac,w)
    implicit none
    integer,intent(in):: n,nf
    integer:: fac(nfmax)
    real(kind=8),intent(out):: w(2,n)
    !
    real(kind=8),parameter:: tpi=2.0d0*3.14159265358979323846d0
    integer:: iw,darg,ir,rad,narg,k,p
    real(kind=8):: argh,argi,arg
    !
    iw = 1
    darg = n
    do ir = 1,nf
       argh = tpi/darg
       rad = fac(ir)
       narg = darg/rad
       do p = 0,narg-1
          do k = 1,rad-1
             argi = argh*k
             arg = argi*p
             w(1,iw) = cos(arg)
             w(2,iw) = -sin(arg)
             iw = iw + 1
          end do
       end do
       darg = darg/rad
    end do
    return
  end subroutine genw

  subroutine fftrd2(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,2),xi(nvk,np,2)
    real(kind=8),intent(out):: yr(nvk,2,np),yi(nvk,2,np)
    real(kind=8),intent(in):: w(2,np)
    !
    real(kind=8):: wr1,wi1,tr,ti
    integer:: p,ivk
    !
    do p = 1,np
       wr1 = w(1,p)
       wi1 = w(2,p)
       do ivk = 1,nvk
          yr(ivk,1,p) = xr(ivk,p,1) + xr(ivk,p,2)
          yi(ivk,1,p) = xi(ivk,p,1) + xi(ivk,p,2)
          !
          tr = xr(ivk,p,1) - xr(ivk,p,2)
          ti = xi(ivk,p,1) - xi(ivk,p,2)
          yr(ivk,2,p) = wr1*tr - wi1*ti
          yi(ivk,2,p) = wr1*ti + wi1*tr
       end do
    end do
    return
  end subroutine fftrd2
  !
  subroutine bftrd2(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,2),xi(nvk,np,2)
    real(kind=8),intent(out):: yr(nvk,2,np),yi(nvk,2,np)
    real(kind=8),intent(in):: w(2,np)
    !
    real(kind=8):: wr1,wi1,tr,ti
    integer:: p,ivk
    !
    do p = 1,np
       wr1 = w(1,p)
       wi1 = w(2,p)
       do ivk = 1,nvk
          yr(ivk,1,p) = xr(ivk,p,1) + xr(ivk,p,2)
          yi(ivk,1,p) = xi(ivk,p,1) + xi(ivk,p,2)
          !
          tr = xr(ivk,p,1) - xr(ivk,p,2)
          ti = xi(ivk,p,1) - xi(ivk,p,2)
          yr(ivk,2,p) = wr1*tr + wi1*ti
          yi(ivk,2,p) = wr1*ti - wi1*tr
       end do
    end do
    return
  end subroutine bftrd2
  !
  subroutine fftrd3(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,3),xi(nvk,np,3)
    real(kind=8),intent(out):: yr(nvk,3,np),yi(nvk,3,np)
    real(kind=8),intent(in):: w(2,2*np)
    !
    real(kind=8),parameter:: sp3 = 0.866025403784438647d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,tr1,ti1,tr2,ti2,tr3,ti3,tr,ti
    integer:: p,ivk,iw
    !
    iw = 1
    do p = 1,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,2) + xr(ivk,p,3)
          ti1 = xi(ivk,p,2) + xi(ivk,p,3)
          tr2 = xr(ivk,p,1) - 0.5d0*tr1
          ti2 = xi(ivk,p,1) - 0.5d0*ti1
          tr3 = sp3*(xi(ivk,p,2) - xi(ivk,p,3))
          ti3 = -sp3*(xr(ivk,p,2) - xr(ivk,p,3))
          yr(ivk,1,p) = xr(ivk,p,1) + tr1
          yi(ivk,1,p) = xi(ivk,p,1) + ti1
          tr = tr2 + tr3
          ti = ti2 + ti3
          yr(ivk,2,p) = wr1*tr - wi1*ti
          yi(ivk,2,p) = wr1*ti + wi1*tr
          tr = tr2 - tr3
          ti = ti2 - ti3
          yr(ivk,3,p) = wr2*tr - wi2*ti
          yi(ivk,3,p) = wr2*ti + wi2*tr
       end do
    end do
    return
  end subroutine fftrd3
  !
  subroutine bftrd3(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,3),xi(nvk,np,3)
    real(kind=8),intent(out):: yr(nvk,3,np),yi(nvk,3,np)
    real(kind=8),intent(in):: w(2,2*np)
    !
    real(kind=8),parameter:: sp3 = 0.866025403784438647d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,tr1,ti1,tr2,ti2,tr3,ti3,tr,ti
    integer:: p,ivk,iw
    !
    iw = 1
    do p = 1,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,2) + xr(ivk,p,3)
          ti1 = xi(ivk,p,2) + xi(ivk,p,3)
          tr2 = xr(ivk,p,1) - 0.5d0*tr1
          ti2 = xi(ivk,p,1) - 0.5d0*ti1
          tr3 = -sp3*(xi(ivk,p,2) - xi(ivk,p,3))
          ti3 = sp3*(xr(ivk,p,2) - xr(ivk,p,3))
          yr(ivk,1,p) = xr(ivk,p,1) + tr1
          yi(ivk,1,p) = xi(ivk,p,1) + ti1
          tr = tr2 + tr3
          ti = ti2 + ti3
          yr(ivk,2,p) = wr1*tr + wi1*ti
          yi(ivk,2,p) = wr1*ti - wi1*tr
          tr = tr2 - tr3
          ti = ti2 - ti3
          yr(ivk,3,p) = wr2*tr + wi2*ti
          yi(ivk,3,p) = wr2*ti - wi2*tr
       end do
    end do
    return
  end subroutine bftrd3
  !
  subroutine fftrd4(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,4),xi(nvk,np,4)
    real(kind=8),intent(out):: yr(nvk,4,np),yi(nvk,4,np)
    real(kind=8),intent(in):: w(2,3*np)
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr4,ti4,tr,ti
    integer:: p,ivk,iw
    !
    iw = 1
    do p = 1,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,1) + xr(ivk,p,3)
          ti1 = xi(ivk,p,1) + xi(ivk,p,3)
          tr2 = xr(ivk,p,1) - xr(ivk,p,3)
          ti2 = xi(ivk,p,1) - xi(ivk,p,3)
          tr3 = xr(ivk,p,2) + xr(ivk,p,4)
          ti3 = xi(ivk,p,2) + xi(ivk,p,4)
          tr4 = xi(ivk,p,2) - xi(ivk,p,4)
          ti4 = xr(ivk,p,4) - xr(ivk,p,2)
          yr(ivk,1,p) = tr1 + tr3
          yi(ivk,1,p) = ti1 + ti3
          tr = tr2 + tr4
          ti = ti2 + ti4
          yr(ivk,2,p) = wr1*tr - wi1*ti
          yi(ivk,2,p) = wr1*ti + wi1*tr
          tr = tr1 - tr3
          ti = ti1 - ti3
          yr(ivk,3,p) = wr2*tr - wi2*ti
          yi(ivk,3,p) = wr2*ti + wi2*tr
          tr = tr2 - tr4
          ti = ti2 - ti4
          yr(ivk,4,p) = wr3*tr - wi3*ti
          yi(ivk,4,p) = wr3*ti + wi3*tr
       end do
    end do
    return
  end subroutine fftrd4
  !
  subroutine bftrd4(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,4),xi(nvk,np,4)
    real(kind=8),intent(out):: yr(nvk,4,np),yi(nvk,4,np)
    real(kind=8),intent(in):: w(2,3*np)
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr4,ti4,tr,ti
    integer:: p,ivk,iw
    !
    iw = 1
    do p = 1,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,1) + xr(ivk,p,3)
          ti1 = xi(ivk,p,1) + xi(ivk,p,3)
          tr2 = xr(ivk,p,1) - xr(ivk,p,3)
          ti2 = xi(ivk,p,1) - xi(ivk,p,3)
          tr3 = xr(ivk,p,2) + xr(ivk,p,4)
          ti3 = xi(ivk,p,2) + xi(ivk,p,4)
          tr4 = xi(ivk,p,4) - xi(ivk,p,2)
          ti4 = xr(ivk,p,2) - xr(ivk,p,4)
          yr(ivk,1,p) = tr1 + tr3
          yi(ivk,1,p) = ti1 + ti3
          tr = tr2 + tr4
          ti = ti2 + ti4
          yr(ivk,2,p) = wr1*tr + wi1*ti
          yi(ivk,2,p) = wr1*ti - wi1*tr
          tr = tr1 - tr3
          ti = ti1 - ti3
          yr(ivk,3,p) = wr2*tr + wi2*ti
          yi(ivk,3,p) = wr2*ti - wi2*tr
          tr = tr2 - tr4
          ti = ti2 - ti4
          yr(ivk,4,p) = wr3*tr + wi3*ti
          yi(ivk,4,p) = wr3*ti - wi3*tr
       end do
    end do
    return
  end subroutine bftrd4
  !
  subroutine fftrd5(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,5),xi(nvk,np,5)
    real(kind=8),intent(out):: yr(nvk,5,np),yi(nvk,5,np)
    real(kind=8),intent(in):: w(2,4*np)
    !
    real(kind=8),parameter:: sp25 = 0.951056516295153572d0
    real(kind=8),parameter:: sq54 = 0.559016994374947424d0
    real(kind=8),parameter:: ss = 0.618033988749894848d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3,wr4,wi4
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr4,ti4,tr5,ti5
    real(kind=8):: tr6,ti6,tr7,ti7,tr8,ti8,tr9,ti9,tr10,ti10,tr11,ti11
    real(kind=8):: tr,ti
    integer:: p,ivk,iw
    !
    do ivk = 1,nvk
       tr1 = xr(ivk,1,2) + xr(ivk,1,5)
       ti1 = xi(ivk,1,2) + xi(ivk,1,5)
       tr2 = xr(ivk,1,3) + xr(ivk,1,4)
       ti2 = xi(ivk,1,3) + xi(ivk,1,4)
       tr3 = sp25*(xr(ivk,1,2) - xr(ivk,1,5))
       ti3 = sp25*(xi(ivk,1,2) - xi(ivk,1,5))
       tr4 = sp25*(xr(ivk,1,3) - xr(ivk,1,4))
       ti4 = sp25*(xi(ivk,1,3) - xi(ivk,1,4))
       tr5 = tr1 + tr2
       ti5 = ti1 + ti2
       tr6 = sq54*(tr1 - tr2)
       ti6 = sq54*(ti1 - ti2)
       tr7 = xr(ivk,1,1) - 0.25d0*tr5
       ti7 = xi(ivk,1,1) - 0.25d0*ti5
       tr8 = tr7 + tr6
       ti8 = ti7 + ti6
       tr9 = tr7 - tr6
       ti9 = ti7 - ti6
       tr10 = ti3 + ss*ti4
       ti10 = - tr3 - ss*tr4
       tr11 = ss*ti3 - ti4
       ti11 = - ss*tr3 + tr4
       yr(ivk,1,1) = xr(ivk,1,1) + tr5
       yi(ivk,1,1) = xi(ivk,1,1) + ti5
       yr(ivk,2,1) = tr8 + tr10
       yi(ivk,2,1) = ti8 + ti10
       yr(ivk,3,1) = tr9 + tr11
       yi(ivk,3,1) = ti9 + ti11
       yr(ivk,4,1) = tr9 - tr11
       yi(ivk,4,1) = ti9 - ti11
       yr(ivk,5,1) = tr8 - tr10
       yi(ivk,5,1) = ti8 - ti10
    end do

    iw = 5
    do p = 2,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       wr4 = w(1,iw)
       wi4 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,2) + xr(ivk,p,5)
          ti1 = xi(ivk,p,2) + xi(ivk,p,5)
          tr2 = xr(ivk,p,3) + xr(ivk,p,4)
          ti2 = xi(ivk,p,3) + xi(ivk,p,4)
          tr3 = sp25*(xr(ivk,p,2) - xr(ivk,p,5))
          ti3 = sp25*(xi(ivk,p,2) - xi(ivk,p,5))
          tr4 = sp25*(xr(ivk,p,3) - xr(ivk,p,4))
          ti4 = sp25*(xi(ivk,p,3) - xi(ivk,p,4))
          tr5 = tr1 + tr2
          ti5 = ti1 + ti2
          tr6 = sq54*(tr1 - tr2)
          ti6 = sq54*(ti1 - ti2)
          tr7 = xr(ivk,p,1) - 0.25d0*tr5
          ti7 = xi(ivk,p,1) - 0.25d0*ti5
          tr8 = tr7 + tr6
          ti8 = ti7 + ti6
          tr9 = tr7 - tr6
          ti9 = ti7 - ti6
          tr10 = ti3 + ss*ti4
          ti10 = - tr3 - ss*tr4
          tr11 = ss*ti3 - ti4
          ti11 = - ss*tr3 + tr4
          yr(ivk,1,p) = xr(ivk,p,1) + tr5
          yi(ivk,1,p) = xi(ivk,p,1) + ti5
          tr = tr8 + tr10
          ti = ti8 + ti10
          yr(ivk,2,p) = wr1*tr - wi1*ti
          yi(ivk,2,p) = wr1*ti + wi1*tr
          tr = tr9 + tr11
          ti = ti9 + ti11
          yr(ivk,3,p) = wr2*tr - wi2*ti
          yi(ivk,3,p) = wr2*ti + wi2*tr
          tr = tr9 - tr11
          ti = ti9 - ti11
          yr(ivk,4,p) = wr3*tr - wi3*ti
          yi(ivk,4,p) = wr3*ti + wi3*tr
          tr = tr8 - tr10
          ti = ti8 - ti10
          yr(ivk,5,p) = wr4*tr - wi4*ti
          yi(ivk,5,p) = wr4*ti + wi4*tr
       end do
    end do
    return
  end subroutine fftrd5
  !
  subroutine bftrd5(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,5),xi(nvk,np,5)
    real(kind=8),intent(out):: yr(nvk,5,np),yi(nvk,5,np)
    real(kind=8),intent(in):: w(2,4*np)
    !
    real(kind=8),parameter:: sp25 = 0.951056516295153572d0
    real(kind=8),parameter:: sq54 = 0.559016994374947424d0
    real(kind=8),parameter:: ss = 0.618033988749894848d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3,wr4,wi4
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr4,ti4,tr5,ti5
    real(kind=8):: tr6,ti6,tr7,ti7,tr8,ti8,tr9,ti9,tr10,ti10,tr11,ti11
    real(kind=8):: tr,ti
    integer:: p,ivk,iw
    !
    do ivk = 1,nvk
       tr1 = xr(ivk,1,2) + xr(ivk,1,5)
       ti1 = xi(ivk,1,2) + xi(ivk,1,5)
       tr2 = xr(ivk,1,3) + xr(ivk,1,4)
       ti2 = xi(ivk,1,3) + xi(ivk,1,4)
       tr3 = sp25*(xr(ivk,1,2) - xr(ivk,1,5))
       ti3 = sp25*(xi(ivk,1,2) - xi(ivk,1,5))
       tr4 = sp25*(xr(ivk,1,3) - xr(ivk,1,4))
       ti4 = sp25*(xi(ivk,1,3) - xi(ivk,1,4))
       tr5 = tr1 + tr2
       ti5 = ti1 + ti2
       tr6 = sq54*(tr1 - tr2)
       ti6 = sq54*(ti1 - ti2)
       tr7 = xr(ivk,1,1) - 0.25d0*tr5
       ti7 = xi(ivk,1,1) - 0.25d0*ti5
       tr8 = tr7 + tr6
       ti8 = ti7 + ti6
       tr9 = tr7 - tr6
       ti9 = ti7 - ti6
       tr10 = - ti3 - ss*ti4
       ti10 = tr3 + ss*tr4
       tr11 = - ss*ti3 + ti4
       ti11 = ss*tr3 - tr4
       yr(ivk,1,1) = xr(ivk,1,1) + tr5
       yi(ivk,1,1) = xi(ivk,1,1) + ti5
       yr(ivk,2,1) = tr8 + tr10
       yi(ivk,2,1) = ti8 + ti10
       yr(ivk,3,1) = tr9 + tr11
       yi(ivk,3,1) = ti9 + ti11
       yr(ivk,4,1) = tr9 - tr11
       yi(ivk,4,1) = ti9 - ti11
       yr(ivk,5,1) = tr8 - tr10
       yi(ivk,5,1) = ti8 - ti10
    end do

    iw = 5
    do p = 2,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       wr4 = w(1,iw)
       wi4 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,2) + xr(ivk,p,5)
          ti1 = xi(ivk,p,2) + xi(ivk,p,5)
          tr2 = xr(ivk,p,3) + xr(ivk,p,4)
          ti2 = xi(ivk,p,3) + xi(ivk,p,4)
          tr3 = sp25*(xr(ivk,p,2) - xr(ivk,p,5))
          ti3 = sp25*(xi(ivk,p,2) - xi(ivk,p,5))
          tr4 = sp25*(xr(ivk,p,3) - xr(ivk,p,4))
          ti4 = sp25*(xi(ivk,p,3) - xi(ivk,p,4))
          tr5 = tr1 + tr2
          ti5 = ti1 + ti2
          tr6 = sq54*(tr1 - tr2)
          ti6 = sq54*(ti1 - ti2)
          tr7 = xr(ivk,p,1) - 0.25d0*tr5
          ti7 = xi(ivk,p,1) - 0.25d0*ti5
          tr8 = tr7 + tr6
          ti8 = ti7 + ti6
          tr9 = tr7 - tr6
          ti9 = ti7 - ti6
          tr10 = - ti3 - ss*ti4
          ti10 = tr3 + ss*tr4
          tr11 = - ss*ti3 + ti4
          ti11 = ss*tr3 - tr4
          yr(ivk,1,p) = xr(ivk,p,1) + tr5
          yi(ivk,1,p) = xi(ivk,p,1) + ti5
          tr = tr8 + tr10
          ti = ti8 + ti10
          yr(ivk,2,p) = wr1*tr + wi1*ti
          yi(ivk,2,p) = wr1*ti - wi1*tr
          tr = tr9 + tr11
          ti = ti9 + ti11
          yr(ivk,3,p) = wr2*tr + wi2*ti
          yi(ivk,3,p) = wr2*ti - wi2*tr
          tr = tr9 - tr11
          ti = ti9 - ti11
          yr(ivk,4,p) = wr3*tr + wi3*ti
          yi(ivk,4,p) = wr3*ti - wi3*tr
          tr = tr8 - tr10
          ti = ti8 - ti10
          yr(ivk,5,p) = wr4*tr + wi4*ti
          yi(ivk,5,p) = wr4*ti - wi4*tr
       end do
    end do
    return
  end subroutine bftrd5

  subroutine fftrd6(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,6),xi(nvk,np,6)
    real(kind=8),intent(out):: yr(nvk,6,np),yi(nvk,6,np)
    real(kind=8),intent(in):: w(2,5*np)
    !
    real(kind=8),parameter:: sp3 = 0.866025403784438647d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3,wr4,wi4,wr5,wi5
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr,ti
    real(kind=8):: ur1,ui1,ur2,ui2,ur3,ui3
    real(kind=8):: vr1,vi1,vr2,vi2,vr3,vi3
    integer:: p,ivk,iw
    !
    do ivk = 1,nvk
       tr1 = xr(ivk,1,3) + xr(ivk,1,5)
       ti1 = xi(ivk,1,3) + xi(ivk,1,5)
       tr2 = xr(ivk,1,1) - 0.5d0*tr1
       ti2 = xi(ivk,1,1) - 0.5d0*ti1
       tr3 = -sp3*(xr(ivk,1,3) - xr(ivk,1,5))
       ti3 = -sp3*(xi(ivk,1,3) - xi(ivk,1,5))
       ur1 = xr(ivk,1,1) + tr1
       ui1 = xi(ivk,1,1) + ti1
       ur2 = tr2 - ti3
       ui2 = ti2 + tr3
       ur3 = tr2 + ti3
       ui3 = ti2 - tr3

       tr1 = xr(ivk,1,6) + xr(ivk,1,2)
       ti1 = xi(ivk,1,6) + xi(ivk,1,2)
       tr2 = xr(ivk,1,4) - 0.5d0*tr1
       ti2 = xi(ivk,1,4) - 0.5d0*ti1
       tr3 = -sp3*(xr(ivk,1,6) - xr(ivk,1,2))
       ti3 = -sp3*(xi(ivk,1,6) - xi(ivk,1,2))
       vr1 = xr(ivk,1,4) + tr1
       vi1 = xi(ivk,1,4) + ti1
       vr2 = tr2 - ti3
       vi2 = ti2 + tr3
       vr3 = tr2 + ti3
       vi3 = ti2 - tr3

       yr(ivk,1,1) = ur1 + vr1
       yi(ivk,1,1) = ui1 + vi1
       yr(ivk,5,1) = ur2 + vr2
       yi(ivk,5,1) = ui2 + vi2
       yr(ivk,3,1) = ur3 + vr3
       yi(ivk,3,1) = ui3 + vi3
       yr(ivk,4,1) = ur1 - vr1
       yi(ivk,4,1) = ui1 - vi1
       yr(ivk,2,1) = ur2 - vr2
       yi(ivk,2,1) = ui2 - vi2
       yr(ivk,6,1) = ur3 - vr3
       yi(ivk,6,1) = ui3 - vi3
    end do

    iw = 6
    do p = 2,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       wr4 = w(1,iw)
       wi4 = w(2,iw)
       iw = iw+1
       wr5 = w(1,iw)
       wi5 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,3) + xr(ivk,p,5)
          ti1 = xi(ivk,p,3) + xi(ivk,p,5)
          tr2 = xr(ivk,p,1) - 0.5d0*tr1
          ti2 = xi(ivk,p,1) - 0.5d0*ti1
          tr3 = -sp3*(xr(ivk,p,3) - xr(ivk,p,5))
          ti3 = -sp3*(xi(ivk,p,3) - xi(ivk,p,5))
          ur1 = xr(ivk,p,1) + tr1
          ui1 = xi(ivk,p,1) + ti1
          ur2 = tr2 - ti3
          ui2 = ti2 + tr3
          ur3 = tr2 + ti3
          ui3 = ti2 - tr3

          tr1 = xr(ivk,p,6) + xr(ivk,p,2)
          ti1 = xi(ivk,p,6) + xi(ivk,p,2)
          tr2 = xr(ivk,p,4) - 0.5d0*tr1
          ti2 = xi(ivk,p,4) - 0.5d0*ti1
          tr3 = -sp3*(xr(ivk,p,6) - xr(ivk,p,2))
          ti3 = -sp3*(xi(ivk,p,6) - xi(ivk,p,2))
          vr1 = xr(ivk,p,4) + tr1
          vi1 = xi(ivk,p,4) + ti1
          vr2 = tr2 - ti3
          vi2 = ti2 + tr3
          vr3 = tr2 + ti3
          vi3 = ti2 - tr3

          yr(ivk,1,p) = ur1 + vr1
          yi(ivk,1,p) = ui1 + vi1
          tr = ur2 + vr2
          ti = ui2 + vi2
          yr(ivk,5,p) = wr4*tr - wi4*ti
          yi(ivk,5,p) = wr4*ti + wi4*tr
          tr = ur3 + vr3
          ti = ui3 + vi3
          yr(ivk,3,p) = wr2*tr - wi2*ti
          yi(ivk,3,p) = wr2*ti + wi2*tr
          tr = ur1 - vr1
          ti = ui1 - vi1
          yr(ivk,4,p) = wr3*tr - wi3*ti
          yi(ivk,4,p) = wr3*ti + wi3*tr
          tr = ur2 - vr2
          ti = ui2 - vi2
          yr(ivk,2,p) = wr1*tr - wi1*ti
          yi(ivk,2,p) = wr1*ti + wi1*tr
          tr = ur3 - vr3
          ti = ui3 - vi3
          yr(ivk,6,p) = wr5*tr - wi5*ti
          yi(ivk,6,p) = wr5*ti + wi5*tr
       end do
    end do
    return
  end subroutine fftrd6

  subroutine bftrd6(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,6),xi(nvk,np,6)
    real(kind=8),intent(out):: yr(nvk,6,np),yi(nvk,6,np)
    real(kind=8),intent(in):: w(2,5*np)
    !
    real(kind=8),parameter:: sp3 = 0.866025403784438647d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3,wr4,wi4,wr5,wi5
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr,ti
    real(kind=8):: ur1,ui1,ur2,ui2,ur3,ui3
    real(kind=8):: vr1,vi1,vr2,vi2,vr3,vi3
    integer:: p,ivk,iw
    !
    do ivk = 1,nvk
       tr1 = xr(ivk,1,3) + xr(ivk,1,5)
       ti1 = xi(ivk,1,3) + xi(ivk,1,5)
       tr2 = xr(ivk,1,1) - 0.5d0*tr1
       ti2 = xi(ivk,1,1) - 0.5d0*ti1
       tr3 = sp3*(xr(ivk,1,3) - xr(ivk,1,5))
       ti3 = sp3*(xi(ivk,1,3) - xi(ivk,1,5))
       ur1 = xr(ivk,1,1) + tr1
       ui1 = xi(ivk,1,1) + ti1
       ur2 = tr2 - ti3
       ui2 = ti2 + tr3
       ur3 = tr2 + ti3
       ui3 = ti2 - tr3

       tr1 = xr(ivk,1,6) + xr(ivk,1,2)
       ti1 = xi(ivk,1,6) + xi(ivk,1,2)
       tr2 = xr(ivk,1,4) - 0.5d0*tr1
       ti2 = xi(ivk,1,4) - 0.5d0*ti1
       tr3 = sp3*(xr(ivk,1,6) - xr(ivk,1,2))
       ti3 = sp3*(xi(ivk,1,6) - xi(ivk,1,2))
       vr1 = xr(ivk,1,4) + tr1
       vi1 = xi(ivk,1,4) + ti1
       vr2 = tr2 - ti3
       vi2 = ti2 + tr3
       vr3 = tr2 + ti3
       vi3 = ti2 - tr3

       yr(ivk,1,1) = ur1 + vr1
       yi(ivk,1,1) = ui1 + vi1
       yr(ivk,5,1) = ur2 + vr2
       yi(ivk,5,1) = ui2 + vi2
       yr(ivk,3,1) = ur3 + vr3
       yi(ivk,3,1) = ui3 + vi3
       yr(ivk,4,1) = ur1 - vr1
       yi(ivk,4,1) = ui1 - vi1
       yr(ivk,2,1) = ur2 - vr2
       yi(ivk,2,1) = ui2 - vi2
       yr(ivk,6,1) = ur3 - vr3
       yi(ivk,6,1) = ui3 - vi3
    end do

!   write(6,*) '20150826 np=',np 
    iw = 6
    do p = 2,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       wr4 = w(1,iw)
       wi4 = w(2,iw)
       iw = iw+1
       wr5 = w(1,iw)
       wi5 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,3) + xr(ivk,p,5)
          ti1 = xi(ivk,p,3) + xi(ivk,p,5)
          tr2 = xr(ivk,p,1) - 0.5d0*tr1
          ti2 = xi(ivk,p,1) - 0.5d0*ti1
          tr3 = sp3*(xr(ivk,p,3) - xr(ivk,p,5))
          ti3 = sp3*(xi(ivk,p,3) - xi(ivk,p,5))
          ur1 = xr(ivk,p,1) + tr1
          ui1 = xi(ivk,p,1) + ti1
          ur2 = tr2 - ti3
          ui2 = ti2 + tr3
          ur3 = tr2 + ti3
          ui3 = ti2 - tr3

          tr1 = xr(ivk,p,6) + xr(ivk,p,2)
          ti1 = xi(ivk,p,6) + xi(ivk,p,2)
          tr2 = xr(ivk,p,4) - 0.5d0*tr1
          ti2 = xi(ivk,p,4) - 0.5d0*ti1
          tr3 = sp3*(xr(ivk,p,6) - xr(ivk,p,2))
          ti3 = sp3*(xi(ivk,p,6) - xi(ivk,p,2))
          vr1 = xr(ivk,p,4) + tr1
          vi1 = xi(ivk,p,4) + ti1
          vr2 = tr2 - ti3
          vi2 = ti2 + tr3
          vr3 = tr2 + ti3
          vi3 = ti2 - tr3

          yr(ivk,1,p) = ur1 + vr1
          yi(ivk,1,p) = ui1 + vi1
          tr = ur2 + vr2
          ti = ui2 + vi2
          yr(ivk,5,p) = wr4*tr + wi4*ti
          yi(ivk,5,p) = wr4*ti - wi4*tr
          tr = ur3 + vr3
          ti = ui3 + vi3
          yr(ivk,3,p) = wr2*tr + wi2*ti
          yi(ivk,3,p) = wr2*ti - wi2*tr
          tr = ur1 - vr1
          ti = ui1 - vi1
          yr(ivk,4,p) = wr3*tr + wi3*ti
          yi(ivk,4,p) = wr3*ti - wi3*tr
          tr = ur2 - vr2
          ti = ui2 - vi2
          yr(ivk,2,p) = wr1*tr + wi1*ti
          yi(ivk,2,p) = wr1*ti - wi1*tr
          tr = ur3 - vr3
          ti = ui3 - vi3
          yr(ivk,6,p) = wr5*tr + wi5*ti
          yi(ivk,6,p) = wr5*ti - wi5*tr
       end do
    end do
    return
  end subroutine bftrd6
  !
  subroutine fftrd8(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,8),xi(nvk,np,8)
    real(kind=8),intent(out):: yr(nvk,8,np),yi(nvk,8,np)
    real(kind=8),intent(in):: w(2,7*np)
    !
    real(kind=8),parameter:: sp2 = 0.70710678118654752440d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3,wr4,wi4,wr5,wi5,wr6,wi6,wr7,wi7
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr4,ti4,tr,ti,sr,si
    real(kind=8):: ur1,ui1,ur2,ui2,ur3,ui3,ur4,ui4
    real(kind=8):: vr1,vi1,vr2,vi2,vr3,vi3,vr4,vi4
    integer:: p,ivk,iw
    !
    do ivk = 1,nvk
       tr1 = xr(ivk,1,1) + xr(ivk,1,5)
       ti1 = xi(ivk,1,1) + xi(ivk,1,5)
       tr2 = xr(ivk,1,1) - xr(ivk,1,5)
       ti2 = xi(ivk,1,1) - xi(ivk,1,5)
       tr3 = xr(ivk,1,3) + xr(ivk,1,7)
       ti3 = xi(ivk,1,3) + xi(ivk,1,7)
       tr4 = xi(ivk,1,3) - xi(ivk,1,7)
       ti4 = xr(ivk,1,7) - xr(ivk,1,3)
       ur1 = tr1 + tr3
       ui1 = ti1 + ti3
       ur2 = tr2 + tr4
       ui2 = ti2 + ti4
       ur3 = tr1 - tr3
       ui3 = ti1 - ti3
       ur4 = tr2 - tr4
       ui4 = ti2 - ti4
       tr1 = xr(ivk,1,2) + xr(ivk,1,6)
       ti1 = xi(ivk,1,2) + xi(ivk,1,6)
       tr2 = xr(ivk,1,2) - xr(ivk,1,6)
       ti2 = xi(ivk,1,2) - xi(ivk,1,6)
       tr3 = xr(ivk,1,4) + xr(ivk,1,8)
       ti3 = xi(ivk,1,4) + xi(ivk,1,8)
       tr4 = xi(ivk,1,4) - xi(ivk,1,8)
       ti4 = xr(ivk,1,8) - xr(ivk,1,4)
       vr1 = tr1 + tr3
       vi1 = ti1 + ti3
       vr2 = tr2 + tr4
       vi2 = ti2 + ti4
       vr3 = tr1 - tr3
       vi3 = ti1 - ti3
       vr4 = tr2 - tr4
       vi4 = ti2 - ti4
       yr(ivk,1,1) = ur1 + vr1
       yi(ivk,1,1) = ui1 + vi1
       yr(ivk,5,1) = ur1 - vr1
       yi(ivk,5,1) = ui1 - vi1

       sr = sp2*(vr2 + vi2)
       si = sp2*(vi2 - vr2)
       yr(ivk,2,1) = ur2 + sr
       yi(ivk,2,1) = ui2 + si
       yr(ivk,6,1) = ur2 - sr
       yi(ivk,6,1) = ui2 - si

       yr(ivk,3,1) = ur3 + vi3
       yi(ivk,3,1) = ui3 - vr3
       yr(ivk,7,1) = ur3 - vi3
       yi(ivk,7,1) = ui3 + vr3

       sr = sp2*(vi4 - vr4)
       si = -sp2*(vr4 + vi4)
       yr(ivk,4,1) = ur4 + sr
       yi(ivk,4,1) = ui4 + si
       yr(ivk,8,1) = ur4 - sr
       yi(ivk,8,1) = ui4 - si
    end do

    iw = 8
    do p = 2,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       wr4 = w(1,iw)
       wi4 = w(2,iw)
       iw = iw+1
       wr5 = w(1,iw)
       wi5 = w(2,iw)
       iw = iw+1
       wr6 = w(1,iw)
       wi6 = w(2,iw)
       iw = iw+1
       wr7 = w(1,iw)
       wi7 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,1) + xr(ivk,p,5)
          ti1 = xi(ivk,p,1) + xi(ivk,p,5)
          tr2 = xr(ivk,p,1) - xr(ivk,p,5)
          ti2 = xi(ivk,p,1) - xi(ivk,p,5)
          tr3 = xr(ivk,p,3) + xr(ivk,p,7)
          ti3 = xi(ivk,p,3) + xi(ivk,p,7)
          tr4 = xi(ivk,p,3) - xi(ivk,p,7)
          ti4 = xr(ivk,p,7) - xr(ivk,p,3)
          ur1 = tr1 + tr3
          ui1 = ti1 + ti3
          ur2 = tr2 + tr4
          ui2 = ti2 + ti4
          ur3 = tr1 - tr3
          ui3 = ti1 - ti3
          ur4 = tr2 - tr4
          ui4 = ti2 - ti4
          tr1 = xr(ivk,p,2) + xr(ivk,p,6)
          ti1 = xi(ivk,p,2) + xi(ivk,p,6)
          tr2 = xr(ivk,p,2) - xr(ivk,p,6)
          ti2 = xi(ivk,p,2) - xi(ivk,p,6)
          tr3 = xr(ivk,p,4) + xr(ivk,p,8)
          ti3 = xi(ivk,p,4) + xi(ivk,p,8)
          tr4 = xi(ivk,p,4) - xi(ivk,p,8)
          ti4 = xr(ivk,p,8) - xr(ivk,p,4)
          vr1 = tr1 + tr3
          vi1 = ti1 + ti3
          vr2 = tr2 + tr4
          vi2 = ti2 + ti4
          vr3 = tr1 - tr3
          vi3 = ti1 - ti3
          vr4 = tr2 - tr4
          vi4 = ti2 - ti4
          yr(ivk,1,p) = ur1 + vr1
          yi(ivk,1,p) = ui1 + vi1
          tr = ur1 - vr1
          ti = ui1 - vi1
          yr(ivk,5,p) = wr4*tr - wi4*ti
          yi(ivk,5,p) = wr4*ti + wi4*tr

          sr = sp2*(vr2 + vi2)
          si = sp2*(vi2 - vr2)
          tr = ur2 + sr
          ti = ui2 + si
          yr(ivk,2,p) = wr1*tr - wi1*ti
          yi(ivk,2,p) = wr1*ti + wi1*tr
          tr = ur2 - sr
          ti = ui2 - si
          yr(ivk,6,p) = wr5*tr - wi5*ti
          yi(ivk,6,p) = wr5*ti + wi5*tr

          tr = ur3 + vi3
          ti = ui3 - vr3
          yr(ivk,3,p) = wr2*tr - wi2*ti
          yi(ivk,3,p) = wr2*ti + wi2*tr
          tr = ur3 - vi3
          ti = ui3 + vr3
          yr(ivk,7,p) = wr6*tr - wi6*ti
          yi(ivk,7,p) = wr6*ti + wi6*tr

          sr = sp2*(vi4 - vr4)
          si = -sp2*(vr4 + vi4)
          tr = ur4 + sr
          ti = ui4 + si
          yr(ivk,4,p) = wr3*tr - wi3*ti
          yi(ivk,4,p) = wr3*ti + wi3*tr
          tr = ur4 - sr
          ti = ui4 - si
          yr(ivk,8,p) = wr7*tr - wi7*ti
          yi(ivk,8,p) = wr7*ti + wi7*tr
       end do
    end do
    return
  end subroutine fftrd8
  !
  subroutine bftrd8(nvk,np,w,xr,xi,yr,yi)
    implicit none
    integer,intent(in):: nvk,np
    real(kind=8),intent(in):: xr(nvk,np,8),xi(nvk,np,8)
    real(kind=8),intent(out):: yr(nvk,8,np),yi(nvk,8,np)
    real(kind=8),intent(in):: w(2,7*np)
    !
    real(kind=8),parameter:: sp2 = 0.70710678118654752440d0
    !
    real(kind=8):: wr1,wi1,wr2,wi2,wr3,wi3,wr4,wi4,wr5,wi5,wr6,wi6,wr7,wi7
    real(kind=8):: tr1,ti1,tr2,ti2,tr3,ti3,tr4,ti4,tr,ti,sr,si
    real(kind=8):: ur1,ui1,ur2,ui2,ur3,ui3,ur4,ui4
    real(kind=8):: vr1,vi1,vr2,vi2,vr3,vi3,vr4,vi4
    integer:: p,ivk,iw
    !
    do ivk = 1,nvk
       tr1 = xr(ivk,1,1) + xr(ivk,1,5)
       ti1 = xi(ivk,1,1) + xi(ivk,1,5)
       tr2 = xr(ivk,1,1) - xr(ivk,1,5)
       ti2 = xi(ivk,1,1) - xi(ivk,1,5)
       tr3 = xr(ivk,1,3) + xr(ivk,1,7)
       ti3 = xi(ivk,1,3) + xi(ivk,1,7)
       tr4 = xi(ivk,1,7) - xi(ivk,1,3)
       ti4 = xr(ivk,1,3) - xr(ivk,1,7)
       ur1 = tr1 + tr3
       ui1 = ti1 + ti3
       ur2 = tr2 + tr4
       ui2 = ti2 + ti4
       ur3 = tr1 - tr3
       ui3 = ti1 - ti3
       ur4 = tr2 - tr4
       ui4 = ti2 - ti4
       tr1 = xr(ivk,1,2) + xr(ivk,1,6)
       ti1 = xi(ivk,1,2) + xi(ivk,1,6)
       tr2 = xr(ivk,1,2) - xr(ivk,1,6)
       ti2 = xi(ivk,1,2) - xi(ivk,1,6)
       tr3 = xr(ivk,1,4) + xr(ivk,1,8)
       ti3 = xi(ivk,1,4) + xi(ivk,1,8)
       tr4 = xi(ivk,1,8) - xi(ivk,1,4)
       ti4 = xr(ivk,1,4) - xr(ivk,1,8)
       vr1 = tr1 + tr3
       vi1 = ti1 + ti3
       vr2 = tr2 + tr4
       vi2 = ti2 + ti4
       vr3 = tr1 - tr3
       vi3 = ti1 - ti3
       vr4 = tr2 - tr4
       vi4 = ti2 - ti4
       yr(ivk,1,1) = ur1 + vr1
       yi(ivk,1,1) = ui1 + vi1
       yr(ivk,5,1) = ur1 - vr1
       yi(ivk,5,1) = ui1 - vi1

       sr = sp2*(vr2 - vi2)
       si = sp2*(vi2 + vr2)
       yr(ivk,2,1) = ur2 + sr
       yi(ivk,2,1) = ui2 + si
       yr(ivk,6,1) = ur2 - sr
       yi(ivk,6,1) = ui2 - si

       yr(ivk,3,1) = ur3 - vi3
       yi(ivk,3,1) = ui3 + vr3
       yr(ivk,7,1) = ur3 + vi3
       yi(ivk,7,1) = ui3 - vr3

       sr = -sp2*(vr4 + vi4)
       si = sp2*(vr4 - vi4)
       yr(ivk,4,1) = ur4 + sr
       yi(ivk,4,1) = ui4 + si
       yr(ivk,8,1) = ur4 - sr
       yi(ivk,8,1) = ui4 - si
    end do

    iw = 8
    do p = 2,np
       wr1 = w(1,iw)
       wi1 = w(2,iw)
       iw = iw+1
       wr2 = w(1,iw)
       wi2 = w(2,iw)
       iw = iw+1
       wr3 = w(1,iw)
       wi3 = w(2,iw)
       iw = iw+1
       wr4 = w(1,iw)
       wi4 = w(2,iw)
       iw = iw+1
       wr5 = w(1,iw)
       wi5 = w(2,iw)
       iw = iw+1
       wr6 = w(1,iw)
       wi6 = w(2,iw)
       iw = iw+1
       wr7 = w(1,iw)
       wi7 = w(2,iw)
       iw = iw+1
       do ivk = 1,nvk
          tr1 = xr(ivk,p,1) + xr(ivk,p,5)
          ti1 = xi(ivk,p,1) + xi(ivk,p,5)
          tr2 = xr(ivk,p,1) - xr(ivk,p,5)
          ti2 = xi(ivk,p,1) - xi(ivk,p,5)
          tr3 = xr(ivk,p,3) + xr(ivk,p,7)
          ti3 = xi(ivk,p,3) + xi(ivk,p,7)
          tr4 = xi(ivk,p,7) - xi(ivk,p,3)
          ti4 = xr(ivk,p,3) - xr(ivk,p,7)
          ur1 = tr1 + tr3
          ui1 = ti1 + ti3
          ur2 = tr2 + tr4
          ui2 = ti2 + ti4
          ur3 = tr1 - tr3
          ui3 = ti1 - ti3
          ur4 = tr2 - tr4
          ui4 = ti2 - ti4
          tr1 = xr(ivk,p,2) + xr(ivk,p,6)
          ti1 = xi(ivk,p,2) + xi(ivk,p,6)
          tr2 = xr(ivk,p,2) - xr(ivk,p,6)
          ti2 = xi(ivk,p,2) - xi(ivk,p,6)
          tr3 = xr(ivk,p,4) + xr(ivk,p,8)
          ti3 = xi(ivk,p,4) + xi(ivk,p,8)
          tr4 = xi(ivk,p,8) - xi(ivk,p,4)
          ti4 = xr(ivk,p,4) - xr(ivk,p,8)
          vr1 = tr1 + tr3
          vi1 = ti1 + ti3
          vr2 = tr2 + tr4
          vi2 = ti2 + ti4
          vr3 = tr1 - tr3
          vi3 = ti1 - ti3
          vr4 = tr2 - tr4
          vi4 = ti2 - ti4
          yr(ivk,1,p) = ur1 + vr1
          yi(ivk,1,p) = ui1 + vi1
          tr = ur1 - vr1
          ti = ui1 - vi1
          yr(ivk,5,p) = wr4*tr + wi4*ti
          yi(ivk,5,p) = wr4*ti - wi4*tr

          sr = sp2*(vr2 - vi2)
          si = sp2*(vi2 + vr2)
          tr = ur2 + sr
          ti = ui2 + si
          yr(ivk,2,p) = wr1*tr + wi1*ti
          yi(ivk,2,p) = wr1*ti - wi1*tr
          tr = ur2 - sr
          ti = ui2 - si
          yr(ivk,6,p) = wr5*tr + wi5*ti
          yi(ivk,6,p) = wr5*ti - wi5*tr

          tr = ur3 - vi3
          ti = ui3 + vr3
          yr(ivk,3,p) = wr2*tr + wi2*ti
          yi(ivk,3,p) = wr2*ti - wi2*tr
          tr = ur3 + vi3
          ti = ui3 - vr3
          yr(ivk,7,p) = wr6*tr + wi6*ti
          yi(ivk,7,p) = wr6*ti - wi6*tr

          sr = -sp2*(vr4 + vi4)
          si = sp2*(vr4 - vi4)
          tr = ur4 + sr
          ti = ui4 + si
          yr(ivk,4,p) = wr3*tr + wi3*ti
          yi(ivk,4,p) = wr3*ti - wi3*tr
          tr = ur4 - sr
          ti = ui4 - si
          yr(ivk,8,p) = wr7*tr + wi7*ti
          yi(ivk,8,p) = wr7*ti - wi7*tr
       end do
    end do
    return
  end subroutine bftrd8
  !
  subroutine fftv(nv,n,nf,fac,w,lxyz,dr,di,er,ei,ix)
    implicit none
    integer,intent(in):: nv,n,lxyz
    integer,intent(in):: nf,fac(nfmax)
    real(kind=8),intent(in):: w(2,n)
    real(kind=8),dimension(lxyz):: dr,di,er,ei
    integer:: ix
    !
    integer:: iw,nvk,np,uif,if
    !
    iw = 1
    nvk = nv
    np = n/fac(1)
    uif = mod(nf,2)
    do if = 1,nf-uif,2
       select case (fac(if))
       case (2)
          call fftrd2(nvk,np,w(1,iw),dr,di,er,ei)
       case (3)
          call fftrd3(nvk,np,w(1,iw),dr,di,er,ei)
       case (4)
          call fftrd4(nvk,np,w(1,iw),dr,di,er,ei)
       case (5)
          call fftrd5(nvk,np,w(1,iw),dr,di,er,ei)
       case (6)
          call fftrd6(nvk,np,w(1,iw),dr,di,er,ei)
       case (8)
          call fftrd8(nvk,np,w(1,iw),dr,di,er,ei)
       case default
          write(6,*)'unsupported factor'
          stop
       end select
       iw=iw+np*(fac(if)-1)
       nvk=nvk*fac(if)
       np=np/fac(if+1)
       select case (fac(if+1))
       case (2)
          call fftrd2(nvk,np,w(1,iw),er,ei,dr,di)
       case (3)
          call fftrd3(nvk,np,w(1,iw),er,ei,dr,di)
       case (4)
          call fftrd4(nvk,np,w(1,iw),er,ei,dr,di)
       case (5)
          call fftrd5(nvk,np,w(1,iw),er,ei,dr,di)
       case (6)
          call fftrd6(nvk,np,w(1,iw),er,ei,dr,di)
       case (8)
          call fftrd8(nvk,np,w(1,iw),er,ei,dr,di)
       case default
          write(6,*)'unsupported factor'
          stop
       end select
       iw=iw+np*(fac(if+1)-1)
       nvk=nvk*fac(if+1)
       if (if+2 .le. nf) then
          np=np/fac(if+2)
       end if
    end do
    if (uif .eq. 1) then
       select case (fac(nf))
       case (2)
          call fftrd2(nvk,np,w(1,iw),dr,di,er,ei)
       case (3)
          call fftrd3(nvk,np,w(1,iw),dr,di,er,ei)
       case (4)
          call fftrd4(nvk,np,w(1,iw),dr,di,er,ei)
       case (5)
          call fftrd5(nvk,np,w(1,iw),dr,di,er,ei)
       case (6)
          call fftrd6(nvk,np,w(1,iw),dr,di,er,ei)
       case (8)
          call fftrd8(nvk,np,w(1,iw),dr,di,er,ei)
       case default
          write(6,*)'unsupported factor'
          stop
       end select
       ix = - ix
    end if

    return
  end subroutine fftv
  !
  subroutine bftv(nv,n,nf,fac,w,lxyz,dr,di,er,ei,ix)
    implicit none
    integer,intent(in):: nv,n,lxyz
    integer,intent(in):: nf,fac(nfmax)
    real(kind=8),intent(in):: w(2,n)
    real(kind=8),dimension(lxyz):: dr,di,er,ei
    integer:: ix
    !
    integer:: iw,nvk,np,uif,if
    !
    iw = 1
    nvk = nv
    np = n/fac(1)
    uif = mod(nf,2)
    do if = 1,nf-uif,2
       select case (fac(if))
       case (2)
          call bftrd2(nvk,np,w(1,iw),dr,di,er,ei)
       case (3)
          call bftrd3(nvk,np,w(1,iw),dr,di,er,ei)
       case (4)
          call bftrd4(nvk,np,w(1,iw),dr,di,er,ei)
       case (5)
          call bftrd5(nvk,np,w(1,iw),dr,di,er,ei)
       case (6)
          call bftrd6(nvk,np,w(1,iw),dr,di,er,ei)
       case (8)
          call bftrd8(nvk,np,w(1,iw),dr,di,er,ei)
       case default
          write(6,*)'unsupported factor'
          stop
       end select
       iw=iw+np*(fac(if)-1)
       nvk=nvk*fac(if)
       np=np/fac(if+1)
       select case(fac(if+1))
       case (2)
          call bftrd2(nvk,np,w(1,iw),er,ei,dr,di)
       case (3)
          call bftrd3(nvk,np,w(1,iw),er,ei,dr,di)
       case (4)
          call bftrd4(nvk,np,w(1,iw),er,ei,dr,di)
       case (5)
          call bftrd5(nvk,np,w(1,iw),er,ei,dr,di)
       case (6)
          call bftrd6(nvk,np,w(1,iw),er,ei,dr,di)
       case (8)
          call bftrd8(nvk,np,w(1,iw),er,ei,dr,di)
       case default
          write(6,*)'unsupported factor'
          stop
       end select
       iw=iw+np*(fac(if+1)-1)
       nvk=nvk*fac(if+1)
       if (if+2 .le. nf) then
          np=np/fac(if+2)
       end if
    end do
    if (uif .eq. 1) then
       select case (fac(nf))
       case (2)
          call bftrd2(nvk,np,w(1,iw),dr,di,er,ei)
       case (3)
          call bftrd3(nvk,np,w(1,iw),dr,di,er,ei)
       case (4)
          call bftrd4(nvk,np,w(1,iw),dr,di,er,ei)
       case (5)
          call bftrd5(nvk,np,w(1,iw),dr,di,er,ei)
       case (6)
          call bftrd6(nvk,np,w(1,iw),dr,di,er,ei)
       case (8)
          call bftrd8(nvk,np,w(1,iw),dr,di,er,ei)
       case default
          write(6,*)'unsupported factor'
          stop
       end select
       ix = - ix
    end if

    return
  end subroutine bftv
  !
  subroutine fft_pad_zero(nx,ny,nz,lx,ly,lz,dat)
    implicit none
    integer,intent(in):: nx,ny,nz,lx,ly,lz
    real(kind=8):: dat(lx,ly,lz,2)
    !
    integer:: j,k
    do k=1,2
       do j=nz+1,lz
          dat(:,:,j,k) = 0.0d0
       end do
       do j=nx+1,lx
          dat(j,:,:,k) = 0.0d0
       end do
       do j=ny+1,ly
          dat(:,j,:,k) = 0.0d0
       end do
    end do
    return
  end subroutine fft_pad_zero
  !
  subroutine fft_tp1(lxy,lz,src,dst)
    implicit none
    integer,intent(in):: lxy,lz
    real(kind=8),intent(in):: src(lxy,lz)
    real(kind=8),intent(out):: dst(lz,lxy)
    integer:: i,j,ui,uj
    real(kind=8):: r11,r12,r13,r14
    real(kind=8):: r21,r22,r23,r24
    real(kind=8):: r31,r32,r33,r34
    real(kind=8):: r41,r42,r43,r44

    ui = mod(lz,4)
    uj = mod(lxy,4)
!SOPTION LOOP(MAX .LE. 3)
    do i=1,ui
       do j=1,lxy
          dst(i,j) = src(j,i)
       end do
    end do
!SOPTION LOOP(MAX .LE. 3)
    do j=1,uj
       do i=ui+1,lz
          dst(i,j) = src(j,i)
       end do
    end do
    do i=ui+1,lz,4
       do j=uj+1,lxy,4
          r11 = src(j,i)
          r21 = src(j+1,i)
          r31 = src(j+2,i)
          r41 = src(j+3,i)
          r12 = src(j,i+1)
          r22 = src(j+1,i+1)
          r32 = src(j+2,i+1)
          r42 = src(j+3,i+1)
          r13 = src(j,i+2)
          r23 = src(j+1,i+2)
          r33 = src(j+2,i+2)
          r43 = src(j+3,i+2)
          r14 = src(j,i+3)
          r24 = src(j+1,i+3)
          r34 = src(j+2,i+3)
          r44 = src(j+3,i+3)

          dst(i,j) = r11
          dst(i+1,j) = r12
          dst(i+2,j) = r13
          dst(i+3,j) = r14
          dst(i,j+1) = r21
          dst(i+1,j+1) = r22
          dst(i+2,j+1) = r23
          dst(i+3,j+1) = r24
          dst(i,j+2) = r31
          dst(i+1,j+2) = r32
          dst(i+2,j+2) = r33
          dst(i+3,j+2) = r34
          dst(i,j+3) = r41
          dst(i+1,j+3) = r42
          dst(i+2,j+3) = r43
          dst(i+3,j+3) = r44
       end do
    end do
    return
  end subroutine fft_tp1
  !
  subroutine fft_tp(lxy,lz,src,dst)
    implicit none
    integer,intent(in):: lxy,lz
    real(kind=8),intent(in):: src(lxy,lz,2)
    real(kind=8),intent(out):: dst(lz,lxy,2)
    !
    call fft_tp1(lxy,lz,src(1,1,1),dst(1,1,1))
    call fft_tp1(lxy,lz,src(1,1,2),dst(1,1,2))
    return
  end subroutine fft_tp
  !
  subroutine fft_tps1(lxy,lz,src,dst,scl)
    implicit none
    integer,intent(in):: lxy,lz
    real(kind=8),intent(in):: src(lxy,lz)
    real(kind=8),intent(out):: dst(lz,lxy)
    real(kind=8),intent(in):: scl
    integer:: i,j,ui,uj
    real(kind=8):: r11,r12,r13,r14
    real(kind=8):: r21,r22,r23,r24
    real(kind=8):: r31,r32,r33,r34
    real(kind=8):: r41,r42,r43,r44

    ui = mod(lz,4)
    uj = mod(lxy,4)
!SOPTION LOOP(MAX .LE. 3)
    do i=1,ui
       do j=1,lxy
          dst(i,j) = scl*src(j,i)
       end do
    end do
!SOPTION LOOP(MAX .LE. 3)
    do j=1,uj
       do i=ui+1,lz
          dst(i,j) = scl*src(j,i)
       end do
    end do
    do i=ui+1,lz,4
       do j=uj+1,lxy,4
          r11 = src(j,i)
          r21 = src(j+1,i)
          r31 = src(j+2,i)
          r41 = src(j+3,i)
          r12 = src(j,i+1)
          r22 = src(j+1,i+1)
          r32 = src(j+2,i+1)
          r42 = src(j+3,i+1)
          r13 = src(j,i+2)
          r23 = src(j+1,i+2)
          r33 = src(j+2,i+2)
          r43 = src(j+3,i+2)
          r14 = src(j,i+3)
          r24 = src(j+1,i+3)
          r34 = src(j+2,i+3)
          r44 = src(j+3,i+3)

          dst(i,j) = scl*r11
          dst(i+1,j) = scl*r12
          dst(i+2,j) = scl*r13
          dst(i+3,j) = scl*r14
          dst(i,j+1) = scl*r21
          dst(i+1,j+1) = scl*r22
          dst(i+2,j+1) = scl*r23
          dst(i+3,j+1) = scl*r24
          dst(i,j+2) = scl*r31
          dst(i+1,j+2) = scl*r32
          dst(i+2,j+2) = scl*r33
          dst(i+3,j+2) = scl*r34
          dst(i,j+3) = scl*r41
          dst(i+1,j+3) = scl*r42
          dst(i+2,j+3) = scl*r43
          dst(i+3,j+3) = scl*r44
       end do
    end do
    return
  end subroutine fft_tps1
  !
  subroutine fft_tps(lxy,lz,src,dst,scl)
    implicit none
    integer,intent(in):: lxy,lz
    real(kind=8),intent(in):: src(lxy,lz,2)
    real(kind=8),intent(out):: dst(lz,lxy,2)
    real(kind=8),intent(in):: scl
    !
    call fft_tps1(lxy,lz,src(1,1,1),dst(1,1,1),scl)
    call fft_tps1(lxy,lz,src(1,1,2),dst(1,1,2),scl)
    return
  end subroutine fft_tps
  !
  subroutine fft3_init(mx,my,mz,lmx,lmy,lmz,fs)
    implicit none
    integer,intent(in):: mx,my,mz,lmx,lmy,lmz
    type (fft3_struct):: fs
    !
    fs%nx = mx
    fs%ny = my
    fs%nz = mz
    fs%nxyz = mx*my*mz
    fs%lx = lmx
    fs%ly = lmy
    fs%lz = lmz
    fs%lxyz = lmx*lmy*lmz
    call fact235(mx,fs%nfx,fs%facx)
    call fact235(my,fs%nfy,fs%facy)
    call fact235(mz,fs%nfz,fs%facz)
    allocate(fs%wx(2,mx),fs%wy(2,my),fs%wz(2,mz))
    call genw(mx,fs%nfx,fs%facx,fs%wx)
    call genw(my,fs%nfy,fs%facy,fs%wy)
    call genw(mz,fs%nfz,fs%facz,fs%wz)
    return
  end subroutine fft3_init

  subroutine fft3_done(fs)
    implicit none
    type (fft3_struct):: fs
    !
    deallocate(fs%wx,fs%wy,fs%wz)
    return
  end subroutine fft3_done

  subroutine fft3_fw(fs,dat,tmp)
    implicit none
    type (fft3_struct):: fs
    real(kind=8):: dat(fs%lxyz,2)
    real(kind=8):: tmp(fs%lxyz,2)
    integer:: ix
    real(kind=8):: scl
    !
    call fft_pad_zero(fs%nx,fs%ny,fs%nz,fs%lx,fs%ly,fs%lz,tmp)
    ix = 1
    !
    call fftv(fs%lx*fs%ly, fs%nz, fs%nfz, fs%facz, fs%wz, &
         fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    !
    if (ix .eq. 1) then
       call fft_tp(fs%lx*fs%ly, fs%lz, dat, tmp)
       ix = - ix
       !
       call fftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%lx*fs%ly, fs%lz, tmp, dat)
       ix = - ix
       !
       call fftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_fw: y, abs(ix) != 1'
       stop
    end if
    !
    if (ix .eq. 1) then
       call fft_tp(fs%lz*fs%lx, fs%ly, dat, tmp)
       ix = - ix
       !
       call fftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%lz*fs%lx, fs%ly, tmp, dat)
       ix = - ix
       !
       call fftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_fw: x, abs(ix) != 1'
       stop
    end if
    !
    scl = 1.0d0/fs%nxyz
    if (ix .eq. 1) then
       call fft_tp(fs%ly*fs%lz, fs%lx, dat, tmp)
       !
       dat = scl*tmp
    else if (ix .eq. -1) then
       call fft_tp(fs%ly*fs%lz, fs%lx, tmp, dat)
       !
       dat = scl*dat
    else
       write(6,*) 'fft3_fw: f, abs(ix) != 1'
       stop
    end if
    return
  end subroutine fft3_fw

  subroutine fft3_bw(fs,dat,tmp)
    implicit none
    type (fft3_struct):: fs
    real(kind=8):: dat(fs%lxyz,2)
    real(kind=8):: tmp(fs%lxyz,2)
    integer:: ix
    !
    call fft_pad_zero(fs%nx,fs%ny,fs%nz,fs%lx,fs%ly,fs%lz,tmp)
    ix = 1
    !
    call bftv(fs%lx*fs%ly, fs%nz, fs%nfz, fs%facz, fs%wz, &
         fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    !
    if (ix .eq. 1) then
       call fft_tp(fs%lx*fs%ly, fs%lz, dat, tmp)
       ix = - ix
       !
       call bftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%lx*fs%ly, fs%lz, tmp, dat)
       ix = - ix
       !
       call bftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_bw: y, abs(ix) != 1'
       stop
    end if
    !
    if (ix .eq. 1) then
       call fft_tp(fs%lz*fs%lx, fs%ly, dat, tmp)
       ix = - ix
       !
       call bftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%lz*fs%lx, fs%ly, tmp, dat)
       ix = - ix
       !
       call bftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_bw: x, abs(ix) != 1'
       stop
    end if
    !
    if (ix .eq. 1) then
       call fft_tp(fs%ly*fs%lz, fs%lx, dat, tmp)
       dat = tmp
    else if (ix .eq. -1) then
       call fft_tp(fs%ly*fs%lz, fs%lx, tmp, dat)
    else
       write(6,*) 'fft3_bw: f, abs(ix) != 1'
       stop
    end if
    return
  end subroutine fft3_bw
  !
  subroutine fft3_fwsx(fs,dat,tmp,ix)
    implicit none
    type (fft3_struct):: fs
    real(kind=8):: dat(fs%lxyz,2)
    real(kind=8):: tmp(fs%lxyz,2)
    integer:: ix
    real(kind=8):: scl
    !
    call fft_pad_zero(fs%nx,fs%ny,fs%nz,fs%lx,fs%ly,fs%lz,tmp)
    !
    if (ix .eq. 1) then
       call fftv(fs%lx*fs%ly, fs%nz, fs%nfz, fs%facz, fs%wz, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else if (ix .eq. -1) then
       call fftv(fs%lx*fs%ly, fs%nz, fs%nfz, fs%facz, fs%wz, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else
       write(6,*) 'fft3_fwsx: z, abs(ix) != 1'
       stop
    end if
    !
    if (ix .eq. 1) then
       call fft_tp(fs%lx*fs%ly, fs%lz, dat, tmp)
       ix = - ix
       !
       call fftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%lx*fs%ly, fs%lz, tmp, dat)
       ix = - ix
       !
       call fftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_fwsx: y, abs(ix) != 1'
       stop
    end if
    !
    scl = 1.0d0/fs%nxyz
    !
    if (ix .eq. 1) then
       call fft_tps(fs%lz*fs%lx, fs%ly, dat, tmp, scl)
       ix = - ix
       !
       call fftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tps(fs%lz*fs%lx, fs%ly, tmp, dat, scl)
       ix = - ix
       !
       call fftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_fwsx: x, abs(ix) != 1'
       stop
    end if
    !
    return
  end subroutine fft3_fwsx

  subroutine fft3_bwsx(fs,dat,tmp,ix)
    implicit none
    type (fft3_struct):: fs
    real(kind=8):: dat(fs%lxyz,2)
    real(kind=8):: tmp(fs%lxyz,2)
    integer:: ix
    !
    call fft_pad_zero(fs%ny,fs%nz,fs%nx,fs%ly,fs%lz,fs%lx,tmp)
    !
    if (ix .eq. 1) then
       call bftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else if (ix .eq. -1) then
       call bftv(fs%lz*fs%lx, fs%ny, fs%nfy, fs%facy, fs%wy, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else
       write(6,*) 'fft3_bwsx: x, abs(ix) != 1'
       stop
    end if
    !
    if (ix .eq. 1) then
       call fft_tp(fs%lz*fs%lx, fs%ly, dat, tmp)
       ix = - ix
       !
       call bftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%lz*fs%lx, fs%ly, tmp, dat)
       ix = - ix
       !
       call bftv(fs%ly*fs%lz, fs%nx, fs%nfx, fs%facx, fs%wx, &
            fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_bwsx: y, abs(ix) != 1'
       stop
    end if
    !
    if (ix .eq. 1) then
       call fft_tp(fs%ly*fs%lz, fs%lx, dat, tmp)
       ix = - ix
       !
       call bftv(fs%lx*fs%ly, fs%nz, fs%nfz, fs%facz, fs%wz, &
         fs%lxyz, tmp(1,1), tmp(1,2), dat(1,1), dat(1,2), ix)
    else if (ix .eq. -1) then
       call fft_tp(fs%ly*fs%lz, fs%lx, tmp, dat)
       ix = - ix
       !
       call bftv(fs%lx*fs%ly, fs%nz, fs%nfz, fs%facz, fs%wz, &
         fs%lxyz, dat(1,1), dat(1,2), tmp(1,1), tmp(1,2), ix)
    else
       write(6,*) 'fft3_bwsx: z, abs(ix) != 1'
       stop
    end if
    !
    return
  end subroutine fft3_bwsx

end module fft_3d

subroutine invmat(nm,mat)
  implicit none 
  integer,intent(in)::nm
  real(8),intent(inout)::mat(nm,nm)
  integer::ipiv(nm)
  integer::Lwork 
  real(8),allocatable::work(:)
  integer::info 

  Lwork = 10*nm
  allocate(work(Lwork))
  info = 0
  call dgetrf(nm,nm,mat,nm,ipiv,info)
  call dgetri(nm,mat,nm,ipiv,work,Lwork,info)
  if(info /= 0) then
   write(6,*)'info (subrouitine inv):',info
   stop
  end if 
  deallocate(work)
  return 
end subroutine

MODULE m_frmsf !(c) Mitsuaki Kawamura 
  !
  IMPLICIT NONE
  !
CONTAINS
  !
!org SUBROUTINE wrt_frmsf_wan(Na1,Na2,Na3,nkb1,nkb2,nkb3,a1,a2,a3,b1,b2,b3,FermiEnergy,WEIGHT_R,H_MAT_R)
SUBROUTINE wrt_frmsf(NWF,dense,Na1,Na2,Na3,nkb1,nkb2,nkb3,a1,a2,a3,b1,b2,b3,FermiEnergy,H_MAT_R)
  !
  !USE m_rdinput, ONLY : n_occ, dense
  !
  IMPLICIT NONE
  !
  integer,intent(in) :: NWF!=n_occ  
  integer,intent(in) :: dense(3)!Dense k-grid for the Wnnier-interpolated FS
  !
  INTEGER,INTENT(IN) :: Na1, Na2, Na3, nkb1, nkb2, nkb3
  REAL(8),INTENT(IN) :: a1(3), a2(3), a3(3), b1(3), b2(3), b3(3), FermiEnergy!, WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  !
  !COMPLEX(8),INTENT(IN) :: H_MAT_R(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  COMPLEX(8),INTENT(IN) :: H_MAT_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  !
  !INTEGER(8) :: ik, i1, i2, i3, ib, jb, fo = 21, nk, i1min, i2min, i3min
  INTEGER :: ik, i1, i2, i3, ib, jb, fo = 21, nk, i1min, i2min, i3min
  REAL(8) :: kvec(3,PRODUCT(dense(1:3))), phase, tpi=2.0d0*acos(-1.0d0), &
  !&          Ek(n_occ,PRODUCT(dense(1:3))), proj(n_occ,n_occ,PRODUCT(dense(1:3)))
  &          Ek(NWF,PRODUCT(dense(1:3))), proj(NWF,NWF,PRODUCT(dense(1:3)))
  !
  real(8),allocatable :: WEIGHT_R(:,:,:)!WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  !
  !COMPLEX(8) :: Hk(n_occ,n_occ), phase_factor, ci=CMPLX(0.0d0,1.0d0)
  COMPLEX(8) :: Hk(NWF,NWF), phase_factor, ci=CMPLX(0.0d0,1.0d0)
  CHARACTER(256) :: fname
  !
  WRITE(*,*) "Wannnier-interpolated Fermi surface"
  !
  WRITE(*,*) "  Dense grid : ", dense(1:3)
  !
  nk = PRODUCT(dense(1:3))
  !
  ik = 0
  DO i1 = 1, dense(1)
     DO i2 = 1, dense(2)
        DO i3 = 1, dense(3)
           ik = ik + 1
           kvec(1:3,ik) = DBLE((/i1, i2, i3/) - 1) / DBLE(dense(1:3))
        END DO
     END DO
  END DO
  !
  allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED(nk,NWF,Na1,Na2,Na3,nkb1,nkb2,nkb3,a1,a2,a3,tpi,ci, &
  !$OMP &        WEIGHT_R,H_MAT_R,kvec,Ek,proj) &
  !$OMP & PRIVATE(ik,ib,jb,i1,i2,i3,i1min,i2min,i3min,phase,Hk,phase_factor)
  !
  !Ek(1:n_occ,        1:nk) = 0.0d0
  Ek(1:NWF,        1:nk) = 0.0d0
  !
  !$OMP DO
  DO ik = 1, nk
     Hk(1:NWF,1:NWF) = 0.0d0
     DO ib = 1, NWF!n_occ
        DO jb = 1, NWF!n_occ
           DO i1 = -Na1, Na1!-1
              DO i2 = -Na2, Na2!-1
                 DO i3 = -Na3, Na3!-1
                    !--
                    !-- NEAREST R SEARCH
                    CALL search_Rmin(i1,i2,i3,nkb1,nkb2,nkb3, &
                    &                a1,a2,a3,i1min,i2min,i3min)
                    phase = tpi * DOT_PRODUCT(kvec(1:3,ik), DBLE((/i1min, i2min, i3min/)))
                    !--
                    phase_factor = EXP(ci * phase) * WEIGHT_R(i1,i2,i3)
                    Hk(jb,ib) = Hk(jb,ib) &
                    &         + H_MAT_R(jb,ib,i1,i2,i3) * phase_factor
                 END DO!i3
              END DO!i2
           END DO!i1
        END DO!jb
     END DO!ib
     !
     !CALL diagV(n_occ,Hk(1:n_occ,1:n_occ),Ek(1:n_occ,ik))
     CALL diagV(NWF,Hk(1:NWF,1:NWF),Ek(1:NWF,ik))
     !
     !proj(1:n_occ,1:n_occ,ik) = DBLE(CONJG(Hk(1:n_occ,1:n_occ)) * Hk(1:n_occ,1:n_occ))
     proj(1:NWF,1:NWF,ik) = DBLE(CONJG(Hk(1:NWF,1:NWF)) * Hk(1:NWF,1:NWF))
     !
  END DO !ik
  !$OMP END DO
  !$OMP END PARALLEL
  ! 
  !20190421 Kazuma Nakamura 
  !
  WRITE(fname,'(a)')"./dat.frmsf"
  OPEN(fo,FILE=TRIM(fname)) 
  rewind(fo) 
  WRITE(fo,*) dense(1:3)
  WRITE(fo,*) 1
  WRITE(fo,*) NWF 
  WRITE(fo,*) REAL(b1(1:3))
  WRITE(fo,*) REAL(b2(1:3))
  WRITE(fo,*) REAL(b3(1:3))
  DO ib=1,NWF 
     DO ik=1,nk
        WRITE(fo,*) REAL(Ek(ib,ik)-FermiEnergy)
     ENDDO!ik
  ENDDO!ib
  DO ib=1,NWF 
     DO ik=1,nk
        WRITE(fo,*) REAL(ib) 
     ENDDO!ik
  ENDDO!ib
  CLOSE(fo)
  !
  WRITE(*,*) TRIM(fname)," finish" 
  !
  ! Write to file
  !
  DO ib = 1, NWF!n_occ
     !
     !WRITE(fname,'(a,i0,a)')"./dir-wan/orb",ib,".frmsf"
     WRITE(fname,'(a,i3.3,a)')"./dat.orb-",ib,".frmsf"       
     OPEN(fo,FILE=TRIM(fname)) 
     WRITE(fo,*) dense(1:3)
     WRITE(fo,*) 1
     WRITE(fo,*) NWF!n_occ 
     WRITE(fo,*) REAL(b1(1:3))
     WRITE(fo,*) REAL(b2(1:3))
     WRITE(fo,*) REAL(b3(1:3))
     DO jb = 1, NWF!n_occ
        DO ik = 1, nk
           WRITE(fo,*) REAL(Ek(jb,ik) - FermiEnergy)
        END DO
     END DO
     DO jb = 1, NWF!n_occ
        DO ik = 1, nk
           WRITE(fo,*) REAL(proj(ib,jb,ik))
        END DO
     END DO
     CLOSE(fo)
     !
     WRITE(*,*) TRIM(fname), " for orbital ", ib
     !
  END DO
  !
!END SUBROUTINE wrt_frmsf_wan
END SUBROUTINE wrt_frmsf 
!
subroutine search_Rmin(i,j,k,nkb1,nkb2,nkb3,a1,a2,a3,imin,jmin,kmin)
    implicit none
    integer::i,j,k,nkb1,nkb2,nkb3
    integer::imin,jmin,kmin
    real(8)::a1(3),a2(3),a3(3) 
    integer::nmin,mmin,lmin
    integer::n,m,l 
    real(8)::R_pos(3),R_abs,R_min,R_bfr
    R_pos(:)=dble(i)*a1(:)+dble(j)*a2(:)+dble(k)*a3(:)
    nmin=0;mmin=0;lmin=0
    R_bfr=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
    R_min=R_bfr 
    do n=-3,3
     do m=-3,3
      do l=-3,3
       R_pos(:)=dble(i+n*nkb1)*a1(:)+dble(j+m*nkb2)*a2(:)+dble(k+l*nkb3)*a3(:)
       R_abs=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
       if(R_min>R_abs)then 
        R_min=R_abs
        nmin=n
        mmin=m
        lmin=l
       endif 
      enddo
     enddo
    enddo
    imin=i+nmin*nkb1
    jmin=j+mmin*nkb2
    kmin=k+lmin*nkb3
    return
    !
end subroutine search_Rmin 

subroutine diagV(nm,mat,eig)
    implicit none 
    integer,intent(in)::nm
    complex(8),intent(inout)::mat(nm,nm)
    real(8),intent(out)::eig(nm)
    integer::LWORK,LRWORK,LIWORK  
    integer,allocatable::iwork_zheevd(:)
    real(8),allocatable::rwork_zheevd(:)
    complex(8),allocatable::work_zheevd(:)
    integer::ind
    real(8)::eps 
    !
    LWORK= 2*nm+nm**2
    LRWORK=1+12*nm+3*nm**2
    LIWORK=3+10*nm 
    allocate(work_zheevd(LWORK));work_zheevd(:)=0.0d0
    allocate(rwork_zheevd(LRWORK));rwork_zheevd(:)=0.0d0
    allocate(iwork_zheevd(LIWORK));iwork_zheevd(:)=0
    eps=1.0d-18
    ind=0                 
    !
    call zheevd("V","U",nm,mat,nm,eig,work_zheevd,LWORK,rwork_zheevd,LRWORK,iwork_zheevd,LIWORK,ind)
    !
    if(ind/=0)then 
     write(6,*)'ind=',ind 
     stop
    endif 
    !
    deallocate(work_zheevd,rwork_zheevd,iwork_zheevd) 
    return 
end subroutine diagV
!
END MODULE m_frmsf 

!
! Copyright (c) 2013,2016 Yoshihide Yoshimoto
!
module subr_readstr
contains
  subroutine read_strfile(nf,nkd,nsi,ax,aa,kd,asi,cforce,zo,zn, &
    o_total_energy,o_fermi_energy)
    implicit none
    integer,intent(in):: nf
    real(kind=8):: ax
    integer:: nkd,nsi
    real(kind=8):: aa(3,3)
    integer,pointer:: kd(:)
    real(kind=8),pointer:: asi(:,:),cforce(:,:)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8),optional:: o_total_energy,o_fermi_energy(2)

    real(kind=8):: lattice_factor, lattice_list(9), total_energy
    real(kind=8):: stress_tensor(6), fermi_energy(2)
    integer:: number_element, number_atom
    real(kind=8):: spin_polarization, abs_spin_polarization
    real(kind=8):: spin_polarization_vector(3)
    real(kind=8):: abs_spin_polarization_vector(3)
    integer:: ikd,it

    namelist /struct_data/ lattice_factor, lattice_list, total_energy, &
         stress_tensor, fermi_energy, number_element, number_atom, &
         spin_polarization, spin_polarization_vector, abs_spin_polarization, &
         abs_spin_polarization_vector

    read(nf, struct_data, err=100, end=100)

    if (present(o_total_energy)) then
       o_total_energy = total_energy
    end if
    if (present(o_fermi_energy)) then
       o_fermi_energy = fermi_energy
    end if

    ax = lattice_factor
    aa(:,1) = lattice_list(1:3)
    aa(:,2) = lattice_list(4:6)
    aa(:,3) = lattice_list(7:9)
    nkd = number_element
    nsi = number_atom
    allocate(zo(nkd),zn(nkd))
    allocate(kd(nsi),asi(3,nsi),cforce(3,nsi))

    read(nf,*,err=200)
    read(nf,*,err=200)
    do ikd=1,nkd
       read(nf,*,err=200) zo(ikd),zn(ikd)
    end do

    read(nf,*,err=300)
    read(nf,*,err=300)
    do it=1,nsi
       read(nf,*,err=300) kd(it),asi(1,it),asi(2,it),asi(3,it)
    end do

    read(nf,*,err=400)
    read(nf,*,err=400)
    do it=1,nsi
       read(nf,*,err=400) cforce(1,it),cforce(2,it),cforce(3,it)
    end do

    return

100 continue
    write(6,'(a)')'error in reading struct_data'
    stop
200 continue
    write(6,'(a)')'error in reading valence and nucleus charge'
    stop
300 continue
    write(6,'(a)')'error in reading atom kind and position'
    stop
400 continue
    write(6,'(a)')'error in reading force'
    stop
  end subroutine read_strfile

  subroutine xread_strfile(nf,nkd,nsi,ax,aa,kd,asi,cforce,zo,zn, &
       etotal,stress,ef,spinpol,aspinpol)
    implicit none
    integer,intent(in):: nf
    real(kind=8):: ax
    integer:: nkd,nsi
    real(kind=8):: aa(3,3)
    integer,pointer:: kd(:)
    real(kind=8),pointer:: asi(:,:),cforce(:,:)
    real(kind=8),pointer:: zo(:),zn(:)
    real(kind=8):: etotal,stress(6),ef(2),spinpol,aspinpol

    real(kind=8):: lattice_factor, lattice_list(9), total_energy
    real(kind=8):: stress_tensor(6), fermi_energy(2)
    integer:: number_element, number_atom
    real(kind=8):: spin_polarization, abs_spin_polarization
    real(kind=8):: spin_polarization_vector(3)
    real(kind=8):: abs_spin_polarization_vector(3)
    integer:: ikd,it

    namelist /struct_data/ lattice_factor, lattice_list, total_energy, &
         stress_tensor, fermi_energy, number_element, number_atom, &
         spin_polarization, abs_spin_polarization, &
         spin_polarization_vector, abs_spin_polarization_vector

    read(nf, struct_data, err=100, end=100)

    ax = lattice_factor
    aa(:,1) = lattice_list(1:3)
    aa(:,2) = lattice_list(4:6)
    aa(:,3) = lattice_list(7:9)
    nkd = number_element
    nsi = number_atom
    etotal = total_energy
    stress = stress_tensor
    ef = fermi_energy
    spinpol = spin_polarization
    aspinpol = abs_spin_polarization

    allocate(zo(nkd),zn(nkd))
    allocate(kd(nsi),asi(3,nsi),cforce(3,nsi))

    read(nf,*,err=200)
    read(nf,*,err=200)
    do ikd=1,nkd
       read(nf,*,err=200) zo(ikd),zn(ikd)
    end do

    read(nf,*,err=300)
    read(nf,*,err=300)
    do it=1,nsi
       read(nf,*,err=300) kd(it),asi(1,it),asi(2,it),asi(3,it)
    end do

    read(nf,*,err=400)
    read(nf,*,err=400)
    do it=1,nsi
       read(nf,*,err=400) cforce(1,it),cforce(2,it),cforce(3,it)
    end do

    return

100 continue
    write(6,'(a)')'error in reading struct_data'
    stop
200 continue
    write(6,'(a)')'error in reading valence and nucleus charge'
    stop
300 continue
    write(6,'(a)')'error in reading atom kind and position'
    stop
400 continue
    write(6,'(a)')'error in reading force'
    stop
  end subroutine xread_strfile

end module subr_readstr

subroutine estimate_nsgm(ecmin,emin,emax,ecmax,gw_grid_separation,nproc,nsgm)
 ! 
 implicit none
 real(8)::ecmin,emin,emax,ecmax,gw_grid_separation 
 real(8)::omega,grd_separation 
 integer::ie,je,nproc
 integer::nsgm 
 integer,parameter::nsgm_max=100000 
 real(8),parameter::expansion=10.0d0!50.0d0  
 !
 je=0
 grd_separation=expansion*gw_grid_separation 
 omega=ecmin 
 do ie=1,nsgm_max
  !
  if(ecmin<=omega.and.omega<emin)then
   grd_separation=expansion*gw_grid_separation 
   je=je+1
  endif 
  !
  if(emin<=omega.and.omega<=emax)then
   grd_separation=gw_grid_separation 
   je=je+1
  endif 
  !
  if(emax<omega)then
   grd_separation=expansion*gw_grid_separation 
   je=je+1
  endif 
  !
  if(omega>ecmax.and.(mod(je,nproc).eq.0))exit 
  !
  omega=omega+grd_separation 
  !
 enddo!ie
 ! 
 !write(6000,*)'#je=',je  
 ! 
 nsgm=je 
 !
 return
end 
!
subroutine make_sgmw(ecmin,emin,emax,gw_grid_separation,nsgm,sgmw)
 !
 implicit none
 real(8)::ecmin,emin,emax,gw_grid_separation
 real(8)::omega,grd_separation 
 integer::nsgm 
 real(8)::sgmw(nsgm) 
 integer::ie 
 real(8),parameter::expansion=10.0d0!50.0d0  
 !
 sgmw=0.0d0 
 !
 grd_separation=expansion*gw_grid_separation 
 omega=ecmin 
 do ie=1,nsgm 
  !
  if(ecmin<=omega.and.omega<emin)then
   sgmw(ie)=omega
   grd_separation=expansion*gw_grid_separation 
  endif 
  !
  if(emin<=omega.and.omega<=emax)then
   sgmw(ie)=omega
   grd_separation=gw_grid_separation
  endif 
  !
  if(emax<omega)then
   sgmw(ie)=omega
   grd_separation=expansion*gw_grid_separation 
  endif 
  !
  omega=omega+grd_separation 
  !
 enddo!ie
 !
 !do ie=1,nsgm 
 ! write(6000,*) ie,sgmw(ie)!*au 
 !enddo 
 !
return
end 

program mklocal !by Kazum NAKAMURA 
implicit none 
integer::NTA 
character(2),allocatable::kd(:)
real,allocatable::lat(:,:)
integer::i,ix 
real(8)::a1(3),a2(3),a3(3),alat 
real(8)::locx(3),locy(3),locz(3),length,inp  
!--
read(100,*) alat 
read(100,*) a1(1),a1(2),a1(3)
read(100,*) a2(1),a2(2),a2(3)
read(100,*) a3(1),a3(2),a3(3)
read(100,*) NTA
allocate(kd(NTA))
allocate(lat(3,NTA)) 
do i=1,NTA
 read(100,*) kd(i),(lat(ix,i),ix=1,3) 
enddo 
!--
!local for TiO2 
 call gen_loc_1_TiO2(NTA,kd(1),lat(1,1),alat,a1(1),a2(1),a3(1),locx(1),locy(1),locz(1)) 
 write(6,'(9f10.5)')locx,locy,locz 
!--
!local for TiO2 
 call gen_loc_2_TiO2(NTA,kd(1),lat(1,1),alat,a1(1),a2(1),a3(1),locx(1),locy(1),locz(1)) 
 write(6,'(9f10.5)')locx,locy,locz 
!--
stop
end
!--
SUBROUTINE OUTER_PRODUCT(vec_x,vec_y,vec_z)
implicit none 
real(8)::vec_x(3),vec_y(3),vec_z(3) 
vec_z(1)=vec_x(2)*vec_y(3)-vec_x(3)*vec_y(2)
vec_z(2)=vec_x(3)*vec_y(1)-vec_x(1)*vec_y(3) 
vec_z(3)=vec_x(1)*vec_y(2)-vec_x(2)*vec_y(1)
RETURN
END
!--
subroutine gen_loc_1_TiO2(NTA,kd,lat,alat,a1,a2,a3,locx,locy,locz) 
implicit none 
integer::NTA 
character(2)::kd(3)
real::lat(3,NTA)
integer::i,ix 
real(8)::a1(3),a2(3),a3(3),alat 
real(8)::x1(3),x2(3),x3(3) 
real(8)::locx(3),locy(3),locz(3),length  
x1=0.0d0;x2=0.0d0;x3=0.0d0 
locx=0.0d0;locy=0.0d0;locz=0.0d0 
!--
do i=1,NTA 
 if(i==1)then
  !write(6,*) kd(i),(lat(ix,i),ix=1,3) 
  x1(:)=lat(1,i)*alat*a1(:)+lat(2,i)*alat*a2(:)+lat(3,i)*alat*a3(:)  
 endif
 if(i==6)then 
  !write(6,*) kd(i),(lat(ix,i),ix=1,3) 
  x2(:)=lat(1,i)*alat*a1(:)+(lat(2,i)-1.0d0)*alat*a2(:)+lat(3,i)*alat*a3(:)  
  x3(:)=lat(1,i)*alat*a1(:)+(lat(2,i)-1.0d0)*alat*a2(:)+(lat(3,i)-1.0d0)*alat*a3(:)  
 endif 
enddo 
!--
locx=x2-x1 
length=dsqrt(locx(1)**2+locx(2)**2+locx(3)**2)
locx=locx/length 
!--
locy(:)=x3-x1
length=dsqrt(locy(1)**2+locy(2)**2+locy(3)**2)
locy=locy/length 
!--
call OUTER_PRODUCT(locx(1),locy(1),locz(1))
length=dsqrt(locz(1)**2+locz(2)**2+locz(3)**2)
locz=locz/length 
return
end
!--
subroutine gen_loc_2_TiO2(NTA,kd,lat,alat,a1,a2,a3,locx,locy,locz) 
implicit none 
integer::NTA 
character(2)::kd(3)
real::lat(3,NTA)
integer::i,ix 
real(8)::a1(3),a2(3),a3(3),alat 
real(8)::x1(3),x2(3),x3(3) 
real(8)::locx(3),locy(3),locz(3),length  
x1=0.0d0;x2=0.0d0;x3=0.0d0 
locx=0.0d0;locy=0.0d0;locz=0.0d0 
!--
do i=1,NTA 
 if(i==2)then
  !write(6,*) kd(i),(lat(ix,i),ix=1,3) 
  x1(:)=lat(1,i)*alat*a1(:)+lat(2,i)*alat*a2(:)+lat(3,i)*alat*a3(:)  
 endif
 if(i==3)then 
  !write(6,*) kd(i),(lat(ix,i),ix=1,3) 
  x2(:)=lat(1,i)*alat*a1(:)+lat(2,i)*alat*a2(:)+(lat(3,i)+1.0d0)*alat*a3(:)  
 endif 
 if(i==4)then 
  x3(:)=lat(1,i)*alat*a1(:)+lat(2,i)*alat*a2(:)+(lat(3,i)+1.0d0)*alat*a3(:)  
 endif 
enddo 
!--
locx=x2-x1 
length=dsqrt(locx(1)**2+locx(2)**2+locx(3)**2)
locx=locx/length 
!--
locy(:)=x3-x1
length=dsqrt(locy(1)**2+locy(2)**2+locy(3)**2)
locy=locy/length 
!--
call OUTER_PRODUCT(locx(1),locy(1),locz(1))
length=dsqrt(locz(1)**2+locz(2)**2+locz(3)**2)
locz=locz/length 
return
end

subroutine calc_ksdos(NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3,idlt,dmna,dmnr,FermiEnergy,a1,a2,a3,b1,b2,b3,sgmw,SK0,KS_R,ksdos)
  !
  implicit none 
  integer::NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3 
  real(8)::idlt,dmna,dmnr
  real(8)::a1(3),a2(3),a3(3)
  real(8)::b1(3),b2(3),b3(3)
  real(8)::sgmw(nsgm)  
  real(8)::SK0(3,NTK) 
  complex(8)::KS_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
  !
  real(8),allocatable::WEIGHT_R(:,:,:)!WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
  real(8),allocatable::EKS(:,:)!EKS(NWF,NTK)           
  complex(8),allocatable::VKS(:,:,:)!VKS(NWF,NWF,NTK)   
  complex(8),allocatable::pf(:,:,:,:)!pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)   
  ! 
  integer::ia1min,ia2min,ia3min 
  integer::ia1,ia2,ia3,ik,ib,jb,ie  
  real(8)::PHASE,FermiEnergy 
  real(8)::SUM_REAL
  complex(8)::SUM_CMPX 
  !
  real(8),parameter::au=27.21151d0
  real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
  complex(8),parameter::ci=(0.0D0,1.0D0) 
  !
  real(8),intent(out)::ksdos(nsgm) 
  !
  !1. WEIGHT_R BY Y.Nomura NOMURA 
  !
  allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
  SUM_REAL=0.0d0 
  do ia1=-Na1,Na1
   do ia2=-Na2,Na2
    do ia3=-Na3,Na3
     if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
    enddo!ia3
   enddo!ia2
  enddo!ia1
  write(6,'(a20,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
  if(abs(SUM_REAL-dble(NTK))>1.0d-6)then 
   stop 'SUM_WEIGHT/=NTK'
  endif 
  !
  allocate(pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)); pf=0.0d0 
  do ik=1,NTK 
   do ia3=-Na3,Na3 
    do ia2=-Na2,Na2 
     do ia1=-Na1,Na1 
      !
      !NEAREST R SEARCH BY Y.Yoshimoto 
      !
      call search_Rmin(ia1,ia2,ia3,nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),ia1min,ia2min,ia3min)
      PHASE=tpi*(SK0(1,ik)*DBLE(ia1min)+SK0(2,ik)*DBLE(ia2min)+SK0(3,ik)*DBLE(ia3min))           
      pf(ia1,ia2,ia3,ik)=EXP(ci*PHASE)*WEIGHT_R(ia1,ia2,ia3)          
     enddo!ia1 
    enddo!ia2 
   enddo!ia3 
  enddo!ik  
  write(6,*)'# finish make pf'
  !
  !2. HKS IN WANNIER BASIS. AND DIAGONALIZE
  !
  allocate(EKS(NWF,NTK)); EKS=0.0d0 
  allocate(VKS(NWF,NWF,NTK)); VKS=0.0d0 
  call make_eks(NTK,NWF,Na1,Na2,Na3,KS_R(1,1,-Na1,-Na2,-Na3),pf(-Na1,-Na2,-Na3,1),EKS(1,1),VKS(1,1,1))  
  !
  !3. KS-DOS CALC
  !
  ksdos=0.0d0 
  call calc_dos_KS(NWF,NTK,nkb1,nkb2,nkb3,nsgm,sgmw(1),EKS(1,1),SK0(1,1),idlt,dmnr,dmna,b1(1),b2(1),b3(1),ksdos(1)) 
  !
  deallocate(WEIGHT_R,EKS,VKS,pf) 
  !
return 
end

module m_rd_dat_wfn
implicit none
public::rd_dat_symmetry
public::rd_dat_bandcalc 
public::rd_dat_lattice 
public::rd_dat_sample_k 
public::rd_dat_nkm 
public::rd_dat_kg 
public::rd_dat_eigenvalue 
public::rd_dat_wavefunction 
!sym(100)
integer,public::nsymq,nnp
integer,public,allocatable::rg(:,:,:)!3,3,nsymq)
integer,public,allocatable::pg(:,:)!pg(3,nsymq)
real(8),public,allocatable::rginv(:,:,:)!rginv(3,3,nsymq) 
!bandcalc(117) 
real(8),public::Ecut_for_psi 
real(8),public::FermiEnergy  
real(8),public::Etot
!avec(105)
real(8),public::a1(3),a2(3),a3(3)
real(8),public::b1(3),b2(3),b3(3)
real(8),public::VOLUME,a,b,c,alp,bet,gmm  
!sample-k(101)
integer,public::Nk_irr,NTK 
integer,public::nkb1!SAMPLING K POINTS ALONG b1 VECTOR
integer,public::nkb2!SAMPLING K POINTS ALONG b2 VECTOR
integer,public::nkb3!SAMPLING K POINTS ALONG b3 VECTOR
integer,public::Na1!LATTICE TRANSLATIONL IN a1 20170327 
integer,public::Na2!LATTICE TRANSLATIONL IN a2 20170327 
integer,public::Na3!LATTICE TRANSLATIONL IN a3 20170327 
real(8),public,allocatable::SKI(:,:)!SKI(3,Nk_irr)  
real(8),public,allocatable::SK0(:,:)!SK0(3,NTK)  
integer,public,allocatable::numirr(:)!numirr(NTK) 
integer,public,allocatable::numrot(:)!numrot(NTK) 
integer,public,allocatable::trs(:)!trs(NTK) 
integer,public,allocatable::RW(:,:)!RW(3,NTK)
integer,public,allocatable::numMK(:)!numMK(Nk_irr)!20180316  
!eigenvalue(111) 
integer,public::NTB 
real(8),public,allocatable::E_EIGI(:,:)!E_EIGI(NTB,Nk_irr) 
!nkm(132)  
integer,public::NTG 
integer,public,allocatable::NGI(:)!NG0(Nk_irr)
!kg(104)
integer,public::L1,L2,L3 
integer,public,allocatable::KGI(:,:,:)!KGI(3,NTG,Nk_irr) 
integer,public,allocatable::KG0(:,:,:)!KG0(3,NTG,NTK)
integer,public,allocatable::NG0(:)!NG0(NTK)
integer,public,allocatable::packing(:,:,:,:)!packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr)
!fft 
integer,public::nwx2,nwy2,nwz2!,nfft1,nfft2,nfft3,Nl123 
!wfn(102)
integer,public::ncomp 
!complex(8),public,allocatable::CIR(:,:,:)!CIR(NTG,NTB,Nk_irr) 
complex(4),public,allocatable::CIR(:,:,:)!CIR(NTG,NTB,Nk_irr) 
complex(8),allocatable::CIRtmp(:)!CIRtmp(NTG)  
contains
subroutine rd_dat_symmetry 
implicit none 
integer::i,j,iop
OPEN(100,FILE='./dir-wfn/dat.symmetry') 
rewind(100) 
read(100,*)nsymq 
read(100,*)nnp 
allocate(rg(3,3,nsymq));rg=0
allocate(pg(3,nsymq));pg=0
allocate(rginv(3,3,nsymq));rginv=0.0d0 
do iop=1,nsymq
 read(100,*)((rg(i,j,iop),i=1,3),j=1,3) 
 read(100,*)(pg(i,iop),i=1,3)   
enddo 
close(100) 
!
rginv=rg 
do iop=1,nsymq
 call invmat(3,rginv(1,1,iop)) 
enddo 
!
do iop=1,nsymq
 write(6,*) iop
 do i=1,3
  write(6,'(3I5,1x,3F15.10)')(rg(i,j,iop),j=1,3),(rginv(i,j,iop),j=1,3)
 enddo 
enddo 
!
end subroutine
!
subroutine rd_dat_bandcalc 
implicit none 
OPEN(117,FILE='./dir-wfn/dat.bandcalc') 
rewind(117) 
read(117,*)Ecut_for_psi 
read(117,*)FermiEnergy  
read(117,*)Etot
!write(6,*)'Ecut_for_psi=',Ecut_for_psi 
!write(6,*)'FermiEnergy=',FermiEnergy  
!write(6,*)'Etot=',Etot
end subroutine
! 
subroutine rd_dat_lattice 
implicit none 
real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
OPEN(105,FILE='./dir-wfn/dat.lattice') 
REWIND(105)
READ(105,*) a1(1),a1(2),a1(3)!a1 vector
READ(105,*) a2(1),a2(2),a2(3)!a2 vector
READ(105,*) a3(1),a3(2),a3(3)!a3 vector
CLOSE(105)
!--
call OUTER_PRODUCT(a2(1),a3(1),b1(1))
VOLUME=a1(1)*b1(1)+a1(2)*b1(2)+a1(3)*b1(3)
b1(:)=b1(:)*tpi/VOLUME 
call OUTER_PRODUCT(a3(1),a1(1),b2(1))
b2(:)=b2(:)*tpi/VOLUME 
call OUTER_PRODUCT(a1(1),a2(1),b3(1))
b3(:)=b3(:)*tpi/VOLUME 
call est_latparam(a1(1),a2(1),a3(1),a,b,c,alp,bet,gmm) 
end subroutine
!--
subroutine rd_dat_sample_k 
implicit none 
integer::i,ik,jk,iop,iik   
real(8)::ktmp(3) 
integer::RWtmp(3) 
integer::initial_flg!20180316 
OPEN(101,FILE='./dir-wfn/dat.sample-k') 
rewind(101) 
read(101,*)Nk_irr 
allocate(SKI(3,Nk_irr));SKI(:,:)=0.0D0 
do ik=1,Nk_irr 
 read(101,*)(SKI(i,ik),i=1,3) 
enddo 
close(101) 
!--
call est_NTK(Nk_irr,nsymq,SKI(1,1),rg(1,1,1),NTK)
write(6,*)'Estimated NTK=',NTK 
!--
!SK0,numirr,numrot,trs,RW
allocate(SK0(3,NTK));SK0(:,:)=0.0d0
allocate(numirr(NTK));numirr(:)=0
allocate(numrot(NTK));numrot(:)=0
allocate(trs(NTK));trs(:)=0
allocate(RW(3,NTK));RW(:,:)=0
allocate(numMK(Nk_irr));numMK=0!20180316 
jk=0
do ik=1,Nk_irr
 initial_flg=0!20180316 
 do iop=1,nsymq
!sym
  ktmp(:)=0.0d0; RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)
  call kcheck(ktmp(1),RWtmp(1))!rewind check 
  do iik=1,jk
   if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and.abs(SK0(2,iik)-ktmp(2))<1.0d-4.and.abs(SK0(3,iik)-ktmp(3))<1.0d-4) goto 1000
  enddo!iik
  jk=jk+1
  SK0(:,jk)=ktmp(:)
  numirr(jk)=ik
  numrot(jk)=iop
  trs(jk)=1
  RW(:,jk)=RWtmp(:)
  !
  !20180316
  !
  if(initial_flg.eq.0)then
   numMK(ik)=jk
   initial_flg=1 
  endif 
  !
!time-reversal
1000 ktmp(:)=0.0d0;RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)
  call kcheck_trs(ktmp(1),RWtmp(1))!rewind check modified 20170316  
  do iik=1,jk
   if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and.abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and.abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4) goto 2000
  enddo!iik
  jk=jk+1
  SK0(:,jk)=-ktmp(:) 
  numirr(jk)=ik
  numrot(jk)=iop
  trs(jk)=-1
  RW(:,jk)=RWtmp(:) 
2000 enddo!iop  
enddo!ik
call est_nkbi(NTK,SK0(1,1),nkb1,nkb2,nkb3)  
Na1=nkb1/2; Na2=nkb2/2; Na3=nkb3/2
!--
if(NTK/=jk) then 
 write(6,*)'ERROR;STOP;NTK should be jk'   
 write(6,*)'NTK=',NTK,'jk=',jk;STOP
endif 
end subroutine
!--
subroutine rd_dat_nkm 
implicit none 
integer::ik 
OPEN(132,FILE='./dir-wfn/dat.nkm') 
allocate(NGI(Nk_irr));NGI(:)=0
rewind(132)
do ik=1,Nk_irr 
 read(132,*)NGI(ik) 
enddo 
close(132) 
NTG=maxval(abs(NGI(:))) 
end subroutine
!--
subroutine rd_dat_kg 
implicit none 
integer::i,ig,ik,jk,iop,i1,j1,k1
integer::algn235
real(8)::ktmp(3)
real(8)::tmp,d1,d2,d3,qwf   
real(8)::h1(3),h2(3),h3(3)   
integer::NG_for_psi 
integer,allocatable::KGtmp(:,:)!KGtmp(3,NTG) 
real(8),allocatable::LKGI(:,:)!LKGI(NTG,Nk_irr) 
!
OPEN(104,FILE='./dir-wfn/dat.kg') 
rewind(104) 
allocate(KGI(3,NTG,Nk_irr));KGI(:,:,:)=0 
do ik=1,Nk_irr 
 read(104,*)NG_for_psi 
 !NGI(ik)=NG_for_psi 
 do ig=1,NGI(ik)!NG_for_psi 
  read(104,*)(KGI(i,ig,ik),i=1,3) 
 enddo 
enddo  
close(104)
!--
allocate(LKGI(NTG,Nk_irr));LKGI=0.0d0 
do ik=1,Nk_irr 
 do ig=1,NGI(ik) 
  ktmp(1)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(1)+(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(1)+(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(1) 
  ktmp(2)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(2)+(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(2)+(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(2) 
  ktmp(3)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(3)+(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(3)+(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(3) 
  LKGI(ig,ik)=ktmp(1)**2+ktmp(2)**2+ktmp(3)**2
 enddo!ig 
 !write(6,*)maxval(LKGI(:,ik))
enddo!ik 
!write(6,*) 
!write(6,*)maxval(LKGI(:,:))
Ecut_for_psi=maxval(LKGI(:,:))+1.0d-8
deallocate(LKGI) 
!--
L1=maxval(abs(KGI(1,:,:)))+1;write(6,*)'L1=',L1 
L2=maxval(abs(KGI(2,:,:)))+1;write(6,*)'L2=',L2 
L3=maxval(abs(KGI(3,:,:)))+1;write(6,*)'L3=',L3 
allocate(packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr)); packing(:,:,:,:)=0 
do ik=1,Nk_irr 
 do ig=1,NGI(ik) 
  i1=KGI(1,ig,ik);j1=KGI(2,ig,ik);k1=KGI(3,ig,ik) 
  packing(i1,j1,k1,ik)=ig 
 enddo 
enddo 
!--
!fft grid
tmp=dsqrt(dot_product(a1,a1))
h1(:)=a1(:)/tmp 
tmp=dsqrt(dot_product(a2,a2))
h2(:)=a2(:)/tmp 
tmp=dsqrt(dot_product(a3,a3)) 
h3(:)=a3(:)/tmp 
d1=abs(dot_product(b1,h1)) 
d2=abs(dot_product(b2,h2)) 
d3=abs(dot_product(b3,h3)) 
!write(6,*)'d1=',d1
!write(6,*)'d2=',d2
!write(6,*)'d3=',d3 
qwf=2.0d0*dsqrt(Ecut_for_psi) 
!nwx2=algn235(int(qwf/d1)+1,1)!error 
!nwy2=algn235(int(qwf/d2)+1,1)!error
!nwz2=algn235(int(qwf/d3)+1,1)!error
nwx2=algn235(int(qwf/d1)+1) 
nwy2=algn235(int(qwf/d2)+1) 
nwz2=algn235(int(qwf/d3)+1) 
!nfft1=nwx2+1
!nfft2=nwy2+1
!nfft3=nwz2+1
!Nl123=nfft1*nfft2*nfft3 
!--
!NG0,KG0 
allocate(NG0(NTK));NG0(:)=0
allocate(KG0(3,NTG,NTK));KG0(:,:,:)=0 
allocate(KGtmp(3,NTG));KGtmp(:,:)=0 
!---
do jk=1,NTK 
 if(trs(jk)==1) then 
  ik=numirr(jk)
  iop=numrot(jk) 
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)+dble(RW(1,jk)) 
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)+dble(RW(2,jk))  
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)+dble(RW(3,jk))  
!--
!20170316 KG0s are generated by original KGI
!  NG0(jk)=NGI(ik) 
!  do ig=1,NG0(jk)  
!   i1=rg(1,1,iop)*KGI(1,ig,ik)+rg(1,2,iop)*KGI(2,ig,ik)+rg(1,3,iop)*KGI(3,ig,ik)-RW(1,jk) 
!   i2=rg(2,1,iop)*KGI(1,ig,ik)+rg(2,2,iop)*KGI(2,ig,ik)+rg(2,3,iop)*KGI(3,ig,ik)-RW(2,jk) 
!   i3=rg(3,1,iop)*KGI(1,ig,ik)+rg(3,2,iop)*KGI(2,ig,ik)+rg(3,3,iop)*KGI(3,ig,ik)-RW(3,jk) 
!   KG0(1,ig,jk)=i1 
!   KG0(2,ig,jk)=i2 
!   KG0(3,ig,jk)=i3 
!   phase=tpi*(dble(i1)*dble(pg(1,iop))+dble(i2)*dble(pg(2,iop))+dble(i3)*dble(pg(3,iop))) 
!   pf=exp(-ci*phase/dble(nnp)) 
!   C0(ig,:,jk)=CIR(ig,:,ik)*pf 
!  enddo!ig  
! write(6,'(i5,3f15.10,i5)') jk,ktmp(:),trs(jk)  
!--
  call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,ktmp(1),ktmp(2),ktmp(3),KG0(1,1,jk),NG_for_psi)
  if(NG_for_psi/=NGI(ik)) then 
   write(6,*)'ERROR; STOP; NG_for_psi should be NGI(ik)'   
   write(6,*)'NG_for_psi=',NG_for_psi,'NG0(ik)=',NGI(ik)
   write(6,*)'ik,jk',ik,jk;STOP
  endif 
  NG0(jk)=NG_for_psi  
!--
 elseif(trs(jk)==-1)then  
  ik=numirr(jk);iop=numrot(jk) 
  ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)+rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
  ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)+rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
  ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)+rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
  KGtmp(:,:)=0 
  call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,ktmp(1),ktmp(2),ktmp(3),KGtmp(1,1),NG_for_psi)
  if(NG_for_psi/=NGI(ik))then 
   write(6,*)'ERROR; STOP; NG_for_psi should be NGI(ik)'   
   write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
  endif 
  NG0(jk)=NG_for_psi  
  KG0(:,:,jk)=-KGtmp(:,:)!notice on '-' sign 
 endif 
enddo!jk 
deallocate(KGtmp) 
end subroutine
!--
subroutine rd_dat_eigenvalue 
implicit none 
integer::ik,ib 
OPEN(111,FILE='./dir-wfn/dat.eigenvalue') 
rewind(111)
read(111,*)NTB 
allocate(E_EIGI(NTB,Nk_irr));E_EIGI=0.0d0
do ik=1,Nk_irr 
 do ib=1,NTB  
  read(111,*)E_EIGI(ib,ik)
 enddo!ib
enddo!ik          
end subroutine
!--
subroutine rd_dat_wavefunction 
implicit none 
integer::ik,ib,ig 
OPEN(102,FILE='./dir-wfn/dat.wfn',FORM='unformatted') 
rewind(102)
read(102)ncomp 
if(ncomp/=1)then 
 write(6,*)'This program not suport ncomp/=1; then stop'
 stop
endif 
allocate(CIR(NTG,NTB,Nk_irr));CIR=0.0d0  
do ik=1,Nk_irr 
 do ib=1,NTB 
  !
  !20180922 
  !
  !read(102)(CIR(ig,ib,ik),ig=1,NGI(ik))
  !
  allocate(CIRtmp(NTG));CIRtmp=0.0d0  
  read(102)(CIRtmp(ig),ig=1,NGI(ik))
  CIR(:,ib,ik)=CIRtmp(:) 
  deallocate(CIRtmp) 
  !
  !
 enddo!ib 
enddo!ik          
close(102) 
end subroutine
!--
end module 

module m_rd_dat_eps 
use m_rd_dat_wfn
implicit none
public::rd_dat_chi_cutoff
public::rd_dat_ttrhdrn 
public::rd_dat_wgrid 
public::rd_dat_sq 
public::rd_dat_eps 
!chi_cutoff(300)  
real(8),public::Ecut_for_eps
!ttrhdrn(302)  
real(8),public::idlt!Green's function delt (au)!ttrhdrn
real(8),public::dmna!dmna (au)!ttrhdrn
real(8),public::dmnr!dmnr (au)!ttrhdrn
!wgrid(135)  
integer,public::Num_freq_grid
integer,public::ne 
complex(8),public,allocatable::em(:)!em(ne)
complex(8),allocatable::pole_of_chi(:)!pole_of_chi(ne)  
complex(8),allocatable::mat_b(:,:)!mat_b(ne,ne) 
!sq(301)  
integer,public::Nq_irr!TOTAL NUMBER OF irreducible q POINTS 
integer,public::NTQ!TOTAL NUMBER OF Q POINTS IN MK MESHES 
integer,public::NTGQ!TOTAL NUMBER OF G VECTORS FOR EPSILON
integer,public::Lq1,Lq2,Lq3  
real(8),public,allocatable::SQI(:,:)!SQI(3,Nq_irr) 
real(8),public,allocatable::SQ(:,:)!SQ(3,NTQ)  
integer,public,allocatable::numirrq(:)!numirrq(NTQ)  
integer,public,allocatable::numrotq(:)!numrotq(NTQ)  
integer,public,allocatable::trsq(:)!trsq(NTQ)  
integer,public,allocatable::RWq(:,:)!RWq(3,NTQ)
integer,public,allocatable::LG0(:,:,:)!LG0(3,NTG,NTQ)    
integer,public,allocatable::NGQ_eps(:)!NGQ_eps(NTQ)
integer,public,allocatable::NGQ_psi(:)!NGQ_psi(NTQ)  
integer,public,allocatable::packingq(:,:,:,:)!packingq(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3,Nq_irr) 
!epsqw(600-) 
!complex(8),public,allocatable::epstmp(:,:,:)!epstmp(NTGQ,NTGQ,ne)
!complex(8),public,allocatable::epstmpgm(:,:,:,:)!epstmpgm(NTGQ,NTGQ,ne,3)
complex(4),public,allocatable::epsirr(:,:,:,:)!epsirr(NTGQ,NTGQ,ne,Nq_irr) 
contains
!--
subroutine rd_dat_chi_cutoff
implicit none 
OPEN(300,FILE='./dir-eps/dat.chi_cutoff')
read(300,*) Ecut_for_eps
end subroutine
!--
!20180423 
!--
subroutine rd_dat_ttrhdrn
implicit none 
OPEN(302,FILE='./dir-eps/dat.ttrhdrn')
read(302,*) idlt!ttrhdrn Green's function delt (au)
read(302,*) dmna!(au) 
read(302,*) dmnr!(au) 
end subroutine
!--
subroutine rd_dat_wgrid 
implicit none 
integer::ie,je,ke 
real(8)::x,y
complex(8),allocatable::emp(:)!emp(ne+1)
complex(8),allocatable::mat_c(:,:)!mat_c(ne,ne) 
complex(8)::sum_cmpx 
!
OPEN(135,FILE='./dir-eps/dat.wgrid') 
rewind(135) 
read(135,*) Num_freq_grid
ne=Num_freq_grid
allocate(em(ne)); em(:)=0.0d0 
do ie=1,ne 
 read(135,'(2f15.10)') em(ie)
enddo 
!
allocate(emp(ne+1));emp(:)=0.0d0 
do ie=1,ne
 emp(ie)=em(ie)
enddo
emp(ne+1)=em(ne)+1.3d0*(em(ne)-em(ne-1)) 
!
!pole of chi
!
allocate(pole_of_chi(ne)); pole_of_chi(:)=0.0d0 
do ie=1,ne 
 x=dble((emp(ie+1)+emp(ie))/2.0d0) 
 y=-dble(1.5d0*(emp(ie+1)-emp(ie))) 
 pole_of_chi(ie)=cmplx(x,y) 
enddo 
!
!mat_b
!
allocate(mat_b(ne,ne)); mat_b=0.0d0 
do ie=1,ne
 do je=1,ne 
  mat_b(ie,je)=1.0d0/(em(ie)-pole_of_chi(je))-1.0d0/(em(ie)+pole_of_chi(je)) 
 enddo 
enddo 
!
!check: mat_b * mat_c = 1
!
allocate(mat_c(ne,ne)); mat_c=0.0d0 
mat_c(:,:)=mat_b(:,:)
!
call invmat_complex(ne,mat_b) 
!
do ie=1,ne
 do je=1,ne
  sum_cmpx=0.0d0
  do ke=1,ne
   sum_cmpx=sum_cmpx+mat_b(ie,ke)*mat_c(ke,je)
  enddo 
  !write(6,'(2I5,2F15.10)') ie,je,sum_cmpx 
 enddo 
enddo 
end subroutine
!--
subroutine rd_dat_sq 
implicit none 
integer::iq,i,iik,ierr,chdir,jk,iop,iqir,NG_for_eps,NG_for_psi,ig,i1,j1,k1  
character(99)::dirname 
logical::file_e 
real(8)::q1,q2,q3,ktmp(3)  
integer::RWtmp(3) 
integer,allocatable::KGtmp(:,:)!KGtmp(3,NTG)
!
Nq_irr=Nk_irr 
allocate(SQI(3,Nq_irr));SQI(:,:)=0.0D0 
ierr=CHDIR("./dir-eps") 
do iq=1,Nq_irr 
 write(dirname,"('q',i3.3)")iq 
 ierr=CHDIR(dirname) 
 inquire(file='dat.log.400',exist=file_e) 
 if(file_e)then 
  write(6,*)'dat.log.400 exists in ',trim(dirname) 
 else
  write(6,*)'error: no dat.log.400 in ',trim(dirname) 
 endif 
 OPEN(301,FILE='dat.sq') 
 rewind(301)
 inquire(file='dat.sq',exist=file_e) 
 if(file_e)then 
  read(301,*)(SQI(i,iq),i=1,3) 
 else
  write(6,*)'error: no dat.sq in',trim(dirname) 
 endif 
 close(301) 
 ierr=CHDIR("..") 
enddo!iq 
ierr=CHDIR("..") 
!call system('pwd') 
!--
!gen(SQ,numirrq,numrotq,trsq,RWq) 
NTQ=NTK
allocate(SQ(3,NTQ));SQ(:,:)=0.0d0 
allocate(numirrq(NTQ));numirrq(:)=0 
allocate(numrotq(NTQ));numrotq(:)=0 
allocate(trsq(NTQ));trsq(:)=0
allocate(RWq(3,NTQ));RWq(:,:)=0      
!
do iq=1,Nq_irr 
 SQ(:,iq)=SQI(:,iq) 
 numirrq(iq)=iq
 numrotq(iq)=1
 trsq(iq)=1
 RWq(1:3,iq)=0
enddo 
jk=Nq_irr 
do iq=1,Nq_irr
 do iop=1,Nsymq
  !sym
  ktmp(:)=0.0d0;RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SQI(1,iq)+dble(rg(1,2,iop))*SQI(2,iq)+dble(rg(1,3,iop))*SQI(3,iq)
  ktmp(2)=dble(rg(2,1,iop))*SQI(1,iq)+dble(rg(2,2,iop))*SQI(2,iq)+dble(rg(2,3,iop))*SQI(3,iq)
  ktmp(3)=dble(rg(3,1,iop))*SQI(1,iq)+dble(rg(3,2,iop))*SQI(2,iq)+dble(rg(3,3,iop))*SQI(3,iq)
  !
  call kcheck(ktmp(1),RWtmp(1))!rewind check 
  !
  do iik=1,jk 
   if(abs(SQ(1,iik)-ktmp(1))<1.0d-4.and.abs(SQ(2,iik)-ktmp(2))<1.0d-4.and.abs(SQ(3,iik)-ktmp(3))<1.0d-4) goto 1100
  enddo!iik
  jk=jk+1
  SQ(:,jk)=ktmp(:)
  numirrq(jk)=iq
  numrotq(jk)=iop
  trsq(jk)=1
  RWq(:,jk)=RWtmp(:)
!time-reversal
1100 ktmp(:)=0.0d0;RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SQI(1,iq)+dble(rg(1,2,iop))*SQI(2,iq)+dble(rg(1,3,iop))*SQI(3,iq)
  ktmp(2)=dble(rg(2,1,iop))*SQI(1,iq)+dble(rg(2,2,iop))*SQI(2,iq)+dble(rg(2,3,iop))*SQI(3,iq) 
  ktmp(3)=dble(rg(3,1,iop))*SQI(1,iq)+dble(rg(3,2,iop))*SQI(2,iq)+dble(rg(3,3,iop))*SQI(3,iq) 
  !
  call kcheck_trs(ktmp(1),RWtmp(1))!rewind check 20170321 
  !
  do iik=1,jk
   if(abs(SQ(1,iik)-(-ktmp(1)))<1.0d-4.and.abs(SQ(2,iik)-(-ktmp(2)))<1.0d-4.and.abs(SQ(3,iik)-(-ktmp(3)))<1.0d-4) goto 2100
  enddo!iik
  jk=jk+1
  SQ(:,jk)=-ktmp(:)
  numirrq(jk)=iq
  numrotq(jk)=iop
  trsq(jk)=-1
  RWq(:,jk)=RWtmp(:)
2100 enddo!iop 
enddo!iq  
!--
if(NTQ/=jk)then 
 write(6,*)'ERROR;STOP;NTQ should be jk'   
 write(6,*)'NTQ=',NTQ,'jk=',jk
 stop 
endif 
!--
!gen(NGQ_eps,NGQ_psi,LG0)
allocate(KGtmp(3,NTG));KGtmp(:,:)=0 
allocate(LG0(3,NTG,NTQ));LG0(:,:,:)=0
allocate(NGQ_eps(NTQ));NGQ_eps(:)=0
allocate(NGQ_psi(NTQ));NGQ_psi(:)=0
!
do iq=1,Nq_irr 
 q1=SQI(1,iq); q2=SQI(2,iq); q3=SQI(3,iq)
 call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,Ecut_for_psi,q1,q2,q3,LG0(1,1,iq),NG_for_eps,NG_for_psi) 
 NGQ_eps(iq)=NG_for_eps
 NGQ_psi(iq)=NG_for_psi  
 write(6,'(i8,3f10.5,a8,i8,a8,i10)') iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
enddo 
do iq=Nq_irr+1,NTQ 
 if(trsq(iq)==1)then 
  iqir=numirrq(iq)
  iop=numrotq(iq) 
  !
  !q1=dble(rg(1,1,iop))*SQI(1,iqir)+dble(rg(1,2,iop))*SQI(2,iqir)+dble(rg(1,3,iop))*SQI(3,iqir)+dble(RWq(1,iq)) 
  !q2=dble(rg(2,1,iop))*SQI(1,iqir)+dble(rg(2,2,iop))*SQI(2,iqir)+dble(rg(2,3,iop))*SQI(3,iqir)+dble(RWq(2,iq))  
  !q3=dble(rg(3,1,iop))*SQI(1,iqir)+dble(rg(3,2,iop))*SQI(2,iqir)+dble(rg(3,3,iop))*SQI(3,iqir)+dble(RWq(3,iq))  
  !
  q1=rg(1,1,iop)*SQI(1,iqir)+rg(1,2,iop)*SQI(2,iqir)+rg(1,3,iop)*SQI(3,iqir)+dble(RWq(1,iq)) 
  q2=rg(2,1,iop)*SQI(1,iqir)+rg(2,2,iop)*SQI(2,iqir)+rg(2,3,iop)*SQI(3,iqir)+dble(RWq(2,iq))  
  q3=rg(3,1,iop)*SQI(1,iqir)+rg(3,2,iop)*SQI(2,iqir)+rg(3,3,iop)*SQI(3,iqir)+dble(RWq(3,iq))  
  !
  call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,Ecut_for_psi,q1,q2,q3,LG0(1,1,iq),NG_for_eps,NG_for_psi) 
  NGQ_eps(iq)=NG_for_eps
  NGQ_psi(iq)=NG_for_psi  
  write(6,'(i8,3f10.5,a8,i8,a8,i10)') iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
 elseif(trsq(iq)==-1)then  
  iqir=numirrq(iq)
  iop=numrotq(iq) 
  !
  !q1=dble(rg(1,1,iop))*SQI(1,iqir)+dble(rg(1,2,iop))*SQI(2,iqir)+dble(rg(1,3,iop))*SQI(3,iqir)+dble(RWq(1,iq)) 
  !q2=dble(rg(2,1,iop))*SQI(1,iqir)+dble(rg(2,2,iop))*SQI(2,iqir)+dble(rg(2,3,iop))*SQI(3,iqir)+dble(RWq(2,iq))  
  !q3=dble(rg(3,1,iop))*SQI(1,iqir)+dble(rg(3,2,iop))*SQI(2,iqir)+dble(rg(3,3,iop))*SQI(3,iqir)+dble(RWq(3,iq))  
  !
  q1=rg(1,1,iop)*SQI(1,iqir)+rg(1,2,iop)*SQI(2,iqir)+rg(1,3,iop)*SQI(3,iqir)+dble(RWq(1,iq)) 
  q2=rg(2,1,iop)*SQI(1,iqir)+rg(2,2,iop)*SQI(2,iqir)+rg(2,3,iop)*SQI(3,iqir)+dble(RWq(2,iq))  
  q3=rg(3,1,iop)*SQI(1,iqir)+rg(3,2,iop)*SQI(2,iqir)+rg(3,3,iop)*SQI(3,iqir)+dble(RWq(3,iq))  
  !
  KGtmp(:,:)=0 
  call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,Ecut_for_psi,q1,q2,q3,KGtmp(1,1),NG_for_eps,NG_for_psi) 
  NGQ_eps(iq)=NG_for_eps 
  NGQ_psi(iq)=NG_for_psi  
  write(6,'(i8,3f10.5,a8,i8,a8,i10)') iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
  LG0(:,:,iq)=-KGtmp(:,:) 
 endif 
enddo 
!--
Lq1=maxval(abs(LG0(1,:,:)))+1
Lq2=maxval(abs(LG0(2,:,:)))+1
Lq3=maxval(abs(LG0(3,:,:)))+1
allocate(packingq(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3,Nq_irr));packingq(:,:,:,:)=0 
do iq=1,Nq_irr 
 do ig=1,NGQ_eps(iq) 
  i1=LG0(1,ig,iq)
  j1=LG0(2,ig,iq)
  k1=LG0(3,ig,iq) 
  packingq(i1,j1,k1,iq)=ig 
  !write(6,'(a,5i10)')'iq,ig,i1,j1,k1',iq,ig,i1,j1,k1
 enddo 
enddo 
!-- 
NTGQ=maxval(NGQ_eps(:))
write(6,*)'Lq1=',Lq1 
write(6,*)'Lq2=',Lq2 
write(6,*)'Lq3=',Lq3 
write(6,*)'NTGQ=',NTGQ  
!--
do iq=1,NTQ 
 write(6,'(i5,3f15.10,6i5)')iq,(SQ(i1,iq),i1=1,3),numirrq(iq),numrotq(iq),trsq(iq),(RWq(j1,iq),j1=1,3) 
enddo  
!--
end subroutine
!--
subroutine rd_dat_eps 
implicit none 
integer::ierr,chdir,iq,iqgm,ix,file_num,NG_for_eps,ig,jg,ie
character(99)::filename,dirname 
complex(8),allocatable::epstmp(:,:,:)!epstmp(NTGQ,NTGQ,ne)
complex(8),allocatable::epstmpgm(:,:,:,:)!epstmpgm(NTGQ,NTGQ,ne,3)
!--
!OPEN(600-,R,FILE='dat.epsqw',FORM='unformatted') 
allocate(epstmp(NTGQ,NTGQ,ne));epstmp(:,:,:)=0.0d0!real8
allocate(epstmpgm(NTGQ,NTGQ,ne,3));epstmpgm(:,:,:,:)=0.0d0!real8
allocate(epsirr(NTGQ,NTGQ,ne,Nq_irr));epsirr(:,:,:,:)=0.0d0!real4 
!
ierr=CHDIR("./dir-eps") 
call system('pwd') 
do iq=1,Nq_irr 
 if(abs(SKI(1,iq))<1.0d-5.and.abs(SKI(2,iq))<1.0d-5.and.abs(SKI(3,iq))<1.0d-5)then 
  write(dirname,"('q',i3.3)")iq
  iqgm=iq 
  ierr=CHDIR(dirname) 
  do ix=1,3 
   file_num=600+(ix-1)  
   write(filename,'("dat.epsqw.",i3.3)')file_num 
   open(file_num,file=filename,form='unformatted') 
   write(6,'(a10,a15,a5,a10)')'read: ',trim(filename),'in ',trim(dirname)  
   rewind(file_num) 
   NG_for_eps=NGQ_eps(iq)
   read(file_num)(((epstmpgm(ig,jg,ie,ix),ig=1,NG_for_eps),jg=1,NG_for_eps),ie=1,ne)
  enddo!ix 
  !epsirr: real4
  !epstmp: real8 
  epsirr(:,:,:,iq)=(epstmpgm(:,:,:,1)+epstmpgm(:,:,:,2)+epstmpgm(:,:,:,3))/3.0d0
 else
  write(dirname,"('q',i3.3)")iq
  ierr=CHDIR(dirname) 
  file_num=600 
  write(filename,'("dat.epsqw.",i3.3)')file_num 
  open(file_num,file=filename,form='unformatted') 
  write(6,'(a10,a15,a5,a10)')'read: ',trim(filename),'in ',trim(dirname)  
  rewind(file_num) 
  NG_for_eps=NGQ_eps(iq)
  read(file_num)(((epstmp(ig,jg,ie),ig=1,NG_for_eps),jg=1,NG_for_eps),ie=1,ne)
  !epsirr: real4 
  !epstmp: real8 
  epsirr(:,:,:,iq)=epstmp(:,:,:)
 endif!q=0 or not 
 ierr=CHDIR("..") 
enddo!iq   
ierr=CHDIR("..") 
call system('pwd') 
!
!do iq=1,Nq_irr 
! NG_for_eps=NGQ_eps(iq)
! write(6,*) NG_for_eps 
! do ig=1,NG_for_eps 
!  write(6,*) epsirr(ig,ig,100,iq) 
! enddo  
!enddo  
!
!do iq=1,Nq_irr 
! NG_for_eps=NGQ_eps(iq) 
! do ie=1,nen 
!  do igL=1,NG_for_eps 
!   epsirr(igL,igL,ie,iq)=epsirr(igL,igL,ie,iq)-1.0d0    
!  enddo 
! enddo 
!enddo 
!write(6,*) 'FINISH READING EPSILON'
!
end subroutine
!--
end module 

subroutine invmat(nm,mat)
implicit none 
integer,intent(in)::nm
real(8),intent(inout)::mat(nm,nm)
integer::ipiv(nm)
integer::Lwork 
real(8),allocatable::work(:)
integer::info 
Lwork=10*nm
allocate(work(Lwork))
info=0
call dgetrf(nm,nm,mat,nm,ipiv,info)
call dgetri(nm,mat,nm,ipiv,work,Lwork,info)
if(info/=0) then
write(6,*) 'info (subrouitine inv):',info
stop
endif 
deallocate(work)
return 
end subroutine

module m_rd_dat_wan
use m_rd_dat_wfn
implicit none
private 
public::rd_dat_ns_nb 
public::rd_dat_umat 
public::rd_dat_wan 
public::rd_dat_hmatr 
!ns-nb(149)  
integer,public::Mb,Mt  
integer,public,allocatable::Ns(:)!Ns(NTK) 
integer,public,allocatable::Nb(:)!Nb(NTK) 
integer,public,allocatable::Nt(:)!Nt(NTK) 
!umat(150)  
integer,public::NWF 
complex(8),public,allocatable::UNT(:,:,:)!UNT(Mb,NWF,NTK) 
!c0_wn(113)  
complex(8),public,allocatable::C0_WN(:,:,:)!C0_WN(NTG,NWF,NTK) 
!h_mat_r(122) 
complex(8),public,allocatable::H_MAT_R(:,:,:,:,:)!H_MAT_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
contains
subroutine rd_dat_ns_nb 
implicit none 
integer::ik 
!--
OPEN(149,FILE='./dir-wan/dat.ns-nb') 
rewind(149) 
allocate(Ns(NTK));Ns=0
allocate(Nb(NTK));Nb=0
allocate(Nt(NTK));Nt=0
do ik=1,NTK 
 read(149,*) Ns(ik),Nb(ik) 
enddo  
Mb=maxval(Nb) 
!write(6,*)'Mb=',Mb 
Nt(:)=0
do ik=1,NTK 
 Nt(ik)=Ns(ik)+Nb(ik) 
enddo 
Mt=maxval(Nt) 
!write(6,*) 'Mt=',Mt 
!---
end subroutine
!--
subroutine rd_dat_umat  
implicit none 
integer::ik,jb,jw
OPEN(150,FILE='./dir-wan/dat.umat') 
rewind(150) 
read(150,*) NWF 
allocate(UNT(Mb,NWF,NTK));UNT(:,:,:)=0.0d0 
do ik=1,NTK
 do jb=1,Nb(ik)
  read(150,*)(UNT(jb,jw,ik),jw=1,NWF) 
 enddo 
enddo 
!write(6,*)'NWF=',NWF 
end subroutine
!--
subroutine rd_dat_wan 
implicit none
integer::ik,iw,ig,nwftmp 
OPEN(113,FILE='./dir-wan/dat.wan',FORM='unformatted') 
REWIND(113)       
read(113) nwftmp 
if(nwftmp/=NWF)then
 write(6,*)'ERROR; STOP; nwftmp should be NWF'   
 write(6,*)'nwftmp=',nwftmp,'NWF=',NWF;STOP
endif 
allocate(C0_WN(NTG,NWF,NTK));C0_WN(:,:,:)=0.0D0 
do ik=1,NTK
 read(113)((C0_WN(ig,iw,ik),ig=1,NG0(ik)),iw=1,NWF)           
 !
 !20180519 
 !do iw=1,NWF
 ! read(113)(C0_WN(ig,iw,ik),ig=1,NG0(ik))
 !enddo!iw
 !
enddo!ik 
CLOSE(113)  
!write(6,*)'FINISH REDING C0_WN'
!--
!do ik=1,Nk_irr 
! do iw=1,NWF
!  do jw=1,NWF 
!   SUM_CMPX=0.0d0 
!   do ig=1,NG0(ik) 
!    SUM_CMPX=SUM_CMPX+CONJG(C0_WN(ig,iw,ik))*C0_WN(ig,jw,ik) 
!   enddo 
!   write(6,'(3i5,x,2f15.10)') ik,iw,jw,SUM_CMPX 
!  enddo 
! enddo 
!enddo 
end subroutine
!--
subroutine rd_dat_hmatr 
implicit none
character(99)::header1,header2,header3 
integer::ia1,ia2,ia3,idum1,idum2,idum3,ib,jb 
real(8),parameter::au=27.21151d0
OPEN(122,FILE='./dir-wan/dat.h_mat_r') 
allocate(H_MAT_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3));H_MAT_R(:,:,:,:,:)=0.0d0  
REWIND(122)
read(122,'(a)') header1 
read(122,'(a)') header2 
read(122,'(a)') header3 
do ia1=-Na1,Na1!-1
 do ia2=-Na2,Na2!-1
  do ia3=-Na3,Na3!-1
   read(122,*) idum1,idum2,idum3 
   do ib=1,NWF 
    do jb=1,NWF 
     read(122,'(i5,i5,2f20.10)') idum1,idum2,H_MAT_R(ib,jb,ia1,ia2,ia3) 
    enddo!jb 
   enddo!ib 
   read(122,*) 
  enddo 
 enddo 
enddo 
CLOSE(122) 
H_MAT_R=H_MAT_R/au 
end subroutine
!--
end module 

      subroutine search_kq(NTK,SK0,q1,q2,q3,ik,ikq,shift_G)
      implicit none 
      integer::NTK
      real(8)::SK0(3,NTK)  
      real(8)::q1,q2,q3
      integer::ik
      integer::jk
      real(8)::SKQ(3)
      integer::ikq,shift_G(3)
      real(8),parameter::dlt_BZ=1.0d-6!20170322  
!--
      SKQ(1)=SK0(1,ik)+q1
      SKQ(2)=SK0(2,ik)+q2 
      SKQ(3)=SK0(3,ik)+q3 
!--
!     if(SKQ(1)<-0.5D0)then 
!      SKQ(1)=SKQ(1)+1.0D0 
!      shift_G(1)=-1
!      endif 
!      if(SKQ(2)<-0.5D0)then 
!      SKQ(2)=SKQ(2)+1.0D0 
!      shift_G(2)=-1
!      endif 
!      if(SKQ(3)<-0.5D0)then 
!      SKQ(3)=SKQ(3)+1.0D0 
!      shift_G(3)=-1
!      endif 
!      if(SKQ(1)>0.5D0)then 
!      SKQ(1)=SKQ(1)-1.0D0 
!      shift_G(1)=+1
!      endif 
!      if(SKQ(2)>0.5D0)then 
!      SKQ(2)=SKQ(2)-1.0D0 
!      shift_G(2)=+1
!      endif 
!      if(SKQ(3)>0.5D0)then 
!      SKQ(3)=SKQ(3)-1.0D0 
!      shift_G(3)=+1
!      endif 
!--
      if(SKQ(1)>1.50d0+dlt_BZ)then 
       SKQ(1)=SKQ(1)-2.0D0 
       shift_G(1)=+2 
      endif 
      if(SKQ(1)>0.5D0+dlt_BZ)then 
       SKQ(1)=SKQ(1)-1.0D0 
       shift_G(1)=+1
      endif 
      if(SKQ(1)<=-1.5D0+dlt_BZ)then 
       SKQ(1)=SKQ(1)+2.0D0 
       shift_G(1)=-2 
      endif 
      if(SKQ(1)<=-0.5D0+dlt_BZ)then 
       SKQ(1)=SKQ(1)+1.0D0 
       shift_G(1)=-1
      endif 
!--
      if(SKQ(2)>1.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)-2.0D0 
       shift_G(2)=+2 
      endif 
      if(SKQ(2)>0.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)-1.0D0 
       shift_G(2)=+1
      endif 
      if(SKQ(2)<=-1.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)+2.0D0 
       shift_G(2)=-2 
      endif 
      if(SKQ(2)<=-0.5D0+dlt_BZ)then 
       SKQ(2)=SKQ(2)+1.0D0 
       shift_G(2)=-1
      endif 
!--
      if(SKQ(3)>1.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)-2.0D0 
       shift_G(3)=+2 
      endif 
      if(SKQ(3)>0.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)-1.0D0 
       shift_G(3)=+1
      endif 
      if(SKQ(3)<=-1.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)+2.0D0 
       shift_G(3)=-2 
      endif 
      if(SKQ(3)<=-0.5D0+dlt_BZ)then 
       SKQ(3)=SKQ(3)+1.0D0 
       shift_G(3)=-1
      endif 
!--
      do jk=1,NTK
       if(ABS(SK0(1,jk)-SKQ(1))<1.D-6.and.
     +    ABS(SK0(2,jk)-SKQ(2))<1.D-6.and. 
     +    ABS(SK0(3,jk)-SKQ(3))<1.D-6)then 
        ikq=jk 
       endif 
      enddo 
      RETURN  
      END 
!--
      subroutine calc_InterStateMatrix(NTK,NTG,NG0,KG0,C0_K,C0_KQ,
     +                                 ik,ikq,nwx2,nwy2,nwz2,
     +                                 nfft1,nfft2,Nl123,
     +                                 wfunc,fftwk,fs,LG0,NG_for_eps,
     +                                 shift_G,m_tmp)
      use fft_3d 
      implicit none 
      type(fft3_struct)::fs 
      integer::NTK,NTG 
      integer::NG0(NTK),KG0(3,NTG,NTK) 
      complex(8)::C0_K(NTG),C0_KQ(NTG) 
      integer::ik,ikq 
      integer::nwx2,nwy2,nwz2,nfft1,nfft2,Nl123 
      real(8)::wfunc(Nl123*2),fftwk(Nl123*2) 
      integer::NG_for_eps 
      integer::LG0(3,NTG) 
      integer::shift_G(3)
      integer::ig,igb1,igb2,igb3,ind,igL,igL1,igL2,igL3  
      integer::ir,ir1,ir2,ir3
      real(8)::dG1,dG2,dG3,phase 
      complex(8),allocatable::cell_periodic_k(:)
      complex(8),allocatable::cell_periodic_kq(:)
      complex(8)::f,pf
      complex(kind=8)::phx(nwx2),phy(nwy2),phz(nwz2)
      complex(kind=8)::m_tmp(NG_for_eps) 
      real(8),parameter::pi=dacos(-1.0d0)
      real(8),parameter::tpi=2.0d0*pi 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      allocate(cell_periodic_k(Nl123))
      allocate(cell_periodic_kq(Nl123))
      wfunc(:)=0.0D0
      fftwk(:)=0.0D0
      do ig=1,NG0(ik) 
      igb1=KG0(1,ig,ik) 
      igb2=KG0(2,ig,ik) 
      igb3=KG0(3,ig,ik) 
      igb1=MOD(nwx2+igb1,nwx2)+1
      igb2=MOD(nwy2+igb2,nwy2)+1
      igb3=MOD(nwz2+igb3,nwz2)+1
      ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
      wfunc(ind)=dble(C0_K(ig))
      wfunc(ind+Nl123)=dimag(C0_K(ig))
      enddo 
      call fft3_bw(fs,wfunc,fftwk) 
      do ir=1,Nl123 
      cell_periodic_k(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
      enddo 
!--
      wfunc(:)=0.0D0
      fftwk(:)=0.0D0
      do ig=1,NG0(ikq)
      igb1=KG0(1,ig,ikq)
      igb2=KG0(2,ig,ikq) 
      igb3=KG0(3,ig,ikq) 
      igb1=MOD(nwx2+igb1,nwx2)+1
      igb2=MOD(nwy2+igb2,nwy2)+1      
      igb3=MOD(nwz2+igb3,nwz2)+1 
      ind=igb1+(igb2-1)*nfft1+(igb3-1)*nfft1*nfft2 
      wfunc(ind)=dble(C0_KQ(ig))
      wfunc(ind+Nl123)=dimag(C0_KQ(ig)) 
      enddo 
      call fft3_bw(fs,wfunc,fftwk)    
      do ir=1,Nl123
      cell_periodic_kq(ir)=cmplx(wfunc(ir),wfunc(ir+Nl123)) 
      enddo 
!--
      dG1=dble(shift_G(1))
      dG2=dble(shift_G(2))
      dG3=dble(shift_G(3))
!YOSHIHIDE YOSHIMOTO 20080620 
      do ir1=1,nwx2
        phase = tpi*(dble(ir1-1)*dG1/dble(nwx2))
        phx(ir1) = exp(-ci*phase)
      end do
      do ir2=1,nwy2
        phase = tpi*(dble(ir2-1)*dG2/dble(nwy2))
        phy(ir2) = exp(-ci*phase)
      end do
      do ir3=1,nwz2
        phase = tpi*(dble(ir3-1)*dG3/dble(nwz2))
        phz(ir3) = exp(-ci*phase)
      end do
!--
      do ir3=1,nwz2
      do ir2=1,nwy2
      do ir1=1,nwx2
       ir=ir1+(ir2-1)*nfft1+(ir3-1)*nfft1*nfft2 
!YOSHIHIDE YOSHIMOTO 20080620 
         pf=phx(ir1)*phy(ir2)*phz(ir3)
         cell_periodic_kq(ir)
     + = cell_periodic_kq(ir) * pf 
      enddo 
      enddo 
      enddo 
!--
      wfunc(:)=0.0D0
      fftwk(:)=0.0D0
      do ir=1,Nl123 
      f=CONJG(cell_periodic_kq(ir))*cell_periodic_k(ir)
      wfunc(ir)=dble(f)
      wfunc(ir+Nl123)=dimag(f) 
      enddo 
      call fft3_fw(fs,wfunc,fftwk) 
      do igL=1,NG_for_eps
      igL1=-LG0(1,igL)
      igL2=-LG0(2,igL)
      igL3=-LG0(3,igL) 
      igL1=MOD(nwx2+igL1,nwx2)+1
      igL2=MOD(nwy2+igL2,nwy2)+1
      igL3=MOD(nwz2+igL3,nwz2)+1
      ind=igL1+(igL2-1)*nfft1+(igL3-1)*nfft1*nfft2
      m_tmp(igL)=cmplx(wfunc(ind),wfunc(ind+Nl123))
      enddo 
!--
      deallocate(cell_periodic_k)
      deallocate(cell_periodic_kq)
      RETURN  
      END 
!--
      subroutine make_eps(NTG,NTGQ,ne,itrs,NG,LGtmp,RWtmp,rginvtmp,
     + pgtmp,nnp,L1,L2,L3,packtmp,epsirr,epsmk) 
      implicit none 
      integer::NTG,NTGQ,itrs,NG,ne,L1,L2,L3,nnp 
      integer::LGtmp(3,NTG) 
      integer::RWtmp(3) 
      real(8)::rginvtmp(3,3) 
      integer::pgtmp(3) 
      integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
      complex(4)::epsirr(NTGQ,NTGQ,ne) 
      integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3,iig,jjg 
      real(8)::phase 
      complex(8)::pf1,pf2 
      complex(4)::epsmk(NTGQ,NTGQ,ne) 
      real(8),parameter::pi=dacos(-1.0d0)
      real(8),parameter::tpi=2.0d0*pi 
      complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
      epsmk(:,:,:)=0.0d0 
      select case(itrs) 
      case(1)!=== not time-reversal ===*      
      do ig=1,NG 
       i1=LGtmp(1,ig); j1=LGtmp(2,ig); k1=LGtmp(3,ig) 
       i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
       i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +   +int(rginvtmp(1,3))*k2 
       j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +   +int(rginvtmp(2,3))*k2 
       k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +   +int(rginvtmp(3,3))*k2 
       iig=packtmp(i3,j3,k3) 
       phase=tpi*(dble(i1)*dble(pgtmp(1))
     +           +dble(j1)*dble(pgtmp(2))
     +           +dble(k1)*dble(pgtmp(3))) 
       pf1=exp(-ci*phase/dble(nnp)) 
       do jg=1,NG 
        i1=LGtmp(1,jg); j1=LGtmp(2,jg); k1=LGtmp(3,jg) 
        i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
        i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +    +int(rginvtmp(1,3))*k2 
        j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +    +int(rginvtmp(2,3))*k2 
        k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +    +int(rginvtmp(3,3))*k2 
        jjg=packtmp(i3,j3,k3) 
        phase=tpi*(dble(i1)*dble(pgtmp(1))
     +            +dble(j1)*dble(pgtmp(2))
     +            +dble(k1)*dble(pgtmp(3))) 
        pf2=exp(ci*phase/dble(nnp)) 
!       write(6,'(a,x,2i5)') 'iig jjg',iig,jjg  
        epsmk(ig,jg,:)=epsirr(iig,jjg,:)*pf1*pf2 
       enddo!jg 
      enddo!ig 
      case(-1)!=== time-reversal ===*      
      do ig=1,NG 
       i1=-LGtmp(1,ig); j1=-LGtmp(2,ig); k1=-LGtmp(3,ig) 
       i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
       i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +   +int(rginvtmp(1,3))*k2 
       j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +   +int(rginvtmp(2,3))*k2 
       k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +   +int(rginvtmp(3,3))*k2 
       iig=packtmp(i3,j3,k3) 
       phase=tpi*(dble(i1)*dble(pgtmp(1))
     +           +dble(j1)*dble(pgtmp(2))
     +           +dble(k1)*dble(pgtmp(3))) 
       pf1=exp(-ci*phase/dble(nnp)) 
       do jg=1,NG 
        i1=-LGtmp(1,jg); j1=-LGtmp(2,jg); k1=-LGtmp(3,jg) 
        i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
        i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2 
     +    +int(rginvtmp(1,3))*k2 
        j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2 
     +    +int(rginvtmp(2,3))*k2 
        k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2 
     +    +int(rginvtmp(3,3))*k2 
        jjg=packtmp(i3,j3,k3) 
        phase=tpi*(dble(i1)*dble(pgtmp(1))
     +            +dble(j1)*dble(pgtmp(2))
     +            +dble(k1)*dble(pgtmp(3))) 
        pf2=exp(ci*phase/dble(nnp)) 
        epsmk(ig,jg,:)=epsirr(jjg,iig,:)*pf1*pf2 
       enddo!jg 
      enddo!ig 
      end select 
!     write(6,*)'finish make_eps'
!--
      return 
      end 
!--
      SUBROUTINE OUTER_PRODUCT(vec_x,vec_y,vec_z)
      implicit none 
      real(8)::vec_x(3),vec_y(3),vec_z(3) 
      vec_z(1)=vec_x(2)*vec_y(3)-vec_x(3)*vec_y(2)
      vec_z(2)=vec_x(3)*vec_y(1)-vec_x(1)*vec_y(3) 
      vec_z(3)=vec_x(1)*vec_y(2)-vec_x(2)*vec_y(1)
      RETURN
      END
!--
      subroutine search_q(SQI,SQ)
      implicit none 
      real(8)::SQI(3),SQ(3)
      real(8),parameter::dlt_BZ=1.0d-6!20170322  
      SQ=SQI 
      if(SQ(1)>  1.50d0+dlt_BZ) SQ(1)=SQ(1)-2.0d0 
      if(SQ(1)>  0.50d0+dlt_BZ) SQ(1)=SQ(1)-1.0d0 
      if(SQ(1)<=-1.50d0+dlt_BZ) SQ(1)=SQ(1)+2.0d0 
      if(SQ(1)<=-0.50d0+dlt_BZ) SQ(1)=SQ(1)+1.0d0 
      if(SQ(2)>  1.50d0+dlt_BZ) SQ(2)=SQ(2)-2.0d0 
      if(SQ(2)>  0.50d0+dlt_BZ) SQ(2)=SQ(2)-1.0d0 
      if(SQ(2)<=-1.50d0+dlt_BZ) SQ(2)=SQ(2)+2.0d0 
      if(SQ(2)<=-0.50d0+dlt_BZ) SQ(2)=SQ(2)+1.0d0 
      if(SQ(3)>  1.50d0+dlt_BZ) SQ(3)=SQ(3)-2.0d0 
      if(SQ(3)>  0.50d0+dlt_BZ) SQ(3)=SQ(3)-1.0d0 
      if(SQ(3)<=-1.50d0+dlt_BZ) SQ(3)=SQ(3)+2.0d0 
      if(SQ(3)<=-0.50d0+dlt_BZ) SQ(3)=SQ(3)+1.0d0 
      RETURN  
      END 
!--
      subroutine kcheck(ktmp,RWtmp) 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      real(8),parameter::dlt_BZ=1.0d-6!20170321 
!--
!      write(6,'(a8,3f15.10)')'before',ktmp(1),ktmp(2),ktmp(3)
!--
      if(ktmp(1)>1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-2.0d0;RWtmp(1)=-2
      endif 
      if(ktmp(1)>0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<=-1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+2.0d0;RWtmp(1)=2 
      endif 
      if(ktmp(1)<=-0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
!---
      if(ktmp(2)>1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-2.0d0;RWtmp(2)=-2 
      endif 
      if(ktmp(2)>0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<=-1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+2.0d0;RWtmp(2)=2 
      endif 
      if(ktmp(2)<=-0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
!--
      if(ktmp(3)>1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-2.0d0;RWtmp(3)=-2 
      endif 
      if(ktmp(3)>0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<=-1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+2.0d0;RWtmp(3)=2 
      endif 
      if(ktmp(3)<=-0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
!--
!     write(6,'(a8,3f15.10)')'after',ktmp(1),ktmp(2),ktmp(3)
!--
      return
      end 
!--
!20170322  
      subroutine kcheck_trs(ktmp,RWtmp)!20170322 
      implicit none 
      real(8),intent(inout)::ktmp(3)
      integer,intent(out)::RWtmp(3) 
      real(8),parameter::dlt_BZ=-1.0d-6 
!--
!      write(6,'(a8,3f15.10)') 'before',ktmp(1),ktmp(2),ktmp(3)
!--
      if(ktmp(1)>=1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-2.0d0;RWtmp(1)=-2
      endif 
      if(ktmp(1)>=0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)-1.0d0;RWtmp(1)=-1
      endif 
      if(ktmp(1)<-1.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+2.0d0;RWtmp(1)=2 
      endif 
      if(ktmp(1)<-0.50d0+dlt_BZ)then 
       ktmp(1)=ktmp(1)+1.0d0;RWtmp(1)=1
      endif 
!--
      if(ktmp(2)>=1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-2.0d0;RWtmp(2)=-2 
      endif 
      if(ktmp(2)>=0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)-1.0d0;RWtmp(2)=-1
      endif 
      if(ktmp(2)<-1.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+2.0d0;RWtmp(2)=2 
      endif 
      if(ktmp(2)<-0.50d0+dlt_BZ)then 
       ktmp(2)=ktmp(2)+1.0d0;RWtmp(2)=1
      endif 
!--
      if(ktmp(3)>=1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-2.0d0;RWtmp(3)=-2 
      endif 
      if(ktmp(3)>=0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)-1.0d0;RWtmp(3)=-1
      endif 
      if(ktmp(3)<-1.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+2.0d0;RWtmp(3)=2 
      endif 
      if(ktmp(3)<-0.50d0+dlt_BZ)then 
       ktmp(3)=ktmp(3)+1.0d0;RWtmp(3)=1
      endif 
!--
!      write(6,'(a8,3f15.10)') 'after',ktmp(1),ktmp(2),ktmp(3)
!--
      return
      end 
!--
      subroutine make_LG0(NTG,b1,b2,b3,Gcut_for_eps,Gcut_for_psi, 
     + q1,q2,q3,LG0,NG_for_eps,NG_for_psi)
      implicit none 
      integer::NTG,igL,igL1,igL2,igL3
      integer::NG_for_eps,NG_for_psi            
      integer::LG0(3,NTG)    
      real(8)::b1(3),b2(3),b3(3) 
      real(8)::Gcut_for_eps,Gcut_for_psi  
      real(8)::q1,q2,q3,qgL2,qgL(3)
      integer,parameter::NGL1=150!100!300 
      integer,parameter::NGL2=150!100!300 
      integer,parameter::NGL3=150!100!300 
!--
      igL=0
      do igL1=-NGL1,NGL1 
      do igL2=-NGL2,NGL2 
      do igL3=-NGL3,NGL3 
      qgL(:)=(q1+dble(igL1))*b1(:)
     +      +(q2+dble(igL2))*b2(:)
     +      +(q3+dble(igL3))*b3(:)    
      qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
      if(qgL2 <= Gcut_for_eps) then 
       igL=igL+1 
       LG0(1,igL)=igL1
       LG0(2,igL)=igL2
       LG0(3,igL)=igL3 
!      write(6,*) igL
      endif  
      enddo 
      enddo 
      enddo 
      NG_for_eps=igL 
!--
      do igL1=-NGL1,NGL1 
      do igL2=-NGL2,NGL2 
      do igL3=-NGL3,NGL3 
      qgL(:)=(q1+dble(igL1))*b1(:)
     +      +(q2+dble(igL2))*b2(:)
     +      +(q3+dble(igL3))*b3(:)    
      qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
      if(qgL2>Gcut_for_eps.and.qgL2<=Gcut_for_psi) then 
       igL=igL+1 
       LG0(1,igL)=igL1
       LG0(2,igL)=igL2
       LG0(3,igL)=igL3 
!      write(6,*) igL
      endif  
      enddo 
      enddo 
      enddo 
      NG_for_psi=igL 
!--
!Do igL=1,NG_for_eps 
!write(6,*) igL,LG0(:,igL)
!enddo 
!--
      RETURN 
      END 
!--
      subroutine make_KG0(NTG,b1,b2,b3,Gcut,q1,q2,q3,KG0,NG) 
      implicit none 
      integer,intent(in)::NTG
      real(8),intent(in)::b1(3),b2(3),b3(3) 
      real(8),intent(in)::Gcut 
      real(8),intent(in)::q1,q2,q3        
      integer,intent(out)::KG0(3,NTG)    
      integer,intent(out)::NG 
      integer::igL,igL1,igL2,igL3
      real(8)::qgL(3),qgL2  
      integer,parameter::NGL1=150!100!300
      integer,parameter::NGL2=150!100!300 
      integer,parameter::NGL3=150!100!300
      igL=0
      do igL1=-NGL1,NGL1 
      do igL2=-NGL2,NGL2 
      do igL3=-NGL3,NGL3 
      qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)
     +      +(q3+dble(igL3))*b3(:)    
      qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
      if(qgL2<=Gcut) then 
       igL=igL+1 
       KG0(1,igL)=igL1
       KG0(2,igL)=igL2
       KG0(3,igL)=igL3 
      endif  
      enddo 
      enddo 
      enddo 
      NG=igL 
!--
!write(6,*) "maxabs KG0_1=",maxval(abs(KG0(1,:))) 
!write(6,*) "maxabs KG0_2=",maxval(abs(KG0(2,:))) 
!write(6,*) "maxabs KG0_3=",maxval(abs(KG0(3,:))) 
!--
!do igL=1,NG 
! write(6,*) igL,KG0(:,igL)
!enddo 
!--
      RETURN 
      END 

module m_dos 
  implicit none
contains
  !
  subroutine calculate_dos(NWF,NTK,nkb1,nkb2,nkb3,electron_number,threshold_transfer,delt,delw,b1,b2,b3,SK0,EIG,VKS)
    implicit none 
    integer,intent(in)::NWF,NTK,nkb1,nkb2,nkb3
    real(8),intent(in)::electron_number
    real(8),intent(in)::threshold_transfer 
    real(8),intent(in)::b1(3),b2(3),b3(3)
    real(8),intent(in)::SK0(3,NTK)
    real(8),intent(in)::EIG(NWF,NTK) 
    real(8),intent(in)::delt!Greens function delt
    real(8),intent(in)::delw!Grid width in dos 
    !
    complex(8),intent(in)::VKS(NWF,NWF,NTK)
    real(8),allocatable::pdos(:,:)!pdos(ndosgrd,NWF) 
    real(8)::flg_pdos
    !
    real(8),parameter::dmna=1.0d-3!Ttrhdrn parameter dmna in au 
    real(8),parameter::dmnr=1.0d-3!Ttrhdrn parameter dmnr in au 
    !
    real(8)::emax!=maxval(EIG)
    real(8)::emin!=minval(EIG)
    integer::ndosgrd!=int(2.0d0*diff/dlt)+1
    real(8)::FermiEnergy 
    real(8),allocatable::dosgrd(:)!dosgrd(ndosgrd) 
    real(8),allocatable::dos(:)!dos(ndosgrd) 
    real(8),allocatable::efline(:)!efline(ndosgrd)   
    !
    !make dos-grid
    !
    call est_ndosgrd(NWF,NTK,EIG(1,1),delw,emin,emax,ndosgrd)  
    allocate(dosgrd(ndosgrd));dosgrd=0.0d0 
    call make_dosgrd(emin,delw,ndosgrd,dosgrd(1))  
    !
    !calc dos 
    !
    allocate(dos(ndosgrd));dos=0.0d0 
    call calc_dos(NWF,NTK,nkb1,nkb2,nkb3,ndosgrd,dosgrd(1),EIG(1,1),SK0(1,1),delt,dmnr,dmna,b1(1),b2(1),b3(1),dos(1)) 
    !
    !calc pdos 
    !
    flg_pdos=maxval(abs(VKS)) 
    if(flg_pdos/=0.0d0)then
      write(6,'(a40,f15.8,a)')'flg_pdos/=0.0:',flg_pdos,': PDOS calculate:' 
      allocate(pdos(ndosgrd,NWF));pdos=0.0d0 
      call calc_pdos(NWF,NTK,nkb1,nkb2,nkb3,ndosgrd,dosgrd(1),EIG(1,1),VKS(1,1,1),SK0(1,1),delt,dmnr,dmna,b1(1),b2(1),b3(1),pdos(1,1)) 
    endif 
    !
    !estimate ef 
    !
    call est_ef(ndosgrd,delw,electron_number,dosgrd(1),dos(1),FermiEnergy) 
    allocate(efline(ndosgrd));efline=0.0d0 
    call make_efline(ndosgrd,FermiEnergy,delw,dosgrd(1),dos(1),efline(1)) 
    !
    !wrt dat.dos 
    !
    call wrt_dos(threshold_transfer,ndosgrd,dosgrd(1),dos(1),efline(1)) 
    !
    !wrt dat.pdos 
    !
    if(flg_pdos/=0.0d0)then
      call wrt_pdos(NWF,ndosgrd,dosgrd(1),pdos(1,1),efline(1)) 
    endif 
    !
    return
  end subroutine 
  !
  subroutine est_ndosgrd(NTB,NTK,E_EIG,deltw,emin,emax,ndosgrd)  
    implicit none
    integer,intent(in)::NTB,NTK
    real(8),intent(in)::E_EIG(NTB,NTK)
    real(8),intent(in)::deltw 
    real(8),intent(out)::emax,emin
    integer,intent(out)::ndosgrd
    real(8)::diff 
    real(8),parameter::au=27.21151d0
    !
    emax=maxval(E_EIG)
    emin=minval(E_EIG)
    diff=emax-emin 
    !
    !define grid range
    !
    ndosgrd=int(2.0d0*diff/deltw)+1
    emax=emax+0.5d0*diff
    emin=emin-0.5d0*diff
    !
    write(6,*)
    write(6,'(a50)')'GRID DATA FOR DOS:'
    write(6,'(a50,f15.7)')'emin(eV):',emin*au 
    write(6,'(a50,f15.7)')'emax(eV):',emax*au 
    write(6,'(a50,f15.7)')'deltw(eV):',deltw*au 
    write(6,'(a50,i15)')'ndosgrd:',ndosgrd 
    write(6,*)
    return
  end subroutine
  !
  subroutine make_dosgrd(emin,deltw,ndosgrd,dosgrd)  
    implicit none
    real(8),intent(in)::emin,deltw 
    integer,intent(in)::ndosgrd
    real(8),intent(out)::dosgrd(ndosgrd) 
    integer::ie 
    !
    dosgrd=0.0d0 
    do ie=1,ndosgrd
     dosgrd(ie)=emin+dble(ie)*deltw 
    enddo 
    return
  end subroutine 
  !
  subroutine est_ef(ndosgrd,deltw,electron_number,dosgrd,dos,FermiEnergy)
    implicit none
    integer,intent(in)::ndosgrd
    real(8),intent(in)::deltw,electron_number 
    real(8),intent(in)::dosgrd(ndosgrd) 
    real(8),intent(in)::dos(ndosgrd) 
    real(8),intent(out)::FermiEnergy 
    real(8)::SUM_REAL
    integer::ie 
    real(8),parameter::au=27.21151d0 
    ! 
    SUM_REAL=0.0d0 
    do ie=1,ndosgrd-1
     !--
     !SUM_REAL=SUM_REAL+deltw*dos(ie) 
     !--
     !Trapezoidal 
     SUM_REAL=SUM_REAL+deltw*(dos(ie)+dos(ie+1))/2.0d0  
    enddo 
    write(6,'(a50,f15.7)')'SUM of DOS:',SUM_REAL
    !
    SUM_REAL=0.0d0 
    do ie=1,ndosgrd-1
     if(SUM_REAL>=electron_number)goto 3000 
     !--
     !SUM_REAL=SUM_REAL+deltw*dos(ie) 
     !--
     !Trapezoidal 
     SUM_REAL=SUM_REAL+deltw*(dos(ie)+dos(ie+1))/2.0d0  
    enddo 
3000 FermiEnergy=dosgrd(ie) 
    write(6,'(a50,f15.7)')'electron_number:',SUM_REAL
    write(6,'(a50,f15.7)')'FermiEnergy:',dosgrd(ie)*au  
    return
  end subroutine 
  !
  subroutine make_efline(ndosgrd,FermiEnergy,deltw,dosgrd,dos,efline) 
    implicit none 
    integer,intent(in)::ndosgrd
    real(8),intent(in)::FermiEnergy,deltw
    real(8),intent(in)::dosgrd(ndosgrd) 
    real(8),intent(in)::dos(ndosgrd) 
    real(8),intent(out)::efline(ndosgrd) 
    real(8)::diff,diff_old,dosmax,N0ttr 
    integer::ie,ief 
    real(8)::SUM_REAL 
    real(8),parameter::au=27.21151d0
    !
    !efline(ndosgrd) 
    !
    diff_old=1.0d0 
    do ie=1,ndosgrd
     diff=dabs(dosgrd(ie)-FermiEnergy) 
     if(diff_old>diff) then 
      ief=ie
      diff_old=diff 
     endif  
    enddo!ie  
    dosmax=1.2d0*maxval(abs(dos(:)))/au  
    dosmax=dble(nint(dosmax*10.0d0))/10.0d0 
    do ie=1,ndosgrd 
     if(ie<=ief) then 
      efline(ie)=dosmax
     else 
      efline(ie)=0.0d0 
     endif 
    enddo!ie 
    !
    !Integral dos(w) dw
    !
    SUM_REAL=0.0d0 
    do ie=1,ndosgrd-1 
     !--
     !SUM_REAL=SUM_REAL+dos(ie)*deltw 
     !--
     !Trapezoidal 
     SUM_REAL=SUM_REAL+deltw*(dos(ie)+dos(ie+1))/2.0d0  
     !write(6,'(2f15.10)') dosgrd(ie)*au,dos(ie)/au  
    enddo 
    write(6,*)
    write(6,'(a50,f15.7)')'Integral dos(w) dw:',SUM_REAL 
    N0ttr=dos(ief)/2.0d0 !2 is spin
    write(6,'(a50,f15.7)')'N(0) in au per calc cell:',N0ttr 
    write(6,'(a50,f15.7)')'N(0) in eV per calc cell:',N0ttr/au   
    write(6,*)
    return
  end subroutine 
  !
  subroutine wrt_dos(threshold_transfer,ndosgrd,dosgrd,dos,efline) 
    implicit none
    integer,intent(in)::ndosgrd
    real(8),intent(in)::dosgrd(ndosgrd)
    real(8),intent(in)::dos(ndosgrd)
    real(8),intent(in)::efline(ndosgrd)
    real(8),intent(in)::threshold_transfer 
    integer::ie 
    real(8),parameter::au=27.21151d0 
    !
    !OPEN(300,W,file='./dat.dos-total')
    !
    OPEN(300,file='./dat.dos-total') 
    rewind(300) 
    write(300,'(a,x,f10.5)')'#Energy cutoff for transfer (eV):',threshold_transfer*au
    do ie=1,ndosgrd
     write(300,'(3f15.10)') dosgrd(ie)*au,dos(ie)/au,efline(ie)  
    enddo!ie 
    close(300)
    return
  end subroutine 
  !
  subroutine wrt_pdos(NTB,ndosgrd,dosgrd,pdos,efline) 
    implicit none
    integer,intent(in)::NTB
    integer,intent(in)::ndosgrd
    real(8),intent(in)::dosgrd(ndosgrd)
    real(8),intent(in)::pdos(ndosgrd,NTB)
    real(8),intent(in)::efline(ndosgrd)
    character(99)::filename 
    integer::ie,ib 
    real(8),parameter::au=27.21151d0 
    !
    !OPEN(400,W,file='./dat.dos-ib')
    !
    do ib=1,NTB 
     write(filename,'("./dat.dos-",i3.3)')ib
     OPEN(400,FILE=TRIM(filename)) 
     rewind(400)  
     do ie=1,ndosgrd
      write(400,'(3f15.10)') dosgrd(ie)*au,pdos(ie,ib)/au,efline(ie)  
     enddo!ie 
     close(400)
    enddo!ib 
    return
  end subroutine wrt_pdos 
  !
  subroutine calc_dos(NTB,NTK,nkb1,nkb2,nkb3,ndosgrd,dosgrd,E_EIG,SK0,delt,dmnr,dmna,b1,b2,b3,dos) 
    use m_tetrahedron
    implicit none
    integer,intent(in)::NTB,NTK,nkb1,nkb2,nkb3,ndosgrd
    real(8),intent(in)::dosgrd(ndosgrd) 
    real(8),intent(in)::E_EIG(NTB,NTK)           
    real(8),intent(in)::SK0(3,NTK)           
    real(8),intent(in)::delt,dmnr,dmna 
    real(8),intent(in)::b1(3),b2(3),b3(3)
    real(8),intent(out)::dos(ndosgrd) 
    !
    integer::index_kpt(nkb1,nkb2,nkb3) 
    integer::imt1(4*nkb1*nkb2*nkb3*6)  
    integer::ie,jb,ik,ikb1,ikb2,ikb3
    integer::iomp,omp_get_thread_num  
    real(8)::SUM_REAL 
    complex(8)::fk_1D(NTK)
    complex(8)::fk_3D(nkb1,nkb2,nkb3) 
    complex(8)::gk_1D(NTK)
    complex(8)::gk_3D(nkb1,nkb2,nkb3)
    complex(8)::xo(nkb1,nkb2,nkb3) 
    complex(8)::xow(ndosgrd,nkb1,nkb2,nkb3)
    real(8),parameter::pi=dacos(-1.0d0)
    real(8),parameter::au=27.21151d0 
    !
    call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
    call ttrhdrn_mkidx(nkb1,nkb2,nkb3,imt1(1),b1(1),b2(1),b3(1))
    xow=0.0d0 
!$OMP PARALLEL PRIVATE(ie,jb,fk_1D,gk_1D,ik,fk_3D,gk_3D,&
!$OMP ikb3,ikb2,ikb1,xo,iomp) 
!$OMP DO 
    do ie=1,ndosgrd 
     do jb=1,NTB
      fk_1D=0.0d0
      gk_1D=0.0d0
      do ik=1,NTK 
       fk_1D(ik)=1.0d0 
       gk_1D(ik)=cmplx(dosgrd(ie)-E_EIG(jb,ik),-delt) 
      enddo 
      fk_3D=0.0d0 
      gk_3D=0.0d0 
      do ikb3=1,nkb3
       do ikb2=1,nkb2
        do ikb1=1,nkb1 
         ik=index_kpt(ikb1,ikb2,ikb3) 
         fk_3D(ikb1,ikb2,ikb3)=fk_1D(ik)
         gk_3D(ikb1,ikb2,ikb3)=gk_1D(ik)
        enddo 
       enddo 
      enddo 
      xo=0.0d0 
      call ttrhdrn_simple(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),& 
       fk_3D(1,1,1),gk_3D(1,1,1),xo(1,1,1))
      xow(ie,:,:,:)=xow(ie,:,:,:)+xo(:,:,:) 
     enddo!jb 
     iomp=omp_get_thread_num() 
     !if(iomp.eq.0) then 
     ! write(6,*) '#',ie  
     !endif 
    enddo!ie
!$OMP END DO 
!$OMP END PARALLEL 
    dos=0.0d0 
    do ie=1,ndosgrd 
     SUM_REAL=0.0d0 
     do ikb3=1,nkb3
      do ikb2=1,nkb2
       do ikb1=1,nkb1 
        SUM_REAL=SUM_REAL+dabs(dimag(xow(ie,ikb1,ikb2,ikb3)))/pi  
       enddo 
      enddo 
     enddo 
     dos(ie)=2.0d0*SUM_REAL/dble(NTK)!2 is spin 
    enddo 
    !
    return
  end subroutine 
  !
  subroutine calc_pdos(NTB,NTK,nkb1,nkb2,nkb3,ndosgrd,dosgrd,E_EIG,VKS,SK0,delt,dmnr,dmna,b1,b2,b3,pdos) 
    use m_tetrahedron
    implicit none
    integer,intent(in)::NTB,NTK,nkb1,nkb2,nkb3,ndosgrd
    real(8),intent(in)::dosgrd(ndosgrd) 
    real(8),intent(in)::E_EIG(NTB,NTK)           
    real(8),intent(in)::SK0(3,NTK)           
    real(8),intent(in)::delt,dmnr,dmna 
    real(8),intent(in)::b1(3),b2(3),b3(3)
    !
    complex(8),intent(in)::VKS(NTB,NTB,NTK)
    complex(8)::pxow(ndosgrd,NTB,nkb1,nkb2,nkb3)
    real(8),intent(out)::pdos(ndosgrd,NTB) 
    !
    integer::index_kpt(nkb1,nkb2,nkb3) 
    integer::imt1(4*nkb1*nkb2*nkb3*6)  
    integer::ie,ib,jb,ik,ikb1,ikb2,ikb3
    integer::iomp,omp_get_thread_num  
    real(8)::SUM_REAL 
    complex(8)::fk_1D(NTK)
    complex(8)::fk_3D(nkb1,nkb2,nkb3) 
    complex(8)::gk_1D(NTK)
    complex(8)::gk_3D(nkb1,nkb2,nkb3)
    complex(8)::xo(nkb1,nkb2,nkb3) 
    real(8),parameter::pi=dacos(-1.0d0)
    real(8),parameter::au=27.21151d0 
    !
    call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
    call ttrhdrn_mkidx(nkb1,nkb2,nkb3,imt1(1),b1(1),b2(1),b3(1))
    pxow=0.0d0 
!$OMP PARALLEL PRIVATE(ie,jb,fk_1D,gk_1D,ik,fk_3D,gk_3D,&
!$OMP ikb3,ikb2,ikb1,xo,iomp) 
!$OMP DO 
    do ie=1,ndosgrd 
     do jb=1,NTB
      fk_1D=0.0d0
      gk_1D=0.0d0
      do ik=1,NTK 
       fk_1D(ik)=1.0d0 
       gk_1D(ik)=cmplx(dosgrd(ie)-E_EIG(jb,ik),-delt) 
      enddo!ik 
      fk_3D=0.0d0 
      gk_3D=0.0d0 
      do ikb3=1,nkb3
       do ikb2=1,nkb2
        do ikb1=1,nkb1 
         ik=index_kpt(ikb1,ikb2,ikb3) 
         fk_3D(ikb1,ikb2,ikb3)=fk_1D(ik)
         gk_3D(ikb1,ikb2,ikb3)=gk_1D(ik)
        enddo!ikb1 
       enddo!ikb2 
      enddo!ikb3 
      xo=0.0d0 
      call ttrhdrn_simple(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),& 
       fk_3D(1,1,1),gk_3D(1,1,1),xo(1,1,1))
      pxow(ie,jb,:,:,:)=xo(:,:,:) 
     enddo!jb 
     iomp=omp_get_thread_num() 
     !if(iomp.eq.0) write(6,*) '#',ie  
    enddo!ie
!$OMP END DO 
!$OMP END PARALLEL 
    pdos=0.0d0 
    do ie=1,ndosgrd 
     do ib=1,NTB
      SUM_REAL=0.0d0 
      do jb=1,NTB 
       do ikb3=1,nkb3
        do ikb2=1,nkb2
         do ikb1=1,nkb1 
          ik=index_kpt(ikb1,ikb2,ikb3) 
          SUM_REAL=SUM_REAL+(abs(VKS(jb,ib,ik))**2)*dabs(dimag(pxow(ie,jb,ikb1,ikb2,ikb3)))/pi  
         enddo!ikb1 
        enddo!ikb2 
       enddo!ikb3 
      enddo!jb  
      pdos(ie,ib)=2.0d0*SUM_REAL/dble(NTK)!2 is spin 
     enddo!ib 
    enddo!ie 
    !
    return
  end subroutine calc_pdos 
  !
  SUBROUTINE make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0,index_kpt)      
    implicit none 
    integer::NTK,nkb1,nkb2,nkb3
    real(8)::SK0(3,NTK)  
    integer::ik,ix,iy,iz
    real(8)::x,y,z
    integer::index_kpt(nkb1,nkb2,nkb3)    
    !-- 
    !if(MOD(NTK,2)/=0)then 
    ! !write(6,*)'i am in make_index for odd'
    ! do ik=1,NTK 
    !  x=SK0(1,ik)*dble(nkb1) 
    !  y=SK0(2,ik)*dble(nkb2)
    !  z=SK0(3,ik)*dble(nkb3)  
    !  x=x+(dble(nkb1)-1.0d0)/2.0d0 
    !  y=y+(dble(nkb2)-1.0d0)/2.0d0
    !  z=z+(dble(nkb3)-1.0d0)/2.0d0 
    !  ix=idnint(x)+1
    !  iy=idnint(y)+1
    !  iz=idnint(z)+1
    !  index_kpt(ix,iy,iz)=ik
    ! enddo 
    !else!20170316 
    ! !write(6,*)'i am in make_index for even'
    ! do ik=1,NTK 
    !  x=SK0(1,ik)*dble(nkb1) 
    !  y=SK0(2,ik)*dble(nkb2)
    !  z=SK0(3,ik)*dble(nkb3)  
    !  x=x+dble(nkb1)/2.0d0 
    !  y=y+dble(nkb2)/2.0d0
    !  z=z+dble(nkb3)/2.0d0 
    !  ix=idnint(x)
    !  iy=idnint(y)
    !  iz=idnint(z)
    !  index_kpt(ix,iy,iz)=ik
    ! enddo 
    !endif 
    !--
    !
    !20190520 Kazuma Nakamura
    !
    do ik=1,NTK 
     x=SK0(1,ik)*dble(nkb1) 
     y=SK0(2,ik)*dble(nkb2)
     z=SK0(3,ik)*dble(nkb3)  
     x=x+(dble(nkb1)-dble(mod(nkb1,2)))/2.0d0 
     y=y+(dble(nkb2)-dble(mod(nkb2,2)))/2.0d0 
     z=z+(dble(nkb3)-dble(mod(nkb3,2)))/2.0d0 
     ix=idnint(x)+mod(nkb1,2)
     iy=idnint(y)+mod(nkb2,2)
     iz=idnint(z)+mod(nkb3,2)
     index_kpt(ix,iy,iz)=ik
    enddo 
    ! 
    RETURN  
  END subroutine  
  !
end module m_dos 

      PROGRAM MATRIX_J 
      use m_rdinput       
      use fft_3d 
      include "config_j3d.h" 
      call read_input 
!--
!OPEN(117,R,FILE='dat.bandcalc') 
      OPEN(117,FILE='./dir-wfn/dat.bandcalc') 
      rewind(117) 
      read(117,*) Ecut_for_psi 
      read(117,*) FermiEnergy  
      read(117,*) Etot
      write(6,*)'Ecut_for_psi=',Ecut_for_psi 
      write(6,*)'FermiEnergy=',FermiEnergy  
      write(6,*)'Etot=',Etot
!--
!OPEN(105,R,FILE='dat.lattice')
      OPEN(105,FILE='./dir-wfn/dat.lattice') 
      REWIND(105)
      READ(105,*) a1(1),a1(2),a1(3)!a1 vector
      READ(105,*) a2(1),a2(2),a2(3)!a2 vector
      READ(105,*) a3(1),a3(2),a3(3)!a3 vector
      write(6,*)'FINISH REDING a1,a2,a3'
      CLOSE(105)
      call OUTER_PRODUCT(a2(1),a3(1),b1(1))
      VOLUME=a1(1)*b1(1)+a1(2)*b1(2)+a1(3)*b1(3)
      b1(:)=b1(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a3(1),a1(1),b2(1))
      b2(:)=b2(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a1(1),a2(1),b3(1))
      b3(:)=b3(:)*tpi/VOLUME 
      write(6,*) 
      write(6,*)'======================'
      write(6,*)'CHECK OF (A_VEC*B_VEC)'
      write(6,*)'======================'
      write(6,*)
      write(6,*)'a1*b1=',b1(1)*a1(1)+b1(2)*a1(2)+b1(3)*a1(3)
      write(6,*)'a2*b2=',b2(1)*a2(1)+b2(2)*a2(2)+b2(3)*a2(3)
      write(6,*)'a3*b3=',b3(1)*a3(1)+b3(2)*a3(2)+b3(3)*a3(3)
      write(6,*)'VOLUME OF UNIT CELL=',VOLUME  
!--
!OPEN(100,R,FILE='dat.symmetry') 
      OPEN(100,FILE='./dir-wfn/dat.symmetry') 
      rewind(100) 
      read(100,*) nsymq 
      read(100,*) nnp 
      allocate(rg(3,3,nsymq));rg=0
      allocate(pg(3,nsymq));pg=0
      allocate(rginv(3,3,nsymq));rginv(:,:,:)=0.0d0 
      do iop=1,nsymq
       read(100,*)((rg(i,j,iop),i=1,3),j=1,3) 
       read(100,*)(pg(i,iop),i=1,3)   
      enddo 
      CLOSE(100) 
      rginv=rg 
      do iop=1,nsymq
      call invmat(3,rginv(1,1,iop)) 
      enddo 
      write(6,*)'finish rg'
!check 
!do iop=1,nsymq
!write(6,*) iop
!do i=1,3
!write(6,'(3I5,1x,3F15.10)') (rg(i,j,iop),j=1,3),(rginv(i,j,iop),j=1,3)
!enddo 
!enddo 
!do iop=1,nsymq
!do i=1,3
!do j=1,3
!s=0.0d0 
!do k=1,3
!s=s+rg(i,k,iop)*rginv(k,j,iop)
!enddo 
!write(6,*) i,j,s
!enddo 
!enddo 
!enddo 
!---
!OPEN(101,R,FILE='dat.sample-k') 
      OPEN(101,FILE='./dir-wfn/dat.sample-k') 
      rewind(101) 
      READ(101,*) Nk_irr 
      allocate(SKI(3,Nk_irr));SKI(:,:)=0.0D0 
      do ik=1,Nk_irr 
       read(101,*)(SKI(i,IK),i=1,3) 
      enddo 
      CLOSE(101) 
      write(6,*)'finish ski'
!20170327 
      !call est_NTK(NK_irr,SKI(1,1),NTK,nkb1,nkb2,nkb3)  
      !write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      !Na1=nkb1/2;Na2=nkb2/2;Na3=nkb3/2
      !write(6,'(a24,3i10)')'Na1,Na2,Na3=',Na1,Na2,Na3 
!--
!OPEN(132,R,FILE='dat.nkm')20170420 
      OPEN(132,FILE='./dir-wfn/dat.nkm') 
      allocate(NGI(Nk_irr));NGI(:)=0
      rewind(132)
      do ik=1,Nk_irr 
       read(132,*) NGI(ik)
      enddo 
      close(132) 
      NTG=maxval(abs(NGI(:))) 
      write(6,'(a10,i10)')'NTG=',NTG  
!--
!OPEN(104,R,FILE='dat.kg') 
      OPEN(104,FILE='./dir-wfn/dat.kg') 
      rewind(104) 
      allocate(KGI(3,NTG,Nk_irr));KGI(:,:,:)=0 
      do ik=1,Nk_irr 
       read(104,*) NG_for_psi 
       NGI(IK)=NG_for_psi 
       do ig=1,NG_for_psi 
        read(104,*)(KGI(i,ig,ik),i=1,3) 
       ENDDO
      ENDDO 
      CLOSE(104)
      write(6,*)'finish kgi'
!--
      allocate(LKGI(NTG,Nk_irr));LKGI=0.0d0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
       ktmp(1)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(1)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(1) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(1) 

       ktmp(2)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(2)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(2) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(2) 

       ktmp(3)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(3)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(3) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(3) 
       LKGI(ig,ik)=ktmp(1)**2+ktmp(2)**2+ktmp(3)**2
       enddo!ig 
       write(6,*) maxval(LKGI(:,ik))
      enddo!ik 
      write(6,*) 
      write(6,*) maxval(LKGI(:,:))
      Ecut_for_psi=maxval(LKGI(:,:))+1.0d-8
      write(6,*)'Ecut_for_psi=',Ecut_for_psi 
!--
      L1=maxval(abs(KGI(1,:,:)))+1;write(6,*) 'L1=',L1 
      L2=maxval(abs(KGI(2,:,:)))+1;write(6,*) 'L2=',L2 
      L3=maxval(abs(KGI(3,:,:)))+1;write(6,*) 'L3=',L3 
      allocate(packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr))   
      packing(:,:,:,:)=0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
        i1=KGI(1,ig,ik);j1=KGI(2,ig,ik);k1=KGI(3,ig,ik) 
        packing(i1,j1,k1,ik)=ig 
       enddo 
      enddo 
!--
!fft grid
      !20180309 
      !m1=maxval(abs(KGI(1,:,:))) 
      !m2=maxval(abs(KGI(2,:,:))) 
      !m3=maxval(abs(KGI(3,:,:))) 
      !nwx2=algn235(2*m1) 
      !nwy2=algn235(2*m2) 
      !nwz2=algn235(2*m3) 
      !
      htmp=dsqrt(dot_product(a1,a1))
      h1(:)=a1(:)/htmp 
      htmp=dsqrt(dot_product(a2,a2))
      h2(:)=a2(:)/htmp 
      htmp=dsqrt(dot_product(a3,a3)) 
      h3(:)=a3(:)/htmp 
      d1=abs(dot_product(b1,h1)) 
      d2=abs(dot_product(b2,h2)) 
      d3=abs(dot_product(b3,h3)) 
      qwf=2.0d0*dsqrt(Ecut_for_psi) 
      !
      !nwx2=algn235(int(qwf/d1)+1,1) 
      !nwy2=algn235(int(qwf/d2)+1,1) 
      !nwz2=algn235(int(qwf/d3)+1,1) 
      !
      nwx2=algn235(int(qwf/d1)+1)!20180412 by Y.Nomura 
      nwy2=algn235(int(qwf/d2)+1)!20180412 by Y.Nomura 
      nwz2=algn235(int(qwf/d3)+1)!20180412 by Y.Nomura 
      !
      nfft1=nwx2+1
      nfft2=nwy2+1
      nfft3=nwz2+1
      Nl123=nfft1*nfft2*nfft3 
      write(6,*)'nwx2=',nwx2 
      write(6,*)'nwy2=',nwy2 
      write(6,*)'nwz2=',nwz2 
      write(6,*)'nfft1=',nfft1 
      write(6,*)'nfft2=',nfft2 
      write(6,*)'nfft3=',nfft3 
      write(6,*)'NL123=',Nl123  
      call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
!--
!20180302  
      call est_NTK(Nk_irr,Nsymq,SKI(1,1),rg(1,1,1),NTK)
      write(6,*)'Estimated NTK=',NTK 
!--
!gen(SK0,numirr,numrot,trs,RW) 
      allocate(SK0(3,NTK));SK0(:,:)=0.0d0
      allocate(numirr(NTK));numirr(:)=0
      allocate(trs(NTK));trs(:)=0
      allocate(numrot(NTK));numrot(:)=0
      allocate(RW(3,NTK));RW(:,:)=0
!20161207 
!      do ik=1,Nk_irr 
!       SK0(:,ik)=SKI(:,ik) 
!       numirr(ik)=ik; numrot(ik)=1; trs(ik)=1; RW(1:3,ik)=0
!      enddo 
!      jk=Nk_irr 
!--
      jk=0 
      do ik=1,Nk_irr
      do iop=1,Nsymq
!sym
       ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik)
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik)
       call kcheck(ktmp(1),RWtmp(1))!rewind check 
       do iik=1,jk
        if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and. 
     +     abs(SK0(2,iik)-ktmp(2))<1.0d-4.and. 
     +     abs(SK0(3,iik)-ktmp(3))<1.0d-4)goto 1000
       enddo!iik
       jk=jk+1
       SK0(:,jk)=ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=1;RW(:,jk)=RWtmp(:)
!time-reversal
1000   ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik) 
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik) 
       call kcheck_trs(ktmp(1),RWtmp(1))!rewind check 20170322
       do iik=1,jk
        if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and. 
     +     abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and. 
     +     abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4)goto 2000
       enddo!iik
       jk=jk+1
       SK0(:,jk)=-ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=-1;RW(:,jk)=RWtmp(:)
2000  enddo 
      enddo 
!--
      if(NTK/=jk)then 
       write(6,*)'ERROR; STOP; NTK should be jk'   
       write(6,*)'NTK=',NTK,'jk=',jk; STOP
      endif 
!--   
       write(6,*)
       write(6,*)'====='
       write(6,*)' SK0 '
       write(6,*)'====='
       write(6,*)
       do ik=1,NTK
        write(6,'(I5,3F15.10)') ik,SK0(:,ik) 
       enddo 
!--
      call est_nkbi(NTK,SK0(1,1),nkb1,nkb2,nkb3)  
      write(6,*) 
      write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      Na1=nkb1/2;Na2=nkb2/2;Na3=nkb3/2
      write(6,'(a24,3i10)')'Na1,Na2,Na3=',Na1,Na2,Na3 
!--
!gen(KG0,NG0)
      allocate(NG0(NTK));NG0(:)=0
      allocate(KG0(3,NTG,NTK));KG0(:,:,:)=0 
      allocate(KGtmp(3,NTG));KGtmp(:,:)=0 
!20161207 
!      do jk=1,Nk_irr 
!       NG0(jk)=NGI(jk);KG0(:,:,jk)=KGI(:,:,jk)
!      enddo 
!      do jk=Nk_irr+1,NTK 
!--
      do jk=1,NTK 
       if(trs(jk)==1)then 
        ik=numirr(jk); iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KG0(1,1,jk),NG_for_psi)
        if(NG_for_psi/=NGI(ik)) then 
         write(6,*)'ERROR; STOP; NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
       elseif(trs(jk)==-1) then  
        ik=numirr(jk); iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        KGtmp(:,:)=0 
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KGtmp(1,1),NG_for_psi)
        if(NG_for_psi/=NGI(ik))then 
         write(6,*)'ERROR; STOP; NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
        KG0(:,:,jk)=-KGtmp(:,:) 
       endif 
      enddo 
!--
      write(6,*)
      write(6,*)'====='
      write(6,*)' NG0 '
      write(6,*)'====='
      write(6,*)
      do ik=1,NTK 
       write(6,'(1I8)') NG0(ik) 
      enddo 
!--
!OPEN(113,R,FILE='dat.wan',FORM='unformatted') 
      OPEN(113,FILE='./dir-wan/dat.wan',FORM='unformatted') 
      REWIND(113)       
      read(113) NWF 
      allocate(C0(NTG,NWF,NTK));C0(:,:,:)=0.0D0 
      do ik=1,NTK 
       read(113)((C0(ig,iw,ik),ig=1,NG0(ik)),iw=1,NWF)           
       !
       !20180519 
       !do iw=1,NWF
       ! read(113)(C0(ig,iw,ik),ig=1,NG0(ik))
       !enddo!iw
       !
      enddo!ik 
      write(6,*)'FINISH REDING C0'
      CLOSE(113)  
!--
!      do ik=1,Nk_irr 
!       do iw=1,NWF
!        do jw=1,NWF 
!         SUM_CMPX=0.0d0 
!         do ig=1,NG0(ik) 
!          SUM_CMPX=SUM_CMPX+CONJG(C0(ig,iw,ik))*C0(ig,jw,ik) 
!         enddo 
!         write(6,'(3i5,x,2f15.10)') ik,iw,jw,SUM_CMPX 
!        enddo 
!       enddo 
!      enddo 
!--
!OPEN(134,R,FILE='dat.wan-center') 
      OPEN(134,FILE='./dir-wan/dat.wan-center') 
      allocate(coord(3,NWF));coord(:,:)=0.0d0   
      rewind(134)
      read(134,'(a)') dum_char
      read(134,'(a)') dum_char
      do iw=1,NWF
      read(134,*) coord(1,iw),coord(2,iw),coord(3,iw) 
      enddo 
!--
!OPEN(127,R,FILE='dat.sample-q')
!      OPEN(127,FILE='./dir-wfn/dat.sample-q')
!      Nq_irr=Nk_irr 
!      allocate(SQR(3,Nq_irr));SQR(:,:)=0.0D0 
!      rewind(127) 
!      read(127,*) idum 
!      do iq=1,Nq_irr 
!       read(127,*)(SQR(i,iq),i=1,3) 
!      enddo 
!      write(6,*)'FINISH REDING SQR'
!      CLOSE(127) 
!20161207 
!shift[-1/2:1/2]  
!      allocate(SQI(3,Nq_irr));SQI(:,:)=0.0D0 
!      do iq=1,Nq_irr
!       call search_q(SQR(1,iq),SQI(1,iq)) 
!      enddo  
!      write(6,*)
!      write(6,*)'====================='
!      write(6,*)'shifted SQ (SQR->SQI)'
!      write(6,*)'====================='
!      write(6,*)
!      do iq=1,Nq_irr 
!       write(6,'(a10,3f10.5,2x,3f10.5)')'SQR->SQI',SQR(:,iq),SQI(:,iq) 
!      enddo 
!--
!OPEN(300,R,FILE='dat.chi_cutoff')!20170402  
       OPEN(300,FILE='./dir-eps/dat.chi_cutoff')!20170402 
       read(300,*) Ecut_for_eps!20170402  
!--
!OPEN(135,R,FILE='W-grid') 
      OPEN(135,FILE='./dir-eps/dat.wgrid') 
      rewind(135) 
      read(135,*) Num_freq_grid!20170402
      ne=Num_freq_grid!20170402
      allocate(em(ne));em(:)=0.0d0 
      do ie=1,ne 
       !read(135,*) em(ie) 
        read(135,'(2f15.10)') em(ie)!20171212
      enddo 
!--
!OPEN(400,R,FILE='dat.log.400')!20170420  
!OPEN(301,R,FILE='dat.sq')!20170420   
      Nq_irr=Nk_irr 
      allocate(SQI(3,Nq_irr));SQI(:,:)=0.0D0 
      ierr=CHDIR("./dir-eps") 
      do iq=1,Nq_irr 
       write(dirname,"('q',i3.3)")iq 
       ierr=CHDIR(dirname) 
       inquire(file='dat.log.400',exist=file_e) 
       if(file_e)then 
        write(6,*)'dat.log.400 exists in ',trim(dirname) 
       else
        write(6,*)'error: no dat.log.400 in ',trim(dirname) 
       endif 
       OPEN(301,FILE='dat.sq') 
       rewind(301)
       inquire(file='dat.sq',exist=file_e) 
       if(file_e)then 
        read(301,*)(SQI(i,iq),i=1,3) 
       else
        write(6,*)'error: no dat.sq in',trim(dirname) 
       endif 
       close(301) 
       ierr=CHDIR("..") 
      enddo!iq 
      ierr=CHDIR("..") 
      call system('pwd') 
!--
!gen(SQ,numirrq,numrotq,trsq,RWq) 
      NTQ=NTK!TOTAL NUMBER OF Q POINTS 
      allocate(SQ(3,NTQ));SQ(:,:)=0.0d0
      allocate(numirrq(NTQ));numirrq(:)=0
      allocate(numrotq(NTQ));numrotq(:)=0
      allocate(trsq(NTQ));trsq(:)=0
      allocate(RWq(3,NTQ));RWq(:,:)=0      
!--
      do iq=1,Nq_irr 
       SQ(:,iq)=SQI(:,iq) 
       numirrq(iq)=iq;numrotq(iq)=1;trsq(iq)=1;RWq(1:3,iq)=0
      enddo 
      jk=Nq_irr 
      do iq=1,Nq_irr
      do iop=1,Nsymq
!sym
       ktmp(:)=0.0d0; RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SQI(1,iq)+rg(1,2,iop)*SQI(2,iq)
     +        +rg(1,3,iop)*SQI(3,iq)
       ktmp(2)=rg(2,1,iop)*SQI(1,iq)+rg(2,2,iop)*SQI(2,iq)
     +        +rg(2,3,iop)*SQI(3,iq)
       ktmp(3)=rg(3,1,iop)*SQI(1,iq)+rg(3,2,iop)*SQI(2,iq)
     +        +rg(3,3,iop)*SQI(3,iq)
       call kcheck(ktmp(1),RWtmp(1))!rewind check 
       do iik=1,jk 
        if(abs(SQ(1,iik)-ktmp(1))<1.0d-4.and. 
     +     abs(SQ(2,iik)-ktmp(2))<1.0d-4.and. 
     +     abs(SQ(3,iik)-ktmp(3))<1.0d-4)goto 1100
       enddo!iik
       jk=jk+1
       SQ(:,jk)=ktmp(:)
       numirrq(jk)=iq;numrotq(jk)=iop;trsq(jk)=1;RWq(:,jk)=RWtmp(:)
!time-reversal
1100   ktmp(:)=0.0d0; RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SQI(1,iq)+rg(1,2,iop)*SQI(2,iq)
     +        +rg(1,3,iop)*SQI(3,iq)
       ktmp(2)=rg(2,1,iop)*SQI(1,iq)+rg(2,2,iop)*SQI(2,iq)
     +        +rg(2,3,iop)*SQI(3,iq) 
       ktmp(3)=rg(3,1,iop)*SQI(1,iq)+rg(3,2,iop)*SQI(2,iq)
     +        +rg(3,3,iop)*SQI(3,iq) 
       call kcheck_trs(ktmp(1),RWtmp(1))!rewind check 20170322
       do iik=1,jk
        if(abs(SQ(1,iik)-(-ktmp(1)))<1.0d-4.and. 
     +     abs(SQ(2,iik)-(-ktmp(2)))<1.0d-4.and. 
     +     abs(SQ(3,iik)-(-ktmp(3)))<1.0d-4)goto 2100
       enddo !iik
       jk=jk+1
       SQ(:,jk)=-ktmp(:)
       numirrq(jk)=iq;numrotq(jk)=iop;trsq(jk)=-1;RWq(:,jk)=RWtmp(:)
2100  enddo 
      enddo 
!--
      if(NTQ/=jk)then 
       write(6,*)'ERROR;STOP;NTQ should be jk'   
       write(6,*)'NTQ=',NTQ,'jk=',jk;STOP
      endif 
!--
      write(6,*)
      write(6,*)'============'
      write(6,*)' SQ and SK0 '
      write(6,*)'============'
      write(6,*)
      do iq=1,NTQ 
       write(6,'(I5,3F10.5,2x,3F10.5)') iq,SQ(:,iq),SK0(:,iq) 
      enddo  
      write(6,*) 
!--
!gen(LG0,NGQ_eps,NGQ_psi)
      allocate(LG0(3,NTG,NTQ));LG0(:,:,:)=0
      allocate(NGQ_eps(NTQ));NGQ_eps(:)=0
      allocate(NGQ_psi(NTQ));NGQ_psi(:)=0
      do iq=1,Nq_irr 
       q1=SQI(1,iq);q2=SQI(2,iq);q3=SQI(3,iq)
       call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +      Ecut_for_psi,q1,q2,q3,LG0(1,1,iq),NG_for_eps,NG_for_psi) 
       NGQ_eps(iq)=NG_for_eps;NGQ_psi(iq)=NG_for_psi  
       write(6,'(i8,3f10.5,a8,i8,a8,i10)') 
     + iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
      enddo 
      do iq=Nq_irr+1,NTQ 
       if(trsq(iq)==1)then 
        ik=numirrq(iq); iop=numrotq(iq) 
        q1=rg(1,1,iop)*SQI(1,ik)+rg(1,2,iop)*SQI(2,ik)
     +    +rg(1,3,iop)*SQI(3,ik)+dble(RWq(1,iq)) 
        q2=rg(2,1,iop)*SQI(1,ik)+rg(2,2,iop)*SQI(2,ik)
     +    +rg(2,3,iop)*SQI(3,ik)+dble(RWq(2,iq))  
        q3=rg(3,1,iop)*SQI(1,ik)+rg(3,2,iop)*SQI(2,ik)
     +    +rg(3,3,iop)*SQI(3,ik)+dble(RWq(3,iq))  
        call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +       Ecut_for_psi,q1,q2,q3,LG0(1,1,iq),NG_for_eps,NG_for_psi) 
        NGQ_eps(iq)=NG_for_eps;NGQ_psi(iq)=NG_for_psi  
        write(6,'(i8,3f10.5,a8,i8,a8,i10)') 
     +  iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
       elseif(trsq(iq)==-1)then  
        ik=numirrq(iq); iop=numrotq(iq) 
        q1=rg(1,1,iop)*SQI(1,ik)+rg(1,2,iop)*SQI(2,ik)
     +    +rg(1,3,iop)*SQI(3,ik)+dble(RWq(1,iq)) 
        q2=rg(2,1,iop)*SQI(1,ik)+rg(2,2,iop)*SQI(2,ik)
     +    +rg(2,3,iop)*SQI(3,ik)+dble(RWq(2,iq))  
        q3=rg(3,1,iop)*SQI(1,ik)+rg(3,2,iop)*SQI(2,ik)
     +    +rg(3,3,iop)*SQI(3,ik)+dble(RWq(3,iq))  
        KGtmp(:,:)=0 
        call make_LG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +       Ecut_for_psi,q1,q2,q3,KGtmp(1,1),NG_for_eps,NG_for_psi) 
        NGQ_eps(iq)=NG_for_eps;NGQ_psi(iq)=NG_for_psi  
        write(6,'(i8,3f10.5,a8,i8,a8,i10)') 
     +  iq,q1,q2,q3,'NGeps',NG_for_eps,'NGpsi',NG_for_psi  
        LG0(:,:,iq)=-KGtmp(:,:) 
       endif 
      enddo 
!--
      Lq1=maxval(abs(LG0(1,:,:)))+1; write(6,*)'Lq1=',Lq1 
      Lq2=maxval(abs(LG0(2,:,:)))+1; write(6,*)'Lq2=',Lq2 
      Lq3=maxval(abs(LG0(3,:,:)))+1; write(6,*)'Lq3=',Lq3 
      allocate(packingq(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3,Nq_irr))   
      packingq(:,:,:,:)=0 
      do iq=1,Nq_irr 
       do ig=1,NGQ_eps(iq) 
        i1=LG0(1,ig,iq); j1=LG0(2,ig,iq); k1=LG0(3,ig,iq) 
        packingq(i1,j1,k1,iq)=ig 
       enddo 
      enddo 
!-- 
      NTGQ=maxval(NGQ_eps(:))!TOTAL NUMBER OF G VECTORS FOR EPSILON
      write(6,*)'NTGQ=',NTGQ  
!--
!OPEN(600-,R,FILE='DATA_EPSILON_fRPA',FORM='unformatted') 
      allocate(epstmp(NTGQ,NTGQ,ne));epstmp(:,:,:)=0.0D0!real8
      allocate(epstmpgm(NTGQ,NTGQ,ne,3));epstmpgm(:,:,:,:)=0.0D0!real8
      allocate(epsirr(NTGQ,NTGQ,ne,Nq_irr));epsirr(:,:,:,:)=0.0D0!real4 
!--
      ierr=CHDIR("./dir-eps") 
      call system('pwd') 
      do iq=1,Nq_irr 
       if(abs(SKI(1,iq))<1.0d-5.and.abs(SKI(2,iq))<1.0d-5.and.
     +    abs(SKI(3,iq))<1.0d-5)then 
        write(dirname,"('q',i3.3)")iq
        iqgm=iq 
        ierr=CHDIR(dirname) 
        do ix=1,3 
         file_num=600+(ix-1)  
         write(filename,'("dat.epsqw.",i3.3)')file_num 
         open(file_num,file=filename,form='unformatted') 
         write(6,'(a10,a15,a5,a10)') 
     +   'read: ',trim(filename),'in ',trim(dirname)  
         rewind(file_num) 
         NG_for_eps=NGQ_eps(iq)
         read(file_num)(((epstmpgm(ig,jg,ie,ix),ig=1,NG_for_eps)
     +                          ,jg=1,NG_for_eps),ie=1,ne)
        enddo!ix 
        epsirr(:,:,:,iq)!epsirr:real4,epstmp:real8 
     + =(epstmpgm(:,:,:,1)+epstmpgm(:,:,:,2)+epstmpgm(:,:,:,3))/3.0d0
       else
        write(dirname,"('q',i3.3)")iq
        ierr=CHDIR(dirname) 
        file_num=600 
        write(filename,'("dat.epsqw.",i3.3)')file_num 
        open(file_num,file=filename,form='unformatted') 
        write(6,'(a10,a15,a5,a10)') 
     +  'read: ',trim(filename),'in ',trim(dirname)  
        rewind(file_num) 
        NG_for_eps=NGQ_eps(iq)
        read(file_num)(((epstmp(ig,jg,ie),ig=1,NG_for_eps)
     +                         ,jg=1,NG_for_eps),ie=1,ne)
        epsirr(:,:,:,iq)=epstmp(:,:,:)!epsirr:real4,epstmp:real8 
       endif!q=0 or not 
       ierr=CHDIR("..") 
      enddo!iq   
      ierr=CHDIR("..") 
      call system('pwd') 
!--
!      do iq=1,Nq_irr 
!       NG_for_eps=NGQ_eps(iq)
!       write(6,*) NG_for_eps 
!       do ig=1,NG_for_eps 
!        write(6,*) epsirr(ig,ig,100,iq) 
!       enddo  
!      enddo  
!--
      WRITE(6,*) 
      WRITE(6,*)'====================================='
      WRITE(6,*)'=== INTERACTION CALCULATION START ==='
      WRITE(6,*)'====================================='
!--
!make J_MAT(iw,jw,R)
!--
       allocate(func(NWF,NWF,NTQ));func(:,:,:)=0.0d0 
       allocate(X_MAT(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)) 
       X_MAT(:,:,:,:,:)=0.0D0 
       allocate(funcw(NWF,NWF,NTQ,ne));funcw(:,:,:,:)=0.0d0 
       allocate(J_MAT(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,ne)) 
       J_MAT(:,:,:,:,:,:)=0.0D0 
!--
      do ia1=ix_intJ_min,ix_intJ_max
       do ia2=iy_intJ_min,iy_intJ_max
        do ia3=iz_intJ_min,iz_intJ_max
         do iq=1,NTQ 
!q/=0 
          q1=SQ(1,iq);q2=SQ(2,iq);q3=SQ(3,iq)
          if(q1.ne.0.0d0.or.q2.ne.0.0d0.or.q3.ne.0.0d0) then 
           NG_for_eps=NGQ_eps(iq)
           NG_for_psi=NGQ_psi(iq)
           allocate(length_qg(NG_for_psi)) 
           length_qg(:)=0.0D0 
           do igL=1,NG_for_psi   
            igL1=LG0(1,igL,iq)
            igL2=LG0(2,igL,iq)
            igL3=LG0(3,igL,iq)
            qgL(:)=(q1+dble(igL1))*b1(:)
     +            +(q2+dble(igL2))*b2(:)
     +            +(q3+dble(igL3))*b3(:)
            qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
            qgL1=dsqrt(qgL2) 
            length_qg(igL)=qgL1
           enddo!igL 
           allocate(rho(NG_for_psi,NWF,NWF));rho(:,:,:)=0.0D0 
!$OMP PARALLEL PRIVATE(ik,iw,jw,igL,pf,shift_G,ikq,C0_K,C0_KQ,
!$OMP&  rho_tmp,wfunc,fftwk,prho)
           allocate(rho_tmp(NG_for_psi));rho_tmp(:)=0.0d0 
           allocate(prho(NG_for_psi,NWF,NWF));prho(:,:,:)=0.0D0 
           allocate(fftwk(Nl123*2));fftwk(:)=0.0d0  
           allocate(wfunc(Nl123*2));wfunc(:)=0.0d0 
           allocate(C0_K(NTG));C0_K(:)=0.0d0     
           allocate(C0_KQ(NTG));C0_KQ(:)=0.0d0     
!$OMP DO 
           do ik=1,NTK 
            do iw=1,NWF 
             do jw=1,NWF 
              pf=exp(-ci*tpi*(SK0(1,ik)*dble(ia1)
     +                       +SK0(2,ik)*dble(ia2)
     +                       +SK0(3,ik)*dble(ia3))) 
              shift_G(:)=0
              call search_kq(NTK,SK0,q1,q2,q3,ik,ikq,shift_G(1))
              C0_K(:)=C0(:,jw,ik) 
              C0_KQ(:)=C0(:,iw,ikq) 
              rho_tmp(:)=0.0D0 
              call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),
     +        C0_K(1),C0_KQ(1),ik,ikq,nwx2,nwy2,nwz2,nfft1,nfft2, 
     +        Nl123,wfunc(1),fftwk(1),fs,LG0(1,1,iq),NG_for_psi,
     +        shift_G(1),rho_tmp(1))
              prho(:,iw,jw)=prho(:,iw,jw)+rho_tmp(:)*pf/length_qg(:)   
             enddo!jw 
            enddo!iw 
           enddo!ik 
!$OMP END DO 
!$OMP CRITICAL 
           rho=rho+prho 
!$OMP END CRITICAL 
           deallocate(prho,fftwk,wfunc,rho_tmp,C0_K,C0_KQ) 
!$OMP END PARALLEL 
           rho(:,:,:)=rho(:,:,:)/dble(NTK)
           deallocate(length_qg)
            do iw=1,NWF 
             do jw=1,NWF 
              SUM_CMPX=0.0D0 
              do igL=1,NG_for_psi  
                SUM_CMPX
     +         =SUM_CMPX
     +         +rho(igL,iw,jw)*CONJG(rho(igL,iw,jw)) 
              enddo 
              func(iw,jw,iq)=SUM_CMPX 
             enddo!jw 
            enddo!iw 
            allocate(epsmk(NTGQ,NTGQ,ne));epsmk(:,:,:)=0.0d0 
            allocate(packtmp(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3)) 
            iqir=numirrq(iq)
            iop=numrotq(iq)
            packtmp(:,:,:)=packingq(:,:,:,iqir) 
            call make_eps(NTG,NTGQ,ne,trsq(iq),NGQ_eps(iq),
     +       LG0(1,1,iq),RWq(1,iq),rginv(1,1,iop),pg(1,iop),
     +       nnp,Lq1,Lq2,Lq3,packtmp(-Lq1,-Lq2,-Lq3),
     +       epsirr(1,1,1,iqir),epsmk(1,1,1)) 
!$OMP PARALLEL PRIVATE(ie,iw,jw,SUM_CMPX,igL,jgL)
!$OMP DO 
            do ie=1,ne 
             do iw=1,NWF 
              do jw=1,NWF 
               SUM_CMPX=0.0D0 
               do igL=1,NG_for_eps 
                do jgL=1,NG_for_eps 
                 SUM_CMPX
     +          =SUM_CMPX
     +          +rho(igL,iw,jw)
     +          *epsmk(igL,jgL,ie)
     +          *CONJG(rho(jgL,iw,jw)) 
                enddo!jgL
               enddo!igL
               do igL=NG_for_eps+1,NG_for_psi  
                 SUM_CMPX
     +          =SUM_CMPX
     +          +rho(igL,iw,jw)*CONJG(rho(igL,iw,jw)) 
               enddo!igL
               funcw(iw,jw,iq,ie)=SUM_CMPX 
              enddo!jw
             enddo!iw
            enddo!ie
!$OMP END DO 
!$OMP END PARALLEL 
            deallocate(epsmk,packtmp)  
            deallocate(rho)  
            write(6,*)'finish iq=',iq 
!q=0 
          elseif(q1==0.0d0.and.q2==0.0d0.and.q3==0.0d0)then 
           write(6,'(a,x,3f10.5)')'q1,q2,q3',q1,q2,q3 
           NG_for_eps=NGQ_eps(iq)
           NG_for_psi=NGQ_psi(iq)
           allocate(length_qg(NG_for_psi)) 
           length_qg(:)=0.0D0 
           do igL=1,NG_for_psi 
            igL1=LG0(1,igL,iq)
            igL2=LG0(2,igL,iq)
            igL3=LG0(3,igL,iq)
            if(igL1==0.and.igL2==0.and.igL3==0)then 
             NoG0=igL  
            else
             qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)
     +             +(q3+dble(igL3))*b3(:)
             qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
             qgL1=dsqrt(qgL2) 
             length_qg(igL)=qgL1
            endif  
           enddo!igL 
           allocate(rho(NG_for_psi,NWF,NWF));rho(:,:,:)=0.0D0 
!$OMP PARALLEL PRIVATE(ik,iw,jw,pf,ikq,shift_G,rho_tmp,C0_K,C0_KQ,
!$OMP&  wfunc,fftwk,prho)
           allocate(prho(NG_for_psi,NWF,NWF));prho(:,:,:)=0.0D0 
           allocate(rho_tmp(NG_for_psi));rho_tmp(:)=0.0d0 
           allocate(fftwk(Nl123*2));fftwk(:)=0.0d0  
           allocate(wfunc(Nl123*2));wfunc(:)=0.0d0 
           allocate(C0_K(NTG));C0_K(:)=0.0d0     
           allocate(C0_KQ(NTG));C0_KQ(:)=0.0d0  
!$OMP DO 
           do ik=1,NTK 
            do iw=1,NWF 
             do jw=1,NWF
              pf=exp(-ci*tpi*(SK0(1,ik)*dble(ia1)
     +                       +SK0(2,ik)*dble(ia2)
     +                       +SK0(3,ik)*dble(ia3))) 
              ikq=ik 
              shift_G(:)=0 
              rho_tmp(:)=0.0D0 
              C0_K(:)=C0(:,jw,ik) 
              C0_KQ(:)=C0(:,iw,ikq) 
              rho_tmp(:)=0.0D0 
              call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),
     +         C0_K(1),C0_KQ(1),ik,ikq,nwx2,nwy2,nwz2,nfft1,nfft2,
     +         Nl123,wfunc(1),fftwk(1),fs,LG0(1,1,iq),
     +         NG_for_psi,shift_G(1),rho_tmp(1))
              rho_tmp(NoG0)=0.0D0 
              prho(:,iw,jw)=prho(:,iw,jw)+rho_tmp(:)*pf  
             enddo!jw
            enddo!iw
           enddo!ik 
!$OMP END DO 
!$OMP CRITICAL 
        rho(:,:,:)=rho(:,:,:)+prho(:,:,:) 
!$OMP END CRITICAL 
        deallocate(prho,rho_tmp,fftwk,wfunc,C0_K,C0_KQ) 
!$OMP END PARALLEL 
           do iw=1,NWF 
            do jw=1,NWF 
             do igL=1,NG_for_psi  
              if(igL/=NoG0) then 
               rho(igL,iw,jw)=rho(igL,iw,jw)/length_qg(igL)/dble(NTK)  
              else 
               rho(igL,iw,jw)=rho(igL,iw,jw)/dble(NTK)  
              endif 
             enddo!igL 
             write(6,*)'rho(NoG0,iw,jw)=',rho(NoG0,iw,jw) 
            enddo!jw
           enddo!iw
           deallocate(length_qg)
!--
            do iw=1,NWF 
             do jw=1,NWF 
              SUM_CMPX=0.0D0 
              do igL=1,NG_for_psi  
               SUM_CMPX
     +        =SUM_CMPX
     +        +rho(igL,iw,jw)*CONJG(rho(igL,iw,jw)) 
              enddo 
              func(iw,jw,iq)=SUM_CMPX 
             enddo 
            enddo 
            allocate(epsmk(NTGQ,NTGQ,ne));epsmk(:,:,:)=0.0d0 
            allocate(packtmp(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3)) 
            iqir=numirrq(iq)
            iop=numrotq(iq)
            packtmp(:,:,:)=packingq(:,:,:,iqir) 
            call make_eps(NTG,NTGQ,ne,trsq(iq),NGQ_eps(iq),
     +       LG0(1,1,iq),RWq(1,iq),rginv(1,1,iop),pg(1,iop),
     +       nnp,Lq1,Lq2,Lq3,packtmp(-Lq1,-Lq2,-Lq3),
     +       epsirr(1,1,1,iqir),epsmk(1,1,1)) 
!$OMP PARALLEL PRIVATE(ie,iw,jw,SUM_CMPX,igL,jgL)
!$OMP DO 
            do ie=1,ne
             do iw=1,NWF
              do jw=1,NWF
               SUM_CMPX=0.0D0 
               do igL=1,NG_for_eps 
                do jgL=1,NG_for_eps 
                 SUM_CMPX
     +          =SUM_CMPX
     +          +rho(igL,iw,jw)
     +          *epsirr(igL,jgL,ie,iq)
     +          *CONJG(rho(jgL,iw,jw)) 
                enddo!jgL
               enddo!igL
               do igL=NG_for_eps+1,NG_for_psi  
                SUM_CMPX
     +         =SUM_CMPX
     +         +rho(igL,iw,jw)*CONJG(rho(igL,iw,jw)) 
               enddo!igL
               funcw(iw,jw,iq,ie)=SUM_CMPX 
              enddo!jw
             enddo!iw
            enddo!ie
!$OMP END DO 
!$OMP END PARALLEL 
            deallocate(epsmk,packtmp)  
            deallocate(rho)  
            write(6,*)'finish iq=',iq 
          endif!q=0.or.q/=0
         enddo!iq 
!--
          do iw=1,NWF 
           do jw=1,NWF 
            SUM_CMPX=0.0D0  
            do iq=1,NTQ 
             SUM_CMPX=SUM_CMPX+func(iw,jw,iq) 
            enddo 
            X_MAT(iw,jw,ia1,ia2,ia3)
     +     =2.0D0*tpi*SUM_CMPX/VOLUME/DBLE(NTQ) 
            write(6,'(a15,i3,i3,2f15.8)')
     +      'FINISH iw,jw',iw,jw,X_MAT(iw,jw,ia1,ia2,ia3) 
           enddo!jw 
          enddo!iw 
          do ie=1,ne
           do iw=1,NWF
            do jw=1,NWF 
             SUM_CMPX=0.0D0  
             do iq=1,NTQ 
              SUM_CMPX=SUM_CMPX+funcw(iw,jw,iq,ie) 
             enddo 
             J_MAT(iw,jw,ia1,ia2,ia3,ie)
     +      =2.0D0*tpi*SUM_CMPX/VOLUME/DBLE(NTQ) 
             write(6,'(a15,i3,i3,2f15.8)')
     +      'FINISH iw,jw',iw,jw,J_MAT(iw,jw,ia1,ia2,ia3,ie) 
            enddo!jw
           enddo!iw 
          enddo!ie
!--
        enddo!ia3      
       enddo!ia2 
      enddo!ia1      
!--
!CORRECTION TERM TO DIVERGENCE 
!--
      write(6,*)'HybertsenLouie'
      write(6,*)'iqgm=',iqgm 
      write(6,*)'NoG0=',NoG0
      qsz=(6.0D0*(pi**2)/dble(NTQ)/dble(VOLUME))**(1.0D0/3.0D0)  
      write(6,*)'qsz=',qsz
      write(6,*)'2*qsz/pi=',(2.0d0/pi)*qsz
       chead=(2.0D0/pi)*qsz 
       write(6,*)'chead(HL) in eV=',chead*au    
       do iw=1,NWF 
        X_MAT(iw,iw,0,0,0)=X_MAT(iw,iw,0,0,0)+chead       
       enddo 
       allocate(cheadw(ne));cheadw(:)=0.0d0 
       do ie=1,ne 
        cheadw(ie)=(2.0D0/pi)*epsirr(NoG0,NoG0,ie,iqgm)*qsz 
        write(6,*)'cheadw(HL) in eV=',cheadw(iw)*au   
        write(6,*)'1/eps=',epsirr(NoG0,NoG0,ie,iqgm)
       enddo 
       do ie=1,ne 
        do iw=1,NWF 
         J_MAT(iw,iw,0,0,0,ie)=J_MAT(iw,iw,0,0,0,ie)+cheadw(ie)      
        enddo 
       enddo 
!--
!write
       write(6,*)'# '
       write(6,*)'#-------------'
       write(6,*)'# X_MAT(bare) '
       write(6,*)'#-------------'
       write(6,*)'# '
       do ia1=ix_intJ_min,ix_intJ_max
        do ia2=iy_intJ_min,iy_intJ_max
         do ia3=iz_intJ_min,iz_intJ_max
          write(6,*) ia1,ia2,ia3           
          do iw=1,NWF
           write(6,'(100F12.5)')
     +     (dble(X_MAT(iw,jw,ia1,ia2,ia3))*au,jw=1,NWF)
          enddo 
          write(6,*) 
         enddo 
        enddo 
       enddo 
!--
!OPEN(206,W,FILE='dat.Xmat')
       call system('rm -rf dir-intJ') 
       call system('mkdir dir-intJ') 
       ierr=CHDIR("./dir-intJ") 
       call system("pwd") 
       OPEN(206,FILE='dat.Xmat') 
       rewind(206)
       write(206,'(a)')'#Bare exchamge: X' 
       write(206,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
       write(206,'(a)')'#1:i, 2:j, 3:Re(X_ij) [eV], 4:Im(X_ij) [eV]' 
       do ia1=ix_intJ_min,ix_intJ_max
        do ia2=iy_intJ_min,iy_intJ_max
         do ia3=iz_intJ_min,iz_intJ_max
          write(206,*) ia1,ia2,ia3           
          do iw=1,NWF
           do jw=1,NWF
            write(206,'(i5,i5,2f20.10)')
     +      iw,jw,X_MAT(iw,jw,ia1,ia2,ia3)*au 
           enddo!jw 
          enddo!iw 
          write(206,*) 
         enddo 
        enddo 
       enddo 
       close(206) 
!--
       ie=calc_ifreq          
       write(6,*)'# '
       write(6,*)'#-------------------------'
       write(6,*)'# J_MAT(omega=calc_ifreq) '
       write(6,*)'#-------------------------'
       write(6,*)'# '
       do ia1=ix_intJ_min,ix_intJ_max
        do ia2=iy_intJ_min,iy_intJ_max
         do ia3=iz_intJ_min,iz_intJ_max
          write(6,*) ia1,ia2,ia3           
          do iw=1,NWF
           write(6,'(100F12.5)')
     +     (dble(J_MAT(iw,jw,ia1,ia2,ia3,ie))*au,jw=1,NWF)
          enddo 
          write(6,*) 
         enddo 
        enddo 
       enddo 
!--
!OPEN(207,W,FILE='dat.Jmat')
       ie=calc_ifreq          
       OPEN(207,FILE='dat.Jmat') 
       rewind(207)
       write(207,'(a)')'#Screened exchamge: J at omega=calc_ifreq' 
       write(207,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
       write(207,'(a)')'#1:i, 2:j, 3:Re(J_ij) [eV], 4:Im(J_ij) [eV]' 
       do ia1=ix_intJ_min,ix_intJ_max
        do ia2=iy_intJ_min,iy_intJ_max
         do ia3=iz_intJ_min,iz_intJ_max
          write(207,*) ia1,ia2,ia3           
          do iw=1,NWF
           do jw=1,NWF
            write(207,'(i5,i5,2f20.10)') 
     +      iw,jw,J_MAT(iw,jw,ia1,ia2,ia3,ie)*au
           enddo!jw 
          enddo!iw 
          write(207,*) 
         enddo 
        enddo 
       enddo 
       close(207) 
!--
!       write(6,*)'# '
!       write(6,*)'#------'
!       write(6,*)'# J(w) '
!       write(6,*)'#------'
!       write(6,*)'# '
!       iw=I_WANNIER 
!       jw=J_WANNIER 
!       do ie=1,ne
!        write(6,'(4F12.5)') em(ie)*au,J_MAT(iw,jw,0,0,0,ie)*au    
!       enddo 
!--
!OPEN(208,W,FILE='dat.JvsE')
!       OPEN(208,FILE='./dir-intJ/dat.JvsE') 
!       rewind(208)
!       iw=I_WANNIER 
!       jw=J_WANNIER 
!       do ie=1,ne
!        write(208,'(4F12.5)') em(ie)*au,J_MAT(iw,jw,0,0,0,ie)*au    
!       enddo 
!       close(208) 
!--
!OPEN(3000,W,FILE='./dir-intJ/dat.JvsE')
      do iw=1,NWF
       do jw=iw,NWF 
        write(filename,'("dat.JvsE.",i3.3,"-",i3.3)') iw,jw  
        file_num=3000+(iw-1)*NWF+(jw-1)  
        OPEN(file_num,FILE=filename) 
        rewind(file_num) 
        write(file_num,'(a)')
     +  '#Omega dependence of screened exchange J' 
        write(file_num,'(a)')
     +  '#Re(w) [eV], Im(w) [eV], Re[J(w)] [eV], Im[J(w)] [eV]'
        do ie=1,ne
         write(file_num,'(4F12.5)') em(ie)*au,J_MAT(iw,jw,0,0,0,ie)*au 
        enddo 
        close(file_num) 
       enddo
      enddo
      ierr=CHDIR("..") 
      call system("pwd") 
!--
!write model_parameter  
      ierr=CHDIR("./dir-model") 
      call system("pwd") 
      ie=calc_ifreq          
      !jcut_model=jcut_model/au 
      !
      !old: 20180604
      !
      ! call wrt_model(nkb1,nkb2,nkb3,NTK,Na1,Na2,Na3,NWF,jcut_model,
      !+     J_MAT(1,1,-Na1,-Na2,-Na3,ie)) 
      !
      !new: 20181127 
      !
      !WEIGHT_R 20170317 by Y.Nomura 
      !
      allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
      SUM_REAL=0.0d0 
      do ia1=-Na1,Na1
       do ia2=-Na2,Na2
        do ia3=-Na3,Na3
         if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) 
     +    WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
         SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
        enddo!ia3
       enddo!ia2
      enddo!ia1 
      write(6,'(a20,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
      if(abs(SUM_REAL-dble(NTK))>1.0d-6)then 
       stop 'SUM_WEIGHT/=NTK'
      endif 
      !
      call wrt_model(Na1,Na2,Na3,NWF,J_MAT(1,1,-Na1,-Na2,-Na3,ie),
     + WEIGHT_R(-Na1,-Na2,-Na3)) 
      !
      ierr=CHDIR("..") 
      call system("pwd") 
      ! 
      deallocate(C0,epsirr) 
      !
      STOP
      END           

subroutine wrt_model(Na1,Na2,Na3,n_occ,UR,WR) 
implicit none 
integer::Na1,Na2,Na3,n_occ 
integer::N_element
integer::ia1,ia2,ia3,ib,jb,i 
integer,allocatable::unit_vec(:)!unit_vec(N_element) 
complex(8)::UR(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3)
real(8)::WR(-Na1:Na1,-Na2:Na2,-Na3:Na3)
real(8),parameter::au=27.21151d0
!
N_element=(2*Na1+1)*(2*Na2+1)*(2*Na3+1)  
!
!OPEN(301,W,FILE='zvo_ur.dat') 
!
OPEN(301,FILE='zvo_ur.dat') 
write(301,'(a)')'wannier90 format for vmcdry.out or HPHI -sdry'
write(301,'(i10)') n_occ
write(301,'(i10)') N_element 
!
allocate(unit_vec(N_element)); unit_vec=1
write(301,'(15i5)')(unit_vec(i),i=1,N_element) 
deallocate(unit_vec) 
do ia1=-Na1,Na1
 do ia2=-Na2,Na2
  do ia3=-Na3,Na3 
   do ib=1,n_occ
    do jb=1,n_occ
     write(301,'(i5,i5,i5,i5,i5,2f15.10)') ia1,ia2,ia3,ib,jb,UR(ib,jb,ia1,ia2,ia3)*WR(ia1,ia2,ia3)*au   
    enddo!jb
   enddo!ib
  enddo!ia3
 enddo!ia2
enddo!ia1 
return
end 

module m_dmx 
  implicit none
contains
  !
  subroutine calculate_dmx(NTB,NTK,NWF,nkb1,nkb2,nkb3,Na1,Na2,Na3,FermiEnergy,a1,a2,a3,b1,b2,b3,SK0,EIG,UNT)
    implicit none 
    integer,intent(in)::NTB,NWF,NTK,nkb1,nkb2,nkb3,Na1,Na2,Na3 
    real(8),intent(in)::FermiEnergy 
    real(8),intent(in)::a1(3),a2(3),a3(3)
    real(8),intent(in)::b1(3),b2(3),b3(3)
    real(8),intent(in)::SK0(3,NTK) 
    real(8),intent(in)::EIG(NTB,NTK)
    complex(8),intent(in)::UNT(NTB,NWF,NTK) 
    !
    integer,allocatable::lat_num_a1(:),lat_num_a2(:),lat_num_a3(:) 
    real(8),allocatable::WEIGHT_R(:,:,:) 
    real(8),allocatable::xow(:,:,:,:)
    complex(8),allocatable::pf(:,:,:,:) 
    complex(8),allocatable::dmx(:,:,:,:,:) 
    integer::NR 
    integer,parameter::flg_weight=1 
    !
    !1. lat_num_a%
    !
    NR=(2*Na1+1)*(2*Na2+1)*(2*Na3+1) 
    allocate(lat_num_a1(NR)); lat_num_a1=0  
    allocate(lat_num_a2(NR)); lat_num_a2=0  
    allocate(lat_num_a3(NR)); lat_num_a3=0  
    call make_lat_num(Na1,Na2,Na3,NR,lat_num_a1(1),lat_num_a2(1),lat_num_a3(1)) 
    !
    !2. xow(ib,ik) 
    !
    allocate(xow(NTB,nkb1,nkb2,nkb3)); xow=0.0d0 
    call make_xow(nkb1,nkb2,nkb3,NTB,NTK,FermiEnergy,b1(1),b2(1),b3(1),SK0(1,1),EIG(1,1),xow(1,1,1,1)) 
    !
    !3. WEIGHT_R
    !
    allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
    call make_WEIGHT_R(nkb1,nkb2,nkb3,Na1,Na2,Na3,NTK,flg_weight,WEIGHT_R(-Na1,-Na2,-Na3)) 
    !
    !4. phase factor
    !
    allocate(pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)); pf=0.0d0 
    call make_pf(Na1,Na2,Na3,nkb1,nkb2,nkb3,NTK,a1(1),a2(1),a3(1),SK0(1,1),pf(-Na1,-Na2,-Na3,1)) 
    !
    !5. density matrix 
    !
    allocate(dmx(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)); dmx=0.0d0   
    call make_dmx(Na1,Na2,Na3,NR,NTB,NTK,NWF,nkb1,nkb2,nkb3,lat_num_a1(1),lat_num_a2(1),lat_num_a3(1),&
    SK0(1,1),UNT(1,1,1),xow(1,1,1,1),pf(-Na1,-Na2,-Na3,1),WEIGHT_R(-Na1,-Na2,-Na3),dmx(1,1,-Na1,-Na2,-Na3)) 
    !
    !6. write density matrix
    call wrt_model_dr(NWF,Na1,Na2,Na3,dmx(1,1,-Na1,-Na2,-Na3))
    ! 
    deallocate(WEIGHT_R,pf,xow,lat_num_a1,lat_num_a2,lat_num_a3,dmx) 
    !
    return 
  end subroutine calculate_dmx 

  subroutine make_lat_num(Na1,Na2,Na3,NR,lat_num_a1,lat_num_a2,lat_num_a3) 
    implicit none
    integer,intent(in)::Na1,Na2,Na3,NR 
    integer,intent(out)::lat_num_a1(NR)
    integer,intent(out)::lat_num_a2(NR)
    integer,intent(out)::lat_num_a3(NR)
    integer::ia1,ia2,ia3,iR 
    !
    do ia1=-Na1,Na1
     do ia2=-Na2,Na2
      do ia3=-Na3,Na3
       iR=(ia3+Na3+1)+(ia2+Na2)*(2*Na3+1)+(ia1+Na1)*(2*Na3+1)*(2*Na2+1) 
       lat_num_a1(iR)=ia1
       lat_num_a2(iR)=ia2
       lat_num_a3(iR)=ia3 
      enddo
     enddo
    enddo 
    !
    return 
  end subroutine make_lat_num 

  subroutine make_xow(nkb1,nkb2,nkb3,NTB,NTK,FermiEnergy,b1,b2,b3,SK0,E_EIG,xow) 
    use m_tetrainteg
    implicit none 
    integer,intent(in)::nkb1,nkb2,nkb3,NTB,NTK
    real(8),intent(in)::FermiEnergy 
    real(8),intent(in)::b1(3),b2(3),b3(3)
    real(8),intent(in)::SK0(3,NTK) 
    real(8),intent(in)::E_EIG(NTB,NTK) 
    real(8),intent(out)::xow(NTB,nkb1,nkb2,nkb3) 
    !
    integer::index_kpt(nkb1,nkb2,nkb3) 
    integer::imt1(4*nkb1*nkb2*nkb3*6)  
    complex(8)::fk_3D(nkb1,nkb2,nkb3) 
    complex(8)::gk_1D(NTK)
    complex(8)::gk_3D(nkb1,nkb2,nkb3)
    complex(8)::xo(nkb1,nkb2,nkb3)  
    complex(8)::ca1(4)
    complex(8)::omega(1)  
    integer::ib,ikb1,ikb2,ikb3,ik 
    real(8)::SUM_REAL 
    real(8),parameter::au=27.21151d0
    !real(8),parameter::delt=0.005d0/au!Greens function delt in au 
    real(8),parameter::delt=0.01d0/au!Greens function delt in au 
    real(8),parameter::dmna=1.0d-3!Ttrhdrn parameter dmna in au 
    real(8),parameter::dmnr=1.0d-3!Ttrhdrn parameter dmnr in au 
    real(8),parameter::pi=dacos(-1.0d0)
    !
    index_kpt=0 
    call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
    !
    imt1=0 
    call ttritg_mkidx(nkb1,nkb2,nkb3,imt1(1),b1(1),b2(1),b3(1)) 
    !
    omega(1)=cmplx(FermiEnergy,0.0d0)
    !
    !   !$OMP PARALLEL PRIVATE(ik,ib,gk_1D,fk_3D,gk_3D,ikb3,ikb2,ikb1,xo,ca1) 
    !   !$OMP DO 
    do ib=1,NTB
     do ik=1,NTK 
      gk_1D(ik)=cmplx(-E_EIG(ib,ik),-delt) 
     enddo 
     gk_3D=0.0d0 
     do ikb3=1,nkb3
      do ikb2=1,nkb2
       do ikb1=1,nkb1 
        ik=index_kpt(ikb1,ikb2,ikb3)
        gk_3D(ikb1,ikb2,ikb3)=gk_1D(ik) 
       enddo
      enddo
     enddo 
     fk_3D=1.0d0 
     xo=0.0d0 
     ca1=0.0d0 
     call ttritg_sum(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),fk_3D(1,1,1),gk_3D(1,1,1),1,omega(1),ca1(1),xo(1,1,1)) 
     xow(ib,:,:,:)=dabs(dimag(xo(:,:,:)))/pi  
    enddo!ib 
    !    !$OMP END DO 
    !    !$OMP END PARALLEL 
    !
    SUM_REAL=0.0d0 
    do ikb3=1,nkb3
     do ikb2=1,nkb2
      do ikb1=1,nkb1
       do ib=1,NTB 
        SUM_REAL=SUM_REAL+xow(ib,ikb1,ikb2,ikb3)  
       enddo 
      enddo 
     enddo 
    enddo 
    write(6,'(a40)')'+++ m_dmx: make_xow +++' 
    write(6,'(a40,f15.8)')'(2/N)sum_{a,k}f(a,k)',2.0d0*SUM_REAL/dble(NTK) !2 is spin   
    write(6,*) 
    return 
  end subroutine make_xow 

  subroutine make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0,index_kpt)      
    implicit none 
    integer,intent(in)::NTK,nkb1,nkb2,nkb3
    real(8),intent(in)::SK0(3,NTK)  
    integer,intent(out)::index_kpt(nkb1,nkb2,nkb3)    
    integer::ik,ix,iy,iz
    real(8)::x,y,z
    ! 
    !if(MOD(NTK,2)/=0)then 
    ! !write(6,*)'i am in make_index for odd'
    ! do ik=1,NTK 
    !  x=SK0(1,ik)*dble(nkb1) 
    !  y=SK0(2,ik)*dble(nkb2)
    !  z=SK0(3,ik)*dble(nkb3)  
    !  x=x+(dble(nkb1)-1.0d0)/2.0d0 
    !  y=y+(dble(nkb2)-1.0d0)/2.0d0
    !  z=z+(dble(nkb3)-1.0d0)/2.0d0 
    !  ix=idnint(x)+1
    !  iy=idnint(y)+1
    !  iz=idnint(z)+1
    !  index_kpt(ix,iy,iz)=ik
    ! enddo 
    !else!20170316 
    ! !write(6,*)'i am in make_index for even'
    ! do ik=1,NTK 
    !  x=SK0(1,ik)*dble(nkb1) 
    !  y=SK0(2,ik)*dble(nkb2)
    !  z=SK0(3,ik)*dble(nkb3)  
    !  x=x+dble(nkb1)/2.0d0 
    !  y=y+dble(nkb2)/2.0d0
    !  z=z+dble(nkb3)/2.0d0 
    !  ix=idnint(x)
    !  iy=idnint(y)
    !  iz=idnint(z)
    !  index_kpt(ix,iy,iz)=ik
    ! enddo 
    !endif 
    !--
    !
    !20190520 Kazuma Nakamura
    !
    do ik=1,NTK 
     x=SK0(1,ik)*dble(nkb1) 
     y=SK0(2,ik)*dble(nkb2)
     z=SK0(3,ik)*dble(nkb3)  
     x=x+(dble(nkb1)-dble(mod(nkb1,2)))/2.0d0 
     y=y+(dble(nkb2)-dble(mod(nkb2,2)))/2.0d0 
     z=z+(dble(nkb3)-dble(mod(nkb3,2)))/2.0d0 
     ix=idnint(x)+mod(nkb1,2)
     iy=idnint(y)+mod(nkb2,2)
     iz=idnint(z)+mod(nkb3,2)
     index_kpt(ix,iy,iz)=ik
    enddo 
    ! 
    return 
  end subroutine  

  subroutine make_WEIGHT_R(nkb1,nkb2,nkb3,Na1,Na2,Na3,NTK,flg_weight,WEIGHT_R) 
    implicit none 
    integer,intent(in)::nkb1,nkb2,nkb3,Na1,Na2,Na3,NTK,flg_weight  
    real(8),intent(out)::WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
    integer::ia1,ia2,ia3
    real(8)::SUM_REAL 
    real(8),parameter::dlt_eps=1.0d-6 
    !
    if(flg_weight.eq.1)then
     write(6,'(a40)')'WEIGHT CALCULATED' 
     SUM_REAL=0.0d0 
     do ia1=-Na1,Na1
      do ia2=-Na2,Na2
       do ia3=-Na3,Na3
        if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
        if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
        if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
        SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
       enddo!ia3
      enddo!ia2
     enddo!ia1
     write(6,'(a40,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
     if(abs(SUM_REAL-dble(NTK))>dlt_eps)then 
      stop 'SUM_WEIGHT/=NTK'
     endif 
    else
     write(6,'(a40)')'WEIGHT NOT CALCULATED' 
    endif 
    !
    return 
  end subroutine make_WEIGHT_R 

  subroutine make_pf(Na1,Na2,Na3,nkb1,nkb2,nkb3,NTK,a1,a2,a3,SK0,pf) 
    implicit none 
    integer,intent(in)::Na1,Na2,Na3,nkb1,nkb2,nkb3,NTK 
    real(8),intent(in)::a1(3),a2(3),a3(3) 
    real(8),intent(in)::SK0(3,NTK) 
    complex(8),intent(out)::pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)   
    integer::ia1,ia2,ia3,ik 
    integer::ia1min,ia2min,ia3min 
    real(8)::PHASE 
    complex(8),parameter::ci=(0.0D0,1.0D0) 
    real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
    !
    do ik=1,NTK 
     do ia3=-Na3,Na3 
      do ia2=-Na2,Na2 
       do ia1=-Na1,Na1 
        call search_Rmin(ia1,ia2,ia3,nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),ia1min,ia2min,ia3min)
        PHASE=tpi*(SK0(1,ik)*DBLE(ia1min)+SK0(2,ik)*DBLE(ia2min)+SK0(3,ik)*DBLE(ia3min))           
        pf(ia1,ia2,ia3,ik)=EXP(-ci*PHASE) !notice minus sign
       enddo!ia1 
      enddo!ia2 
     enddo!ia3 
    enddo!ik  
    !
    return 
  end subroutine make_pf 

  subroutine search_Rmin(i,j,k,nkb1,nkb2,nkb3,a1,a2,a3,imin,jmin,kmin)
    implicit none
    integer,intent(in)::i,j,k,nkb1,nkb2,nkb3
    real(8),intent(in)::a1(3),a2(3),a3(3) 
    integer,intent(out)::imin,jmin,kmin
    integer::nmin,mmin,lmin
    integer::n,m,l 
    real(8)::R_pos(3),R_abs,R_min,R_bfr
    R_pos(:)=dble(i)*a1(:)+dble(j)*a2(:)+dble(k)*a3(:)
    nmin=0;mmin=0;lmin=0
    R_bfr=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
    R_min=R_bfr 
    do n=-3,3
     do m=-3,3
      do l=-3,3
       R_pos(:)=dble(i+n*nkb1)*a1(:)+dble(j+m*nkb2)*a2(:)+dble(k+l*nkb3)*a3(:)
       R_abs=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
       if(R_min>R_abs)then 
        R_min=R_abs
        nmin=n
        mmin=m
        lmin=l
       endif 
      enddo
     enddo
    enddo
    imin=i+nmin*nkb1
    jmin=j+mmin*nkb2
    kmin=k+lmin*nkb3
    return
  end subroutine search_Rmin
  
  subroutine make_dmx(Na1,Na2,Na3,NR,NTB,NTK,NWF,nkb1,nkb2,nkb3,lat_num_a1,lat_num_a2,lat_num_a3,SK0,UNT,xow,pf,WEIGHT_R,dmx) 
    implicit none
    integer,intent(in)::Na1,Na2,Na3,NR,NTB,NTK,NWF,nkb1,nkb2,nkb3   
    integer,intent(in)::lat_num_a1(NR),lat_num_a2(NR),lat_num_a3(NR)
    real(8),intent(in)::SK0(3,NTK) 
    real(8),intent(in)::WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
    real(8),intent(in)::xow(NTB,nkb1,nkb2,nkb3) 
    complex(8),intent(in)::UNT(NTB,NWF,NTK) 
    complex(8),intent(in)::pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK) 
    complex(8),intent(out)::dmx(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
    integer::iR,ia1,ia2,ia3,iw,jw,ib,ikb1,ikb2,ikb3,ik 
    integer::index_kpt(nkb1,nkb2,nkb3) 
    real(8)::DMX_REAL 
    complex(8)::SUM_CMPX,DMX_CMPX
    !
    index_kpt=0 
    call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
    !
    !write(6,*) 
    !write(6,'(a40)')'+++ m_dmx: UNT check +++' 
    !do iw=1,NWF
    ! SUM_CMPX=0.0d0 
    ! do ib=1,NTB 
    !  do ikb1=1,nkb1
    !   do ikb2=1,nkb2
    !    do ikb3=1,nkb3 
    !     ik=index_kpt(ikb1,ikb2,ikb3)
    !     write(6,'(a,i8,2f15.8)')'pf000ik',ik,pf(0,0,0,ik)  
    !     SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*UNT(ib,iw,ik)*pf(0,0,0,ik)*WEIGHT_R(0,0,0)*xow(ib,ikb1,ikb2,ikb3) 
    !    enddo
    !   enddo
    !  enddo
    ! enddo 
    ! write(6,'(a40,i8,x,2f15.10)')'(2/N)sum_{a,k}|<ak|i0>|^2',iw,2.0d0*SUM_CMPX/dble(NTK)  
    !enddo 
    !
    dmx=0.0d0 
    do iR=1,NR 
     ia1=lat_num_a1(iR)
     ia2=lat_num_a2(iR)
     ia3=lat_num_a3(iR)
     !write(6,'(3i5,f15.8)')ia1,ia2,ia3,WEIGHT_R(ia1,ia2,ia3) 
     do iw=1,NWF
      do jw=1,NWF 
       SUM_CMPX=0.0d0 
       do ib=1,NTB 
        do ikb1=1,nkb1
         do ikb2=1,nkb2
          do ikb3=1,nkb3 
           ik=index_kpt(ikb1,ikb2,ikb3)
           SUM_CMPX&
          =SUM_CMPX&
          +CONJG(UNT(ib,iw,ik))*UNT(ib,jw,ik)*xow(ib,ikb1,ikb2,ikb3)*pf(ia1,ia2,ia3,ik)*WEIGHT_R(ia1,ia2,ia3)  
          enddo!ikb1
         enddo!ikb2
        enddo!ikb3
       enddo!ib  
       dmx(iw,jw,ia1,ia2,ia3)=2.0d0*SUM_CMPX/dble(NTK) !2 is spin   
      enddo!jw 
     enddo!iw 
    enddo!iR 
    ! 
    !impose sum rule
    !
    SUM_CMPX=0.0d0 
    do iw=1,NWF
     SUM_CMPX=SUM_CMPX+dmx(iw,iw,0,0,0) 
    enddo 
    write(6,*) 
    write(6,'(a40)')'+++ m_dmx: Tr(DMX) +++' 
    DMX_REAL=dble(nint(dble(SUM_CMPX))) 
    DMX_CMPX=cmplx(DMX_REAL,0.0d0)    
    write(6,'(a40,2f15.10)')'before correction',SUM_CMPX 
    write(6,'(a40,2f15.10)')'after  correction',DMX_CMPX 
    do iw=1,NWF
     dmx(iw,iw,0,0,0)=dmx(iw,iw,0,0,0)*(DMX_CMPX/SUM_CMPX) 
    enddo 
    !
    return 
  end subroutine make_dmx 

  subroutine wrt_model_dr(NWF,Na1,Na2,Na3,DR) 
    implicit none 
    integer,intent(in)::NWF,Na1,Na2,Na3 
    complex(8),intent(in)::DR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)
    integer::N_element 
    integer::ia1,ia2,ia3,ib,jb,i 
    integer,allocatable::unit_vec(:)!unit_vec(N_element) 
    real(8),parameter::au=27.21151d0
    !
    N_element=(2*Na1+1)*(2*Na2+1)*(2*Na3+1)  
    !
    !OPEN(307,W,FILE='zvo_dr.dat') 
    !
    OPEN(307,FILE='./dir-model/zvo_dr.dat') 
    write(307,'(a)')'wannier90 format for vmcdry.out or HPhi -sdry'
    write(307,'(i10)') NWF 
    write(307,'(i10)') N_element
    !
    allocate(unit_vec(N_element)); unit_vec=1
    write(307,'(15i5)')(unit_vec(i),i=1,N_element) 
    deallocate(unit_vec) 
    !
    do ia1=-Na1,Na1
     do ia2=-Na2,Na2
      do ia3=-Na3,Na3 
       do ib=1,NWF 
        do jb=1,NWF 
         write(307,'(i5,i5,i5,i5,i5,2f15.10)') ia1,ia2,ia3,ib,jb,DR(ib,jb,ia1,ia2,ia3) 
        enddo!jb
       enddo!ib
      enddo!ia3
     enddo!ia2
    enddo!ia1 
    return
    !
  end subroutine wrt_model_dr 
  !
end module m_dmx 

module m_eigenstate  
  implicit none
contains
  !
  subroutine calculate_eigenstate(NWF,Na1,Na2,Na3,HKS,NTK,nkb1,nkb2,nkb3,a1,a2,a3,flg_weight,Ncalck,SK0,EKS,VKS) 
    implicit none 
    integer,intent(in)::NWF,Na1,Na2,Na3
    complex(8),intent(in)::HKS(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
    integer,intent(in)::NTK,nkb1,nkb2,nkb3 
    real(8),intent(in)::a1(3),a2(3),a3(3)
    integer,intent(in)::flg_weight 
    integer,intent(in)::Ncalck
    real(8),intent(in)::SK0(3,Ncalck) 
    real(8),intent(out)::EKS(NWF,Ncalck)           
    complex(8),intent(out)::VKS(NWF,NWF,Ncalck)   
    real(8),allocatable::WEIGHT_R(:,:,:)!WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
    complex(8),allocatable::pf(:,:,:,:)!pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)   
    integer::ia1min,ia2min,ia3min 
    integer::ia1,ia2,ia3,ik 
    real(8)::PHASE 
    real(8)::SUM_REAL
    real(8),parameter::au=27.21151d0
    real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
    complex(8),parameter::ci=(0.0D0,1.0D0) 
    !
    !WEIGHT_R BY Y.Nomura NOMURA 
    !
    allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
    if(flg_weight.eq.1)then
     write(6,'(a40)')'WEIGHT CALCULATED' 
     call make_WEIGHT_R(nkb1,nkb2,nkb3,Na1,Na2,Na3,NTK,WEIGHT_R(-Na1,-Na2,-Na3)) 
    else
     write(6,'(a40)')'WEIGHT NOT CALCULATED' 
    endif 
    !
    !phase factor
    !
    allocate(pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,Ncalck)); pf=0.0d0 
    do ik=1,Ncalck 
     do ia3=-Na3,Na3 
      do ia2=-Na2,Na2 
       do ia1=-Na1,Na1 
        !
        !NEAREST R SEARCH BY Y.Yoshimoto 
        !
        call search_Rmin(ia1,ia2,ia3,nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),ia1min,ia2min,ia3min)
        PHASE=tpi*(SK0(1,ik)*DBLE(ia1min)+SK0(2,ik)*DBLE(ia2min)+SK0(3,ik)*DBLE(ia3min))           
        pf(ia1,ia2,ia3,ik)=EXP(ci*PHASE)*WEIGHT_R(ia1,ia2,ia3)          
       enddo!ia1 
      enddo!ia2 
     enddo!ia3 
    enddo!ik  
    !
    !HKS IN WANNIER BASIS. AND DIAGONALIZE
    !
    EKS=0.0d0 
    VKS=0.0d0 
    call eigenvalue(Ncalck,NWF,Na1,Na2,Na3,HKS(1,1,-Na1,-Na2,-Na3),pf(-Na1,-Na2,-Na3,1),EKS(1,1),VKS(1,1,1))  
    !
    deallocate(WEIGHT_R,pf) 
    !
    return 
  end subroutine calculate_eigenstate 

  subroutine search_Rmin(i,j,k,nkb1,nkb2,nkb3,a1,a2,a3,imin,jmin,kmin)
    implicit none
    integer::i,j,k,nkb1,nkb2,nkb3
    integer::imin,jmin,kmin
    real(8)::a1(3),a2(3),a3(3) 
    integer::nmin,mmin,lmin
    integer::n,m,l 
    real(8)::R_pos(3),R_abs,R_min,R_bfr
    R_pos(:)=dble(i)*a1(:)+dble(j)*a2(:)+dble(k)*a3(:)
    nmin=0;mmin=0;lmin=0
    R_bfr=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
    R_min=R_bfr 
    do n=-3,3
     do m=-3,3
      do l=-3,3
       R_pos(:)=dble(i+n*nkb1)*a1(:)+dble(j+m*nkb2)*a2(:)+dble(k+l*nkb3)*a3(:)
       R_abs=dsqrt(R_pos(1)**2+R_pos(2)**2+R_pos(3)**2) 
       if(R_min>R_abs)then 
        R_min=R_abs
        nmin=n
        mmin=m
        lmin=l
       endif 
      enddo
     enddo
    enddo
    imin=i+nmin*nkb1
    jmin=j+mmin*nkb2
    kmin=k+lmin*nkb3
    return
  end subroutine 

  subroutine eigenvalue(NTK,NWF,Na1,Na2,Na3,HmatR,pf,EKS,VKS)  
    implicit none 
    integer,intent(in)::NTK,NWF,Na1,Na2,Na3 
    complex(8),intent(in)::pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK)   
    complex(8),intent(in)::HmatR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
    real(8),intent(inout)::EKS(NWF,NTK)           
    complex(8),intent(inout)::VKS(NWF,NWF,NTK)  
    complex(8),allocatable::Hin(:,:)!Hin(NWF,NWF)          
    real(8),allocatable::E_TMP_R(:)!E_TMP_R(NWF)           
    integer::ik,ib,jb,ia1,ia2,ia3
    complex(8)::SUM_CMPX 
    allocate(Hin(NWF,NWF)); Hin=0.0d0           
    allocate(E_TMP_R(NWF)); E_TMP_R=0.0d0            
    !
    EKS=0.0d0 
    VKS=0.0d0 
    do ik=1,NTK 
     Hin(:,:)=0.0D0               
     do ib=1,NWF      
      do jb=1,NWF      
       SUM_CMPX=0.0D0                    
       do ia1=-Na1,Na1 
        do ia2=-Na2,Na2 
         do ia3=-Na3,Na3 
          SUM_CMPX=SUM_CMPX+HmatR(ib,jb,ia1,ia2,ia3)*pf(ia1,ia2,ia3,ik)  
         enddo!ia3            
        enddo!ia2                       
       enddo!ia1
       Hin(ib,jb)=SUM_CMPX           
      enddo!jb 
     enddo!ib 
     E_TMP_R(:)=0.0D0 
     call diagV(NWF,Hin(1,1),E_TMP_R(1)) 
     EKS(:,ik)=E_TMP_R(:) 
     !
     !H(ib,jb):: ib: basis, jb: eigenvector
     !
     ![NOTE] trnspose 
     !
     !VKS(jb,ib):: jb: eigenvector, ib: basis 
     !
     do ib=1,NWF
      do jb=1,NWF
       VKS(jb,ib,ik)=Hin(ib,jb) 
      enddo
     enddo
     !
    enddo!ik 
    deallocate(Hin,E_TMP_R) 
    !
    return
  end subroutine 

  subroutine diagV(nm,mat,eig)
    implicit none 
    integer,intent(in)::nm
    complex(8),intent(inout)::mat(nm,nm)
    real(8),intent(out)::eig(nm)
    integer::LWORK,LRWORK,LIWORK  
    integer,allocatable::iwork_zheevd(:)
    real(8),allocatable::rwork_zheevd(:)
    complex(8),allocatable::work_zheevd(:)
    integer::ind
    real(8)::eps 
    !
    LWORK= 2*nm+nm**2
    LRWORK=1+12*nm+3*nm**2
    LIWORK=3+10*nm 
    allocate(work_zheevd(LWORK));work_zheevd(:)=0.0d0
    allocate(rwork_zheevd(LRWORK));rwork_zheevd(:)=0.0d0
    allocate(iwork_zheevd(LIWORK));iwork_zheevd(:)=0
    eps=1.0d-18
    ind=0                 
    !
    call zheevd("V","U",nm,mat,nm,eig,work_zheevd,LWORK,rwork_zheevd,LRWORK,iwork_zheevd,LIWORK,ind)
    !
    if(ind/=0)then 
     write(6,'(a40,i15)')'ind=',ind 
     stop
    endif 
    !
    deallocate(work_zheevd,rwork_zheevd,iwork_zheevd) 
    return 
  end subroutine
  
  subroutine diagN(nm,mat,eig)
    implicit none 
    integer,intent(in)::nm
    complex(8),intent(inout)::mat(nm,nm)
    real(8),intent(out)::eig(nm)
    integer::LWORK,LRWORK,LIWORK  
    integer,allocatable::iwork_zheevd(:)
    real(8),allocatable::rwork_zheevd(:)
    complex(8),allocatable::work_zheevd(:)
    integer::ind
    real(8)::eps 
    !
    LWORK= 2*nm+nm**2
    LRWORK=1+12*nm+3*nm**2
    LIWORK=3+10*nm 
    allocate(work_zheevd(LWORK));work_zheevd(:)=0.0d0
    allocate(rwork_zheevd(LRWORK));rwork_zheevd(:)=0.0d0
    allocate(iwork_zheevd(LIWORK));iwork_zheevd(:)=0
    eps=1.0d-18
    ind=0                 
    !
    call zheevd("N","U",nm,mat,nm,eig,work_zheevd,LWORK,rwork_zheevd,LRWORK,iwork_zheevd,LIWORK,ind)
    !
    if(ind/=0)then 
     write(6,'(a40,i15)')'ind=',ind 
     stop
    endif 
    !
    deallocate(work_zheevd,rwork_zheevd,iwork_zheevd) 
    return 
  end subroutine
  !
  subroutine make_WEIGHT_R(nkb1,nkb2,nkb3,Na1,Na2,Na3,NTK,WEIGHT_R) 
    implicit none 
    integer,intent(in)::nkb1,nkb2,nkb3,Na1,Na2,Na3,NTK 
    real(8),intent(out)::WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
    integer::ia1,ia2,ia3
    real(8)::SUM_REAL 
    real(8),parameter::dlt_eps=1.0d-6 
    !
    SUM_REAL=0.0d0 
    do ia1=-Na1,Na1
     do ia2=-Na2,Na2
      do ia3=-Na3,Na3
       if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
       if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
       if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
       SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
      enddo!ia3
     enddo!ia2
    enddo!ia1
    write(6,'(a40,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
    if(abs(SUM_REAL-dble(NTK))>dlt_eps)then 
     stop 'SUM_WEIGHT/=NTK'
    endif 
    !
    return 
  end subroutine make_WEIGHT_R 
  !
end module m_eigenstate 

!
!     Generalized Tetrahedron Method
!
!     (Copyright) 2003 Takeo Fujiwara, Susumu Yamamoto, Yasushi Ishii, and
!     Yoshiro Nohara
!
!     This program uses the generalized tetrahedron method and implements
!     an efficient tool in the GW-LMTO package developed by Fujiwara group
!     in University of Tokyo. The algorithm of the generalized tetrahedron
!     method is written in the following published papers:
!
!     [Generalized tetrahedron method] Takeo Fujiwara, Susumu Yamamoto, and
!     Yasushi Ishii, J. Phys. Soc. Jpn. 72, No.4, 777-780 (2003).
!     (cond.mat/0211159)
!
!     [GW-LMTO package] Yoshiro Nohara, Susumu Yamamoto, and Takeo Fujiwara,
!     Phys. Rev. B 79, 195110 (2009)
!
!     One can use this part of the program package in one's developed code
!     on the condition of citing these two papers and mentioning the name of
!     `the generalized tetrahedron method'  in the published paper.
!
!     For those not following the above, this part of the program package is also
!     released under the MIT License. http://opensource.org/licenses/mit-license.php
!
      module m_tetrahedron
      implicit none
      private

      public :: ttrhdrn_mkidx
      public :: ttrhdrn_chi0
      public :: ttrhdrn_sum
      public :: ttrhdrn_simple
      public :: ttrhdrn_sub1normal
      public :: ttrhdrn_sub1simple
      public :: ttrhdrn_sub1g30g20
      public :: ttrhdrn_sub1g30g21
      public :: ttrhdrn_sub1g30
      public :: ttrhdrn_sub2normal
      public :: ttrhdrn_sub2simple
      public :: ttrhdrn_sub2g30g20
      public :: ttrhdrn_sub2g30g10
      public :: ttrhdrn_sub2g30g21
      public :: ttrhdrn_sub2g30
      public :: ttrhdrn_sub2g10


      integer, parameter, public :: ttrhdrn_vtx=4
      integer, parameter, public :: ttrhdrn_div=6
      integer, parameter :: nvtx=ttrhdrn_vtx
      integer, parameter :: ndiv=ttrhdrn_div
      integer, parameter, public :: ttrhdrn_tbl1(nvtx,ndiv)
     $                       =reshape((/1,2,3,6
     $                                 ,1,3,5,6
     $                                 ,3,5,6,7
     $                                 ,2,3,4,6
     $                                 ,3,4,6,8
     $                                 ,3,6,7,8/)
     $                               ,(/nvtx,ndiv/))

      contains

      subroutine ttrhdrn_simple(dmna,dmnr,n1,n2,n3,imt1,fk,gk,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: n1
      integer, intent(in) :: n2
      integer, intent(in) :: n3
      integer, intent(in) :: imt1(nvtx,n1*n2*n3*ndiv)
      complex(8), intent(in) :: fk(n1*n2*n3)
      complex(8), intent(in) :: gk(n1*n2*n3)
      complex(8), intent(inout) :: xo(n1*n2*n3)
      complex(8) :: ca1(nvtx),ca2(1)
      ca2=(0.d0,0.d0)
      call ttrhdrn_sum(dmna,dmnr,n1,n2,n3,imt1,fk,gk
     $                ,1,ca2,ca1,xo)
      end subroutine

      subroutine ttrhdrn_sum(dmna,dmnr,n1,n2,n3,imt1,fk,gk,ne,em,ca1,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: n1
      integer, intent(in) :: n2
      integer, intent(in) :: n3
      integer, intent(in) :: imt1(nvtx,n1*n2*n3*ndiv)
      complex(8), intent(in) :: fk(n1*n2*n3)
      complex(8), intent(in) :: gk(n1*n2*n3)
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(  out) :: ca1(ne*nvtx)
      complex(8), intent(inout) :: xo(ne,n1*n2*n3)
      integer :: i1,i2,i3,i4,i5,i6,i7
      do i1=1,n1*n2*n3*ndiv
        call calc(dmna,dmnr,imt1(:,i1),n1*n2*n3
     $           ,fk
     $           ,gk,ne,em,ca1
     $           ,xo)
      end do
      end subroutine

      subroutine ttrhdrn_chi0(dmna,dmnr,n1,n2,n3,imt1
     $                       ,e1,e2,f1,f2,delt,dsgn,ne,em,ca1,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: n1,n2,n3,imt1(nvtx,n1*n2*n3*ndiv)
      complex(8), intent(in) :: e1(n1*n2*n3),e2(n1*n2*n3)
      real(8), intent(in) :: f1,f2,delt,dsgn
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(  out) :: ca1(ne*nvtx)
      complex(8), intent(inout) :: xo(ne,n1*n2*n3)
      integer :: i1,i2,i3,i4,i5,i6,i7
      real(8) :: ee1(4),ee2(4)
      complex(8) :: ffk(4),ggk(4),xxo(ne,4)
      integer, parameter :: ia1(4)=(/1,2,3,4/),nmax=99
!--- 2013.4.23 
!     real(8), allocatable :: dwgt(:,:,:),dvol(:)
!     allocate(dwgt(4,4,nmax),dvol(nmax))
!---
      real(8) :: dwgt(4,4,nmax),dvol(nmax)
      do i1=1,n1*n2*n3*ndiv
        dwgt(:,:,1)=0.d0; do i2=1,4; dwgt(i2,i2,1)=1.d0; end do
        dvol(1)=1.d0; i2=1
        ee2=dble(e2(imt1(:,i1))); call ttct(f2,ee2,+1,nmax,i2,dwgt,dvol)
        ee1=dble(e1(imt1(:,i1))); call ttct(f1,ee1,-1,nmax,i2,dwgt,dvol)
        do i3=1,i2
          xxo=0.d0; ffk=dvol(i3)
          do i4=1,4
            ggk(i4)=-dcmplx(sum((ee2-ee1)*dwgt(:,i4,i3)),-delt)
          end do
          ffk=ffk*dsgn; ggk=ggk*dsgn
          call calc(dmna,dmnr,ia1,4
     $             ,ffk
     $             ,ggk,ne,em,ca1
     $             ,xxo)
          do i4=1,4; do i5=1,4
            xo(:,imt1(i5,i1))=xo(:,imt1(i5,i1))+xxo(:,i4)*dwgt(i5,i4,i3)
          end do; end do
        end do
      end do
!--- 2013.4.23 
!     deallocate(dwgt,dvol)
!---
      end subroutine

      subroutine ttct(dval,dvtx,imod,nmax,ntet,dwgt,dvol)
      real(8), intent(in) :: dval,dvtx(4)
      integer, intent(in) :: imod,nmax
      integer, intent(inout) :: ntet
      real(8), intent(inout) :: dwgt(4,4,nmax),dvol(nmax)
      logical :: bvtx0(4)
      logical :: b1
      integer :: i1,i2
      real(8) :: d1,d2
      real(8) :: dvtx0(4),dvol0
      integer :: itet
!--- 2013.4.23 
!      logical, allocatable :: bvtx(:,:),btsk(:)
!      allocate(bvtx(4,nmax),btsk(nmax)); bvtx=.false.; btsk=.false.
!---
      logical :: bvtx(4,nmax),btsk(nmax)
      bvtx=.false.
      btsk=.false.
!---
      itet=0
      do while(itet.lt.ntet); itet=itet+1
        do i1=1,4; dvtx0(i1)=sum(dwgt(:,i1,itet)*dvtx(:)); end do
        dvol0=dvol(itet); bvtx0=bvtx(:,itet); b1=.false.
        do i1=   1,3; if(bvtx0(i1))cycle
        do i2=i1+1,4; if(bvtx0(i2))cycle
          b1=(dvtx0(i1)-dval)*(dval-dvtx0(i2)).gt.0.d0; if(b1)exit
        end do; if(b1)exit
        end do
        if(b1)then
!         write(*,*)"divide",dvtx0(i2),dvtx0(i1)
          d1=(dvtx0(i2)-dval)/(dvtx0(i2)-dvtx0(i1))
          d2=(dval-dvtx0(i1))/(dvtx0(i2)-dvtx0(i1))
          ntet=ntet+1; if(ntet.gt.nmax)stop "ntet.gt.nmax"
          bvtx(:,ntet)=bvtx(:,itet); dwgt(:,:,ntet)=dwgt(:,:,itet)
          bvtx(i1,ntet)=.true.
          dwgt(:,i1,ntet)=dwgt(:,i1,itet)*d1+dwgt(:,i2,itet)*d2
          dvol(ntet)=dvol(itet)*d1
          bvtx(i2,itet)=.true.
          dwgt(:,i2,itet)=dwgt(:,i1,itet)*d1+dwgt(:,i2,itet)*d2
          dvol(itet)=dvol(itet)*d2
          itet=itet-1
        else
          do i1=1,4; if(bvtx0(i1))cycle
            btsk(itet)=btsk(itet)
     $        .or.dble(imod)*(dvtx0(i1)-dval).gt.0.d0
!           if(btsk(itet))write(*,"(4g15.7)")dvtx0
!           btsk(itet)=.true.!!!This makes last checking values become 1!!!
          end do
        end if
      end do
!     write(*,*)"ntet=",ntet
!     write(*,*)"btet=",btsk(1:ntet)
      itet=0! dvtx0=0.d0
      do i1=1,ntet; if(.not.btsk(i1))cycle
        itet=itet+1; dwgt(:,:,itet)=dwgt(:,:,i1);dvol(itet)=dvol(i1)
!       write(*,"(4g15.7)")itet,dvol(itet)
!       write(*,"(4g15.7)")dwgt(:,:,itet)
!       dvtx0=dvtx0+dvol(itet)
!    $  *(dwgt(:,1,itet)+dwgt(:,2,itet)+dwgt(:,3,itet)+dwgt(:,4,itet))
      end do; ntet=itet
!     write(*,*)"check",dvtx0
!--- 2013.4.23 
!      deallocate(bvtx,btsk)
!---
      end subroutine

      subroutine calc(dmna,dmnr,ia1,nnn,fk,gk,ne,em,ca1,xo)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: ia1(nvtx)
      integer, intent(in) :: nnn
      complex(8), intent(in) :: fk(nnn)
      complex(8), intent(in) :: gk(nnn)
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(  out) :: ca1(ne,nvtx)
      complex(8), intent(inout) :: xo(ne,nnn)
      integer :: i1,i2,i3,i4,i5,i6
      integer :: ia2(4),ia3(4),ia4(4)
      complex(8) :: geq1,geq2
      call chk1(dmna,dmnr,nnn,gk,ia1,ia2,ia3,ia4,i3)
      select case(sum(ia2))
      case(0)
        call ttrhdrn_sub2normal(
     $             gk(ia4(2)),gk(ia4(1)),gk(ia4(3)),gk(ia4(4))
     $            ,ne,em,ca1(:,1))
        call ttrhdrn_sub2normal(
     $             gk(ia4(1)),gk(ia4(2)),gk(ia4(3)),gk(ia4(4))
     $            ,ne,em,ca1(:,2))
        call ttrhdrn_sub2normal(
     $             gk(ia4(1)),gk(ia4(3)),gk(ia4(2)),gk(ia4(4))
     $            ,ne,em,ca1(:,3))
        call ttrhdrn_sub1normal(
     $             gk(ia4(1)),gk(ia4(4)),gk(ia4(2)),gk(ia4(3))
     $            ,ne,em,ca1(:,4))
          xo(:,ia4(1))=xo(:,ia4(1))+fk(ia4(1))*ca1(:,1)
          xo(:,ia4(2))=xo(:,ia4(2))+fk(ia4(2))*ca1(:,2)
          xo(:,ia4(3))=xo(:,ia4(3))+fk(ia4(3))*ca1(:,3)
          xo(:,ia4(4))=xo(:,ia4(4))+fk(ia4(4))
     $            *(ca1(:,4)-ca1(:,3)-ca1(:,2)-ca1(:,1))
      case(2)
          geq1=sum(gk(ia3(1:2)))/2.d0
          call ttrhdrn_sub2g10   (
     $             geq1      ,geq1      ,gk(ia4(1)),gk(ia4(2))
     $            ,ne,em,ca1(:,1))
          call ttrhdrn_sub2g30   (
     $             geq1      ,gk(ia4(1)),gk(ia4(2)),geq1      
     $            ,ne,em,ca1(:,2))
          call ttrhdrn_sub1g30   (
     $             geq1      ,gk(ia4(2)),gk(ia4(1)),geq1      
     $            ,ne,em,ca1(:,3))
          xo(:,ia3(1))=xo(:,ia3(1))+fk(ia3(1))*ca1(:,1)
          xo(:,ia3(2))=xo(:,ia3(2))+fk(ia3(2))*ca1(:,1)
          xo(:,ia4(1))=xo(:,ia4(1))+fk(ia4(1))*ca1(:,2)
          xo(:,ia4(2))=xo(:,ia4(2))+fk(ia4(2))
     $            *(ca1(:,3)-ca1(:,2)-ca1(:,1)-ca1(:,1))
      case(3)
          geq1=sum(gk(ia3(1:3)))/3.d0
          call ttrhdrn_sub2g30g10(
     $             geq1      ,geq1      ,gk(ia4(1)),geq1      
     $            ,ne,em,ca1(:,1))
          call ttrhdrn_sub1g30g20(
     $             geq1      ,gk(ia4(1)),geq1      ,geq1      
     $            ,ne,em,ca1(:,2))
          xo(:,ia3(1))=xo(:,ia3(1))+fk(ia3(1))*ca1(:,1)
          xo(:,ia3(2))=xo(:,ia3(2))+fk(ia3(2))*ca1(:,1)
          xo(:,ia3(3))=xo(:,ia3(3))+fk(ia3(3))*ca1(:,1)
          xo(:,ia4(1))=xo(:,ia4(1))+fk(ia4(1))
     $            *(ca1(:,2)-ca1(:,1)-ca1(:,1)-ca1(:,1))
      case(4)
        select case(i3)
        case(2)
          geq1=sum(gk(ia3(1:2)))/2.d0; geq2=sum(gk(ia3(3:4)))/2.d0
          call ttrhdrn_sub2g30g21(
     $             geq2      ,geq1      ,geq1      ,geq2      
     $            ,ne,em,ca1(:,1))
          call ttrhdrn_sub1g30g21(
     $             geq1      ,geq2      ,geq2      ,geq1      
     $            ,ne,em,ca1(:,2))
          xo(:,ia3(1))=xo(:,ia3(1))+fk(ia3(1))*ca1(:,1)
          xo(:,ia3(2))=xo(:,ia3(2))+fk(ia3(2))*ca1(:,1)
          xo(:,ia3(3))=xo(:,ia3(3))+fk(ia3(3))
     $                     *(ca1(:,2)-ca1(:,1)-ca1(:,1))*.5d0
          xo(:,ia3(4))=xo(:,ia3(4))+fk(ia3(4))
     $                     *(ca1(:,2)-ca1(:,1)-ca1(:,1))*.5d0
        case(3:6)
          geq1=sum(gk(ia3(1:4)))/4.d0
          call ttrhdrn_sub2simple(
     $             geq1      ,geq1      ,geq1      ,geq1      
     $            ,ne,em,ca1(:,1))
          xo(:,ia3(1))=xo(:,ia3(1))+ca1(:,1)*fk(ia3(1))
          xo(:,ia3(2))=xo(:,ia3(2))+ca1(:,1)*fk(ia3(2))
          xo(:,ia3(3))=xo(:,ia3(3))+ca1(:,1)*fk(ia3(3))
          xo(:,ia3(4))=xo(:,ia3(4))+ca1(:,1)*fk(ia3(4))
        case default
          call errexec("bad i3")
        end select
      case default
        call errexec("bad sum ia2")
      end select
      end subroutine

      subroutine ttrhdrn_sub1simple(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=1.d0/((g0+em)*6.d0)
      end subroutine

      subroutine ttrhdrn_sub1g30g21(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   (.5d0*(g0+g1)+em)/(g0-g1)**2
      x0=x0-   log((g0+em)/(g1+em))*(g0+em)*(g1+em)/(g0-g1)**3
      end subroutine

      subroutine ttrhdrn_sub1g30g20(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   (g0-3.d0*g1-2.d0*em)*.25d0/(g0-g1)**2
      x0=x0+   (g1+em)**2*log((g0+em)/(g1+em))*.5d0/(g0-g1)**3
      end subroutine

      subroutine ttrhdrn_sub1g30   (g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   .5d0/(g0-g2)
      x0=x0-   .5d0/((g0-g2)*(g0-g1))**2
     $        *(g0+em)
     $        *(-2.d0*(g1+em)*(g2+em)+(g0+em)*(g1+g2+2.d0*em))
     $        *log((g0+em)/(g1+em))
      x0=x0+   .5d0/(g0-g2)**2
     $        *(g2+em)**2*log((g1+em)/(g2+em))/(g1-g2)
      x0=x0+   .5d0/((g0-g2)*(g0-g1))
     $        *(g1+em)
      end subroutine

      subroutine ttrhdrn_sub1normal(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
!     x0=   (-g0-g1-2.d0*em)/((g0-g2)*(g0-g3))*.25d0
      x0=  +   (
     $         -(g1+em)**2*log((g1+em)/(g0+em)))
     $        /((g0-g2)*(g0-g3)*(g0-g1))*.5d0
!     x0=x0-   (-g1-g2-2.d0*em)/((g0-g2)*(g2-g3))*.25d0
      x0=x0-   ((g1+em)**2*log((g1+em)/(g0+em))
     $         -(g2+em)**2*log((g2+em)/(g0+em)))
     $        /((g0-g2)*(g1-g2)*(g2-g3))*.5d0
!     x0=x0+   (-g1-g3-2.d0*em)/((g0-g3)*(g2-g3))*.25d0
      x0=x0+   ((g1+em)**2*log((g1+em)/(g0+em))
     $         -(g3+em)**2*log((g3+em)/(g0+em)))
     $        /((g1-g3)*(g0-g3)*(g2-g3))*.5d0
      end subroutine

      subroutine ttrhdrn_sub2simple(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=1.d0/((g0+em)*24.d0)
      end subroutine

      subroutine ttrhdrn_sub2g30g20(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   ((g0-g1)*(g0+2.d0*g1+3.d0*em)
     $         -6.d0*(g0+em)*(g1+em))
     $        /(12.d0*(g0-g1)**3)
      x0=x0+   (g0+em)*(g1+em)**2*log((g0+em)/(g1+em))
     $        /(g0-g1)**4*.5d0
      end subroutine

      subroutine ttrhdrn_sub2g30g21(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      call ttrhdrn_sub2g30g20(g1,g0,g1,g1,ne,em,x0)
      end subroutine

      subroutine ttrhdrn_sub2g30g10(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   (2.d0*(g0+em)**2-7.d0*(g0+em)*(g2+em)+11.d0*(g2+em)**2)
     $        /(36.d0*(g0-g2)**3)
      x0=x0-   (g2+em)**3*log((g0+em)/(g2+em))
     $        /(6.d0*(g0-g2)**4)
      end subroutine

      subroutine ttrhdrn_sub2g10   (g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   (g0+em)*((g0+em)**2+5.d0*(g2+em)*(g3+em)
     $                 -3.d0*(g0+em)*(g2+g3+2.d0*em))
     $        /(12.d0*(g0-g2)**2*(g0-g3)**2)
!     x0=x0+   (g0+em)*(3.d0*(g2+em)*(g3+em)*(g0-g2)*(g0-g3)
!    $                 +((g0+em)*(g2-g3))**2)
!    $        *log(g0+em)/(6.d0*(g0-g2)**3*(g0-g3)**3)
      x0=x0-   (g2+em)**3*log((g2+em)/(g0+em))/(6.d0*(g0-g2)**3*(g2-g3))
      x0=x0+   (g3+em)**3*log((g3+em)/(g0+em))/(6.d0*(g0-g3)**3*(g2-g3))
      end subroutine

      subroutine ttrhdrn_sub2g30   (g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=   ((g0+em)**2*(g1-g2)+(g1+em)**2*(g0-g2))
     $        /(6.d0*(g0-g2)*(g0-g1)**2*(g1-g2))
      x0=x0-   (g0+em)**2*(2.d0*(g1+em)*(g0-g2)+(g2+em)*(g0-g1))
     $                   *log((g0+em)/(g2+em))
     $        /(6.d0*(g0-g2)**2*(g0-g1)**3)
      x0=x0+   (g1+em)**2*(2.d0*(g0+em)*(g1-g2)-(g2+em)*(g0-g1))
     $                   *log((g1+em)/(g2+em))
     $        /(6.d0*(g0-g1)**3*(g1-g2)**2)
!     x0=x0+   (g2+em)**3*log(g2+em)/(6.d0*(g0-g2)**2*(g1-g2)**2)
      end subroutine

      subroutine ttrhdrn_sub2normal(g0,g1,g2,g3,ne,em,x0)
      complex(8), intent(in) :: g0,g1,g2,g3
      integer, intent(in) :: ne
      complex(8), intent(in) :: em(ne)
      complex(8), intent(out) :: x0(ne)
      x0=-   (g1+em)**2/(6.d0*(g0-g1)*(g1-g2)*(g1-g3))
!     x0=x0+   ((g1+em)*(g2+em)**2*(g1-g3)*(g0-g3)
!    $         +(g1+em)*(g2+em)*(g3+em)*(g1-g2)*(g0-g3)
!    $         +(g0+em)*(g3+em)**2*(g1-g2)**2)*log(g1+em)
!    $        /(6.d0*(g0-g2)*(g0-g3)*(g1-g2)**2*(g1-g3)**2)
      x0=x0-   (g2+em)**3*log((g2+em)/(g1+em))
     $        /(6.d0*(g0-g2)*(g1-g2)**2*(g2-g3))
      x0=x0+   (g3+em)**3*log((g3+em)/(g1+em))
     $        /(6.d0*(g0-g3)*(g1-g3)**2*(g2-g3))
      x0=x0+   (g0+em)**3*log((g0+em)/(g1+em))
     $        /(6.d0*(g0-g1)**2*(g0-g2)*(g0-g3))
      end subroutine





      subroutine chk1(dmna,dmnr,nnn,gk,ia1,ia2,ia3,ia4,i3)
      real(8), intent(in) :: dmna,dmnr
      integer, intent(in) :: nnn
      complex(8), intent(in) :: gk(nnn)
      integer, intent(in) :: ia1(4)
      integer, intent(out):: ia2(4)
      integer, intent(out):: ia3(4)
      integer, intent(out):: ia4(4)
      integer, intent(out):: i3
      integer :: i1,i2,i4,i5
      real(8) :: d1,d2
      i3=0
      i4=0
      ia2=0
      ia3=0
      do i1=1,3
        do i2=i1+1,4
          d1=abs(gk(ia1(mod(i1,4)+1))-gk(ia1(mod(i2,4)+1)))
          d2=abs(gk(ia1(mod(i1,4)+1))+gk(ia1(mod(i2,4)+1)))*.5d0
           if(d1.lt.dmna.or.d1/d2.lt.dmnr)then
!          if(d1.lt.dmna.and.d1/d2.lt.dmnr)then
            i3=i3+1
            if(ia2(mod(i1,4)+1).eq.0)then
              i4=i4+1
              ia3(i4)=ia1(mod(i1,4)+1)
              ia2(mod(i1,4)+1)=1
            end if
            if(ia2(mod(i2,4)+1).eq.0)then
              i4=i4+1
              ia3(i4)=ia1(mod(i2,4)+1)
              ia2(mod(i2,4)+1)=1
            end if
          else
          end if
        end do
      end do
      i5=0
      ia4=0
      do i1=1,4
        if(ia2(mod(i1,4)+1).eq.0) then
          i5=i5+1
          ia4(i5)=ia1(mod(i1,4)+1)
        end if
      end do
      if(sum(ia2).ne.i4) call errexec("bad ia2 and i4")
      if(i4+i5.ne.4)     call errexec("bad i4 and i5")
      end subroutine

      subroutine ttrhdrn_mkidx(n1,n2,n3,idx1,bvec1,bvec2,bvec3)
      integer, intent(in) :: n1
      integer, intent(in) :: n2
      integer, intent(in) :: n3
      integer, intent(out):: idx1(nvtx,n1*n2*n3*ndiv)
      real(8), intent(in), optional :: bvec1(3),bvec2(3),bvec3(3)
      real(8) :: bvec(3,3)
      integer :: i1,i2,i3,i4,i5,i6,i7
      integer :: imt1(8,8)
      integer :: ia1(8)
      !
      integer :: nvec(3)!20180413 Y.Nohara 
      !
      bvec=reshape((/1d0,0d0,0d0,0d0,1d0,0d0,0d0,0d0,1d0/),(/3,3/))
      if(present(bvec1))bvec(:,1)=bvec1
      if(present(bvec2))bvec(:,2)=bvec2
      if(present(bvec3))bvec(:,3)=bvec3
      !
      !20180413 Y.Nohara    
      !
      !(/n1,n2,n3/) gives a warning at run time
      !
      !call libtetrabzinitialize(bvec,(/n1,n2,n3/),idx1)
      !
      nvec(1)=n1; nvec(2)=n2; nvec(3)=n3
      call libtetrabzinitialize(bvec,nvec(1),idx1)
      !
      end subroutine

!!!FROM LIBTETRABZ, MIT License, Copyright (c) 2014 Mitsuaki Kawamura!!!
      subroutine libtetrabzinitialize(bvec,ng,indx1)
      real(8), intent(in   ) :: bvec(3,3)
      integer, intent(in   ) :: ng(3)
      integer, intent(  out) :: indx1(4,*)
      integer :: nk,nt, ivvec(3,4,6), ikv(3)
      integer :: itype, i1, i2, i3, it, ii, divvec(4,4), ivvec0(4)
      real(8) :: l(4), bvec2(3,3), bvec3(3,4)
      nk = product(ng(1:3))
      nt = nk * 6
      do i1 = 1, 3
        bvec2(1:3,i1) = bvec(1:3,i1) / dble(ng(i1))
      end do
      bvec3(1:3,1) = -bvec2(1:3,1) + bvec2(1:3,2) + bvec2(1:3,3)
      bvec3(1:3,2) =  bvec2(1:3,1) - bvec2(1:3,2) + bvec2(1:3,3)
      bvec3(1:3,3) =  bvec2(1:3,1) + bvec2(1:3,2) - bvec2(1:3,3)
      bvec3(1:3,4) =  bvec2(1:3,1) + bvec2(1:3,2) + bvec2(1:3,3)
      ! length of delta bvec
      do i1 = 1, 4
        l(i1) = dot_product(bvec3(1:3,i1),bvec3(1:3,i1))
      end do
      itype = minloc(l(1:4),1)
      ! start & last
      ivvec0(1:4) = (/ 0, 0, 0, 0 /)
      divvec(1:4,1) = (/ 1, 0, 0, 0 /)
      divvec(1:4,2) = (/ 0, 1, 0, 0 /)
      divvec(1:4,3) = (/ 0, 0, 1, 0 /)
      divvec(1:4,4) = (/ 0, 0, 0, 1 /)
      ivvec0(itype) = 1
      divvec(itype, itype) = - 1
      ! Corners of tetrahedra
      it = 0
      do i1 = 1, 3
        do i2 = 1, 3
          if(i2 == i1) cycle
          do i3 = 1, 3
            if(i3 == i1 .or. i3 == i2) cycle
            it = it + 1
            ivvec(1:3,1,it) = ivvec0(1:3)
            ivvec(1:3,2,it) = ivvec(1:3,1,it) + divvec(1:3,i1)
            ivvec(1:3,3,it) = ivvec(1:3,2,it) + divvec(1:3,i2)
            ivvec(1:3,4,it) = ivvec(1:3,3,it) + divvec(1:3,i3)
          end do
        end do
      end do
!     allocate(indx1(20, 6 * nk), indx2(20, 6 * nk), indx3(20 * 6 * nk))
      nt = 0
      do i3 = 1, ng(3)
        do i2  = 1, ng(2)
          do i1 = 1, ng(1)
            do it = 1, 6
              nt = nt + 1
              do ii = 1, 4
                ikv(1:3) = (/i1, i2, i3/) + ivvec(1:3,ii,it) - 1
                ikv(1:3) = modulo(ikv(1:3), ng(1:3))
                indx1(ii,nt) = 1 + ikv(1) + ng(1) * ikv(2) 
     $                                    + ng(1) * ng(2) * ikv(3)
              end do
            end do
          end do
        end do
      end do
      end subroutine
!!!FROM LIBTETRABZ, MIT License, Copyright (c) 2014 Mitsuaki Kawamura!!!
        
      subroutine errexec(smsg)
      character(*), intent(in) :: smsg
      integer :: i(1:1)
      integer :: j
      j=0
      write(*,"(a)")"#ERROR in ttrhdrn_ : "//smsg
      i(j)=0
      write(*,"('#errexec cannot stop')")
      write(*,"('#please use debug option')")
      stop
      end subroutine

      end module

subroutine kcheck(ktmp,RWtmp) 
implicit none 
real(8),intent(inout)::ktmp(3)
integer,intent(out)::RWtmp(3) 
real(8),parameter::dlt_BZ=1.0d-6 
!
if(ktmp(1)>1.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)-2.0d0
 RWtmp(1)=-2
endif 
if(ktmp(1)>0.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)-1.0d0
 RWtmp(1)=-1
endif 
if(ktmp(1)<=-1.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)+2.0d0
 RWtmp(1)=2 
endif 
if(ktmp(1)<=-0.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)+1.0d0
 RWtmp(1)=1
endif 
!
if(ktmp(2)>1.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)-2.0d0
 RWtmp(2)=-2 
endif 
if(ktmp(2)>0.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)-1.0d0
 RWtmp(2)=-1
endif 
if(ktmp(2)<=-1.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)+2.0d0
 RWtmp(2)=2 
endif 
if(ktmp(2)<=-0.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)+1.0d0
 RWtmp(2)=1
endif 
!
if(ktmp(3)>1.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)-2.0d0
 RWtmp(3)=-2 
endif 
if(ktmp(3)>0.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)-1.0d0
 RWtmp(3)=-1
endif 
if(ktmp(3)<=-1.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)+2.0d0
 RWtmp(3)=2 
endif 
if(ktmp(3)<=-0.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)+1.0d0
 RWtmp(3)=1
endif 
return
end 
!
subroutine kcheck_trs(ktmp,RWtmp) 
implicit none 
real(8),intent(inout)::ktmp(3)
integer,intent(out)::RWtmp(3) 
real(8),parameter::dlt_BZ=-1.0d-6 
!
if(ktmp(1)>=1.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)-2.0d0
 RWtmp(1)=-2
endif 
if(ktmp(1)>=0.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)-1.0d0
 RWtmp(1)=-1
endif 
if(ktmp(1)<-1.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)+2.0d0
 RWtmp(1)=2 
endif 
if(ktmp(1)<-0.50d0+dlt_BZ)then 
 ktmp(1)=ktmp(1)+1.0d0
 RWtmp(1)=1
endif 
!
if(ktmp(2)>=1.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)-2.0d0
 RWtmp(2)=-2 
endif 
if(ktmp(2)>=0.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)-1.0d0
 RWtmp(2)=-1
endif 
if(ktmp(2)<-1.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)+2.0d0
 RWtmp(2)=2 
endif 
if(ktmp(2)<-0.50d0+dlt_BZ)then 
 ktmp(2)=ktmp(2)+1.0d0
 RWtmp(2)=1
endif 
!
if(ktmp(3)>=1.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)-2.0d0
 RWtmp(3)=-2 
endif 
if(ktmp(3)>=0.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)-1.0d0
 RWtmp(3)=-1
endif 
if(ktmp(3)<-1.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)+2.0d0
 RWtmp(3)=2 
endif 
if(ktmp(3)<-0.50d0+dlt_BZ)then 
 ktmp(3)=ktmp(3)+1.0d0
 RWtmp(3)=1
endif 
return
end 
!
subroutine make_KG0(NTG,b1,b2,b3,Gcut,q1,q2,q3,KG0,NG) 
implicit none 
integer,intent(in)::NTG
real(8),intent(in)::b1(3),b2(3),b3(3) 
real(8),intent(in)::Gcut,q1,q2,q3        
integer,intent(out)::KG0(3,NTG),NG 
integer::igL,igL1,igL2,igL3
real(8)::qgL(3),qgL2  
integer,parameter::NGL1=150!100
integer,parameter::NGL2=150!100 
integer,parameter::NGL3=150!100
!
igL=0
do igL1=-NGL1,NGL1 
 do igL2=-NGL2,NGL2 
  do igL3=-NGL3,NGL3 
   qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)    
   qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
   if(qgL2<=Gcut)then 
    igL=igL+1 
    KG0(1,igL)=igL1
    KG0(2,igL)=igL2
    KG0(3,igL)=igL3 
   endif  
  enddo 
 enddo 
enddo 
NG=igL 
!
RETURN 
END 
!
subroutine est_nkbi(N,SK,nkb1,nkb2,nkb3)  
implicit none 
integer::N,nkb1,nkb2,nkb3,NTK  
real(8)::SK(3,N) 
integer::i 
real(8)::x 
!
x=1.0d0 
do i=1,N
 if(abs(SK(1,i))<1.0d-7)cycle 
 if(abs(SK(1,i))<x)then 
  x=abs(SK(1,i))  
 endif 
enddo    
nkb1=nint(1.0d0/x)  
!
x=1.0d0 
do i=1,N
 if(abs(SK(2,i))<1.0d-7)cycle 
 if(abs(SK(2,i))<x)then 
  x=abs(SK(2,i))  
 endif 
enddo    
nkb2=nint(1.0d0/x)  
!
x=1.0d0 
do i=1,N
 if(abs(SK(3,i))<1.0d-7)cycle 
 if(abs(SK(3,i))<x)then 
  x=abs(SK(3,i))  
 endif 
enddo    
nkb3=nint(1.0d0/x)  
!
NTK=nkb1*nkb2*nkb3 
!
!write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
!
return 
end 
!
subroutine est_NTK(Nk_irr,Nsymq,SKI,rg,NTK)
!
!20180301 
!
implicit none 
integer::Nk_irr,Nsymq,N  
real(8)::SKI(3,Nk_irr) 
integer::rg(3,3,Nsymq) 
real(8),allocatable::SK0(:,:)!SK0(3,N) 
real(8)::ktmp(3)
integer::RWtmp(3)
integer::jk,ik,iop,iik 
integer::NTK 
!
N=Nk_irr*Nsymq*2
!
!write(6,*)'N=',N
!
!SK0
!
allocate(SK0(3,N));SK0(:,:)=0.0d0
jk=0
do ik=1,Nk_irr
 do iop=1,Nsymq
  ktmp(:)=0.0d0; RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)
  call kcheck(ktmp(1),RWtmp(1))!rewind check 
  do iik=1,jk
   if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and.abs(SK0(2,iik)-ktmp(2))<1.0d-4.and.abs(SK0(3,iik)-ktmp(3))<1.0d-4) goto 1000
  enddo!iik
  jk=jk+1
  SK0(:,jk)=ktmp(:)
1000 ktmp(:)=0.0d0; RWtmp(:)=0  
  ktmp(1)=dble(rg(1,1,iop))*SKI(1,ik)+dble(rg(1,2,iop))*SKI(2,ik)+dble(rg(1,3,iop))*SKI(3,ik)
  ktmp(2)=dble(rg(2,1,iop))*SKI(1,ik)+dble(rg(2,2,iop))*SKI(2,ik)+dble(rg(2,3,iop))*SKI(3,ik)
  ktmp(3)=dble(rg(3,1,iop))*SKI(1,ik)+dble(rg(3,2,iop))*SKI(2,ik)+dble(rg(3,3,iop))*SKI(3,ik)
  call kcheck_trs(ktmp(1),RWtmp(1))!rewind check modified 20170316  
  do iik=1,jk
   if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and.abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and.abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4) goto 2000
  enddo!iik
  jk=jk+1
  SK0(:,jk)=-ktmp(:) 
2000 enddo!iop 
enddo!ik 
!
NTK=jk 
if(NTK>N)then 
 write(6,*)'Estimated NTK is too large; stop' 
 write(6,*)'NTK, N=',NTK, N 
 stop
endif 
!
!write(6,*)'Estimated NTK=',NTK 
!
return
end
!
subroutine est_latparam(a1,a2,a3,a,b,c,alp,bet,gmm)   
implicit none 
real(8)::a1(3),a2(3),a3(3) 
real(8)::a,b,c,alp,bet,gmm  
real(8),parameter::pi=DACOS(-1.0d0)
!
a=0.0d0 
b=0.0d0 
c=0.0d0 
a=dsqrt(a1(1)**2+a1(2)**2+a1(3)**2) 
b=dsqrt(a2(1)**2+a2(2)**2+a2(3)**2) 
c=dsqrt(a3(1)**2+a3(2)**2+a3(3)**2) 
alp=(a2(1)*a3(1)+a2(2)*a3(2)+a2(3)*a3(3))/b/c 
bet=(a3(1)*a1(1)+a3(2)*a1(2)+a3(3)*a1(3))/c/a
gmm=(a1(1)*a2(1)+a1(2)*a2(2)+a1(3)*a2(3))/a/b 
alp=dacos(alp)*180.0d0/pi  
bet=dacos(bet)*180.0d0/pi  
gmm=dacos(gmm)*180.0d0/pi  
!
!write(6,'(6f15.10)') a,b,c,alp,bet,gmm 
!
return 
end 
!
integer function algn235(inr)
implicit none
integer,intent(in)::inr
integer:: nr,m2,m3,m5,info
nr=inr
call fctck(nr,m2,m3,m5,info)
do while (info .eq. 1)
   nr = nr + 1
   call fctck(nr,m2,m3,m5,info)
end do
algn235 = nr 
return
end function algn235
!
subroutine fctck(n,m2,m3,m5,info)
implicit none
integer,intent(in):: n
integer,intent(out):: m2, m3, m5, info
integer:: i
i=n
m2 = 0
m3 = 0
m5 = 0
info = 0
do while (i .ne. 1)
   if (mod(i,2) .eq. 0) then
      m2 = m2 + 1
      i = i / 2
   else if (mod(i,3) .eq. 0) then
      m3 = m3 + 1
      i = i / 3
   else if (mod(i,5) .eq. 0) then
      m5 = m5 + 1
      i = i / 5
   else
      info = 1
      exit
   end if
end do
return
end subroutine fctck
!
!subroutine make_LG0(NTG,b1,b2,b3,Gcut_for_eps,Gcut_for_psi,q1,q2,q3,LG0,NG_for_eps,NG_for_psi)
!implicit none 
!integer::NTG,igL,igL1,igL2,igL3
!integer::NG_for_eps,NG_for_psi            
!integer::LG0(3,NTG)    
!real(8)::b1(3),b2(3),b3(3) 
!real(8)::Gcut_for_eps,Gcut_for_psi  
!real(8)::q1,q2,q3,qgL2,qgL(3)
!integer,parameter::NGL1=100 
!integer,parameter::NGL2=100 
!integer,parameter::NGL3=100 
!!
!igL=0
!do igL1=-NGL1,NGL1 
! do igL2=-NGL2,NGL2 
!  do igL3=-NGL3,NGL3 
!   qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)    
!   qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
!   if(qgL2<=Gcut_for_eps)then 
!    igL=igL+1 
!    LG0(1,igL)=igL1
!    LG0(2,igL)=igL2
!    LG0(3,igL)=igL3 
!    !write(6,*) igL
!   endif  
!  enddo 
! enddo 
!enddo 
!NG_for_eps=igL 
!!
!do igL1=-NGL1,NGL1 
! do igL2=-NGL2,NGL2 
!  do igL3=-NGL3,NGL3 
!   qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)    
!   qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
!   if(qgL2>Gcut_for_eps.and.qgL2<=Gcut_for_psi)then 
!    igL=igL+1 
!    LG0(1,igL)=igL1
!    LG0(2,igL)=igL2
!    LG0(3,igL)=igL3 
!    !write(6,*) igL
!   endif  
!  enddo 
! enddo 
!enddo 
!NG_for_psi=igL 
!!
!!do igL=1,NG_for_eps 
!! write(6,*) igL,LG0(:,igL)
!!enddo 
!!
!RETURN 
!END 
!
!
subroutine make_C0(NTG,NTB,itrs,NG,KGtmp,RWtmp,rginvtmp,pgtmp,nnp,L1,L2,L3,packtmp,C0irr,C0_K) 
implicit none 
integer::NTG,NTB,itrs,NG,L1,L2,L3,nnp 
integer::KGtmp(3,NTG),RWtmp(3),pgtmp(3) 
integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3,ib  
real(8)::rginvtmp(3,3),phase 
complex(8)::C0irr(NTG,NTB)
complex(8)::pf
complex(8),intent(out)::C0_K(NTG,NTB) 
real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
complex(8),parameter::ci=(0.0D0,1.0D0) 
!--
C0_K(:,:)=0.0d0 
write(6,*)'nnp=',nnp 
select case(itrs) 
case(1)!=== not time-reversal ===   
 do ig=1,NG 
  i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2
  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
  jg=packtmp(i3,j3,k3) 
  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
  pf=exp(-ci*phase/dble(nnp)) 
  write(6,*)'pf=',pf 
  !C0_K(ig,:)=C0irr(jg,:)*pf 
  do ib=1,NTB 
   write(6,*) ig,jg 
   C0_K(ig,ib)=C0irr(jg,ib)*pf 
  enddo!ib
 enddo!ig 
case(-1)!=== time-reversal ===      
 do ig=1,NG 
  i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2
  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
  jg=packtmp(i3,j3,k3) 
  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
  pf=exp(-ci*phase/dble(nnp)) 
  !C0_K(ig,:)=C0irr(jg,:)*pf 
  do ib=1,NTB 
   write(6,*) ig,jg 
   C0_K(ig,ib)=C0irr(jg,ib)*pf 
  enddo!ib
 enddo!ig 
 C0_K(:,:)=conjg(C0_K(:,:))  
end select 
!--
return 
end 
!
subroutine make_C0_for_given_band(NTG,itrs,NG,KGtmp,RWtmp,rginvtmp,pgtmp,nnp,L1,L2,L3,packtmp,OCCtmp,C0_K) 
implicit none 
integer::NTG,L1,L2,L3,nnp 
integer::itrs 
integer::NG
integer::KGtmp(3,NTG) 
integer::RWtmp(3) 
real(8)::rginvtmp(3,3) 
integer::pgtmp(3) 
integer::packtmp(-L1:L1,-L2:L2,-L3:L3) 
!
!20180922
!
!complex(8)::OCCtmp(NTG) 
complex(4)::OCCtmp(NTG) 
!
integer::ig,jg,i1,i2,i3,j1,j2,j3,k1,k2,k3 
real(8),parameter::pi=dacos(-1.0d0)
real(8),parameter::tpi=2.0d0*pi 
complex(8),parameter::ci=(0.0D0,1.0D0) 
real(8)::phase 
complex(8)::pf 
complex(8)::C0_K(NTG) 
!
C0_K(:)=0.0d0 
select case(itrs) 
case(1)!=== not time-reversal ===      
 do ig=1,NG 
  i1=KGtmp(1,ig); j1=KGtmp(2,ig); k1=KGtmp(3,ig) 
  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
  jg=packtmp(i3,j3,k3) 
  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
  pf=exp(-ci*phase/dble(nnp)) 
  C0_K(ig)=OCCtmp(jg)*pf 
 enddo!ig 
case(-1)!=== time-reversal ===      
 do ig=1,NG 
  i1=-KGtmp(1,ig); j1=-KGtmp(2,ig); k1=-KGtmp(3,ig) 
  i2=i1+RWtmp(1); j2=j1+RWtmp(2); k2=k1+RWtmp(3) 
  i3=int(rginvtmp(1,1))*i2+int(rginvtmp(1,2))*j2+int(rginvtmp(1,3))*k2 
  j3=int(rginvtmp(2,1))*i2+int(rginvtmp(2,2))*j2+int(rginvtmp(2,3))*k2 
  k3=int(rginvtmp(3,1))*i2+int(rginvtmp(3,2))*j2+int(rginvtmp(3,3))*k2 
  jg=packtmp(i3,j3,k3) 
  phase=tpi*(dble(i1)*dble(pgtmp(1))+dble(j1)*dble(pgtmp(2))+dble(k1)*dble(pgtmp(3))) 
  pf=exp(-ci*phase/dble(nnp)) 
  C0_K(ig)=OCCtmp(jg)*pf 
 enddo !ig 
 C0_K(:)=conjg(C0_K(:))  
end select 
return 
end 

integer function algn235(inr)
implicit none
integer,intent(in):: inr
integer:: nr,m2,m3,m5,info
nr=inr
call fctck(nr,m2,m3,m5,info)
do while (info .eq. 1)
   nr = nr + 1
   call fctck(nr,m2,m3,m5,info)
end do
algn235 = nr 
return
end function algn235
!---
subroutine fctck(n,m2,m3,m5,info)
implicit none
integer,intent(in):: n
integer,intent(out):: m2, m3, m5, info
integer:: i
i=n
m2 = 0
m3 = 0
m5 = 0
info = 0
do while (i .ne. 1)
   if (mod(i,2) .eq. 0) then
      m2 = m2 + 1
      i = i / 2
   else if (mod(i,3) .eq. 0) then
      m3 = m3 + 1
      i = i / 3
   else if (mod(i,5) .eq. 0) then
      m5 = m5 + 1
      i = i / 5
   else
      info = 1
      exit
   end if
end do
return
end subroutine fctck
!---

MODULE m_frmsf_wan
  !
  IMPLICIT NONE
  !
CONTAINS
  !
SUBROUTINE wrt_frmsf_wan(Na1,Na2,Na3,nkb1,nkb2,nkb3,a1,a2,a3,b1,b2,b3,FermiEnergy,WEIGHT_R,H_MAT_R)
  !
  USE m_rdinput, ONLY : n_occ, dense
  !
  IMPLICIT NONE
  !
  INTEGER,INTENT(IN) :: Na1, Na2, Na3, nkb1, nkb2, nkb3
  REAL(8),INTENT(IN) :: a1(3), a2(3), a3(3), b1(3), b2(3), b3(3), FermiEnergy, &
  &                     WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  COMPLEX(8),INTENT(IN) :: H_MAT_R(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  !
  !INTEGER(8) :: ik, i1, i2, i3, ib, jb, fo = 21, nk, i1min, i2min, i3min
  INTEGER :: ik, i1, i2, i3, ib, jb, fo = 21, nk, i1min, i2min, i3min
  REAL(8) :: kvec(3,PRODUCT(dense(1:3))), phase, tpi=2.0d0*acos(-1.0d0), &
  &          Ek(n_occ,PRODUCT(dense(1:3))), proj(n_occ,n_occ,PRODUCT(dense(1:3)))
  COMPLEX(8) :: Hk(n_occ,n_occ), phase_factor, ci=CMPLX(0.0d0,1.0d0)
  CHARACTER(256) :: fname
  !
  WRITE(*,*) "Wannnier-interpolated Fermi surface"
  !
  WRITE(*,*) "  Dense grid : ", dense(1:3)
  !
  nk = PRODUCT(dense(1:3))
  !
  ik = 0
  DO i1 = 1, dense(1)
     DO i2 = 1, dense(2)
        DO i3 = 1, dense(3)
           ik = ik + 1
           kvec(1:3,ik) = DBLE((/i1, i2, i3/) - 1) / DBLE(dense(1:3))
        END DO
     END DO
  END DO
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED(nk,n_occ,Na1,Na2,Na3,nkb1,nkb2,nkb3,a1,a2,a3,tpi,ci, &
  !$OMP &        WEIGHT_R,H_MAT_R,kvec,Ek,proj) &
  !$OMP & PRIVATE(ik,ib,jb,i1,i2,i3,i1min,i2min,i3min,phase,Hk,phase_factor)
  !
  Ek(1:n_occ,        1:nk) = 0.0d0
  !
  !$OMP DO
  DO ik = 1, nk
     Hk(1:n_occ,1:n_occ) = 0.0d0
     DO ib = 1, n_occ
        DO jb = 1, n_occ
           DO i1 = -Na1, Na1!-1
              DO i2 = -Na2, Na2!-1
                 DO i3 = -Na3, Na3!-1
                    !--
                    !-- NEAREST R SEARCH
                    CALL search_Rmin(i1,i2,i3,nkb1,nkb2,nkb3, &
                    &                a1,a2,a3,i1min,i2min,i3min)
                    phase = tpi * DOT_PRODUCT(kvec(1:3,ik), DBLE((/i1min, i2min, i3min/)))
                    !--
                    phase_factor = EXP(ci * phase) * WEIGHT_R(i1,i2,i3)
                    Hk(jb,ib) = Hk(jb,ib) &
                    &         + H_MAT_R(jb,ib,i1,i2,i3) * phase_factor
                 END DO!i3
              END DO!i2
           END DO!i1
        END DO!jb
     END DO!ib
     !
     CALL diagV(n_occ,Hk(1:n_occ,1:n_occ),Ek(1:n_occ,ik))
     !
     proj(1:n_occ,1:n_occ,ik) = DBLE(CONJG(Hk(1:n_occ,1:n_occ)) * Hk(1:n_occ,1:n_occ))
     !
  END DO !ik
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Write to file
  !
  DO ib = 1, n_occ
     !
     WRITE(fname,'(a,i0,a)') "./dir-wan/orb", ib, ".frmsf"
     OPEN(fo,FILE=TRIM(fname)) 
     WRITE(fo,*) dense(1:3)
     WRITE(fo,*) 1
     WRITE(fo,*) n_occ 
     WRITE(fo,*) REAL(b1(1:3))
     WRITE(fo,*) REAL(b2(1:3))
     WRITE(fo,*) REAL(b3(1:3))
     DO jb = 1, n_occ
        DO ik = 1, nk
           WRITE(fo,*) REAL(Ek(jb,ik) - FermiEnergy)
        END DO
     END DO
     DO jb = 1, n_occ
        DO ik = 1, nk
           WRITE(fo,*) REAL(proj(ib,jb,ik))
        END DO
     END DO
     CLOSE(fo)
     !
     WRITE(*,*) TRIM(fname), " for orbital ", ib
     !
  END DO
  !
END SUBROUTINE wrt_frmsf_wan
!
END MODULE m_frmsf_wan

module m_rd_dat_zvo 
  implicit none
  private 
  public::rd_dat_hr
  public::rd_dat_geom 
  public::rd_dat_bandkpts
  public::rd_dat_mkkpts 
  public::rd_dat_ef 
  !h_mat_r(300) 
  integer,public::NWF 
  complex(8),public,allocatable::HR(:,:,:,:,:)!HR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
  !geom(303)
  integer,public::N_wannier_center 
  real(8),public::a1(3),a2(3),a3(3) 
  real(8),public::b1(3),b2(3),b3(3)
  real(8),public::VOLUME 
  real(8),public,allocatable::wcenter_lat(:,:)!wcenter_lat(3,N_wannier_center) 
  !bandkpts(304)
  integer,public::Ndiv,N_sym_points,NSK_BAND_DISP
  real(8),public,allocatable::SK_BAND_DISP(:,:)!SK_BAND_DISP(3,NSK_BAND_DISP) 
  !mkkpts(305)  
  integer,public::NTK 
  integer,public::nkb1,nkb2,nkb3 
  integer,public::Na1,Na2,Na3 
  real(8),public,allocatable::SK0(:,:)!SK0(3,NTK) 
  !ef(306) 
  real(8),public::FermiEnergy_bandcalc 
  contains
  !--
  subroutine rd_dat_hr 
    implicit none 
    integer::dum1,dum2,dum3,dumi,dumj
    integer::N_element 
    character(len=80)::dum_ch
    integer,allocatable::unit_vec(:)!unit_vec(N_element) 
    integer::i,ia1,ia2,ia3,ib,jb 
    real(8),parameter::au=27.21151d0
    !
    !OPEN(300,R,FILE='./dir-model/zvo_hr.dat') 
    !
    OPEN(300,FILE='./dir-model/zvo_hr.dat') 
    rewind(300) 
    read(300,'(a)') dum_ch 
    read(300,'(i10)') NWF 
    read(300,'(i10)') N_element 
    allocate(unit_vec(N_element)); unit_vec=1
    read(300,'(15i5)')(unit_vec(i),i=1,N_element) 
    deallocate(unit_vec) 
    allocate(HR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3));HR(:,:,:,:,:)=0.0d0  
    do ia1=-Na1,Na1
     do ia2=-Na2,Na2
      do ia3=-Na3,Na3 
       do ib=1,NWF!n_occ
        do jb=1,NWF!n_occ
         read(300,'(i5,i5,i5,i5,i5,2f15.10)') dum1,dum2,dum3,dumi,dumj,HR(ib,jb,ia1,ia2,ia3) 
        enddo!jb
       enddo!ib
      enddo!ia3
     enddo!ia2
    enddo!ia1 
    HR=HR/au !au<-eV
  end subroutine
  ! 
  subroutine rd_dat_geom 
    implicit none 
    real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
    integer::ib,i 
    !
    !OPEN(303,R,FILE='./dir-model/zvo_geom.dat') 
    !
    OPEN(303,FILE='./dir-model/zvo_geom.dat') 
    read(303,'(3f15.10)')(a1(i),i=1,3) 
    read(303,'(3f15.10)')(a2(i),i=1,3) 
    read(303,'(3f15.10)')(a3(i),i=1,3) 
    read(303,'(i10)') N_wannier_center 
    allocate(wcenter_lat(3,N_wannier_center)) 
    do ib=1,N_wannier_center 
     read(303,*)(wcenter_lat(i,ib),i=1,3) 
    enddo 
    !
    call OUTER_PRODUCT(a2(1),a3(1),b1(1))
    VOLUME=a1(1)*b1(1)+a1(2)*b1(2)+a1(3)*b1(3)
    b1(:)=b1(:)*tpi/VOLUME 
    call OUTER_PRODUCT(a3(1),a1(1),b2(1))
    b2(:)=b2(:)*tpi/VOLUME 
    call OUTER_PRODUCT(a1(1),a2(1),b3(1))
    b3(:)=b3(:)*tpi/VOLUME 
  end subroutine
  !
  subroutine rd_dat_bandkpts 
    implicit none 
    integer::ik,i 
    !
    !OPEN(304,R,FILE='zvo_bandkpts.dat') 
    !
    OPEN(304,FILE='./dir-model/zvo_bandkpts.dat') 
    read(304,'(3i10)') NSK_BAND_DISP,Ndiv,N_sym_points 
    allocate(SK_BAND_DISP(3,NSK_BAND_DISP));SK_BAND_DISP=0.0d0 
    do ik=1,NSK_BAND_DISP
     read(304,*)(SK_BAND_DISP(i,ik),i=1,3) 
    enddo 
  end subroutine
  !
  subroutine rd_dat_mkkpts 
    implicit none 
    integer::ik,i 
    !
    !OPEN(305,R,FILE='zvo_mkkpts.dat') 
    !
    OPEN(305,FILE='./dir-model/zvo_mkkpts.dat') 
    read(305,'(i10)') NTK 
    allocate(SK0(3,NTK));SK0=0.0d0 
    do ik=1,NTK 
     read(305,*)(SK0(i,ik),i=1,3) 
    enddo 
    call est_nkbi(NTK,SK0,nkb1,nkb2,nkb3)  
    Na1=nkb1/2; Na2=nkb2/2; Na3=nkb3/2
  end subroutine
  !
  subroutine rd_dat_ef 
    implicit none 
    !
    !OPEN(306,R,FILE='zvo_ef.dat') 
    !
    OPEN(306,FILE='./dir-model/zvo_ef.dat') 
    read(306,'(f15.10)') FermiEnergy_bandcalc 
  end subroutine rd_dat_ef 
  !
  subroutine OUTER_PRODUCT(vec_x,vec_y,vec_z)
    implicit none 
    real(8)::vec_x(3),vec_y(3),vec_z(3) 
    !
    vec_z(1)=vec_x(2)*vec_y(3)-vec_x(3)*vec_y(2)
    vec_z(2)=vec_x(3)*vec_y(1)-vec_x(1)*vec_y(3) 
    vec_z(3)=vec_x(1)*vec_y(2)-vec_x(2)*vec_y(1)
    !
    return
  end subroutine 
  !
  subroutine est_nkbi(N,SK,nkb1,nkb2,nkb3)  
    implicit none 
    integer,intent(in)::N
    real(8),intent(in)::SK(3,N) 
    integer,intent(out)::nkb1,nkb2,nkb3
    integer::NTK  
    integer::i 
    real(8)::x 
    real(8),parameter::dlt_BZ=1.0d-6 
    x=1.0d0 
    do i=1,N
     if(abs(SK(1,i))<dlt_BZ) cycle 
     if(abs(SK(1,i))<x) then 
      x=abs(SK(1,i))  
     endif 
    enddo    
    nkb1=nint(1.0d0/x)  
    x=1.0d0 
    do i=1,N
     if(abs(SK(2,i))<dlt_BZ) cycle 
     if(abs(SK(2,i))<x) then 
      x=abs(SK(2,i))  
     endif 
    enddo    
    nkb2=nint(1.0d0/x)  
    x=1.0d0 
    do i=1,N
     if(abs(SK(3,i))<dlt_BZ) cycle 
     if(abs(SK(3,i))<x) then 
      x=abs(SK(3,i))  
     endif 
    enddo    
    nkb3=nint(1.0d0/x)  
    NTK=nkb1*nkb2*nkb3 
    write(6,'(a50,4i10)')'nkb1, nkb2, nkb3, NTK:',nkb1,nkb2,nkb3,NTK  
    return 
  end subroutine 
  !
end module 

module m_band 
  implicit none
contains
  !
  subroutine calculate_banddisp(NWF,NSK_BAND_DISP,Ndiv,N_sym_points,threshold_transfer,b1,b2,b3,SK_BAND_DISP,EKS) 
    implicit none 
    integer,intent(in)::NWF,NSK_BAND_DISP,Ndiv,N_sym_points
    real(8),intent(in)::threshold_transfer 
    real(8),intent(in)::b1(3),b2(3),b3(3)
    real(8),intent(in)::SK_BAND_DISP(3,NSK_BAND_DISP) 
    real(8),intent(in)::EKS(NWF,NSK_BAND_DISP) 
    !
    real(8),allocatable::kdata(:)!kdata(NSK_BAND_DISP) 
    !
    !make kdata 
    !
    allocate(kdata(NSK_BAND_DISP)); kdata=0.0d0 
    call make_kdata(Ndiv,N_sym_points,NSK_BAND_DISP,SK_BAND_DISP(1,1),b1(1),b2(1),b3(1),kdata(1)) 
    !
    !wrt dat.iband 
    !
    call wrt_iband(threshold_transfer,NWF,NSK_BAND_DISP,kdata(1),EKS(1,1)) 
    !
    return
  end subroutine      
  !
  subroutine make_kdata(Ndiv,N_sym_points,NSK_BAND_DISP,SK_BAND_DISP,b1,b2,b3,kdata) 
    implicit none 
    integer,intent(in)::Ndiv,N_sym_points,NSK_BAND_DISP 
    real(8),intent(in)::SK_BAND_DISP(3,NSK_BAND_DISP)
    real(8),intent(in)::b1(3),b2(3),b3(3) 
    real(8),intent(out)::kdata(NSK_BAND_DISP)
    integer::ik,ix,ks,ke 
    real(8)::DIST_B(3),DIST_KSPACE
    real(8),allocatable::DIST_K(:)!DIST_K(NTK)
    real(8),allocatable::dist(:)!dist(0:Nblk-1)
    allocate(DIST_K(NSK_BAND_DISP));DIST_K(:)=0.0d0 
    allocate(dist(0:N_sym_points-1));dist(:)=0.0d0 
    !
    dist(0)=0.0d0 
    do ix=1,N_sym_points-1 
     ks=(ix-1)*Ndiv+1
     ke=(ix)*Ndiv+1
     do ik=ks,ke 
      DIST_B(:)=(SK_BAND_DISP(1,ik)-SK_BAND_DISP(1,ks))*b1(:)&
               +(SK_BAND_DISP(2,ik)-SK_BAND_DISP(2,ks))*b2(:)&
               +(SK_BAND_DISP(3,ik)-SK_BAND_DISP(3,ks))*b3(:)
      DIST_KSPACE=DSQRT(DIST_B(1)**2+DIST_B(2)**2+DIST_B(3)**2)
      DIST_K(ik)=DIST_KSPACE+dist(ix-1) 
     enddo!ik 
     dist(ix)=dist(ix-1)+DIST_KSPACE
    enddo!ix 
    !
    kdata=0.0d0 
    kdata(:)=DIST_K(:)/DIST_K(NSK_BAND_DISP)
    !
    deallocate(DIST_K,dist) 
    return
  end subroutine 
  !
  subroutine wrt_iband(threshold_transfer,NWF,NSK_BAND_DISP,kdata,EKS) 
    implicit none
    integer,intent(in)::NWF,NSK_BAND_DISP
    real(8),intent(in)::kdata(NSK_BAND_DISP)
    real(8),intent(in)::EKS(NWF,NSK_BAND_DISP) 
    real(8),intent(in)::threshold_transfer 
    integer::ib,ik 
    LOGICAL::REVERSE 
    real(8),parameter::au=27.21151d0 
    !
    !OPEN(114,W,FILE='./dat.iband') 
    !
    OPEN(114,FILE='./dat.iband') 
    write(114,'(a)')'#Wannier interpolaed band'
    write(114,'(a,x,f10.5)')'#Energy cutoff for transfer (eV)=',threshold_transfer*au
    write(114,'(a)')'#1:k, 2:Energy [eV]' 
    REVERSE=.TRUE.        
    do ib=1,NWF 
     if(REVERSE)then 
      do ik=1,NSK_BAND_DISP                     
       write(114,'(2f20.10)') kdata(ik),EKS(ib,ik)*au
      enddo!ik        
      REVERSE=.FALSE.        
     else         
      do ik=NSK_BAND_DISP,1,-1          
       write(114,'(2f20.10)') kdata(ik),EKS(ib,ik)*au
      enddo!ik        
      REVERSE=.TRUE.        
     endif!REVERSE                   
    enddo!ib 
    close(114) 
    !
    return 
  end subroutine   
  !
end module m_band 

module m_truncation 
  implicit none
contains
  subroutine truncation(NWF,Na1,Na2,Na3,threshold_e,threshold_r,diff_transfers,a1,a2,a3,wcenter_lat,KS_R)
    implicit none 
    integer,intent(in)::NWF,Na1,Na2,Na3 
    real(8),intent(in)::threshold_e,threshold_r,diff_transfers  
    real(8),intent(in)::a1(3),a2(3),a3(3) 
    real(8),intent(in)::wcenter_lat(3,NWF) 
    complex(8),intent(inout)::KS_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
    complex(8)::tij
    complex(8),allocatable::tr(:)
    real(8),allocatable::dist(:)
    integer,allocatable::ib_map(:)
    integer,allocatable::jb_map(:)
    integer,allocatable::ia1_map(:)
    integer,allocatable::ia2_map(:)
    integer,allocatable::ia3_map(:)
    integer::ia1,ia2,ia3,ib,jb
    integer::Ntr,itr 
    real(8)::vec_rij(3),rij 
    !
    Ntr=NWF*NWF*(2*Na3+1)*(2*Na2+1)*(2*Na1+1) 
    allocate(tr(Ntr)); tr=0.0d0  
    allocate(dist(Ntr)); dist=0.0d0  
    allocate(ib_map(Ntr)); ib_map=0 
    allocate(jb_map(Ntr)); jb_map=0 
    allocate(ia1_map(Ntr)); ia1_map=0
    allocate(ia2_map(Ntr)); ia2_map=0
    allocate(ia3_map(Ntr)); ia3_map=0
    !
    do ia1=-Na1,Na1
     do ia2=-Na2,Na2
      do ia3=-Na3,Na3
       do ib=1,NWF
        do jb=1,NWF 
         tij=KS_R(ib,jb,ia1,ia2,ia3)
         !
         if(threshold_e>abs(tij))then 
          tij=0.0d0 
         endif 
         !
         vec_rij(:)=(dble(ia1)+wcenter_lat(1,jb)-wcenter_lat(1,ib))*a1(:)&
                   +(dble(ia2)+wcenter_lat(2,jb)-wcenter_lat(2,ib))*a2(:)&
                   +(dble(ia3)+wcenter_lat(3,jb)-wcenter_lat(3,ib))*a3(:)
         rij=dsqrt(vec_rij(1)**2+vec_rij(2)**2+vec_rij(3)**2) 
         if(threshold_r<abs(rij))then 
          !write(6,*)'rij=',rij 
          tij=0.0d0 
         endif 
         !
         KS_R(ib,jb,ia1,ia2,ia3)=tij 
         ! 
         itr=jb +(ib-1)*NWF +(ia3+Na3)*NWF*NWF +(ia2+Na2)*NWF*NWF*(2*Na3+1) +(ia1+Na1)*NWF*NWF*(2*Na3+1)*(2*Na2+1)  
         ib_map(itr)=ib
         jb_map(itr)=jb
         ia3_map(itr)=ia3
         ia2_map(itr)=ia2
         ia1_map(itr)=ia1
         tr(itr)=tij
         dist(itr)=rij
         !
        enddo!jb 
       enddo!ib 
      enddo!ia3 
     enddo!ia2 
    enddo!ia1 
    !
    call wrt_transfer_analysis(threshold_e,threshold_r,diff_transfers,Ntr,ib_map(1),jb_map(1),ia1_map(1),ia2_map(1),ia3_map(1),dist(1),tr(1)) 
    !
    deallocate(tr,dist,ib_map,jb_map,ia1_map,ia2_map,ia3_map)
    !
    return
  end subroutine truncation 

  subroutine wrt_transfer_analysis(threshold_e,threshold_r,diff_transfers,Ntr,ib_map,jb_map,ia1_map,ia2_map,ia3_map,dist,tr) 
    implicit none 
    integer,intent(in)::Ntr
    real(8),intent(in)::threshold_e,threshold_r,diff_transfers   
    integer,intent(in)::ib_map(Ntr)
    integer,intent(in)::jb_map(Ntr)
    integer,intent(in)::ia1_map(Ntr)
    integer,intent(in)::ia2_map(Ntr)
    integer,intent(in)::ia3_map(Ntr)
    real(8),intent(in)::dist(Ntr)
    complex(8),intent(in)::tr(Ntr)
    real(8)::tri,trj 
    integer::itr,jtr
    integer,allocatable::skip(:)
    real(8),parameter::au=27.21151d0 
    real(8),parameter::del_zero=(1.d-5)/au  
    !
    !OPEN(122,W,FILE='./dat.tr') 
    !
    OPEN(122,FILE='./dat.tr') 
    rewind(122)
    write(122,'(a30,x,f10.5)')'#Threshold for transfer (eV):',threshold_e*au
    write(122,'(a30,x,f10.5)')'#Threshold for distance (AA):',threshold_r 
    write(122,'(a30,x,f10.5)')'#difference in transfers (eV):',diff_transfers*au  
    write(122,'(a30)')'#i,j,ia1,ia2,ia3,tr,dist:'
    allocate(skip(Ntr)); skip=0
    do itr=1,Ntr 
     tri=abs(dble(tr(itr)))  
     if(tri<del_zero)cycle 
     if(skip(itr)==1)cycle 
     write(122,*) 
     write(122,'(a30)')'irreducible transfer:' 
     !write(122,'(5i5,2f15.7)') ib_map(itr),jb_map(itr),ia1_map(itr),ia2_map(itr),ia3_map(itr),dble(tr(itr))*au,dist(itr)
     write(122,'(5i3,2f10.5)') ib_map(itr),jb_map(itr),ia1_map(itr),ia2_map(itr),ia3_map(itr),dble(tr(itr))*au,dist(itr)
     write(122,*) 
     do jtr=1,Ntr 
      trj=abs(dble(tr(jtr)))  
      if(itr==jtr)cycle 
      if(skip(jtr)==1)cycle 
      if(trj<del_zero)cycle 
      if(abs(tri-trj)<diff_transfers)then 
       !write(122,'(5i5,2f15.7)') ib_map(jtr),jb_map(jtr),ia1_map(jtr),ia2_map(jtr),ia3_map(jtr),dble(tr(jtr))*au,dist(jtr)
       write(122,'(5i3,2f10.5)') ib_map(jtr),jb_map(jtr),ia1_map(jtr),ia2_map(jtr),ia3_map(jtr),dble(tr(jtr))*au,dist(jtr)
       !write(122,'(2i10,2f15.7)') itr,jtr,dble(tr(itr))*au,dble(tr(jtr))*au  
       skip(jtr)=1
      endif 
     enddo 
     skip(itr)=1 
    enddo 
    deallocate(skip)
    !
    return
  end subroutine wrt_transfer_analysis 
  !
  subroutine set_kgrid(dense,kvec)
    IMPLICIT NONE
    integer,intent(in)::dense(3)!Calculated k-grid 
    REAL(8),intent(out)::kvec(3,PRODUCT(dense(1:3))) 
    INTEGER::ik,i1,i2,i3,s1,s2,s3 
    !
    WRITE(6,'(a50,x,3i10)')'Calculated k-grid:',dense(1:3)
    !
    s1=dense(1)/2; s2=dense(2)/2; s3=dense(3)/2 
    ik = 0
    DO i1=-(s1-mod(dense(1)+1,2)),s1  
       DO i2=-(s2-mod(dense(2)+1,2)),s2  
          DO i3=-(s3-mod(dense(3)+1,2)),s3  
             ik=ik + 1
             kvec(1:3,ik)=DBLE((/i1, i2, i3/))/DBLE(dense(1:3))
          END DO
       END DO
    END DO
    !
    WRITE(6,'(a50,x,i10)')'Total number of k-grid:',ik 
    return
  end subroutine set_kgrid 
  !
  subroutine set_FR(NWF,nkb1,nkb2,nkb3,kgd1,kgd2,kgd3,Na1,Na2,Na3,La1,La2,La3,HR,FR) 
    implicit none 
    integer,intent(in)::NWF,nkb1,nkb2,nkb3,kgd1,kgd2,kgd3,Na1,Na2,Na3,La1,La2,La3 
    complex(8),intent(inout)::HR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3) 
    complex(8),intent(out)::FR(NWF,NWF,-La1:La1,-La2:La2,-La3:La3) 
    real(8),allocatable::WR(:,:,:) 
    integer::i,j,k 
    !integer::ib,jb  
    !complex(8)::tij
    real(8),parameter::au=27.21151d0 
    !
    allocate(WR(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WR=1.0 
    call get_weightR(nkb1,nkb2,nkb3,Na1,Na2,Na3,WR(-Na1,-Na2,-Na3))      
    !
    !rm weight factor
    !
    do i=-Na1,Na1
     do j=-Na2,Na2
      do k=-Na3,Na3 
       HR(:,:,i,j,k)=HR(:,:,i,j,k)/WR(i,j,k) 
      enddo
     enddo
    enddo
    deallocate(WR) 
    !
    !F(R)<--H(R) 
    !
    do i=-min(Na1,La1),min(Na1,La1)  
     do j=-min(Na2,La2),min(Na2,La2)  
      do k=-min(Na3,La3),min(Na3,La3)  
       FR(:,:,i,j,k)=HR(:,:,i,j,k) 
      enddo
     enddo
    enddo 
    !
    allocate(WR(-La1:La1,-La2:La2,-La3:La3)); WR=1.0 
    call get_weightR(kgd1,kgd2,kgd3,La1,La2,La3,WR(-La1,-La2,-La3))      
    ! 
    !add weight factor
    !
    do i=-La1,La1
     do j=-La2,La2
      do k=-La3,La3 
       FR(:,:,i,j,k)=FR(:,:,i,j,k)*WR(i,j,k) 
      enddo
     enddo
    enddo
    deallocate(WR) 
    !
    !output check 
    !
    !do i=-La1,La1
    ! do j=-La2,La2
    !  do k=-La3,La3 
    !   do ib=1,NWF
    !    do jb=1,NWF 
    !     tij=FR(ib,jb,i,j,k)
    !     write(6,'(5i5,2f15.7)') ib,jb,i,j,k,dble(tij)*au,abs(tij)*au
    !    enddo
    !   enddo 
    !  enddo
    ! enddo
    !enddo  
    ! 
    return
  end subroutine set_FR 
  !
  subroutine get_weightR(kgd1,kgd2,kgd3,Na1,Na2,Na3,WEIGHT_R) 
    implicit none 
    integer,intent(in)::kgd1,kgd2,kgd3,Na1,Na2,Na3 
    real(8),intent(out)::WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3) 
    integer::ia1,ia2,ia3 
    integer::ncalck 
    real(8)::SUM_REAL
    !
    !WEIGHT_R BY Y.Nomura NOMURA 
    !
    SUM_REAL=0.0d0 
    WEIGHT_R=1.0d0  
    ncalck=kgd1*kgd2*kgd3 
    do ia1=-Na1,Na1
     do ia2=-Na2,Na2
      do ia3=-Na3,Na3
       if(abs(ia1)==Na1.and.mod(kgd1,2)==0.and.Na1/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
       if(abs(ia2)==Na2.and.mod(kgd2,2)==0.and.Na2/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
       if(abs(ia3)==Na3.and.mod(kgd3,2)==0.and.Na3/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
       SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
      enddo!ia3
     enddo!ia2
    enddo!ia1
    write(6,'(a50,f15.8,i8)')'SUM_WEIGHT, ncalck:',SUM_REAL,ncalck 
    if(abs(SUM_REAL-dble(ncalck))>1.0d-6)then 
     stop 'SUM_WEIGHT/=ncalck'
    endif 
    return
  end subroutine get_weightR    
  !
end module m_truncation 

subroutine invmat(nm,mat)
  implicit none 
  integer , intent(in) :: nm
  real(8) , intent(inout) :: mat(nm,nm)
  integer :: ipiv(nm)
  integer :: Lwork 
  real(8) , allocatable :: work(:)
  integer :: info 

  Lwork = 10*nm
  allocate (work(Lwork))
  info = 0
  call dgetrf(nm,nm,mat,nm,ipiv,info)
  call dgetri(nm,mat,nm,ipiv,work,Lwork,info)

  if(info /= 0) then
    write(6,*) 'info (subrouitine inv):' , info
    stop
  end if 
  deallocate(work)
  return 
end subroutine
!
subroutine invmat_complex(nm,mat)
  implicit none 
  integer,intent(in)::nm
  complex(8),intent(inout)::mat(nm,nm)
  integer::ipiv(nm)
  integer::Lwork 
  complex(8),allocatable::work(:)
  integer::info 
  !
  Lwork = 10*nm
  allocate (work(Lwork))
  info = 0
  call zgetrf(nm,nm,mat,nm,ipiv,info)
  call zgetri(nm,mat,nm,ipiv,work,Lwork,info)
  !
  if(info /= 0) then
    write(6,*) 'info (subrouitine inv):' , info
    stop
  end if 
  deallocate(work)
  return 
end subroutine
!
subroutine diagV(nm,mat,eig)
  implicit none 
  integer,intent(in)::nm
  complex(8),intent(inout)::mat(nm,nm)
  real(8),intent(out)::eig(nm)
  integer::LWORK,LRWORK,LIWORK  
  integer,allocatable::iwork_zheevd(:)
  real(8),allocatable::rwork_zheevd(:)
  complex(8),allocatable::work_zheevd(:)
  integer::ind
  real(8)::eps 
  !
  LWORK= 2*nm+nm**2
  LRWORK=1+12*nm+3*nm**2
  LIWORK=3+10*nm 
  allocate(work_zheevd(LWORK));work_zheevd(:)=0.0d0
  allocate(rwork_zheevd(LRWORK));rwork_zheevd(:)=0.0d0
  allocate(iwork_zheevd(LIWORK));iwork_zheevd(:)=0
  eps=1.0d-18
  ind=0                 
  !
  call zheevd("V","U",nm,mat,nm,eig,work_zheevd,LWORK,rwork_zheevd,LRWORK,iwork_zheevd,LIWORK,ind)
  !
  if(ind/=0)then 
   write(6,*)'ind=',ind 
   stop
  endif 
  !
  deallocate(work_zheevd,rwork_zheevd,iwork_zheevd) 
  return 
end subroutine
!
subroutine OUTER_PRODUCT(vec_x,vec_y,vec_z)
  implicit none 
  real(8)::vec_x(3),vec_y(3),vec_z(3) 
  !
  vec_z(1)=vec_x(2)*vec_y(3)-vec_x(3)*vec_y(2)
  vec_z(2)=vec_x(3)*vec_y(1)-vec_x(1)*vec_y(3) 
  vec_z(3)=vec_x(1)*vec_y(2)-vec_x(2)*vec_y(1)
  !
  return
end subroutine 

PROGRAM GW
!
use mpi
use fft_3d 
use m_rd_input       
use m_rd_dat_wfn
use m_rd_dat_wan 
use m_rd_dat_eps 
include "config.h" 
!
!mpi 
!
comm=MPI_COMM_WORLD
call MPI_INIT(ierr)
call MPI_COMM_RANK(comm,myrank,ierr)
call MPI_COMM_SIZE(comm,nproc,ierr)
write(6,'(a10,i10,a10,i10)')'myrank=',myrank,'nproc=',nproc
!file_id=9000+myrank 
call MPI_BARRIER(comm,ierr)
start_time=MPI_Wtime() 
!
!read input
!
if(myrank.eq.0)then 
 call read_input 
 gw_grid_separation=gw_grid_separation/au
endif 
call MPI_BARRIER(comm,ierr)
!
call MPI_Bcast(gw_grid_separation,1,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(Rc_range_spacing,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Ncalc,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(calc_SC,1,MPI_LOGICAL,0,comm,ierr) 
!
call MPI_Bcast(N_sym_points,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Ndiv,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(reading_sk_format,1,MPI_INTEGER,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
!
if(myrank/=0) allocate(dense(3))
if(myrank/=0) allocate(SK_sym_pts(3,N_sym_points))  
call MPI_Bcast(dense,3,MPI_INTEGER,0,comm,ierr)
call MPI_Bcast(SK_sym_pts,3*N_sym_points,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_BARRIER(comm,ierr)
!
!read wfn 
!
if(myrank.eq.0)then 
 call rd_dat_symmetry 
 call rd_dat_bandcalc 
 call rd_dat_lattice 
 call rd_dat_sample_k 
 call rd_dat_nkm 
 call rd_dat_kg 
 call rd_dat_eigenvalue  
 call rd_dat_wavefunction 
endif 
call MPI_BARRIER(comm,ierr)
!
!sym(100)
!
call MPI_Bcast(nsymq,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(nnp,1,MPI_INTEGER,0,comm,ierr) 
!
!bandcalc(117) 
!
call MPI_Bcast(Ecut_for_psi,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(FermiEnergy,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(Etot,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
!
!avec(105)
!
call MPI_Bcast(a1,3,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(a2,3,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(a3,3,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(b1,3,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(b2,3,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(b3,3,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(VOLUME,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(a,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(b,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(c,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(alp,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(bet,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(gmm,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
!
!sample-k(101)
!
call MPI_Bcast(Nk_irr,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(NTK,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(nkb1,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(nkb2,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(nkb3,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Na1,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Na2,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Na3,1,MPI_INTEGER,0,comm,ierr) 
!
!kg(104)
!
call MPI_Bcast(L1,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(L2,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(L3,1,MPI_INTEGER,0,comm,ierr) 
!
!fft 
!
call MPI_Bcast(nwx2,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(nwy2,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(nwz2,1,MPI_INTEGER,0,comm,ierr) 
!
!nkm(132)  
!
call MPI_Bcast(NTG,1,MPI_INTEGER,0,comm,ierr) 
!
!eigenvalue(111) 
!
call MPI_Bcast(NTB,1,MPI_INTEGER,0,comm,ierr) 
!
!cir(102) 
!
call MPI_Bcast(ncomp,1,MPI_INTEGER,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
!
if(myrank/=0) allocate(rg(3,3,nsymq))
if(myrank/=0) allocate(pg(3,nsymq))
if(myrank/=0) allocate(rginv(3,3,nsymq))  
if(myrank/=0) allocate(SKI(3,Nk_irr))  
if(myrank/=0) allocate(SK0(3,NTK))  
if(myrank/=0) allocate(numirr(NTK)) 
if(myrank/=0) allocate(numrot(NTK)) 
if(myrank/=0) allocate(trs(NTK)) 
if(myrank/=0) allocate(RW(3,NTK))
if(myrank/=0) allocate(numMK(Nk_irr))
if(myrank/=0) allocate(NGI(Nk_irr)) 
if(myrank/=0) allocate(NG0(NTK))
if(myrank/=0) allocate(KGI(3,NTG,Nk_irr)) 
if(myrank/=0) allocate(KG0(3,NTG,NTK))
if(myrank/=0) allocate(packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr))
if(myrank/=0) allocate(E_EIGI(NTB,Nk_irr))  
if(myrank/=0) allocate(CIR(NTG,NTB,Nk_irr)) 
call MPI_BARRIER(comm,ierr)
!
!20180922
!
!mem_size=dble(NTG*NTB*Nk_irr)*16.0d0/1024.0d0/1024.0d0/1024.0d0 
 mem_size=dble(NTG*NTB*Nk_irr)*8.0d0/1024.0d0/1024.0d0/1024.0d0 
!
if(myrank.eq.0)then 
 write(6,'(a35,f20.15)')'mem size CIR (GB)',mem_size
endif 
! 
call MPI_Bcast(rg,3*3*nsymq,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(pg,3*nsymq,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(rginv,3*3*nsymq,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(SKI,3*Nk_irr,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(SK0,3*NTK,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(numirr,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(numrot,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(trs,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(RW,3*NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(numMK,Nk_irr,MPI_INTEGER,0,comm,ierr)
call MPI_Bcast(NGI,Nk_irr,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(NG0,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(KGI,3*NTG*Nk_irr,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(KG0,3*NTG*NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(packing(-L1,-L2,-L3,1),(2*L1+1)*(2*L2+1)*(2*L3+1)*Nk_irr,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(E_EIGI,NTB*Nk_irr,MPI_DOUBLE_PRECISION,0,comm,ierr) 
!
!20180922
!
!call MPI_Bcast(CIR,NTG*NTB*Nk_irr,MPI_DOUBLE_COMPLEX,0,comm,ierr) 
 call MPI_Bcast(CIR,NTG*NTB*Nk_irr,MPI_COMPLEX,0,comm,ierr) 
!
call MPI_BARRIER(comm,ierr)
!
!read wan 
!
if(myrank.eq.0)then 
 call rd_dat_ns_nb 
 call rd_dat_umat 
 call rd_dat_wan 
 call rd_dat_hmatr 
endif 
call MPI_BARRIER(comm,ierr)
!
!ns-nb(149)  
!
call MPI_Bcast(Mb,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Mt,1,MPI_INTEGER,0,comm,ierr) 
!
!umat(150)  
!
call MPI_Bcast(NWF,1,MPI_INTEGER,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
!
if(myrank/=0) allocate(Ns(NTK))
if(myrank/=0) allocate(Nb(NTK))
if(myrank/=0) allocate(Nt(NTK))
if(myrank/=0) allocate(UNT(Mb,NWF,NTK))
if(myrank/=0) allocate(C0_WN(NTG,NWF,NTK))
if(myrank/=0) allocate(H_MAT_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3))
call MPI_BARRIER(comm,ierr)
!
call MPI_Bcast(Ns,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Nb,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Nt,NTK,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(UNT,Mb*NWF*NTK,MPI_DOUBLE_COMPLEX,0,comm,ierr) 
call MPI_Bcast(C0_WN,NTG*NWF*NTK,MPI_DOUBLE_COMPLEX,0,comm,ierr) 
call MPI_Bcast(H_MAT_R(1,1,-Na1,-Na2,-Na3),NWF*NWF*(2*Na1+1)*(2*Na2+1)*(2*Na3+1),MPI_DOUBLE_COMPLEX,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
!
!read eps 
!
if(myrank.eq.0)then 
 call rd_dat_chi_cutoff
 call rd_dat_ttrhdrn 
 call rd_dat_wgrid 
 call rd_dat_sq 
 call rd_dat_eps
 ! 
 !espinv=epsinv-1 
 !
 do iq=1,Nq_irr 
  NG_for_eps=NGQ_eps(iq) 
  do ie=1,ne 
   do igL=1,NG_for_eps 
    epsirr(igL,igL,ie,iq)=epsirr(igL,igL,ie,iq)-1.0d0    
   enddo 
  enddo 
 enddo 
 !
endif!myrank.eq.0 
!
!chi_cutoff(300)  
!
call MPI_Bcast(Ecut_for_eps,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
!
!ttrhdrn(302) 
!
call MPI_Bcast(idlt,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(dmna,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
call MPI_Bcast(dmnr,1,MPI_DOUBLE_PRECISION,0,comm,ierr)
!
!wgrid(135)  
!
call MPI_Bcast(Num_freq_grid,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(ne,1,MPI_INTEGER,0,comm,ierr) 
!
!sq(301)  
!
call MPI_Bcast(Nq_irr,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(NTQ,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(NTGQ,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Lq1,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Lq2,1,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(Lq3,1,MPI_INTEGER,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
!
if(myrank/=0) allocate(em(ne))
if(myrank/=0) allocate(pole_of_chi(ne))
if(myrank/=0) allocate(mat_b(ne,ne))
if(myrank/=0) allocate(SQI(3,Nq_irr)) 
if(myrank/=0) allocate(SQ(3,NTQ)) 
if(myrank/=0) allocate(numirrq(NTQ)) 
if(myrank/=0) allocate(numrotq(NTQ))  
if(myrank/=0) allocate(trsq(NTQ))  
if(myrank/=0) allocate(RWq(3,NTQ))
if(myrank/=0) allocate(LG0(3,NTG,NTQ))    
if(myrank/=0) allocate(NGQ_eps(NTQ))
if(myrank/=0) allocate(NGQ_psi(NTQ)) 
if(myrank/=0) allocate(packingq(-Lq1:Lq1,-Lq2:Lq2,-Lq3:Lq3,Nq_irr))
if(myrank/=0) allocate(epsirr(NTGQ,NTGQ,ne,Nq_irr))!real4 
call MPI_BARRIER(comm,ierr)
!
mem_size=dble(NTGQ*NTGQ*ne*Nq_irr)*8.0d0/1024.0d0/1024.0d0/1024.0d0 
if(myrank.eq.0)then 
 write(6,'(a35,f20.15)')'mem size epsirr (GB)',mem_size
endif 
! 
call MPI_Bcast(em,ne,MPI_DOUBLE_COMPLEX,0,comm,ierr) 
call MPI_Bcast(pole_of_chi,ne,MPI_DOUBLE_COMPLEX,0,comm,ierr)
call MPI_Bcast(mat_b,ne*ne,MPI_DOUBLE_COMPLEX,0,comm,ierr)
call MPI_Bcast(SQI,3*Nq_irr,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(SQ,3*NTQ,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_Bcast(numirrq,NTQ,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(numrotq,NTQ,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(trsq,NTQ,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(RWq,3*NTQ,MPI_INTEGER,0,comm,ierr)
call MPI_Bcast(LG0,3*NTG*NTQ,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(NGQ_eps,NTQ,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(NGQ_psi,NTQ,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(packingq(-Lq1,-Lq2,-Lq3,1),(2*Lq1+1)*(2*Lq2+1)*(2*Lq3+1)*Nq_irr,MPI_INTEGER,0,comm,ierr) 
call MPI_Bcast(epsirr,NTGQ*NTGQ*ne*Nq_irr,MPI_COMPLEX,0,comm,ierr)
call MPI_BARRIER(comm,ierr)
!
!if(myrank.eq.0)then 
! write(6,*) 
! write(6,*)'====================================='
! write(6,*)'dir-eps: FREQUENCY GRID IN EPSQW (eV)'
! write(6,*)'====================================='
! write(6,*) 
! do ie=1,ne 
!  write(6,'(2f15.7)') em(ie)*au 
! enddo 
! !write(6,*) 
! !write(6,*)'==========================='
! !write(6,*)'dir-eps: POLE OF MODEL GRID'
! !write(6,*)'==========================='
! !write(6,*) 
! !do ie=1,ne 
! ! write(6,'(2f15.10)') pole_of_chi(ie)
! !enddo 
!endif!myrank.eq.0  
!
!Rc, idlt, Ncalc
!
avec_length(1)=dsqrt(a1(1)**2+a1(2)**2+a1(3)**2)
avec_length(2)=dsqrt(a2(1)**2+a2(2)**2+a2(3)**2)
avec_length(3)=dsqrt(a3(1)**2+a3(2)**2+a3(3)**2)
Rc=Rc_range_spacing*maxval(avec_length) 
!
!Ncalc is set to NTB (defalut)
!
if(Ncalc.eq.0) Ncalc=NTB 
!
if(myrank.eq.0)then 
 write(6,*) 
 write(6,'(a40,x,i10)')'Ncalc (considered bands in self-energy)=',Ncalc 
 write(6,'(a40,x,f15.10)')'idlt (eV)=',idlt*au 
 write(6,'(a40,x,f15.10)')'Rc (AA)=',Rc*bohr   
endif 
!
!fbk 
!
allocate(fbk(NTB,NTK));fbk(:,:)=0.0d0 
do ik=1,NTK
 ikir=numirr(ik) 
 do ib=1,NTB
  FACTOR=(FermiEnergy-E_EIGI(ib,ikir))/idlt    
  fbk(ib,ik)=atan(FACTOR)/pi+0.5d0 
 enddo 
enddo 
SUM_REAL=0.0d0 
do ik=1,NTK
 ikir=numirr(ik) 
 do ib=1,NTB
  SUM_REAL=SUM_REAL+fbk(ib,ik) 
  en=(E_EIGI(ib,ikir)-FermiEnergy)*au  
 enddo
enddo
if(myrank.eq.0)then
 write(6,*) 
 write(6,'(a40,x,f15.7)')'Nele=',2.0d0*SUM_REAL/dble(NTK)  
endif 
!
!make sgmw
!
if(gw_grid_separation<idlt) gw_grid_separation=idlt
!
if(myrank.eq.0)then 
 bandmin=minval(E_EIGI(1+minval(Ns),:)) 
 bandmax=maxval(E_EIGI(minval(Nb)+minval(Ns),:))
 diff_band_energy=bandmax-bandmin 
 chiqw_grd_size=dble(em(ne)) 
 emax=bandmax+diff_band_energy 
 emin=bandmin-diff_band_energy 
 ecmax=bandmax+diff_band_energy+chiqw_grd_size 
 ecmin=bandmin-diff_band_energy-chiqw_grd_size  
 !
 call estimate_nsgm(ecmin,emin,emax,ecmax,gw_grid_separation,nproc,nsgm)
 allocate(sgmw(nsgm));sgmw=0.0d0 
 call make_sgmw(ecmin,emin,emax,gw_grid_separation,nsgm,sgmw(1))
 !
 write(6,*) 
 write(6,'(a40,x,i10)')'number of chiqw_grd =',Num_freq_grid 
 write(6,'(a40,x,f15.7)')'bandmax (eV)=',bandmax*au
 write(6,'(a40,x,f15.7)')'bandmin (eV)=',bandmin*au
 write(6,'(a40,x,f15.7)')'diff_band_energy (eV)=',diff_band_energy*au  
 write(6,'(a40,x,f15.7)')'chiqw_grd_range (eV)=',chiqw_grd_size*au  
 write(6,*) 
 write(6,'(a40,x,i10)')'number of gw_grd =',nsgm 
 write(6,'(a40,x,f15.7)')'emax (eV)=',emax*au
 write(6,'(a40,x,f15.7)')'emin (eV)=',emin*au
 write(6,'(a40,x,f15.7)')'ecmax (eV)=',ecmax*au
 write(6,'(a40,x,f15.7)')'ecmin (eV)=',ecmin*au
 write(6,'(a40,x,f15.7)')'gw_grid_separation (eV)=',gw_grid_separation*au
 write(6,*) 
 !write(6,*)'============================'
 !write(6,*)'FREQUENCY GRID IN EPSQW (eV)'
 !write(6,*)'============================'
 !write(6,*) 
 !do ie=1,ne 
 ! write(6,'(2f15.7)') em(ie)*au 
 !enddo 
 !write(6,*) 
 !write(6,*)'==========================='
 !write(6,*)'dir-eps: POLE OF MODEL GRID'
 !write(6,*)'==========================='
 !write(6,*) 
 !do ie=1,ne 
 ! write(6,'(2f15.10)') pole_of_chi(ie)
 !enddo 
 !write(6,*) 
 !write(6,*)'========================='
 !write(6,*)'FREQUENCY GRID IN GW (eV)'
 !write(6,*)'========================='
 !write(6,*) 
 !do ie=1,nsgm  
 ! write(6,'(f15.7)') sgmw(ie)*au 
 !enddo 
 !write(6,*) 
endif!myrank.eq.0
!
call MPI_Bcast(nsgm,1,MPI_INTEGER,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
if(myrank/=0) allocate(sgmw(nsgm))
call MPI_BARRIER(comm,ierr)
call MPI_Bcast(sgmw,nsgm,MPI_DOUBLE_PRECISION,0,comm,ierr) 
call MPI_BARRIER(comm,ierr)
!
!mkdir dir-gw
!
if(myrank.eq.0)then!master  
 call system('mkdir -p dir-gw')!20180509
 ierr=CHDIR("./dir-gw") 
 call system('pwd') 
 ! 
 !OPEN(136,R,FILE='./dat.gwgrid') 
 ! 
 OPEN(136,FILE='./dat.gwgrid') 
 rewind(136) 
 write(136,*) nsgm 
 do ie=1,nsgm 
  write(136,'(f20.10)') sgmw(ie) 
 enddo 
 ierr=CHDIR("..") 
 call system('pwd') 
endif!myrankeq0 
flush(6) 
!
!MPI 
!
pnq=NTQ/nproc 
if(mod(NTQ,nproc).ne.0) then
 nbufq=pnq+1
else
 nbufq=pnq
end if
if(myrank.lt.mod(NTQ,nproc)) then
 pnq=pnq+1
 bnq=pnq*myrank+1 
 enq=bnq+pnq-1
else
 bnq=(pnq+1)*mod(NTQ,nproc)+pnq*(myrank-mod(NTQ,nproc))+1 
 enq=bnq+pnq-1
end if
!
!######
!  SC 
!######
!
if(calc_sc)then!.true.=default 
 !
 !write(file_id,'(a)')'## SC calc start ##'
 !write(file_id,'(a,3i7)')'bnq,enq,pnq',bnq,enq,pnq 
 !
 if(myrank.eq.0)then 
  write(6,*)'## SC calc start ##' 
  write(6,*) 
 endif 
 !
 !fft
 !
 nfft1=nwx2+1; nfft2=nwy2+1; nfft3=nwz2+1; Nl123=nfft1*nfft2*nfft3 
 call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
 !
 allocate(pSC(nsgm,Mb,Mb,Nk_irr)); pSC(:,:,:,:)=0.0d0 
 do iq=1,pnq
  !
  q1=SQ(1,bnq+iq-1);q2=SQ(2,bnq+iq-1);q3=SQ(3,bnq+iq-1)
  !
  !q.ne.0 
  !
  if(q1/=0.0d0.or.q2/=0.0d0.or.q3/=0.0d0)then 
   NG_for_eps=NGQ_eps(bnq+iq-1)
   allocate(length_qg(NG_for_eps)); length_qg=0.0D0 
   allocate(atten_factor(NG_for_eps)); atten_factor=0.0D0 
   allocate(epsmk(NTGQ,NTGQ,ne)); epsmk=0.0d0 
   iqir=numirrq(bnq+iq-1)
   iop=numrotq(bnq+iq-1)
   !
   call make_eps(NTG,NTGQ,ne,trsq(bnq+iq-1),NGQ_eps(bnq+iq-1),LG0(1,1,bnq+iq-1),RWq(1,bnq+iq-1),&
   rginv(1,1,iop),pg(1,iop),nnp,Lq1,Lq2,Lq3,packingq(-Lq1,-Lq2,-Lq3,iqir),epsirr(1,1,1,iqir),&
   epsmk(1,1,1)) 
   !
   length_qg(:)=0.0d0 
   atten_factor(:)=0.0d0 
   do igL=1,NG_for_eps   
    igL1=LG0(1,igL,bnq+iq-1)
    igL2=LG0(2,igL,bnq+iq-1)
    igL3=LG0(3,igL,bnq+iq-1)
    qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)
    qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
    qgL1=dsqrt(qgL2) 
    length_qg(igL)=qgL1
    atten_factor(igL)=dsqrt(1.0d0-dcos(qgL1*Rc))   
   enddo!igL 
   !
!$OMP PARALLEL PRIVATE(ib,ik,jb,shift_G,ikq,C0_K,C0_KmQ,rho,wfunc,fftwk,rho_tmp,ikir,iop,kb,ie,SUM_CMPX,&
!$OMP&         ikqir,ikqop,igL,jgL,vecf,je,veca,delta,de,sgn,dnm,pSComp) 
   allocate(rho(NG_for_eps,Mb,Nk_irr));rho=0.0d0
   allocate(fftwk(Nl123*2));fftwk=0.0d0 
   allocate(wfunc(Nl123*2));wfunc=0.0d0 
   allocate(rho_tmp(NG_for_eps));rho_tmp=0.0d0
   allocate(pSComp(nsgm,Mb,Mb,Nk_irr)); pSComp=0.0d0  
   allocate(C0_K(NTG));C0_K=0.0d0
   allocate(C0_KmQ(NTG));C0_KmQ=0.0d0
   allocate(vecf(ne));vecf=0.0d0
   allocate(veca(ne));veca=0.0d0
!$OMP DO  
   do ib=1,Ncalc
    if(myrank.eq.0) write(6,*)'ib=',ib
    !
    rho(:,:,:)=0.0D0 
    !
    do ikir=1,Nk_irr
     !
     ik=numMK(ikir) 
     iop=numrot(ik) 
     !
     do jb=1,Nb(ik)!Mb  
      !
      call make_C0_for_given_band(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),rginv(1,1,iop),pg(1,iop),nnp,&
      L1,L2,L3,packing(-L1,-L2,-L3,ikir),CIR(1,jb+Ns(ik),ikir),C0_K(1)) 
      ! 
      shift_G(:)=0
      call search_kq(NTK,SK0(1,1),-q1,-q2,-q3,ik,ikq,shift_G(1))
      shift_G(:)=-shift_G(:)
      !
      ikqir=numirr(ikq)
      ikqop=numrot(ikq) 
      !
      call make_C0_for_given_band(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),rginv(1,1,ikqop),pg(1,ikqop),nnp,&
      L1,L2,L3,packing(-L1,-L2,-L3,ikqir),CIR(1,ib,ikqir),C0_KmQ(1)) 
      !
      call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),C0_KmQ(1),C0_K(1),ikq,ik,nwx2,nwy2,nwz2,&
      nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,LG0(1,1,bnq+iq-1),NG_for_eps,shift_G(1),rho_tmp(1))
      !
      rho(:,jb,ikir)=rho_tmp(:)
      !
     enddo!jb  
    enddo!ikir 
    !
    do ikir=1,Nk_irr 
     !
     ik=numMK(ikir) 
     !
     shift_G(:)=0
     call search_kq(NTK,SK0(1,1),-q1,-q2,-q3,ik,ikq,shift_G(1))
     !
     do jb=1,Nb(ik)!Mb 
      do kb=1,Nb(ik)!Mb 
       vecf=0.0d0
       do ie=1,ne 
        SUM_CMPX=0.0d0
        do igL=1,NG_for_eps  
         do jgL=1,NG_for_eps 
          !
          SUM_CMPX=SUM_CMPX+rho(igL,jb,ikir)/length_qg(igL)*atten_factor(igL)*epsmk(igL,jgL,ie)&
          *CONJG(rho(jgL,kb,ikir))/length_qg(jgL)*atten_factor(jgL) 
          !
         enddo!jgL 
        enddo!igL 
        vecf(ie)=2.0d0*tpi*SUM_CMPX/dble(NTQ)/VOLUME 
       enddo!ie 
       !
       veca=0.0d0 
       do je=1,ne 
        SUM_CMPX=0.0d0 
        do ie=1,ne 
         SUM_CMPX=SUM_CMPX+mat_b(je,ie)*vecf(ie) 
        enddo!ie 
        veca(je)=SUM_CMPX
       enddo!je 
       !
       do ie=1,nsgm 
        delta=sgmw(ie) 
        !
        ikqir=numirr(ikq) 
        de=delta-E_EIGI(ib,ikqir)
        !
        if(E_EIGI(ib,ikqir)>FermiEnergy)then 
         sgn=1.0d0
        else
         sgn=-1.0d0
        endif 
        !
        do je=1,ne 
         !
         dnm=de-(pole_of_chi(je)-ci*idlt)*sgn
         !
         pSComp(ie,jb,kb,ikir)=pSComp(ie,jb,kb,ikir)+veca(je)/dnm 
         !
        enddo!je 
       enddo!ie  
      enddo!kb 
     enddo!jb 
    enddo!ikir  
   enddo!ib 
!$OMP END DO
!$OMP CRITICAL
   pSC=pSC+pSComp
!$OMP END CRITICAL
   deallocate(fftwk,wfunc,rho_tmp,rho,pSComp,C0_K,C0_KmQ,vecf,veca)
!$OMP END PARALLEL
   if(myrank.eq.0) write(6,*)'FINISH iq',iq 
   deallocate(length_qg,atten_factor,epsmk) 
   !
  elseif(q1==0.0d0.and.q2==0.0d0.and.q3==0.0d0) then 
   !
   !q.eq.0 
   !
   NG_for_eps=NGQ_eps(bnq+iq-1)
   allocate(length_qg(NG_for_eps));length_qg=0.0d0 
   allocate(atten_factor(NG_for_eps));atten_factor=0.0d0  
   allocate(rho(NG_for_eps,Mb,Nk_irr));rho=0.0d0 
   allocate(epsmk(NTGQ,NTGQ,ne));epsmk(:,:,:)=0.0d0 
   iqir=numirrq(bnq+iq-1)
   iop=numrotq(bnq+iq-1)
   !
   call make_eps(NTG,NTGQ,ne,trsq(bnq+iq-1),NGQ_eps(bnq+iq-1),LG0(1,1,bnq+iq-1),RWq(1,bnq+iq-1),&
   rginv(1,1,iop),pg(1,iop),nnp,Lq1,Lq2,Lq3,packingq(-Lq1,-Lq2,-Lq3,iqir),epsirr(1,1,1,iqir),&
   epsmk(1,1,1)) 
   !
   length_qg(:)=0.0D0 
   do igL=1,NG_for_eps   
    igL1=LG0(1,igL,bnq+iq-1)
    igL2=LG0(2,igL,bnq+iq-1)
    igL3=LG0(3,igL,bnq+iq-1)
    if(igL1==0.and.igL2==0.and.igL3==0)then 
     No_G_0=igL  
     !20180822
     length_qg(igL)=1.0d0 
     atten_factor(igL)=0.0d0 
    else
     qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)
     qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
     qgL1=dsqrt(qgL2) 
     length_qg(igL)=qgL1
     atten_factor(igL)=dsqrt(1.0d0-dcos(qgL1*Rc))   
    endif 
   enddo!igL 
   !
   do ib=1,Ncalc
    if(myrank.eq.0) write(6,*)'ib=',ib
    rho(:,:,:)=0.0D0 
!$OMP PARALLEL PRIVATE(ik,jb,ikqir,ikqop,shift_G,ikq,C0_K,C0_KmQ,wfunc,fftwk,rho_tmp,ikir,iop) 
    allocate(fftwk(Nl123*2));fftwk=0.0d0 
    allocate(wfunc(Nl123*2));wfunc=0.0d0  
    allocate(rho_tmp(NG_for_eps));rho_tmp=0.0d0 
    allocate(C0_K(NTG));C0_K=0.0d0
    allocate(C0_KmQ(NTG));C0_KmQ=0.0d0
!$OMP DO
    do ikir=1,Nk_irr 
     !
     ik=numMK(ikir) 
     iop=numrot(ik) 
     !
     do jb=1,Nb(ik)!Mb 
      !
      call make_C0_for_given_band(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),rginv(1,1,iop),pg(1,iop),nnp,&
      L1,L2,L3,packing(-L1,-L2,-L3,ikir),CIR(1,jb+Ns(ik),ikir),C0_K(1)) 
      !
      shift_G(:)=0
      ikq=ik 
      !
      ikqir=numirr(ikq)
      ikqop=numrot(ikq) 
      !
      call make_C0_for_given_band(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),rginv(1,1,ikqop),pg(1,ikqop),nnp,&
      L1,L2,L3,packing(-L1,-L2,-L3,ikqir),CIR(1,ib,ikqir),C0_KmQ(1)) 
      !
      call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),C0_KmQ(1),C0_K(1),ikq,ik,nwx2,nwy2,nwz2,&
      nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,LG0(1,1,bnq+iq-1),NG_for_eps,shift_G(1),rho_tmp(1))
      !
      rho(:,jb,ikir)=rho_tmp(:)
      !
     enddo!jb
    enddo!ikir 
!$OMP END DO
    deallocate(fftwk,wfunc,rho_tmp,C0_K,C0_KmQ)
!$OMP END PARALLEL
!--
!$OMP PARALLEL PRIVATE(ik,jb,kb,ie,SUM_CMPX,igL,jgL,vecf,je,veca,ikq,delta,ikir,ikqir,de,sgn,dnm) 
    allocate(vecf(ne));vecf=0.0d0
    allocate(veca(ne));veca=0.0d0
!$OMP DO
    do ikir=1,Nk_irr 
     !
     ik=numMK(ikir)
     !
     do jb=1,Nb(ik)!Mb 
      do kb=1,Nb(ik)!Mb 
       vecf=0.0d0 
       do ie=1,ne 
        SUM_CMPX=0.0d0
        do igL=1,NG_for_eps 
         !if(igL==No_G_0) cycle 
         do jgL=1,NG_for_eps 
          !if(jgL==No_G_0) cycle 
          !
          SUM_CMPX=SUM_CMPX+rho(igL,jb,ikir)/length_qg(igL)*atten_factor(igL)*epsmk(igL,jgL,ie)&
          *CONJG(rho(jgL,kb,ikir))/length_qg(jgL)*atten_factor(jgL) 
          !
         enddo!jgL 
        enddo!igL  
        vecf(ie)=2.0d0*tpi*SUM_CMPX/VOLUME/dble(NTQ)  
       enddo!ie 
       veca=0.0d0
       do je=1,ne 
        SUM_CMPX=0.0d0 
        do ie=1,ne 
         SUM_CMPX=SUM_CMPX+mat_b(je,ie)*vecf(ie) 
        enddo!ie  
        veca(je)=SUM_CMPX 
       enddo!je  
       do ie=1,nsgm 
        ikq=ik 
        delta=sgmw(ie) 
        !
        ikqir=numirr(ikq) 
        de=delta-E_EIGI(ib,ikqir)
        !
        if(E_EIGI(ib,ikqir)>FermiEnergy)then 
         sgn=1.0d0
        else
         sgn=-1.0d0
        endif 
        !
        do je=1,ne 
         dnm=de-(pole_of_chi(je)-ci*idlt)*sgn
         !
         pSC(ie,jb,kb,ikir)=pSC(ie,jb,kb,ikir)+veca(je)/dnm 
         !
        enddo!je  
       enddo!ie  
      enddo!kb 
     enddo!jb 
    enddo!ikir 
!$OMP END DO
    deallocate(vecf,veca)
!$OMP END PARALLEL
   enddo!ib 
   deallocate(length_qg,atten_factor,rho,epsmk) 
   !
   !<head contribution> 
   !
   !(i) Spencer-Alabi
   !
   chead=(tpi/dble(NTQ)/VOLUME)*Rc*Rc   
   !
   !(ii) Hybertsen-Louie
   !
   !qsz=(6.0D0*(pi**2)/dble(NTQ)/dble(VOLUME))**(1.0D0/3.0D0)  
   !chead=(2.0D0/pi)*qsz 
   !
   !write(file_id,*)'bnq+iq-1=',bnq+iq-1 
   !write(file_id,*)'correction_head=',chead   
   !
   !cGW
   !
   !chead=0.0d0    
   !write(file_id,*)'cGW, then correction_head=0'
   !
   !write(file_id,*)'No_G_0=',No_G_0 
   allocate(vecf(ne));vecf=0.0d0
   allocate(veca(ne));veca=0.0d0
   do ikir=1,Nk_irr 
    !
    ik=numMK(ikir) 
    !
    do jb=1,Nb(ik)!Mb 
     !
     vecf=0.0d0 
     do ie=1,ne 
      vecf(ie)=epsirr(No_G_0,No_G_0,ie,bnq+iq-1)
     enddo!ie   
     !
     veca=0.0d0 
     do je=1,ne 
      SUM_CMPX=0.0d0 
      do ie=1,ne 
       SUM_CMPX=SUM_CMPX+mat_b(je,ie)*vecf(ie) 
      enddo!ie 
      veca(je)=SUM_CMPX 
     enddo!je  
     !
     do ie=1,nsgm  
      delta=sgmw(ie) 
      !
      de=delta-E_EIGI(jb+Ns(ik),ikir) 
      !
      if(E_EIGI(jb+Ns(ik),ikir)>FermiEnergy)then 
       sgn=1.0d0
      else
       sgn=-1.0d0
      endif 
      do je=1,ne 
       dnm=de-(pole_of_chi(je)-ci*idlt)*sgn
       !
       pSC(ie,jb,jb,ikir)=pSC(ie,jb,jb,ikir)+veca(je)/dnm*chead  
       !
      enddo!je
     enddo!ie  
    enddo!jb 
   enddo!ikir 
   deallocate(vecf,veca) 
   if(myrank.eq.0) write(6,*)'FINISH iq',iq 
  endif 
 enddo!iq 
 call MPI_BARRIER(comm,ierr)
 !write(file_id,*)'I finished pSC calc' 
 allocate(SCirr(nsgm,Mb,Mb,Nk_irr)); SCirr(:,:,:,:)=0.0d0 
 !
 !20180922
 !
 !mem_size=dble(nsgm*Mb*Mb*Nk_irr)*16.0d0/1024.0d0/1024.0d0/1024.0d0 
  mem_size=dble(nsgm*Mb*Mb*Nk_irr)*8.0d0/1024.0d0/1024.0d0/1024.0d0 
 if(myrank.eq.0)then 
  write(6,'(a35,f20.15)')'mem size pSC or SCirr (GB)',mem_size
 endif 
 !call MPI_REDUCE(pSC,SCirr,nsgm*Mb*Mb*Nk_irr,MPI_DOUBLE_COMPLEX,MPI_SUM,0,comm,ierr)
 call MPI_REDUCE(pSC,SCirr,nsgm*Mb*Mb*Nk_irr,MPI_COMPLEX,MPI_SUM,0,comm,ierr)
 call MPI_BARRIER(comm,ierr)
 !call MPI_Bcast(SCirr,nsgm*Mb*Mb*Nk_irr,MPI_DOUBLE_COMPLEX,0,comm,ierr) 
 call MPI_Bcast(SCirr,nsgm*Mb*Mb*Nk_irr,MPI_COMPLEX,0,comm,ierr) 
 call MPI_BARRIER(comm,ierr)
 !
 !MPI for nsgm 
 !
 pnw=nsgm/nproc 
 if(mod(nsgm,nproc).ne.0) then
  nbufw=pnw+1
 else
  nbufw=pnw 
 end if
 if(myrank.lt.mod(nsgm,nproc)) then
  pnw=pnw+1
  bnw=pnw*myrank+1 
  enw=bnw+pnw-1
 else
  bnw=(pnw+1)*mod(nsgm,nproc)+pnw*(myrank-mod(nsgm,nproc))+1 
  enw=bnw+pnw-1
 end if
 !write(file_id,'(a,3i7)')'bnw,enw,pnw',bnw,enw,pnw            
 !
 allocate(SC(pnw,Mb,Mb,NTK)); SC=0.0d0
 ! 
 !mem_size=dble(pnw*Mb*Mb*NTK)*16.0d0/1024.0d0/1024.0d0/1024.0d0 
 !if(myrank.eq.0)then 
 ! write(6,'(a35,f20.15)')'mem size SC (GB)',mem_size
 !endif 
 !
 do ik=1,NTK 
  ikir=numirr(ik) 
  if(trs(ik)==1)then 
   do ie=1,pnw!nsgm
    do ib=1,Nb(ik)!Mb
     do jb=1,Nb(ik)!Mb 
      SC(ie,ib,jb,ik)=SCirr(bnw+ie-1,ib,jb,ikir) 
     enddo 
    enddo 
   enddo 
  elseif(trs(ik)==-1)then 
   do ie=1,pnw!nsgm  
    do ib=1,Nb(ik)!Mb
     do jb=1,Nb(ik)!Mb 
      SC(ie,ib,jb,ik)=SCirr(bnw+ie-1,jb,ib,ikir) 
     enddo 
    enddo 
   enddo 
  endif 
 enddo 
 deallocate(pSC)
 !
 allocate(pf(NTK,-Na1:Na1,-Na2:Na2,-Na3:Na3)); pf=0.0d0     
 do ik=1,NTK 
  do ia3=-Na3,Na3 
   do ia2=-Na2,Na2 
    do ia1=-Na1,Na1 
     phase=tpi*(SK0(1,ik)*dble(ia1)+SK0(2,ik)*dble(ia2)+SK0(3,ik)*dble(ia3)) 
     pf(ik,ia1,ia2,ia3)=exp(-ci*phase) 
    enddo  
   enddo  
  enddo  
 enddo  
 !
 !make pSCR
 !
 if(myrank.eq.0)then
  write(6,*) 
  write(6,*)'start SCR' 
  write(6,*) 
 endif 
 !
 allocate(pSCR(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,pnw)); pSCR=0.0d0 
 !--
 !OMP CRITICAL: off-diagonal case (default)
 !--
 do ie=1,pnw!nsgm  
  do ia1=-Na1,Na1
   do ia2=-Na2,Na2
    do ia3=-Na3,Na3
     do iw=1,NWF
      do jw=1,NWF 
       SUM_CMPX=0.0D0 
!$OMP PARALLEL private(psum,ik,jb,kb)  
        psum=0.0d0 
!$OMP DO 
        do ik=1,NTK 
         do jb=1,Nb(ik) 
          do kb=1,Nb(ik) 
           psum=psum+CONJG(UNT(jb,iw,ik))*SC(ie,jb,kb,ik)*UNT(kb,jw,ik)*pf(ik,ia1,ia2,ia3) 
          enddo!kb 
         enddo!jb 
        enddo!ik 
!$OMP END DO 
!$OMP CRITICAL 
        SUM_CMPX=SUM_CMPX+psum 
!$OMP END CRITICAL 
!$OMP END PARALLEL 
       pSCR(iw,jw,ia1,ia2,ia3,ie)=SUM_CMPX/DBLE(NTK)
      enddo!jw
     enddo!iw
    enddo!ia3
   enddo!ia2 
  enddo!ia1 
  !write(file_id,'(a,i7)')'ie=',ie 
  !if(myrank.eq.0) write(6,*)'FINISH ie',ie  
  write(6,*)'FINISH ie myrank',ie,myrank   
 enddo!ie
 !--
 !OMP CRITICAL: diagonal case (not default)
 !--
 if(.false.)then 
  do ie=1,pnw!nsgm  
   do ia1=-Na1,Na1
    do ia2=-Na2,Na2
     do ia3=-Na3,Na3
      do iw=1,NWF
       do jw=1,NWF 
        SUM_CMPX=0.0D0 
!$OMP PARALLEL private(psum,ik,jb)  
         psum=0.0d0 
!$OMP DO 
         do ik=1,NTK 
          do jb=1,Nb(ik) 
           psum=psum+CONJG(UNT(jb,iw,ik))*SC(ie,jb,jb,ik)*UNT(jb,jw,ik)*pf(ik,ia1,ia2,ia3) 
          enddo!jb 
         enddo!ik 
!$OMP END DO 
!$OMP CRITICAL 
        SUM_CMPX=SUM_CMPX+psum 
!$OMP END CRITICAL 
!$OMP END PARALLEL 
        pSCR(iw,jw,ia1,ia2,ia3,ie)=SUM_CMPX/DBLE(NTK)
       enddo!jw
      enddo!iw
     enddo!ia3
    enddo!ia2 
   enddo!ia1 
   !write(file_id,'(a,i7)')'ie=',ie 
   if(myrank.eq.0) write(6,*)'FINISH ie',ie  
  enddo!ie
 endif
 !
 deallocate(SC,pf) 
 call MPI_BARRIER(comm,ierr)
 !write(file_id,*)'I finished pSCR calc' 
 !
 !make MAT_SC_R 
 !
 if(myrank.eq.0)then 
  allocate(MAT_SC_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm)); MAT_SC_R=0.0d0 
 endif 
 !
 ! 
 mem_size=dble(pnw*NWF*NWF*(2*Na1+1)*(2*Na2+1)*(2*Na3+1))*8.0d0/1024.0d0/1024.0d0/1024.0d0 
 if(myrank.eq.0)then 
  write(6,'(a35,f20.15)')'mem size pSCR (GB)',mem_size
 endif 
 ! 
 !
 call MPI_Gather(pSCR,pnw*NWF*NWF*(2*Na1+1)*(2*Na2+1)*(2*Na3+1),MPI_COMPLEX,&
                 MAT_SC_R,pnw*NWF*NWF*(2*Na1+1)*(2*Na2+1)*(2*Na3+1),MPI_COMPLEX,0,comm,ierr)
 !
 !
 if(myrank.eq.0)then 
  !write(5004) MAT_SC_R 
  write(6,*)'finish MAT_SC_R' 
 endif!myrank.eq.0 
 !
else
 write(6,*)'skip SC calc.' 
 if(myrank.eq.0)then 
  allocate(MAT_SC_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm)); MAT_SC_R=0.0d0 
 endif 
endif!calc SC or not 
!
!#############
!  OUTPUT SC 
!#############
!
if(calc_sc)then!.true.=default 
 if(myrank.eq.0)then 
  ierr=CHDIR("./dir-gw") 
  call system('pwd') 
  !
  !OPEN(156,FILE='./dat.energy_vs_sc') 
  !
  OPEN(156,FILE='./dat.energy_vs_sc') 
  rewind(156) 
  do ikir=1,Nk_irr 
   ik=numMK(ikir)
   do jb=1,Nb(ik)!Mb 
    min_diff=1.0d0 
    do ie=1,nsgm
     en=abs(sgmw(ie)-E_EIGI(jb+Ns(ik),ikir))  
     if(en<min_diff)then 
      min_diff=en 
      min_ie=ie
     endif  
    enddo!ie 
    en=E_EIGI(jb+Ns(ik),ikir)-FermiEnergy 
    write(156,'(3F20.10)') en*au,SCirr(min_ie,jb,jb,ikir)*au 
   enddo!jb 
  enddo!ikir 
  close(156) 
  !
  !OPEN(157,W,FILE='MAT_SC_R') 
  !
  !rewind(157)
  !do ia1=-Na1,Na1
  ! do ia2=-Na2,Na2 
  !  do ia3=-Na3,Na3 
  !   do jw=1,NWF
  !    do iw=1,NWF 
  !     write(157)(MAT_SC_R(ie,iw,jw,ia1,ia2,ia3),ie=1,nsgm) 
  !    enddo!iw  
  !   enddo!jw  
  !  enddo!ia3 
  ! enddo!ia2 
  !enddo!ia1 
  !close(157) 
  !
  ierr=CHDIR("..") 
  call system('pwd') 
 endif!myrank.eq.0
endif!calc SC or not 
!
deallocate(SCirr) 
!
!######
!  SX
!######
!
!write(file_id,'(a)')'## SX calc start ##'
!
if(myrank.eq.0)then 
 write(6,*)'## SX calc start ##' 
 write(6,*) 
endif 
!
!fft
!
nfft1=nwx2+1; nfft2=nwy2+1; nfft3=nwz2+1; Nl123=nfft1*nfft2*nfft3 
call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
!
allocate(SXirr(Mb,Mb,Nk_irr));SXirr(:,:,:)=0.0d0 
allocate(pSX(Mb,Mb,Nk_irr));pSX(:,:,:)=0.0d0 
do iq=1,pnq 
 !
 q1=SQ(1,bnq+iq-1); q2=SQ(2,bnq+iq-1); q3=SQ(3,bnq+iq-1)
 !
 !q.ne.0 
 !
 if(q1/=0.0d0.or.q2/=0.0d0.or.q3/=0.0d0)then 
  NG_for_psi=NGQ_psi(bnq+iq-1)
  allocate(atten_factor(NG_for_psi));atten_factor(:)=0.0D0 
  allocate(length_qg(NG_for_psi));length_qg(:)=0.0D0 
  allocate(rho(NG_for_psi,Mb,Nk_irr))
  do igL=1,NG_for_psi   
   igL1=LG0(1,igL,bnq+iq-1)
   igL2=LG0(2,igL,bnq+iq-1)
   igL3=LG0(3,igL,bnq+iq-1)
   qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)
   qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
   qgL1=dsqrt(qgL2) 
   length_qg(igL)=qgL1
   atten_factor(igL)=1.0d0-dcos(qgL1*Rc)  
  enddo 
  do ib=1,Ncalc!Mt
   rho(:,:,:)=0.0D0 
!$OMP PARALLEL PRIVATE(ik,shift_G,ikq,C0_K,C0_KmQ,jb,wfunc,fftwk,rho_tmp,ikir,iop,ikqir,ikqop) 
   allocate(fftwk(Nl123*2));fftwk=0.0d0 
   allocate(wfunc(Nl123*2));wfunc=0.0d0 
   allocate(rho_tmp(NG_for_psi));rho_tmp=0.0d0 
   allocate(C0_K(NTG));C0_K=0.0d0
   allocate(C0_KmQ(NTG));C0_KmQ=0.0d0
!$OMP DO
   do ikir=1,Nk_irr 
    !
    ik=numMK(ikir) 
    iop=numrot(ik) 
    !
    do jb=1,Nb(ik)!Mb 
     !
     call make_C0_for_given_band(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),rginv(1,1,iop),pg(1,iop),nnp,&
     L1,L2,L3,packing(-L1,-L2,-L3,ikir),CIR(1,jb+Ns(ik),ikir),C0_K(1)) 
     ! 
     shift_G(:)=0
     call search_kq(NTK,SK0(1,1),-q1,-q2,-q3,ik,ikq,shift_G(1))
     shift_G(:)=-shift_G(:)  
     !
     ikqir=numirr(ikq)
     ikqop=numrot(ikq) 
     !
     call make_C0_for_given_band(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),rginv(1,1,ikqop),pg(1,ikqop),nnp,&
     L1,L2,L3,packing(-L1,-L2,-L3,ikqir),CIR(1,ib,ikqir),C0_KmQ(1)) 
     !
     !
     call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),C0_KmQ(1),C0_K(1),ikq,ik,nwx2,nwy2,nwz2,&
     nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,LG0(1,1,bnq+iq-1),NG_for_psi,shift_G(1),rho_tmp(1))
     !
     rho(:,jb,ikir)=rho_tmp(:)
     !
    enddo!jb  
   enddo!ik 
!$OMP END DO 
   deallocate(fftwk,wfunc,rho_tmp,C0_K,C0_KmQ)
!$OMP END PARALLEL 
!$OMP PARALLEL PRIVATE(ik,ikir,shift_G,ikq,jb,kb,SUM_CMPX,igL)  
!$OMP DO
   do ikir=1,Nk_irr 
    !
    ik=numMK(ikir) 
    ! 
    shift_G(:)=0
    call search_kq(NTK,SK0(1,1),-q1,-q2,-q3,ik,ikq,shift_G(1))
    !
    do jb=1,Nb(ik)!Mb 
     do kb=1,Nb(ik)!Mb 
      SUM_CMPX=0.0d0
      do igL=1,NG_for_psi 
       !
       SUM_CMPX=SUM_CMPX+fbk(ib,ikq)*rho(igL,jb,ikir)&
       *CONJG(rho(igL,kb,ikir))/((length_qg(igL))**2)*atten_factor(igL)
       !
      enddo 
      !
      pSX(jb,kb,ikir)=pSX(jb,kb,ikir)+SUM_CMPX 
      !
     enddo!kb 
    enddo!jb 
   enddo!ik 
!$OMP END DO 
!$OMP END PARALLEL 
  enddo!ib 
  !write(file_id,*)'FINISH iq',iq
  if(myrank.eq.0) write(6,*)'FINISH iq',iq 
  deallocate(length_qg,atten_factor,rho) 
 elseif(q1==0.0d0.and.q2==0.0d0.and.q3==0.0d0)then 
  !
  !q.eq.0 
  !
  !write(file_id,'(a,x,3f10.5)')'q1,q2,q3=',q1,q2,q3  
  NG_for_psi=NGQ_psi(bnq+iq-1)
  allocate(length_qg(NG_for_psi));length_qg(:)=0.0D0 
  allocate(atten_factor(NG_for_psi));atten_factor(:)=0.0D0 
  allocate(rho(NG_for_psi,Mb,Nk_irr))
  do igL=1,NG_for_psi 
   igL1=LG0(1,igL,bnq+iq-1)
   igL2=LG0(2,igL,bnq+iq-1)
   igL3=LG0(3,igL,bnq+iq-1)
   if(igL1==0.and.igL2==0.and.igL3==0)then 
    No_G_0=igL  
    !20180822
    length_qg(igL)=1.0d0 
    atten_factor(igL)=0.0d0 
   else
    qgL(:)=(q1+dble(igL1))*b1(:)+(q2+dble(igL2))*b2(:)+(q3+dble(igL3))*b3(:)
    qgL2=qgL(1)**2+qgL(2)**2+qgL(3)**2
    qgL1=dsqrt(qgL2) 
    length_qg(igL)=qgL1
    atten_factor(igL)=1.0d0-dcos(qgL1*Rc)  
   endif 
  enddo!igL 
  do ib=1,Ncalc!Mt 
   rho(:,:,:)=0.0D0 
!$OMP PARALLEL PRIVATE(ik,shift_G,ikq,C0_K,C0_KmQ,jb,wfunc,fftwk,rho_tmp,ikir,iop,ikqir,ikqop) 
   allocate(fftwk(Nl123*2));fftwk=0.0d0 
   allocate(wfunc(Nl123*2));wfunc=0.0d0 
   allocate(rho_tmp(NG_for_psi));rho_tmp=0.0d0
   allocate(C0_K(NTG));C0_K=0.0d0
   allocate(C0_KmQ(NTG));C0_KmQ=0.0d0
!$OMP DO
   do ikir=1,Nk_irr 
    !
    ik=numMK(ikir) 
    iop=numrot(ik) 
    !
    do jb=1,Nb(ik)!Mb 
     !
     call make_C0_for_given_band(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),rginv(1,1,iop),pg(1,iop),nnp,&
     L1,L2,L3,packing(-L1,-L2,-L3,ikir),CIR(1,jb+Ns(ik),ikir),C0_K(1)) 
     !
     shift_G(:)=0
     ikq=ik 
     !
     ikqir=numirr(ikq)
     ikqop=numrot(ikq) 
     !
     call make_C0_for_given_band(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),rginv(1,1,ikqop),pg(1,ikqop),nnp,&
     L1,L2,L3,packing(-L1,-L2,-L3,ikqir),CIR(1,ib,ikqir),C0_KmQ(1)) 
     !
     call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),C0_KmQ(1),C0_K(1),ikq,ik,nwx2,nwy2,nwz2,&
     nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,LG0(1,1,bnq+iq-1),NG_for_psi,shift_G(1),rho_tmp(1))
     !
     rho(:,jb,ikir)=rho_tmp(:)
     !
    enddo!jb 
   enddo!ik  
!$OMP END DO
   deallocate(fftwk,wfunc,rho_tmp,C0_K,C0_KmQ)
!$OMP END PARALLEL 
!$OMP PARALLEL PRIVATE(ikir,ik,ikq,jb,kb,SUM_CMPX,igL) 
!$OMP DO
   do ikir=1,Nk_irr 
    !
    ik=numMK(ikir)
    !
    ikq=ik 
    !
    do jb=1,Nb(ik)!Mb 
     do kb=1,Nb(ik)!Mb 
      SUM_CMPX=0.0d0
      do igL=1,NG_for_psi 
       !if(igL.ne.No_G_0)then 
       !
       SUM_CMPX=SUM_CMPX+fbk(ib,ikq)*rho(igL,jb,ikir)*CONJG(rho(igL,kb,ikir))/((length_qg(igL))**2)*atten_factor(igL)
       !
       !endif 
      enddo!igL 
      !
      pSX(jb,kb,ikir)=pSX(jb,kb,ikir)+SUM_CMPX 
      !
     enddo!kb 
    enddo!jb 
   enddo!ik 
!$OMP END DO
!$OMP END PARALLEL 
  enddo ! ib 
  !write(file_id,*)'FINISH iq',iq
  !if(myrank.eq.0) write(6,*)'FINISH iq',iq 
  write(6,*)'FINISH iq myrank',iq,myrank  
  deallocate(length_qg,atten_factor,rho) 
 endif 
enddo!iq 
!
call MPI_BARRIER(comm,ierr)
!write(file_id,*)'I finished pSX calc' 
call MPI_REDUCE(pSX,SXirr,Mb*Mb*Nk_irr,MPI_DOUBLE_COMPLEX,MPI_SUM,0,comm,ierr)
!
if(myrank.eq.0)then 
 SXirr(:,:,:)=2.0d0*tpi*SXirr(:,:,:)/dble(NTQ)/VOLUME 
 !
 !<head contribution> iq=NTQ
 !
 !(i) Spencer-Alabi
 !
 chead=(tpi/dble(NTQ)/VOLUME)*Rc*Rc   
 !
 !(ii) Hybertsen-Louie
 !
 !qsz=(6.0D0*(pi**2)/dble(NTQ)/dble(VOLUME))**(1.0D0/3.0D0)  
 !chead=(2.0D0/pi)*qsz 
 !
 write(6,*)'correction_head=',chead   
 !
 allocate(SX_DIV(Mb,Mb,Nk_irr));SX_DIV(:,:,:)=0.0d0 
 do ikir=1,Nk_irr 
  ik=numMK(ikir)
  do jb=1,Nb(ik)!Mb 
   SX_DIV(jb,jb,ikir)=fbk(jb+Ns(ik),ik)*chead 
  enddo!jb 
 enddo!ik 
 SXirr=SXirr+SX_DIV!fGW
 !--
 !SXirr=SXirr!cGW
 !--
 allocate(SX(Mb,Mb,NTK));SX(:,:,:)=0.0d0 
 do ik=1,NTK 
  ikir=numirr(ik) 
  if(trs(ik)==1) then 
   SX(:,:,ik)=SXirr(:,:,ikir) 
  elseif(trs(ik)==-1) then 
   do ib=1,Nb(ik)!Mb
    do jb=1,Nb(ik)!Mb
     SX(ib,jb,ik)=SXirr(jb,ib,ikir) 
    enddo!jb
   enddo!ib 
  endif 
 enddo!ik 
 !
 allocate(pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK));pf=0.0d0     
 do ik=1,NTK 
  do ia3=-Na3,Na3 
   do ia2=-Na2,Na2 
    do ia1=-Na1,Na1 
     phase=tpi*(SK0(1,ik)*dble(ia1)+SK0(2,ik)*dble(ia2)+SK0(3,ik)*dble(ia3)) 
     pf(ia1,ia2,ia3,ik)=exp(-ci*phase) 
    enddo  
   enddo  
  enddo  
 enddo  
 write(6,*)'#finish make pf'
 !
 allocate(MAT_SX_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3));MAT_SX_R(:,:,:,:,:)=0.0d0 
 do ia3=-Na3,Na3
  do ia2=-Na2,Na2
   do ia1=-Na1,Na1
    do iw=1,NWF
     do jw=1,NWF 
      SUM_CMPX=0.0D0 
      if(.true.)then!.true.=off-diag, .false.=diag
       do ik=1,NTK 
        do ib=1,Nb(ik) 
         do jb=1,Nb(ik) 
          SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*SX(ib,jb,ik)*UNT(jb,jw,ik)*pf(ia1,ia2,ia3,ik) 
         enddo 
        enddo 
       enddo 
      else 
       do ik=1,NTK 
        do ib=1,Nb(ik) 
         SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*SX(ib,ib,ik)*UNT(ib,jw,ik)*pf(ia1,ia2,ia3,ik) 
        enddo 
       enddo 
      endif 
      MAT_SX_R(iw,jw,ia1,ia2,ia3)=SUM_CMPX/DBLE(NTK)
     enddo 
    enddo 
   enddo 
  enddo 
 enddo 
 deallocate(SX,pf) 
 write(6,*)'finish MAT_SX_R' 
 !
 !write(5003) MAT_SX_R 
 !
 write(6,*) 
 write(6,*)'================'
 write(6,*)' MAT_SX_R in eV '
 write(6,*)'================'
 write(6,*) 
 do ia1=-Na1,Na1 
  do ia2=-Na2,Na2 
   do ia3=-Na3,Na3 
    write(6,*) ia1,ia2,ia3           
    do iw=1,NWF
     write(6,'(300F15.8)')(dble(MAT_SX_R(iw,jw,ia1,ia2,ia3)*au),jw=1,NWF)
    enddo!iw  
    write(6,*)  
   enddo!ia3       
  enddo!ia2 
 enddo!ia1 
 !
endif!myrank.eq.0
!
!#############
!  OUTPUT SX 
!#############
!
if(myrank.eq.0)then 
 ierr=CHDIR("./dir-gw") 
 call system('pwd') 
 !
 !OPEN(154,FILE='./dat.energy_vs_sx') 
 !
 OPEN(154,FILE='./dat.energy_vs_sx') 
 rewind(154) 
 do ikir=1,Nk_irr 
  ik=numMK(ikir)
  do jb=1,Nb(ik)!Mb 
   en=(E_EIGI(jb+Ns(ik),ikir)-FermiEnergy)*au 
   write(154,'(3F20.10)') en,SXirr(jb,jb,ikir)*au 
  enddo!jb 
 enddo!ikir 
 close(154)
 !
 deallocate(SXirr) 
 !
 !OPEN(155,FILE='./dat.sx_mat_r') 
 !
 OPEN(155,FILE='./dat.sx_mat_r') 
 rewind(155)
 write(155,'(a)')'#sx_mat_r'
 write(155,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
 write(155,'(a)')'#1:i, 2:j, 3:Re(Sx_ij) [eV], 4:Im(Sx_ij) [eV]' 
 do ia1=-Na1,Na1 
  do ia2=-Na2,Na2 
   do ia3=-Na3,Na3
    write(155,*) ia1,ia2,ia3           
    do iw=1,NWF
     do jw=1,NWF 
      write(155,'(i5,i5,2f20.10)') iw,jw,MAT_SX_R(iw,jw,ia1,ia2,ia3)*au 
     enddo!jw       
    enddo!iw       
    write(155,*) 
   enddo!ia3
  enddo!ia2
 enddo!ia1
 close(155) 
 ierr=CHDIR("..") 
 call system('pwd') 
endif!myrank.eq.0
!
!#######
!  VXC
!#######
!
if(myrank.eq.0)then
 !
 !write(file_id,'(a)')'## Vxc calc start ##'
 !
 write(6,*)'## Vxc calc start ##' 
 write(6,*) 
 !
 !
 !OPEN(151,FILE='./dat.vxc',FORM='unformatted') 
 !
 OPEN(151,FILE='./dat.vxc',FORM='unformatted') 
 REWIND(151)       
 read(151) header 
 read(151) aa,nsnd 
 if(nsnd>1)then
  write(6,*)'nspin*ndens>1; the program not supported; then stop'
  stop
 endif 
 read(151) nrx2,nry2,nrz2; write(6,*)'nrx2,nry2,nrz2=',nrx2,nry2,nrz2 
 allocate(vxcr(nrx2,nry2,nrz2));vxcr(:,:,:)=0.0d0 
 read(151) vxcr(:,:,:) 
 close(151)  
 write(6,*)'FINISH REDING VXCR'
 !
 !fft
 !
 nfft1=nrx2+1; nfft2=nry2+1; nfft3=nrz2+1; Nl123=nfft1*nfft2*nfft3 
 call fft3_init(nrx2,nry2,nrz2,nfft1,nfft2,nfft3,fs) 
 allocate(fftwk(Nl123*2),stat=err) 
 allocate(wfunc(Nl123*2),stat=err) 
 !
 allocate(VXCirr(Mb,Mb,Nk_irr));VXCirr(:,:,:)=0.0d0 
 allocate(MAT_VXC(Mb,Mb));MAT_VXC=0.0d0             
 do ikir=1,Nk_irr 
  ik=numMK(ikir)
  MAT_VXC(:,:)=0.0d0 
  call calc_MAT_VXC(Nk_irr,Mb,NTG,NGI(1),KGI(1,1,1),vxcr(1,1,1),CIR(1,1+Ns(ik),ikir),ikir,&
  nrx2,nry2,nrz2,nfft1,nfft2,Nl123,wfunc(1),fftwk(1),fs,MAT_VXC(1,1))
  VXCirr(:,:,ikir)=MAT_VXC(:,:)
  write(6,*)'ikir=',ikir 
 enddo!ikir 
 deallocate(MAT_VXC,vxcr) 
 !
 allocate(VXC(Mb,Mb,NTK));VXC(:,:,:)=0.0d0 
 do ik=1,NTK 
  !
  ikir=numirr(ik) 
  !
  if(trs(ik)==1)then 
   VXC(:,:,ik)=VXCirr(:,:,ikir) 
  elseif(trs(ik)==-1)then 
   do ib=1,Nb(ik)
    do jb=1,Nb(ik) 
     VXC(ib,jb,ik)=VXCirr(jb,ib,ikir) 
    enddo!jb 
   enddo!ib 
  endif 
 enddo!ik 
 write(6,*)'#finish make VXC'
 !
 allocate(pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NTK));pf=0.0d0     
 do ik=1,NTK 
  do ia3=-Na3,Na3 
   do ia2=-Na2,Na2 
    do ia1=-Na1,Na1 
     phase=tpi*(SK0(1,ik)*dble(ia1)+SK0(2,ik)*dble(ia2)+SK0(3,ik)*dble(ia3)) 
     pf(ia1,ia2,ia3,ik)=exp(-ci*phase) 
    enddo  
   enddo  
  enddo  
 enddo  
 write(6,*)'#finish make pf'
 !
 allocate(MAT_VXC_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3));MAT_VXC_R(:,:,:,:,:)=0.0d0 
 do ia3=-Na3,Na3
  do ia2=-Na2,Na2
   do ia1=-Na1,Na1
    do iw=1,NWF
     do jw=1,NWF 
     SUM_CMPX=0.0D0 
     if(.true.)then!.true.=off-diag, .false.=diag
      do ik=1,NTK 
       do ib=1,Nb(ik) 
        do jb=1,Nb(ik) 
         SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*VXC(ib,jb,ik)*UNT(jb,jw,ik)*pf(ia1,ia2,ia3,ik) 
        enddo 
       enddo 
      enddo 
     else 
      do ik=1,NTK 
       do ib=1,Nb(ik) 
        SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*VXC(ib,ib,ik)*UNT(ib,jw,ik)*pf(ia1,ia2,ia3,ik) 
       enddo 
      enddo 
     endif 
     MAT_VXC_R(iw,jw,ia1,ia2,ia3)=SUM_CMPX/DBLE(NTK)
     enddo 
    enddo 
   enddo 
  enddo 
 enddo 
 deallocate(VXC,pf) 
 !
 write(6,*) 
 write(6,*)'================='
 write(6,*)' MAT_VXC_R in eV '
 write(6,*)'================='
 write(6,*) 
 do ia1=-Na1,Na1 
  do ia2=-Na2,Na2 
   do ia3=-Na3,Na3 
    write(6,*) ia1,ia2,ia3           
    do iw=1,NWF
     write(6,'(300F15.8)')(dble(MAT_VXC_R(iw,jw,ia1,ia2,ia3)*au),jw=1,NWF)
    enddo!iw  
    write(6,*)  
   enddo!ia3       
  enddo!ia2 
 enddo!ia1 
 write(6,*)'finish MAT_VXC_R' 
 !
 !write(5002) MAT_VXC_R 
 !
endif!myrank.eq.0
!
!##############
!  OUTPUT VXC 
!##############
!
if(myrank.eq.0)then 
 ierr=CHDIR("./dir-gw") 
 call system('pwd') 
 !
 !OPEN(152,W,FILE='energy_vs_vxc') 
 !
 OPEN(152,FILE='./dat.energy_vs_vxc') 
 rewind(152) 
 do ikir=1,Nk_irr 
  ik=numMK(ikir)
  do jb=1,Nb(ik)!Mb 
   en=(E_EIGI(jb+Ns(ik),ikir)-FermiEnergy)*au 
   write(152,'(3f20.10)') en,VXCirr(jb,jb,ikir)*au 
  enddo!jb 
 enddo!ikir 
 close(152)
 !
 deallocate(VXCirr) 
 !
 !OPEN(153,W,FILE='vxc_mat_r') 
 !
 OPEN(153,FILE='./dat.vxc_mat_r') 
 rewind(153)
 write(153,'(a)')'#vxc_mat_r'
 write(153,'(a)')'#1:R1, 2:R2, 3:R3 (lattice vector)'
 write(153,'(a)')'#1:i, 2:j, 3:Re(vxc_ij) [eV], 4:Im(vxc_ij) [eV]' 
 do ia1=-Na1,Na1 
  do ia2=-Na2,Na2 
   do ia3=-Na3,Na3 
    write(153,*) ia1,ia2,ia3           
    do iw=1,NWF
     do jw=1,NWF 
      write(153,'(i5,i5,2f20.10)') iw,jw,MAT_VXC_R(iw,jw,ia1,ia2,ia3)*au 
     enddo!jw  
    enddo!iw  
    write(153,*)  
   enddo!ia3       
  enddo!ia2 
 enddo!ia1  
 close(153) 
 ierr=CHDIR("..") 
 call system('pwd') 
endif!myrank.eq.0
!
!######################
!  GW-DOS CALCULATION
!######################
!
if(myrank.eq.0)then 
  write(6,'(a)')'## gw-dos calc start ##'
  allocate(ksdos(nsgm)); ksdos=0.0d0 
  allocate(gwdos(nsgm)); gwdos=0.0d0  
  allocate(gw_sigma_dos(nsgm)); gw_sigma_dos=0.0d0  
  ! 
  call calc_ksdos(NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3,idlt,dmna,dmnr,FermiEnergy,a1(1),a2(1),a3(1),&
  b1(1),b2(1),b3(1),sgmw(1),SK0(1,1),H_MAT_R(1,1,-Na1,-Na2,-Na3),ksdos(1))
  !
  call calc_gwdos(NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3,idlt,dmna,dmnr,FermiEnergy,a1(1),a2(1),a3(1),&
  b1(1),b2(1),b3(1),sgmw(1),SK0(1,1),H_MAT_R(1,1,-Na1,-Na2,-Na3),MAT_VXC_R(1,1,-Na1,-Na2,-Na3),&
  MAT_SX_R(1,1,-Na1,-Na2,-Na3),MAT_SC_R(1,1,-Na1,-Na2,-Na3,1),shift_value,gwdos(1),gw_sigma_dos(1))
  !
  write(6,'(a)')'finish gw-dos calc' 
endif!myrank.eq.0 
!
!##############
!  OUTPUT DOS 
!##############
!
if(myrank.eq.0)then 
 ierr=CHDIR("./dir-gw") 
 call system('pwd') 
 !
 !OPEN(159,W,FILE='dat.gwdos') 
 !
 OPEN(159,FILE='./dat.gwdos') 
 rewind(159) 
 do ie=1,nsgm 
  write(159,'(2f20.10)') sgmw(ie)*au,gwdos(ie) 
 enddo 
 close(159) 
 !
 !OPEN(160,W,FILE='dat.ksdos') 
 !
 OPEN(160,FILE='./dat.ksdos') 
 rewind(160)
 do ie=1,nsgm
  write(160,'(2f20.10)') sgmw(ie)*au,ksdos(ie)
 enddo 
 close(160) 
 !
 !OPEN(170,W,FILE='dat.gw_sigma_dos') 
 !
 OPEN(170,FILE='./dat.gw_sigma_dos') 
 rewind(170)
 do ie=1,nsgm
  write(170,'(3f20.10)') sgmw(ie)*au,gw_sigma_dos(ie)
 enddo 
 close(170) 
 !
 ierr=CHDIR("..") 
 call system('pwd') 
endif!myrank.eq.0 
!
!######################
!  GW-AKW CALCULATION
!######################
!
if(myrank.eq.0)then
  write(6,'(a)')'## gw-akw calc start ##'
  NSK_BAND_DISP=Ndiv*(N_sym_points-1)+1
  allocate(SK_BAND_DISP(3,NSK_BAND_DISP)); SK_BAND_DISP(:,:)=0.0d0 
  call makekpts(Ndiv,N_sym_points,NSK_BAND_DISP,SK_sym_pts(1,1),SK_BAND_DISP(1,1))
  !
  !write(5001) H_MAT_R 
  !H_MAT_R=H_MAT_R-MAT_VXC_R-MAT_SX_R  
  !
  allocate(kdata(NSK_BAND_DISP)); kdata=0.0d0 
  allocate(EKS(NWF,NSK_BAND_DISP)); EKS=0.0d0 
  call calc_band_disp(Ndiv,N_sym_points,NTK,NSK_BAND_DISP,Na1,Na2,Na3,NWF,SK_BAND_DISP(1,1),&
  H_MAT_R(1,1,-Na1,-Na2,-Na3),nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),b1(1),b2(1),b3(1),kdata,EKS(1,1))  
  !
  allocate(gwakw(NSK_BAND_DISP,nsgm)); gwakw=0.0d0
  allocate(gw_sigma_kw(NSK_BAND_DISP,nsgm)); gw_sigma_kw=0.0d0
  call calc_gwakw(NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3,NSK_BAND_DISP,idlt,shift_value,&
  SK_BAND_DISP(1,1),a1(1),a2(1),a3(1),sgmw(1),H_MAT_R(1,1,-Na1,-Na2,-Na3),MAT_VXC_R(1,1,-Na1,-Na2,-Na3),&
  MAT_SX_R(1,1,-Na1,-Na2,-Na3),MAT_SC_R(1,1,-Na1,-Na2,-Na3,1),gwakw(1,1),gw_sigma_kw(1,1))            
  !
  write(6,'(a)')'finish gw-akw calc' 
endif!myrank.eq.0
!
!##############
!  OUTPUT AKW 
!##############
!
if(myrank.eq.0)then 
 ierr=CHDIR("./dir-gw") 
 call system('pwd') 
 !
 !OPEN(114,W,FILE='dat.iband') 
 !
 OPEN(114,FILE='./dat.iband') 
 write(114,'(a)')'#Wannier interpolaed band'
 write(114,'(a)')'#1:k, 2:Energy [eV]' 
 REVERSE=.TRUE.        
 do ib=1,NWF 
  if(REVERSE)then 
   do ik=1,NSK_BAND_DISP                     
    write(114,'(2f20.10)') kdata(ik),EKS(ib,ik)*au
   enddo!ik        
   REVERSE=.FALSE.        
  else         
   do ik=NSK_BAND_DISP,1,-1          
    write(114,'(2f20.10)') kdata(ik),EKS(ib,ik)*au
   enddo!ik        
   REVERSE=.TRUE.        
  endif!REVERSE                   
 enddo!ib 
 close(114) 
 ! 
 !OPEN(161,W,FILE='dat.gwakw') 
 !
 OPEN(161,FILE='./dat.gwakw') 
 rewind(161) 
 do ie=1,nsgm 
  do ik=1,NSK_BAND_DISP 
   if(gwakw(ik,ie)>=500.0d0) gwakw(ik,ie)=500.0d0 
   write(161,'(3f20.10)') kdata(ik),sgmw(ie)*au,gwakw(ik,ie) 
  enddo 
  write(161,*) 
 enddo 
 close(161) 
 ! 
 !OPEN(171,W,FILE='dat.gw_sigma_kw') 
 !
 OPEN(171,FILE='./dat.gw_sigma_kw') 
 rewind(171) 
 do ie=1,nsgm 
  do ik=1,NSK_BAND_DISP 
   write(171,'(3f20.10)') kdata(ik),sgmw(ie)*au,gw_sigma_kw(ik,ie) 
  enddo 
  write(171,*) 
 enddo 
 close(171) 
 ! 
 ierr=CHDIR("..") 
 call system('pwd') 
endif!myrank.eq.0 
!
!##########
!  FINISH 
!##########
!
call MPI_BARRIER(comm,ierr)
end_time=MPI_Wtime()
diff_time=end_time-start_time 
if(myrank.eq.0) then 
 call system('pwd') 
 write(6,*)'#TOTAL TIME=',diff_time 
endif 
!
call MPI_FINALIZE(ierr)
STOP 
END              

module m_rd_transdef 
  implicit none
  private 
  public::rd_transdef 
  !trans.def(400) 
  integer,public::Ndim_TR 
  complex(8),public,allocatable::TR(:,:) 
  contains
  !--
  subroutine rd_transdef 
    integer,allocatable::isite(:)
    integer,allocatable::ispin(:)
    integer,allocatable::jsite(:)
    integer,allocatable::jspin(:)
    complex(8),allocatable::TR1dim(:) 
    character(len=80)::dum_ch
    integer::NTransfer 
    integer::Nlat_times_Norb 
    integer::i,n,m
    real(8),parameter::au=27.21151d0
    !
    !OPEN(400,R,FILE='./dir-model/trans.def') 
    !
    OPEN(400,FILE='./dir-model/trans.def') 
    rewind(400) 
    read(400,*) dum_ch
    read(400,*) dum_ch,NTransfer 
    read(400,*) dum_ch
    read(400,*) dum_ch
    read(400,*) dum_ch
    allocate(isite(NTransfer));isite=0
    allocate(ispin(NTransfer));ispin=0
    allocate(jsite(NTransfer));jsite=0
    allocate(jspin(NTransfer));ispin=0
    allocate(TR1dim(NTransfer));TR1dim=0.0d0
    do i=1,NTransfer
     read(400,*) isite(i),ispin(i),jsite(i),jspin(i),TR1dim(i) 
    enddo 
    close(400) 
    !
    Nlat_times_Norb=maxval(isite)+1
    !
    if(Nlat_times_Norb/=(maxval(jsite)+1))then
     write(6,*) 'error; stop'
     stop
    endif 
    !
    Ndim_TR=Nlat_times_Norb*2 
    !
    write(6,'(i10)') NTransfer  
    write(6,'(i10)') Nlat_times_Norb 
    write(6,'(i10)') Ndim_TR 
    !
    allocate(TR(Ndim_TR,Ndim_TR));TR=0.0d0 
    do i=1,NTransfer
     n=isite(i)+ispin(i)*Nlat_times_Norb+1
     m=jsite(i)+jspin(i)*Nlat_times_Norb+1
     TR(n,m)=TR1dim(i) 
    enddo  
    TR=-TR/au !au<-eV
    ! 
    deallocate(isite,ispin,jsite,jspin,TR1dim) 
  end subroutine
  !--
end module 

subroutine calc_gwakw(NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3,NSK_BAND_DISP,idlt,shift_ef,SK_BAND_DISP,a1,a2,a3,&
  sgmw,KS_R,XC_R,SX_R,SC_R,AKW,gw_sigma_kw)
  !
  implicit none 
  integer::NWF,NTK,nsgm,Na1,Na2,Na3,nkb1,nkb2,nkb3,NSK_BAND_DISP
  real(8)::idlt,shift_ef 
  real(8)::SK_BAND_DISP(3,NSK_BAND_DISP)
  real(8)::a1(3),a2(3),a3(3)
  real(8)::sgmw(nsgm)  
  complex(8)::KS_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
  complex(8)::XC_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
  complex(8)::SX_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3)   
  complex(4)::SC_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm)   
  !
  real(8),allocatable::WEIGHT_R(:,:,:)!WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)
  complex(8),allocatable::pf(:,:,:,:)!pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NSK_BAND_DISP)   
  complex(8),allocatable::EMK(:,:,:)!EMK(NWF,NSK_BAND_DISP,nsgm)           
  complex(4),allocatable::GW_R(:,:,:,:,:,:)!GW_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm)   
  !
  integer::ik,ib,jb,ia1,ia2,ia3,ie,ia1min,ia2min,ia3min 
  real(8)::PHASE           
  real(8)::SUM_REAL 
  complex(8)::w,d,en 
  !
  real(8),parameter::au=27.21151d0
  real(8),parameter::tpi=2.0d0*dacos(-1.0d0)
  complex(8),parameter::ci=(0.0D0,1.0D0) 
  !
  real(8),intent(out)::AKW(NSK_BAND_DISP,nsgm)           
  real(8),intent(out)::gw_sigma_kw(NSK_BAND_DISP,nsgm)           
  ! 
  !1. GW_R 
  !
  allocate(GW_R(NWF,NWF,-Na1:Na1,-Na2:Na2,-Na3:Na3,nsgm));GW_R=0.0d0   
  do ia1=-Na1,Na1 
   do ia2=-Na2,Na2 
    do ia3=-Na3,Na3 
     do ib=1,NWF          
      do jb=1,NWF          
       do ie=1,nsgm
        GW_R(ib,jb,ia1,ia2,ia3,ie)&
       =KS_R(ib,jb,ia1,ia2,ia3)&
       -XC_R(ib,jb,ia1,ia2,ia3)&
       -SX_R(ib,jb,ia1,ia2,ia3)&
       +SC_R(ib,jb,ia1,ia2,ia3,ie) 
       enddo 
      enddo
     enddo
    enddo
   enddo
  enddo
  write(6,*)'# finish make H(R)'
  !
  !2. WEIGHT_R
  !
  allocate(WEIGHT_R(-Na1:Na1,-Na2:Na2,-Na3:Na3)); WEIGHT_R=1.0d0
  SUM_REAL=0.0d0 
  do ia1=-Na1,Na1
   do ia2=-Na2,Na2
    do ia3=-Na3,Na3
     if(abs(ia1)==Na1.and.mod(nkb1,2)==0.and.Na1/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     if(abs(ia2)==Na2.and.mod(nkb2,2)==0.and.Na2/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     if(abs(ia3)==Na3.and.mod(nkb3,2)==0.and.Na3/=0) WEIGHT_R(ia1,ia2,ia3)=WEIGHT_R(ia1,ia2,ia3)*0.5d0 
     SUM_REAL=SUM_REAL+WEIGHT_R(ia1,ia2,ia3)
    enddo
   enddo
  enddo 
  write(6,'(a20,f15.8,i8)')'SUM_WEIGHT,NTK',SUM_REAL,NTK  
  if(abs(SUM_REAL-dble(NTK))>1.0d-6)then 
   stop 'SUM_WEIGHT/=NTK'
  endif 
  !
  !3. PHASE FACTOR 
  !
  allocate(pf(-Na1:Na1,-Na2:Na2,-Na3:Na3,NSK_BAND_DISP)); pf=0.0d0 
  do ik=1,NSK_BAND_DISP          
   do ia3=-Na3,Na3 
    do ia2=-Na2,Na2 
     do ia1=-Na1,Na1 
      !
      !NEAREST R SEARCH BY Y.Yoshimoto 
      !
      call search_Rmin(ia1,ia2,ia3,nkb1,nkb2,nkb3,a1(1),a2(1),a3(1),ia1min,ia2min,ia3min)
      PHASE=tpi*(SK_BAND_DISP(1,ik)*DBLE(ia1min)+SK_BAND_DISP(2,ik)*DBLE(ia2min)+SK_BAND_DISP(3,ik)*DBLE(ia3min))           
      pf(ia1,ia2,ia3,ik)=EXP(ci*PHASE)*WEIGHT_R(ia1,ia2,ia3)          
     enddo 
    enddo 
   enddo 
  enddo 
  write(6,*)'# finish make pf'
  !
  !4. HGW IN WANNIER BASIS. AND DIAGONALIZE
  !
  allocate(EMK(NWF,NSK_BAND_DISP,nsgm)); EMK=0.0d0 
  call make_emk(NSK_BAND_DISP,NWF,nsgm,Na1,Na2,Na3,GW_R(1,1,-Na1,-Na2,-Na3,1),pf(-Na1,-Na2,-Na3,1),EMK(1,1,1))  
  !
  !5. CALC SPECTRAL FUNCTION 
  !
  AKW=0.0d0
  do ik=1,NSK_BAND_DISP 
   do jb=1,NWF 
    do ie=1,nsgm 
     w=cmplx(sgmw(ie)+shift_ef,-idlt) 
     en=EMK(jb,ik,ie)
     d=1.0d0/(w-en) 
     AKW(ik,ie)=AKW(ik,ie)+abs(imag(d)) 
    enddo 
   enddo 
  enddo 
  !
  !6. CALC SIGMA_GW SPECTRAL FUNCTION 
  !
  gw_sigma_kw=0.0d0
  do ie=1,nsgm 
   do ik=1,NSK_BAND_DISP 
    do jb=1,NWF 
     gw_sigma_kw(ik,ie)=gw_sigma_kw(ik,ie)+abs(imag(EMK(jb,ik,ie))) 
    enddo!jb 
   enddo!ik 
  enddo!ie  
  !
  deallocate(WEIGHT_R,pf,EMK,GW_R) 
  !
return
end

      PROGRAM DIELECTRIC 
      use mpi
      use fft_3d 
      use m_tetrahedron
      use m_rdinput       
      include "config.h"
!mpi global 
      comm_glb=MPI_COMM_WORLD
      call MPI_INIT(ierr)
      call MPI_COMM_RANK(comm_glb,myrank_glb,ierr)
      call MPI_COMM_SIZE(comm_glb,nproc_glb,ierr)
      write(6,*)'myrank_glb=',myrank_glb,'nproc_glb=',nproc_glb
!read input from master 
      if(myrank_glb.eq.0)then 
       call read_input(nproc_glb)!20170926  
      endif 
      !--
      call MPI_Bcast(N_CALC_BAND,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(Ecut_for_eps,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr)
      call MPI_Bcast(shift_ef,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr)
      call MPI_Bcast(Max_excitation_energy,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(delta_ex,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr)
      call MPI_Bcast(Green_func_delt,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(delt,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr) 
      call MPI_Bcast(ttrhdrn_dmna,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(dmna,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr) 
      call MPI_Bcast(ttrhdrn_dmnr,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(dmnr,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr) 
      call MPI_Bcast(MPI_io_rank,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(io_rank,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(MPI_num_proc_per_qcomm,1,MPI_INTEGER,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(num_of_mpi_per_comm,1,MPI_INTEGER,0,comm_glb,ierr)
      call MPI_Bcast(MPI_num_qcomm,1,MPI_INTEGER,0,comm_glb,ierr)
      call MPI_Bcast(num_of_comm,1,MPI_INTEGER,0,comm_glb,ierr)
      call MPI_Bcast(Num_freq_grid,1,MPI_INTEGER,0,comm_glb,ierr)
      call MPI_Bcast(nen,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(Lower_bound_energy_window,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(E_LOWER,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr) 
      call MPI_Bcast(Upper_bound_energy_window,1,MPI_DOUBLE_PRECISION,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(E_UPPER,1,MPI_DOUBLE_PRECISION,0,comm_glb,ierr) 
      call MPI_Bcast(flg_cRPA,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(flg_cRPA_band,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(flg_cRPA_ewin,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(flg_calc_type,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(file_num_log_start,1,MPI_INTEGER,0,comm_glb,ierr)
      call MPI_Bcast(file_num_chi_start,1,MPI_INTEGER,0,comm_glb,ierr)
      call MPI_Bcast(file_num_eps_start,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(file_num_chi_base_start,1,MPI_INTEGER,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(file_num_eps_base_start,1,MPI_INTEGER,0,
     +               comm_glb,ierr) 
      call MPI_Bcast(n_calc_q,1,MPI_INTEGER,0,comm_glb,ierr) 
      if(myrank_glb /= 0) allocate(calc_num_k(n_calc_q))
      call MPI_Bcast(calc_num_k,n_calc_q,MPI_INTEGER,0,comm_glb,ierr)
!--
!      call MPI_FINALIZE(ierr)
!      stop
!--
      shift_ef=shift_ef/au 
      delta_ex=delta_ex/au 
      delt=delt/au 
      id_sub=myrank_glb/num_of_mpi_per_comm 
!mpi split 
      call MPI_BARRIER(comm_glb,ierr)
      call MPI_COMM_SPLIT(comm_glb,id_sub,myrank_glb,comm,ierr)
      call MPI_COMM_RANK(comm,myrank,ierr)
      call MPI_COMM_SIZE(comm,nproc,ierr)
      !--
      call MPI_BARRIER(comm_glb,ierr)
      start_time=MPI_Wtime() 
      if(myrank_glb.eq.MPI_io_rank)then 
       WRITE(6,*) 
       WRITE(6,*)'============='
       WRITE(6,*)' setup start '
       WRITE(6,*)'============='
       WRITE(6,*) 
      endif 
!--
!OPEN(117,R,FILE='dat.bandcalc') 
      OPEN(117,FILE='./dir-wfn/dat.bandcalc') 
      rewind(117) 
      read(117,*) Ecut_for_psi 
      read(117,*) FermiEnergy  
      read(117,*) Etot
      if (myrank_glb.eq.0) then 
       write(6,'(a20,f15.10)')'Ecut_for_psi=',Ecut_for_psi 
       write(6,'(a20,f15.10)')'FermiEnergy (eV)=',FermiEnergy*au  
       write(6,'(a20,f15.10)')'Etot (au)=',Etot
      endif 
!--
!artificially fermi level shifted <--- Option, basically shift=0.00 
      FermiEnergy=FermiEnergy+shift_ef 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*) 
       write(6,*)'========================='
       write(6,*)'FermiEnergy=',FermiEnergy
       write(6,*)'========================='
       write(6,*) 
      endif 
!--
!cRPA 
      flg_cRPA_band=0
      flg_cRPA_ewin=0
      if(flg_cRPA==1)then 
       flg_cRPA_band=1!band-cRPA
       !flg_cRPA_ewin=1!window-cRPA 
      endif 
      !--
      if(flg_cRPA_ewin==1)then 
       if(E_LOWER==E_UPPER)then 
        write(6,*)'ERROR: wrong setting energy window; stop' 
        stop
       endif 
       if(E_LOWER==0.0d0)then 
        write(6,*)'WARNING: E_LOWER=0.0eV'
       endif 
       if(E_UPPER==0.0d0)then 
        write(6,*)'WARNING: E_UPPER=0.0eV'
       endif 
       E_LOWER=E_LOWER/au 
       E_UPPER=E_UPPER/au 
!--
!20180110 
!      else 
!       E_LOWER=FermiEnergy-0.5d0/au 
!       E_UPPER=FermiEnergy+0.5d0/au 
!       E_LOWER=FermiEnergy-1.5d0/au 
!       E_UPPER=FermiEnergy+1.5d0/au 
!       E_LOWER=E_LOWER/au!20171220 
!       E_UPPER=E_UPPER/au!20171220 
!--
      endif 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,'(a20,i5)')'flg_cRPA     =',flg_cRPA
       write(6,'(a20,i5)')'flg_cRPA_band=',flg_cRPA_band
       write(6,'(a20,i5)')'flg_cRPA_ewin=',flg_cRPA_ewin 
       write(6,'(a20,f15.10)')'EPS_UPPER (eV)=',E_UPPER*au 
       write(6,'(a20,f15.10)')'EPS_LOWER (eV)=',E_LOWER*au 
      endif 
!--
!OPEN(105,R,FILE='dat.lattice') 
      OPEN(105,FILE='./dir-wfn/dat.lattice') 
      REWIND(105)
      READ(105,*) a1(1),a1(2),a1(3)!a1 vector
      READ(105,*) a2(1),a2(2),a2(3)!a2 vector
      READ(105,*) a3(1),a3(2),a3(3)!a3 vector
      CLOSE(105)
      call OUTER_PRODUCT(a2(1),a3(1),b1(1))
      VOLUME=a1(1)*b1(1)+a1(2)*b1(2)+a1(3)*b1(3)
      b1(:)=b1(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a3(1),a1(1),b2(1))
      b2(:)=b2(:)*tpi/VOLUME 
      call OUTER_PRODUCT(a1(1),a2(1),b3(1))
      b3(:)=b3(:)*tpi/VOLUME 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)
       write(6,*)'=============='
       write(6,*)'LATTICE VECTOR'
       write(6,*)'=============='
       write(6,*)
       write(6,*) a1(1), a1(2), a1(3)
       write(6,*) a2(1), a2(2), a2(3)
       write(6,*) a3(1), a3(2), a3(3)
       write(6,*)
       write(6,*)'VOLUME OF UNIT CELL=',VOLUME  
      endif 
      !--
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*) 
       write(6,*)'======================'
       write(6,*)'CHECK OF (A_VEC*B_VEC)'
       write(6,*)'======================'
       write(6,*) 
       write(6,*)'a1*b1=',b1(1)*a1(1)+b1(2)*a1(2)+b1(3)*a1(3)
       write(6,*)'a2*b2=',b2(1)*a2(1)+b2(2)*a2(2)+b2(3)*a2(3)
       write(6,*)'a3*b3=',b3(1)*a3(1)+b3(2)*a3(2)+b3(3)*a3(3)
      endif 
!--
!OPEN(100,R,FILE='dat.symmetry') 
      OPEN(100,FILE='./dir-wfn/dat.symmetry') 
      rewind(100) 
      read(100,*) nsymq 
      read(100,*) nnp 
      allocate(rg(3,3,nsymq));rg(:,:,:)=0 
      allocate(pg(3,nsymq));pg(:,:)=0
      allocate(rginv(3,3,nsymq));rginv(:,:,:)=0.0d0 
      do iop=1,nsymq
       read(100,*)((rg(i,j,iop),i=1,3),j=1,3) 
       read(100,*)(pg(i,iop),i=1,3)   
      enddo 
      close(100) 
      rginv=rg 
      do iop=1,nsymq
       call invmat(3,rginv(1,1,iop)) 
      enddo 
      if(myrank_glb.eq.0)then!master
       write(6,*) 
       write(6,*)'========'
       write(6,*)'SYMMETRY'
       write(6,*)'========'
       write(6,*) 
       write(6,*)'nsymq=',nsymq 
       write(6,*)'nnp=',nnp 
       do iop=1,nsymq  
        write(6,'(a5,i4)')'sym=',iop
        write(6,'(a10)')'rg and pg' 
        do i=1,3
         write(6,'(3i5,5x,i5)')(rg(i,j,iop),j=1,3),pg(i,iop) 
        enddo
        write(6,*) 
       enddo
       rginv=rg 
       do iop=1,nsymq
        call invmat(3,rginv(1,1,iop)) 
       enddo 
       do iop=1,nsymq  
        write(6,'(a5,i4)')'sym=',iop
        write(6,'(a10)')'rginv' 
        do i=1,3
         write(6,'(3f10.5)')(rginv(i,j,iop),j=1,3) 
        enddo
        write(6,*) 
       enddo
       write(6,*)'finish read dat.symmetry'
      endif 
!--
!check 
!do iop=1,nsymq
!write(6,*) iop
!do i=1,3
!write(6,'(3I5,1x,3F15.10)') (rg(i,j,iop),j=1,3),(rginv(i,j,iop),j=1,3)
!enddo 
!enddo 
!do iop=1,nsymq
!do i=1,3
!do j=1,3
!s=0.0d0 
!do k=1,3
!s=s+rg(i,k,iop)*rginv(k,j,iop)
!enddo 
!write(6,*) i,j,s
!enddo 
!enddo 
!enddo 
!--
!OPEN(101,R,FILE='dat.sample-k') 
      OPEN(101,FILE='./dir-wfn/dat.sample-k') 
      rewind(101) 
      read(101,*) Nk_irr 
      allocate(SKI(3,Nk_irr));SKI(:,:)=0.0D0 
      do ik=1,Nk_irr 
       read(101,*)(SKI(i,ik),i=1,3) 
      enddo 
      close(101) 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'finish fort.101' 
      endif 
      !call est_NTK(Nk_irr,SKI(1,1),NTK,nkb1,nkb2,nkb3)  
!--
!20170415 
      allocate(SKI_list(3,Nk_irr));SKI_list(:,:)=0.0D0 
      do ik=1,Nk_irr
       call search_list(SKI(1,ik),SKI_list(1,ik)) 
      enddo  
!--
!      if(myrank_glb.eq.MPI_io_rank)then 
!       write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
!      endif 
!--
!OPEN(132,R,FILE='dat.nkm')20170406 
      OPEN(132,FILE='./dir-wfn/dat.nkm')!20170406 
      allocate(NGI(Nk_irr));NGI(:)=0
      rewind(132)
      do ik=1,Nk_irr 
       read(132,*) NGI(ik) 
      enddo 
      close(132) 
      NTG=maxval(abs(NGI(:))) 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,'(a10,i10)')'NTG=',NTG  
      endif 
!--
!OPEN(111,R,FILE='dat.eigenvalue') 
      OPEN(111,FILE='./dir-wfn/dat.eigenvalue') 
      rewind(111)
      read(111,*) NTB!20170406  
      allocate(E_EIGI(NTB,Nk_irr));E_EIGI(:,:)=0.0d0
      do ik=1,Nk_irr 
       do ib=1,NTB 
        read(111,*) E_EIGI(ib,ik) 
       enddo!ib 
      enddo!ik          
      close(111) 
      !--
      if(N_CALC_BAND==0) N_CALC_BAND=NTB  
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,'(a15,i10)')'NTB=',NTB  
       write(6,'(a15,i10)')'N_CALC_BAND=',N_CALC_BAND 
      endif 
!--
!      call MPI_FINALIZE(ierr)
!      stop
!--
!OPEN(131,R,FILE='dat.MAT_NLr_rNL')---not active---
      allocate(MAT_NLr_rNL(3,NTB,NTB,Nk_irr));MAT_NLr_rNL=0.0d0   
!rewind(131) 
!close(131) 
!---
!OPEN(104,R,FILE='dat.kg') 
      OPEN(104,FILE='./dir-wfn/dat.kg') 
      rewind(104) 
      allocate(KGI(3,NTG,Nk_irr));KGI=0 
      do ik=1,Nk_irr 
       read(104,*) NG_for_psi 
       if(NG_for_psi/=NGI(ik))THEN 
        write(6,*)'ERROR;STOP;NG_for_psi should be NGI(ik)'   
        write(6,*)'NG_for_pis=',NG_for_psi,'NGI(ik)=',NGI(ik)
        stop 
       endif 
       do ig=1,NG_for_psi 
        read(104,*)(KGI(i,ig,ik),i=1,3) 
       enddo 
      enddo!ik 
      close(104)
      !--
      allocate(LKGI(NTG,Nk_irr));LKGI=0.0d0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
       ktmp(1)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(1)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(1) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(1) 

       ktmp(2)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(2)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(2) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(2) 

       ktmp(3)=(SKI(1,ik)+dble(KGI(1,ig,ik)))*b1(3)
     +        +(SKI(2,ik)+dble(KGI(2,ig,ik)))*b2(3) 
     +        +(SKI(3,ik)+dble(KGI(3,ig,ik)))*b3(3) 
       LKGI(ig,ik)=ktmp(1)**2+ktmp(2)**2+ktmp(3)**2
       enddo!ig 
      enddo!ik 
      !--
      Ecut_for_psi=maxval(LKGI(:,:))+1.0d-8!20170512 
      if(Ecut_for_eps==0.0d0)then!default
       Ecut_for_eps=Ecut_for_psi/10.0d0!20171010  
      endif 
      !--
      if(myrank_glb.eq.MPI_io_rank)then 
       do ik=1,Nk_irr 
        write(6,*) maxval(LKGI(:,ik))
       enddo 
       write(6,*) 
       write(6,*) maxval(LKGI(:,:))
       write(6,*)'reset Ecut_for_psi=',Ecut_for_psi 
       write(6,*)'set Ecut_for_eps=',Ecut_for_eps 
      endif 
      !--
      L1=maxval(abs(KGI(1,:,:)))+1
      L2=maxval(abs(KGI(2,:,:)))+1
      L3=maxval(abs(KGI(3,:,:)))+1
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'maxKGI(1)=',L1 
       write(6,*)'maxKGI(2)=',L2 
       write(6,*)'maxKGI(3)=',L3 
      endif 
      allocate(packing(-L1:L1,-L2:L2,-L3:L3,Nk_irr));packing(:,:,:,:)=0 
      do ik=1,Nk_irr 
       do ig=1,NGI(ik) 
        i1=KGI(1,ig,ik);j1=KGI(2,ig,ik);k1=KGI(3,ig,ik) 
        packing(i1,j1,k1,ik)=ig 
       enddo 
      enddo 
!--
!fft grid
      !20180309 
      !m1=maxval(abs(KGI(1,:,:))) 
      !m2=maxval(abs(KGI(2,:,:))) 
      !m3=maxval(abs(KGI(3,:,:))) 
      !nwx2=algn235(2*m1) 
      !nwy2=algn235(2*m2) 
      !nwz2=algn235(2*m3) 
      !--
      htmp=dsqrt(dot_product(a1,a1))
      h1(:)=a1(:)/htmp 
      htmp=dsqrt(dot_product(a2,a2))
      h2(:)=a2(:)/htmp 
      htmp=dsqrt(dot_product(a3,a3)) 
      h3(:)=a3(:)/htmp 
      d1=abs(dot_product(b1,h1)) 
      d2=abs(dot_product(b2,h2)) 
      d3=abs(dot_product(b3,h3)) 
      qwf=2.0d0*dsqrt(Ecut_for_psi) 
      !--
      !nwx2=algn235(int(qwf/d1)+1,1) 
      !nwy2=algn235(int(qwf/d2)+1,1) 
      !nwz2=algn235(int(qwf/d3)+1,1) 
      !--
      nwx2=algn235(int(qwf/d1)+1)!20180412 by Y.Nomura 
      nwy2=algn235(int(qwf/d2)+1)!20180412 by Y.Nomura 
      nwz2=algn235(int(qwf/d3)+1)!20180412 by Y.Nomura 
      !--
      nfft1=nwx2+1
      nfft2=nwy2+1
      nfft3=nwz2+1
      Nl123=nfft1*nfft2*nfft3 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'nwx2=',nwx2 
       write(6,*)'nwy2=',nwy2 
       write(6,*)'nwz2=',nwz2 
       write(6,*)'nfft1=',nfft1 
       write(6,*)'nfft2=',nfft2 
       write(6,*)'nfft3=',nfft3 
       write(6,*)'NL123=',Nl123  
      endif 
      call fft3_init(nwx2,nwy2,nwz2,nfft1,nfft2,nfft3,fs) 
!--
!20180302  
      call est_NTK(Nk_irr,Nsymq,SKI(1,1),rg(1,1,1),NTK)
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'Estimated NTK=',NTK 
      endif 
!--
!gen(SK0,numirr,numrot,trs,RW) 
      allocate(SK0(3,NTK));SK0(:,:)=0.0d0
      allocate(numirr(NTK));numirr(:)=0
      allocate(numrot(NTK));numrot(:)=0
      allocate(trs(NTK));trs(:)=0
      allocate(RW(3,NTK));RW(:,:)=0
!--
!20161207 
!      do ik=1,Nk_irr 
!       SK0(:,ik)=SKI(:,ik) 
!       numirr(ik)=ik; numrot(ik)=1; trs(ik)=1; RW(1:3,ik)=0
!      enddo 
!      jk=Nk_irr 
!--
      jk=0 
      do ik=1,Nk_irr
      do iop=1,Nsymq
!sym
       ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik)
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik)
       call kcheck(ktmp(1),RWtmp(1))!rewind check 
       do iik=1,jk
        if(abs(SK0(1,iik)-ktmp(1))<1.0d-4.and. 
     +     abs(SK0(2,iik)-ktmp(2))<1.0d-4.and. 
     +     abs(SK0(3,iik)-ktmp(3))<1.0d-4)goto 1000
       enddo!iik
       jk=jk+1
       SK0(:,jk)=ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=1;RW(:,jk)=RWtmp(:)
!time-reversal
1000   ktmp(:)=0.0d0;RWtmp(:)=0  
       ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +        +rg(1,3,iop)*SKI(3,ik)
       ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +        +rg(2,3,iop)*SKI(3,ik) 
       ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +        +rg(3,3,iop)*SKI(3,ik) 
       call kcheck_trs(ktmp(1),RWtmp(1))!rewind check modified 20170316  
       do iik=1,jk
        if(abs(SK0(1,iik)-(-ktmp(1)))<1.0d-4.and. 
     +     abs(SK0(2,iik)-(-ktmp(2)))<1.0d-4.and. 
     +     abs(SK0(3,iik)-(-ktmp(3)))<1.0d-4)goto 2000
       enddo!iik
       jk=jk+1
       SK0(:,jk)=-ktmp(:)
       numirr(jk)=ik;numrot(jk)=iop;trs(jk)=-1;RW(:,jk)=RWtmp(:)
2000  enddo 
      enddo 
      !--
      if(NTK/=jk)then 
       write(6,*)'ERROR;STOP;NTK should be jk'   
       write(6,*)'NTK=',NTK,'jk=',jk;STOP
      endif 
      !--   
      if (myrank_glb.eq.0) then 
       write(6,*) 
       write(6,*)'====='
       write(6,*)' SK0 '
       write(6,*)'====='
       write(6,*) 
       DO ik=1,NTK
        WRITE(6,'(I5,3F15.10)') ik,SK0(:,ik) 
       ENDDO 
      endif 
      !--
      call est_nkbi(NTK,SK0(1,1),nkb1,nkb2,nkb3)  
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,'(a24,4i10)')'nkb1,nkb2,nkb3,NTK=',nkb1,nkb2,nkb3,NTK  
      endif 
!--
!gen(NB0,NG0,KG0,E_EIG)
      allocate(NG0(NTK));NG0(:)=0
      allocate(NB0(NTK));NB0(:)=0
      allocate(KG0(3,NTG,NTK));KG0(:,:,:)=0 
      allocate(KGtmp(3,NTG));KGtmp(:,:)=0 
!--
!20161207 
!      do jk=1,Nk_irr 
!       NG0(jk)=NGI(jk);NB0(jk)=NTB;KG0(:,:,jk)=KGI(:,:,jk) 
!      enddo 
!      do jk=Nk_irr+1,NTK 
!--
      do jk=1,NTK 
       if(trs(jk)==1)then 
        ik=numirr(jk);iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        NB0(jk)=NTB 
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KG0(1,1,jk),NG_for_psi)
        if(NG_for_psi/=NGI(ik))then 
         write(6,*)'ERROR;STOP;NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
       elseif(trs(jk)==-1)then  
        ik=numirr(jk);iop=numrot(jk) 
        ktmp(1)=rg(1,1,iop)*SKI(1,ik)+rg(1,2,iop)*SKI(2,ik)
     +         +rg(1,3,iop)*SKI(3,ik)+dble(RW(1,jk)) 
        ktmp(2)=rg(2,1,iop)*SKI(1,ik)+rg(2,2,iop)*SKI(2,ik)
     +         +rg(2,3,iop)*SKI(3,ik)+dble(RW(2,jk))  
        ktmp(3)=rg(3,1,iop)*SKI(1,ik)+rg(3,2,iop)*SKI(2,ik)
     +         +rg(3,3,iop)*SKI(3,ik)+dble(RW(3,jk))  
        NB0(jk)=NTB 
        KGtmp(:,:)=0 
        call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_psi,
     +       ktmp(1),ktmp(2),ktmp(3),KGtmp(1,1),NG_for_psi)
        if(NG_for_psi/=NGI(ik))then 
         write(6,*)'ERROR;STOP;NG_for_psi should be NGI(ik)'   
         write(6,*)'NG_for_psi=',NG_for_psi,'NGI(ik)=',NGI(ik);STOP
        endif 
        NG0(jk)=NG_for_psi  
        KG0(:,:,jk)=-KGtmp(:,:) 
       endif 
      enddo 
      deallocate(KGtmp) 
      !--
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*) 
       write(6,*)'==========='
       write(6,*)'NB0 and NG0'
       write(6,*)'==========='
       write(6,*) 
       do ik=1,NTK 
        write(6,'(2I20)') NB0(ik),NG0(ik) 
       enddo 
      endif 
!--
!20170418 
!mkdir dir-eps/qxx
      if(myrank_glb.eq.0)then!master 
       !inquire(directory='./dir-eps',exist=dir_e) 
       !if(dir_e)then
       ! write(6,*) 'dir exist'
       !else
       ! call system('rm -rf dir-eps') 
       ! call system('mkdir dir-eps') 
       !endif 
       call system('mkdir -p dir-eps')!20171208
       ierr=CHDIR("./dir-eps") 
       call system('pwd') 
       do ik=1,Nk_irr 
        !write(dirname,"('q',i3.3)")ik 
        !inquire(directory=dirname,exist=dir_e) 
        !if(dir_e)then
        ! write(6,*) 'dir exist'
        !else
        ! write(command,"('mkdir q',i3.3)")ik 
        ! call system(command) 
        !endif 
        write(command,"('mkdir -p q',i3.3)")ik 
        call system(command) 
       enddo  
       ierr=CHDIR("..") 
       call system('pwd') 
      endif!myrank_glb==0 
      flush(6) 
!Nq_irr, calc_qlist
      allocate(calc_qlist(3,Nk_irr));calc_qlist(:,:)=0.0D0 
      if(myrank_glb.eq.0)then!master 
       ierr=CHDIR("./dir-eps") 
       call system('pwd') 
!all-q-calc 
       if(flg_calc_type==0)then!all-q-calc
        iq=0 
        do ik=1,Nk_irr 
         write(dirname,"('q',i3.3)")ik 
         ierr=CHDIR(dirname) 
         inquire(file='dat.log.400',exist=file_e) 
         if(file_e)then
          write(6,*)'dat.log.400 exists in',trim(dirname)  
         else
          iq=iq+1
          calc_qlist(:,iq)=SKI(:,ik) 
         endif!file_e 
         ierr=CHDIR("..") 
        enddo  
        Nq_irr=iq  
       endif!flg_calc_type==0
!gamma-only 
       if(flg_calc_type==1)then!gamma-only 
        iq=0;ix=0  
        do ik=1,Nk_irr 
         if(abs(SKI(1,ik))<1.0d-5.and.abs(SKI(2,ik))<1.0d-5.and.
     +      abs(SKI(3,ik))<1.0d-5)then 
          ix=ik 
         endif 
        enddo 
        write(dirname,"('q',i3.3)")ix  
        ierr=CHDIR(dirname) 
        inquire(file='dat.log.400',exist=file_e) 
        if(file_e)then
         write(6,*)'dat.log.400 exists in',trim(dirname)  
        else
         iq=iq+1
         calc_qlist(:,iq)=SKI(:,ix) 
        endif!file_e 
        ierr=CHDIR("..") 
        Nq_irr=iq  
       endif!flg_calc_type==1
!manual mode 
       if(flg_calc_type==2)then!manual mode 
        iq=0 
        do ix=1,N_calc_q 
         ik=calc_num_k(ix) 
         write(dirname,"('q',i3.3)")ik 
         ierr=CHDIR(dirname) 
         inquire(file='dat.log.400',exist=file_e) 
         if(file_e)then
          write(6,*)'dat.log.400 exists in',trim(dirname)  
         else
          iq=iq+1
          calc_qlist(:,iq)=SKI(:,ik) 
         endif!file_e 
         ierr=CHDIR("..") 
        enddo!ix 
        Nq_irr=iq  
       endif!flg_calc_type==2 
       !--
       ierr=CHDIR("..") 
       call system('pwd') 
      endif!myrank_glb==0 
      flush(6) 
      call MPI_Bcast(Nq_irr,1,MPI_INTEGER,0,comm_glb,ierr) 
      call MPI_Bcast(calc_qlist,3*Nk_irr,MPI_DOUBLE_PRECISION,
     +               0,comm_glb,ierr) 
!--
!      call MPI_FINALIZE(ierr)
!      stop
!--
!sample-q
!--
      pnq=Nq_irr/num_of_comm
      if(mod(Nq_irr,num_of_comm).ne.0)then
       nbufq=pnq+1
      else
       nbufq=pnq
      endif
      allocate(SQI(3,nbufq)) 
      allocate(SQ(3,nbufq)) 
      allocate(LG0(3,NTG,nbufq)) 
      allocate(NGQ(nbufq)) 
      !--
      if(id_sub.lt.mod(Nq_irr,num_of_comm))then
       pnq=pnq+1
       bnq=pnq*id_sub+1 
       enq=bnq+pnq-1
      else
       bnq=(pnq+1)*mod(Nq_irr,num_of_comm) 
     +    +(pnq)*(id_sub-mod(Nq_irr,num_of_comm))+1 
       enq=bnq+pnq-1
      endif
      !--
      do iq=1,Nq_irr
       if((bnq.le.iq).and.(iq.le.enq))then 
        SQI(:,iq-bnq+1)=calc_qlist(:,iq) 
       endif
      enddo 
!--
!OPEN(127,R,FILE='SAMPLE_Qirr')
!      OPEN(127,FILE='./dir-wfn/dat.sample-q')
!      SQI(:,:)=0.0d0 
!      read(127,*) idum 
!      do iq=1,Nq_irr
!       if((bnq.le.iq).and.(iq.le.enq))then 
!        read(127,*)(SQI(i,iq-bnq+1),i=1,3) 
!       else 
!        read(127,*) 
!       endif
!      enddo 
!--
!OPEN(101,R,FILE='dat.sample-k'='dat.sample-q')
!       OPEN(101,FILE='./dir-wfn/dat.sample-k')
!       SQI(:,:)=0.0d0 
!       rewind(101) 
!       read(101,*) idum 
!       do iq=1,Nq_irr
!        if((bnq.le.iq).and.(iq.le.enq))then 
!         read(101,*)(SQI(i,iq-bnq+1),i=1,3) 
!        else 
!         read(101,*) 
!        endif
!       enddo 
!--
!      elseif(flg_calc_type==1)then!gamma only
!       Nq_irr=1
!       pnq=Nq_irr/num_of_comm
!       if(mod(Nq_irr,num_of_comm).ne.0)then
!        nbufq=pnq+1
!       else
!        nbufq=pnq
!       endif
!       allocate(SQI(3,nbufq)) 
!       allocate(SQ(3,nbufq)) 
!       allocate(LG0(3,NTG,nbufq)) 
!       allocate(NGQ(nbufq)) 
!!--
!       if(id_sub.lt.mod(Nq_irr,num_of_comm))then
!        pnq=pnq+1
!        bnq=pnq*id_sub+1 
!        enq=bnq+pnq-1
!       else
!        bnq=(pnq+1)*mod(Nq_irr,num_of_comm) 
!     +     +(pnq)*(id_sub-mod(Nq_irr,num_of_comm))+1 
!        enq=bnq+pnq-1
!       endif
!!      SQI(:,:)=0.0d0 
!       do iq=1,Nq_irr
!       if((bnq.le.iq).and.(iq.le.enq))then 
!        SQI(:,iq-bnq+1)=0.0d0!gamma only 
!       endif
!      endif 
!--
!20161207 
!shift[-1/2:1/2]  
      do iq=1,pnq 
       call search_list(SQI(1,iq),SQ(1,iq)) 
      enddo  
      if(myrank.eq.0)then 
       write(6,*) 
       write(6,*)'======================'
       write(6,*)'calclated SQ (SQI->SQ)'
       write(6,*)'======================'
       write(6,*) 
       write(6,*)'Nq_irr=',Nq_irr 
       write(6,*) 
       do iq=1,pnq 
        write(6,'(a10,3f10.5,2x,3f10.5)')'SQI->SQ',SQI(:,iq),SQ(:,iq) 
       enddo 
      endif  
      flush(6) 
!--
!      call MPI_BARRIER(comm_glb,ierr)
!      call MPI_FINALIZE(ierr)
!      stop
!--
!      if(myrank.eq.0)then!master  
!       ierr=CHDIR("./dir-eps") 
!       call system('pwd') 
!       do iq=1,pnq
!        write(file_num_log,'(a8,3(1x,f10.5),1x,a,1x,i3)') 
!     +  '#SQ=',SQ(1,iq),SQ(2,iq),SQ(3,iq),'myrank_glb=',myrank_glb 
!       enddo 
!       ierr=CHDIR("..") 
!       call system('pwd') 
!      endif 
!      call MPI_FINALIZE(ierr)
!      stop
!--
      if(myrank.eq.0)then 
       write(6,*) 
       write(6,*)'========'
       write(6,*)'make LG0'
       write(6,*)'========'
       write(6,*) 
      endif 
      do iq=1,pnq 
       q1=SQ(1,iq)
       q2=SQ(2,iq)
       q3=SQ(3,iq)
       if(myrank.eq.0)then 
        write(6,'(i5,3f15.8)') iq,q1,q2,q3 
       endif 
       call make_KG0(NTG,b1(1),b2(1),b3(1),Ecut_for_eps,
     +               q1,q2,q3,LG0(1,1,iq),NG_for_eps) 
       if(myrank.eq.0)then 
        write(6,'(a,i10)')'NG_for_eps',NG_for_eps 
       endif 
       NGQ(iq)=NG_for_eps  
      enddo  
      !--
      call MPI_BARRIER(comm_glb,ierr)
      !--
      allocate(index_kpt(nkb1,nkb2,nkb3));index_kpt(:,:,:)=0     
      call make_index_kpt(NTK,nkb1,nkb2,nkb3,SK0(1,1),index_kpt(1,1,1)) 
!--
!      if(myrank_glb.eq.MPI_io_rank)then 
!       do iz=1,nkb3 
!        do iy=1,nkb2
!         do ix=1,nkb1
!          ik=index_kpt(ix,iy,iz)
!          write(6,'(i8,3f15.10)')ik,SK0(:,ik)
!         enddo
!        enddo
!       enddo
!      endif 
!--
      allocate(WindowInside(NTB));WindowInside(:)=0
      allocate(Tindx(NTB));Tindx(:)=0 
      allocate(E_AVE(NTB));E_AVE(:)=0.0d0 
      allocate(band_max(NTB));band_max(:)=0.0d0
      allocate(band_min(NTB));band_min(:)=0.0d0
      allocate(prob(NTB,NTK));prob(:,:)=0.0d0 
      !--
      if(flg_cRPA==0)then 
       call judge_FermiInside(Nk_irr,NTB,E_EIGI(1,1),FermiEnergy,
     + WindowInside(1),Tindx(1),E_AVE(1),band_max(1),band_min(1))
      endif 
      !--
      if(flg_cRPA==1.and.flg_cRPA_band==1)then 
       call judge_FermiInside(Nk_irr,NTB,E_EIGI(1,1),FermiEnergy,
     + WindowInside(1),Tindx(1),E_AVE(1),band_max(1),band_min(1))
      endif 
      !--
      if(flg_cRPA==1.and.flg_cRPA_ewin==1)then 
       call judge_WindowInside(Nk_irr,NTB,E_EIGI(1,1),E_LOWER,E_UPPER,
     + WindowInside(1),Tindx(1),E_AVE(1),band_max(1),band_min(1)) 
      endif 
      !--
      if (myrank_glb.eq.0) then 
       write(6,*) 
       write(6,*)'Winside'
       write(6,*) 
       do ib=1,NTB
        write(6,*) ib,WindowInside(ib)
       enddo 
       !--
       write(6,*) 
       write(6,*)'Tindx'
       write(6,*) 
       do ib=1,NTB
        write(6,*) ib,Tindx(ib)
       enddo 
       !--
       write(6,*) 
       write(6,*)'bandMax and bandMin in eV'
       write(6,*) 
       do ib=1,NTB
        write(6,'(i5,2f15.10)') ib,band_max(ib)*au,band_min(ib)*au 
       enddo 
       !--
       write(6,*) 
       write(6,*)'E_AVE in eV'
       write(6,*) 
       do ib=1,NTB
        write(6,*) ib,E_AVE(ib)*au 
       enddo 
      endif 
!--
!band-cRPA
      if(flg_cRPA_band==1)then 
!--
!OPEN(149,R,FILE='dat.ns-nb')
       OPEN(149,FILE='./dir-wan/dat.ns-nb') 
       rewind(149) 
       allocate(Ns(NTK));Ns=0
       allocate(Nb(NTK));Nb=0
       do ik=1,NTK 
        read(149,*) Ns(ik),Nb(ik) 
       enddo  
       Mb=maxval(Nb) 
       if(myrank_glb.eq.MPI_io_rank)then 
        write(6,*)'Mb=',Mb 
       endif 
!--
!OPEN(150,R,FILE='dat.umat')
       OPEN(150,FILE='./dir-wan/dat.umat') 
       rewind(150) 
       read(150,*) NWF 
       allocate(UNT(Mb,NWF,NTK));UNT(:,:,:)=0.0d0 
       do ik=1,NTK
        do jb=1,Nb(ik)
         read(150,*)(UNT(jb,jw,ik),jw=1,NWF) 
        enddo 
       enddo 
!--
!probability
       prob(:,:)=0.0d0 
       do ik=1,NTK 
        do ib=1,Nb(ik) 
         SUM_CMPX=0.0D0            
         do iw=1,NWF 
          SUM_CMPX=SUM_CMPX+CONJG(UNT(ib,iw,ik))*UNT(ib,iw,ik) 
         enddo!iw  
         prob(Ns(ik)+ib,ik)=SUM_CMPX 
        enddo!ib   
       enddo!ik        
       !-- 
       if(myrank_glb.eq.0)then!master  
        WRITE(6,*) 
        WRITE(6,*)'========================'
        WRITE(6,*)'PROBABILITY MATRIX:<a|b>'
        WRITE(6,*)'========================'
        WRITE(6,*) 
        do ik=1,NTK 
         SUM_CMPX=0.0d0 
         do ib=1,NTB 
          if(abs(prob(ib,ik))>1.0d-4)then 
           write(6,'(i5,2f10.5)') ib,prob(ib,ik) 
          endif 
          SUM_CMPX=SUM_CMPX+prob(ib,ik) 
         enddo!ib 
         write(6,'(a10,2f15.10)')'total=',SUM_CMPX 
         write(6,*)       
        enddo!ik   
       endif  
      else 
       if(myrank_glb.eq.0)then!master  
        WRITE(6,*) 
        WRITE(6,*)'======================================='
        WRITE(6,*)'PROBABILITY MATRIX:<a|b> is set to zero'
        WRITE(6,*)'======================================='
        WRITE(6,*) 
       endif  
      endif!band-cRPA 
!--
!SETTING MPI-process PARAMETERS
      call MPI_BARRIER(comm_glb,ierr)
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*) 
       write(6,*)'MPI started'
       write(6,*) 
      endif 
      id=0
      ip=0
      iu=0
      do i_band=1,N_CALC_BAND
       fs1=WindowInside(i_band)
       if(fs1==0) id=id+1
       if(fs1==1) ip=ip+1
       if(fs1==2) iu=iu+1
      enddo 
      !--
      N_docc=id
      N_pocc=ip
      N_uocc=iu 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'N_docc=',N_docc 
       write(6,*)'N_pocc=',N_pocc 
       write(6,*)'N_uocc=',N_uocc 
      endif 
      !--
      N_occ=N_docc+N_pocc
      N_vir=N_uocc+N_pocc  
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'N_occ=',N_occ 
       write(6,*)'N_vir=',N_vir  
      endif 
      !--
      pnv=N_vir/nproc
      if(mod(N_vir,nproc).ne.0)then
       nbufv=pnv+1
      else
       nbufv=pnv
      endif
      if(myrank.lt.mod(N_vir,nproc))then
       pnv=pnv+1
       bnv=pnv*myrank+1 
       env=bnv+pnv-1
      else
       bnv=(pnv+1)*mod(N_vir,nproc) 
     +    +pnv*(myrank-mod(N_vir,nproc))+1 
       env=bnv+pnv-1
      endif
!--
!      allocate(datav(nbufv),newdatav(nbufv))
!      do i=1,pnv
!         datav(i)=bnv+i-1
!      end do
!--
      pno=N_occ/nproc
      if(mod(N_occ,nproc).ne.0)then
       nbufo=pno+1
      else
       nbufo=pno
      endif
      if(myrank.lt.mod(N_occ,nproc)) then
       pno=pno+1
       bno=pno*myrank+1 
       eno=bno+pno-1
      else
       bno=(pno+1)*mod(N_occ,nproc) 
     +    +pno*(myrank-mod(N_occ,nproc))+1 
       eno=bno+pno-1
      endif
!--
!      allocate(datao(nbufo),newdatao(nbufo))
!      do i=1,pno
!         datao(i)=bno+i-1
!      end do
!--
!      call MPI_BARRIER(comm,ierr)
!      if (myrank_glb.eq.0) then 
!       write(6,'(a,4(1x,i5),1x,a,100(1x,f10.5))')'myrank=',myrank, 
!     +      bnv,env,pnv,'datav',datav(1:pnv)
!      endif 
!--
!      call MPI_BARRIER(comm,ierr)
!      if (myrank_glb.eq.0) then 
!       write(6,'(a,4(1x,i5),1x,a,100(1x,f10.5))')'myrank=',myrank, 
!     +       bno,eno,pno,'datao',datao(1:pno)
!      endif 
!      write(6,*)'myrank=',myrank,bno,eno,pno,nbufo 
!      write(6,*)'myrank=',myrank,bnv,env,pnv,nbufv
!--
      call MPI_BARRIER(comm_glb,ierr)
      allocate(E_OCC(1:nbufo,Nk_irr));E_OCC(:,:)=0.0d0 
      allocate(E_VIR(1:nbufv,Nk_irr));E_VIR(:,:)=0.0d0 
      allocate(E_VIR_new(1:nbufv,Nk_irr));E_VIR_new(:,:)=0.0d0 
      allocate(W_OCC(1:nbufo));W_OCC(:)=0
      allocate(W_VIR(1:nbufv));W_VIR(:)=0
      allocate(W_VIR_new(1:nbufv));W_VIR_new(:)=0
      allocate(T_OCC(1:nbufo));T_OCC(:)=0
      allocate(T_VIR(1:nbufv));T_VIR(:)=0
      allocate(T_VIR_new(1:nbufv));T_VIR_new(:)=0
      allocate(EO_AVE(1:nbufo));EO_AVE(:)=0.0d0 
      allocate(EV_AVE(1:nbufv));EV_AVE(:)=0.0d0 
      allocate(EV_AVE_new(1:nbufv));EV_AVE_new(:)=0.0d0 
      !--
      allocate(P_OCC(1:nbufo,NTK));P_OCC(:,:)=0.0d0 
      allocate(P_VIR(1:nbufv,NTK));P_VIR(:,:)=0.0d0 
      allocate(P_VIR_new(1:nbufv,NTK));P_VIR_new(:,:)=0.0d0 
      !--
      do i_band=1,pno!N_occ
       W_OCC(i_band)=WindowInside(bno-1+i_band)
       E_OCC(i_band,:)=E_EIGI(bno-1+i_band,:)
       T_OCC(i_band)=Tindx(bno-1+i_band) 
       EO_AVE(i_band)=E_AVE(bno-1+i_band) 
       P_OCC(i_band,:)=prob(bno-1+i_band,:)
      enddo 
      do i_band=1,pnv!N_vir
       W_VIR(i_band)=WindowInside(N_docc+bnv-1+i_band)
       E_VIR(i_band,:)=E_EIGI(N_docc+bnv-1+i_band,:)
       T_VIR(i_band)=Tindx(N_docc+bnv-1+i_band) 
       EV_AVE(i_band)=E_AVE(N_docc+bnv-1+i_band) 
       P_VIR(i_band,:)=prob(N_docc+bnv-1+i_band,:)
      enddo 
      !--
      call MPI_BARRIER(comm_glb,ierr)
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*) 
       write(6,*)'W_OCC'
       write(6,*) 
       do i_band=1,pno!N_occ
        write(6,*) i_band,W_OCC(i_band)
       enddo 
       write(6,*) 
       write(6,*)'W_VIR'
       write(6,*) 
       do i_band=1,pnv!N_vir
        write(6,*) i_band,W_VIR(i_band)
       enddo 
       write(6,*) 
       write(6,*)'T_OCC'
       write(6,*) 
       do i_band=1,pno!N_occ
        write(6,*) i_band,T_OCC(i_band)
       enddo 
       write(6,*) 
       write(6,*)'T_VIR'
       write(6,*) 
       do i_band=1,pnv!N_vir
        write(6,*) i_band,T_VIR(i_band)
       enddo 
       write(6,*) 
       write(6,*)'EO_AVE'
       write(6,*) 
       do i_band=1,pno!N_occ
        write(6,*) i_band,EO_AVE(i_band)
       enddo 
       write(6,*) 
       write(6,*)'EV_AVE'
       write(6,*) 
       do i_band=1,pnv!N_vir
        write(6,*) i_band,EV_AVE(i_band)
       enddo 
      endif 
      flush(6) 
      !-- 
      call MPI_BARRIER(comm_glb,ierr)
      allocate(OCC(NTG,1:nbufo,Nk_irr));OCC(:,:,:)=0.0d0 
      allocate(VIR(NTG,1:nbufv,Nk_irr));VIR(:,:,:)=0.0d0 
      allocate(VIR_new(NTG,1:nbufv,Nk_irr));VIR_new(:,:,:)=0.0d0 
      call MPI_BARRIER(comm_glb,ierr)
!--
!OPEN(102,FILE='./dir-wfn/dat.wfn',FORM='unformatted') 
      OPEN(102,FILE='./dir-wfn/dat.wfn',FORM='unformatted') 
      rewind(102) 
      read(102) ncomp!20170512  
      if(ncomp/=1)then 
       write(6,*)'This program not suport ncomp/=1; then stop'
       stop
      endif 
      call system('pwd') 
      do ik=1,Nk_irr  
       if(myrank/=0)then!not master  
        dest=0
        pnocld=pno 
        call MPI_Send(pnocld,1,MPI_INTEGER,dest,0,comm,ierr) 
        call MPI_Recv(OCC(1,1,ik),nbufo*NTG,MPI_DOUBLE_COMPLEX,
     +                dest,0,comm,status,ierr) 
        pnvcld=pnv 
        call MPI_Send(pnvcld,1,MPI_INTEGER,dest,0,comm,ierr) 
        call MPI_Recv(VIR(1,1,ik),nbufv*NTG,MPI_DOUBLE_COMPLEX,
     +                dest,0,comm,status,ierr) 
       else 
        do ib=1,pno
         read(102)(OCC(ig,ib,ik),ig=1,NGI(ik))
        enddo 
        allocate(Otmp(NTG,nbufo));Otmp(:,:)=0.0d0  
        do source=1,nproc-1
         write(6,*)'source=',source 
         call MPI_Recv(pnocld,1,MPI_INTEGER,source,0,comm,status,ierr) 
         do ib=1,pnocld 
          read(102)(Otmp(ig,ib),ig=1,NGI(ik))
         enddo 
         call MPI_Send(Otmp(1,1),nbufo*NTG,MPI_DOUBLE_COMPLEX,
     +                 source,0,comm,ierr) 
        enddo!source 
        deallocate(Otmp) 
        !--
        !20180412 M.Charlebois 
        !
        !It is better not to use backspace function
        !
        !do ib=1,N_pocc
        ! backspace(102)
        !enddo 
        !--
        rewind(102)
        read(102) ncomp
        do jk=1,ik-1
         do ib=1,NTB 
          read(102) 
         enddo!ib
        enddo!jk  
        do ib=1,N_docc
         read(102) 
        enddo!ib 
        !--
        do ib=1,pnv 
         read(102)(VIR(ig,ib,ik),ig=1,NGI(ik))
        enddo 
        allocate(Vtmp(NTG,nbufv));Vtmp(:,:)=0.0d0  
        do source=1,nproc-1
         call MPI_Recv(pnvcld,1,MPI_INTEGER,source,0,comm,status,ierr) 
         do ib=1,pnvcld 
          read(102)(Vtmp(ig,ib),ig=1,NGI(ik))
         enddo 
         call MPI_Send(Vtmp(1,1),nbufv*NTG,MPI_DOUBLE_COMPLEX,
     +                 source,0,comm,ierr) 
        enddo!source 
        deallocate(Vtmp) 
        do ib=1,NTB-N_CALC_BAND 
        read(102)
        enddo 
       endif  
      enddo 
!MPI_Broadcast
      IF(num_of_comm.gt.1)then 
       id_sub_perp=MOD(myrank_glb,num_of_mpi_per_comm)  
       write(6,*)'glb=',myrank_glb,'id_sub_perp=',id_sub_perp 
       call MPI_COMM_SPLIT(comm_glb,id_sub_perp,myrank_glb
     +                    ,comm_perp,ierr)
       call MPI_COMM_RANK(comm_perp,myrank_perp,ierr)
       call MPI_COMM_SIZE(comm_perp,nproc_perp,ierr)
       call MPI_Bcast(OCC,nbufo*Nk_irr*NTG,MPI_DOUBLE_COMPLEX,  
     +                0,comm_perp,ierr) 
       call MPI_Bcast(VIR,nbufv*Nk_irr*NTG,MPI_DOUBLE_COMPLEX,  
     +                0,comm_perp,ierr) 
      ENDIF 
!--
!      call MPI_BARRIER(comm_glb,ierr)
!      end_time=MPI_Wtime()
!      diff_time=end_time-start_time 
!      if(myrank.eq.0) then 
!       write(file_num_log,*)'#TOTAL TIME=',diff_time 
!      endif 
!      call MPI_FINALIZE(ierr)
!      stop
!--
      emax=dabs(maxval(band_max(1:N_CALC_BAND))
     +         -minval(band_min(1:N_CALC_BAND))) 
      if(myrank_glb.eq.MPI_io_rank)then 
       write(6,*)'emax(eV)=',emax*au 
       write(6,*)'bandmax(eV)=',maxval(band_max(1:N_CALC_BAND))*au 
       write(6,*)'bandmin(eV)=',minval(band_min(1:N_CALC_BAND))*au 
      endif 
      allocate(em(nen));em(:)=0.0d0 
      call gen_grid(nen,emax,em(1)) 
      if(myrank_glb.eq.0)then!master  
       write(6,*) 
       write(6,*)'==============='
       write(6,*)' freqency grid ' 
       write(6,*)'==============='
       write(6,*) 
       do ie=1,nen
        write(6,'(A5,2F10.5)')'em=',em(ie) 
       enddo 
       write(6,*) 
       ierr=CHDIR("./dir-eps") 
       call system('pwd') 
!--
!OPEN(300,W,FILE='dat.chi_cutoff')!20170402  
       OPEN(300,FILE='./dat.chi_cutoff')!20170402 
       write(300,*) Ecut_for_eps!20170402  
!--
!OPEN(302,W,FILE='dat.ttrhdrn')!20180507 
       OPEN(302,FILE='./dat.ttrhdrn')!20180507 
       write(302,*) delt!au 
       write(302,*) ttrhdrn_dmna!au 
       write(302,*) ttrhdrn_dmnr!au 
!--
!OPEN(135,R,FILE='dat.wgrid') 
       OPEN(135,FILE='./dat.wgrid') 
       write(135,*) nen!20170331 nen=Num_freq_grid 
       do ie=1,nen 
        write(135,'(2F15.10)') em(ie)
       enddo 
       ierr=CHDIR("..") 
       call system('pwd') 
      endif 
!--
!     call MPI_FINALIZE(ierr)
!     stop
!--
      call MPI_BARRIER(comm,ierr)
      if(myrank_glb.eq.MPI_io_rank)then 
       WRITE(6,*) 
       WRITE(6,*)'====================='
       WRITE(6,*)'=== dielmat start ==='
       WRITE(6,*)'====================='
       WRITE(6,*) 
      endif 
      !--
      allocate(imt1(4*nkb1*nkb2*nkb3*6));imt1(:)=0    
!--
!     call ttrhdrn_mkidx(nkb1,nkb2,nkb3,imt1(1)) 
!--
!20170325 for new ttrhdrn
      call ttrhdrn_mkidx(nkb1,nkb2,nkb3,imt1(1),b1(1),b2(1),b3(1))
!--
!this mpi calculates eps(q,w) for bnq to enq points 
!      if(myrank.eq.0)then!master  
!       ierr=CHDIR("./dir-eps") 
!       call system('pwd') 
!       write(file_num_eps) 
!     + bnq+num_start_irrq-1,enq+num_start_irrq-1,pnq  
!       write(6,*)'this mpi calculates eps(q,w) for bnq to enq points',
!     +            bnq+num_start_irrq-1,enq+num_start_irrq-1,pnq  
!       ierr=CHDIR("..") 
!       call system('pwd') 
!      endif 
!--
      do iq=1,pnq 
       q1=SQ(1,iq);q2=SQ(2,iq);q3=SQ(3,iq)
       NG_for_eps=NGQ(iq) 
       if(myrank.eq.0)then!master 
        write(6,'(i5,3f15.8)') iq,q1,q2,q3 
       endif 
!q.ne.0 
      if((q1/=0.0d0).or.(q2/=0.0d0).or.(q3/=0.0d0))then 
       allocate(chiqw(NG_for_eps,NG_for_eps,nen))
       allocate(pchiqw(NG_for_eps,NG_for_eps,nen))
       allocate(i_for_pair(N_CALC_BAND*N_CALC_BAND))
       allocate(j_for_pair(N_CALC_BAND*N_CALC_BAND))
       chiqw(:,:,:)=0.0D0 
       pchiqw(:,:,:)=0.0D0 
!wavefunction rotation loop  
       do irot=0,nproc-1
!double loop-->single loop 
       i_for_pair(:)=0
       j_for_pair(:)=0
       ij=0
       do jb=1,pno 
        do ib=1,pnv 
         fs1=W_VIR(ib)
         fs2=W_OCC(jb)
!constrained excitation 
         bci=EV_AVE(ib) 
         bcj=EO_AVE(jb) 
         if(abs(bci-bcj)>=delta_ex)cycle 
!--
!         if(myrank.eq.0)then 
!          write(6,*) abs(bci-bcj)*au,delta_ex*au  
!         endif 
!--
!1:window-cRPA not default 
        if(fs1==1.and.fs2==1.and.flg_cRPA_ewin==1)cycle 
         ij=ij+1
         i_for_pair(ij)=ib  
         j_for_pair(ij)=jb  
         if(myrank.eq.0)then 
          write(6,*)'ij=',ij,ib,jb 
         endif 
        enddo 
       enddo 
       N_PAIR=ij 
       if(myrank.eq.0)write(6,*)'FOR q/=0,N_PAIR=',N_PAIR 
!$OMP PARALLEL PRIVATE(ij,i_band,j_band
!$OMP&                ,e1_1D,e2_1D,ik,shift_G,ikq
!$OMP&                ,C0_K,C0_KQ,dsgn,kpq
!$OMP&                ,wfunc,fftwk,m_tmp,ism
!$OMP&                ,e1_3D,e2_3D,ikb3,ikb2,ikb1
!$OMP&                ,xow,xow_1D,ca1,ie,ig,jg
!$OMP&                ,pc0d,iomp,ikir,iop)  
       allocate(pc0d(NG_for_eps,NG_for_eps,nen));pc0d=(0.d0,0.d0)
       allocate(fftwk(Nl123*2)) 
       allocate(wfunc(Nl123*2)) 
       allocate(m_tmp(NG_for_eps))
       allocate(ism(NTK,NG_for_eps))
       allocate(C0_K(NTG))    
       allocate(C0_KQ(NTG))    
       allocate(kpq(NTK)) 
       allocate(e1_1D(NTK))
       allocate(e2_1D(NTK))
       allocate(e1_3D(nkb1,nkb2,nkb3)) 
       allocate(e2_3D(nkb1,nkb2,nkb3))
       allocate(xow(nen,nkb1,nkb2,nkb3)) 
       allocate(xow_1D(NTK,nen)) 
       allocate(ca1(4*nen))  
!$OMP DO
       do ij=1,N_PAIR 
        i_band=i_for_pair(ij) 
        j_band=j_for_pair(ij) 
        do ik=1,NTK 
         shift_G(:)=0 
         call search_kq(NTK,SK0(1,1),q1,q2,q3,ik,ikq,shift_G(1))  
         kpq(ik)=ikq
!C0_K=OCC(jb,ik)
         ikir=numirr(ik)
         iop=numrot(ik) 
         C0_K(:)=0.0d0 
         call make_C0(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),
     +   rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,
     +   packing(-L1,-L2,-L3,ikir),OCC(1,j_band,ikir),C0_K(1)) 
!C0_KQ=VIR(ib,ikq)
         ikir=numirr(ikq)
         iop=numrot(ikq) 
         C0_KQ(:)=0.0d0 
         call make_C0(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),     
     +   rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,
     +   packing(-L1,-L2,-L3,ikir),VIR(1,i_band,ikir),C0_KQ(1)) 
!calc ISM 
         call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),
     +                              C0_K(1),C0_KQ(1),
     +                              ik,ikq,nwx2,nwy2,nwz2,
     +                              nfft1,nfft2,Nl123,
     +                              wfunc(1),fftwk(1),fs,LG0(1,1,iq),
     +                              NG_for_eps,shift_G(1),m_tmp(1))
         ism(ik,:)=m_tmp(:) 
        enddo!ik 
!Using ttrhdrn_chi0 
        e1_1D(:)=0.0d0
        e2_1D(:)=0.0d0 
        do ik=1,NTK
         ikir=numirr(ik) 
         e1_1D(ik)=cmplx(E_OCC(j_band,ikir),0.0d0)  
         ikq=kpq(ik)
         ikir=numirr(ikq) 
         e2_1D(ik)=cmplx(E_VIR(i_band,ikir),0.0d0)  
        enddo 
        e1_3D(:,:,:)=0.0d0 
        e2_3D(:,:,:)=0.0d0
        do ikb3=1,nkb3
         do ikb2=1,nkb2
          do ikb1=1,nkb1
           ik=index_kpt(ikb1,ikb2,ikb3)
           e1_3D(ikb1,ikb2,ikb3)=e1_1D(ik)
           e2_3D(ikb1,ikb2,ikb3)=e2_1D(ik)
          enddo 
         enddo 
        enddo 
!freq dep 
        xow(:,:,:,:)=0.0d0 
        ca1(:)=0.0d0
        dsgn=1.0d0
        call ttrhdrn_chi0(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),
     +                   e1_3D(1,1,1),e2_3D(1,1,1),
     +                   FermiEnergy,FermiEnergy,delt,dsgn,
     +                   nen,em(1),ca1(1),xow(1,1,1,1)) 
        dsgn=-1.0d0
        ca1(:)=0.0d0
        call ttrhdrn_chi0(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),
     +                   e1_3D(1,1,1),e2_3D(1,1,1),
     +                   FermiEnergy,FermiEnergy,delt,dsgn,
     +                   nen,em(1),ca1(1),xow(1,1,1,1)) 
        !--
        xow_1D(:,:)=0.0d0 
        do ikb3=1,nkb3
         do ikb2=1,nkb2
          do ikb1=1,nkb1
           ik=index_kpt(ikb1,ikb2,ikb3)
           do ie=1,nen
            xow_1D(ik,ie)=xow(ie,ikb1,ikb2,ikb3)
           enddo 
          enddo 
         enddo 
        enddo 
        !--
        do ie=1,nen
         do ig=1,NG_for_eps
          do jg=1,NG_for_eps
           do ik=1,NTK 
            ikq=kpq(ik)
            pc0d(ig,jg,ie)
     +     =pc0d(ig,jg,ie)
     +     +xow_1D(ik,ie)
     +     *CONJG(ism(ik,ig))*ism(ik,jg)/dble(NTK)
     +     *(1.0d0-P_OCC(j_band,ik)*P_VIR(i_band,ikq)) 
           enddo 
          enddo 
         enddo 
        enddo 
        !--
        iomp=omp_get_thread_num() 
        if(myrank.eq.0.and.iomp.eq.0)then 
         write(6,*)'#',i_band,j_band 
        endif 
        !--
       enddo!ij
!$OMP END DO
!$OMP CRITICAL
       pchiqw=pchiqw+pc0d
!$OMP END CRITICAL
       deallocate(pc0d,fftwk,wfunc,m_tmp,ism)
       deallocate(C0_K,C0_KQ,kpq,e1_1D,e2_1D,e1_3D,e2_3D,xow,xow_1D,ca1) 
!$OMP END PARALLEL
       !--
       if(myrank.eq.0)write(6,*)'#MPI start' 
       call MPI_BARRIER(comm,ierr)
       dest=modulo(myrank+1,nproc)
       source=modulo(myrank-1,nproc)
       tmpnv(1)=pnv
       tmpnv(2)=bnv
       tmpnv(3)=env
       call MPI_SENDRECV(   tmpnv,      3, MPI_INTEGER, 
     +                       dest,      0, 
     +                   newtmpnv,      3, MPI_INTEGER,
     +                     source,      0, 
     +                       comm, status,        ierr)
       newpnv=newtmpnv(1)
       newbnv=newtmpnv(2)
       newenv=newtmpnv(3)
       call MPI_SENDRECV(    W_VIR,  nbufv, MPI_INTEGER,
     +                        dest,      0, 
     +                   W_VIR_new,  nbufv, MPI_INTEGER,
     +                      source,      0, 
     +                        comm, status,        ierr)
       call MPI_SENDRECV(    E_VIR, nbufv*Nk_irr, MPI_DOUBLE_PRECISION,
     +                        dest,         0, 
     +                   E_VIR_new, nbufv*Nk_irr, MPI_DOUBLE_PRECISION,
     +                      source,         0, 
     +                        comm,    status,                  ierr)
       call MPI_SENDRECV(    P_VIR, nbufv*NTK, MPI_DOUBLE_COMPLEX,
     +                        dest,         0, 
     +                   P_VIR_new, nbufv*NTK, MPI_DOUBLE_COMPLEX, 
     +                      source,         0, 
     +                        comm,    status,                  ierr)
       call MPI_SENDRECV(    VIR, nbufv*Nk_irr*NTG, MPI_DOUBLE_COMPLEX,
     +                      dest,             0, 
     +                    VIR_new, nbufv*Nk_irr*NTG, MPI_DOUBLE_COMPLEX,
     +                     source,             0,
     +                      comm,        status,             ierr)
       pnv=newpnv
       bnv=newbnv
       env=newenv
       W_VIR(1:nbufv)=W_VIR_new(1:nbufv)
       E_VIR(1:nbufv,1:Nk_irr)=E_VIR_new(1:nbufv,1:Nk_irr)
       P_VIR(1:nbufv,1:NTK)=P_VIR_new(1:nbufv,1:NTK)
       VIR(1:NTG,1:nbufv,1:Nk_irr)=VIR_new(1:NTG,1:nbufv,1:Nk_irr)
       if(myrank.eq.0)write(6,*)'#MPI end' 
       enddo!irot 
       !--
       call MPI_REDUCE(pchiqw,chiqw,NG_for_eps*NG_for_eps*nen,
     +      MPI_DOUBLE_COMPLEX,MPI_SUM,0,comm,ierr)
!--
!output 
       if(myrank.eq.0)then 
        chiqw(:,:,:)=chiqw(:,:,:)/VOLUME 
        ierr=CHDIR("./dir-eps") 
        call system('pwd') 
!--
!2017413 
        do ik=1,Nk_irr 
         if(ABS(SKI_list(1,ik)-q1)<1.D-6.and.
     +      ABS(SKI_list(2,ik)-q2)<1.D-6.and. 
     +      ABS(SKI_list(3,ik)-q3)<1.D-6)then 
          qnum=ik 
         endif 
        enddo 
        write(6,*) 'qnum=',qnum
        write(dirname,"('q',i3.3)")qnum 
        ierr=CHDIR(dirname) 
        call system('pwd') 
!--
!OPEN(301,W,FILE='dat.sq') 
        OPEN(301,FILE='dat.sq') 
        rewind(301)
        write(301,*) q1,q2,q3 
        close(301) 
        !--
        allocate(epsqw(NG_for_eps,NG_for_eps,nen));epsqw(:,:,:)=0.0d0 
        allocate(eps_rpa(NG_for_eps,NG_for_eps));eps_rpa(:,:)=0.0d0 
        allocate(chi0(NG_for_eps,NG_for_eps));chi0(:,:)=0.0d0 
!--
!OPEN(60000-,W,FILE='epsqw(G,G)) 
        file_num_eps_base=file_num_eps_base_start!20171011  
        do ie=1,nen 
         file_num_eps_ie=file_num_eps_base+ie!-1 
         write(filename,'("dat.epsqw.",i6.6)')file_num_eps_ie   
         OPEN(file_num_eps_ie,FILE=filename) 
         rewind(file_num_eps_ie)
         write(file_num_eps_ie,'(a)')'#epsqw diagonal term' 
         write(file_num_eps_ie,'(a)')
     +   '#1:q+G [au], 2:Re(eps-1), 3:Im(eps-1)'
        enddo!ie 
        !--
        do ie=1,nen 
         file_num_chi_ie=0!file_num_chi_base+ie-1
         file_num_eps_ie=file_num_eps_base+ie!-1 
         chi0(:,:)=chiqw(:,:,ie)
         call calc_eps_rpa(NTG,NG_for_eps,LG0(1,1,iq),
     +                     q1,q2,q3,b1(1),b2(1),b3(1),
     +                     chi0(1,1),tpi,eps_rpa(1,1), 
     +                     file_num_chi_ie,file_num_eps_ie)  
         epsqw(:,:,ie)=eps_rpa(:,:)
         close(file_num_eps_ie)
        enddo!ie 
!--
!chiqw 
!       write(file_num_chi)(((chiqw(ig,jg,ie),ig=1,NG_for_eps)
!     +                            ,jg=1,NG_for_eps),ie=1,nen)   
!--
!OPEN(600,W,FILE='epsqw',FORM='unformatted') 
        file_num_eps=file_num_eps_start 
        write(filename,'("dat.epsqw.",i3.3)')file_num_eps  
        OPEN(file_num_eps,FILE=filename,FORM='unformatted') 
        rewind(file_num_eps)
        write(file_num_eps)(((epsqw(ig,jg,ie),ig=1,NG_for_eps)
     +                             ,jg=1,NG_for_eps),ie=1,nen) 
        close(file_num_eps) 
!--
!OPEN(400,W,FILE='dat.log') 
        file_num_log=file_num_log_start 
        write(filename,'("dat.log.",i3.3)')file_num_log 
        OPEN(file_num_log,FILE=filename) 
        rewind(file_num_log)
        write(file_num_log,*)'#'
        write(file_num_log,*)'#finish chi0 evaluation for',qnum!iq 
        write(file_num_log,*)'#' 
        close(file_num_log) 
        !--
        deallocate(epsqw,eps_rpa,chi0)
        ierr=CHDIR("../..")!2017413  
        call system('pwd') 
       endif 
       deallocate(chiqw,pchiqw,i_for_pair,j_for_pair) 
!--
!q.eq.0 
      elseif(q1==0.0d0.and.q2==0.0d0.and.q3==0.0d0)then 
       if(myrank.eq.0)then 
        write(6,'(i5,3f15.8)') iq,q1,q2,q3 
       endif 
       do igL=1,NG_for_eps
        igL1=LG0(1,igL,iq) 
        igL2=LG0(2,igL,iq) 
        igL3=LG0(3,igL,iq) 
        if(igL1==0.and.igL2==0.and.igL3==0)then
         No_G_0=igL 
         write(6,*)'No. for G=0',No_G_0
        endif
       enddo!igL
       allocate(chiqwgm(NG_for_eps,NG_for_eps,nen,3))
       chiqwgm(:,:,:,:)=0.0D0        
       allocate(pchiqwgm(NG_for_eps,NG_for_eps,nen,3))
       pchiqwgm(:,:,:,:)=0.0D0 
       allocate(i_for_pair(N_CALC_BAND*N_CALC_BAND))
       allocate(j_for_pair(N_CALC_BAND*N_CALC_BAND))
       allocate(i_for_intra(N_CALC_BAND*N_CALC_BAND))
       allocate(j_for_intra(N_CALC_BAND*N_CALC_BAND))
!wavefunction-rotation loop  
!wpl calc 20130308 
       wpl(:)=0.0d0;pwpl(:)=0.0d0
      do irot=0,nproc-1
!double loop-->single loop 
       i_for_pair(:)=0
       j_for_pair(:)=0
       ij=0
       ij_intra=0
       i_for_intra(:)=0
       j_for_intra(:)=0
       do jb=1,pno 
       do ib=1,pnv
        fs1=W_VIR(ib)
        fs2=W_OCC(jb)
!--
!constrained excitation 
        bci=EV_AVE(ib) 
        bcj=EO_AVE(jb) 
        if(abs(bci-bcj)>=delta_ex)cycle 
!--
!        if(myrank.eq.0)then 
!         write(6,*) abs(bci-bcj)*au,delta_ex*au  
!        endif 
!--
!1:window-cRPA not default
       if(fs1==1.and.fs2==1.and.flg_cRPA_ewin==1)cycle
        !--
        fs1=T_VIR(ib)
        fs2=T_OCC(jb)
        !--
        if((fs1==fs2).and.fs1.ne.0)then 
!wpl calc 20130308
         ij_intra=ij_intra+1
         write(6,*)'iandj',fs1,fs2 
         i_for_intra(ij_intra)=ib  
         j_for_intra(ij_intra)=jb  
        else 
         ij=ij+1
         i_for_pair(ij)=ib  
         j_for_pair(ij)=jb  
         write(6,*)'ij=',ij,ib,jb 
        endif 
       enddo 
       enddo 
       N_PAIR=ij 
       if(myrank.eq.0)write(6,*)'FOR q=0,N_PAIR=',N_PAIR 
       N_INTRA=ij_intra 
!cRPA
       if(flg_cRPA==1)then 
        if(myrank.eq.0)write(6,*)'In cRPA,N_INTRA=0 forcidly'
        N_INTRA=0
       endif 
       if(myrank.eq.0)write(6,*)'FOR q=0, N_INTRA=',N_INTRA 
!wpl calc 20130308
       allocate(pk_1D(NTK,3))
       allocate(pk_3D(nkb1,nkb2,nkb3,3))  
       allocate(fk_1D(NTK))
       allocate(fk_3D(nkb1,nkb2,nkb3))  
       allocate(gk_1D(NTK)) 
       allocate(gk_3D(nkb1,nkb2,nkb3)) 
       allocate(xo(nkb1,nkb2,nkb3))  
       do ij_intra=1,N_INTRA 
        ib=i_for_intra(ij_intra)
        jb=j_for_intra(ij_intra)
        gk_1D(:)=0.0d0 
        fk_1D(:)=0.0d0
        pk_1D(:,:)=0.0d0
        do ik=1,NTK 
         ikq=ik 
         SKT(:)=SK0(:,ik) 
!C0_K(:)=OCC(:,jb,ik) 
         ikir=numirr(ik)
         iop=numrot(ik) 
         allocate(C0_K(NTG));C0_K(:)=0.0d0 
         call make_C0(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),
     +   rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,
     +   packing(-L1,-L2,-L3,ikir),OCC(1,jb,ikir),C0_K(1)) 
!C0_KQ(:)=VIR(:,ib,ikq) 
         ikir=numirr(ikq)
         iop=numrot(ikq) 
         allocate(C0_KQ(NTG));C0_KQ(:)=0.0d0 
         call make_C0(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),     
     +   rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,
     +   packing(-L1,-L2,-L3,ikir),VIR(1,ib,ikir),C0_KQ(1)) 
         call calc_VMaa(NTK,NTG,NG0(1),KG0(1,1,1),C0_K(1),C0_KQ(1),ik, 
     +                  b1(1),b2(1),b3(1),SKT(1),vm(1))  
         deallocate(C0_K,C0_KQ) 
!20170424 
        NLvm(:)=0.0d0 
        NLvm(:)=MAT_NLr_rNL(:,ib+(N_docc+bnv-1),jb+(bno-1),numirr(ik))
        pk_1D(ik,:)=-ci*(vm(:)-NLvm(:)) 
        !--
        fk_1D(ik)=1.0d0
        ikir=numirr(ik) 
        gk_1D(ik)=cmplx(E_OCC(jb,ikir)-FermiEnergy,-delt)
        enddo!ik  
        pk_3D(:,:,:,:)=0.0d0
        fk_3D(:,:,:)=0.0d0
        gk_3D(:,:,:)=0.0d0 
        do ikb3=1,nkb3
         do ikb2=1,nkb2
          do ikb1=1,nkb1
           ik=index_kpt(ikb1,ikb2,ikb3)
           pk_3D(ikb1,ikb2,ikb3,:)=pk_1D(ik,:)
           fk_3D(ikb1,ikb2,ikb3)=fk_1D(ik)
           gk_3D(ikb1,ikb2,ikb3)=gk_1D(ik)
          enddo 
         enddo 
        enddo 
        !--
        xo(:,:,:)=0.0d0 
        call ttrhdrn_simple(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),
     +                      fk_3D(1,1,1),gk_3D(1,1,1),xo(1,1,1))
        !--
        do ikb3=1,nkb3
         do ikb2=1,nkb2
          do ikb1=1,nkb1
           ik=index_kpt(ikb1,ikb2,ikb3)
           pwpl(:)
     +    =pwpl(:)+dimag(xo(ikb1,ikb2,ikb3))
     +    *pk_3D(ikb1,ikb2,ikb3,:)*pk_3D(ikb1,ikb2,ikb3,:) 
          enddo 
         enddo 
        enddo 
!--
!20170324 
!        xo_1D(:)=0.0d0 
!        do ikb3=1,nkb3
!         do ikb2=1,nkb2
!          do ikb1=1,nkb1
!           ik=index_kpt(ikb1,ikb2,ikb3)
!           xo_1D(ik)=xo(ikb1,ikb2,ikb3)
!          enddo 
!         enddo 
!        enddo 
!--
!       xo_1D_av(:)=0.0d0 
!       do ikir=1,Nk_irr 
!        nk=0
!        SUM_CMPX=0.0d0 
!        do ik=1,NTK 
!         if(numirr(ik)==ikir)then 
!          SUM_CMPX=SUM_CMPX+xo_1D(ik)
!          nk=nk+1
!         endif 
!        enddo!ik
!        xo_1D_av(ikir)=SUM_CMPX/dble(nk)
!       enddo!ikir
!--
!        do ik=1,NTK 
!         ikir=numirr(ik) 
!         pwpl=pwpl+dimag(xo_1D(ik))*pk_1D(ik)*pk_1D(ik) 
!!        pwpl=pwpl+dimag(xo_1D_av(ikir))*pk_1D(ik)*pk_1D(ik)!20170324  
!        enddo 
!--
       enddo!ij_intra 
       deallocate(pk_1D,pk_3D,fk_1D,fk_3D,gk_1D,gk_3D,xo)
!$OMP PARALLEL PRIVATE(ij,ib,jb,ix,
!$OMP&                 e1_1D,e2_1D,ik,shift_G,ikq, 
!$OMP&                 C0_K,C0_KQ,dsgn,kpq, 
!$OMP&                 wfunc,fftwk,m_tmp,ismgm,vm,NLvm,del_eps, 
!$OMP&                 e1_3D,e2_3D,ikb3,ikb2,ikb1, 
!$OMP&                 xow,xow_1D,ca1,ie,ig,jg, 
!$OMP&                 pc0dgm,iomp,ikir,iop) 
       allocate(pc0dgm(NG_for_eps,NG_for_eps,nen,3));pc0dgm=(0.d0,0.d0) 
       allocate(ismgm(NTK,NG_for_eps,3))
       !--
       allocate(m_tmp(NG_for_eps))
       allocate(fftwk(Nl123*2)) 
       allocate(wfunc(Nl123*2)) 
       allocate(C0_K(NTG))    
       allocate(C0_KQ(NTG))    
       allocate(kpq(NTK)) 
       allocate(e1_1D(NTK))
       allocate(e2_1D(NTK))
       allocate(e1_3D(nkb1,nkb2,nkb3)) 
       allocate(e2_3D(nkb1,nkb2,nkb3))
       allocate(xow(nen,nkb1,nkb2,nkb3)) 
       allocate(xow_1D(NTK,nen)) 
       allocate(ca1(4*nen))  
!$OMP DO
       do ij=1,N_PAIR 
        ib=i_for_pair(ij) 
        jb=j_for_pair(ij) 
        do ik=1,NTK 
         ikq=ik 
         kpq(ik)=ikq
         shift_G(:)=0 
         ikir=numirr(ik)
         iop=numrot(ik) 
!C0_K(:)=OCC(:,jb,ik) 
         C0_K(:)=0.0d0 
         call make_C0(NTG,trs(ik),NG0(ik),KG0(1,1,ik),RW(1,ik),
     +   rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,
     +   packing(-L1,-L2,-L3,ikir),OCC(1,jb,ikir),C0_K(1)) 
         ikir=numirr(ikq)
         iop=numrot(ikq) 
!C0_KQ(:)=VIR(:,ib,ikq) 
         C0_KQ(:)=0.0d0 
         call make_C0(NTG,trs(ikq),NG0(ikq),KG0(1,1,ikq),RW(1,ikq),     
     +   rginv(1,1,iop),pg(1,iop),nnp,L1,L2,L3,
     +   packing(-L1,-L2,-L3,ikir),VIR(1,ib,ikir),C0_KQ(1)) 
         call calc_InterStateMatrix(NTK,NTG,NG0(1),KG0(1,1,1),
     +                              C0_K(1),C0_KQ(1),
     +                              ik,ikq,nwx2,nwy2,nwz2,
     +                              nfft1,nfft2,Nl123,
     +                              wfunc(1),fftwk(1),fs,LG0(1,1,iq),
     +                              NG_for_eps,shift_G(1),m_tmp(1))
         call calc_VMab(NTK,NTG,NG0(1),KG0(1,1,1),C0_K(1),C0_KQ(1),ik, 
     +                  b1(1),b2(1),b3(1),vm(1))  
         !--
         del_eps=E_VIR(ib,numirr(ikq))-E_OCC(jb,numirr(ik))
!20140915 
         if(abs(del_eps)<delt)then 
          write(6,*)'del_eps=',del_eps 
          del_eps=delt 
         endif 
!2017022 
         NLvm(:)=0.0d0 
         NLvm(:)=MAT_NLr_rNL(:,ib+(N_docc+bnv-1),jb+(bno-1),numirr(ik))
         vm(:)=-ci*(vm(:)-NLvm(:))/del_eps!correct  
!20170424 
         do ix=1,3
          m_tmp(No_G_0)=vm(ix)
          if(abs(del_eps)<=delt)then 
           m_tmp(No_G_0)=0.0d0 
          endif 
          ismgm(ik,:,ix)=m_tmp(:) 
         enddo!ix  
        enddo!ik 
!Using ttrhdrn_chi0 
        e1_1D(:)=0.0d0
        e2_1D(:)=0.0d0 
        do ik=1,NTK
         ikq=kpq(ik)
         e1_1D(ik)=cmplx(E_OCC(jb,numirr(ik)),0.0d0) 
         e2_1D(ik)=cmplx(E_VIR(ib,numirr(ikq)),0.0d0) 
        enddo 
!--
!avoid degeneracy 20120916 
!       do ik=1,NTK 
!        if(abs(e1_1D(ik)-e2_1D(ik))<delt) then 
!         e1_1D(ik)=e1_1D(ik)-0.5d0*delt !*100.0d0 
!         e2_1D(ik)=e2_1D(ik)+0.5d0*delt !*100.0d0
!        endif 
!       enddo 
!--
        e1_3D(:,:,:)=0.0d0 
        e2_3D(:,:,:)=0.0d0
        do ikb3=1,nkb3
         do ikb2=1,nkb2
          do ikb1=1,nkb1
           ik=index_kpt(ikb1,ikb2,ikb3)
           e1_3D(ikb1,ikb2,ikb3)=e1_1D(ik)
           e2_3D(ikb1,ikb2,ikb3)=e2_1D(ik)
          enddo 
         enddo 
        enddo 
!freq dep 
        xow(:,:,:,:)=0.0d0 
        dsgn=1.0d0
        ca1(:)=0.0d0
        call ttrhdrn_chi0(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),
     +                   e1_3D(1,1,1),e2_3D(1,1,1),
     +                   FermiEnergy,FermiEnergy,delt,dsgn,
     +                   nen,em(1),ca1(1),xow(1,1,1,1)) 
        dsgn=-1.0d0
        ca1(:)=0.0d0
        call ttrhdrn_chi0(dmna,dmnr,nkb1,nkb2,nkb3,imt1(1),
     +                   e1_3D(1,1,1),e2_3D(1,1,1),
     +                   FermiEnergy,FermiEnergy,delt,dsgn,
     +                   nen,em(1),ca1(1),xow(1,1,1,1)) 
        !--
        xow_1D(:,:)=0.0d0 
        do ikb3=1,nkb3
         do ikb2=1,nkb2
          do ikb1=1,nkb1
           ik=index_kpt(ikb1,ikb2,ikb3)
           do ie=1,nen 
            xow_1D(ik,ie)=xow(ie,ikb1,ikb2,ikb3)
           enddo 
          enddo 
         enddo 
        enddo 
!org freq dep 
        do ie=1,nen 
         do ig=1,NG_for_eps
          do jg=1,NG_for_eps
           do ik=1,NTK 
            ikq=kpq(ik)
            pc0dgm(ig,jg,ie,:)
     +     =pc0dgm(ig,jg,ie,:)
     +     +xow_1D(ik,ie)
     +     *CONJG(ismgm(ik,ig,:))*ismgm(ik,jg,:)/dble(NTK)
     +     *(1.0d0-P_OCC(jb,ik)*P_VIR(ib,ikq)) 
           enddo!ik 
          enddo!jg 
         enddo!ig 
        enddo!ie
!--
!20170321 
!       xow_1D_av(:,:)=0.0d0 
!       do ie=1,nen 
!        do ikir=1,Nk_irr 
!         nk=0
!         SUM_CMPX=0.0d0 
!         do ik=1,NTK 
!          if(numirr(ik)==ikir)then 
!           SUM_CMPX=SUM_CMPX+xow_1D(ik,ie)
!           nk=nk+1
!          endif 
!         enddo!ik
!         xow_1D_av(ikir,ie)=SUM_CMPX/dble(nk)
!        enddo!ikir
!       enddo!ie 
!--
!20170321 averaging: In new ttrhdrn, averaging is no need.
!       
!       do ie=1,nen 
!        do ig=1,NG_for_eps
!         do jg=1,NG_for_eps
!          do ik=1,NTK 
!           ikir=numirr(ik) 
!           ikq=kpq(ik)
!           pc0d(ig,jg,ie)
!     +    =pc0d(ig,jg,ie)
!     +    +xow_1D_av(ikir,ie)
!!    +    *CONJG(ism(ik,ig))*ism(ik,jg)/dble(NTK)
!     +    *CONJG(ism_st(ik,ig))*ism(ik,jg)/dble(NTK)
!     +    *(1.0d0-P_OCC(jb,ik)*P_VIR(ib,ikq)) 
!          enddo!ik 
!         enddo!jg 
!        enddo!ig 
!       enddo!ie 
!--
       iomp=omp_get_thread_num() 
       if(myrank.eq.0.and.iomp.eq.0)write(6,*)'#',ib,jb
       !if(myrank.eq.0.and.iomp.eq.0)write(6,*)'av'!20170321  
!--
      enddo!ij 
!$OMP END DO
!$OMP CRITICAL
      pchiqwgm=pchiqwgm+pc0dgm 
!$OMP END CRITICAL
      deallocate(pc0dgm,fftwk,wfunc,m_tmp,ismgm)
      deallocate(C0_K,C0_KQ,kpq,e1_1D,e2_1D,e1_3D,e2_3D,xow,xow_1D,ca1) 
!     deallocate(xow_1D_av,m_tmp_st,ism_st)!20170322
!$OMP END PARALLEL
      !--
      if(myrank.eq.0)write(6,*)'#MPI start' 
       call MPI_BARRIER(comm,ierr)
       dest=modulo(myrank+1,nproc)
       source=modulo(myrank-1,nproc)
       tmpnv(1)=pnv
       tmpnv(2)=bnv
       tmpnv(3)=env
       call MPI_SENDRECV(   tmpnv,      3, MPI_INTEGER, 
     +                       dest,      0, 
     +                   newtmpnv,      3, MPI_INTEGER,
     +                     source,      0, 
     +                       comm, status,        ierr)
       newpnv = newtmpnv(1)
       newbnv = newtmpnv(2)
       newenv = newtmpnv(3)
       call MPI_SENDRECV(    W_VIR,  nbufv, MPI_INTEGER,
     +                        dest,      0, 
     +                   W_VIR_new,  nbufv, MPI_INTEGER,
     +                      source,      0, 
     +                        comm, status,        ierr)
       call MPI_SENDRECV(    T_VIR,  nbufv, MPI_INTEGER,
     +                        dest,      0, 
     +                   T_VIR_new,  nbufv, MPI_INTEGER,
     +                      source,      0, 
     +                        comm, status,        ierr)
       call MPI_SENDRECV(   EV_AVE,  nbufv, MPI_DOUBLE_PRECISION,
     +                        dest,      0, 
     +                  EV_AVE_new,  nbufv, MPI_DOUBLE_PRECISION,
     +                      source,      0, 
     +                        comm,    status,                  ierr)
       call MPI_SENDRECV(    E_VIR, nbufv*Nk_irr, MPI_DOUBLE_PRECISION,
     +                        dest,         0, 
     +                   E_VIR_new, nbufv*Nk_irr, MPI_DOUBLE_PRECISION,
     +                      source,         0, 
     +                        comm,    status,                  ierr)
       call MPI_SENDRECV(    P_VIR, nbufv*NTK, MPI_DOUBLE_COMPLEX, 
     +                        dest,         0, 
     +                   P_VIR_new, nbufv*NTK, MPI_DOUBLE_COMPLEX, 
     +                      source,         0, 
     +                        comm,    status,                  ierr)
       call MPI_SENDRECV(    VIR, nbufv*Nk_irr*NTG, MPI_DOUBLE_COMPLEX,
     +                      dest,             0, 
     +                   VIR_new, nbufv*Nk_irr*NTG, MPI_DOUBLE_COMPLEX,
     +                    source,             0,
     +                      comm,        status,             ierr)
       pnv=newpnv
       bnv=newbnv
       env=newenv
       W_VIR(1:nbufv)=W_VIR_new(1:nbufv)
       T_VIR(1:nbufv)=T_VIR_new(1:nbufv)
       EV_AVE(1:nbufv)=EV_AVE_new(1:nbufv)
       E_VIR(1:nbufv,1:Nk_irr)=E_VIR_new(1:nbufv,1:Nk_irr)
       P_VIR(1:nbufv,1:NTK)=P_VIR_new(1:nbufv,1:NTK)
       VIR(1:NTG,1:nbufv,1:Nk_irr)=VIR_new(1:NTG,1:nbufv,1:Nk_irr)
       if(myrank.eq.0) write(6,*)'#MPI end' 
      enddo!irot 
      !--
      call MPI_REDUCE(pchiqwgm,chiqwgm,NG_for_eps*NG_for_eps*nen*3,
     +     MPI_DOUBLE_COMPLEX,MPI_SUM,0,comm,ierr)
      call MPI_REDUCE(pwpl,wpl,3,MPI_DOUBLE_COMPLEX,MPI_SUM,0,comm,ierr)
!--
!output 
      if(myrank.eq.0)then 
       chiqwgm(:,:,:,:)=chiqwgm(:,:,:,:)/VOLUME 
!--
!wpl calc 20130308 
       wpl(:)=8.0d0*wpl(:)/VOLUME/dble(NTK) 
       wd(:)=dsqrt(dble(wpl(:))) 
       write(6,'(a10,3f15.10)')'wd in eV',wd*au 
       !--
       ierr=CHDIR("./dir-eps") 
       call system('pwd') 
!--
!2017413 
       do ik=1,Nk_irr 
        if(ABS(SKI_list(1,ik)-q1)<1.D-6.and.
     +     ABS(SKI_list(2,ik)-q2)<1.D-6.and. 
     +     ABS(SKI_list(3,ik)-q3)<1.D-6)then 
         qnum=ik 
        endif 
       enddo 
       write(6,*)'qnum=',qnum
       write(dirname,"('q',i3.3)")qnum 
       ierr=CHDIR(dirname) 
       call system('pwd') 
!--
!OPEN(301,W,FILE='dat.sq') 
       OPEN(301,FILE='dat.sq') 
       rewind(301)
       write(301,*) q1,q2,q3 
       close(301) 
       !--
       allocate(epsqwgm(NG_for_eps,NG_for_eps,nen,3))
       epsqwgm(:,:,:,:)=0.0d0 
       allocate(eps_rpa(NG_for_eps,NG_for_eps));eps_rpa(:,:)=0.0d0 
       allocate(chi0(NG_for_eps,NG_for_eps));chi0(:,:)=0.0d0 
!--
!OPEN(60000-,W,FILE='epsqw(G,G)) 
       do ix=1,3
        file_num_eps_base=file_num_eps_base_start+(ix-1)*1000   
        do ie=1,nen 
         file_num_eps_ie=file_num_eps_base+ie!-1 
         write(filename,'("dat.epsqw.",i6.6)')file_num_eps_ie   
         OPEN(file_num_eps_ie,FILE=filename) 
         rewind(file_num_eps_ie)
         write(file_num_eps_ie,'(a)')'#epsqw diagonal term' 
         write(file_num_eps_ie,'(a)')
     +   '#1:q+G [au], 2:Re(eps-1), 3:Im(eps-1)' 
        enddo!ie 
       enddo!ix
       !--
       do ix=1,3
        file_num_eps_base=file_num_eps_base_start+(ix-1)*1000   
        do ie=1,nen 
         file_num_chi_ie=0 
         file_num_eps_ie=file_num_eps_base+ie!-1 
         chi0(:,:)=chiqwgm(:,:,ie,ix)
         call calc_eps_rpa_q_0(NTG,NG_for_eps,LG0(1,1,iq),
     +                     q1,q2,q3,b1(1),b2(1),b3(1),
     +                     chi0(1,1),tpi,No_G_0,eps_rpa(1,1),
     +                     wd(ix),delt,em(ie),     
     +                     file_num_chi_ie,file_num_eps_ie)  
         epsqwgm(:,:,ie,ix)=eps_rpa(:,:)
         close(file_num_eps_ie)
        enddo!ie
       enddo!ix 
!--
!chiqw 
!      write(file_num_chi)(((chiqw(ig,jg,ie),ig=1,NG_for_eps)
!     +                           ,jg=1,NG_for_eps),ie=1,nen) 
!--
!OPEN(600,W,FILE='epsqw',FORM='unformatted') 
       do ix=1,3 
        file_num_eps=file_num_eps_start+(ix-1)  
        write(filename,'("dat.epsqw.",i3.3)')file_num_eps  
        OPEN(file_num_eps,FILE=filename,FORM='unformatted') 
        rewind(file_num_eps)
        write(file_num_eps)(((epsqwgm(ig,jg,ie,ix),ig=1,NG_for_eps)
     +                               ,jg=1,NG_for_eps),ie=1,nen) 
        close(file_num_eps)
       enddo 
!--
!OPEN(400,W,FILE='dat.log') 
       file_num_log=file_num_log_start 
       write(filename,'("dat.log.",i3.3)')file_num_log 
       OPEN(file_num_log,FILE=filename) 
       rewind(file_num_log)
       write(file_num_log,*)'#'
       write(file_num_log,*)'#finish chi0 evaluation for',qnum 
       write(file_num_log,*)'#' 
       close(file_num_log)
!--
!20180907 
!optical properties
       ierr=CHDIR("..")
       allocate(eps00w(1:nen,1:3));eps00w=0.0d0  
       eps00w(:,:)=epsqwgm(No_G_0,No_G_0,:,:) 
       call wrt_optical_property(nen,em(1),eps00w(1,1)) 
       deallocate(eps00w) 
       ierr=CHDIR("..")
       deallocate(epsqwgm,eps_rpa,chi0)
       !--
       !ierr=CHDIR("../..")!20170413 
       !--
       call system('pwd') 
      endif!myrank==0  
      deallocate(chiqwgm,pchiqwgm,i_for_pair,j_for_pair)
      deallocate(i_for_intra,j_for_intra) 
      !--
      endif!q=0 or q/=0
      enddo!iq 
!--
!     CLOSE(file_num_chi)
!     CLOSE(file_num_eps)
!--
      call MPI_BARRIER(comm_glb,ierr)
      end_time=MPI_Wtime()
      diff_time=end_time-start_time 
      if(myrank_glb.eq.0) then 
       call system('pwd') 
       write(6,*)'#TOTAL TIME=',diff_time 
      endif 
      !--
      call MPI_FINALIZE(ierr)
      STOP 
      END              

module m_wrt_model  
  implicit none
contains
subroutine wrt_model_hr(Na1,Na2,Na3,n_occ,HR,WR) 
  implicit none 
  integer::Na1,Na2,Na3,n_occ 
  integer::N_element 
  integer::ia1,ia2,ia3,ib,jb,i 
  integer,allocatable::unit_vec(:)!unit_vec(N_element) 
  complex(8)::HR(n_occ,n_occ,-Na1:Na1,-Na2:Na2,-Na3:Na3)
  real(8)::WR(-Na1:Na1,-Na2:Na2,-Na3:Na3)
  real(8),parameter::au=27.21151d0
  !
  N_element=(2*Na1+1)*(2*Na2+1)*(2*Na3+1)  
  !
  !OPEN(300,W,FILE='zvo_hr.dat') 
  !
  OPEN(300,FILE='./dir-model/zvo_hr.dat') 
  write(300,'(a)')'wannier90 format for vmcdry.out or HPhi -sdry'
  write(300,'(i10)') n_occ
  write(300,'(i10)') N_element
  !
  allocate(unit_vec(N_element)); unit_vec=1
  write(300,'(15i5)')(unit_vec(i),i=1,N_element) 
  deallocate(unit_vec) 
  !
  do ia1=-Na1,Na1
   do ia2=-Na2,Na2
    do ia3=-Na3,Na3 
     do ib=1,n_occ
      do jb=1,n_occ
       write(300,'(i5,i5,i5,i5,i5,2f15.10)') ia1,ia2,ia3,ib,jb,HR(ib,jb,ia1,ia2,ia3)*WR(ia1,ia2,ia3)*au   
      enddo!jb
     enddo!ib
    enddo!ia3
   enddo!ia2
  enddo!ia1 
  return
end subroutine wrt_model_hr 
!
subroutine wrt_model_wcenter(n_occ,a1,a2,a3,wcenter)
  implicit none 
  integer::n_occ 
  real(8)::a1(3),a2(3),a3(3),wcenter(3,n_occ) 
  real(8)::ainv(3,3)
  integer::ib,i,j
  real(8)::wcenter_lat(3) 
  real(8)::SUM_REAL
  real(8),parameter::bohr=0.529177249d0 
  integer,parameter::unity=1 
  !
  ainv(:,1)=a1(:)
  ainv(:,2)=a2(:)
  ainv(:,3)=a3(:)
  !
  call inv_amat(3,ainv(1,1)) 
  !
  !OPEN(303,W,FILE='zvo_geom.dat') 
  !
  OPEN(303,FILE='./dir-model/zvo_geom.dat') 
  write(303,'(3f15.10)')(a1(i)*bohr,i=1,3) 
  write(303,'(3f15.10)')(a2(i)*bohr,i=1,3) 
  write(303,'(3f15.10)')(a3(i)*bohr,i=1,3) 
  write(303,'(i10)') n_occ
  do ib=1,n_occ 
   wcenter_lat=0.0d0 
   do i=1,3
    SUM_REAL=0.0d0 
    do j=1,3
     SUM_REAL=SUM_REAL+ainv(i,j)*wcenter(j,ib) 
    enddo!j 
    wcenter_lat(i)=SUM_REAL
   enddo!i
   write(303,*)(wcenter_lat(i),i=1,3) 
  enddo 
  !
  !OPEN(307,W,FILE='zvo_geom.xsf') 
  !
  OPEN(307,FILE='./dir-model/zvo_geom.xsf') 
  write(307,'(a10)')'CRYSTAL'
  write(307,'(a10)')'PRIMVEC'
  write(307,'(3f15.10)')(a1(i)*bohr,i=1,3)  
  write(307,'(3f15.10)')(a2(i)*bohr,i=1,3)  
  write(307,'(3f15.10)')(a3(i)*bohr,i=1,3)  
  write(307,'(a10)')'PRIMCOORD'
  write(307,'(2i10)') n_occ,unity 
  do ib=1,n_occ
   write(307,'(a5,3f15.10)')' H ',(wcenter(j,ib)*bohr,j=1,3)
  enddo 
  !
  return
end subroutine wrt_model_wcenter 
!
subroutine wrt_model_SK_BAND_DISP(Ndiv,N_sym_points,NSK_BAND_DISP,SK_BAND_DISP) 
  implicit none 
  integer,intent(in)::Ndiv,N_sym_points,NSK_BAND_DISP
  real(8),intent(in)::SK_BAND_DISP(3,NSK_BAND_DISP) 
  integer::ik,i 
  !
  !OPEN(304,W,FILE='zvo_bandkpts.dat') 
  !
  OPEN(304,FILE='./dir-model/zvo_bandkpts.dat') 
  write(304,'(3i10)') NSK_BAND_DISP,Ndiv,N_sym_points 
  do ik=1,NSK_BAND_DISP
   write(304,*)(SK_BAND_DISP(i,ik),i=1,3) 
  enddo 
  return
end subroutine wrt_model_SK_BAND_DISP 
!
subroutine wrt_model_SK0(NTK,SK0)
  implicit none 
  integer,intent(in)::NTK 
  real(8),intent(in)::SK0(3,NTK) 
  integer::ik,i 
  !
  !OPEN(305,W,FILE='zvo_mkkpts.dat') 
  !
  OPEN(305,FILE='./dir-model/zvo_mkkpts.dat') 
  write(305,'(i10)') NTK 
  do ik=1,NTK 
   write(305,*)(SK0(i,ik),i=1,3) 
  enddo 
  return
end subroutine wrt_model_SK0 
!
subroutine wrt_model_ef(FermiEnergy) 
  implicit none 
  real(8),intent(in)::FermiEnergy 
  !
  !OPEN(306,W,FILE='zvo_ef.dat') 
  !
  OPEN(306,FILE='./dir-model/zvo_ef.dat') 
  write(306,'(f15.10)') FermiEnergy 
  return 
end subroutine wrt_model_ef 
!
subroutine inv_amat(nm,mat)
  implicit none 
  integer,intent(in)::nm
  real(8),intent(inout)::mat(nm,nm)
  integer::ipiv(nm)
  integer::Lwork 
  real(8),allocatable::work(:)
  integer::info 
  Lwork=10*nm
  allocate(work(Lwork))
  info=0
  call dgetrf(nm,nm,mat,nm,ipiv,info)
  call dgetri(nm,mat,nm,ipiv,work,Lwork,info)
  if(info/=0) then
  write(6,*) 'info (subrouitine inv):',info
  stop
  endif 
  deallocate(work)
  return 
end subroutine inv_amat 
!
end module m_wrt_model 

module m_hist 
  implicit none
contains
  !
  subroutine calculate_hist(Ndim_TR,delw,TR) 
    implicit none 
    integer,intent(in)::Ndim_TR 
    real(8),intent(in)::delw!Grid width in histgram 
    complex(8),intent(inout)::TR(Ndim_TR,Ndim_TR) 
    !
    real(8),allocatable::EIG_TR(:)!EIG_TR(Ndim_TR) 
    real(8),allocatable::hist(:)!hist(ndosgrd) 
    real(8)::emin,emax
    integer::ndosgrd 
    integer::emin_grd,emax_grd 
    !
    !diagonalize TR 
    !
    allocate(EIG_TR(Ndim_TR)); EIG_TR=0.0d0 
    call diagN(Ndim_TR,TR(1,1),EIG_TR(1)) 
    !
    !make dos-grid
    !
    call est_ndosgrd(Ndim_TR,1,EIG_TR(1),delw,emin,emax,ndosgrd)  
    !
    !calc histgram
    !
    emin_grd=nint(emin/delw) 
    emax_grd=nint(emax/delw)
    allocate(hist(emin_grd:emax_grd)); hist=0.0d0 
    call calc_hist(Ndim_TR,emin_grd,emax_grd,delw,EIG_TR(1),hist(emin_grd)) 
    !
    !wrt histgram
    ! 
    call wrt_hist(emin_grd,emax_grd,delw,hist(emin_grd)) 
    deallocate(EIG_TR,hist) 
    !
    return
  end subroutine 
  !
  subroutine est_ndosgrd(NTB,NTK,E_EIG,deltw,emin,emax,ndosgrd)  
    implicit none
    integer,intent(in)::NTB,NTK
    real(8),intent(in)::E_EIG(NTB,NTK)
    real(8),intent(in)::deltw 
    real(8),intent(out)::emax,emin
    integer,intent(out)::ndosgrd
    real(8)::diff 
    real(8),parameter::au=27.21151d0
    !
    emax=maxval(E_EIG)
    emin=minval(E_EIG)
    diff=emax-emin 
    !
    !define grid range
    !
    ndosgrd=int(2.0d0*diff/deltw)+1
    emax=emax+0.5d0*diff
    emin=emin-0.5d0*diff
    !
    write(6,*)
    write(6,'(a)')'GRID DATA FOR DOS'
    write(6,'(a10,f12.7)')'emin(eV)',emin*au 
    write(6,'(a10,f12.7)')'emax(eV)',emax*au 
    write(6,'(a10,f12.7)')'deltw(eV)',deltw*au 
    write(6,'(a10,i12)')'ndosgrd',ndosgrd 
    write(6,*)
    return
  end subroutine
  !
  subroutine diagN(nm,mat,eig)
    implicit none 
    integer,intent(in)::nm
    complex(8),intent(inout)::mat(nm,nm)
    real(8),intent(out)::eig(nm)
    integer::LWORK,LRWORK,LIWORK  
    integer,allocatable::iwork_zheevd(:)
    real(8),allocatable::rwork_zheevd(:)
    complex(8),allocatable::work_zheevd(:)
    integer::ind
    real(8)::eps 
    !
    LWORK= 2*nm+nm**2
    LRWORK=1+12*nm+3*nm**2
    LIWORK=3+10*nm 
    allocate(work_zheevd(LWORK));work_zheevd(:)=0.0d0
    allocate(rwork_zheevd(LRWORK));rwork_zheevd(:)=0.0d0
    allocate(iwork_zheevd(LIWORK));iwork_zheevd(:)=0
    eps=1.0d-18
    ind=0                 
    !
    call zheevd("N","U",nm,mat,nm,eig,work_zheevd,LWORK,rwork_zheevd,LRWORK,iwork_zheevd,LIWORK,ind)
    !
    if(ind/=0)then 
     write(6,*)'ind=',ind 
     stop
    endif 
    !
    deallocate(work_zheevd,rwork_zheevd,iwork_zheevd) 
    return 
  end subroutine
  !
  subroutine calc_hist(N_eig,N_ini,N_end,del,EIG,hist) 
    implicit none
    integer,intent(in)::N_eig,N_ini,N_end 
    real(8),intent(in)::del 
    real(8),intent(in)::EIG(N_eig) 
    real(8),intent(out)::hist(N_ini:N_end) 
    integer::ie,ix 
    real(8),parameter::au=27.21151d0
    !
    hist=0.0d0 
    do ie=1,N_eig 
     ix=nint(EIG(ie)/del) 
     hist(ix)=hist(ix)+1.0d0 
    enddo
    !
    return 
  end subroutine 
  !
  subroutine wrt_hist(emin_grd,emax_grd,delw,hist) 
    implicit none 
    integer,intent(in)::emin_grd,emax_grd
    real(8),intent(in)::delw 
    real(8),intent(in)::hist(emin_grd:emax_grd) 
    integer::ix 
    real(8),parameter::au=27.21151d0 
    !
    !OPEN(302,W,file='./dat.hist')
    !
    OPEN(302,file='./dat.hist') 
    rewind(302) 
    do ix=emin_grd,emax_grd 
     write(302,'(2f15.10)') dble(ix)*delw*au,hist(ix)/au  
    enddo 
    close(302) 
    !
    return 
  end subroutine 
  !
end module m_hist 

subroutine invmat(nm,mat)
  implicit none 
  integer , intent(in) :: nm
  real(8) , intent(inout) :: mat(nm,nm)
  integer :: ipiv(nm)
  integer :: Lwork 
  real(8) , allocatable :: work(:)
  integer :: info 

  Lwork = 10*nm
  allocate (work(Lwork))
  info = 0
  call dgetrf(nm,nm,mat,nm,ipiv,info)
  call dgetri(nm,mat,nm,ipiv,work,Lwork,info)

  if(info /= 0) then
    write(6,*) 'info (subrouitine inv):' , info
    stop
  end if 
  deallocate(work)
  return 
end subroutine

subroutine invZGE(nm,mat)
  implicit none 
  integer,intent(in)::nm
  complex(8),intent(inout)::mat(nm,nm)
  integer::ipiv(nm)
  integer::Lwork 
  complex(8),ALLOCATABLE::work(:)
  integer::info 
  Lwork=10*nm
  allocate(work(Lwork))
  info=0
  call zgetrf(nm,nm,mat,nm,ipiv,info)
!  write(6,*)'finish zgetrf'
  call zgetri(nm,mat,nm,ipiv,work,Lwork,info)
!  write(6,*)'finish zgetri'
  if(info/=0) then
    write(6,*)'info (subrouitine inv):',info
    stop
  end if 
  deallocate(work)
  return 
end subroutine

#!/bin/sh
# Copyright (c) 2017,2018 Yoshihide Yoshimoto

set -- `getopt b:s: "$@"`
if [ $? != 0 ]; then
    echo "Usage: $0 [-b path_to_wfn2respack ] [-s path_to_strconv ] wfn_base_name" 1>&2
    exit 1
fi

WFN2RESPACK=wfn2respack
STRCONV=strconv

while [ $# -gt 0 ]; do
    case $1 in
	--) shift; break ;;
	-b) WFN2RESPACK=`readlink -f $2`; shift;;
	-s) STRCONV=`readlink -f $2`; shift;;
    esac
    shift
done

which $WFN2RESPACK > /dev/null
if  [ $? = 1 ]; then
    echo "Error: $WFN2RESPACK was not found in your PATH"
    echo "specify the path to $WFN2RESPACK by -b option"
    exit 1
fi
which $STRCONV > /dev/null
if  [ $? = 1 ]; then
    echo "Error: $STRCONV was not found in your PATH"
    echo "specify the path to $STRCONV by -s option"
    exit 1
fi

target=$1

error=0
if [ ! -f $target.wfn ]; then
    echo "$target.wfn not found"
    error=1
fi
if [ ! -f $target.str ]; then
   echo "$target.str not found"
   error=1
fi
if [ $error = 1 ]; then
    exit 1
fi

if [ ! -e dir-wfn ]; then
    mkdir dir-wfn
fi
( cd dir-wfn; $WFN2RESPACK ../$target.wfn 2> /dev/null ; exit $? )
status=$?
if [ $status -ne 0 ]; then
    echo "wfn2respack failed"
    rmdir dir-wfn > /dev/null 2>&1
    exit 1
fi

( cd dir-wfn; $STRCONV respack ../$target.str 2> /dev/null ; exit $? )
if [ $status -ne 0 ]; then
    echo "strconv failed"
    rmdir dir-wfn > /dev/null 2>&1
    exit 1
fi

#!/bin/sh 

set -x 

#xtapp
#rm -f fort.* Si.lpt Si.rho Si.str Si.wfn *.log
#rm -f fort.10 ; ln -s Si.cg fort.10
#mpirun -np 1 inipot > log.Si-inipot 
#mpirun -np 1 cgmrpt > log.Si-cgmrpt 
#rm -f fort.10 ; ln -s Si.vb fort.10
#mpirun -np 1 inipot > log.Si-inipot-vb 
#mpirun -np 1 vbpef  > log.Si-vbpef 
#vbpef2gp-lsda Si.band 

#interface 
#./xtapp2respack.sh -b ./wfn2respack -s ./strconv Si 

#respack 
#mpirun -np 1 calc_wannier < input.in > log.Si-wannier
#mpirun -np 1 calc_chiqw < input.in   > log.Si-chiqw
#mpirun -np 1 calc_w3d < input.in     > log.Si-calc_w3d
#mpirun -np 1 calc_j3d < input.in     > log.Si-calc_j3d

#!/bin/sh
# Copyright (c) 2017 Yusuke Nomura, Terumasa Tadano 

if [ $# -ne 1 ]; then
  echo "Please specify the output directory where data-file.xml exists" 1>&2 
  echo "Example: bash qe2respack.sh ./outdir/prefix.save/ " 1>&2 
  exit 1
fi

 qe2respack_root="/home/xxx/RESPACK-20170820/util/qe2respack"               #your machine 
#qe2respack_root="/home/r0088/r008806/src/RESPACK-20170820/util/qe2respack" #sysmteB@issp 

if [ ! -e dir-wfn ]; then
  mkdir dir-wfn
  $qe2respack_root/qe2respack $1
else
  mv dir-wfn dir-wfn_original
  mkdir dir-wfn
  $qe2respack_root/qe2respack $1
  echo "dir-wfn exists. Original directory is saved as dir-wfn_original." 
  echo "If it is not necessary, please remove it (rm -r dir-wfn_original)." 
fi

#!/bin/sh 

set -x 

#xtapp
#rm -f fort.* La2CuO4.lpt La2CuO4.rho La2CuO4.str La2CuO4.wfn *.log
#rm -f fort.10 ; ln -s La2CuO4.cg fort.10
#mpirun -np 1 inipot > log.La2CuO4-inipot 
#mpirun -np 1 cgmrpt > log.La2CuO4-cgmrpt 
#rm -f fort.10 ; ln -s La2CuO4.vb fort.10
#mpirun -np 1 inipot > log.La2CuO4-inipot-vb 
#mpirun -np 1 vbpef  > log.La2CuO4-vbpef 
#vbpef2gp-lsda La2CuO4.band 

#interface 
#./xtapp2respack.sh -b ./wfn2respack -s ./strconv La2CuO4

#respack 
#mpirun -np 1 calc_wannier < input.in > log.La2CuO4-wannier
#mpirun -np 1 calc_chiqw < input.in   > log.La2CuO4-chiqw
#mpirun -np 1 calc_w3d < input.in     > log.La2CuO4-calc_w3d
#mpirun -np 1 calc_j3d < input.in     > log.La2CuO4-calc_j3d

#!/bin/sh 

set -x 

#xtapp
#rm -f fort.* Al.lpt Al.rho Al.str Al.wfn *.log
#rm -f fort.10 ; ln -s Al.cg fort.10
#mpirun -np 1 inipot > log.Al-inipot 
#mpirun -np 1 cgmrpt > log.Al-cgmrpt 
#rm -f fort.10 ; ln -s Al.vb fort.10
#mpirun -np 1 inipot > log.Al-inipot-vb 
#mpirun -np 1 vbpef > log.Al-vbpef 
#vbpef2gp-lsda Al.band 

#interface 
#./xtapp2respack.sh -b ./wfn2respack -s ./strconv Al 

#respack 
#mpirun -np 1 calc_wannier < input.in > log.Al-wannier
#mpirun -np 1 calc_chiqw < input.in > log.Al-chiqw
#mpirun -np 1 calc_w3d < input.in > log.Al-calc_w3d
#mpirun -np 1 calc_j3d < input.in > log.Al-calc_j3d

#!/bin/sh 

set -x 

#xtapp
#rm -f fort.* SrVO3.lpt SrVO3.rho SrVO3.str SrVO3.wfn *.log
#rm -f fort.10 ; ln -s SrVO3.cg fort.10
#mpirun -np 1 inipot > log.SrVO3-inipot 
#mpirun -np 1 cgmrpt > log.SrVO3-cgmrpt 
#rm -f fort.10 ; ln -s SrVO3.vb fort.10
#mpirun -np 1 inipot > log.SrVO3-inipot-vb 
#mpirun -np 1 vbpef  > log.SrVO3-vbpef 
#vbpef2gp-lsda SrVO3.band 

#interface 
#./xtapp2respack.sh -b ./wfn2respack -s ./strconv SrVO3

#respack 
#mpirun -np 1 calc_wannier < input.in > log.SrVO3-wannier
#mpirun -np 1 calc_chiqw < input.in   > log.SrVO3-chiqw
#mpirun -np 1 calc_w3d < input.in     > log.SrVO3-calc_w3d
#mpirun -np 1 calc_j3d < input.in     > log.SrVO3-calc_j3d

#!/bin/sh 

set -x 

#xtapp
#rm -f fort.* TiO2.lpt TiO2.rho TiO2.str TiO2.wfn *.log
#rm -f fort.10 ; ln -s TiO2.cg fort.10
#mpirun -np 1 inipot > log.TiO2-inipot 
#mpirun -np 1 cgmrpt > log.TiO2-cgmrpt 
#rm -f fort.10 ; ln -s TiO2.vb fort.10
#mpirun -np 1 inipot > log.TiO2-inipot-vb 
#mpirun -np 1 vbpef  > log.TiO2-vbpef 
#vbpef2gp-lsda TiO2.band 

#interface 
#./xtapp2respack.sh -b ./wfn2respack -s ./strconv TiO2 

#respack 
#mpirun -np 1 calc_wannier < input.in > log.TiO2-wannier
